-- The proof of Equation 19.

import Proposition
import Equality

import Word
import Generator
import Word-Lemmas
import Word-Tactics
import Clifford-Lemmas
import CliffordT-Lemmas
import PauliRotations

open Proposition
open Equality using (auto)

open Word
open Generator
open Generator.Clifford+T
open Word-Lemmas.Monoid-Equational
open Word-Tactics.InContext
open Word-Tactics.Associative
open Clifford-Lemmas.Clifford-Rewriting
open CliffordT-Lemmas
open PauliRotations.Pauli
open PauliRotations.PauliRotRep
open PauliRotations.Commutativity
open PauliRotations.Combine
open PauliRotations.Correction

private module C = PauliRotations.Clifford

eqn19 : Clifford+T.Rel ⊢ T0⁻¹ • T1⁻¹ • W • X1 • CX1 • X0 • CX0 • T0 • CX0 • X0 • X1 • CX1 • ε === X1 • CX1 • T0⁻¹ • T1⁻¹ • W • X1 • CX1 • X0 • CX0 • T0 • CX0 • X0 • ε
eqn19 = 
  equational T0⁻¹ • T1⁻¹ • W • X1 • CX1 • X0 • CX0 • T0 • CX0 • X0 • X1 • CX1 • ε
          by in-context 0 1 auto lemma-R-T0⁻¹
      equals R (plus , Z⊗I) • S0⁻¹ • T1⁻¹ • W • X1 • CX1 • X0 • CX0 • T0 • CX0 • X0 • X1 • CX1 • ε
          by in-context 2 1 auto lemma-R-T1⁻¹
      equals R (plus , Z⊗I) • S0⁻¹ • R (plus , I⊗Z) • S1⁻¹ • W • X1 • CX1 • X0 • CX0 • T0 • CX0 • X0 • X1 • CX1 • ε
          by general-assoc auto
      equals R (plus , Z⊗I) • S0⁻¹ • R (plus , I⊗Z) • S1⁻¹ • W • X1 • CX1 • X0 • CX0 • R (plus , Z⊗I) • CX0 • X0 • X1 • CX1 • ε
          by in-context 1 2 auto (lemma-R (C.S0⁻¹) (plus , I⊗Z))
      equals R (plus , Z⊗I) • R (plus , I⊗Z) • S0⁻¹ • S1⁻¹ • W • X1 • CX1 • X0 • CX0 • R (plus , Z⊗I) • CX0 • X0 • X1 • CX1 • ε
          by in-context 2 8 auto (lemma-R (C.S0⁻¹ • C.S1⁻¹ • C.W • C.X1 • C.CX1 • C.X0 • C.CX0) (plus , Z⊗I))
      equals R (plus , Z⊗I) • R (plus , I⊗Z) • R (plus , I⊗Z) • S0⁻¹ • S1⁻¹ • W • X1 • CX1 • X0 • CX0 • CX0 • X0 • X1 • CX1 • ε
          by clifford-tactic 3 11 10000 auto
      equals R (plus , Z⊗I) • R (plus , I⊗Z) • R (plus , I⊗Z) • S0 • S0 • S0 • S1 • S1 • S1 • W • ε
          by in-context 0 2 auto (symm (tactic-pauli-commute (plus , I⊗Z) (plus , Z⊗I) auto))
      equals R (plus , I⊗Z) • R (plus , Z⊗I) • R (plus , I⊗Z) • S0 • S0 • S0 • S1 • S1 • S1 • W • ε
          by in-context 1 2 auto (symm (tactic-pauli-commute (plus , I⊗Z) (plus , Z⊗I) auto))
      equals R (plus , I⊗Z) • R (plus , I⊗Z) • R (plus , Z⊗I) • S0 • S0 • S0 • S1 • S1 • S1 • W • ε
          by in-context 0 2 auto (lemma-combine plus plus I⊗Z)
      equals Swap • S0 • Swap • R (plus , Z⊗I) • S0 • S0 • S0 • S1 • S1 • S1 • W • ε
          by clifford-tactic 0 3 10000 auto
      equals S1 • R (plus , Z⊗I) • S0 • S0 • S0 • S1 • S1 • S1 • W • ε
          by in-context 0 2 auto (lemma-R (C.S1) (plus , Z⊗I))
      equals R (plus , Z⊗I) • S1 • S0 • S0 • S0 • S1 • S1 • S1 • W • ε
          by clifford-tactic 1 7 10000 auto
      equals R (plus , Z⊗I) • S0 • S0 • S0 • W • ε
          by clifford-tactic 1 4 10000 auto
      equals R (plus , Z⊗I) • H0 • CZ • H0 • S0⁻¹ • W ^ 2 • H0 • CZ • H0 • CZ • S1 • W⁻¹ • ε
          by in-context 1 8 auto (symm (lemma-combine minus minus Z⊗Z))
      equals R (plus , Z⊗I) • R (minus , Z⊗Z) • R (minus , Z⊗Z) • CZ • S1 • W⁻¹ • ε
          by clifford-tactic 3 3 10000 auto
      equals R (plus , Z⊗I) • R (minus , Z⊗Z) • R (minus , Z⊗Z) • X1 • CX1 • S0⁻¹ • S1⁻¹ • W • X1 • CX1 • X0 • CX0 • CX0 • X0 • ε
          by in-context 2 10 auto (symm (lemma-R (C.X1 • C.CX1 • C.S0⁻¹ • C.S1⁻¹ • C.W • C.X1 • C.CX1 • C.X0 • C.CX0) (plus , Z⊗I)))
      equals R (plus , Z⊗I) • R (minus , Z⊗Z) • X1 • CX1 • S0⁻¹ • S1⁻¹ • W • X1 • CX1 • X0 • CX0 • R (plus , Z⊗I) • CX0 • X0 • ε
          by in-context 1 4 auto (symm (lemma-R (C.X1 • C.CX1 • C.S0⁻¹) (plus , I⊗Z)))
      equals R (plus , Z⊗I) • X1 • CX1 • S0⁻¹ • R (plus , I⊗Z) • S1⁻¹ • W • X1 • CX1 • X0 • CX0 • R (plus , Z⊗I) • CX0 • X0 • ε
          by in-context 0 3 auto (symm (lemma-R (C.X1 • C.CX1) (plus , Z⊗I)))
      equals X1 • CX1 • R (plus , Z⊗I) • S0⁻¹ • R (plus , I⊗Z) • S1⁻¹ • W • X1 • CX1 • X0 • CX0 • R (plus , Z⊗I) • CX0 • X0 • ε
          by general-assoc auto
      equals X1 • CX1 • R (plus , Z⊗I) • S0⁻¹ • R (plus , I⊗Z) • S1⁻¹ • W • X1 • CX1 • X0 • CX0 • T0 • CX0 • X0 • ε
          by in-context 4 2 auto (symm lemma-R-T1⁻¹)
      equals X1 • CX1 • R (plus , Z⊗I) • S0⁻¹ • T1⁻¹ • W • X1 • CX1 • X0 • CX0 • T0 • CX0 • X0 • ε
          by in-context 2 2 auto (symm lemma-R-T0⁻¹)
      equals X1 • CX1 • T0⁻¹ • T1⁻¹ • W • X1 • CX1 • X0 • CX0 • T0 • CX0 • X0 • ε


