-- The proof of Equation 23.

import Proposition
import Equality

import Word
import Generator
import Word-Lemmas
import Word-Tactics
import Clifford-Lemmas
import CliffordT-Lemmas
import PauliRotations

open Proposition
open Equality using (auto)

open Word
open Generator
open Generator.Clifford+T
open Word-Lemmas.Monoid-Equational
open Word-Tactics.InContext
open Word-Tactics.Associative
open Clifford-Lemmas.Clifford-Rewriting
open CliffordT-Lemmas
open PauliRotations.Pauli
open PauliRotations.PauliRotRep
open PauliRotations.Commutativity
open PauliRotations.Combine
open PauliRotations.Correction

private module C = PauliRotations.Clifford

eqn23 : Clifford+T.Rel ⊢ T0⁻¹ • T1⁻¹ • W • Swap • ε === Swap • T0⁻¹ • T1⁻¹ • W • ε
eqn23 = 
  equational T0⁻¹ • T1⁻¹ • W • Swap • ε
          by in-context 0 1 auto lemma-R-T0⁻¹
      equals R (plus , Z⊗I) • S0⁻¹ • T1⁻¹ • W • Swap • ε
          by in-context 2 1 auto lemma-R-T1⁻¹
      equals R (plus , Z⊗I) • S0⁻¹ • R (plus , I⊗Z) • S1⁻¹ • W • Swap • ε
          by in-context 1 2 auto (lemma-R (C.S0⁻¹) (plus , I⊗Z))
      equals R (plus , Z⊗I) • R (plus , I⊗Z) • S0⁻¹ • S1⁻¹ • W • Swap • ε
          by in-context 0 2 auto (symm (tactic-pauli-commute (plus , I⊗Z) (plus , Z⊗I) auto))
      equals R (plus , I⊗Z) • R (plus , Z⊗I) • S0⁻¹ • S1⁻¹ • W • Swap • ε
          by clifford-tactic 2 4 10000 auto
      equals R (plus , I⊗Z) • R (plus , Z⊗I) • CZ • H0 • H1 • CZ • H0 • H1 • CZ • H0 • S0 • S0 • S0 • H1 • S1 • S1 • S1 • W • ε
          by clifford-tactic 2 15 10000 auto
      equals R (plus , I⊗Z) • R (plus , Z⊗I) • Swap • S0⁻¹ • S1⁻¹ • W • ε
          by in-context 1 3 auto (symm (lemma-R (C.Swap • C.S0⁻¹) (plus , I⊗Z)))
      equals R (plus , I⊗Z) • Swap • S0⁻¹ • R (plus , I⊗Z) • S1⁻¹ • W • ε
          by in-context 0 2 auto (symm (lemma-R (C.Swap) (plus , Z⊗I)))
      equals Swap • R (plus , Z⊗I) • S0⁻¹ • R (plus , I⊗Z) • S1⁻¹ • W • ε
          by in-context 3 2 auto (symm lemma-R-T1⁻¹)
      equals Swap • R (plus , Z⊗I) • S0⁻¹ • T1⁻¹ • W • ε
          by in-context 1 2 auto (symm lemma-R-T0⁻¹)
      equals Swap • T0⁻¹ • T1⁻¹ • W • ε


