-- The proof of Equation 24.

import Proposition
import Equality

import Word
import Generator
import Word-Lemmas
import Word-Tactics
import Clifford-Lemmas
import CliffordT-Lemmas
import PauliRotations

open Proposition
open Equality using (auto)

open Word
open Generator
open Generator.Clifford+T
open Word-Lemmas.Monoid-Equational
open Word-Tactics.InContext
open Word-Tactics.Associative
open Clifford-Lemmas.Clifford-Rewriting
open CliffordT-Lemmas
open PauliRotations.Pauli
open PauliRotations.PauliRotRep
open PauliRotations.Commutativity
open PauliRotations.Combine
open PauliRotations.Correction

private module C = PauliRotations.Clifford

eqn24 : Clifford+T.Rel ⊢ X0 • CX0 • T0 • CX0 • X0 • Swap • ε === Swap • X0 • CX0 • T0 • CX0 • X0 • ε
eqn24 = 
  equational X0 • CX0 • T0 • CX0 • X0 • Swap • ε
          by general-assoc auto
      equals X0 • CX0 • R (plus , Z⊗I) • CX0 • X0 • Swap • ε
          by in-context 0 3 auto (lemma-R (C.X0 • C.CX0) (plus , Z⊗I))
      equals R (minus , Z⊗Z) • X0 • CX0 • CX0 • X0 • Swap • ε
          by clifford-tactic 1 4 10000 auto
      equals R (minus , Z⊗Z) • Swap • ε
          by clifford-tactic 2 0 10000 auto
      equals R (minus , Z⊗Z) • Swap • X0 • CX0 • CX0 • X0 • ε
          by in-context 0 4 auto (symm (lemma-R (C.Swap • C.X0 • C.CX0) (plus , Z⊗I)))
      equals Swap • X0 • CX0 • R (plus , Z⊗I) • CX0 • X0 • ε
          by general-assoc auto
      equals Swap • X0 • CX0 • T0 • CX0 • X0 • ε


