-- The proof of Equation 33.

import Proposition
import Equality

import Word
import Generator
import Word-Lemmas
import Word-Tactics
import Clifford-Lemmas
import CliffordT-Lemmas
import PauliRotations

open Proposition
open Equality using (auto)

open Word
open Generator
open Generator.Clifford+T
open Word-Lemmas.Monoid-Equational
open Word-Tactics.InContext
open Word-Tactics.Associative
open Clifford-Lemmas.Clifford-Rewriting
open CliffordT-Lemmas
open PauliRotations.Pauli
open PauliRotations.PauliRotRep
open PauliRotations.Commutativity
open PauliRotations.Combine
open PauliRotations.Correction

private module C = PauliRotations.Clifford

eqn33 : Clifford+T.Rel ⊢ X1 • CX1 • Swap • X1 • CX1 • ε === Swap • X1 • CX1 • Swap • ε
eqn33 = 
  equational X1 • CX1 • Swap • X1 • CX1 • ε
          by clifford-tactic 0 5 10000 auto
      equals H0 • CZ • S0 • S0 • H0 • ε
          by clifford-tactic 0 5 10000 auto
      equals Swap • X1 • CX1 • Swap • ε


