-- The proof of Equation 35.

import Proposition
import Equality

import Word
import Generator
import Word-Lemmas
import Word-Tactics
import Clifford-Lemmas
import CliffordT-Lemmas
import PauliRotations

open Proposition
open Equality using (auto)

open Word
open Generator
open Generator.Clifford+T
open Word-Lemmas.Monoid-Equational
open Word-Tactics.InContext
open Word-Tactics.Associative
open Clifford-Lemmas.Clifford-Rewriting
open CliffordT-Lemmas
open PauliRotations.Pauli
open PauliRotations.PauliRotRep
open PauliRotations.Commutativity
open PauliRotations.Combine
open PauliRotations.Correction

private module C = PauliRotations.Clifford

eqn35 : Clifford+T.Rel ⊢ Swap • CX1 • Swap • ε === CX1 • Swap • CX1 • ε
eqn35 = 
  equational Swap • CX1 • Swap • ε
          by clifford-tactic 0 3 10000 auto
      equals H0 • CZ • H0 • ε
          by clifford-tactic 0 3 10000 auto
      equals CX1 • Swap • CX1 • ε


