-- This module provides the "inspect" paradigm from the Agda standard
-- library. This is used when one needs to do a pattern matching on
-- the result r of some expression e, while also "remembering" a proof
-- of r == e.

-- Example usage:
-- 
-- f x y with g x | inspect g x
-- f x y | c z | [ eq ] = ...

open import Equality

module Inspect where

record Reveal_·_is_ {A : Set} {B : A → Set}
                    (f : (x : A) → B x) (x : A) (y : B x) : Set where
  constructor [_]
  field eq : f x == y

inspect : ∀ {A : Set} {B : A → Set}
          (f : (x : A) → B x) (x : A) → Reveal f · x is f x
inspect f x = [ refl ]
