-- The proof of Equation 28.

import Proposition
import Equality

import Word
import Generator
import Word-Lemmas
import Word-Tactics
import Clifford-Lemmas
import CliffordT-Lemmas
import PauliRotations

open Proposition
open Equality using (auto)

open Word
open Generator
open Generator.Clifford+T
open Word-Lemmas.Monoid-Equational
open Word-Tactics.InContext
open Word-Tactics.Associative
open Clifford-Lemmas.Clifford-Rewriting
open CliffordT-Lemmas
open PauliRotations.Pauli
open PauliRotations.PauliRotRep
open PauliRotations.Commutativity
open PauliRotations.Combine
open PauliRotations.Correction

private module C = PauliRotations.Clifford

eqn28 : Clifford+T.Rel ⊢ X0 • CH1 • X0 • Swap • T1 • CX1 • T1⁻¹ • X1 • CX1 • Swap • X0 • CH1 • X0 • Swap • X1 • CX1 • T1 • CX1 • T1⁻¹ • Swap • ε === Swap • T1 • CX1 • T1⁻¹ • X1 • CX1 • Swap • X0 • CH1 • X0 • Swap • X1 • CX1 • T1 • CX1 • T1⁻¹ • Swap • X0 • CH1 • X0 • ε
eqn28 = 
  equational X0 • CH1 • X0 • Swap • T1 • CX1 • T1⁻¹ • X1 • CX1 • Swap • X0 • CH1 • X0 • Swap • X1 • CX1 • T1 • CX1 • T1⁻¹ • Swap • ε
          by general-assoc auto
      equals X0 • S1 • H1 • T1 • CX1 • T1⁻¹ • H1 • S1⁻¹ • X0 • Swap • T1 • CX1 • T1⁻¹ • X1 • CX1 • Swap • X0 • CH1 • X0 • Swap • X1 • CX1 • T1 • CX1 • T1⁻¹ • Swap • ε
          by in-context 3 1 auto lemma-R-T1
      equals X0 • S1 • H1 • R (plus , I⊗Z) • CX1 • T1⁻¹ • H1 • S1⁻¹ • X0 • Swap • T1 • CX1 • T1⁻¹ • X1 • CX1 • Swap • X0 • CH1 • X0 • Swap • X1 • CX1 • T1 • CX1 • T1⁻¹ • Swap • ε
          by in-context 5 1 auto lemma-R-T1⁻¹
      equals X0 • S1 • H1 • R (plus , I⊗Z) • CX1 • R (plus , I⊗Z) • S1⁻¹ • H1 • S1⁻¹ • X0 • Swap • T1 • CX1 • T1⁻¹ • X1 • CX1 • Swap • X0 • CH1 • X0 • Swap • X1 • CX1 • T1 • CX1 • T1⁻¹ • Swap • ε
          by in-context 11 1 auto lemma-R-T1
      equals X0 • S1 • H1 • R (plus , I⊗Z) • CX1 • R (plus , I⊗Z) • S1⁻¹ • H1 • S1⁻¹ • X0 • Swap • R (plus , I⊗Z) • CX1 • T1⁻¹ • X1 • CX1 • Swap • X0 • CH1 • X0 • Swap • X1 • CX1 • T1 • CX1 • T1⁻¹ • Swap • ε
          by in-context 13 1 auto lemma-R-T1⁻¹
      equals X0 • S1 • H1 • R (plus , I⊗Z) • CX1 • R (plus , I⊗Z) • S1⁻¹ • H1 • S1⁻¹ • X0 • Swap • R (plus , I⊗Z) • CX1 • R (plus , I⊗Z) • S1⁻¹ • X1 • CX1 • Swap • X0 • CH1 • X0 • Swap • X1 • CX1 • T1 • CX1 • T1⁻¹ • Swap • ε
          by general-assoc auto
      equals X0 • S1 • H1 • R (plus , I⊗Z) • CX1 • R (plus , I⊗Z) • S1⁻¹ • H1 • S1⁻¹ • X0 • Swap • R (plus , I⊗Z) • CX1 • R (plus , I⊗Z) • S1⁻¹ • X1 • CX1 • Swap • X0 • S1 • H1 • T1 • CX1 • T1⁻¹ • H1 • S1⁻¹ • X0 • Swap • X1 • CX1 • T1 • CX1 • T1⁻¹ • Swap • ε
          by in-context 21 1 auto lemma-R-T1
      equals X0 • S1 • H1 • R (plus , I⊗Z) • CX1 • R (plus , I⊗Z) • S1⁻¹ • H1 • S1⁻¹ • X0 • Swap • R (plus , I⊗Z) • CX1 • R (plus , I⊗Z) • S1⁻¹ • X1 • CX1 • Swap • X0 • S1 • H1 • R (plus , I⊗Z) • CX1 • T1⁻¹ • H1 • S1⁻¹ • X0 • Swap • X1 • CX1 • T1 • CX1 • T1⁻¹ • Swap • ε
          by in-context 23 1 auto lemma-R-T1⁻¹
      equals X0 • S1 • H1 • R (plus , I⊗Z) • CX1 • R (plus , I⊗Z) • S1⁻¹ • H1 • S1⁻¹ • X0 • Swap • R (plus , I⊗Z) • CX1 • R (plus , I⊗Z) • S1⁻¹ • X1 • CX1 • Swap • X0 • S1 • H1 • R (plus , I⊗Z) • CX1 • R (plus , I⊗Z) • S1⁻¹ • H1 • S1⁻¹ • X0 • Swap • X1 • CX1 • T1 • CX1 • T1⁻¹ • Swap • ε
          by in-context 31 1 auto lemma-R-T1
      equals X0 • S1 • H1 • R (plus , I⊗Z) • CX1 • R (plus , I⊗Z) • S1⁻¹ • H1 • S1⁻¹ • X0 • Swap • R (plus , I⊗Z) • CX1 • R (plus , I⊗Z) • S1⁻¹ • X1 • CX1 • Swap • X0 • S1 • H1 • R (plus , I⊗Z) • CX1 • R (plus , I⊗Z) • S1⁻¹ • H1 • S1⁻¹ • X0 • Swap • X1 • CX1 • R (plus , I⊗Z) • CX1 • T1⁻¹ • Swap • ε
          by in-context 33 1 auto lemma-R-T1⁻¹
      equals X0 • S1 • H1 • R (plus , I⊗Z) • CX1 • R (plus , I⊗Z) • S1⁻¹ • H1 • S1⁻¹ • X0 • Swap • R (plus , I⊗Z) • CX1 • R (plus , I⊗Z) • S1⁻¹ • X1 • CX1 • Swap • X0 • S1 • H1 • R (plus , I⊗Z) • CX1 • R (plus , I⊗Z) • S1⁻¹ • H1 • S1⁻¹ • X0 • Swap • X1 • CX1 • R (plus , I⊗Z) • CX1 • R (plus , I⊗Z) • S1⁻¹ • Swap • ε
          by in-context 0 4 auto (lemma-R (C.X0 • C.S1 • C.H1) (plus , I⊗Z))
      equals R (plus , I⊗Y) • X0 • S1 • H1 • CX1 • R (plus , I⊗Z) • S1⁻¹ • H1 • S1⁻¹ • X0 • Swap • R (plus , I⊗Z) • CX1 • R (plus , I⊗Z) • S1⁻¹ • X1 • CX1 • Swap • X0 • S1 • H1 • R (plus , I⊗Z) • CX1 • R (plus , I⊗Z) • S1⁻¹ • H1 • S1⁻¹ • X0 • Swap • X1 • CX1 • R (plus , I⊗Z) • CX1 • R (plus , I⊗Z) • S1⁻¹ • Swap • ε
          by in-context 1 5 auto (lemma-R (C.X0 • C.S1 • C.H1 • C.CX1) (plus , I⊗Z))
      equals R (plus , I⊗Y) • R (minus , Z⊗Y) • X0 • S1 • H1 • CX1 • S1⁻¹ • H1 • S1⁻¹ • X0 • Swap • R (plus , I⊗Z) • CX1 • R (plus , I⊗Z) • S1⁻¹ • X1 • CX1 • Swap • X0 • S1 • H1 • R (plus , I⊗Z) • CX1 • R (plus , I⊗Z) • S1⁻¹ • H1 • S1⁻¹ • X0 • Swap • X1 • CX1 • R (plus , I⊗Z) • CX1 • R (plus , I⊗Z) • S1⁻¹ • Swap • ε
          by clifford-tactic 2 8 10000 auto
      equals R (plus , I⊗Y) • R (minus , Z⊗Y) • CZ • H1 • W⁻¹ • Swap • R (plus , I⊗Z) • CX1 • R (plus , I⊗Z) • S1⁻¹ • X1 • CX1 • Swap • X0 • S1 • H1 • R (plus , I⊗Z) • CX1 • R (plus , I⊗Z) • S1⁻¹ • H1 • S1⁻¹ • X0 • Swap • X1 • CX1 • R (plus , I⊗Z) • CX1 • R (plus , I⊗Z) • S1⁻¹ • Swap • ε
          by in-context 2 5 auto (lemma-R (C.CZ • C.H1 • C.W⁻¹ • C.Swap) (plus , I⊗Z))
      equals R (plus , I⊗Y) • R (minus , Z⊗Y) • R (plus , Z⊗I) • CZ • H1 • W⁻¹ • Swap • CX1 • R (plus , I⊗Z) • S1⁻¹ • X1 • CX1 • Swap • X0 • S1 • H1 • R (plus , I⊗Z) • CX1 • R (plus , I⊗Z) • S1⁻¹ • H1 • S1⁻¹ • X0 • Swap • X1 • CX1 • R (plus , I⊗Z) • CX1 • R (plus , I⊗Z) • S1⁻¹ • Swap • ε
          by in-context 3 6 auto (lemma-R (C.CZ • C.H1 • C.W⁻¹ • C.Swap • C.CX1) (plus , I⊗Z))
      equals R (plus , I⊗Y) • R (minus , Z⊗Y) • R (plus , Z⊗I) • R (plus , I⊗X) • CZ • H1 • W⁻¹ • Swap • CX1 • S1⁻¹ • X1 • CX1 • Swap • X0 • S1 • H1 • R (plus , I⊗Z) • CX1 • R (plus , I⊗Z) • S1⁻¹ • H1 • S1⁻¹ • X0 • Swap • X1 • CX1 • R (plus , I⊗Z) • CX1 • R (plus , I⊗Z) • S1⁻¹ • Swap • ε
          by clifford-tactic 4 12 10000 auto
      equals R (plus , I⊗Y) • R (minus , Z⊗Y) • R (plus , Z⊗I) • R (plus , I⊗X) • S1 • H1 • CZ • H1 • S1 • S1 • S1 • W⁻¹ • R (plus , I⊗Z) • CX1 • R (plus , I⊗Z) • S1⁻¹ • H1 • S1⁻¹ • X0 • Swap • X1 • CX1 • R (plus , I⊗Z) • CX1 • R (plus , I⊗Z) • S1⁻¹ • Swap • ε
          by in-context 4 9 auto (lemma-R (C.S1 • C.H1 • C.CZ • C.H1 • C.S1 • C.S1 • C.S1 • C.W⁻¹) (plus , I⊗Z))
      equals R (plus , I⊗Y) • R (minus , Z⊗Y) • R (plus , Z⊗I) • R (plus , I⊗X) • R (plus , Z⊗Z) • S1 • H1 • CZ • H1 • S1 • S1 • S1 • W⁻¹ • CX1 • R (plus , I⊗Z) • S1⁻¹ • H1 • S1⁻¹ • X0 • Swap • X1 • CX1 • R (plus , I⊗Z) • CX1 • R (plus , I⊗Z) • S1⁻¹ • Swap • ε
          by clifford-tactic 5 9 10000 auto
      equals R (plus , I⊗Y) • R (minus , Z⊗Y) • R (plus , Z⊗I) • R (plus , I⊗X) • R (plus , Z⊗Z) • CZ • S0 • S0 • S0 • W⁻¹ • R (plus , I⊗Z) • S1⁻¹ • H1 • S1⁻¹ • X0 • Swap • X1 • CX1 • R (plus , I⊗Z) • CX1 • R (plus , I⊗Z) • S1⁻¹ • Swap • ε
          by in-context 5 6 auto (lemma-R (C.CZ • C.S0 • C.S0 • C.S0 • C.W⁻¹) (plus , I⊗Z))
      equals R (plus , I⊗Y) • R (minus , Z⊗Y) • R (plus , Z⊗I) • R (plus , I⊗X) • R (plus , Z⊗Z) • R (plus , I⊗Z) • CZ • S0 • S0 • S0 • W⁻¹ • S1⁻¹ • H1 • S1⁻¹ • X0 • Swap • X1 • CX1 • R (plus , I⊗Z) • CX1 • R (plus , I⊗Z) • S1⁻¹ • Swap • ε
          by in-context 6 13 auto (lemma-R (C.CZ • C.S0 • C.S0 • C.S0 • C.W⁻¹ • C.S1⁻¹ • C.H1 • C.S1⁻¹ • C.X0 • C.Swap • C.X1 • C.CX1) (plus , I⊗Z))
      equals R (plus , I⊗Y) • R (minus , Z⊗Y) • R (plus , Z⊗I) • R (plus , I⊗X) • R (plus , Z⊗Z) • R (plus , I⊗Z) • R (minus , I⊗Y) • CZ • S0 • S0 • S0 • W⁻¹ • S1⁻¹ • H1 • S1⁻¹ • X0 • Swap • X1 • CX1 • CX1 • R (plus , I⊗Z) • S1⁻¹ • Swap • ε
          by clifford-tactic 11 9 10000 auto
      equals R (plus , I⊗Y) • R (minus , Z⊗Y) • R (plus , Z⊗I) • R (plus , I⊗X) • R (plus , Z⊗Z) • R (plus , I⊗Z) • R (minus , I⊗Y) • CZ • S0 • S0 • S0 • H1 • S1 • H1 • W ^ 6 • Swap • R (plus , I⊗Z) • S1⁻¹ • Swap • ε
          by in-context 7 10 auto (lemma-R (C.CZ • C.S0 • C.S0 • C.S0 • C.H1 • C.S1 • C.H1 • C.W ^ 6 • C.Swap) (plus , I⊗Z))
      equals R (plus , I⊗Y) • R (minus , Z⊗Y) • R (plus , Z⊗I) • R (plus , I⊗X) • R (plus , Z⊗Z) • R (plus , I⊗Z) • R (minus , I⊗Y) • R (plus , Z⊗I) • CZ • S0 • S0 • S0 • H1 • S1 • H1 • W ^ 6 • Swap • S1⁻¹ • Swap • ε
          by clifford-tactic 11 8 10000 auto
      equals R (plus , I⊗Y) • R (minus , Z⊗Y) • R (plus , Z⊗I) • R (plus , I⊗X) • R (plus , Z⊗Z) • R (plus , I⊗Z) • R (minus , I⊗Y) • R (plus , Z⊗I) • CZ • S0 • S0 • H1 • S1 • H1 • W ^ 6 • ε
          by in-context 1 2 auto (symm (tactic-pauli-commute (plus , Z⊗I) (minus , Z⊗Y) auto))
      equals R (plus , I⊗Y) • R (plus , Z⊗I) • R (minus , Z⊗Y) • R (plus , I⊗X) • R (plus , Z⊗Z) • R (plus , I⊗Z) • R (minus , I⊗Y) • R (plus , Z⊗I) • CZ • S0 • S0 • H1 • S1 • H1 • W ^ 6 • ε
          by in-context 6 2 auto (symm (tactic-pauli-commute (plus , Z⊗I) (minus , I⊗Y) auto))
      equals R (plus , I⊗Y) • R (plus , Z⊗I) • R (minus , Z⊗Y) • R (plus , I⊗X) • R (plus , Z⊗Z) • R (plus , I⊗Z) • R (plus , Z⊗I) • R (minus , I⊗Y) • CZ • S0 • S0 • H1 • S1 • H1 • W ^ 6 • ε
          by in-context 5 2 auto (symm (tactic-pauli-commute (plus , Z⊗I) (plus , I⊗Z) auto))
      equals R (plus , I⊗Y) • R (plus , Z⊗I) • R (minus , Z⊗Y) • R (plus , I⊗X) • R (plus , Z⊗Z) • R (plus , Z⊗I) • R (plus , I⊗Z) • R (minus , I⊗Y) • CZ • S0 • S0 • H1 • S1 • H1 • W ^ 6 • ε
          by in-context 4 2 auto (symm (tactic-pauli-commute (plus , Z⊗I) (plus , Z⊗Z) auto))
      equals R (plus , I⊗Y) • R (plus , Z⊗I) • R (minus , Z⊗Y) • R (plus , I⊗X) • R (plus , Z⊗I) • R (plus , Z⊗Z) • R (plus , I⊗Z) • R (minus , I⊗Y) • CZ • S0 • S0 • H1 • S1 • H1 • W ^ 6 • ε
          by in-context 3 2 auto (symm (tactic-pauli-commute (plus , Z⊗I) (plus , I⊗X) auto))
      equals R (plus , I⊗Y) • R (plus , Z⊗I) • R (minus , Z⊗Y) • R (plus , Z⊗I) • R (plus , I⊗X) • R (plus , Z⊗Z) • R (plus , I⊗Z) • R (minus , I⊗Y) • CZ • S0 • S0 • H1 • S1 • H1 • W ^ 6 • ε
          by in-context 2 2 auto (symm (tactic-pauli-commute (plus , Z⊗I) (minus , Z⊗Y) auto))
      equals R (plus , I⊗Y) • R (plus , Z⊗I) • R (plus , Z⊗I) • R (minus , Z⊗Y) • R (plus , I⊗X) • R (plus , Z⊗Z) • R (plus , I⊗Z) • R (minus , I⊗Y) • CZ • S0 • S0 • H1 • S1 • H1 • W ^ 6 • ε
          by in-context 5 2 auto (symm (tactic-pauli-commute (plus , I⊗Z) (plus , Z⊗Z) auto))
      equals R (plus , I⊗Y) • R (plus , Z⊗I) • R (plus , Z⊗I) • R (minus , Z⊗Y) • R (plus , I⊗X) • R (plus , I⊗Z) • R (plus , Z⊗Z) • R (minus , I⊗Y) • CZ • S0 • S0 • H1 • S1 • H1 • W ^ 6 • ε
          by in-context 1 2 auto (lemma-combine plus plus Z⊗I)
      equals R (plus , I⊗Y) • S0 • R (minus , Z⊗Y) • R (plus , I⊗X) • R (plus , I⊗Z) • R (plus , Z⊗Z) • R (minus , I⊗Y) • CZ • S0 • S0 • H1 • S1 • H1 • W ^ 6 • ε
          by in-context 1 2 auto (lemma-R (C.S0) (minus , Z⊗Y))
      equals R (plus , I⊗Y) • R (minus , Z⊗Y) • S0 • R (plus , I⊗X) • R (plus , I⊗Z) • R (plus , Z⊗Z) • R (minus , I⊗Y) • CZ • S0 • S0 • H1 • S1 • H1 • W ^ 6 • ε
          by in-context 2 2 auto (lemma-R (C.S0) (plus , I⊗X))
      equals R (plus , I⊗Y) • R (minus , Z⊗Y) • R (plus , I⊗X) • S0 • R (plus , I⊗Z) • R (plus , Z⊗Z) • R (minus , I⊗Y) • CZ • S0 • S0 • H1 • S1 • H1 • W ^ 6 • ε
          by in-context 3 2 auto (lemma-R (C.S0) (plus , I⊗Z))
      equals R (plus , I⊗Y) • R (minus , Z⊗Y) • R (plus , I⊗X) • R (plus , I⊗Z) • S0 • R (plus , Z⊗Z) • R (minus , I⊗Y) • CZ • S0 • S0 • H1 • S1 • H1 • W ^ 6 • ε
          by in-context 4 2 auto (lemma-R (C.S0) (plus , Z⊗Z))
      equals R (plus , I⊗Y) • R (minus , Z⊗Y) • R (plus , I⊗X) • R (plus , I⊗Z) • R (plus , Z⊗Z) • S0 • R (minus , I⊗Y) • CZ • S0 • S0 • H1 • S1 • H1 • W ^ 6 • ε
          by in-context 5 2 auto (lemma-R (C.S0) (minus , I⊗Y))
      equals R (plus , I⊗Y) • R (minus , Z⊗Y) • R (plus , I⊗X) • R (plus , I⊗Z) • R (plus , Z⊗Z) • R (minus , I⊗Y) • S0 • CZ • S0 • S0 • H1 • S1 • H1 • W ^ 6 • ε
          by in-context 1 1 auto (lemma-correction Z⊗Y)
      equals R (plus , I⊗Y) • R (plus , Z⊗Y) • S1 • H1 • H0 • CZ • H0 • S0⁻¹ • W • H0 • CZ • H0 • H1 • S1⁻¹ • R (plus , I⊗X) • R (plus , I⊗Z) • R (plus , Z⊗Z) • R (minus , I⊗Y) • S0 • CZ • S0 • S0 • H1 • S1 • H1 • W ^ 6 • ε
          by clifford-tactic 4 10 10000 auto
      equals R (plus , I⊗Y) • R (plus , Z⊗Y) • S1 • H1 • CZ • S0 • S0 • S0 • H1 • S1 • H1 • R (plus , I⊗X) • R (plus , I⊗Z) • R (plus , Z⊗Z) • R (minus , I⊗Y) • S0 • CZ • S0 • S0 • H1 • S1 • H1 • W ^ 6 • ε
          by in-context 2 10 auto (lemma-R (C.S1 • C.H1 • C.CZ • C.S0 • C.S0 • C.S0 • C.H1 • C.S1 • C.H1) (plus , I⊗X))
      equals R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , Z⊗Z) • S1 • H1 • CZ • S0 • S0 • S0 • H1 • S1 • H1 • R (plus , I⊗Z) • R (plus , Z⊗Z) • R (minus , I⊗Y) • S0 • CZ • S0 • S0 • H1 • S1 • H1 • W ^ 6 • ε
          by in-context 3 10 auto (lemma-R (C.S1 • C.H1 • C.CZ • C.S0 • C.S0 • C.S0 • C.H1 • C.S1 • C.H1) (plus , I⊗Z))
      equals R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , Z⊗Z) • R (minus , Z⊗X) • S1 • H1 • CZ • S0 • S0 • S0 • H1 • S1 • H1 • R (plus , Z⊗Z) • R (minus , I⊗Y) • S0 • CZ • S0 • S0 • H1 • S1 • H1 • W ^ 6 • ε
          by in-context 3 1 auto (lemma-correction Z⊗X)
      equals R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , Z⊗Z) • R (plus , Z⊗X) • H1 • H0 • CZ • H0 • S0⁻¹ • W • H0 • CZ • H0 • H1 • S1 • H1 • CZ • S0 • S0 • S0 • H1 • S1 • H1 • R (plus , Z⊗Z) • R (minus , I⊗Y) • S0 • CZ • S0 • S0 • H1 • S1 • H1 • W ^ 6 • ε
          by clifford-tactic 4 17 10000 auto
      equals R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , Z⊗Z) • R (plus , Z⊗X) • S1 • H1 • CZ • S0 • S0 • S0 • S1 • S1 • S1 • H1 • R (plus , Z⊗Z) • R (minus , I⊗Y) • S0 • CZ • S0 • S0 • H1 • S1 • H1 • W ^ 6 • ε
          by in-context 4 11 auto (lemma-R (C.S1 • C.H1 • C.CZ • C.S0 • C.S0 • C.S0 • C.S1 • C.S1 • C.S1 • C.H1) (plus , Z⊗Z))
      equals R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , Z⊗Z) • R (plus , Z⊗X) • R (minus , I⊗X) • S1 • H1 • CZ • S0 • S0 • S0 • S1 • S1 • S1 • H1 • R (minus , I⊗Y) • S0 • CZ • S0 • S0 • H1 • S1 • H1 • W ^ 6 • ε
          by in-context 4 1 auto (lemma-correction I⊗X)
      equals R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , Z⊗Z) • R (plus , Z⊗X) • R (plus , I⊗X) • H1 • Swap • S0⁻¹ • W • Swap • H1 • S1 • H1 • CZ • S0 • S0 • S0 • S1 • S1 • S1 • H1 • R (minus , I⊗Y) • S0 • CZ • S0 • S0 • H1 • S1 • H1 • W ^ 6 • ε
          by clifford-tactic 5 16 10000 auto
      equals R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , Z⊗Z) • R (plus , Z⊗X) • R (plus , I⊗X) • CZ • S0 • S1 • S1 • H1 • S1 • S1 • W ^ 6 • R (minus , I⊗Y) • S0 • CZ • S0 • S0 • H1 • S1 • H1 • W ^ 6 • ε
          by in-context 5 9 auto (lemma-R (C.CZ • C.S0 • C.S1 • C.S1 • C.H1 • C.S1 • C.S1 • C.W ^ 6) (minus , I⊗Y))
      equals R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , Z⊗Z) • R (plus , Z⊗X) • R (plus , I⊗X) • R (plus , Z⊗Y) • CZ • S0 • S1 • S1 • H1 • S1 • S1 • W ^ 6 • S0 • CZ • S0 • S0 • H1 • S1 • H1 • W ^ 6 • ε
          by clifford-tactic 6 15 10000 auto
      equals R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , Z⊗Z) • R (plus , Z⊗X) • R (plus , I⊗X) • R (plus , Z⊗Y) • S1 • H1 • CZ • S0 • S0 • S0 • S1 • S1 • W ^ 6 • ε
          by in-context 3 2 auto (symm (tactic-pauli-commute (plus , I⊗X) (plus , Z⊗X) auto))
      equals R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , Z⊗Z) • R (plus , I⊗X) • R (plus , Z⊗X) • R (plus , Z⊗Y) • S1 • H1 • CZ • S0 • S0 • S0 • S1 • S1 • W ^ 6 • ε
          by clifford-tactic 15 0 10000 auto
      equals R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , Z⊗Z) • R (plus , I⊗X) • R (plus , Z⊗X) • R (plus , Z⊗Y) • S1 • H1 • CZ • S0 • S0 • S0 • S1 • S1 • W ^ 6 • W ^ 2 • S1⁻¹ • S1⁻¹ • S0⁻¹ • S0⁻¹ • S0⁻¹ • CZ • H1 • S1⁻¹ • S1 • H1 • CZ • S0 • S0 • S0 • S1 • S1 • W ^ 6 • ε
          by clifford-tactic 24 0 10000 auto
      equals R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , Z⊗Z) • R (plus , I⊗X) • R (plus , Z⊗X) • R (plus , Z⊗Y) • S1 • H1 • CZ • S0 • S0 • S0 • S1 • S1 • W ^ 6 • W ^ 2 • S1⁻¹ • S1⁻¹ • S0⁻¹ • S0⁻¹ • S0⁻¹ • CZ • H1 • S1⁻¹ • H1 • H0 • CZ • H0 • H0 • CZ • H0 • H1 • S1 • H1 • CZ • S0 • S0 • S0 • S1 • S1 • W ^ 6 • ε
          by in-context 28 0 auto (symm lemma-order-T0)
      equals R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , Z⊗Z) • R (plus , I⊗X) • R (plus , Z⊗X) • R (plus , Z⊗Y) • S1 • H1 • CZ • S0 • S0 • S0 • S1 • S1 • W ^ 6 • W ^ 2 • S1⁻¹ • S1⁻¹ • S0⁻¹ • S0⁻¹ • S0⁻¹ • CZ • H1 • S1⁻¹ • H1 • H0 • CZ • H0 • T0 • T0 • T0 • T0 • T0 • T0 • T0 • T0 • H0 • CZ • H0 • H1 • S1 • H1 • CZ • S0 • S0 • S0 • S1 • S1 • W ^ 6 • ε
          by general-assoc auto
      equals R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , Z⊗Z) • R (plus , I⊗X) • R (plus , Z⊗X) • R (plus , Z⊗Y) • S1 • H1 • CZ • S0 • S0 • S0 • S1 • S1 • W ^ 6 • W ^ 2 • S1⁻¹ • S1⁻¹ • S0⁻¹ • S0⁻¹ • S0⁻¹ • CZ • H1 • S1⁻¹ • H1 • H0 • CZ • H0 • T0⁻¹ • T0 • H0 • CZ • H0 • H1 • S1 • H1 • CZ • S0 • S0 • S0 • S1 • S1 • W ^ 6 • ε
          by clifford-tactic 29 0 10000 auto
      equals R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , Z⊗Z) • R (plus , I⊗X) • R (plus , Z⊗X) • R (plus , Z⊗Y) • S1 • H1 • CZ • S0 • S0 • S0 • S1 • S1 • W ^ 6 • W ^ 2 • S1⁻¹ • S1⁻¹ • S0⁻¹ • S0⁻¹ • S0⁻¹ • CZ • H1 • S1⁻¹ • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • H1 • H0 • CZ • H0 • T0 • H0 • CZ • H0 • H1 • S1 • H1 • CZ • S0 • S0 • S0 • S1 • S1 • W ^ 6 • ε
          by general-assoc auto
      equals R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , Z⊗Z) • R (plus , I⊗X) • R (plus , Z⊗X) • R (plus , Z⊗Y) • S1 • H1 • CZ • S0 • S0 • S0 • S1 • S1 • W ^ 6 • W ^ 2 • S1⁻¹ • S1⁻¹ • S0⁻¹ • S0⁻¹ • S0⁻¹ • CZ • H1 • S1⁻¹ • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • R (plus , Z⊗X) • S1 • H1 • CZ • S0 • S0 • S0 • S1 • S1 • W ^ 6 • ε
          by clifford-tactic 33 0 10000 auto
      equals R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , Z⊗Z) • R (plus , I⊗X) • R (plus , Z⊗X) • R (plus , Z⊗Y) • S1 • H1 • CZ • S0 • S0 • S0 • S1 • S1 • W ^ 6 • W ^ 2 • S1⁻¹ • S1⁻¹ • S0⁻¹ • S0⁻¹ • S0⁻¹ • CZ • H1 • S1⁻¹ • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • H1 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • H1 • R (plus , Z⊗X) • S1 • H1 • CZ • S0 • S0 • S0 • S1 • S1 • W ^ 6 • ε
          by in-context 43 0 auto (symm lemma-order-T0)
      equals R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , Z⊗Z) • R (plus , I⊗X) • R (plus , Z⊗X) • R (plus , Z⊗Y) • S1 • H1 • CZ • S0 • S0 • S0 • S1 • S1 • W ^ 6 • W ^ 2 • S1⁻¹ • S1⁻¹ • S0⁻¹ • S0⁻¹ • S0⁻¹ • CZ • H1 • S1⁻¹ • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • H1 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0 • T0 • T0 • T0 • T0 • T0 • T0 • T0 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • H1 • R (plus , Z⊗X) • S1 • H1 • CZ • S0 • S0 • S0 • S1 • S1 • W ^ 6 • ε
          by general-assoc auto
      equals R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , Z⊗Z) • R (plus , I⊗X) • R (plus , Z⊗X) • R (plus , Z⊗Y) • S1 • H1 • CZ • S0 • S0 • S0 • S1 • S1 • W ^ 6 • W ^ 2 • S1⁻¹ • S1⁻¹ • S0⁻¹ • S0⁻¹ • S0⁻¹ • CZ • H1 • S1⁻¹ • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • H1 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0⁻¹ • T0 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • H1 • R (plus , Z⊗X) • S1 • H1 • CZ • S0 • S0 • S0 • S1 • S1 • W ^ 6 • ε
          by clifford-tactic 44 0 10000 auto
      equals R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , Z⊗Z) • R (plus , I⊗X) • R (plus , Z⊗X) • R (plus , Z⊗Y) • S1 • H1 • CZ • S0 • S0 • S0 • S1 • S1 • W ^ 6 • W ^ 2 • S1⁻¹ • S1⁻¹ • S0⁻¹ • S0⁻¹ • S0⁻¹ • CZ • H1 • S1⁻¹ • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • H1 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • H1 • H1 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • H1 • R (plus , Z⊗X) • S1 • H1 • CZ • S0 • S0 • S0 • S1 • S1 • W ^ 6 • ε
          by general-assoc auto
      equals R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , Z⊗Z) • R (plus , I⊗X) • R (plus , Z⊗X) • R (plus , Z⊗Y) • S1 • H1 • CZ • S0 • S0 • S0 • S1 • S1 • W ^ 6 • W ^ 2 • S1⁻¹ • S1⁻¹ • S0⁻¹ • S0⁻¹ • S0⁻¹ • CZ • H1 • S1⁻¹ • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • H1 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • H1 • R (plus , I⊗X) • R (plus , Z⊗X) • S1 • H1 • CZ • S0 • S0 • S0 • S1 • S1 • W ^ 6 • ε
          by clifford-tactic 54 0 10000 auto
      equals R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , Z⊗Z) • R (plus , I⊗X) • R (plus , Z⊗X) • R (plus , Z⊗Y) • S1 • H1 • CZ • S0 • S0 • S0 • S1 • S1 • W ^ 6 • W ^ 2 • S1⁻¹ • S1⁻¹ • S0⁻¹ • S0⁻¹ • S0⁻¹ • CZ • H1 • S1⁻¹ • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • H1 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • H1 • S1 • H1 • H0 • CZ • H0 • H0 • CZ • H0 • H1 • S1⁻¹ • R (plus , I⊗X) • R (plus , Z⊗X) • S1 • H1 • CZ • S0 • S0 • S0 • S1 • S1 • W ^ 6 • ε
          by in-context 59 0 auto (symm lemma-order-T0)
      equals R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , Z⊗Z) • R (plus , I⊗X) • R (plus , Z⊗X) • R (plus , Z⊗Y) • S1 • H1 • CZ • S0 • S0 • S0 • S1 • S1 • W ^ 6 • W ^ 2 • S1⁻¹ • S1⁻¹ • S0⁻¹ • S0⁻¹ • S0⁻¹ • CZ • H1 • S1⁻¹ • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • H1 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • H1 • S1 • H1 • H0 • CZ • H0 • T0 • T0 • T0 • T0 • T0 • T0 • T0 • T0 • H0 • CZ • H0 • H1 • S1⁻¹ • R (plus , I⊗X) • R (plus , Z⊗X) • S1 • H1 • CZ • S0 • S0 • S0 • S1 • S1 • W ^ 6 • ε
          by general-assoc auto
      equals R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , Z⊗Z) • R (plus , I⊗X) • R (plus , Z⊗X) • R (plus , Z⊗Y) • S1 • H1 • CZ • S0 • S0 • S0 • S1 • S1 • W ^ 6 • W ^ 2 • S1⁻¹ • S1⁻¹ • S0⁻¹ • S0⁻¹ • S0⁻¹ • CZ • H1 • S1⁻¹ • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • H1 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • H1 • S1 • H1 • H0 • CZ • H0 • T0⁻¹ • T0 • H0 • CZ • H0 • H1 • S1⁻¹ • R (plus , I⊗X) • R (plus , Z⊗X) • S1 • H1 • CZ • S0 • S0 • S0 • S1 • S1 • W ^ 6 • ε
          by clifford-tactic 60 0 10000 auto
      equals R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , Z⊗Z) • R (plus , I⊗X) • R (plus , Z⊗X) • R (plus , Z⊗Y) • S1 • H1 • CZ • S0 • S0 • S0 • S1 • S1 • W ^ 6 • W ^ 2 • S1⁻¹ • S1⁻¹ • S0⁻¹ • S0⁻¹ • S0⁻¹ • CZ • H1 • S1⁻¹ • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • H1 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • H1 • S1 • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • S1 • H1 • H0 • CZ • H0 • T0 • H0 • CZ • H0 • H1 • S1⁻¹ • R (plus , I⊗X) • R (plus , Z⊗X) • S1 • H1 • CZ • S0 • S0 • S0 • S1 • S1 • W ^ 6 • ε
          by general-assoc auto
      equals R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , Z⊗Z) • R (plus , I⊗X) • R (plus , Z⊗X) • R (plus , Z⊗Y) • S1 • H1 • CZ • S0 • S0 • S0 • S1 • S1 • W ^ 6 • W ^ 2 • S1⁻¹ • S1⁻¹ • S0⁻¹ • S0⁻¹ • S0⁻¹ • CZ • H1 • S1⁻¹ • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • H1 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • H1 • S1 • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • R (plus , Z⊗Y) • R (plus , I⊗X) • R (plus , Z⊗X) • S1 • H1 • CZ • S0 • S0 • S0 • S1 • S1 • W ^ 6 • ε
          by clifford-tactic 65 0 10000 auto
      equals R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , Z⊗Z) • R (plus , I⊗X) • R (plus , Z⊗X) • R (plus , Z⊗Y) • S1 • H1 • CZ • S0 • S0 • S0 • S1 • S1 • W ^ 6 • W ^ 2 • S1⁻¹ • S1⁻¹ • S0⁻¹ • S0⁻¹ • S0⁻¹ • CZ • H1 • S1⁻¹ • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • H1 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • H1 • S1 • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • H1 • H0 • CZ • H0 • H0 • CZ • H0 • H1 • R (plus , Z⊗Y) • R (plus , I⊗X) • R (plus , Z⊗X) • S1 • H1 • CZ • S0 • S0 • S0 • S1 • S1 • W ^ 6 • ε
          by in-context 69 0 auto (symm lemma-order-T0)
      equals R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , Z⊗Z) • R (plus , I⊗X) • R (plus , Z⊗X) • R (plus , Z⊗Y) • S1 • H1 • CZ • S0 • S0 • S0 • S1 • S1 • W ^ 6 • W ^ 2 • S1⁻¹ • S1⁻¹ • S0⁻¹ • S0⁻¹ • S0⁻¹ • CZ • H1 • S1⁻¹ • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • H1 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • H1 • S1 • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • H1 • H0 • CZ • H0 • T0 • T0 • T0 • T0 • T0 • T0 • T0 • T0 • H0 • CZ • H0 • H1 • R (plus , Z⊗Y) • R (plus , I⊗X) • R (plus , Z⊗X) • S1 • H1 • CZ • S0 • S0 • S0 • S1 • S1 • W ^ 6 • ε
          by general-assoc auto
      equals R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , Z⊗Z) • R (plus , I⊗X) • R (plus , Z⊗X) • R (plus , Z⊗Y) • S1 • H1 • CZ • S0 • S0 • S0 • S1 • S1 • W ^ 6 • W ^ 2 • S1⁻¹ • S1⁻¹ • S0⁻¹ • S0⁻¹ • S0⁻¹ • CZ • H1 • S1⁻¹ • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • H1 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • H1 • S1 • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • H1 • H0 • CZ • H0 • T0⁻¹ • T0 • H0 • CZ • H0 • H1 • R (plus , Z⊗Y) • R (plus , I⊗X) • R (plus , Z⊗X) • S1 • H1 • CZ • S0 • S0 • S0 • S1 • S1 • W ^ 6 • ε
          by clifford-tactic 70 0 10000 auto
      equals R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , Z⊗Z) • R (plus , I⊗X) • R (plus , Z⊗X) • R (plus , Z⊗Y) • S1 • H1 • CZ • S0 • S0 • S0 • S1 • S1 • W ^ 6 • W ^ 2 • S1⁻¹ • S1⁻¹ • S0⁻¹ • S0⁻¹ • S0⁻¹ • CZ • H1 • S1⁻¹ • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • H1 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • H1 • S1 • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • H1 • H0 • CZ • H0 • T0 • H0 • CZ • H0 • H1 • R (plus , Z⊗Y) • R (plus , I⊗X) • R (plus , Z⊗X) • S1 • H1 • CZ • S0 • S0 • S0 • S1 • S1 • W ^ 6 • ε
          by general-assoc auto
      equals R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , Z⊗Z) • R (plus , I⊗X) • R (plus , Z⊗X) • R (plus , Z⊗Y) • S1 • H1 • CZ • S0 • S0 • S0 • S1 • S1 • W ^ 6 • W ^ 2 • S1⁻¹ • S1⁻¹ • S0⁻¹ • S0⁻¹ • S0⁻¹ • CZ • H1 • S1⁻¹ • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • H1 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • H1 • S1 • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • R (plus , Z⊗X) • R (plus , Z⊗Y) • R (plus , I⊗X) • R (plus , Z⊗X) • S1 • H1 • CZ • S0 • S0 • S0 • S1 • S1 • W ^ 6 • ε
          by clifford-tactic 74 0 10000 auto
      equals R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , Z⊗Z) • R (plus , I⊗X) • R (plus , Z⊗X) • R (plus , Z⊗Y) • S1 • H1 • CZ • S0 • S0 • S0 • S1 • S1 • W ^ 6 • W ^ 2 • S1⁻¹ • S1⁻¹ • S0⁻¹ • S0⁻¹ • S0⁻¹ • CZ • H1 • S1⁻¹ • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • H1 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • H1 • S1 • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • H1 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • H1 • R (plus , Z⊗X) • R (plus , Z⊗Y) • R (plus , I⊗X) • R (plus , Z⊗X) • S1 • H1 • CZ • S0 • S0 • S0 • S1 • S1 • W ^ 6 • ε
          by in-context 84 0 auto (symm lemma-order-T0)
      equals R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , Z⊗Z) • R (plus , I⊗X) • R (plus , Z⊗X) • R (plus , Z⊗Y) • S1 • H1 • CZ • S0 • S0 • S0 • S1 • S1 • W ^ 6 • W ^ 2 • S1⁻¹ • S1⁻¹ • S0⁻¹ • S0⁻¹ • S0⁻¹ • CZ • H1 • S1⁻¹ • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • H1 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • H1 • S1 • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • H1 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0 • T0 • T0 • T0 • T0 • T0 • T0 • T0 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • H1 • R (plus , Z⊗X) • R (plus , Z⊗Y) • R (plus , I⊗X) • R (plus , Z⊗X) • S1 • H1 • CZ • S0 • S0 • S0 • S1 • S1 • W ^ 6 • ε
          by general-assoc auto
      equals R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , Z⊗Z) • R (plus , I⊗X) • R (plus , Z⊗X) • R (plus , Z⊗Y) • S1 • H1 • CZ • S0 • S0 • S0 • S1 • S1 • W ^ 6 • W ^ 2 • S1⁻¹ • S1⁻¹ • S0⁻¹ • S0⁻¹ • S0⁻¹ • CZ • H1 • S1⁻¹ • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • H1 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • H1 • S1 • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • H1 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0⁻¹ • T0 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • H1 • R (plus , Z⊗X) • R (plus , Z⊗Y) • R (plus , I⊗X) • R (plus , Z⊗X) • S1 • H1 • CZ • S0 • S0 • S0 • S1 • S1 • W ^ 6 • ε
          by clifford-tactic 85 0 10000 auto
      equals R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , Z⊗Z) • R (plus , I⊗X) • R (plus , Z⊗X) • R (plus , Z⊗Y) • S1 • H1 • CZ • S0 • S0 • S0 • S1 • S1 • W ^ 6 • W ^ 2 • S1⁻¹ • S1⁻¹ • S0⁻¹ • S0⁻¹ • S0⁻¹ • CZ • H1 • S1⁻¹ • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • H1 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • H1 • S1 • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • H1 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • H1 • H1 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • H1 • R (plus , Z⊗X) • R (plus , Z⊗Y) • R (plus , I⊗X) • R (plus , Z⊗X) • S1 • H1 • CZ • S0 • S0 • S0 • S1 • S1 • W ^ 6 • ε
          by general-assoc auto
      equals R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , Z⊗Z) • R (plus , I⊗X) • R (plus , Z⊗X) • R (plus , Z⊗Y) • S1 • H1 • CZ • S0 • S0 • S0 • S1 • S1 • W ^ 6 • W ^ 2 • S1⁻¹ • S1⁻¹ • S0⁻¹ • S0⁻¹ • S0⁻¹ • CZ • H1 • S1⁻¹ • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • H1 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • H1 • S1 • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • H1 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • H1 • R (plus , I⊗X) • R (plus , Z⊗X) • R (plus , Z⊗Y) • R (plus , I⊗X) • R (plus , Z⊗X) • S1 • H1 • CZ • S0 • S0 • S0 • S1 • S1 • W ^ 6 • ε
          by clifford-tactic 95 0 10000 auto
      equals R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , Z⊗Z) • R (plus , I⊗X) • R (plus , Z⊗X) • R (plus , Z⊗Y) • S1 • H1 • CZ • S0 • S0 • S0 • S1 • S1 • W ^ 6 • W ^ 2 • S1⁻¹ • S1⁻¹ • S0⁻¹ • S0⁻¹ • S0⁻¹ • CZ • H1 • S1⁻¹ • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • H1 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • H1 • S1 • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • H1 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • H1 • H0 • CZ • H0 • H0 • CZ • H0 • R (plus , I⊗X) • R (plus , Z⊗X) • R (plus , Z⊗Y) • R (plus , I⊗X) • R (plus , Z⊗X) • S1 • H1 • CZ • S0 • S0 • S0 • S1 • S1 • W ^ 6 • ε
          by in-context 98 0 auto (symm lemma-order-T0)
      equals R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , Z⊗Z) • R (plus , I⊗X) • R (plus , Z⊗X) • R (plus , Z⊗Y) • S1 • H1 • CZ • S0 • S0 • S0 • S1 • S1 • W ^ 6 • W ^ 2 • S1⁻¹ • S1⁻¹ • S0⁻¹ • S0⁻¹ • S0⁻¹ • CZ • H1 • S1⁻¹ • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • H1 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • H1 • S1 • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • H1 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • H1 • H0 • CZ • H0 • T0 • T0 • T0 • T0 • T0 • T0 • T0 • T0 • H0 • CZ • H0 • R (plus , I⊗X) • R (plus , Z⊗X) • R (plus , Z⊗Y) • R (plus , I⊗X) • R (plus , Z⊗X) • S1 • H1 • CZ • S0 • S0 • S0 • S1 • S1 • W ^ 6 • ε
          by general-assoc auto
      equals R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , Z⊗Z) • R (plus , I⊗X) • R (plus , Z⊗X) • R (plus , Z⊗Y) • S1 • H1 • CZ • S0 • S0 • S0 • S1 • S1 • W ^ 6 • W ^ 2 • S1⁻¹ • S1⁻¹ • S0⁻¹ • S0⁻¹ • S0⁻¹ • CZ • H1 • S1⁻¹ • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • H1 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • H1 • S1 • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • H1 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • H1 • H0 • CZ • H0 • T0⁻¹ • T0 • H0 • CZ • H0 • R (plus , I⊗X) • R (plus , Z⊗X) • R (plus , Z⊗Y) • R (plus , I⊗X) • R (plus , Z⊗X) • S1 • H1 • CZ • S0 • S0 • S0 • S1 • S1 • W ^ 6 • ε
          by clifford-tactic 99 0 10000 auto
      equals R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , Z⊗Z) • R (plus , I⊗X) • R (plus , Z⊗X) • R (plus , Z⊗Y) • S1 • H1 • CZ • S0 • S0 • S0 • S1 • S1 • W ^ 6 • W ^ 2 • S1⁻¹ • S1⁻¹ • S0⁻¹ • S0⁻¹ • S0⁻¹ • CZ • H1 • S1⁻¹ • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • H1 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • H1 • S1 • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • H1 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H0 • CZ • H0 • T0 • H0 • CZ • H0 • R (plus , I⊗X) • R (plus , Z⊗X) • R (plus , Z⊗Y) • R (plus , I⊗X) • R (plus , Z⊗X) • S1 • H1 • CZ • S0 • S0 • S0 • S1 • S1 • W ^ 6 • ε
          by general-assoc auto
      equals R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , Z⊗Z) • R (plus , I⊗X) • R (plus , Z⊗X) • R (plus , Z⊗Y) • S1 • H1 • CZ • S0 • S0 • S0 • S1 • S1 • W ^ 6 • W ^ 2 • S1⁻¹ • S1⁻¹ • S0⁻¹ • S0⁻¹ • S0⁻¹ • CZ • H1 • S1⁻¹ • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • H1 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • H1 • S1 • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • H1 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • R (plus , Z⊗Z) • R (plus , I⊗X) • R (plus , Z⊗X) • R (plus , Z⊗Y) • R (plus , I⊗X) • R (plus , Z⊗X) • S1 • H1 • CZ • S0 • S0 • S0 • S1 • S1 • W ^ 6 • ε
          by clifford-tactic 102 0 10000 auto
      equals R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , Z⊗Z) • R (plus , I⊗X) • R (plus , Z⊗X) • R (plus , Z⊗Y) • S1 • H1 • CZ • S0 • S0 • S0 • S1 • S1 • W ^ 6 • W ^ 2 • S1⁻¹ • S1⁻¹ • S0⁻¹ • S0⁻¹ • S0⁻¹ • CZ • H1 • S1⁻¹ • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • H1 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • H1 • S1 • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • H1 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • S1 • H1 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • H1 • S1⁻¹ • R (plus , Z⊗Z) • R (plus , I⊗X) • R (plus , Z⊗X) • R (plus , Z⊗Y) • R (plus , I⊗X) • R (plus , Z⊗X) • S1 • H1 • CZ • S0 • S0 • S0 • S1 • S1 • W ^ 6 • ε
          by in-context 113 0 auto (symm lemma-order-T0)
      equals R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , Z⊗Z) • R (plus , I⊗X) • R (plus , Z⊗X) • R (plus , Z⊗Y) • S1 • H1 • CZ • S0 • S0 • S0 • S1 • S1 • W ^ 6 • W ^ 2 • S1⁻¹ • S1⁻¹ • S0⁻¹ • S0⁻¹ • S0⁻¹ • CZ • H1 • S1⁻¹ • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • H1 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • H1 • S1 • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • H1 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • S1 • H1 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0 • T0 • T0 • T0 • T0 • T0 • T0 • T0 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • H1 • S1⁻¹ • R (plus , Z⊗Z) • R (plus , I⊗X) • R (plus , Z⊗X) • R (plus , Z⊗Y) • R (plus , I⊗X) • R (plus , Z⊗X) • S1 • H1 • CZ • S0 • S0 • S0 • S1 • S1 • W ^ 6 • ε
          by general-assoc auto
      equals R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , Z⊗Z) • R (plus , I⊗X) • R (plus , Z⊗X) • R (plus , Z⊗Y) • S1 • H1 • CZ • S0 • S0 • S0 • S1 • S1 • W ^ 6 • W ^ 2 • S1⁻¹ • S1⁻¹ • S0⁻¹ • S0⁻¹ • S0⁻¹ • CZ • H1 • S1⁻¹ • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • H1 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • H1 • S1 • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • H1 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • S1 • H1 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0 • T0⁻¹ • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • H1 • S1⁻¹ • R (plus , Z⊗Z) • R (plus , I⊗X) • R (plus , Z⊗X) • R (plus , Z⊗Y) • R (plus , I⊗X) • R (plus , Z⊗X) • S1 • H1 • CZ • S0 • S0 • S0 • S1 • S1 • W ^ 6 • ε
          by clifford-tactic 114 0 10000 auto
      equals R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , Z⊗Z) • R (plus , I⊗X) • R (plus , Z⊗X) • R (plus , Z⊗Y) • S1 • H1 • CZ • S0 • S0 • S0 • S1 • S1 • W ^ 6 • W ^ 2 • S1⁻¹ • S1⁻¹ • S0⁻¹ • S0⁻¹ • S0⁻¹ • CZ • H1 • S1⁻¹ • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • H1 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • H1 • S1 • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • H1 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • S1 • H1 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • H1 • S1⁻¹ • S1⁻¹ • H1 • X0 • CZ • CZ • X0 • H1 • S1 • S1 • H1 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • H1 • S1⁻¹ • R (plus , Z⊗Z) • R (plus , I⊗X) • R (plus , Z⊗X) • R (plus , Z⊗Y) • R (plus , I⊗X) • R (plus , Z⊗X) • S1 • H1 • CZ • S0 • S0 • S0 • S1 • S1 • W ^ 6 • ε
          by clifford-tactic 0 0 10000 auto
      equals S1 • H1 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • H1 • S1⁻¹ • R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , Z⊗Z) • R (plus , I⊗X) • R (plus , Z⊗X) • R (plus , Z⊗Y) • S1 • H1 • CZ • S0 • S0 • S0 • S1 • S1 • W ^ 6 • W ^ 2 • S1⁻¹ • S1⁻¹ • S0⁻¹ • S0⁻¹ • S0⁻¹ • CZ • H1 • S1⁻¹ • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • H1 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • H1 • S1 • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • H1 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • S1 • H1 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • H1 • S1⁻¹ • S1⁻¹ • H1 • X0 • CZ • CZ • X0 • H1 • S1 • S1 • H1 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • H1 • S1⁻¹ • R (plus , Z⊗Z) • R (plus , I⊗X) • R (plus , Z⊗X) • R (plus , Z⊗Y) • R (plus , I⊗X) • R (plus , Z⊗X) • S1 • H1 • CZ • S0 • S0 • S0 • S1 • S1 • W ^ 6 • ε
          by in-context 11 0 auto (symm lemma-order-T0)
      equals S1 • H1 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0 • T0 • T0 • T0 • T0 • T0 • T0 • T0 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • H1 • S1⁻¹ • R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , Z⊗Z) • R (plus , I⊗X) • R (plus , Z⊗X) • R (plus , Z⊗Y) • S1 • H1 • CZ • S0 • S0 • S0 • S1 • S1 • W ^ 6 • W ^ 2 • S1⁻¹ • S1⁻¹ • S0⁻¹ • S0⁻¹ • S0⁻¹ • CZ • H1 • S1⁻¹ • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • H1 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • H1 • S1 • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • H1 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • S1 • H1 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • H1 • S1⁻¹ • S1⁻¹ • H1 • X0 • CZ • CZ • X0 • H1 • S1 • S1 • H1 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • H1 • S1⁻¹ • R (plus , Z⊗Z) • R (plus , I⊗X) • R (plus , Z⊗X) • R (plus , Z⊗Y) • R (plus , I⊗X) • R (plus , Z⊗X) • S1 • H1 • CZ • S0 • S0 • S0 • S1 • S1 • W ^ 6 • ε
          by general-assoc auto
      equals S1 • H1 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0 • T0⁻¹ • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • H1 • S1⁻¹ • R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , Z⊗Z) • R (plus , I⊗X) • R (plus , Z⊗X) • R (plus , Z⊗Y) • S1 • H1 • CZ • S0 • S0 • S0 • S1 • S1 • W ^ 6 • W ^ 2 • S1⁻¹ • S1⁻¹ • S0⁻¹ • S0⁻¹ • S0⁻¹ • CZ • H1 • S1⁻¹ • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • H1 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • H1 • S1 • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • H1 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • S1 • H1 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • H1 • S1⁻¹ • S1⁻¹ • H1 • X0 • CZ • CZ • X0 • H1 • S1 • S1 • H1 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • H1 • S1⁻¹ • R (plus , Z⊗Z) • R (plus , I⊗X) • R (plus , Z⊗X) • R (plus , Z⊗Y) • R (plus , I⊗X) • R (plus , Z⊗X) • S1 • H1 • CZ • S0 • S0 • S0 • S1 • S1 • W ^ 6 • ε
          by clifford-tactic 12 0 10000 auto
      equals S1 • H1 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • H1 • S1⁻¹ • S1⁻¹ • H1 • X0 • CZ • CZ • X0 • H1 • S1 • S1 • H1 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • H1 • S1⁻¹ • R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , Z⊗Z) • R (plus , I⊗X) • R (plus , Z⊗X) • R (plus , Z⊗Y) • S1 • H1 • CZ • S0 • S0 • S0 • S1 • S1 • W ^ 6 • W ^ 2 • S1⁻¹ • S1⁻¹ • S0⁻¹ • S0⁻¹ • S0⁻¹ • CZ • H1 • S1⁻¹ • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • H1 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • H1 • S1 • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • H1 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • S1 • H1 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • H1 • S1⁻¹ • S1⁻¹ • H1 • X0 • CZ • CZ • X0 • H1 • S1 • S1 • H1 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • H1 • S1⁻¹ • R (plus , Z⊗Z) • R (plus , I⊗X) • R (plus , Z⊗X) • R (plus , Z⊗Y) • R (plus , I⊗X) • R (plus , Z⊗X) • S1 • H1 • CZ • S0 • S0 • S0 • S1 • S1 • W ^ 6 • ε
          by in-context 42 1 auto lemma-R-T0⁻¹
      equals S1 • H1 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • H1 • S1⁻¹ • S1⁻¹ • H1 • X0 • CZ • CZ • X0 • H1 • S1 • S1 • H1 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • R (plus , Z⊗I) • S0⁻¹ • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • H1 • S1⁻¹ • R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , Z⊗Z) • R (plus , I⊗X) • R (plus , Z⊗X) • R (plus , Z⊗Y) • S1 • H1 • CZ • S0 • S0 • S0 • S1 • S1 • W ^ 6 • W ^ 2 • S1⁻¹ • S1⁻¹ • S0⁻¹ • S0⁻¹ • S0⁻¹ • CZ • H1 • S1⁻¹ • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • H1 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • H1 • S1 • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • H1 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • S1 • H1 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • H1 • S1⁻¹ • S1⁻¹ • H1 • X0 • CZ • CZ • X0 • H1 • S1 • S1 • H1 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • H1 • S1⁻¹ • R (plus , Z⊗Z) • R (plus , I⊗X) • R (plus , Z⊗X) • R (plus , Z⊗Y) • R (plus , I⊗X) • R (plus , Z⊗X) • S1 • H1 • CZ • S0 • S0 • S0 • S1 • S1 • W ^ 6 • ε
          by in-context 83 1 auto lemma-R-T0⁻¹
      equals S1 • H1 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • H1 • S1⁻¹ • S1⁻¹ • H1 • X0 • CZ • CZ • X0 • H1 • S1 • S1 • H1 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • R (plus , Z⊗I) • S0⁻¹ • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • H1 • S1⁻¹ • R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , Z⊗Z) • R (plus , I⊗X) • R (plus , Z⊗X) • R (plus , Z⊗Y) • S1 • H1 • CZ • S0 • S0 • S0 • S1 • S1 • W ^ 6 • W ^ 2 • S1⁻¹ • S1⁻¹ • S0⁻¹ • S0⁻¹ • S0⁻¹ • CZ • H1 • S1⁻¹ • H1 • H0 • CZ • H0 • R (plus , Z⊗I) • S0⁻¹ • H0 • CZ • H0 • H1 • H1 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • H1 • S1 • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • H1 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • S1 • H1 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • H1 • S1⁻¹ • S1⁻¹ • H1 • X0 • CZ • CZ • X0 • H1 • S1 • S1 • H1 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • H1 • S1⁻¹ • R (plus , Z⊗Z) • R (plus , I⊗X) • R (plus , Z⊗X) • R (plus , Z⊗Y) • R (plus , I⊗X) • R (plus , Z⊗X) • S1 • H1 • CZ • S0 • S0 • S0 • S1 • S1 • W ^ 6 • ε
          by in-context 99 1 auto lemma-R-T0⁻¹
      equals S1 • H1 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • H1 • S1⁻¹ • S1⁻¹ • H1 • X0 • CZ • CZ • X0 • H1 • S1 • S1 • H1 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • R (plus , Z⊗I) • S0⁻¹ • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • H1 • S1⁻¹ • R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , Z⊗Z) • R (plus , I⊗X) • R (plus , Z⊗X) • R (plus , Z⊗Y) • S1 • H1 • CZ • S0 • S0 • S0 • S1 • S1 • W ^ 6 • W ^ 2 • S1⁻¹ • S1⁻¹ • S0⁻¹ • S0⁻¹ • S0⁻¹ • CZ • H1 • S1⁻¹ • H1 • H0 • CZ • H0 • R (plus , Z⊗I) • S0⁻¹ • H0 • CZ • H0 • H1 • H1 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • R (plus , Z⊗I) • S0⁻¹ • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • H1 • S1 • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • H1 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • S1 • H1 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • H1 • S1⁻¹ • S1⁻¹ • H1 • X0 • CZ • CZ • X0 • H1 • S1 • S1 • H1 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • H1 • S1⁻¹ • R (plus , Z⊗Z) • R (plus , I⊗X) • R (plus , Z⊗X) • R (plus , Z⊗Y) • R (plus , I⊗X) • R (plus , Z⊗X) • S1 • H1 • CZ • S0 • S0 • S0 • S1 • S1 • W ^ 6 • ε
          by in-context 116 1 auto lemma-R-T0⁻¹
      equals S1 • H1 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • H1 • S1⁻¹ • S1⁻¹ • H1 • X0 • CZ • CZ • X0 • H1 • S1 • S1 • H1 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • R (plus , Z⊗I) • S0⁻¹ • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • H1 • S1⁻¹ • R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , Z⊗Z) • R (plus , I⊗X) • R (plus , Z⊗X) • R (plus , Z⊗Y) • S1 • H1 • CZ • S0 • S0 • S0 • S1 • S1 • W ^ 6 • W ^ 2 • S1⁻¹ • S1⁻¹ • S0⁻¹ • S0⁻¹ • S0⁻¹ • CZ • H1 • S1⁻¹ • H1 • H0 • CZ • H0 • R (plus , Z⊗I) • S0⁻¹ • H0 • CZ • H0 • H1 • H1 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • R (plus , Z⊗I) • S0⁻¹ • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • H1 • S1 • H1 • H0 • CZ • H0 • R (plus , Z⊗I) • S0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • H1 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • S1 • H1 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • H1 • S1⁻¹ • S1⁻¹ • H1 • X0 • CZ • CZ • X0 • H1 • S1 • S1 • H1 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • H1 • S1⁻¹ • R (plus , Z⊗Z) • R (plus , I⊗X) • R (plus , Z⊗X) • R (plus , Z⊗Y) • R (plus , I⊗X) • R (plus , Z⊗X) • S1 • H1 • CZ • S0 • S0 • S0 • S1 • S1 • W ^ 6 • ε
          by in-context 127 1 auto lemma-R-T0⁻¹
      equals S1 • H1 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • H1 • S1⁻¹ • S1⁻¹ • H1 • X0 • CZ • CZ • X0 • H1 • S1 • S1 • H1 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • R (plus , Z⊗I) • S0⁻¹ • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • H1 • S1⁻¹ • R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , Z⊗Z) • R (plus , I⊗X) • R (plus , Z⊗X) • R (plus , Z⊗Y) • S1 • H1 • CZ • S0 • S0 • S0 • S1 • S1 • W ^ 6 • W ^ 2 • S1⁻¹ • S1⁻¹ • S0⁻¹ • S0⁻¹ • S0⁻¹ • CZ • H1 • S1⁻¹ • H1 • H0 • CZ • H0 • R (plus , Z⊗I) • S0⁻¹ • H0 • CZ • H0 • H1 • H1 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • R (plus , Z⊗I) • S0⁻¹ • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • H1 • S1 • H1 • H0 • CZ • H0 • R (plus , Z⊗I) • S0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • H1 • H0 • CZ • H0 • R (plus , Z⊗I) • S0⁻¹ • H0 • CZ • H0 • H1 • H1 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • S1 • H1 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • H1 • S1⁻¹ • S1⁻¹ • H1 • X0 • CZ • CZ • X0 • H1 • S1 • S1 • H1 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • H1 • S1⁻¹ • R (plus , Z⊗Z) • R (plus , I⊗X) • R (plus , Z⊗X) • R (plus , Z⊗Y) • R (plus , I⊗X) • R (plus , Z⊗X) • S1 • H1 • CZ • S0 • S0 • S0 • S1 • S1 • W ^ 6 • ε
          by in-context 143 1 auto lemma-R-T0⁻¹
      equals S1 • H1 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • H1 • S1⁻¹ • S1⁻¹ • H1 • X0 • CZ • CZ • X0 • H1 • S1 • S1 • H1 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • R (plus , Z⊗I) • S0⁻¹ • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • H1 • S1⁻¹ • R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , Z⊗Z) • R (plus , I⊗X) • R (plus , Z⊗X) • R (plus , Z⊗Y) • S1 • H1 • CZ • S0 • S0 • S0 • S1 • S1 • W ^ 6 • W ^ 2 • S1⁻¹ • S1⁻¹ • S0⁻¹ • S0⁻¹ • S0⁻¹ • CZ • H1 • S1⁻¹ • H1 • H0 • CZ • H0 • R (plus , Z⊗I) • S0⁻¹ • H0 • CZ • H0 • H1 • H1 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • R (plus , Z⊗I) • S0⁻¹ • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • H1 • S1 • H1 • H0 • CZ • H0 • R (plus , Z⊗I) • S0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • H1 • H0 • CZ • H0 • R (plus , Z⊗I) • S0⁻¹ • H0 • CZ • H0 • H1 • H1 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • R (plus , Z⊗I) • S0⁻¹ • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • S1 • H1 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • H1 • S1⁻¹ • S1⁻¹ • H1 • X0 • CZ • CZ • X0 • H1 • S1 • S1 • H1 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • H1 • S1⁻¹ • R (plus , Z⊗Z) • R (plus , I⊗X) • R (plus , Z⊗X) • R (plus , Z⊗Y) • R (plus , I⊗X) • R (plus , Z⊗X) • S1 • H1 • CZ • S0 • S0 • S0 • S1 • S1 • W ^ 6 • ε
          by in-context 158 1 auto lemma-R-T0⁻¹
      equals S1 • H1 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • H1 • S1⁻¹ • S1⁻¹ • H1 • X0 • CZ • CZ • X0 • H1 • S1 • S1 • H1 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • R (plus , Z⊗I) • S0⁻¹ • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • H1 • S1⁻¹ • R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , Z⊗Z) • R (plus , I⊗X) • R (plus , Z⊗X) • R (plus , Z⊗Y) • S1 • H1 • CZ • S0 • S0 • S0 • S1 • S1 • W ^ 6 • W ^ 2 • S1⁻¹ • S1⁻¹ • S0⁻¹ • S0⁻¹ • S0⁻¹ • CZ • H1 • S1⁻¹ • H1 • H0 • CZ • H0 • R (plus , Z⊗I) • S0⁻¹ • H0 • CZ • H0 • H1 • H1 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • R (plus , Z⊗I) • S0⁻¹ • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • H1 • S1 • H1 • H0 • CZ • H0 • R (plus , Z⊗I) • S0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • H1 • H0 • CZ • H0 • R (plus , Z⊗I) • S0⁻¹ • H0 • CZ • H0 • H1 • H1 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • R (plus , Z⊗I) • S0⁻¹ • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • H1 • H0 • CZ • H0 • R (plus , Z⊗I) • S0⁻¹ • H0 • CZ • H0 • S1 • H1 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • H1 • S1⁻¹ • S1⁻¹ • H1 • X0 • CZ • CZ • X0 • H1 • S1 • S1 • H1 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • H1 • S1⁻¹ • R (plus , Z⊗Z) • R (plus , I⊗X) • R (plus , Z⊗X) • R (plus , Z⊗Y) • R (plus , I⊗X) • R (plus , Z⊗X) • S1 • H1 • CZ • S0 • S0 • S0 • S1 • S1 • W ^ 6 • ε
          by general-assoc auto
      equals S1 • H1 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • H1 • S1⁻¹ • S1⁻¹ • H1 • X0 • CZ • CZ • H0 • S0 • S0 • H0 • H1 • S1 • S1 • H1 • Swap • R (plus , Z⊗I) • S0⁻¹ • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • H1 • S1⁻¹ • R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , Z⊗Z) • R (plus , I⊗X) • R (plus , Z⊗X) • R (plus , Z⊗Y) • S1 • H1 • CZ • S0 • S0 • S0 • S1 • S1 • W ^ 6 • W ^ 2 • S1⁻¹ • S1⁻¹ • S0⁻¹ • S0⁻¹ • S0⁻¹ • CZ • H1 • S1⁻¹ • H1 • H0 • CZ • H0 • R (plus , Z⊗I) • S0⁻¹ • H0 • CZ • H0 • H1 • H1 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • R (plus , Z⊗I) • S0⁻¹ • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • H1 • S1 • H1 • H0 • CZ • H0 • R (plus , Z⊗I) • S0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • H1 • H0 • CZ • H0 • R (plus , Z⊗I) • S0⁻¹ • H0 • CZ • H0 • H1 • H1 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • R (plus , Z⊗I) • S0⁻¹ • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • H1 • H0 • CZ • H0 • R (plus , Z⊗I) • S0⁻¹ • H0 • CZ • H0 • S1 • H1 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • R (plus , Z⊗I) • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • H1 • S1⁻¹ • S1⁻¹ • H1 • X0 • CZ • CZ • X0 • H1 • S1 • S1 • H1 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • H1 • S1⁻¹ • R (plus , Z⊗Z) • R (plus , I⊗X) • R (plus , Z⊗X) • R (plus , Z⊗Y) • R (plus , I⊗X) • R (plus , Z⊗X) • S1 • H1 • CZ • S0 • S0 • S0 • S1 • S1 • W ^ 6 • ε
          by clifford-tactic 38 12 10000 auto
      equals S1 • H1 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • H1 • S1⁻¹ • S1⁻¹ • H1 • X0 • CZ • CZ • H0 • S0 • S0 • H0 • H1 • S1 • S1 • H1 • Swap • R (plus , Z⊗I) • H0 • S0 • H0 • W⁻¹ • Swap • R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , Z⊗Z) • R (plus , I⊗X) • R (plus , Z⊗X) • R (plus , Z⊗Y) • S1 • H1 • CZ • S0 • S0 • S0 • S1 • S1 • W ^ 6 • W ^ 2 • S1⁻¹ • S1⁻¹ • S0⁻¹ • S0⁻¹ • S0⁻¹ • CZ • H1 • S1⁻¹ • H1 • H0 • CZ • H0 • R (plus , Z⊗I) • S0⁻¹ • H0 • CZ • H0 • H1 • H1 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • R (plus , Z⊗I) • S0⁻¹ • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • H1 • S1 • H1 • H0 • CZ • H0 • R (plus , Z⊗I) • S0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • H1 • H0 • CZ • H0 • R (plus , Z⊗I) • S0⁻¹ • H0 • CZ • H0 • H1 • H1 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • R (plus , Z⊗I) • S0⁻¹ • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • H1 • H0 • CZ • H0 • R (plus , Z⊗I) • S0⁻¹ • H0 • CZ • H0 • S1 • H1 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • R (plus , Z⊗I) • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • H1 • S1⁻¹ • S1⁻¹ • H1 • X0 • CZ • CZ • X0 • H1 • S1 • S1 • H1 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • H1 • S1⁻¹ • R (plus , Z⊗Z) • R (plus , I⊗X) • R (plus , Z⊗X) • R (plus , Z⊗Y) • R (plus , I⊗X) • R (plus , Z⊗X) • S1 • H1 • CZ • S0 • S0 • S0 • S1 • S1 • W ^ 6 • ε
          by clifford-tactic 49 20 10000 auto
      equals S1 • H1 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • H1 • S1⁻¹ • S1⁻¹ • H1 • X0 • CZ • CZ • H0 • S0 • S0 • H0 • H1 • S1 • S1 • H1 • Swap • R (plus , Z⊗I) • H0 • S0 • H0 • W⁻¹ • Swap • R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , Z⊗Z) • R (plus , I⊗X) • R (plus , Z⊗X) • R (plus , Z⊗Y) • H0 • H1 • CZ • H0 • R (plus , Z⊗I) • S0⁻¹ • H0 • CZ • H0 • H1 • H1 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • R (plus , Z⊗I) • S0⁻¹ • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • H1 • S1 • H1 • H0 • CZ • H0 • R (plus , Z⊗I) • S0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • H1 • H0 • CZ • H0 • R (plus , Z⊗I) • S0⁻¹ • H0 • CZ • H0 • H1 • H1 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • R (plus , Z⊗I) • S0⁻¹ • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • H1 • H0 • CZ • H0 • R (plus , Z⊗I) • S0⁻¹ • H0 • CZ • H0 • S1 • H1 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • R (plus , Z⊗I) • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • H1 • S1⁻¹ • S1⁻¹ • H1 • X0 • CZ • CZ • X0 • H1 • S1 • S1 • H1 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • H1 • S1⁻¹ • R (plus , Z⊗Z) • R (plus , I⊗X) • R (plus , Z⊗X) • R (plus , Z⊗Y) • R (plus , I⊗X) • R (plus , Z⊗X) • S1 • H1 • CZ • S0 • S0 • S0 • S1 • S1 • W ^ 6 • ε
          by clifford-tactic 54 15 10000 auto
      equals S1 • H1 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • H1 • S1⁻¹ • S1⁻¹ • H1 • X0 • CZ • CZ • H0 • S0 • S0 • H0 • H1 • S1 • S1 • H1 • Swap • R (plus , Z⊗I) • H0 • S0 • H0 • W⁻¹ • Swap • R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , Z⊗Z) • R (plus , I⊗X) • R (plus , Z⊗X) • R (plus , Z⊗Y) • H0 • H1 • CZ • H0 • R (plus , Z⊗I) • S0 • H0 • CZ • H0 • S0 • S0 • S1 • S1 • Swap • R (plus , Z⊗I) • S0⁻¹ • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • H1 • S1 • H1 • H0 • CZ • H0 • R (plus , Z⊗I) • S0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • H1 • H0 • CZ • H0 • R (plus , Z⊗I) • S0⁻¹ • H0 • CZ • H0 • H1 • H1 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • R (plus , Z⊗I) • S0⁻¹ • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • H1 • H0 • CZ • H0 • R (plus , Z⊗I) • S0⁻¹ • H0 • CZ • H0 • S1 • H1 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • R (plus , Z⊗I) • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • H1 • S1⁻¹ • S1⁻¹ • H1 • X0 • CZ • CZ • X0 • H1 • S1 • S1 • H1 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • H1 • S1⁻¹ • R (plus , Z⊗Z) • R (plus , I⊗X) • R (plus , Z⊗X) • R (plus , Z⊗Y) • R (plus , I⊗X) • R (plus , Z⊗X) • S1 • H1 • CZ • S0 • S0 • S0 • S1 • S1 • W ^ 6 • ε
          by clifford-tactic 64 16 10000 auto
      equals S1 • H1 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • H1 • S1⁻¹ • S1⁻¹ • H1 • X0 • CZ • CZ • H0 • S0 • S0 • H0 • H1 • S1 • S1 • H1 • Swap • R (plus , Z⊗I) • H0 • S0 • H0 • W⁻¹ • Swap • R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , Z⊗Z) • R (plus , I⊗X) • R (plus , Z⊗X) • R (plus , Z⊗Y) • H0 • H1 • CZ • H0 • R (plus , Z⊗I) • S0 • H0 • CZ • H0 • S0 • S0 • S1 • S1 • Swap • R (plus , Z⊗I) • H0 • H1 • CZ • S0 • H0 • S0 • S0 • H0 • S1 • S1 • H1 • W⁻¹ • Swap • R (plus , Z⊗I) • S0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • H1 • H0 • CZ • H0 • R (plus , Z⊗I) • S0⁻¹ • H0 • CZ • H0 • H1 • H1 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • R (plus , Z⊗I) • S0⁻¹ • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • H1 • H0 • CZ • H0 • R (plus , Z⊗I) • S0⁻¹ • H0 • CZ • H0 • S1 • H1 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • R (plus , Z⊗I) • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • H1 • S1⁻¹ • S1⁻¹ • H1 • X0 • CZ • CZ • X0 • H1 • S1 • S1 • H1 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • H1 • S1⁻¹ • R (plus , Z⊗Z) • R (plus , I⊗X) • R (plus , Z⊗X) • R (plus , Z⊗Y) • R (plus , I⊗X) • R (plus , Z⊗X) • S1 • H1 • CZ • S0 • S0 • S0 • S1 • S1 • W ^ 6 • ε
          by clifford-tactic 89 15 10000 auto
      equals S1 • H1 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • H1 • S1⁻¹ • S1⁻¹ • H1 • X0 • CZ • CZ • H0 • S0 • S0 • H0 • H1 • S1 • S1 • H1 • Swap • R (plus , Z⊗I) • H0 • S0 • H0 • W⁻¹ • Swap • R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , Z⊗Z) • R (plus , I⊗X) • R (plus , Z⊗X) • R (plus , Z⊗Y) • H0 • H1 • CZ • H0 • R (plus , Z⊗I) • S0 • H0 • CZ • H0 • S0 • S0 • S1 • S1 • Swap • R (plus , Z⊗I) • H0 • H1 • CZ • S0 • H0 • S0 • S0 • H0 • S1 • S1 • H1 • W⁻¹ • Swap • R (plus , Z⊗I) • S0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • H1 • H0 • CZ • H0 • R (plus , Z⊗I) • S0 • H0 • CZ • H0 • S0 • S0 • S1 • S1 • Swap • R (plus , Z⊗I) • S0⁻¹ • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • H1 • H0 • CZ • H0 • R (plus , Z⊗I) • S0⁻¹ • H0 • CZ • H0 • S1 • H1 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • R (plus , Z⊗I) • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • H1 • S1⁻¹ • S1⁻¹ • H1 • X0 • CZ • CZ • X0 • H1 • S1 • S1 • H1 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • H1 • S1⁻¹ • R (plus , Z⊗Z) • R (plus , I⊗X) • R (plus , Z⊗X) • R (plus , Z⊗Y) • R (plus , I⊗X) • R (plus , Z⊗X) • S1 • H1 • CZ • S0 • S0 • S0 • S1 • S1 • W ^ 6 • ε
          by clifford-tactic 99 14 10000 auto
      equals S1 • H1 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • H1 • S1⁻¹ • S1⁻¹ • H1 • X0 • CZ • CZ • H0 • S0 • S0 • H0 • H1 • S1 • S1 • H1 • Swap • R (plus , Z⊗I) • H0 • S0 • H0 • W⁻¹ • Swap • R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , Z⊗Z) • R (plus , I⊗X) • R (plus , Z⊗X) • R (plus , Z⊗Y) • H0 • H1 • CZ • H0 • R (plus , Z⊗I) • S0 • H0 • CZ • H0 • S0 • S0 • S1 • S1 • Swap • R (plus , Z⊗I) • H0 • H1 • CZ • S0 • H0 • S0 • S0 • H0 • S1 • S1 • H1 • W⁻¹ • Swap • R (plus , Z⊗I) • S0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • H1 • H0 • CZ • H0 • R (plus , Z⊗I) • S0 • H0 • CZ • H0 • S0 • S0 • S1 • S1 • Swap • R (plus , Z⊗I) • CZ • S0 • H0 • H1 • CZ • H0 • S0 • S0 • H0 • S1 • S1 • H1 • R (plus , Z⊗I) • S0⁻¹ • H0 • CZ • H0 • S1 • H1 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • R (plus , Z⊗I) • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • H1 • S1⁻¹ • S1⁻¹ • H1 • X0 • CZ • CZ • X0 • H1 • S1 • S1 • H1 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • H1 • S1⁻¹ • R (plus , Z⊗Z) • R (plus , I⊗X) • R (plus , Z⊗X) • R (plus , Z⊗Y) • R (plus , I⊗X) • R (plus , Z⊗X) • S1 • H1 • CZ • S0 • S0 • S0 • S1 • S1 • W ^ 6 • ε
          by clifford-tactic 112 15 10000 auto
      equals S1 • H1 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • H1 • S1⁻¹ • S1⁻¹ • H1 • X0 • CZ • CZ • H0 • S0 • S0 • H0 • H1 • S1 • S1 • H1 • Swap • R (plus , Z⊗I) • H0 • S0 • H0 • W⁻¹ • Swap • R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , Z⊗Z) • R (plus , I⊗X) • R (plus , Z⊗X) • R (plus , Z⊗Y) • H0 • H1 • CZ • H0 • R (plus , Z⊗I) • S0 • H0 • CZ • H0 • S0 • S0 • S1 • S1 • Swap • R (plus , Z⊗I) • H0 • H1 • CZ • S0 • H0 • S0 • S0 • H0 • S1 • S1 • H1 • W⁻¹ • Swap • R (plus , Z⊗I) • S0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • H1 • H0 • CZ • H0 • R (plus , Z⊗I) • S0 • H0 • CZ • H0 • S0 • S0 • S1 • S1 • Swap • R (plus , Z⊗I) • CZ • S0 • H0 • H1 • CZ • H0 • S0 • S0 • H0 • S1 • S1 • H1 • R (plus , Z⊗I) • S0 • H0 • CZ • H0 • S0 • S0 • S1 • S1 • S1 • H1 • Swap • R (plus , Z⊗I) • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • H1 • S1⁻¹ • S1⁻¹ • H1 • X0 • CZ • CZ • X0 • H1 • S1 • S1 • H1 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • H1 • S1⁻¹ • R (plus , Z⊗Z) • R (plus , I⊗X) • R (plus , Z⊗X) • R (plus , Z⊗Y) • R (plus , I⊗X) • R (plus , Z⊗X) • S1 • H1 • CZ • S0 • S0 • S0 • S1 • S1 • W ^ 6 • ε
          by in-context 27 11 auto (lemma-R (C.CZ • C.H0 • C.S0 • C.S0 • C.H0 • C.H1 • C.S1 • C.S1 • C.H1 • C.Swap) (plus , Z⊗I))
      equals S1 • H1 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • H1 • S1⁻¹ • S1⁻¹ • H1 • X0 • CZ • R (minus , I⊗Z) • CZ • H0 • S0 • S0 • H0 • H1 • S1 • S1 • H1 • Swap • H0 • S0 • H0 • W⁻¹ • Swap • R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , Z⊗Z) • R (plus , I⊗X) • R (plus , Z⊗X) • R (plus , Z⊗Y) • H0 • H1 • CZ • H0 • R (plus , Z⊗I) • S0 • H0 • CZ • H0 • S0 • S0 • S1 • S1 • Swap • R (plus , Z⊗I) • H0 • H1 • CZ • S0 • H0 • S0 • S0 • H0 • S1 • S1 • H1 • W⁻¹ • Swap • R (plus , Z⊗I) • S0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • H1 • H0 • CZ • H0 • R (plus , Z⊗I) • S0 • H0 • CZ • H0 • S0 • S0 • S1 • S1 • Swap • R (plus , Z⊗I) • CZ • S0 • H0 • H1 • CZ • H0 • S0 • S0 • H0 • S1 • S1 • H1 • R (plus , Z⊗I) • S0 • H0 • CZ • H0 • S0 • S0 • S1 • S1 • S1 • H1 • Swap • R (plus , Z⊗I) • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • H1 • S1⁻¹ • S1⁻¹ • H1 • X0 • CZ • CZ • X0 • H1 • S1 • S1 • H1 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • H1 • S1⁻¹ • R (plus , Z⊗Z) • R (plus , I⊗X) • R (plus , Z⊗X) • R (plus , Z⊗Y) • R (plus , I⊗X) • R (plus , Z⊗X) • S1 • H1 • CZ • S0 • S0 • S0 • S1 • S1 • W ^ 6 • ε
          by clifford-tactic 33 10 10000 auto
      equals S1 • H1 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • H1 • S1⁻¹ • S1⁻¹ • H1 • X0 • CZ • R (minus , I⊗Z) • CZ • H0 • S0 • S0 • H0 • S1 • H1 • S1 • W ^ 6 • R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , Z⊗Z) • R (plus , I⊗X) • R (plus , Z⊗X) • R (plus , Z⊗Y) • H0 • H1 • CZ • H0 • R (plus , Z⊗I) • S0 • H0 • CZ • H0 • S0 • S0 • S1 • S1 • Swap • R (plus , Z⊗I) • H0 • H1 • CZ • S0 • H0 • S0 • S0 • H0 • S1 • S1 • H1 • W⁻¹ • Swap • R (plus , Z⊗I) • S0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • H1 • H0 • CZ • H0 • R (plus , Z⊗I) • S0 • H0 • CZ • H0 • S0 • S0 • S1 • S1 • Swap • R (plus , Z⊗I) • CZ • S0 • H0 • H1 • CZ • H0 • S0 • S0 • H0 • S1 • S1 • H1 • R (plus , Z⊗I) • S0 • H0 • CZ • H0 • S0 • S0 • S1 • S1 • S1 • H1 • Swap • R (plus , Z⊗I) • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • H1 • S1⁻¹ • S1⁻¹ • H1 • X0 • CZ • CZ • X0 • H1 • S1 • S1 • H1 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • H1 • S1⁻¹ • R (plus , Z⊗Z) • R (plus , I⊗X) • R (plus , Z⊗X) • R (plus , Z⊗Y) • R (plus , I⊗X) • R (plus , Z⊗X) • S1 • H1 • CZ • S0 • S0 • S0 • S1 • S1 • W ^ 6 • ε
          by in-context 28 10 auto (lemma-R (C.CZ • C.H0 • C.S0 • C.S0 • C.H0 • C.S1 • C.H1 • C.S1 • C.W ^ 6) (plus , I⊗Y))
      equals S1 • H1 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • H1 • S1⁻¹ • S1⁻¹ • H1 • X0 • CZ • R (minus , I⊗Z) • R (minus , I⊗Z) • CZ • H0 • S0 • S0 • H0 • S1 • H1 • S1 • W ^ 6 • R (plus , Z⊗Y) • R (plus , Z⊗Z) • R (plus , I⊗X) • R (plus , Z⊗X) • R (plus , Z⊗Y) • H0 • H1 • CZ • H0 • R (plus , Z⊗I) • S0 • H0 • CZ • H0 • S0 • S0 • S1 • S1 • Swap • R (plus , Z⊗I) • H0 • H1 • CZ • S0 • H0 • S0 • S0 • H0 • S1 • S1 • H1 • W⁻¹ • Swap • R (plus , Z⊗I) • S0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • H1 • H0 • CZ • H0 • R (plus , Z⊗I) • S0 • H0 • CZ • H0 • S0 • S0 • S1 • S1 • Swap • R (plus , Z⊗I) • CZ • S0 • H0 • H1 • CZ • H0 • S0 • S0 • H0 • S1 • S1 • H1 • R (plus , Z⊗I) • S0 • H0 • CZ • H0 • S0 • S0 • S1 • S1 • S1 • H1 • Swap • R (plus , Z⊗I) • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • H1 • S1⁻¹ • S1⁻¹ • H1 • X0 • CZ • CZ • X0 • H1 • S1 • S1 • H1 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • H1 • S1⁻¹ • R (plus , Z⊗Z) • R (plus , I⊗X) • R (plus , Z⊗X) • R (plus , Z⊗Y) • R (plus , I⊗X) • R (plus , Z⊗X) • S1 • H1 • CZ • S0 • S0 • S0 • S1 • S1 • W ^ 6 • ε
          by in-context 29 10 auto (lemma-R (C.CZ • C.H0 • C.S0 • C.S0 • C.H0 • C.S1 • C.H1 • C.S1 • C.W ^ 6) (plus , Z⊗Y))
      equals S1 • H1 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • H1 • S1⁻¹ • S1⁻¹ • H1 • X0 • CZ • R (minus , I⊗Z) • R (minus , I⊗Z) • R (plus , Z⊗Z) • CZ • H0 • S0 • S0 • H0 • S1 • H1 • S1 • W ^ 6 • R (plus , Z⊗Z) • R (plus , I⊗X) • R (plus , Z⊗X) • R (plus , Z⊗Y) • H0 • H1 • CZ • H0 • R (plus , Z⊗I) • S0 • H0 • CZ • H0 • S0 • S0 • S1 • S1 • Swap • R (plus , Z⊗I) • H0 • H1 • CZ • S0 • H0 • S0 • S0 • H0 • S1 • S1 • H1 • W⁻¹ • Swap • R (plus , Z⊗I) • S0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • H1 • H0 • CZ • H0 • R (plus , Z⊗I) • S0 • H0 • CZ • H0 • S0 • S0 • S1 • S1 • Swap • R (plus , Z⊗I) • CZ • S0 • H0 • H1 • CZ • H0 • S0 • S0 • H0 • S1 • S1 • H1 • R (plus , Z⊗I) • S0 • H0 • CZ • H0 • S0 • S0 • S1 • S1 • S1 • H1 • Swap • R (plus , Z⊗I) • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • H1 • S1⁻¹ • S1⁻¹ • H1 • X0 • CZ • CZ • X0 • H1 • S1 • S1 • H1 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • H1 • S1⁻¹ • R (plus , Z⊗Z) • R (plus , I⊗X) • R (plus , Z⊗X) • R (plus , Z⊗Y) • R (plus , I⊗X) • R (plus , Z⊗X) • S1 • H1 • CZ • S0 • S0 • S0 • S1 • S1 • W ^ 6 • ε
          by in-context 30 10 auto (lemma-R (C.CZ • C.H0 • C.S0 • C.S0 • C.H0 • C.S1 • C.H1 • C.S1 • C.W ^ 6) (plus , Z⊗Z))
      equals S1 • H1 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • H1 • S1⁻¹ • S1⁻¹ • H1 • X0 • CZ • R (minus , I⊗Z) • R (minus , I⊗Z) • R (plus , Z⊗Z) • R (minus , I⊗Y) • CZ • H0 • S0 • S0 • H0 • S1 • H1 • S1 • W ^ 6 • R (plus , I⊗X) • R (plus , Z⊗X) • R (plus , Z⊗Y) • H0 • H1 • CZ • H0 • R (plus , Z⊗I) • S0 • H0 • CZ • H0 • S0 • S0 • S1 • S1 • Swap • R (plus , Z⊗I) • H0 • H1 • CZ • S0 • H0 • S0 • S0 • H0 • S1 • S1 • H1 • W⁻¹ • Swap • R (plus , Z⊗I) • S0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • H1 • H0 • CZ • H0 • R (plus , Z⊗I) • S0 • H0 • CZ • H0 • S0 • S0 • S1 • S1 • Swap • R (plus , Z⊗I) • CZ • S0 • H0 • H1 • CZ • H0 • S0 • S0 • H0 • S1 • S1 • H1 • R (plus , Z⊗I) • S0 • H0 • CZ • H0 • S0 • S0 • S1 • S1 • S1 • H1 • Swap • R (plus , Z⊗I) • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • H1 • S1⁻¹ • S1⁻¹ • H1 • X0 • CZ • CZ • X0 • H1 • S1 • S1 • H1 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • H1 • S1⁻¹ • R (plus , Z⊗Z) • R (plus , I⊗X) • R (plus , Z⊗X) • R (plus , Z⊗Y) • R (plus , I⊗X) • R (plus , Z⊗X) • S1 • H1 • CZ • S0 • S0 • S0 • S1 • S1 • W ^ 6 • ε
          by in-context 31 10 auto (lemma-R (C.CZ • C.H0 • C.S0 • C.S0 • C.H0 • C.S1 • C.H1 • C.S1 • C.W ^ 6) (plus , I⊗X))
      equals S1 • H1 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • H1 • S1⁻¹ • S1⁻¹ • H1 • X0 • CZ • R (minus , I⊗Z) • R (minus , I⊗Z) • R (plus , Z⊗Z) • R (minus , I⊗Y) • R (plus , Z⊗X) • CZ • H0 • S0 • S0 • H0 • S1 • H1 • S1 • W ^ 6 • R (plus , Z⊗X) • R (plus , Z⊗Y) • H0 • H1 • CZ • H0 • R (plus , Z⊗I) • S0 • H0 • CZ • H0 • S0 • S0 • S1 • S1 • Swap • R (plus , Z⊗I) • H0 • H1 • CZ • S0 • H0 • S0 • S0 • H0 • S1 • S1 • H1 • W⁻¹ • Swap • R (plus , Z⊗I) • S0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • H1 • H0 • CZ • H0 • R (plus , Z⊗I) • S0 • H0 • CZ • H0 • S0 • S0 • S1 • S1 • Swap • R (plus , Z⊗I) • CZ • S0 • H0 • H1 • CZ • H0 • S0 • S0 • H0 • S1 • S1 • H1 • R (plus , Z⊗I) • S0 • H0 • CZ • H0 • S0 • S0 • S1 • S1 • S1 • H1 • Swap • R (plus , Z⊗I) • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • H1 • S1⁻¹ • S1⁻¹ • H1 • X0 • CZ • CZ • X0 • H1 • S1 • S1 • H1 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • H1 • S1⁻¹ • R (plus , Z⊗Z) • R (plus , I⊗X) • R (plus , Z⊗X) • R (plus , Z⊗Y) • R (plus , I⊗X) • R (plus , Z⊗X) • S1 • H1 • CZ • S0 • S0 • S0 • S1 • S1 • W ^ 6 • ε
          by in-context 32 10 auto (lemma-R (C.CZ • C.H0 • C.S0 • C.S0 • C.H0 • C.S1 • C.H1 • C.S1 • C.W ^ 6) (plus , Z⊗X))
      equals S1 • H1 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • H1 • S1⁻¹ • S1⁻¹ • H1 • X0 • CZ • R (minus , I⊗Z) • R (minus , I⊗Z) • R (plus , Z⊗Z) • R (minus , I⊗Y) • R (plus , Z⊗X) • R (minus , I⊗X) • CZ • H0 • S0 • S0 • H0 • S1 • H1 • S1 • W ^ 6 • R (plus , Z⊗Y) • H0 • H1 • CZ • H0 • R (plus , Z⊗I) • S0 • H0 • CZ • H0 • S0 • S0 • S1 • S1 • Swap • R (plus , Z⊗I) • H0 • H1 • CZ • S0 • H0 • S0 • S0 • H0 • S1 • S1 • H1 • W⁻¹ • Swap • R (plus , Z⊗I) • S0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • H1 • H0 • CZ • H0 • R (plus , Z⊗I) • S0 • H0 • CZ • H0 • S0 • S0 • S1 • S1 • Swap • R (plus , Z⊗I) • CZ • S0 • H0 • H1 • CZ • H0 • S0 • S0 • H0 • S1 • S1 • H1 • R (plus , Z⊗I) • S0 • H0 • CZ • H0 • S0 • S0 • S1 • S1 • S1 • H1 • Swap • R (plus , Z⊗I) • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • H1 • S1⁻¹ • S1⁻¹ • H1 • X0 • CZ • CZ • X0 • H1 • S1 • S1 • H1 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • H1 • S1⁻¹ • R (plus , Z⊗Z) • R (plus , I⊗X) • R (plus , Z⊗X) • R (plus , Z⊗Y) • R (plus , I⊗X) • R (plus , Z⊗X) • S1 • H1 • CZ • S0 • S0 • S0 • S1 • S1 • W ^ 6 • ε
          by in-context 33 10 auto (lemma-R (C.CZ • C.H0 • C.S0 • C.S0 • C.H0 • C.S1 • C.H1 • C.S1 • C.W ^ 6) (plus , Z⊗Y))
      equals S1 • H1 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • H1 • S1⁻¹ • S1⁻¹ • H1 • X0 • CZ • R (minus , I⊗Z) • R (minus , I⊗Z) • R (plus , Z⊗Z) • R (minus , I⊗Y) • R (plus , Z⊗X) • R (minus , I⊗X) • R (plus , Z⊗Z) • CZ • H0 • S0 • S0 • H0 • S1 • H1 • S1 • W ^ 6 • H0 • H1 • CZ • H0 • R (plus , Z⊗I) • S0 • H0 • CZ • H0 • S0 • S0 • S1 • S1 • Swap • R (plus , Z⊗I) • H0 • H1 • CZ • S0 • H0 • S0 • S0 • H0 • S1 • S1 • H1 • W⁻¹ • Swap • R (plus , Z⊗I) • S0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • H1 • H0 • CZ • H0 • R (plus , Z⊗I) • S0 • H0 • CZ • H0 • S0 • S0 • S1 • S1 • Swap • R (plus , Z⊗I) • CZ • S0 • H0 • H1 • CZ • H0 • S0 • S0 • H0 • S1 • S1 • H1 • R (plus , Z⊗I) • S0 • H0 • CZ • H0 • S0 • S0 • S1 • S1 • S1 • H1 • Swap • R (plus , Z⊗I) • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • H1 • S1⁻¹ • S1⁻¹ • H1 • X0 • CZ • CZ • X0 • H1 • S1 • S1 • H1 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • H1 • S1⁻¹ • R (plus , Z⊗Z) • R (plus , I⊗X) • R (plus , Z⊗X) • R (plus , Z⊗Y) • R (plus , I⊗X) • R (plus , Z⊗X) • S1 • H1 • CZ • S0 • S0 • S0 • S1 • S1 • W ^ 6 • ε
          by clifford-tactic 36 11 10000 auto
      equals S1 • H1 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • H1 • S1⁻¹ • S1⁻¹ • H1 • X0 • CZ • R (minus , I⊗Z) • R (minus , I⊗Z) • R (plus , Z⊗Z) • R (minus , I⊗Y) • R (plus , Z⊗X) • R (minus , I⊗X) • R (plus , Z⊗Z) • CZ • H0 • H1 • CZ • S0 • S0 • H0 • S1 • S1 • S1 • W⁻¹ • R (plus , Z⊗I) • S0 • H0 • CZ • H0 • S0 • S0 • S1 • S1 • Swap • R (plus , Z⊗I) • H0 • H1 • CZ • S0 • H0 • S0 • S0 • H0 • S1 • S1 • H1 • W⁻¹ • Swap • R (plus , Z⊗I) • S0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • H1 • H0 • CZ • H0 • R (plus , Z⊗I) • S0 • H0 • CZ • H0 • S0 • S0 • S1 • S1 • Swap • R (plus , Z⊗I) • CZ • S0 • H0 • H1 • CZ • H0 • S0 • S0 • H0 • S1 • S1 • H1 • R (plus , Z⊗I) • S0 • H0 • CZ • H0 • S0 • S0 • S1 • S1 • S1 • H1 • Swap • R (plus , Z⊗I) • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • H1 • S1⁻¹ • S1⁻¹ • H1 • X0 • CZ • CZ • X0 • H1 • S1 • S1 • H1 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • H1 • S1⁻¹ • R (plus , Z⊗Z) • R (plus , I⊗X) • R (plus , Z⊗X) • R (plus , Z⊗Y) • R (plus , I⊗X) • R (plus , Z⊗X) • S1 • H1 • CZ • S0 • S0 • S0 • S1 • S1 • W ^ 6 • ε
          by in-context 34 12 auto (lemma-R (C.CZ • C.H0 • C.H1 • C.CZ • C.S0 • C.S0 • C.H0 • C.S1 • C.S1 • C.S1 • C.W⁻¹) (plus , Z⊗I))
      equals S1 • H1 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • H1 • S1⁻¹ • S1⁻¹ • H1 • X0 • CZ • R (minus , I⊗Z) • R (minus , I⊗Z) • R (plus , Z⊗Z) • R (minus , I⊗Y) • R (plus , Z⊗X) • R (minus , I⊗X) • R (plus , Z⊗Z) • R (minus , I⊗X) • CZ • H0 • H1 • CZ • S0 • S0 • H0 • S1 • S1 • S1 • W⁻¹ • S0 • H0 • CZ • H0 • S0 • S0 • S1 • S1 • Swap • R (plus , Z⊗I) • H0 • H1 • CZ • S0 • H0 • S0 • S0 • H0 • S1 • S1 • H1 • W⁻¹ • Swap • R (plus , Z⊗I) • S0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • H1 • H0 • CZ • H0 • R (plus , Z⊗I) • S0 • H0 • CZ • H0 • S0 • S0 • S1 • S1 • Swap • R (plus , Z⊗I) • CZ • S0 • H0 • H1 • CZ • H0 • S0 • S0 • H0 • S1 • S1 • H1 • R (plus , Z⊗I) • S0 • H0 • CZ • H0 • S0 • S0 • S1 • S1 • S1 • H1 • Swap • R (plus , Z⊗I) • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • H1 • S1⁻¹ • S1⁻¹ • H1 • X0 • CZ • CZ • X0 • H1 • S1 • S1 • H1 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • H1 • S1⁻¹ • R (plus , Z⊗Z) • R (plus , I⊗X) • R (plus , Z⊗X) • R (plus , Z⊗Y) • R (plus , I⊗X) • R (plus , Z⊗X) • S1 • H1 • CZ • S0 • S0 • S0 • S1 • S1 • W ^ 6 • ε
          by clifford-tactic 35 19 10000 auto
      equals S1 • H1 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • H1 • S1⁻¹ • S1⁻¹ • H1 • X0 • CZ • R (minus , I⊗Z) • R (minus , I⊗Z) • R (plus , Z⊗Z) • R (minus , I⊗Y) • R (plus , Z⊗X) • R (minus , I⊗X) • R (plus , Z⊗Z) • R (minus , I⊗X) • S1 • H1 • CZ • S0 • S0 • H0 • S0 • S0 • H0 • S1 • H1 • S1 • W ^ 4 • Swap • R (plus , Z⊗I) • H0 • H1 • CZ • S0 • H0 • S0 • S0 • H0 • S1 • S1 • H1 • W⁻¹ • Swap • R (plus , Z⊗I) • S0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • H1 • H0 • CZ • H0 • R (plus , Z⊗I) • S0 • H0 • CZ • H0 • S0 • S0 • S1 • S1 • Swap • R (plus , Z⊗I) • CZ • S0 • H0 • H1 • CZ • H0 • S0 • S0 • H0 • S1 • S1 • H1 • R (plus , Z⊗I) • S0 • H0 • CZ • H0 • S0 • S0 • S1 • S1 • S1 • H1 • Swap • R (plus , Z⊗I) • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • H1 • S1⁻¹ • S1⁻¹ • H1 • X0 • CZ • CZ • X0 • H1 • S1 • S1 • H1 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • H1 • S1⁻¹ • R (plus , Z⊗Z) • R (plus , I⊗X) • R (plus , Z⊗X) • R (plus , Z⊗Y) • R (plus , I⊗X) • R (plus , Z⊗X) • S1 • H1 • CZ • S0 • S0 • S0 • S1 • S1 • W ^ 6 • ε
          by in-context 35 15 auto (lemma-R (C.S1 • C.H1 • C.CZ • C.S0 • C.S0 • C.H0 • C.S0 • C.S0 • C.H0 • C.S1 • C.H1 • C.S1 • C.W ^ 4 • C.Swap) (plus , Z⊗I))
      equals S1 • H1 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • H1 • S1⁻¹ • S1⁻¹ • H1 • X0 • CZ • R (minus , I⊗Z) • R (minus , I⊗Z) • R (plus , Z⊗Z) • R (minus , I⊗Y) • R (plus , Z⊗X) • R (minus , I⊗X) • R (plus , Z⊗Z) • R (minus , I⊗X) • R (plus , Z⊗X) • S1 • H1 • CZ • S0 • S0 • H0 • S0 • S0 • H0 • S1 • H1 • S1 • W ^ 4 • Swap • H0 • H1 • CZ • S0 • H0 • S0 • S0 • H0 • S1 • S1 • H1 • W⁻¹ • Swap • R (plus , Z⊗I) • S0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • H1 • H0 • CZ • H0 • R (plus , Z⊗I) • S0 • H0 • CZ • H0 • S0 • S0 • S1 • S1 • Swap • R (plus , Z⊗I) • CZ • S0 • H0 • H1 • CZ • H0 • S0 • S0 • H0 • S1 • S1 • H1 • R (plus , Z⊗I) • S0 • H0 • CZ • H0 • S0 • S0 • S1 • S1 • S1 • H1 • Swap • R (plus , Z⊗I) • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • H1 • S1⁻¹ • S1⁻¹ • H1 • X0 • CZ • CZ • X0 • H1 • S1 • S1 • H1 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • H1 • S1⁻¹ • R (plus , Z⊗Z) • R (plus , I⊗X) • R (plus , Z⊗X) • R (plus , Z⊗Y) • R (plus , I⊗X) • R (plus , Z⊗X) • S1 • H1 • CZ • S0 • S0 • S0 • S1 • S1 • W ^ 6 • ε
          by clifford-tactic 36 26 10000 auto
      equals S1 • H1 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • H1 • S1⁻¹ • S1⁻¹ • H1 • X0 • CZ • R (minus , I⊗Z) • R (minus , I⊗Z) • R (plus , Z⊗Z) • R (minus , I⊗Y) • R (plus , Z⊗X) • R (minus , I⊗X) • R (plus , Z⊗Z) • R (minus , I⊗X) • R (plus , Z⊗X) • H0 • CZ • S0 • S0 • H0 • S0 • S0 • S1 • S1 • S1 • Swap • R (plus , Z⊗I) • S0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • H1 • H0 • CZ • H0 • R (plus , Z⊗I) • S0 • H0 • CZ • H0 • S0 • S0 • S1 • S1 • Swap • R (plus , Z⊗I) • CZ • S0 • H0 • H1 • CZ • H0 • S0 • S0 • H0 • S1 • S1 • H1 • R (plus , Z⊗I) • S0 • H0 • CZ • H0 • S0 • S0 • S1 • S1 • S1 • H1 • Swap • R (plus , Z⊗I) • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • H1 • S1⁻¹ • S1⁻¹ • H1 • X0 • CZ • CZ • X0 • H1 • S1 • S1 • H1 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • H1 • S1⁻¹ • R (plus , Z⊗Z) • R (plus , I⊗X) • R (plus , Z⊗X) • R (plus , Z⊗Y) • R (plus , I⊗X) • R (plus , Z⊗X) • S1 • H1 • CZ • S0 • S0 • S0 • S1 • S1 • W ^ 6 • ε
          by in-context 36 12 auto (lemma-R (C.H0 • C.CZ • C.S0 • C.S0 • C.H0 • C.S0 • C.S0 • C.S1 • C.S1 • C.S1 • C.Swap) (plus , Z⊗I))
      equals S1 • H1 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • H1 • S1⁻¹ • S1⁻¹ • H1 • X0 • CZ • R (minus , I⊗Z) • R (minus , I⊗Z) • R (plus , Z⊗Z) • R (minus , I⊗Y) • R (plus , Z⊗X) • R (minus , I⊗X) • R (plus , Z⊗Z) • R (minus , I⊗X) • R (plus , Z⊗X) • R (plus , I⊗Z) • H0 • CZ • S0 • S0 • H0 • S0 • S0 • S1 • S1 • S1 • Swap • S0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • H1 • H0 • CZ • H0 • R (plus , Z⊗I) • S0 • H0 • CZ • H0 • S0 • S0 • S1 • S1 • Swap • R (plus , Z⊗I) • CZ • S0 • H0 • H1 • CZ • H0 • S0 • S0 • H0 • S1 • S1 • H1 • R (plus , Z⊗I) • S0 • H0 • CZ • H0 • S0 • S0 • S1 • S1 • S1 • H1 • Swap • R (plus , Z⊗I) • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • H1 • S1⁻¹ • S1⁻¹ • H1 • X0 • CZ • CZ • X0 • H1 • S1 • S1 • H1 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • H1 • S1⁻¹ • R (plus , Z⊗Z) • R (plus , I⊗X) • R (plus , Z⊗X) • R (plus , Z⊗Y) • R (plus , I⊗X) • R (plus , Z⊗X) • S1 • H1 • CZ • S0 • S0 • S0 • S1 • S1 • W ^ 6 • ε
          by clifford-tactic 38 20 10000 auto
      equals S1 • H1 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • H1 • S1⁻¹ • S1⁻¹ • H1 • X0 • CZ • R (minus , I⊗Z) • R (minus , I⊗Z) • R (plus , Z⊗Z) • R (minus , I⊗Y) • R (plus , Z⊗X) • R (minus , I⊗X) • R (plus , Z⊗Z) • R (minus , I⊗X) • R (plus , Z⊗X) • R (plus , I⊗Z) • H0 • S1 • H1 • CZ • S0 • S0 • H0 • S0 • S0 • S1 • S1 • S1 • W⁻¹ • Swap • R (plus , Z⊗I) • S0 • H0 • CZ • H0 • S0 • S0 • S1 • S1 • Swap • R (plus , Z⊗I) • CZ • S0 • H0 • H1 • CZ • H0 • S0 • S0 • H0 • S1 • S1 • H1 • R (plus , Z⊗I) • S0 • H0 • CZ • H0 • S0 • S0 • S1 • S1 • S1 • H1 • Swap • R (plus , Z⊗I) • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • H1 • S1⁻¹ • S1⁻¹ • H1 • X0 • CZ • CZ • X0 • H1 • S1 • S1 • H1 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • H1 • S1⁻¹ • R (plus , Z⊗Z) • R (plus , I⊗X) • R (plus , Z⊗X) • R (plus , Z⊗Y) • R (plus , I⊗X) • R (plus , Z⊗X) • S1 • H1 • CZ • S0 • S0 • S0 • S1 • S1 • W ^ 6 • ε
          by in-context 37 15 auto (lemma-R (C.H0 • C.S1 • C.H1 • C.CZ • C.S0 • C.S0 • C.H0 • C.S0 • C.S0 • C.S1 • C.S1 • C.S1 • C.W⁻¹ • C.Swap) (plus , Z⊗I))
      equals S1 • H1 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • H1 • S1⁻¹ • S1⁻¹ • H1 • X0 • CZ • R (minus , I⊗Z) • R (minus , I⊗Z) • R (plus , Z⊗Z) • R (minus , I⊗Y) • R (plus , Z⊗X) • R (minus , I⊗X) • R (plus , Z⊗Z) • R (minus , I⊗X) • R (plus , Z⊗X) • R (plus , I⊗Z) • R (plus , I⊗Y) • H0 • S1 • H1 • CZ • S0 • S0 • H0 • S0 • S0 • S1 • S1 • S1 • W⁻¹ • Swap • S0 • H0 • CZ • H0 • S0 • S0 • S1 • S1 • Swap • R (plus , Z⊗I) • CZ • S0 • H0 • H1 • CZ • H0 • S0 • S0 • H0 • S1 • S1 • H1 • R (plus , Z⊗I) • S0 • H0 • CZ • H0 • S0 • S0 • S1 • S1 • S1 • H1 • Swap • R (plus , Z⊗I) • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • H1 • S1⁻¹ • S1⁻¹ • H1 • X0 • CZ • CZ • X0 • H1 • S1 • S1 • H1 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • H1 • S1⁻¹ • R (plus , Z⊗Z) • R (plus , I⊗X) • R (plus , Z⊗X) • R (plus , Z⊗Y) • R (plus , I⊗X) • R (plus , Z⊗X) • S1 • H1 • CZ • S0 • S0 • S0 • S1 • S1 • W ^ 6 • ε
          by clifford-tactic 38 22 10000 auto
      equals S1 • H1 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • H1 • S1⁻¹ • S1⁻¹ • H1 • X0 • CZ • R (minus , I⊗Z) • R (minus , I⊗Z) • R (plus , Z⊗Z) • R (minus , I⊗Y) • R (plus , Z⊗X) • R (minus , I⊗X) • R (plus , Z⊗Z) • R (minus , I⊗X) • R (plus , Z⊗X) • R (plus , I⊗Z) • R (plus , I⊗Y) • CZ • S0 • S0 • H0 • S0 • S0 • H0 • S1 • S1 • S1 • H1 • W ^ 3 • Swap • R (plus , Z⊗I) • CZ • S0 • H0 • H1 • CZ • H0 • S0 • S0 • H0 • S1 • S1 • H1 • R (plus , Z⊗I) • S0 • H0 • CZ • H0 • S0 • S0 • S1 • S1 • S1 • H1 • Swap • R (plus , Z⊗I) • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • H1 • S1⁻¹ • S1⁻¹ • H1 • X0 • CZ • CZ • X0 • H1 • S1 • S1 • H1 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • H1 • S1⁻¹ • R (plus , Z⊗Z) • R (plus , I⊗X) • R (plus , Z⊗X) • R (plus , Z⊗Y) • R (plus , I⊗X) • R (plus , Z⊗X) • S1 • H1 • CZ • S0 • S0 • S0 • S1 • S1 • W ^ 6 • ε
          by in-context 38 14 auto (lemma-R (C.CZ • C.S0 • C.S0 • C.H0 • C.S0 • C.S0 • C.H0 • C.S1 • C.S1 • C.S1 • C.H1 • C.W ^ 3 • C.Swap) (plus , Z⊗I))
      equals S1 • H1 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • H1 • S1⁻¹ • S1⁻¹ • H1 • X0 • CZ • R (minus , I⊗Z) • R (minus , I⊗Z) • R (plus , Z⊗Z) • R (minus , I⊗Y) • R (plus , Z⊗X) • R (minus , I⊗X) • R (plus , Z⊗Z) • R (minus , I⊗X) • R (plus , Z⊗X) • R (plus , I⊗Z) • R (plus , I⊗Y) • R (minus , Z⊗Y) • CZ • S0 • S0 • H0 • S0 • S0 • H0 • S1 • S1 • S1 • H1 • W ^ 3 • Swap • CZ • S0 • H0 • H1 • CZ • H0 • S0 • S0 • H0 • S1 • S1 • H1 • R (plus , Z⊗I) • S0 • H0 • CZ • H0 • S0 • S0 • S1 • S1 • S1 • H1 • Swap • R (plus , Z⊗I) • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • H1 • S1⁻¹ • S1⁻¹ • H1 • X0 • CZ • CZ • X0 • H1 • S1 • S1 • H1 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • H1 • S1⁻¹ • R (plus , Z⊗Z) • R (plus , I⊗X) • R (plus , Z⊗X) • R (plus , Z⊗Y) • R (plus , I⊗X) • R (plus , Z⊗X) • S1 • H1 • CZ • S0 • S0 • S0 • S1 • S1 • W ^ 6 • ε
          by clifford-tactic 40 24 10000 auto
      equals S1 • H1 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • H1 • S1⁻¹ • S1⁻¹ • H1 • X0 • CZ • R (minus , I⊗Z) • R (minus , I⊗Z) • R (plus , Z⊗Z) • R (minus , I⊗Y) • R (plus , Z⊗X) • R (minus , I⊗X) • R (plus , Z⊗Z) • R (minus , I⊗X) • R (plus , Z⊗X) • R (plus , I⊗Z) • R (plus , I⊗Y) • R (minus , Z⊗Y) • CZ • H0 • H1 • CZ • S0 • S0 • H0 • S0 • S0 • S1 • S1 • S1 • W ^ 6 • R (plus , Z⊗I) • S0 • H0 • CZ • H0 • S0 • S0 • S1 • S1 • S1 • H1 • Swap • R (plus , Z⊗I) • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • H1 • S1⁻¹ • S1⁻¹ • H1 • X0 • CZ • CZ • X0 • H1 • S1 • S1 • H1 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • H1 • S1⁻¹ • R (plus , Z⊗Z) • R (plus , I⊗X) • R (plus , Z⊗X) • R (plus , Z⊗Y) • R (plus , I⊗X) • R (plus , Z⊗X) • S1 • H1 • CZ • S0 • S0 • S0 • S1 • S1 • W ^ 6 • ε
          by in-context 39 14 auto (lemma-R (C.CZ • C.H0 • C.H1 • C.CZ • C.S0 • C.S0 • C.H0 • C.S0 • C.S0 • C.S1 • C.S1 • C.S1 • C.W ^ 6) (plus , Z⊗I))
      equals S1 • H1 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • H1 • S1⁻¹ • S1⁻¹ • H1 • X0 • CZ • R (minus , I⊗Z) • R (minus , I⊗Z) • R (plus , Z⊗Z) • R (minus , I⊗Y) • R (plus , Z⊗X) • R (minus , I⊗X) • R (plus , Z⊗Z) • R (minus , I⊗X) • R (plus , Z⊗X) • R (plus , I⊗Z) • R (plus , I⊗Y) • R (minus , Z⊗Y) • R (minus , I⊗X) • CZ • H0 • H1 • CZ • S0 • S0 • H0 • S0 • S0 • S1 • S1 • S1 • W ^ 6 • S0 • H0 • CZ • H0 • S0 • S0 • S1 • S1 • S1 • H1 • Swap • R (plus , Z⊗I) • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • H1 • S1⁻¹ • S1⁻¹ • H1 • X0 • CZ • CZ • X0 • H1 • S1 • S1 • H1 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • H1 • S1⁻¹ • R (plus , Z⊗Z) • R (plus , I⊗X) • R (plus , Z⊗X) • R (plus , Z⊗Y) • R (plus , I⊗X) • R (plus , Z⊗X) • S1 • H1 • CZ • S0 • S0 • S0 • S1 • S1 • W ^ 6 • ε
          by clifford-tactic 40 23 10000 auto
      equals S1 • H1 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • H1 • S1⁻¹ • S1⁻¹ • H1 • X0 • CZ • R (minus , I⊗Z) • R (minus , I⊗Z) • R (plus , Z⊗Z) • R (minus , I⊗Y) • R (plus , Z⊗X) • R (minus , I⊗X) • R (plus , Z⊗Z) • R (minus , I⊗X) • R (plus , Z⊗X) • R (plus , I⊗Z) • R (plus , I⊗Y) • R (minus , Z⊗Y) • R (minus , I⊗X) • S1 • H1 • CZ • H0 • S0 • S0 • H0 • S1 • W⁻¹ • Swap • R (plus , Z⊗I) • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • H1 • S1⁻¹ • S1⁻¹ • H1 • X0 • CZ • CZ • X0 • H1 • S1 • S1 • H1 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • H1 • S1⁻¹ • R (plus , Z⊗Z) • R (plus , I⊗X) • R (plus , Z⊗X) • R (plus , Z⊗Y) • R (plus , I⊗X) • R (plus , Z⊗X) • S1 • H1 • CZ • S0 • S0 • S0 • S1 • S1 • W ^ 6 • ε
          by in-context 40 11 auto (lemma-R (C.S1 • C.H1 • C.CZ • C.H0 • C.S0 • C.S0 • C.H0 • C.S1 • C.W⁻¹ • C.Swap) (plus , Z⊗I))
      equals S1 • H1 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • H1 • S1⁻¹ • S1⁻¹ • H1 • X0 • CZ • R (minus , I⊗Z) • R (minus , I⊗Z) • R (plus , Z⊗Z) • R (minus , I⊗Y) • R (plus , Z⊗X) • R (minus , I⊗X) • R (plus , Z⊗Z) • R (minus , I⊗X) • R (plus , Z⊗X) • R (plus , I⊗Z) • R (plus , I⊗Y) • R (minus , Z⊗Y) • R (minus , I⊗X) • R (plus , I⊗Y) • S1 • H1 • CZ • H0 • S0 • S0 • H0 • S1 • W⁻¹ • Swap • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • H1 • S1⁻¹ • S1⁻¹ • H1 • X0 • CZ • CZ • X0 • H1 • S1 • S1 • H1 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • H1 • S1⁻¹ • R (plus , Z⊗Z) • R (plus , I⊗X) • R (plus , Z⊗X) • R (plus , Z⊗Y) • R (plus , I⊗X) • R (plus , Z⊗X) • S1 • H1 • CZ • S0 • S0 • S0 • S1 • S1 • W ^ 6 • ε
          by clifford-tactic 41 25 10000 auto
      equals S1 • H1 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • H1 • S1⁻¹ • S1⁻¹ • H1 • X0 • CZ • R (minus , I⊗Z) • R (minus , I⊗Z) • R (plus , Z⊗Z) • R (minus , I⊗Y) • R (plus , Z⊗X) • R (minus , I⊗X) • R (plus , Z⊗Z) • R (minus , I⊗X) • R (plus , Z⊗X) • R (plus , I⊗Z) • R (plus , I⊗Y) • R (minus , Z⊗Y) • R (minus , I⊗X) • R (plus , I⊗Y) • S0 • S0 • H1 • S1 • H1 • CZ • X0 • H1 • S1 • S1 • H1 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • H1 • S1⁻¹ • R (plus , Z⊗Z) • R (plus , I⊗X) • R (plus , Z⊗X) • R (plus , Z⊗Y) • R (plus , I⊗X) • R (plus , Z⊗X) • S1 • H1 • CZ • S0 • S0 • S0 • S1 • S1 • W ^ 6 • ε
          by in-context 31 2 auto (symm (tactic-pauli-commute (minus , I⊗X) (plus , Z⊗X) auto))
      equals S1 • H1 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • H1 • S1⁻¹ • S1⁻¹ • H1 • X0 • CZ • R (minus , I⊗Z) • R (minus , I⊗Z) • R (plus , Z⊗Z) • R (minus , I⊗Y) • R (minus , I⊗X) • R (plus , Z⊗X) • R (plus , Z⊗Z) • R (minus , I⊗X) • R (plus , Z⊗X) • R (plus , I⊗Z) • R (plus , I⊗Y) • R (minus , Z⊗Y) • R (minus , I⊗X) • R (plus , I⊗Y) • S0 • S0 • H1 • S1 • H1 • CZ • X0 • H1 • S1 • S1 • H1 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • H1 • S1⁻¹ • R (plus , Z⊗Z) • R (plus , I⊗X) • R (plus , Z⊗X) • R (plus , Z⊗Y) • R (plus , I⊗X) • R (plus , Z⊗X) • S1 • H1 • CZ • S0 • S0 • S0 • S1 • S1 • W ^ 6 • ε
          by in-context 27 2 auto (lemma-combine minus minus I⊗Z)
      equals S1 • H1 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • H1 • S1⁻¹ • S1⁻¹ • H1 • X0 • CZ • Swap • S0⁻¹ • W ^ 2 • Swap • R (plus , Z⊗Z) • R (minus , I⊗Y) • R (minus , I⊗X) • R (plus , Z⊗X) • R (plus , Z⊗Z) • R (minus , I⊗X) • R (plus , Z⊗X) • R (plus , I⊗Z) • R (plus , I⊗Y) • R (minus , Z⊗Y) • R (minus , I⊗X) • R (plus , I⊗Y) • S0 • S0 • H1 • S1 • H1 • CZ • X0 • H1 • S1 • S1 • H1 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • H1 • S1⁻¹ • R (plus , Z⊗Z) • R (plus , I⊗X) • R (plus , Z⊗X) • R (plus , Z⊗Y) • R (plus , I⊗X) • R (plus , Z⊗X) • S1 • H1 • CZ • S0 • S0 • S0 • S1 • S1 • W ^ 6 • ε
          by in-context 27 5 auto (lemma-R (C.Swap • C.S0⁻¹ • C.W ^ 2 • C.Swap) (plus , Z⊗Z))
      equals S1 • H1 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • H1 • S1⁻¹ • S1⁻¹ • H1 • X0 • CZ • R (plus , Z⊗Z) • Swap • S0⁻¹ • W ^ 2 • Swap • R (minus , I⊗Y) • R (minus , I⊗X) • R (plus , Z⊗X) • R (plus , Z⊗Z) • R (minus , I⊗X) • R (plus , Z⊗X) • R (plus , I⊗Z) • R (plus , I⊗Y) • R (minus , Z⊗Y) • R (minus , I⊗X) • R (plus , I⊗Y) • S0 • S0 • H1 • S1 • H1 • CZ • X0 • H1 • S1 • S1 • H1 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • H1 • S1⁻¹ • R (plus , Z⊗Z) • R (plus , I⊗X) • R (plus , Z⊗X) • R (plus , Z⊗Y) • R (plus , I⊗X) • R (plus , Z⊗X) • S1 • H1 • CZ • S0 • S0 • S0 • S1 • S1 • W ^ 6 • ε
          by in-context 28 5 auto (lemma-R (C.Swap • C.S0⁻¹ • C.W ^ 2 • C.Swap) (minus , I⊗Y))
      equals S1 • H1 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • H1 • S1⁻¹ • S1⁻¹ • H1 • X0 • CZ • R (plus , Z⊗Z) • R (minus , I⊗X) • Swap • S0⁻¹ • W ^ 2 • Swap • R (minus , I⊗X) • R (plus , Z⊗X) • R (plus , Z⊗Z) • R (minus , I⊗X) • R (plus , Z⊗X) • R (plus , I⊗Z) • R (plus , I⊗Y) • R (minus , Z⊗Y) • R (minus , I⊗X) • R (plus , I⊗Y) • S0 • S0 • H1 • S1 • H1 • CZ • X0 • H1 • S1 • S1 • H1 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • H1 • S1⁻¹ • R (plus , Z⊗Z) • R (plus , I⊗X) • R (plus , Z⊗X) • R (plus , Z⊗Y) • R (plus , I⊗X) • R (plus , Z⊗X) • S1 • H1 • CZ • S0 • S0 • S0 • S1 • S1 • W ^ 6 • ε
          by in-context 29 5 auto (lemma-R (C.Swap • C.S0⁻¹ • C.W ^ 2 • C.Swap) (minus , I⊗X))
      equals S1 • H1 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • H1 • S1⁻¹ • S1⁻¹ • H1 • X0 • CZ • R (plus , Z⊗Z) • R (minus , I⊗X) • R (plus , I⊗Y) • Swap • S0⁻¹ • W ^ 2 • Swap • R (plus , Z⊗X) • R (plus , Z⊗Z) • R (minus , I⊗X) • R (plus , Z⊗X) • R (plus , I⊗Z) • R (plus , I⊗Y) • R (minus , Z⊗Y) • R (minus , I⊗X) • R (plus , I⊗Y) • S0 • S0 • H1 • S1 • H1 • CZ • X0 • H1 • S1 • S1 • H1 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • H1 • S1⁻¹ • R (plus , Z⊗Z) • R (plus , I⊗X) • R (plus , Z⊗X) • R (plus , Z⊗Y) • R (plus , I⊗X) • R (plus , Z⊗X) • S1 • H1 • CZ • S0 • S0 • S0 • S1 • S1 • W ^ 6 • ε
          by in-context 30 5 auto (lemma-R (C.Swap • C.S0⁻¹ • C.W ^ 2 • C.Swap) (plus , Z⊗X))
      equals S1 • H1 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • H1 • S1⁻¹ • S1⁻¹ • H1 • X0 • CZ • R (plus , Z⊗Z) • R (minus , I⊗X) • R (plus , I⊗Y) • R (minus , Z⊗Y) • Swap • S0⁻¹ • W ^ 2 • Swap • R (plus , Z⊗Z) • R (minus , I⊗X) • R (plus , Z⊗X) • R (plus , I⊗Z) • R (plus , I⊗Y) • R (minus , Z⊗Y) • R (minus , I⊗X) • R (plus , I⊗Y) • S0 • S0 • H1 • S1 • H1 • CZ • X0 • H1 • S1 • S1 • H1 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • H1 • S1⁻¹ • R (plus , Z⊗Z) • R (plus , I⊗X) • R (plus , Z⊗X) • R (plus , Z⊗Y) • R (plus , I⊗X) • R (plus , Z⊗X) • S1 • H1 • CZ • S0 • S0 • S0 • S1 • S1 • W ^ 6 • ε
          by in-context 31 5 auto (lemma-R (C.Swap • C.S0⁻¹ • C.W ^ 2 • C.Swap) (plus , Z⊗Z))
      equals S1 • H1 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • H1 • S1⁻¹ • S1⁻¹ • H1 • X0 • CZ • R (plus , Z⊗Z) • R (minus , I⊗X) • R (plus , I⊗Y) • R (minus , Z⊗Y) • R (plus , Z⊗Z) • Swap • S0⁻¹ • W ^ 2 • Swap • R (minus , I⊗X) • R (plus , Z⊗X) • R (plus , I⊗Z) • R (plus , I⊗Y) • R (minus , Z⊗Y) • R (minus , I⊗X) • R (plus , I⊗Y) • S0 • S0 • H1 • S1 • H1 • CZ • X0 • H1 • S1 • S1 • H1 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • H1 • S1⁻¹ • R (plus , Z⊗Z) • R (plus , I⊗X) • R (plus , Z⊗X) • R (plus , Z⊗Y) • R (plus , I⊗X) • R (plus , Z⊗X) • S1 • H1 • CZ • S0 • S0 • S0 • S1 • S1 • W ^ 6 • ε
          by in-context 32 5 auto (lemma-R (C.Swap • C.S0⁻¹ • C.W ^ 2 • C.Swap) (minus , I⊗X))
      equals S1 • H1 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • H1 • S1⁻¹ • S1⁻¹ • H1 • X0 • CZ • R (plus , Z⊗Z) • R (minus , I⊗X) • R (plus , I⊗Y) • R (minus , Z⊗Y) • R (plus , Z⊗Z) • R (plus , I⊗Y) • Swap • S0⁻¹ • W ^ 2 • Swap • R (plus , Z⊗X) • R (plus , I⊗Z) • R (plus , I⊗Y) • R (minus , Z⊗Y) • R (minus , I⊗X) • R (plus , I⊗Y) • S0 • S0 • H1 • S1 • H1 • CZ • X0 • H1 • S1 • S1 • H1 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • H1 • S1⁻¹ • R (plus , Z⊗Z) • R (plus , I⊗X) • R (plus , Z⊗X) • R (plus , Z⊗Y) • R (plus , I⊗X) • R (plus , Z⊗X) • S1 • H1 • CZ • S0 • S0 • S0 • S1 • S1 • W ^ 6 • ε
          by in-context 33 5 auto (lemma-R (C.Swap • C.S0⁻¹ • C.W ^ 2 • C.Swap) (plus , Z⊗X))
      equals S1 • H1 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • H1 • S1⁻¹ • S1⁻¹ • H1 • X0 • CZ • R (plus , Z⊗Z) • R (minus , I⊗X) • R (plus , I⊗Y) • R (minus , Z⊗Y) • R (plus , Z⊗Z) • R (plus , I⊗Y) • R (minus , Z⊗Y) • Swap • S0⁻¹ • W ^ 2 • Swap • R (plus , I⊗Z) • R (plus , I⊗Y) • R (minus , Z⊗Y) • R (minus , I⊗X) • R (plus , I⊗Y) • S0 • S0 • H1 • S1 • H1 • CZ • X0 • H1 • S1 • S1 • H1 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • H1 • S1⁻¹ • R (plus , Z⊗Z) • R (plus , I⊗X) • R (plus , Z⊗X) • R (plus , Z⊗Y) • R (plus , I⊗X) • R (plus , Z⊗X) • S1 • H1 • CZ • S0 • S0 • S0 • S1 • S1 • W ^ 6 • ε
          by in-context 34 5 auto (lemma-R (C.Swap • C.S0⁻¹ • C.W ^ 2 • C.Swap) (plus , I⊗Z))
      equals S1 • H1 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • H1 • S1⁻¹ • S1⁻¹ • H1 • X0 • CZ • R (plus , Z⊗Z) • R (minus , I⊗X) • R (plus , I⊗Y) • R (minus , Z⊗Y) • R (plus , Z⊗Z) • R (plus , I⊗Y) • R (minus , Z⊗Y) • R (plus , I⊗Z) • Swap • S0⁻¹ • W ^ 2 • Swap • R (plus , I⊗Y) • R (minus , Z⊗Y) • R (minus , I⊗X) • R (plus , I⊗Y) • S0 • S0 • H1 • S1 • H1 • CZ • X0 • H1 • S1 • S1 • H1 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • H1 • S1⁻¹ • R (plus , Z⊗Z) • R (plus , I⊗X) • R (plus , Z⊗X) • R (plus , Z⊗Y) • R (plus , I⊗X) • R (plus , Z⊗X) • S1 • H1 • CZ • S0 • S0 • S0 • S1 • S1 • W ^ 6 • ε
          by in-context 35 5 auto (lemma-R (C.Swap • C.S0⁻¹ • C.W ^ 2 • C.Swap) (plus , I⊗Y))
      equals S1 • H1 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • H1 • S1⁻¹ • S1⁻¹ • H1 • X0 • CZ • R (plus , Z⊗Z) • R (minus , I⊗X) • R (plus , I⊗Y) • R (minus , Z⊗Y) • R (plus , Z⊗Z) • R (plus , I⊗Y) • R (minus , Z⊗Y) • R (plus , I⊗Z) • R (plus , I⊗X) • Swap • S0⁻¹ • W ^ 2 • Swap • R (minus , Z⊗Y) • R (minus , I⊗X) • R (plus , I⊗Y) • S0 • S0 • H1 • S1 • H1 • CZ • X0 • H1 • S1 • S1 • H1 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • H1 • S1⁻¹ • R (plus , Z⊗Z) • R (plus , I⊗X) • R (plus , Z⊗X) • R (plus , Z⊗Y) • R (plus , I⊗X) • R (plus , Z⊗X) • S1 • H1 • CZ • S0 • S0 • S0 • S1 • S1 • W ^ 6 • ε
          by in-context 36 5 auto (lemma-R (C.Swap • C.S0⁻¹ • C.W ^ 2 • C.Swap) (minus , Z⊗Y))
      equals S1 • H1 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • H1 • S1⁻¹ • S1⁻¹ • H1 • X0 • CZ • R (plus , Z⊗Z) • R (minus , I⊗X) • R (plus , I⊗Y) • R (minus , Z⊗Y) • R (plus , Z⊗Z) • R (plus , I⊗Y) • R (minus , Z⊗Y) • R (plus , I⊗Z) • R (plus , I⊗X) • R (minus , Z⊗X) • Swap • S0⁻¹ • W ^ 2 • Swap • R (minus , I⊗X) • R (plus , I⊗Y) • S0 • S0 • H1 • S1 • H1 • CZ • X0 • H1 • S1 • S1 • H1 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • H1 • S1⁻¹ • R (plus , Z⊗Z) • R (plus , I⊗X) • R (plus , Z⊗X) • R (plus , Z⊗Y) • R (plus , I⊗X) • R (plus , Z⊗X) • S1 • H1 • CZ • S0 • S0 • S0 • S1 • S1 • W ^ 6 • ε
          by in-context 37 5 auto (lemma-R (C.Swap • C.S0⁻¹ • C.W ^ 2 • C.Swap) (minus , I⊗X))
      equals S1 • H1 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • H1 • S1⁻¹ • S1⁻¹ • H1 • X0 • CZ • R (plus , Z⊗Z) • R (minus , I⊗X) • R (plus , I⊗Y) • R (minus , Z⊗Y) • R (plus , Z⊗Z) • R (plus , I⊗Y) • R (minus , Z⊗Y) • R (plus , I⊗Z) • R (plus , I⊗X) • R (minus , Z⊗X) • R (plus , I⊗Y) • Swap • S0⁻¹ • W ^ 2 • Swap • R (plus , I⊗Y) • S0 • S0 • H1 • S1 • H1 • CZ • X0 • H1 • S1 • S1 • H1 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • H1 • S1⁻¹ • R (plus , Z⊗Z) • R (plus , I⊗X) • R (plus , Z⊗X) • R (plus , Z⊗Y) • R (plus , I⊗X) • R (plus , Z⊗X) • S1 • H1 • CZ • S0 • S0 • S0 • S1 • S1 • W ^ 6 • ε
          by in-context 38 5 auto (lemma-R (C.Swap • C.S0⁻¹ • C.W ^ 2 • C.Swap) (plus , I⊗Y))
      equals S1 • H1 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • H1 • S1⁻¹ • S1⁻¹ • H1 • X0 • CZ • R (plus , Z⊗Z) • R (minus , I⊗X) • R (plus , I⊗Y) • R (minus , Z⊗Y) • R (plus , Z⊗Z) • R (plus , I⊗Y) • R (minus , Z⊗Y) • R (plus , I⊗Z) • R (plus , I⊗X) • R (minus , Z⊗X) • R (plus , I⊗Y) • R (plus , I⊗X) • Swap • S0⁻¹ • W ^ 2 • Swap • S0 • S0 • H1 • S1 • H1 • CZ • X0 • H1 • S1 • S1 • H1 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • H1 • S1⁻¹ • R (plus , Z⊗Z) • R (plus , I⊗X) • R (plus , Z⊗X) • R (plus , Z⊗Y) • R (plus , I⊗X) • R (plus , Z⊗X) • S1 • H1 • CZ • S0 • S0 • S0 • S1 • S1 • W ^ 6 • ε
          by in-context 28 1 auto (lemma-correction I⊗X)
      equals S1 • H1 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • H1 • S1⁻¹ • S1⁻¹ • H1 • X0 • CZ • R (plus , Z⊗Z) • R (plus , I⊗X) • H1 • Swap • S0⁻¹ • W • Swap • H1 • R (plus , I⊗Y) • R (minus , Z⊗Y) • R (plus , Z⊗Z) • R (plus , I⊗Y) • R (minus , Z⊗Y) • R (plus , I⊗Z) • R (plus , I⊗X) • R (minus , Z⊗X) • R (plus , I⊗Y) • R (plus , I⊗X) • Swap • S0⁻¹ • W ^ 2 • Swap • S0 • S0 • H1 • S1 • H1 • CZ • X0 • H1 • S1 • S1 • H1 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • H1 • S1⁻¹ • R (plus , Z⊗Z) • R (plus , I⊗X) • R (plus , Z⊗X) • R (plus , Z⊗Y) • R (plus , I⊗X) • R (plus , Z⊗X) • S1 • H1 • CZ • S0 • S0 • S0 • S1 • S1 • W ^ 6 • ε
          by clifford-tactic 29 6 10000 auto
      equals S1 • H1 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • H1 • S1⁻¹ • S1⁻¹ • H1 • X0 • CZ • R (plus , Z⊗Z) • R (plus , I⊗X) • S1 • H1 • S1 • R (plus , I⊗Y) • R (minus , Z⊗Y) • R (plus , Z⊗Z) • R (plus , I⊗Y) • R (minus , Z⊗Y) • R (plus , I⊗Z) • R (plus , I⊗X) • R (minus , Z⊗X) • R (plus , I⊗Y) • R (plus , I⊗X) • Swap • S0⁻¹ • W ^ 2 • Swap • S0 • S0 • H1 • S1 • H1 • CZ • X0 • H1 • S1 • S1 • H1 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • H1 • S1⁻¹ • R (plus , Z⊗Z) • R (plus , I⊗X) • R (plus , Z⊗X) • R (plus , Z⊗Y) • R (plus , I⊗X) • R (plus , Z⊗X) • S1 • H1 • CZ • S0 • S0 • S0 • S1 • S1 • W ^ 6 • ε
          by in-context 29 4 auto (lemma-R (C.S1 • C.H1 • C.S1) (plus , I⊗Y))
      equals S1 • H1 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • H1 • S1⁻¹ • S1⁻¹ • H1 • X0 • CZ • R (plus , Z⊗Z) • R (plus , I⊗X) • R (minus , I⊗Z) • S1 • H1 • S1 • R (minus , Z⊗Y) • R (plus , Z⊗Z) • R (plus , I⊗Y) • R (minus , Z⊗Y) • R (plus , I⊗Z) • R (plus , I⊗X) • R (minus , Z⊗X) • R (plus , I⊗Y) • R (plus , I⊗X) • Swap • S0⁻¹ • W ^ 2 • Swap • S0 • S0 • H1 • S1 • H1 • CZ • X0 • H1 • S1 • S1 • H1 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • H1 • S1⁻¹ • R (plus , Z⊗Z) • R (plus , I⊗X) • R (plus , Z⊗X) • R (plus , Z⊗Y) • R (plus , I⊗X) • R (plus , Z⊗X) • S1 • H1 • CZ • S0 • S0 • S0 • S1 • S1 • W ^ 6 • ε
          by in-context 29 1 auto (lemma-correction I⊗Z)
      equals S1 • H1 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • H1 • S1⁻¹ • S1⁻¹ • H1 • X0 • CZ • R (plus , Z⊗Z) • R (plus , I⊗X) • R (plus , I⊗Z) • Swap • S0⁻¹ • W • Swap • S1 • H1 • S1 • R (minus , Z⊗Y) • R (plus , Z⊗Z) • R (plus , I⊗Y) • R (minus , Z⊗Y) • R (plus , I⊗Z) • R (plus , I⊗X) • R (minus , Z⊗X) • R (plus , I⊗Y) • R (plus , I⊗X) • Swap • S0⁻¹ • W ^ 2 • Swap • S0 • S0 • H1 • S1 • H1 • CZ • X0 • H1 • S1 • S1 • H1 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • H1 • S1⁻¹ • R (plus , Z⊗Z) • R (plus , I⊗X) • R (plus , Z⊗X) • R (plus , Z⊗Y) • R (plus , I⊗X) • R (plus , Z⊗X) • S1 • H1 • CZ • S0 • S0 • S0 • S1 • S1 • W ^ 6 • ε
          by clifford-tactic 30 7 10000 auto
      equals S1 • H1 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • H1 • S1⁻¹ • S1⁻¹ • H1 • X0 • CZ • R (plus , Z⊗Z) • R (plus , I⊗X) • R (plus , I⊗Z) • H1 • S1 • W • R (minus , Z⊗Y) • R (plus , Z⊗Z) • R (plus , I⊗Y) • R (minus , Z⊗Y) • R (plus , I⊗Z) • R (plus , I⊗X) • R (minus , Z⊗X) • R (plus , I⊗Y) • R (plus , I⊗X) • Swap • S0⁻¹ • W ^ 2 • Swap • S0 • S0 • H1 • S1 • H1 • CZ • X0 • H1 • S1 • S1 • H1 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • H1 • S1⁻¹ • R (plus , Z⊗Z) • R (plus , I⊗X) • R (plus , Z⊗X) • R (plus , Z⊗Y) • R (plus , I⊗X) • R (plus , Z⊗X) • S1 • H1 • CZ • S0 • S0 • S0 • S1 • S1 • W ^ 6 • ε
          by in-context 30 4 auto (lemma-R (C.H1 • C.S1 • C.W) (minus , Z⊗Y))
      equals S1 • H1 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • H1 • S1⁻¹ • S1⁻¹ • H1 • X0 • CZ • R (plus , Z⊗Z) • R (plus , I⊗X) • R (plus , I⊗Z) • R (plus , Z⊗Z) • H1 • S1 • W • R (plus , Z⊗Z) • R (plus , I⊗Y) • R (minus , Z⊗Y) • R (plus , I⊗Z) • R (plus , I⊗X) • R (minus , Z⊗X) • R (plus , I⊗Y) • R (plus , I⊗X) • Swap • S0⁻¹ • W ^ 2 • Swap • S0 • S0 • H1 • S1 • H1 • CZ • X0 • H1 • S1 • S1 • H1 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • H1 • S1⁻¹ • R (plus , Z⊗Z) • R (plus , I⊗X) • R (plus , Z⊗X) • R (plus , Z⊗Y) • R (plus , I⊗X) • R (plus , Z⊗X) • S1 • H1 • CZ • S0 • S0 • S0 • S1 • S1 • W ^ 6 • ε
          by in-context 31 4 auto (lemma-R (C.H1 • C.S1 • C.W) (plus , Z⊗Z))
      equals S1 • H1 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • H1 • S1⁻¹ • S1⁻¹ • H1 • X0 • CZ • R (plus , Z⊗Z) • R (plus , I⊗X) • R (plus , I⊗Z) • R (plus , Z⊗Z) • R (plus , Z⊗X) • H1 • S1 • W • R (plus , I⊗Y) • R (minus , Z⊗Y) • R (plus , I⊗Z) • R (plus , I⊗X) • R (minus , Z⊗X) • R (plus , I⊗Y) • R (plus , I⊗X) • Swap • S0⁻¹ • W ^ 2 • Swap • S0 • S0 • H1 • S1 • H1 • CZ • X0 • H1 • S1 • S1 • H1 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • H1 • S1⁻¹ • R (plus , Z⊗Z) • R (plus , I⊗X) • R (plus , Z⊗X) • R (plus , Z⊗Y) • R (plus , I⊗X) • R (plus , Z⊗X) • S1 • H1 • CZ • S0 • S0 • S0 • S1 • S1 • W ^ 6 • ε
          by in-context 32 4 auto (lemma-R (C.H1 • C.S1 • C.W) (plus , I⊗Y))
      equals S1 • H1 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • H1 • S1⁻¹ • S1⁻¹ • H1 • X0 • CZ • R (plus , Z⊗Z) • R (plus , I⊗X) • R (plus , I⊗Z) • R (plus , Z⊗Z) • R (plus , Z⊗X) • R (minus , I⊗Z) • H1 • S1 • W • R (minus , Z⊗Y) • R (plus , I⊗Z) • R (plus , I⊗X) • R (minus , Z⊗X) • R (plus , I⊗Y) • R (plus , I⊗X) • Swap • S0⁻¹ • W ^ 2 • Swap • S0 • S0 • H1 • S1 • H1 • CZ • X0 • H1 • S1 • S1 • H1 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • H1 • S1⁻¹ • R (plus , Z⊗Z) • R (plus , I⊗X) • R (plus , Z⊗X) • R (plus , Z⊗Y) • R (plus , I⊗X) • R (plus , Z⊗X) • S1 • H1 • CZ • S0 • S0 • S0 • S1 • S1 • W ^ 6 • ε
          by in-context 32 1 auto (lemma-correction I⊗Z)
      equals S1 • H1 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • H1 • S1⁻¹ • S1⁻¹ • H1 • X0 • CZ • R (plus , Z⊗Z) • R (plus , I⊗X) • R (plus , I⊗Z) • R (plus , Z⊗Z) • R (plus , Z⊗X) • R (plus , I⊗Z) • Swap • S0⁻¹ • W • Swap • H1 • S1 • W • R (minus , Z⊗Y) • R (plus , I⊗Z) • R (plus , I⊗X) • R (minus , Z⊗X) • R (plus , I⊗Y) • R (plus , I⊗X) • Swap • S0⁻¹ • W ^ 2 • Swap • S0 • S0 • H1 • S1 • H1 • CZ • X0 • H1 • S1 • S1 • H1 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • H1 • S1⁻¹ • R (plus , Z⊗Z) • R (plus , I⊗X) • R (plus , Z⊗X) • R (plus , Z⊗Y) • R (plus , I⊗X) • R (plus , Z⊗X) • S1 • H1 • CZ • S0 • S0 • S0 • S1 • S1 • W ^ 6 • ε
          by clifford-tactic 33 7 10000 auto
      equals S1 • H1 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • H1 • S1⁻¹ • S1⁻¹ • H1 • X0 • CZ • R (plus , Z⊗Z) • R (plus , I⊗X) • R (plus , I⊗Z) • R (plus , Z⊗Z) • R (plus , Z⊗X) • R (plus , I⊗Z) • S1 • S1 • S1 • H1 • S1 • W ^ 2 • R (minus , Z⊗Y) • R (plus , I⊗Z) • R (plus , I⊗X) • R (minus , Z⊗X) • R (plus , I⊗Y) • R (plus , I⊗X) • Swap • S0⁻¹ • W ^ 2 • Swap • S0 • S0 • H1 • S1 • H1 • CZ • X0 • H1 • S1 • S1 • H1 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • H1 • S1⁻¹ • R (plus , Z⊗Z) • R (plus , I⊗X) • R (plus , Z⊗X) • R (plus , Z⊗Y) • R (plus , I⊗X) • R (plus , Z⊗X) • S1 • H1 • CZ • S0 • S0 • S0 • S1 • S1 • W ^ 6 • ε
          by in-context 33 7 auto (lemma-R (C.S1 • C.S1 • C.S1 • C.H1 • C.S1 • C.W ^ 2) (minus , Z⊗Y))
      equals S1 • H1 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • H1 • S1⁻¹ • S1⁻¹ • H1 • X0 • CZ • R (plus , Z⊗Z) • R (plus , I⊗X) • R (plus , I⊗Z) • R (plus , Z⊗Z) • R (plus , Z⊗X) • R (plus , I⊗Z) • R (plus , Z⊗Z) • S1 • S1 • S1 • H1 • S1 • W ^ 2 • R (plus , I⊗Z) • R (plus , I⊗X) • R (minus , Z⊗X) • R (plus , I⊗Y) • R (plus , I⊗X) • Swap • S0⁻¹ • W ^ 2 • Swap • S0 • S0 • H1 • S1 • H1 • CZ • X0 • H1 • S1 • S1 • H1 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • H1 • S1⁻¹ • R (plus , Z⊗Z) • R (plus , I⊗X) • R (plus , Z⊗X) • R (plus , Z⊗Y) • R (plus , I⊗X) • R (plus , Z⊗X) • S1 • H1 • CZ • S0 • S0 • S0 • S1 • S1 • W ^ 6 • ε
          by in-context 34 7 auto (lemma-R (C.S1 • C.S1 • C.S1 • C.H1 • C.S1 • C.W ^ 2) (plus , I⊗Z))
      equals S1 • H1 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • H1 • S1⁻¹ • S1⁻¹ • H1 • X0 • CZ • R (plus , Z⊗Z) • R (plus , I⊗X) • R (plus , I⊗Z) • R (plus , Z⊗Z) • R (plus , Z⊗X) • R (plus , I⊗Z) • R (plus , Z⊗Z) • R (minus , I⊗Y) • S1 • S1 • S1 • H1 • S1 • W ^ 2 • R (plus , I⊗X) • R (minus , Z⊗X) • R (plus , I⊗Y) • R (plus , I⊗X) • Swap • S0⁻¹ • W ^ 2 • Swap • S0 • S0 • H1 • S1 • H1 • CZ • X0 • H1 • S1 • S1 • H1 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • H1 • S1⁻¹ • R (plus , Z⊗Z) • R (plus , I⊗X) • R (plus , Z⊗X) • R (plus , Z⊗Y) • R (plus , I⊗X) • R (plus , Z⊗X) • S1 • H1 • CZ • S0 • S0 • S0 • S1 • S1 • W ^ 6 • ε
          by in-context 34 1 auto (lemma-correction I⊗Y)
      equals S1 • H1 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • H1 • S1⁻¹ • S1⁻¹ • H1 • X0 • CZ • R (plus , Z⊗Z) • R (plus , I⊗X) • R (plus , I⊗Z) • R (plus , Z⊗Z) • R (plus , Z⊗X) • R (plus , I⊗Z) • R (plus , Z⊗Z) • R (plus , I⊗Y) • S1 • H1 • Swap • S0⁻¹ • W • Swap • H1 • S1⁻¹ • S1 • S1 • S1 • H1 • S1 • W ^ 2 • R (plus , I⊗X) • R (minus , Z⊗X) • R (plus , I⊗Y) • R (plus , I⊗X) • Swap • S0⁻¹ • W ^ 2 • Swap • S0 • S0 • H1 • S1 • H1 • CZ • X0 • H1 • S1 • S1 • H1 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • H1 • S1⁻¹ • R (plus , Z⊗Z) • R (plus , I⊗X) • R (plus , Z⊗X) • R (plus , Z⊗Y) • R (plus , I⊗X) • R (plus , Z⊗X) • S1 • H1 • CZ • S0 • S0 • S0 • S1 • S1 • W ^ 6 • ε
          by clifford-tactic 36 13 10000 auto
      equals S1 • H1 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • H1 • S1⁻¹ • S1⁻¹ • H1 • X0 • CZ • R (plus , Z⊗Z) • R (plus , I⊗X) • R (plus , I⊗Z) • R (plus , Z⊗Z) • R (plus , Z⊗X) • R (plus , I⊗Z) • R (plus , Z⊗Z) • R (plus , I⊗Y) • S1 • S1 • S1 • H1 • S1 • S1 • W • R (plus , I⊗X) • R (minus , Z⊗X) • R (plus , I⊗Y) • R (plus , I⊗X) • Swap • S0⁻¹ • W ^ 2 • Swap • S0 • S0 • H1 • S1 • H1 • CZ • X0 • H1 • S1 • S1 • H1 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • H1 • S1⁻¹ • R (plus , Z⊗Z) • R (plus , I⊗X) • R (plus , Z⊗X) • R (plus , Z⊗Y) • R (plus , I⊗X) • R (plus , Z⊗X) • S1 • H1 • CZ • S0 • S0 • S0 • S1 • S1 • W ^ 6 • ε
          by in-context 35 8 auto (lemma-R (C.S1 • C.S1 • C.S1 • C.H1 • C.S1 • C.S1 • C.W) (plus , I⊗X))
      equals S1 • H1 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • H1 • S1⁻¹ • S1⁻¹ • H1 • X0 • CZ • R (plus , Z⊗Z) • R (plus , I⊗X) • R (plus , I⊗Z) • R (plus , Z⊗Z) • R (plus , Z⊗X) • R (plus , I⊗Z) • R (plus , Z⊗Z) • R (plus , I⊗Y) • R (minus , I⊗Z) • S1 • S1 • S1 • H1 • S1 • S1 • W • R (minus , Z⊗X) • R (plus , I⊗Y) • R (plus , I⊗X) • Swap • S0⁻¹ • W ^ 2 • Swap • S0 • S0 • H1 • S1 • H1 • CZ • X0 • H1 • S1 • S1 • H1 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • H1 • S1⁻¹ • R (plus , Z⊗Z) • R (plus , I⊗X) • R (plus , Z⊗X) • R (plus , Z⊗Y) • R (plus , I⊗X) • R (plus , Z⊗X) • S1 • H1 • CZ • S0 • S0 • S0 • S1 • S1 • W ^ 6 • ε
          by in-context 35 1 auto (lemma-correction I⊗Z)
      equals S1 • H1 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • H1 • S1⁻¹ • S1⁻¹ • H1 • X0 • CZ • R (plus , Z⊗Z) • R (plus , I⊗X) • R (plus , I⊗Z) • R (plus , Z⊗Z) • R (plus , Z⊗X) • R (plus , I⊗Z) • R (plus , Z⊗Z) • R (plus , I⊗Y) • R (plus , I⊗Z) • Swap • S0⁻¹ • W • Swap • S1 • S1 • S1 • H1 • S1 • S1 • W • R (minus , Z⊗X) • R (plus , I⊗Y) • R (plus , I⊗X) • Swap • S0⁻¹ • W ^ 2 • Swap • S0 • S0 • H1 • S1 • H1 • CZ • X0 • H1 • S1 • S1 • H1 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • H1 • S1⁻¹ • R (plus , Z⊗Z) • R (plus , I⊗X) • R (plus , Z⊗X) • R (plus , Z⊗Y) • R (plus , I⊗X) • R (plus , Z⊗X) • S1 • H1 • CZ • S0 • S0 • S0 • S1 • S1 • W ^ 6 • ε
          by clifford-tactic 36 11 10000 auto
      equals S1 • H1 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • H1 • S1⁻¹ • S1⁻¹ • H1 • X0 • CZ • R (plus , Z⊗Z) • R (plus , I⊗X) • R (plus , I⊗Z) • R (plus , Z⊗Z) • R (plus , Z⊗X) • R (plus , I⊗Z) • R (plus , Z⊗Z) • R (plus , I⊗Y) • R (plus , I⊗Z) • S1 • S1 • H1 • S1 • S1 • W ^ 2 • R (minus , Z⊗X) • R (plus , I⊗Y) • R (plus , I⊗X) • Swap • S0⁻¹ • W ^ 2 • Swap • S0 • S0 • H1 • S1 • H1 • CZ • X0 • H1 • S1 • S1 • H1 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • H1 • S1⁻¹ • R (plus , Z⊗Z) • R (plus , I⊗X) • R (plus , Z⊗X) • R (plus , Z⊗Y) • R (plus , I⊗X) • R (plus , Z⊗X) • S1 • H1 • CZ • S0 • S0 • S0 • S1 • S1 • W ^ 6 • ε
          by in-context 36 7 auto (lemma-R (C.S1 • C.S1 • C.H1 • C.S1 • C.S1 • C.W ^ 2) (minus , Z⊗X))
      equals S1 • H1 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • H1 • S1⁻¹ • S1⁻¹ • H1 • X0 • CZ • R (plus , Z⊗Z) • R (plus , I⊗X) • R (plus , I⊗Z) • R (plus , Z⊗Z) • R (plus , Z⊗X) • R (plus , I⊗Z) • R (plus , Z⊗Z) • R (plus , I⊗Y) • R (plus , I⊗Z) • R (plus , Z⊗Z) • S1 • S1 • H1 • S1 • S1 • W ^ 2 • R (plus , I⊗Y) • R (plus , I⊗X) • Swap • S0⁻¹ • W ^ 2 • Swap • S0 • S0 • H1 • S1 • H1 • CZ • X0 • H1 • S1 • S1 • H1 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • H1 • S1⁻¹ • R (plus , Z⊗Z) • R (plus , I⊗X) • R (plus , Z⊗X) • R (plus , Z⊗Y) • R (plus , I⊗X) • R (plus , Z⊗X) • S1 • H1 • CZ • S0 • S0 • S0 • S1 • S1 • W ^ 6 • ε
          by in-context 37 7 auto (lemma-R (C.S1 • C.S1 • C.H1 • C.S1 • C.S1 • C.W ^ 2) (plus , I⊗Y))
      equals S1 • H1 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • H1 • S1⁻¹ • S1⁻¹ • H1 • X0 • CZ • R (plus , Z⊗Z) • R (plus , I⊗X) • R (plus , I⊗Z) • R (plus , Z⊗Z) • R (plus , Z⊗X) • R (plus , I⊗Z) • R (plus , Z⊗Z) • R (plus , I⊗Y) • R (plus , I⊗Z) • R (plus , Z⊗Z) • R (minus , I⊗Y) • S1 • S1 • H1 • S1 • S1 • W ^ 2 • R (plus , I⊗X) • Swap • S0⁻¹ • W ^ 2 • Swap • S0 • S0 • H1 • S1 • H1 • CZ • X0 • H1 • S1 • S1 • H1 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • H1 • S1⁻¹ • R (plus , Z⊗Z) • R (plus , I⊗X) • R (plus , Z⊗X) • R (plus , Z⊗Y) • R (plus , I⊗X) • R (plus , Z⊗X) • S1 • H1 • CZ • S0 • S0 • S0 • S1 • S1 • W ^ 6 • ε
          by in-context 37 1 auto (lemma-correction I⊗Y)
      equals S1 • H1 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • H1 • S1⁻¹ • S1⁻¹ • H1 • X0 • CZ • R (plus , Z⊗Z) • R (plus , I⊗X) • R (plus , I⊗Z) • R (plus , Z⊗Z) • R (plus , Z⊗X) • R (plus , I⊗Z) • R (plus , Z⊗Z) • R (plus , I⊗Y) • R (plus , I⊗Z) • R (plus , Z⊗Z) • R (plus , I⊗Y) • S1 • H1 • Swap • S0⁻¹ • W • Swap • H1 • S1⁻¹ • S1 • S1 • H1 • S1 • S1 • W ^ 2 • R (plus , I⊗X) • Swap • S0⁻¹ • W ^ 2 • Swap • S0 • S0 • H1 • S1 • H1 • CZ • X0 • H1 • S1 • S1 • H1 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • H1 • S1⁻¹ • R (plus , Z⊗Z) • R (plus , I⊗X) • R (plus , Z⊗X) • R (plus , Z⊗Y) • R (plus , I⊗X) • R (plus , Z⊗X) • S1 • H1 • CZ • S0 • S0 • S0 • S1 • S1 • W ^ 6 • ε
          by clifford-tactic 38 14 10000 auto
      equals S1 • H1 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • H1 • S1⁻¹ • S1⁻¹ • H1 • X0 • CZ • R (plus , Z⊗Z) • R (plus , I⊗X) • R (plus , I⊗Z) • R (plus , Z⊗Z) • R (plus , Z⊗X) • R (plus , I⊗Z) • R (plus , Z⊗Z) • R (plus , I⊗Y) • R (plus , I⊗Z) • R (plus , Z⊗Z) • R (plus , I⊗Y) • H1 • S1 • S1 • H1 • W ^ 6 • R (plus , I⊗X) • Swap • S0⁻¹ • W ^ 2 • Swap • S0 • S0 • H1 • S1 • H1 • CZ • X0 • H1 • S1 • S1 • H1 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • H1 • S1⁻¹ • R (plus , Z⊗Z) • R (plus , I⊗X) • R (plus , Z⊗X) • R (plus , Z⊗Y) • R (plus , I⊗X) • R (plus , Z⊗X) • S1 • H1 • CZ • S0 • S0 • S0 • S1 • S1 • W ^ 6 • ε
          by in-context 38 6 auto (lemma-R (C.H1 • C.S1 • C.S1 • C.H1 • C.W ^ 6) (plus , I⊗X))
      equals S1 • H1 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • H1 • S1⁻¹ • S1⁻¹ • H1 • X0 • CZ • R (plus , Z⊗Z) • R (plus , I⊗X) • R (plus , I⊗Z) • R (plus , Z⊗Z) • R (plus , Z⊗X) • R (plus , I⊗Z) • R (plus , Z⊗Z) • R (plus , I⊗Y) • R (plus , I⊗Z) • R (plus , Z⊗Z) • R (plus , I⊗Y) • R (plus , I⊗X) • H1 • S1 • S1 • H1 • W ^ 6 • Swap • S0⁻¹ • W ^ 2 • Swap • S0 • S0 • H1 • S1 • H1 • CZ • X0 • H1 • S1 • S1 • H1 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • H1 • S1⁻¹ • R (plus , Z⊗Z) • R (plus , I⊗X) • R (plus , Z⊗X) • R (plus , Z⊗Y) • R (plus , I⊗X) • R (plus , Z⊗X) • S1 • H1 • CZ • S0 • S0 • S0 • S1 • S1 • W ^ 6 • ε
          by clifford-tactic 39 14 10000 auto
      equals S1 • H1 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • H1 • S1⁻¹ • S1⁻¹ • H1 • X0 • CZ • R (plus , Z⊗Z) • R (plus , I⊗X) • R (plus , I⊗Z) • R (plus , Z⊗Z) • R (plus , Z⊗X) • R (plus , I⊗Z) • R (plus , Z⊗Z) • R (plus , I⊗Y) • R (plus , I⊗Z) • R (plus , Z⊗Z) • R (plus , I⊗Y) • R (plus , I⊗X) • S0 • S0 • S1 • S1 • H1 • S1 • W ^ 5 • CZ • X0 • H1 • S1 • S1 • H1 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • H1 • S1⁻¹ • R (plus , Z⊗Z) • R (plus , I⊗X) • R (plus , Z⊗X) • R (plus , Z⊗Y) • R (plus , I⊗X) • R (plus , Z⊗X) • S1 • H1 • CZ • S0 • S0 • S0 • S1 • S1 • W ^ 6 • ε
          by in-context 35 2 auto (tactic-pauli-commute (plus , I⊗Z) (plus , Z⊗Z) auto)
      equals S1 • H1 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • H1 • S1⁻¹ • S1⁻¹ • H1 • X0 • CZ • R (plus , Z⊗Z) • R (plus , I⊗X) • R (plus , I⊗Z) • R (plus , Z⊗Z) • R (plus , Z⊗X) • R (plus , I⊗Z) • R (plus , Z⊗Z) • R (plus , I⊗Y) • R (plus , Z⊗Z) • R (plus , I⊗Z) • R (plus , I⊗Y) • R (plus , I⊗X) • S0 • S0 • S1 • S1 • H1 • S1 • W ^ 5 • CZ • X0 • H1 • S1 • S1 • H1 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • H1 • S1⁻¹ • R (plus , Z⊗Z) • R (plus , I⊗X) • R (plus , Z⊗X) • R (plus , Z⊗Y) • R (plus , I⊗X) • R (plus , Z⊗X) • S1 • H1 • CZ • S0 • S0 • S0 • S1 • S1 • W ^ 6 • ε
          by in-context 32 2 auto (tactic-pauli-commute (plus , I⊗Z) (plus , Z⊗Z) auto)
      equals S1 • H1 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • H1 • S1⁻¹ • S1⁻¹ • H1 • X0 • CZ • R (plus , Z⊗Z) • R (plus , I⊗X) • R (plus , I⊗Z) • R (plus , Z⊗Z) • R (plus , Z⊗X) • R (plus , Z⊗Z) • R (plus , I⊗Z) • R (plus , I⊗Y) • R (plus , Z⊗Z) • R (plus , I⊗Z) • R (plus , I⊗Y) • R (plus , I⊗X) • S0 • S0 • S1 • S1 • H1 • S1 • W ^ 5 • CZ • X0 • H1 • S1 • S1 • H1 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • H1 • S1⁻¹ • R (plus , Z⊗Z) • R (plus , I⊗X) • R (plus , Z⊗X) • R (plus , Z⊗Y) • R (plus , I⊗X) • R (plus , Z⊗X) • S1 • H1 • CZ • S0 • S0 • S0 • S1 • S1 • W ^ 6 • ε
          by clifford-tactic 39 7 10000 auto
      equals S1 • H1 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • H1 • S1⁻¹ • S1⁻¹ • H1 • X0 • CZ • R (plus , Z⊗Z) • R (plus , I⊗X) • R (plus , I⊗Z) • R (plus , Z⊗Z) • R (plus , Z⊗X) • R (plus , Z⊗Z) • R (plus , I⊗Z) • R (plus , I⊗Y) • R (plus , Z⊗Z) • R (plus , I⊗Z) • R (plus , I⊗Y) • R (plus , I⊗X) • H1 • Swap • S0⁻¹ • W • Swap • H1 • S1 • H1 • CZ • S0 • H1 • S1 • H1 • W ^ 4 • S1 • H1 • CZ • S0 • H1 • W ^ 2 • S1⁻¹ • CZ • X0 • H1 • S1 • S1 • H1 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • H1 • S1⁻¹ • R (plus , Z⊗Z) • R (plus , I⊗X) • R (plus , Z⊗X) • R (plus , Z⊗Y) • R (plus , I⊗X) • R (plus , Z⊗X) • S1 • H1 • CZ • S0 • S0 • S0 • S1 • S1 • W ^ 6 • ε
          by in-context 38 7 auto (symm (lemma-correction I⊗X))
      equals S1 • H1 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • H1 • S1⁻¹ • S1⁻¹ • H1 • X0 • CZ • R (plus , Z⊗Z) • R (plus , I⊗X) • R (plus , I⊗Z) • R (plus , Z⊗Z) • R (plus , Z⊗X) • R (plus , Z⊗Z) • R (plus , I⊗Z) • R (plus , I⊗Y) • R (plus , Z⊗Z) • R (plus , I⊗Z) • R (plus , I⊗Y) • R (minus , I⊗X) • S1 • H1 • CZ • S0 • H1 • S1 • H1 • W ^ 4 • S1 • H1 • CZ • S0 • H1 • W ^ 2 • S1⁻¹ • CZ • X0 • H1 • S1 • S1 • H1 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • H1 • S1⁻¹ • R (plus , Z⊗Z) • R (plus , I⊗X) • R (plus , Z⊗X) • R (plus , Z⊗Y) • R (plus , I⊗X) • R (plus , Z⊗X) • S1 • H1 • CZ • S0 • S0 • S0 • S1 • S1 • W ^ 6 • ε
          by in-context 38 9 auto (symm (lemma-R (C.S1 • C.H1 • C.CZ • C.S0 • C.H1 • C.S1 • C.H1 • C.W ^ 4) (plus , Z⊗Z)))
      equals S1 • H1 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • H1 • S1⁻¹ • S1⁻¹ • H1 • X0 • CZ • R (plus , Z⊗Z) • R (plus , I⊗X) • R (plus , I⊗Z) • R (plus , Z⊗Z) • R (plus , Z⊗X) • R (plus , Z⊗Z) • R (plus , I⊗Z) • R (plus , I⊗Y) • R (plus , Z⊗Z) • R (plus , I⊗Z) • R (plus , I⊗Y) • S1 • H1 • CZ • S0 • H1 • S1 • H1 • W ^ 4 • R (plus , Z⊗Z) • S1 • H1 • CZ • S0 • H1 • W ^ 2 • S1⁻¹ • CZ • X0 • H1 • S1 • S1 • H1 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • H1 • S1⁻¹ • R (plus , Z⊗Z) • R (plus , I⊗X) • R (plus , Z⊗X) • R (plus , Z⊗Y) • R (plus , I⊗X) • R (plus , Z⊗X) • S1 • H1 • CZ • S0 • S0 • S0 • S1 • S1 • W ^ 6 • ε
          by in-context 37 9 auto (symm (lemma-R (C.S1 • C.H1 • C.CZ • C.S0 • C.H1 • C.S1 • C.H1 • C.W ^ 4) (plus , I⊗Y)))
      equals S1 • H1 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • H1 • S1⁻¹ • S1⁻¹ • H1 • X0 • CZ • R (plus , Z⊗Z) • R (plus , I⊗X) • R (plus , I⊗Z) • R (plus , Z⊗Z) • R (plus , Z⊗X) • R (plus , Z⊗Z) • R (plus , I⊗Z) • R (plus , I⊗Y) • R (plus , Z⊗Z) • R (plus , I⊗Z) • S1 • H1 • CZ • S0 • H1 • S1 • H1 • W ^ 4 • R (plus , I⊗Y) • R (plus , Z⊗Z) • S1 • H1 • CZ • S0 • H1 • W ^ 2 • S1⁻¹ • CZ • X0 • H1 • S1 • S1 • H1 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • H1 • S1⁻¹ • R (plus , Z⊗Z) • R (plus , I⊗X) • R (plus , Z⊗X) • R (plus , Z⊗Y) • R (plus , I⊗X) • R (plus , Z⊗X) • S1 • H1 • CZ • S0 • S0 • S0 • S1 • S1 • W ^ 6 • ε
          by in-context 36 9 auto (symm (lemma-R (C.S1 • C.H1 • C.CZ • C.S0 • C.H1 • C.S1 • C.H1 • C.W ^ 4) (plus , Z⊗X)))
      equals S1 • H1 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • H1 • S1⁻¹ • S1⁻¹ • H1 • X0 • CZ • R (plus , Z⊗Z) • R (plus , I⊗X) • R (plus , I⊗Z) • R (plus , Z⊗Z) • R (plus , Z⊗X) • R (plus , Z⊗Z) • R (plus , I⊗Z) • R (plus , I⊗Y) • R (plus , Z⊗Z) • S1 • H1 • CZ • S0 • H1 • S1 • H1 • W ^ 4 • R (plus , Z⊗X) • R (plus , I⊗Y) • R (plus , Z⊗Z) • S1 • H1 • CZ • S0 • H1 • W ^ 2 • S1⁻¹ • CZ • X0 • H1 • S1 • S1 • H1 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • H1 • S1⁻¹ • R (plus , Z⊗Z) • R (plus , I⊗X) • R (plus , Z⊗X) • R (plus , Z⊗Y) • R (plus , I⊗X) • R (plus , Z⊗X) • S1 • H1 • CZ • S0 • S0 • S0 • S1 • S1 • W ^ 6 • ε
          by clifford-tactic 36 8 10000 auto
      equals S1 • H1 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • H1 • S1⁻¹ • S1⁻¹ • H1 • X0 • CZ • R (plus , Z⊗Z) • R (plus , I⊗X) • R (plus , I⊗Z) • R (plus , Z⊗Z) • R (plus , Z⊗X) • R (plus , Z⊗Z) • R (plus , I⊗Z) • R (plus , I⊗Y) • R (plus , Z⊗Z) • H0 • CZ • H0 • S0⁻¹ • W • H0 • CZ • H0 • S1 • H1 • CZ • S0 • H1 • S1 • S1 • H1 • W ^ 3 • R (plus , Z⊗X) • R (plus , I⊗Y) • R (plus , Z⊗Z) • S1 • H1 • CZ • S0 • H1 • W ^ 2 • S1⁻¹ • CZ • X0 • H1 • S1 • S1 • H1 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • H1 • S1⁻¹ • R (plus , Z⊗Z) • R (plus , I⊗X) • R (plus , Z⊗X) • R (plus , Z⊗Y) • R (plus , I⊗X) • R (plus , Z⊗X) • S1 • H1 • CZ • S0 • S0 • S0 • S1 • S1 • W ^ 6 • ε
          by in-context 35 9 auto (symm (lemma-correction Z⊗Z))
      equals S1 • H1 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • H1 • S1⁻¹ • S1⁻¹ • H1 • X0 • CZ • R (plus , Z⊗Z) • R (plus , I⊗X) • R (plus , I⊗Z) • R (plus , Z⊗Z) • R (plus , Z⊗X) • R (plus , Z⊗Z) • R (plus , I⊗Z) • R (plus , I⊗Y) • R (minus , Z⊗Z) • S1 • H1 • CZ • S0 • H1 • S1 • S1 • H1 • W ^ 3 • R (plus , Z⊗X) • R (plus , I⊗Y) • R (plus , Z⊗Z) • S1 • H1 • CZ • S0 • H1 • W ^ 2 • S1⁻¹ • CZ • X0 • H1 • S1 • S1 • H1 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • H1 • S1⁻¹ • R (plus , Z⊗Z) • R (plus , I⊗X) • R (plus , Z⊗X) • R (plus , Z⊗Y) • R (plus , I⊗X) • R (plus , Z⊗X) • S1 • H1 • CZ • S0 • S0 • S0 • S1 • S1 • W ^ 6 • ε
          by in-context 35 10 auto (symm (lemma-R (C.S1 • C.H1 • C.CZ • C.S0 • C.H1 • C.S1 • C.S1 • C.H1 • C.W ^ 3) (minus , I⊗X)))
      equals S1 • H1 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • H1 • S1⁻¹ • S1⁻¹ • H1 • X0 • CZ • R (plus , Z⊗Z) • R (plus , I⊗X) • R (plus , I⊗Z) • R (plus , Z⊗Z) • R (plus , Z⊗X) • R (plus , Z⊗Z) • R (plus , I⊗Z) • R (plus , I⊗Y) • S1 • H1 • CZ • S0 • H1 • S1 • S1 • H1 • W ^ 3 • R (minus , I⊗X) • R (plus , Z⊗X) • R (plus , I⊗Y) • R (plus , Z⊗Z) • S1 • H1 • CZ • S0 • H1 • W ^ 2 • S1⁻¹ • CZ • X0 • H1 • S1 • S1 • H1 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • H1 • S1⁻¹ • R (plus , Z⊗Z) • R (plus , I⊗X) • R (plus , Z⊗X) • R (plus , Z⊗Y) • R (plus , I⊗X) • R (plus , Z⊗X) • S1 • H1 • CZ • S0 • S0 • S0 • S1 • S1 • W ^ 6 • ε
          by in-context 34 10 auto (symm (lemma-R (C.S1 • C.H1 • C.CZ • C.S0 • C.H1 • C.S1 • C.S1 • C.H1 • C.W ^ 3) (minus , I⊗Z)))
      equals S1 • H1 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • H1 • S1⁻¹ • S1⁻¹ • H1 • X0 • CZ • R (plus , Z⊗Z) • R (plus , I⊗X) • R (plus , I⊗Z) • R (plus , Z⊗Z) • R (plus , Z⊗X) • R (plus , Z⊗Z) • R (plus , I⊗Z) • S1 • H1 • CZ • S0 • H1 • S1 • S1 • H1 • W ^ 3 • R (minus , I⊗Z) • R (minus , I⊗X) • R (plus , Z⊗X) • R (plus , I⊗Y) • R (plus , Z⊗Z) • S1 • H1 • CZ • S0 • H1 • W ^ 2 • S1⁻¹ • CZ • X0 • H1 • S1 • S1 • H1 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • H1 • S1⁻¹ • R (plus , Z⊗Z) • R (plus , I⊗X) • R (plus , Z⊗X) • R (plus , Z⊗Y) • R (plus , I⊗X) • R (plus , Z⊗X) • S1 • H1 • CZ • S0 • S0 • S0 • S1 • S1 • W ^ 6 • ε
          by clifford-tactic 34 9 10000 auto
      equals S1 • H1 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • H1 • S1⁻¹ • S1⁻¹ • H1 • X0 • CZ • R (plus , Z⊗Z) • R (plus , I⊗X) • R (plus , I⊗Z) • R (plus , Z⊗Z) • R (plus , Z⊗X) • R (plus , Z⊗Z) • R (plus , I⊗Z) • Swap • S0⁻¹ • W • Swap • H1 • CZ • S0 • S0 • S0 • W ^ 2 • R (minus , I⊗Z) • R (minus , I⊗X) • R (plus , Z⊗X) • R (plus , I⊗Y) • R (plus , Z⊗Z) • S1 • H1 • CZ • S0 • H1 • W ^ 2 • S1⁻¹ • CZ • X0 • H1 • S1 • S1 • H1 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • H1 • S1⁻¹ • R (plus , Z⊗Z) • R (plus , I⊗X) • R (plus , Z⊗X) • R (plus , Z⊗Y) • R (plus , I⊗X) • R (plus , Z⊗X) • S1 • H1 • CZ • S0 • S0 • S0 • S1 • S1 • W ^ 6 • ε
          by in-context 33 5 auto (symm (lemma-correction I⊗Z))
      equals S1 • H1 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • H1 • S1⁻¹ • S1⁻¹ • H1 • X0 • CZ • R (plus , Z⊗Z) • R (plus , I⊗X) • R (plus , I⊗Z) • R (plus , Z⊗Z) • R (plus , Z⊗X) • R (plus , Z⊗Z) • R (minus , I⊗Z) • H1 • CZ • S0 • S0 • S0 • W ^ 2 • R (minus , I⊗Z) • R (minus , I⊗X) • R (plus , Z⊗X) • R (plus , I⊗Y) • R (plus , Z⊗Z) • S1 • H1 • CZ • S0 • H1 • W ^ 2 • S1⁻¹ • CZ • X0 • H1 • S1 • S1 • H1 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • H1 • S1⁻¹ • R (plus , Z⊗Z) • R (plus , I⊗X) • R (plus , Z⊗X) • R (plus , Z⊗Y) • R (plus , I⊗X) • R (plus , Z⊗X) • S1 • H1 • CZ • S0 • S0 • S0 • S1 • S1 • W ^ 6 • ε
          by in-context 33 7 auto (symm (lemma-R (C.H1 • C.CZ • C.S0 • C.S0 • C.S0 • C.W ^ 2) (minus , Z⊗X)))
      equals S1 • H1 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • H1 • S1⁻¹ • S1⁻¹ • H1 • X0 • CZ • R (plus , Z⊗Z) • R (plus , I⊗X) • R (plus , I⊗Z) • R (plus , Z⊗Z) • R (plus , Z⊗X) • R (plus , Z⊗Z) • H1 • CZ • S0 • S0 • S0 • W ^ 2 • R (minus , Z⊗X) • R (minus , I⊗Z) • R (minus , I⊗X) • R (plus , Z⊗X) • R (plus , I⊗Y) • R (plus , Z⊗Z) • S1 • H1 • CZ • S0 • H1 • W ^ 2 • S1⁻¹ • CZ • X0 • H1 • S1 • S1 • H1 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • H1 • S1⁻¹ • R (plus , Z⊗Z) • R (plus , I⊗X) • R (plus , Z⊗X) • R (plus , Z⊗Y) • R (plus , I⊗X) • R (plus , Z⊗X) • S1 • H1 • CZ • S0 • S0 • S0 • S1 • S1 • W ^ 6 • ε
          by clifford-tactic 33 6 10000 auto
      equals S1 • H1 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • H1 • S1⁻¹ • S1⁻¹ • H1 • X0 • CZ • R (plus , Z⊗Z) • R (plus , I⊗X) • R (plus , I⊗Z) • R (plus , Z⊗Z) • R (plus , Z⊗X) • R (plus , Z⊗Z) • H0 • CZ • H0 • S0⁻¹ • W • H0 • CZ • H0 • H1 • CZ • S0 • S0 • S0 • H1 • S1 • H1 • W • R (minus , Z⊗X) • R (minus , I⊗Z) • R (minus , I⊗X) • R (plus , Z⊗X) • R (plus , I⊗Y) • R (plus , Z⊗Z) • S1 • H1 • CZ • S0 • H1 • W ^ 2 • S1⁻¹ • CZ • X0 • H1 • S1 • S1 • H1 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • H1 • S1⁻¹ • R (plus , Z⊗Z) • R (plus , I⊗X) • R (plus , Z⊗X) • R (plus , Z⊗Y) • R (plus , I⊗X) • R (plus , Z⊗X) • S1 • H1 • CZ • S0 • S0 • S0 • S1 • S1 • W ^ 6 • ε
          by in-context 32 9 auto (symm (lemma-correction Z⊗Z))
      equals S1 • H1 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • H1 • S1⁻¹ • S1⁻¹ • H1 • X0 • CZ • R (plus , Z⊗Z) • R (plus , I⊗X) • R (plus , I⊗Z) • R (plus , Z⊗Z) • R (plus , Z⊗X) • R (minus , Z⊗Z) • H1 • CZ • S0 • S0 • S0 • H1 • S1 • H1 • W • R (minus , Z⊗X) • R (minus , I⊗Z) • R (minus , I⊗X) • R (plus , Z⊗X) • R (plus , I⊗Y) • R (plus , Z⊗Z) • S1 • H1 • CZ • S0 • H1 • W ^ 2 • S1⁻¹ • CZ • X0 • H1 • S1 • S1 • H1 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • H1 • S1⁻¹ • R (plus , Z⊗Z) • R (plus , I⊗X) • R (plus , Z⊗X) • R (plus , Z⊗Y) • R (plus , I⊗X) • R (plus , Z⊗X) • S1 • H1 • CZ • S0 • S0 • S0 • S1 • S1 • W ^ 6 • ε
          by in-context 32 10 auto (symm (lemma-R (C.H1 • C.CZ • C.S0 • C.S0 • C.S0 • C.H1 • C.S1 • C.H1 • C.W) (minus , I⊗X)))
      equals S1 • H1 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • H1 • S1⁻¹ • S1⁻¹ • H1 • X0 • CZ • R (plus , Z⊗Z) • R (plus , I⊗X) • R (plus , I⊗Z) • R (plus , Z⊗Z) • R (plus , Z⊗X) • H1 • CZ • S0 • S0 • S0 • H1 • S1 • H1 • W • R (minus , I⊗X) • R (minus , Z⊗X) • R (minus , I⊗Z) • R (minus , I⊗X) • R (plus , Z⊗X) • R (plus , I⊗Y) • R (plus , Z⊗Z) • S1 • H1 • CZ • S0 • H1 • W ^ 2 • S1⁻¹ • CZ • X0 • H1 • S1 • S1 • H1 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • H1 • S1⁻¹ • R (plus , Z⊗Z) • R (plus , I⊗X) • R (plus , Z⊗X) • R (plus , Z⊗Y) • R (plus , I⊗X) • R (plus , Z⊗X) • S1 • H1 • CZ • S0 • S0 • S0 • S1 • S1 • W ^ 6 • ε
          by clifford-tactic 33 8 10000 auto
      equals S1 • H1 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • H1 • S1⁻¹ • S1⁻¹ • H1 • X0 • CZ • R (plus , Z⊗Z) • R (plus , I⊗X) • R (plus , I⊗Z) • R (plus , Z⊗Z) • R (plus , Z⊗X) • H1 • H0 • CZ • H0 • S0⁻¹ • W • H0 • CZ • H0 • H1 • Swap • S0⁻¹ • W • Swap • R (minus , I⊗X) • R (minus , Z⊗X) • R (minus , I⊗Z) • R (minus , I⊗X) • R (plus , Z⊗X) • R (plus , I⊗Y) • R (plus , Z⊗Z) • S1 • H1 • CZ • S0 • H1 • W ^ 2 • S1⁻¹ • CZ • X0 • H1 • S1 • S1 • H1 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • H1 • S1⁻¹ • R (plus , Z⊗Z) • R (plus , I⊗X) • R (plus , Z⊗X) • R (plus , Z⊗Y) • R (plus , I⊗X) • R (plus , Z⊗X) • S1 • H1 • CZ • S0 • S0 • S0 • S1 • S1 • W ^ 6 • ε
          by in-context 31 11 auto (symm (lemma-correction Z⊗X))
      equals S1 • H1 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • H1 • S1⁻¹ • S1⁻¹ • H1 • X0 • CZ • R (plus , Z⊗Z) • R (plus , I⊗X) • R (plus , I⊗Z) • R (plus , Z⊗Z) • R (minus , Z⊗X) • Swap • S0⁻¹ • W • Swap • R (minus , I⊗X) • R (minus , Z⊗X) • R (minus , I⊗Z) • R (minus , I⊗X) • R (plus , Z⊗X) • R (plus , I⊗Y) • R (plus , Z⊗Z) • S1 • H1 • CZ • S0 • H1 • W ^ 2 • S1⁻¹ • CZ • X0 • H1 • S1 • S1 • H1 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • H1 • S1⁻¹ • R (plus , Z⊗Z) • R (plus , I⊗X) • R (plus , Z⊗X) • R (plus , Z⊗Y) • R (plus , I⊗X) • R (plus , Z⊗X) • S1 • H1 • CZ • S0 • S0 • S0 • S1 • S1 • W ^ 6 • ε
          by in-context 31 5 auto (symm (lemma-R (C.Swap • C.S0⁻¹ • C.W • C.Swap) (minus , Z⊗Y)))
      equals S1 • H1 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • H1 • S1⁻¹ • S1⁻¹ • H1 • X0 • CZ • R (plus , Z⊗Z) • R (plus , I⊗X) • R (plus , I⊗Z) • R (plus , Z⊗Z) • Swap • S0⁻¹ • W • Swap • R (minus , Z⊗Y) • R (minus , I⊗X) • R (minus , Z⊗X) • R (minus , I⊗Z) • R (minus , I⊗X) • R (plus , Z⊗X) • R (plus , I⊗Y) • R (plus , Z⊗Z) • S1 • H1 • CZ • S0 • H1 • W ^ 2 • S1⁻¹ • CZ • X0 • H1 • S1 • S1 • H1 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • H1 • S1⁻¹ • R (plus , Z⊗Z) • R (plus , I⊗X) • R (plus , Z⊗X) • R (plus , Z⊗Y) • R (plus , I⊗X) • R (plus , Z⊗X) • S1 • H1 • CZ • S0 • S0 • S0 • S1 • S1 • W ^ 6 • ε
          by in-context 30 5 auto (symm (lemma-R (C.Swap • C.S0⁻¹ • C.W • C.Swap) (plus , Z⊗Z)))
      equals S1 • H1 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • H1 • S1⁻¹ • S1⁻¹ • H1 • X0 • CZ • R (plus , Z⊗Z) • R (plus , I⊗X) • R (plus , I⊗Z) • Swap • S0⁻¹ • W • Swap • R (plus , Z⊗Z) • R (minus , Z⊗Y) • R (minus , I⊗X) • R (minus , Z⊗X) • R (minus , I⊗Z) • R (minus , I⊗X) • R (plus , Z⊗X) • R (plus , I⊗Y) • R (plus , Z⊗Z) • S1 • H1 • CZ • S0 • H1 • W ^ 2 • S1⁻¹ • CZ • X0 • H1 • S1 • S1 • H1 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • H1 • S1⁻¹ • R (plus , Z⊗Z) • R (plus , I⊗X) • R (plus , Z⊗X) • R (plus , Z⊗Y) • R (plus , I⊗X) • R (plus , Z⊗X) • S1 • H1 • CZ • S0 • S0 • S0 • S1 • S1 • W ^ 6 • ε
          by in-context 29 5 auto (symm (lemma-correction I⊗Z))
      equals S1 • H1 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • H1 • S1⁻¹ • S1⁻¹ • H1 • X0 • CZ • R (plus , Z⊗Z) • R (plus , I⊗X) • R (minus , I⊗Z) • R (plus , Z⊗Z) • R (minus , Z⊗Y) • R (minus , I⊗X) • R (minus , Z⊗X) • R (minus , I⊗Z) • R (minus , I⊗X) • R (plus , Z⊗X) • R (plus , I⊗Y) • R (plus , Z⊗Z) • S1 • H1 • CZ • S0 • H1 • W ^ 2 • S1⁻¹ • CZ • X0 • H1 • S1 • S1 • H1 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • H1 • S1⁻¹ • R (plus , Z⊗Z) • R (plus , I⊗X) • R (plus , Z⊗X) • R (plus , Z⊗Y) • R (plus , I⊗X) • R (plus , Z⊗X) • S1 • H1 • CZ • S0 • S0 • S0 • S1 • S1 • W ^ 6 • ε
          by in-context 32 2 auto (tactic-pauli-commute (minus , I⊗X) (minus , Z⊗X) auto)
      equals S1 • H1 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • H1 • S1⁻¹ • S1⁻¹ • H1 • X0 • CZ • R (plus , Z⊗Z) • R (plus , I⊗X) • R (minus , I⊗Z) • R (plus , Z⊗Z) • R (minus , Z⊗Y) • R (minus , Z⊗X) • R (minus , I⊗X) • R (minus , I⊗Z) • R (minus , I⊗X) • R (plus , Z⊗X) • R (plus , I⊗Y) • R (plus , Z⊗Z) • S1 • H1 • CZ • S0 • H1 • W ^ 2 • S1⁻¹ • CZ • X0 • H1 • S1 • S1 • H1 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • H1 • S1⁻¹ • R (plus , Z⊗Z) • R (plus , I⊗X) • R (plus , Z⊗X) • R (plus , Z⊗Y) • R (plus , I⊗X) • R (plus , Z⊗X) • S1 • H1 • CZ • S0 • S0 • S0 • S1 • S1 • W ^ 6 • ε
          by in-context 29 2 auto (tactic-pauli-commute (minus , I⊗Z) (plus , Z⊗Z) auto)
      equals S1 • H1 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • H1 • S1⁻¹ • S1⁻¹ • H1 • X0 • CZ • R (plus , Z⊗Z) • R (plus , I⊗X) • R (plus , Z⊗Z) • R (minus , I⊗Z) • R (minus , Z⊗Y) • R (minus , Z⊗X) • R (minus , I⊗X) • R (minus , I⊗Z) • R (minus , I⊗X) • R (plus , Z⊗X) • R (plus , I⊗Y) • R (plus , Z⊗Z) • S1 • H1 • CZ • S0 • H1 • W ^ 2 • S1⁻¹ • CZ • X0 • H1 • S1 • S1 • H1 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • H1 • S1⁻¹ • R (plus , Z⊗Z) • R (plus , I⊗X) • R (plus , Z⊗X) • R (plus , Z⊗Y) • R (plus , I⊗X) • R (plus , Z⊗X) • S1 • H1 • CZ • S0 • S0 • S0 • S1 • S1 • W ^ 6 • ε
          by in-context 38 7 auto (symm (lemma-R (C.S1 • C.H1 • C.CZ • C.S0 • C.H1 • C.W ^ 2) (plus , I⊗Z)))
      equals S1 • H1 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • H1 • S1⁻¹ • S1⁻¹ • H1 • X0 • CZ • R (plus , Z⊗Z) • R (plus , I⊗X) • R (plus , Z⊗Z) • R (minus , I⊗Z) • R (minus , Z⊗Y) • R (minus , Z⊗X) • R (minus , I⊗X) • R (minus , I⊗Z) • R (minus , I⊗X) • R (plus , Z⊗X) • R (plus , I⊗Y) • S1 • H1 • CZ • S0 • H1 • W ^ 2 • R (plus , I⊗Z) • S1⁻¹ • CZ • X0 • H1 • S1 • S1 • H1 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • H1 • S1⁻¹ • R (plus , Z⊗Z) • R (plus , I⊗X) • R (plus , Z⊗X) • R (plus , Z⊗Y) • R (plus , I⊗X) • R (plus , Z⊗X) • S1 • H1 • CZ • S0 • S0 • S0 • S1 • S1 • W ^ 6 • ε
          by clifford-tactic 42 2 10000 auto
      equals S1 • H1 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • H1 • S1⁻¹ • S1⁻¹ • H1 • X0 • CZ • R (plus , Z⊗Z) • R (plus , I⊗X) • R (plus , Z⊗Z) • R (minus , I⊗Z) • R (minus , Z⊗Y) • R (minus , Z⊗X) • R (minus , I⊗X) • R (minus , I⊗Z) • R (minus , I⊗X) • R (plus , Z⊗X) • R (plus , I⊗Y) • S1 • H1 • CZ • S0 • S1 • W ^ 2 • S1⁻¹ • H1 • R (plus , I⊗Z) • S1⁻¹ • CZ • X0 • H1 • S1 • S1 • H1 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • H1 • S1⁻¹ • R (plus , Z⊗Z) • R (plus , I⊗X) • R (plus , Z⊗X) • R (plus , Z⊗Y) • R (plus , I⊗X) • R (plus , Z⊗X) • S1 • H1 • CZ • S0 • S0 • S0 • S1 • S1 • W ^ 6 • ε
          by in-context 37 7 auto (symm (lemma-R (C.S1 • C.H1 • C.CZ • C.S0 • C.S1 • C.W ^ 2) (plus , I⊗Z)))
      equals S1 • H1 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • H1 • S1⁻¹ • S1⁻¹ • H1 • X0 • CZ • R (plus , Z⊗Z) • R (plus , I⊗X) • R (plus , Z⊗Z) • R (minus , I⊗Z) • R (minus , Z⊗Y) • R (minus , Z⊗X) • R (minus , I⊗X) • R (minus , I⊗Z) • R (minus , I⊗X) • R (plus , Z⊗X) • S1 • H1 • CZ • S0 • S1 • W ^ 2 • R (plus , I⊗Z) • S1⁻¹ • H1 • R (plus , I⊗Z) • S1⁻¹ • CZ • X0 • H1 • S1 • S1 • H1 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • H1 • S1⁻¹ • R (plus , Z⊗Z) • R (plus , I⊗X) • R (plus , Z⊗X) • R (plus , Z⊗Y) • R (plus , I⊗X) • R (plus , Z⊗X) • S1 • H1 • CZ • S0 • S0 • S0 • S1 • S1 • W ^ 6 • ε
          by clifford-tactic 42 1 10000 auto
      equals S1 • H1 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • H1 • S1⁻¹ • S1⁻¹ • H1 • X0 • CZ • R (plus , Z⊗Z) • R (plus , I⊗X) • R (plus , Z⊗Z) • R (minus , I⊗Z) • R (minus , Z⊗Y) • R (minus , Z⊗X) • R (minus , I⊗X) • R (minus , I⊗Z) • R (minus , I⊗X) • R (plus , Z⊗X) • S1 • H1 • CZ • S0 • S1 • H1 • W ^ 2 • H1 • R (plus , I⊗Z) • S1⁻¹ • H1 • R (plus , I⊗Z) • S1⁻¹ • CZ • X0 • H1 • S1 • S1 • H1 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • H1 • S1⁻¹ • R (plus , Z⊗Z) • R (plus , I⊗X) • R (plus , Z⊗X) • R (plus , Z⊗Y) • R (plus , I⊗X) • R (plus , Z⊗X) • S1 • H1 • CZ • S0 • S0 • S0 • S1 • S1 • W ^ 6 • ε
          by in-context 36 8 auto (symm (lemma-R (C.S1 • C.H1 • C.CZ • C.S0 • C.S1 • C.H1 • C.W ^ 2) (plus , I⊗Z)))
      equals S1 • H1 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • H1 • S1⁻¹ • S1⁻¹ • H1 • X0 • CZ • R (plus , Z⊗Z) • R (plus , I⊗X) • R (plus , Z⊗Z) • R (minus , I⊗Z) • R (minus , Z⊗Y) • R (minus , Z⊗X) • R (minus , I⊗X) • R (minus , I⊗Z) • R (minus , I⊗X) • S1 • H1 • CZ • S0 • S1 • H1 • W ^ 2 • R (plus , I⊗Z) • H1 • R (plus , I⊗Z) • S1⁻¹ • H1 • R (plus , I⊗Z) • S1⁻¹ • CZ • X0 • H1 • S1 • S1 • H1 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • H1 • S1⁻¹ • R (plus , Z⊗Z) • R (plus , I⊗X) • R (plus , Z⊗X) • R (plus , Z⊗Y) • R (plus , I⊗X) • R (plus , Z⊗X) • S1 • H1 • CZ • S0 • S0 • S0 • S1 • S1 • W ^ 6 • ε
          by clifford-tactic 36 7 10000 auto
      equals S1 • H1 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • H1 • S1⁻¹ • S1⁻¹ • H1 • X0 • CZ • R (plus , Z⊗Z) • R (plus , I⊗X) • R (plus , Z⊗Z) • R (minus , I⊗Z) • R (minus , Z⊗Y) • R (minus , Z⊗X) • R (minus , I⊗X) • R (minus , I⊗Z) • R (minus , I⊗X) • S0 • S1 • S1 • H1 • S1 • S1 • W • S1⁻¹ • CX1 • X1 • R (plus , I⊗Z) • H1 • R (plus , I⊗Z) • S1⁻¹ • H1 • R (plus , I⊗Z) • S1⁻¹ • CZ • X0 • H1 • S1 • S1 • H1 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • H1 • S1⁻¹ • R (plus , Z⊗Z) • R (plus , I⊗X) • R (plus , Z⊗X) • R (plus , Z⊗Y) • R (plus , I⊗X) • R (plus , Z⊗X) • S1 • H1 • CZ • S0 • S0 • S0 • S1 • S1 • W ^ 6 • ε
          by in-context 35 8 auto (symm (lemma-R (C.S0 • C.S1 • C.S1 • C.H1 • C.S1 • C.S1 • C.W) (plus , I⊗Z)))
      equals S1 • H1 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • H1 • S1⁻¹ • S1⁻¹ • H1 • X0 • CZ • R (plus , Z⊗Z) • R (plus , I⊗X) • R (plus , Z⊗Z) • R (minus , I⊗Z) • R (minus , Z⊗Y) • R (minus , Z⊗X) • R (minus , I⊗X) • R (minus , I⊗Z) • S0 • S1 • S1 • H1 • S1 • S1 • W • R (plus , I⊗Z) • S1⁻¹ • CX1 • X1 • R (plus , I⊗Z) • H1 • R (plus , I⊗Z) • S1⁻¹ • H1 • R (plus , I⊗Z) • S1⁻¹ • CZ • X0 • H1 • S1 • S1 • H1 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • H1 • S1⁻¹ • R (plus , Z⊗Z) • R (plus , I⊗X) • R (plus , Z⊗X) • R (plus , Z⊗Y) • R (plus , I⊗X) • R (plus , Z⊗X) • S1 • H1 • CZ • S0 • S0 • S0 • S1 • S1 • W ^ 6 • ε
          by clifford-tactic 42 0 10000 auto
      equals S1 • H1 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • H1 • S1⁻¹ • S1⁻¹ • H1 • X0 • CZ • R (plus , Z⊗Z) • R (plus , I⊗X) • R (plus , Z⊗Z) • R (minus , I⊗Z) • R (minus , Z⊗Y) • R (minus , Z⊗X) • R (minus , I⊗X) • R (minus , I⊗Z) • S0 • S1 • S1 • H1 • S1 • S1 • W • H1 • H1 • R (plus , I⊗Z) • S1⁻¹ • CX1 • X1 • R (plus , I⊗Z) • H1 • R (plus , I⊗Z) • S1⁻¹ • H1 • R (plus , I⊗Z) • S1⁻¹ • CZ • X0 • H1 • S1 • S1 • H1 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • H1 • S1⁻¹ • R (plus , Z⊗Z) • R (plus , I⊗X) • R (plus , Z⊗X) • R (plus , Z⊗Y) • R (plus , I⊗X) • R (plus , Z⊗X) • S1 • H1 • CZ • S0 • S0 • S0 • S1 • S1 • W ^ 6 • ε
          by in-context 34 9 auto (symm (lemma-R (C.S0 • C.S1 • C.S1 • C.H1 • C.S1 • C.S1 • C.W • C.H1) (plus , I⊗Z)))
      equals S1 • H1 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • H1 • S1⁻¹ • S1⁻¹ • H1 • X0 • CZ • R (plus , Z⊗Z) • R (plus , I⊗X) • R (plus , Z⊗Z) • R (minus , I⊗Z) • R (minus , Z⊗Y) • R (minus , Z⊗X) • R (minus , I⊗X) • S0 • S1 • S1 • H1 • S1 • S1 • W • H1 • R (plus , I⊗Z) • H1 • R (plus , I⊗Z) • S1⁻¹ • CX1 • X1 • R (plus , I⊗Z) • H1 • R (plus , I⊗Z) • S1⁻¹ • H1 • R (plus , I⊗Z) • S1⁻¹ • CZ • X0 • H1 • S1 • S1 • H1 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • H1 • S1⁻¹ • R (plus , Z⊗Z) • R (plus , I⊗X) • R (plus , Z⊗X) • R (plus , Z⊗Y) • R (plus , I⊗X) • R (plus , Z⊗X) • S1 • H1 • CZ • S0 • S0 • S0 • S1 • S1 • W ^ 6 • ε
          by in-context 33 8 auto (symm (lemma-R (C.S0 • C.S1 • C.S1 • C.H1 • C.S1 • C.S1 • C.W) (plus , I⊗Z)))
      equals S1 • H1 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • H1 • S1⁻¹ • S1⁻¹ • H1 • X0 • CZ • R (plus , Z⊗Z) • R (plus , I⊗X) • R (plus , Z⊗Z) • R (minus , I⊗Z) • R (minus , Z⊗Y) • R (minus , Z⊗X) • S0 • S1 • S1 • H1 • S1 • S1 • W • R (plus , I⊗Z) • H1 • R (plus , I⊗Z) • H1 • R (plus , I⊗Z) • S1⁻¹ • CX1 • X1 • R (plus , I⊗Z) • H1 • R (plus , I⊗Z) • S1⁻¹ • H1 • R (plus , I⊗Z) • S1⁻¹ • CZ • X0 • H1 • S1 • S1 • H1 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • H1 • S1⁻¹ • R (plus , Z⊗Z) • R (plus , I⊗X) • R (plus , Z⊗X) • R (plus , Z⊗Y) • R (plus , I⊗X) • R (plus , Z⊗X) • S1 • H1 • CZ • S0 • S0 • S0 • S1 • S1 • W ^ 6 • ε
          by clifford-tactic 33 7 10000 auto
      equals S1 • H1 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • H1 • S1⁻¹ • S1⁻¹ • H1 • X0 • CZ • R (plus , Z⊗Z) • R (plus , I⊗X) • R (plus , Z⊗Z) • R (minus , I⊗Z) • R (minus , Z⊗Y) • R (minus , Z⊗X) • CX1 • H1 • H1 • S1⁻¹ • CX1 • X1 • H1 • S1⁻¹ • H1 • S1⁻¹ • CX1 • R (plus , I⊗Z) • H1 • R (plus , I⊗Z) • H1 • R (plus , I⊗Z) • S1⁻¹ • CX1 • X1 • R (plus , I⊗Z) • H1 • R (plus , I⊗Z) • S1⁻¹ • H1 • R (plus , I⊗Z) • S1⁻¹ • CZ • X0 • H1 • S1 • S1 • H1 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • H1 • S1⁻¹ • R (plus , Z⊗Z) • R (plus , I⊗X) • R (plus , Z⊗X) • R (plus , Z⊗Y) • R (plus , I⊗X) • R (plus , Z⊗X) • S1 • H1 • CZ • S0 • S0 • S0 • S1 • S1 • W ^ 6 • ε
          by in-context 32 10 auto (symm (lemma-R (C.CX1 • C.H1 • C.H1 • C.S1⁻¹ • C.CX1 • C.X1 • C.H1 • C.S1⁻¹ • C.H1) (plus , I⊗Z)))
      equals S1 • H1 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • H1 • S1⁻¹ • S1⁻¹ • H1 • X0 • CZ • R (plus , Z⊗Z) • R (plus , I⊗X) • R (plus , Z⊗Z) • R (minus , I⊗Z) • R (minus , Z⊗Y) • CX1 • H1 • H1 • S1⁻¹ • CX1 • X1 • H1 • S1⁻¹ • H1 • R (plus , I⊗Z) • S1⁻¹ • CX1 • R (plus , I⊗Z) • H1 • R (plus , I⊗Z) • H1 • R (plus , I⊗Z) • S1⁻¹ • CX1 • X1 • R (plus , I⊗Z) • H1 • R (plus , I⊗Z) • S1⁻¹ • H1 • R (plus , I⊗Z) • S1⁻¹ • CZ • X0 • H1 • S1 • S1 • H1 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • H1 • S1⁻¹ • R (plus , Z⊗Z) • R (plus , I⊗X) • R (plus , Z⊗X) • R (plus , Z⊗Y) • R (plus , I⊗X) • R (plus , Z⊗X) • S1 • H1 • CZ • S0 • S0 • S0 • S1 • S1 • W ^ 6 • ε
          by in-context 31 8 auto (symm (lemma-R (C.CX1 • C.H1 • C.H1 • C.S1⁻¹ • C.CX1 • C.X1 • C.H1) (plus , I⊗Z)))
      equals S1 • H1 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • H1 • S1⁻¹ • S1⁻¹ • H1 • X0 • CZ • R (plus , Z⊗Z) • R (plus , I⊗X) • R (plus , Z⊗Z) • R (minus , I⊗Z) • CX1 • H1 • H1 • S1⁻¹ • CX1 • X1 • H1 • R (plus , I⊗Z) • S1⁻¹ • H1 • R (plus , I⊗Z) • S1⁻¹ • CX1 • R (plus , I⊗Z) • H1 • R (plus , I⊗Z) • H1 • R (plus , I⊗Z) • S1⁻¹ • CX1 • X1 • R (plus , I⊗Z) • H1 • R (plus , I⊗Z) • S1⁻¹ • H1 • R (plus , I⊗Z) • S1⁻¹ • CZ • X0 • H1 • S1 • S1 • H1 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • H1 • S1⁻¹ • R (plus , Z⊗Z) • R (plus , I⊗X) • R (plus , Z⊗X) • R (plus , Z⊗Y) • R (plus , I⊗X) • R (plus , Z⊗X) • S1 • H1 • CZ • S0 • S0 • S0 • S1 • S1 • W ^ 6 • ε
          by in-context 30 7 auto (symm (lemma-R (C.CX1 • C.H1 • C.H1 • C.S1⁻¹ • C.CX1 • C.X1) (plus , I⊗Z)))
      equals S1 • H1 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • H1 • S1⁻¹ • S1⁻¹ • H1 • X0 • CZ • R (plus , Z⊗Z) • R (plus , I⊗X) • R (plus , Z⊗Z) • CX1 • H1 • H1 • S1⁻¹ • CX1 • X1 • R (plus , I⊗Z) • H1 • R (plus , I⊗Z) • S1⁻¹ • H1 • R (plus , I⊗Z) • S1⁻¹ • CX1 • R (plus , I⊗Z) • H1 • R (plus , I⊗Z) • H1 • R (plus , I⊗Z) • S1⁻¹ • CX1 • X1 • R (plus , I⊗Z) • H1 • R (plus , I⊗Z) • S1⁻¹ • H1 • R (plus , I⊗Z) • S1⁻¹ • CZ • X0 • H1 • S1 • S1 • H1 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • H1 • S1⁻¹ • R (plus , Z⊗Z) • R (plus , I⊗X) • R (plus , Z⊗X) • R (plus , Z⊗Y) • R (plus , I⊗X) • R (plus , Z⊗X) • S1 • H1 • CZ • S0 • S0 • S0 • S1 • S1 • W ^ 6 • ε
          by in-context 29 4 auto (symm (lemma-R (C.CX1 • C.H1 • C.H1) (plus , I⊗Z)))
      equals S1 • H1 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • H1 • S1⁻¹ • S1⁻¹ • H1 • X0 • CZ • R (plus , Z⊗Z) • R (plus , I⊗X) • CX1 • H1 • H1 • R (plus , I⊗Z) • S1⁻¹ • CX1 • X1 • R (plus , I⊗Z) • H1 • R (plus , I⊗Z) • S1⁻¹ • H1 • R (plus , I⊗Z) • S1⁻¹ • CX1 • R (plus , I⊗Z) • H1 • R (plus , I⊗Z) • H1 • R (plus , I⊗Z) • S1⁻¹ • CX1 • X1 • R (plus , I⊗Z) • H1 • R (plus , I⊗Z) • S1⁻¹ • H1 • R (plus , I⊗Z) • S1⁻¹ • CZ • X0 • H1 • S1 • S1 • H1 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • H1 • S1⁻¹ • R (plus , Z⊗Z) • R (plus , I⊗X) • R (plus , Z⊗X) • R (plus , Z⊗Y) • R (plus , I⊗X) • R (plus , Z⊗X) • S1 • H1 • CZ • S0 • S0 • S0 • S1 • S1 • W ^ 6 • ε
          by in-context 28 3 auto (symm (lemma-R (C.CX1 • C.H1) (plus , I⊗Z)))
      equals S1 • H1 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • H1 • S1⁻¹ • S1⁻¹ • H1 • X0 • CZ • R (plus , Z⊗Z) • CX1 • H1 • R (plus , I⊗Z) • H1 • R (plus , I⊗Z) • S1⁻¹ • CX1 • X1 • R (plus , I⊗Z) • H1 • R (plus , I⊗Z) • S1⁻¹ • H1 • R (plus , I⊗Z) • S1⁻¹ • CX1 • R (plus , I⊗Z) • H1 • R (plus , I⊗Z) • H1 • R (plus , I⊗Z) • S1⁻¹ • CX1 • X1 • R (plus , I⊗Z) • H1 • R (plus , I⊗Z) • S1⁻¹ • H1 • R (plus , I⊗Z) • S1⁻¹ • CZ • X0 • H1 • S1 • S1 • H1 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • H1 • S1⁻¹ • R (plus , Z⊗Z) • R (plus , I⊗X) • R (plus , Z⊗X) • R (plus , Z⊗Y) • R (plus , I⊗X) • R (plus , Z⊗X) • S1 • H1 • CZ • S0 • S0 • S0 • S1 • S1 • W ^ 6 • ε
          by in-context 27 2 auto (symm (lemma-R (C.CX1) (plus , I⊗Z)))
      equals S1 • H1 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • H1 • S1⁻¹ • S1⁻¹ • H1 • X0 • CZ • CX1 • R (plus , I⊗Z) • H1 • R (plus , I⊗Z) • H1 • R (plus , I⊗Z) • S1⁻¹ • CX1 • X1 • R (plus , I⊗Z) • H1 • R (plus , I⊗Z) • S1⁻¹ • H1 • R (plus , I⊗Z) • S1⁻¹ • CX1 • R (plus , I⊗Z) • H1 • R (plus , I⊗Z) • H1 • R (plus , I⊗Z) • S1⁻¹ • CX1 • X1 • R (plus , I⊗Z) • H1 • R (plus , I⊗Z) • S1⁻¹ • H1 • R (plus , I⊗Z) • S1⁻¹ • CZ • X0 • H1 • S1 • S1 • H1 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • H1 • S1⁻¹ • R (plus , Z⊗Z) • R (plus , I⊗X) • R (plus , Z⊗X) • R (plus , Z⊗Y) • R (plus , I⊗X) • R (plus , Z⊗X) • S1 • H1 • CZ • S0 • S0 • S0 • S1 • S1 • W ^ 6 • ε
          by in-context 57 2 auto (symm lemma-R-T1⁻¹)
      equals S1 • H1 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • H1 • S1⁻¹ • S1⁻¹ • H1 • X0 • CZ • CX1 • R (plus , I⊗Z) • H1 • R (plus , I⊗Z) • H1 • R (plus , I⊗Z) • S1⁻¹ • CX1 • X1 • R (plus , I⊗Z) • H1 • R (plus , I⊗Z) • S1⁻¹ • H1 • R (plus , I⊗Z) • S1⁻¹ • CX1 • R (plus , I⊗Z) • H1 • R (plus , I⊗Z) • H1 • R (plus , I⊗Z) • S1⁻¹ • CX1 • X1 • R (plus , I⊗Z) • H1 • R (plus , I⊗Z) • S1⁻¹ • H1 • T1⁻¹ • CZ • X0 • H1 • S1 • S1 • H1 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • H1 • S1⁻¹ • R (plus , Z⊗Z) • R (plus , I⊗X) • R (plus , Z⊗X) • R (plus , Z⊗Y) • R (plus , I⊗X) • R (plus , Z⊗X) • S1 • H1 • CZ • S0 • S0 • S0 • S1 • S1 • W ^ 6 • ε
          by in-context 54 2 auto (symm lemma-R-T1⁻¹)
      equals S1 • H1 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • H1 • S1⁻¹ • S1⁻¹ • H1 • X0 • CZ • CX1 • R (plus , I⊗Z) • H1 • R (plus , I⊗Z) • H1 • R (plus , I⊗Z) • S1⁻¹ • CX1 • X1 • R (plus , I⊗Z) • H1 • R (plus , I⊗Z) • S1⁻¹ • H1 • R (plus , I⊗Z) • S1⁻¹ • CX1 • R (plus , I⊗Z) • H1 • R (plus , I⊗Z) • H1 • R (plus , I⊗Z) • S1⁻¹ • CX1 • X1 • R (plus , I⊗Z) • H1 • T1⁻¹ • H1 • T1⁻¹ • CZ • X0 • H1 • S1 • S1 • H1 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • H1 • S1⁻¹ • R (plus , Z⊗Z) • R (plus , I⊗X) • R (plus , Z⊗X) • R (plus , Z⊗Y) • R (plus , I⊗X) • R (plus , Z⊗X) • S1 • H1 • CZ • S0 • S0 • S0 • S1 • S1 • W ^ 6 • ε
          by in-context 52 1 auto (symm lemma-R-T1)
      equals S1 • H1 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • H1 • S1⁻¹ • S1⁻¹ • H1 • X0 • CZ • CX1 • R (plus , I⊗Z) • H1 • R (plus , I⊗Z) • H1 • R (plus , I⊗Z) • S1⁻¹ • CX1 • X1 • R (plus , I⊗Z) • H1 • R (plus , I⊗Z) • S1⁻¹ • H1 • R (plus , I⊗Z) • S1⁻¹ • CX1 • R (plus , I⊗Z) • H1 • R (plus , I⊗Z) • H1 • R (plus , I⊗Z) • S1⁻¹ • CX1 • X1 • T1 • H1 • T1⁻¹ • H1 • T1⁻¹ • CZ • X0 • H1 • S1 • S1 • H1 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • H1 • S1⁻¹ • R (plus , Z⊗Z) • R (plus , I⊗X) • R (plus , Z⊗X) • R (plus , Z⊗Y) • R (plus , I⊗X) • R (plus , Z⊗X) • S1 • H1 • CZ • S0 • S0 • S0 • S1 • S1 • W ^ 6 • ε
          by in-context 48 2 auto (symm lemma-R-T1⁻¹)
      equals S1 • H1 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • H1 • S1⁻¹ • S1⁻¹ • H1 • X0 • CZ • CX1 • R (plus , I⊗Z) • H1 • R (plus , I⊗Z) • H1 • R (plus , I⊗Z) • S1⁻¹ • CX1 • X1 • R (plus , I⊗Z) • H1 • R (plus , I⊗Z) • S1⁻¹ • H1 • R (plus , I⊗Z) • S1⁻¹ • CX1 • R (plus , I⊗Z) • H1 • R (plus , I⊗Z) • H1 • T1⁻¹ • CX1 • X1 • T1 • H1 • T1⁻¹ • H1 • T1⁻¹ • CZ • X0 • H1 • S1 • S1 • H1 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • H1 • S1⁻¹ • R (plus , Z⊗Z) • R (plus , I⊗X) • R (plus , Z⊗X) • R (plus , Z⊗Y) • R (plus , I⊗X) • R (plus , Z⊗X) • S1 • H1 • CZ • S0 • S0 • S0 • S1 • S1 • W ^ 6 • ε
          by in-context 46 1 auto (symm lemma-R-T1)
      equals S1 • H1 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • H1 • S1⁻¹ • S1⁻¹ • H1 • X0 • CZ • CX1 • R (plus , I⊗Z) • H1 • R (plus , I⊗Z) • H1 • R (plus , I⊗Z) • S1⁻¹ • CX1 • X1 • R (plus , I⊗Z) • H1 • R (plus , I⊗Z) • S1⁻¹ • H1 • R (plus , I⊗Z) • S1⁻¹ • CX1 • R (plus , I⊗Z) • H1 • T1 • H1 • T1⁻¹ • CX1 • X1 • T1 • H1 • T1⁻¹ • H1 • T1⁻¹ • CZ • X0 • H1 • S1 • S1 • H1 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • H1 • S1⁻¹ • R (plus , Z⊗Z) • R (plus , I⊗X) • R (plus , Z⊗X) • R (plus , Z⊗Y) • R (plus , I⊗X) • R (plus , Z⊗X) • S1 • H1 • CZ • S0 • S0 • S0 • S1 • S1 • W ^ 6 • ε
          by in-context 44 1 auto (symm lemma-R-T1)
      equals S1 • H1 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • H1 • S1⁻¹ • S1⁻¹ • H1 • X0 • CZ • CX1 • R (plus , I⊗Z) • H1 • R (plus , I⊗Z) • H1 • R (plus , I⊗Z) • S1⁻¹ • CX1 • X1 • R (plus , I⊗Z) • H1 • R (plus , I⊗Z) • S1⁻¹ • H1 • R (plus , I⊗Z) • S1⁻¹ • CX1 • T1 • H1 • T1 • H1 • T1⁻¹ • CX1 • X1 • T1 • H1 • T1⁻¹ • H1 • T1⁻¹ • CZ • X0 • H1 • S1 • S1 • H1 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • H1 • S1⁻¹ • R (plus , Z⊗Z) • R (plus , I⊗X) • R (plus , Z⊗X) • R (plus , Z⊗Y) • R (plus , I⊗X) • R (plus , Z⊗X) • S1 • H1 • CZ • S0 • S0 • S0 • S1 • S1 • W ^ 6 • ε
          by in-context 41 2 auto (symm lemma-R-T1⁻¹)
      equals S1 • H1 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • H1 • S1⁻¹ • S1⁻¹ • H1 • X0 • CZ • CX1 • R (plus , I⊗Z) • H1 • R (plus , I⊗Z) • H1 • R (plus , I⊗Z) • S1⁻¹ • CX1 • X1 • R (plus , I⊗Z) • H1 • R (plus , I⊗Z) • S1⁻¹ • H1 • T1⁻¹ • CX1 • T1 • H1 • T1 • H1 • T1⁻¹ • CX1 • X1 • T1 • H1 • T1⁻¹ • H1 • T1⁻¹ • CZ • X0 • H1 • S1 • S1 • H1 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • H1 • S1⁻¹ • R (plus , Z⊗Z) • R (plus , I⊗X) • R (plus , Z⊗X) • R (plus , Z⊗Y) • R (plus , I⊗X) • R (plus , Z⊗X) • S1 • H1 • CZ • S0 • S0 • S0 • S1 • S1 • W ^ 6 • ε
          by in-context 38 2 auto (symm lemma-R-T1⁻¹)
      equals S1 • H1 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • H1 • S1⁻¹ • S1⁻¹ • H1 • X0 • CZ • CX1 • R (plus , I⊗Z) • H1 • R (plus , I⊗Z) • H1 • R (plus , I⊗Z) • S1⁻¹ • CX1 • X1 • R (plus , I⊗Z) • H1 • T1⁻¹ • H1 • T1⁻¹ • CX1 • T1 • H1 • T1 • H1 • T1⁻¹ • CX1 • X1 • T1 • H1 • T1⁻¹ • H1 • T1⁻¹ • CZ • X0 • H1 • S1 • S1 • H1 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • H1 • S1⁻¹ • R (plus , Z⊗Z) • R (plus , I⊗X) • R (plus , Z⊗X) • R (plus , Z⊗Y) • R (plus , I⊗X) • R (plus , Z⊗X) • S1 • H1 • CZ • S0 • S0 • S0 • S1 • S1 • W ^ 6 • ε
          by in-context 36 1 auto (symm lemma-R-T1)
      equals S1 • H1 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • H1 • S1⁻¹ • S1⁻¹ • H1 • X0 • CZ • CX1 • R (plus , I⊗Z) • H1 • R (plus , I⊗Z) • H1 • R (plus , I⊗Z) • S1⁻¹ • CX1 • X1 • T1 • H1 • T1⁻¹ • H1 • T1⁻¹ • CX1 • T1 • H1 • T1 • H1 • T1⁻¹ • CX1 • X1 • T1 • H1 • T1⁻¹ • H1 • T1⁻¹ • CZ • X0 • H1 • S1 • S1 • H1 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • H1 • S1⁻¹ • R (plus , Z⊗Z) • R (plus , I⊗X) • R (plus , Z⊗X) • R (plus , Z⊗Y) • R (plus , I⊗X) • R (plus , Z⊗X) • S1 • H1 • CZ • S0 • S0 • S0 • S1 • S1 • W ^ 6 • ε
          by in-context 32 2 auto (symm lemma-R-T1⁻¹)
      equals S1 • H1 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • H1 • S1⁻¹ • S1⁻¹ • H1 • X0 • CZ • CX1 • R (plus , I⊗Z) • H1 • R (plus , I⊗Z) • H1 • T1⁻¹ • CX1 • X1 • T1 • H1 • T1⁻¹ • H1 • T1⁻¹ • CX1 • T1 • H1 • T1 • H1 • T1⁻¹ • CX1 • X1 • T1 • H1 • T1⁻¹ • H1 • T1⁻¹ • CZ • X0 • H1 • S1 • S1 • H1 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • H1 • S1⁻¹ • R (plus , Z⊗Z) • R (plus , I⊗X) • R (plus , Z⊗X) • R (plus , Z⊗Y) • R (plus , I⊗X) • R (plus , Z⊗X) • S1 • H1 • CZ • S0 • S0 • S0 • S1 • S1 • W ^ 6 • ε
          by in-context 30 1 auto (symm lemma-R-T1)
      equals S1 • H1 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • H1 • S1⁻¹ • S1⁻¹ • H1 • X0 • CZ • CX1 • R (plus , I⊗Z) • H1 • T1 • H1 • T1⁻¹ • CX1 • X1 • T1 • H1 • T1⁻¹ • H1 • T1⁻¹ • CX1 • T1 • H1 • T1 • H1 • T1⁻¹ • CX1 • X1 • T1 • H1 • T1⁻¹ • H1 • T1⁻¹ • CZ • X0 • H1 • S1 • S1 • H1 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • H1 • S1⁻¹ • R (plus , Z⊗Z) • R (plus , I⊗X) • R (plus , Z⊗X) • R (plus , Z⊗Y) • R (plus , I⊗X) • R (plus , Z⊗X) • S1 • H1 • CZ • S0 • S0 • S0 • S1 • S1 • W ^ 6 • ε
          by in-context 28 1 auto (symm lemma-R-T1)
      equals S1 • H1 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • H1 • S1⁻¹ • S1⁻¹ • H1 • X0 • CZ • CX1 • T1 • H1 • T1 • H1 • T1⁻¹ • CX1 • X1 • T1 • H1 • T1⁻¹ • H1 • T1⁻¹ • CX1 • T1 • H1 • T1 • H1 • T1⁻¹ • CX1 • X1 • T1 • H1 • T1⁻¹ • H1 • T1⁻¹ • CZ • X0 • H1 • S1 • S1 • H1 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • H1 • S1⁻¹ • R (plus , Z⊗Z) • R (plus , I⊗X) • R (plus , Z⊗X) • R (plus , Z⊗Y) • R (plus , I⊗X) • R (plus , Z⊗X) • S1 • H1 • CZ • S0 • S0 • S0 • S1 • S1 • W ^ 6 • ε
          by in-context 27 26 auto lemma-rel-B
      equals S1 • H1 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • H1 • S1⁻¹ • S1⁻¹ • H1 • X0 • CZ • CZ • X0 • H1 • S1 • S1 • H1 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • H1 • S1⁻¹ • R (plus , Z⊗Z) • R (plus , I⊗X) • R (plus , Z⊗X) • R (plus , Z⊗Y) • R (plus , I⊗X) • R (plus , Z⊗X) • S1 • H1 • CZ • S0 • S0 • S0 • S1 • S1 • W ^ 6 • ε
          by clifford-tactic 12 30 10000 auto
      equals S1 • H1 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0 • T0⁻¹ • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • H1 • S1⁻¹ • R (plus , Z⊗Z) • R (plus , I⊗X) • R (plus , Z⊗X) • R (plus , Z⊗Y) • R (plus , I⊗X) • R (plus , Z⊗X) • S1 • H1 • CZ • S0 • S0 • S0 • S1 • S1 • W ^ 6 • ε
          by general-assoc auto
      equals S1 • H1 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0 • T0 • T0 • T0 • T0 • T0 • T0 • T0 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • H1 • S1⁻¹ • R (plus , Z⊗Z) • R (plus , I⊗X) • R (plus , Z⊗X) • R (plus , Z⊗Y) • R (plus , I⊗X) • R (plus , Z⊗X) • S1 • H1 • CZ • S0 • S0 • S0 • S1 • S1 • W ^ 6 • ε
          by in-context 11 8 auto lemma-order-T0
      equals S1 • H1 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • H1 • S1⁻¹ • R (plus , Z⊗Z) • R (plus , I⊗X) • R (plus , Z⊗X) • R (plus , Z⊗Y) • R (plus , I⊗X) • R (plus , Z⊗X) • S1 • H1 • CZ • S0 • S0 • S0 • S1 • S1 • W ^ 6 • ε
          by clifford-tactic 0 22 10000 auto
      equals R (plus , Z⊗Z) • R (plus , I⊗X) • R (plus , Z⊗X) • R (plus , Z⊗Y) • R (plus , I⊗X) • R (plus , Z⊗X) • S1 • H1 • CZ • S0 • S0 • S0 • S1 • S1 • W ^ 6 • ε
          by clifford-tactic 6 8 10000 auto
      equals R (plus , Z⊗Z) • R (plus , I⊗X) • R (plus , Z⊗X) • R (plus , Z⊗Y) • R (plus , I⊗X) • R (plus , Z⊗X) • H1 • H0 • CZ • H0 • S0⁻¹ • W • H0 • CZ • H0 • H1 • S0 • S1 • H1 • CZ • S0 • S0 • H1 • W ^ 6 • ε
          by in-context 5 11 auto (symm (lemma-correction Z⊗X))
      equals R (plus , Z⊗Z) • R (plus , I⊗X) • R (plus , Z⊗X) • R (plus , Z⊗Y) • R (plus , I⊗X) • R (minus , Z⊗X) • S0 • S1 • H1 • CZ • S0 • S0 • H1 • W ^ 6 • ε
          by in-context 5 2 auto (symm (lemma-R (C.S0) (minus , Z⊗X)))
      equals R (plus , Z⊗Z) • R (plus , I⊗X) • R (plus , Z⊗X) • R (plus , Z⊗Y) • R (plus , I⊗X) • S0 • R (minus , Z⊗X) • S1 • H1 • CZ • S0 • S0 • H1 • W ^ 6 • ε
          by in-context 4 2 auto (symm (lemma-R (C.S0) (plus , I⊗X)))
      equals R (plus , Z⊗Z) • R (plus , I⊗X) • R (plus , Z⊗X) • R (plus , Z⊗Y) • S0 • R (plus , I⊗X) • R (minus , Z⊗X) • S1 • H1 • CZ • S0 • S0 • H1 • W ^ 6 • ε
          by in-context 3 2 auto (symm (lemma-R (C.S0) (plus , Z⊗Y)))
      equals R (plus , Z⊗Z) • R (plus , I⊗X) • R (plus , Z⊗X) • S0 • R (plus , Z⊗Y) • R (plus , I⊗X) • R (minus , Z⊗X) • S1 • H1 • CZ • S0 • S0 • H1 • W ^ 6 • ε
          by in-context 2 2 auto (symm (lemma-R (C.S0) (plus , Z⊗X)))
      equals R (plus , Z⊗Z) • R (plus , I⊗X) • S0 • R (plus , Z⊗X) • R (plus , Z⊗Y) • R (plus , I⊗X) • R (minus , Z⊗X) • S1 • H1 • CZ • S0 • S0 • H1 • W ^ 6 • ε
          by in-context 1 2 auto (symm (lemma-R (C.S0) (plus , I⊗X)))
      equals R (plus , Z⊗Z) • S0 • R (plus , I⊗X) • R (plus , Z⊗X) • R (plus , Z⊗Y) • R (plus , I⊗X) • R (minus , Z⊗X) • S1 • H1 • CZ • S0 • S0 • H1 • W ^ 6 • ε
          by in-context 0 2 auto (symm (lemma-R (C.S0) (plus , Z⊗Z)))
      equals S0 • R (plus , Z⊗Z) • R (plus , I⊗X) • R (plus , Z⊗X) • R (plus , Z⊗Y) • R (plus , I⊗X) • R (minus , Z⊗X) • S1 • H1 • CZ • S0 • S0 • H1 • W ^ 6 • ε
          by in-context 0 1 auto (symm (lemma-combine plus plus Z⊗I))
      equals R (plus , Z⊗I) • R (plus , Z⊗I) • R (plus , Z⊗Z) • R (plus , I⊗X) • R (plus , Z⊗X) • R (plus , Z⊗Y) • R (plus , I⊗X) • R (minus , Z⊗X) • S1 • H1 • CZ • S0 • S0 • H1 • W ^ 6 • ε
          by in-context 3 2 auto (tactic-pauli-commute (plus , I⊗X) (plus , Z⊗X) auto)
      equals R (plus , Z⊗I) • R (plus , Z⊗I) • R (plus , Z⊗Z) • R (plus , Z⊗X) • R (plus , I⊗X) • R (plus , Z⊗Y) • R (plus , I⊗X) • R (minus , Z⊗X) • S1 • H1 • CZ • S0 • S0 • H1 • W ^ 6 • ε
          by in-context 1 2 auto (tactic-pauli-commute (plus , Z⊗I) (plus , Z⊗Z) auto)
      equals R (plus , Z⊗I) • R (plus , Z⊗Z) • R (plus , Z⊗I) • R (plus , Z⊗X) • R (plus , I⊗X) • R (plus , Z⊗Y) • R (plus , I⊗X) • R (minus , Z⊗X) • S1 • H1 • CZ • S0 • S0 • H1 • W ^ 6 • ε
          by in-context 2 2 auto (tactic-pauli-commute (plus , Z⊗I) (plus , Z⊗X) auto)
      equals R (plus , Z⊗I) • R (plus , Z⊗Z) • R (plus , Z⊗X) • R (plus , Z⊗I) • R (plus , I⊗X) • R (plus , Z⊗Y) • R (plus , I⊗X) • R (minus , Z⊗X) • S1 • H1 • CZ • S0 • S0 • H1 • W ^ 6 • ε
          by in-context 3 2 auto (tactic-pauli-commute (plus , Z⊗I) (plus , I⊗X) auto)
      equals R (plus , Z⊗I) • R (plus , Z⊗Z) • R (plus , Z⊗X) • R (plus , I⊗X) • R (plus , Z⊗I) • R (plus , Z⊗Y) • R (plus , I⊗X) • R (minus , Z⊗X) • S1 • H1 • CZ • S0 • S0 • H1 • W ^ 6 • ε
          by in-context 4 2 auto (tactic-pauli-commute (plus , Z⊗I) (plus , Z⊗Y) auto)
      equals R (plus , Z⊗I) • R (plus , Z⊗Z) • R (plus , Z⊗X) • R (plus , I⊗X) • R (plus , Z⊗Y) • R (plus , Z⊗I) • R (plus , I⊗X) • R (minus , Z⊗X) • S1 • H1 • CZ • S0 • S0 • H1 • W ^ 6 • ε
          by clifford-tactic 8 7 10000 auto
      equals R (plus , Z⊗I) • R (plus , Z⊗Z) • R (plus , Z⊗X) • R (plus , I⊗X) • R (plus , Z⊗Y) • R (plus , Z⊗I) • R (plus , I⊗X) • R (minus , Z⊗X) • S0 • S0 • H0 • S0 • S0 • H0 • H1 • S1 • S1 • S1 • CX1 • S1⁻¹ • H1 • S1⁻¹ • X0 • ε
          by in-context 7 12 auto (symm (lemma-R (C.S0 • C.S0 • C.H0 • C.S0 • C.S0 • C.H0 • C.H1 • C.S1 • C.S1 • C.S1 • C.CX1) (plus , I⊗Z)))
      equals R (plus , Z⊗I) • R (plus , Z⊗Z) • R (plus , Z⊗X) • R (plus , I⊗X) • R (plus , Z⊗Y) • R (plus , Z⊗I) • R (plus , I⊗X) • S0 • S0 • H0 • S0 • S0 • H0 • H1 • S1 • S1 • S1 • CX1 • R (plus , I⊗Z) • S1⁻¹ • H1 • S1⁻¹ • X0 • ε
          by in-context 6 11 auto (symm (lemma-R (C.S0 • C.S0 • C.H0 • C.S0 • C.S0 • C.H0 • C.H1 • C.S1 • C.S1 • C.S1) (plus , I⊗Z)))
      equals R (plus , Z⊗I) • R (plus , Z⊗Z) • R (plus , Z⊗X) • R (plus , I⊗X) • R (plus , Z⊗Y) • R (plus , Z⊗I) • S0 • S0 • H0 • S0 • S0 • H0 • H1 • S1 • S1 • S1 • R (plus , I⊗Z) • CX1 • R (plus , I⊗Z) • S1⁻¹ • H1 • S1⁻¹ • X0 • ε
          by clifford-tactic 8 8 10000 auto
      equals R (plus , Z⊗I) • R (plus , Z⊗Z) • R (plus , Z⊗X) • R (plus , I⊗X) • R (plus , Z⊗Y) • R (plus , Z⊗I) • S0 • S0 • S0 • S1 • H1 • W⁻¹ • Swap • S1⁻¹ • Swap • X0 • S1 • H1 • R (plus , I⊗Z) • CX1 • R (plus , I⊗Z) • S1⁻¹ • H1 • S1⁻¹ • X0 • ε
          by in-context 5 8 auto (symm (lemma-R (C.S0 • C.S0 • C.S0 • C.S1 • C.H1 • C.W⁻¹ • C.Swap) (plus , I⊗Z)))
      equals R (plus , Z⊗I) • R (plus , Z⊗Z) • R (plus , Z⊗X) • R (plus , I⊗X) • R (plus , Z⊗Y) • S0 • S0 • S0 • S1 • H1 • W⁻¹ • Swap • R (plus , I⊗Z) • S1⁻¹ • Swap • X0 • S1 • H1 • R (plus , I⊗Z) • CX1 • R (plus , I⊗Z) • S1⁻¹ • H1 • S1⁻¹ • X0 • ε
          by clifford-tactic 8 4 10000 auto
      equals R (plus , Z⊗I) • R (plus , Z⊗Z) • R (plus , Z⊗X) • R (plus , I⊗X) • R (plus , Z⊗Y) • S0 • S0 • S0 • H1 • S1⁻¹ • H1 • S1⁻¹ • X0 • Swap • X1 • CX1 • CX1 • R (plus , I⊗Z) • S1⁻¹ • Swap • X0 • S1 • H1 • R (plus , I⊗Z) • CX1 • R (plus , I⊗Z) • S1⁻¹ • H1 • S1⁻¹ • X0 • ε
          by in-context 4 12 auto (symm (lemma-R (C.S0 • C.S0 • C.S0 • C.H1 • C.S1⁻¹ • C.H1 • C.S1⁻¹ • C.X0 • C.Swap • C.X1 • C.CX1) (plus , I⊗Z)))
      equals R (plus , Z⊗I) • R (plus , Z⊗Z) • R (plus , Z⊗X) • R (plus , I⊗X) • S0 • S0 • S0 • H1 • S1⁻¹ • H1 • S1⁻¹ • X0 • Swap • X1 • CX1 • R (plus , I⊗Z) • CX1 • R (plus , I⊗Z) • S1⁻¹ • Swap • X0 • S1 • H1 • R (plus , I⊗Z) • CX1 • R (plus , I⊗Z) • S1⁻¹ • H1 • S1⁻¹ • X0 • ε
          by in-context 3 5 auto (symm (lemma-R (C.S0 • C.S0 • C.S0 • C.H1) (plus , I⊗Z)))
      equals R (plus , Z⊗I) • R (plus , Z⊗Z) • R (plus , Z⊗X) • S0 • S0 • S0 • H1 • R (plus , I⊗Z) • S1⁻¹ • H1 • S1⁻¹ • X0 • Swap • X1 • CX1 • R (plus , I⊗Z) • CX1 • R (plus , I⊗Z) • S1⁻¹ • Swap • X0 • S1 • H1 • R (plus , I⊗Z) • CX1 • R (plus , I⊗Z) • S1⁻¹ • H1 • S1⁻¹ • X0 • ε
          by clifford-tactic 3 4 10000 auto
      equals R (plus , Z⊗I) • R (plus , Z⊗Z) • R (plus , Z⊗X) • CZ • S0 • S0 • S0 • H1 • CX1 • R (plus , I⊗Z) • S1⁻¹ • H1 • S1⁻¹ • X0 • Swap • X1 • CX1 • R (plus , I⊗Z) • CX1 • R (plus , I⊗Z) • S1⁻¹ • Swap • X0 • S1 • H1 • R (plus , I⊗Z) • CX1 • R (plus , I⊗Z) • S1⁻¹ • H1 • S1⁻¹ • X0 • ε
          by in-context 2 6 auto (symm (lemma-R (C.CZ • C.S0 • C.S0 • C.S0 • C.H1) (plus , I⊗Z)))
      equals R (plus , Z⊗I) • R (plus , Z⊗Z) • CZ • S0 • S0 • S0 • H1 • R (plus , I⊗Z) • CX1 • R (plus , I⊗Z) • S1⁻¹ • H1 • S1⁻¹ • X0 • Swap • X1 • CX1 • R (plus , I⊗Z) • CX1 • R (plus , I⊗Z) • S1⁻¹ • Swap • X0 • S1 • H1 • R (plus , I⊗Z) • CX1 • R (plus , I⊗Z) • S1⁻¹ • H1 • S1⁻¹ • X0 • ε
          by clifford-tactic 2 4 10000 auto
      equals R (plus , Z⊗I) • R (plus , Z⊗Z) • Swap • CX1 • S1⁻¹ • X1 • CX1 • Swap • X0 • S1 • H1 • R (plus , I⊗Z) • CX1 • R (plus , I⊗Z) • S1⁻¹ • H1 • S1⁻¹ • X0 • Swap • X1 • CX1 • R (plus , I⊗Z) • CX1 • R (plus , I⊗Z) • S1⁻¹ • Swap • X0 • S1 • H1 • R (plus , I⊗Z) • CX1 • R (plus , I⊗Z) • S1⁻¹ • H1 • S1⁻¹ • X0 • ε
          by in-context 1 3 auto (symm (lemma-R (C.Swap • C.CX1) (plus , I⊗Z)))
      equals R (plus , Z⊗I) • Swap • CX1 • R (plus , I⊗Z) • S1⁻¹ • X1 • CX1 • Swap • X0 • S1 • H1 • R (plus , I⊗Z) • CX1 • R (plus , I⊗Z) • S1⁻¹ • H1 • S1⁻¹ • X0 • Swap • X1 • CX1 • R (plus , I⊗Z) • CX1 • R (plus , I⊗Z) • S1⁻¹ • Swap • X0 • S1 • H1 • R (plus , I⊗Z) • CX1 • R (plus , I⊗Z) • S1⁻¹ • H1 • S1⁻¹ • X0 • ε
          by in-context 0 2 auto (symm (lemma-R (C.Swap) (plus , I⊗Z)))
      equals Swap • R (plus , I⊗Z) • CX1 • R (plus , I⊗Z) • S1⁻¹ • X1 • CX1 • Swap • X0 • S1 • H1 • R (plus , I⊗Z) • CX1 • R (plus , I⊗Z) • S1⁻¹ • H1 • S1⁻¹ • X0 • Swap • X1 • CX1 • R (plus , I⊗Z) • CX1 • R (plus , I⊗Z) • S1⁻¹ • Swap • X0 • S1 • H1 • R (plus , I⊗Z) • CX1 • R (plus , I⊗Z) • S1⁻¹ • H1 • S1⁻¹ • X0 • ε
          by in-context 31 2 auto (symm lemma-R-T1⁻¹)
      equals Swap • R (plus , I⊗Z) • CX1 • R (plus , I⊗Z) • S1⁻¹ • X1 • CX1 • Swap • X0 • S1 • H1 • R (plus , I⊗Z) • CX1 • R (plus , I⊗Z) • S1⁻¹ • H1 • S1⁻¹ • X0 • Swap • X1 • CX1 • R (plus , I⊗Z) • CX1 • R (plus , I⊗Z) • S1⁻¹ • Swap • X0 • S1 • H1 • R (plus , I⊗Z) • CX1 • T1⁻¹ • H1 • S1⁻¹ • X0 • ε
          by in-context 29 1 auto (symm lemma-R-T1)
      equals Swap • R (plus , I⊗Z) • CX1 • R (plus , I⊗Z) • S1⁻¹ • X1 • CX1 • Swap • X0 • S1 • H1 • R (plus , I⊗Z) • CX1 • R (plus , I⊗Z) • S1⁻¹ • H1 • S1⁻¹ • X0 • Swap • X1 • CX1 • R (plus , I⊗Z) • CX1 • R (plus , I⊗Z) • S1⁻¹ • Swap • X0 • S1 • H1 • T1 • CX1 • T1⁻¹ • H1 • S1⁻¹ • X0 • ε
          by general-assoc auto
      equals Swap • R (plus , I⊗Z) • CX1 • R (plus , I⊗Z) • S1⁻¹ • X1 • CX1 • Swap • X0 • S1 • H1 • R (plus , I⊗Z) • CX1 • R (plus , I⊗Z) • S1⁻¹ • H1 • S1⁻¹ • X0 • Swap • X1 • CX1 • R (plus , I⊗Z) • CX1 • R (plus , I⊗Z) • S1⁻¹ • Swap • X0 • CH1 • X0 • ε
          by in-context 23 2 auto (symm lemma-R-T1⁻¹)
      equals Swap • R (plus , I⊗Z) • CX1 • R (plus , I⊗Z) • S1⁻¹ • X1 • CX1 • Swap • X0 • S1 • H1 • R (plus , I⊗Z) • CX1 • R (plus , I⊗Z) • S1⁻¹ • H1 • S1⁻¹ • X0 • Swap • X1 • CX1 • R (plus , I⊗Z) • CX1 • T1⁻¹ • Swap • X0 • CH1 • X0 • ε
          by in-context 21 1 auto (symm lemma-R-T1)
      equals Swap • R (plus , I⊗Z) • CX1 • R (plus , I⊗Z) • S1⁻¹ • X1 • CX1 • Swap • X0 • S1 • H1 • R (plus , I⊗Z) • CX1 • R (plus , I⊗Z) • S1⁻¹ • H1 • S1⁻¹ • X0 • Swap • X1 • CX1 • T1 • CX1 • T1⁻¹ • Swap • X0 • CH1 • X0 • ε
          by in-context 13 2 auto (symm lemma-R-T1⁻¹)
      equals Swap • R (plus , I⊗Z) • CX1 • R (plus , I⊗Z) • S1⁻¹ • X1 • CX1 • Swap • X0 • S1 • H1 • R (plus , I⊗Z) • CX1 • T1⁻¹ • H1 • S1⁻¹ • X0 • Swap • X1 • CX1 • T1 • CX1 • T1⁻¹ • Swap • X0 • CH1 • X0 • ε
          by in-context 11 1 auto (symm lemma-R-T1)
      equals Swap • R (plus , I⊗Z) • CX1 • R (plus , I⊗Z) • S1⁻¹ • X1 • CX1 • Swap • X0 • S1 • H1 • T1 • CX1 • T1⁻¹ • H1 • S1⁻¹ • X0 • Swap • X1 • CX1 • T1 • CX1 • T1⁻¹ • Swap • X0 • CH1 • X0 • ε
          by general-assoc auto
      equals Swap • R (plus , I⊗Z) • CX1 • R (plus , I⊗Z) • S1⁻¹ • X1 • CX1 • Swap • X0 • CH1 • X0 • Swap • X1 • CX1 • T1 • CX1 • T1⁻¹ • Swap • X0 • CH1 • X0 • ε
          by in-context 3 2 auto (symm lemma-R-T1⁻¹)
      equals Swap • R (plus , I⊗Z) • CX1 • T1⁻¹ • X1 • CX1 • Swap • X0 • CH1 • X0 • Swap • X1 • CX1 • T1 • CX1 • T1⁻¹ • Swap • X0 • CH1 • X0 • ε
          by in-context 1 1 auto (symm lemma-R-T1)
      equals Swap • T1 • CX1 • T1⁻¹ • X1 • CX1 • Swap • X0 • CH1 • X0 • Swap • X1 • CX1 • T1 • CX1 • T1⁻¹ • Swap • X0 • CH1 • X0 • ε


