-- The proof of Equation 44.

import Proposition
import Equality

import Word
import Generator
import Word-Lemmas
import Word-Tactics
import Clifford-Lemmas
import CliffordT-Lemmas
import PauliRotations

open Proposition
open Equality using (auto)

open Word
open Generator
open Generator.Clifford+T
open Word-Lemmas.Monoid-Equational
open Word-Tactics.InContext
open Word-Tactics.Associative
open Clifford-Lemmas.Clifford-Rewriting
open CliffordT-Lemmas
open PauliRotations.Pauli
open PauliRotations.PauliRotRep
open PauliRotations.Commutativity
open PauliRotations.Combine
open PauliRotations.Correction

private module C = PauliRotations.Clifford

eqn44 : Clifford+T.Rel ⊢ X0 • CH1 • X0 • X0 • CX0 • T0 • CX0 • X0 • T0⁻¹ • T1⁻¹ • W • X0 • CH1 • X0 • ε === X0 • CX0 • T0 • CX0 • X0 • T0⁻¹ • T1⁻¹ • W • X0 • CX0 • T0 • CX0 • X0 • T0⁻¹ • T1⁻¹ • W • X0 • CX0 • T0 • CX0 • X0 • T0⁻¹ • T1⁻¹ • W • X0 • CH1 • X0 • X0 • CX0 • T0 • CX0 • X0 • T0⁻¹ • T1⁻¹ • W • X0 • CX0 • T0 • CX0 • X0 • X1 • CX1 • T0⁻¹ • T1⁻¹ • W • X1 • CX1 • X1 • CX1 • X0 • CX0 • T0 • CX0 • X0 • X1 • CX1 • X1 • CX1 • T0⁻¹ • T1⁻¹ • W • X1 • CX1 • X1 • CX1 • X0 • CX0 • T0 • CX0 • X0 • X1 • CX1 • X1 • CX1 • T0⁻¹ • T1⁻¹ • W • X1 • CX1 • ε
eqn44 = 
  equational X0 • CH1 • X0 • X0 • CX0 • T0 • CX0 • X0 • T0⁻¹ • T1⁻¹ • W • X0 • CH1 • X0 • ε
          by general-assoc auto
      equals X0 • S1 • H1 • T1 • CX1 • T1⁻¹ • H1 • S1⁻¹ • X0 • X0 • CX0 • T0 • CX0 • X0 • T0⁻¹ • T1⁻¹ • W • X0 • CH1 • X0 • ε
          by in-context 3 1 auto lemma-R-T1
      equals X0 • S1 • H1 • R (plus , I⊗Z) • CX1 • T1⁻¹ • H1 • S1⁻¹ • X0 • X0 • CX0 • T0 • CX0 • X0 • T0⁻¹ • T1⁻¹ • W • X0 • CH1 • X0 • ε
          by in-context 5 1 auto lemma-R-T1⁻¹
      equals X0 • S1 • H1 • R (plus , I⊗Z) • CX1 • R (plus , I⊗Z) • S1⁻¹ • H1 • S1⁻¹ • X0 • X0 • CX0 • T0 • CX0 • X0 • T0⁻¹ • T1⁻¹ • W • X0 • CH1 • X0 • ε
          by general-assoc auto
      equals X0 • S1 • H1 • R (plus , I⊗Z) • CX1 • R (plus , I⊗Z) • S1⁻¹ • H1 • S1⁻¹ • X0 • X0 • CX0 • R (plus , Z⊗I) • CX0 • X0 • T0⁻¹ • T1⁻¹ • W • X0 • CH1 • X0 • ε
          by in-context 15 1 auto lemma-R-T0⁻¹
      equals X0 • S1 • H1 • R (plus , I⊗Z) • CX1 • R (plus , I⊗Z) • S1⁻¹ • H1 • S1⁻¹ • X0 • X0 • CX0 • R (plus , Z⊗I) • CX0 • X0 • R (plus , Z⊗I) • S0⁻¹ • T1⁻¹ • W • X0 • CH1 • X0 • ε
          by in-context 17 1 auto lemma-R-T1⁻¹
      equals X0 • S1 • H1 • R (plus , I⊗Z) • CX1 • R (plus , I⊗Z) • S1⁻¹ • H1 • S1⁻¹ • X0 • X0 • CX0 • R (plus , Z⊗I) • CX0 • X0 • R (plus , Z⊗I) • S0⁻¹ • R (plus , I⊗Z) • S1⁻¹ • W • X0 • CH1 • X0 • ε
          by general-assoc auto
      equals X0 • S1 • H1 • R (plus , I⊗Z) • CX1 • R (plus , I⊗Z) • S1⁻¹ • H1 • S1⁻¹ • X0 • X0 • CX0 • R (plus , Z⊗I) • CX0 • X0 • R (plus , Z⊗I) • S0⁻¹ • R (plus , I⊗Z) • S1⁻¹ • W • X0 • S1 • H1 • T1 • CX1 • T1⁻¹ • H1 • S1⁻¹ • X0 • ε
          by in-context 23 1 auto lemma-R-T1
      equals X0 • S1 • H1 • R (plus , I⊗Z) • CX1 • R (plus , I⊗Z) • S1⁻¹ • H1 • S1⁻¹ • X0 • X0 • CX0 • R (plus , Z⊗I) • CX0 • X0 • R (plus , Z⊗I) • S0⁻¹ • R (plus , I⊗Z) • S1⁻¹ • W • X0 • S1 • H1 • R (plus , I⊗Z) • CX1 • T1⁻¹ • H1 • S1⁻¹ • X0 • ε
          by in-context 25 1 auto lemma-R-T1⁻¹
      equals X0 • S1 • H1 • R (plus , I⊗Z) • CX1 • R (plus , I⊗Z) • S1⁻¹ • H1 • S1⁻¹ • X0 • X0 • CX0 • R (plus , Z⊗I) • CX0 • X0 • R (plus , Z⊗I) • S0⁻¹ • R (plus , I⊗Z) • S1⁻¹ • W • X0 • S1 • H1 • R (plus , I⊗Z) • CX1 • R (plus , I⊗Z) • S1⁻¹ • H1 • S1⁻¹ • X0 • ε
          by in-context 0 4 auto (lemma-R (C.X0 • C.S1 • C.H1) (plus , I⊗Z))
      equals R (plus , I⊗Y) • X0 • S1 • H1 • CX1 • R (plus , I⊗Z) • S1⁻¹ • H1 • S1⁻¹ • X0 • X0 • CX0 • R (plus , Z⊗I) • CX0 • X0 • R (plus , Z⊗I) • S0⁻¹ • R (plus , I⊗Z) • S1⁻¹ • W • X0 • S1 • H1 • R (plus , I⊗Z) • CX1 • R (plus , I⊗Z) • S1⁻¹ • H1 • S1⁻¹ • X0 • ε
          by in-context 1 5 auto (lemma-R (C.X0 • C.S1 • C.H1 • C.CX1) (plus , I⊗Z))
      equals R (plus , I⊗Y) • R (minus , Z⊗Y) • X0 • S1 • H1 • CX1 • S1⁻¹ • H1 • S1⁻¹ • X0 • X0 • CX0 • R (plus , Z⊗I) • CX0 • X0 • R (plus , Z⊗I) • S0⁻¹ • R (plus , I⊗Z) • S1⁻¹ • W • X0 • S1 • H1 • R (plus , I⊗Z) • CX1 • R (plus , I⊗Z) • S1⁻¹ • H1 • S1⁻¹ • X0 • ε
          by clifford-tactic 2 10 10000 auto
      equals R (plus , I⊗Y) • R (minus , Z⊗Y) • CZ • H0 • H1 • CZ • S0 • S0 • H0 • W⁻¹ • R (plus , Z⊗I) • CX0 • X0 • R (plus , Z⊗I) • S0⁻¹ • R (plus , I⊗Z) • S1⁻¹ • W • X0 • S1 • H1 • R (plus , I⊗Z) • CX1 • R (plus , I⊗Z) • S1⁻¹ • H1 • S1⁻¹ • X0 • ε
          by in-context 2 9 auto (lemma-R (C.CZ • C.H0 • C.H1 • C.CZ • C.S0 • C.S0 • C.H0 • C.W⁻¹) (plus , Z⊗I))
      equals R (plus , I⊗Y) • R (minus , Z⊗Y) • R (minus , I⊗X) • CZ • H0 • H1 • CZ • S0 • S0 • H0 • W⁻¹ • CX0 • X0 • R (plus , Z⊗I) • S0⁻¹ • R (plus , I⊗Z) • S1⁻¹ • W • X0 • S1 • H1 • R (plus , I⊗Z) • CX1 • R (plus , I⊗Z) • S1⁻¹ • H1 • S1⁻¹ • X0 • ε
          by clifford-tactic 4 9 10000 auto
      equals R (plus , I⊗Y) • R (minus , Z⊗Y) • R (minus , I⊗X) • CZ • H1 • W⁻¹ • R (plus , Z⊗I) • S0⁻¹ • R (plus , I⊗Z) • S1⁻¹ • W • X0 • S1 • H1 • R (plus , I⊗Z) • CX1 • R (plus , I⊗Z) • S1⁻¹ • H1 • S1⁻¹ • X0 • ε
          by in-context 3 4 auto (lemma-R (C.CZ • C.H1 • C.W⁻¹) (plus , Z⊗I))
      equals R (plus , I⊗Y) • R (minus , Z⊗Y) • R (minus , I⊗X) • R (plus , Z⊗I) • CZ • H1 • W⁻¹ • S0⁻¹ • R (plus , I⊗Z) • S1⁻¹ • W • X0 • S1 • H1 • R (plus , I⊗Z) • CX1 • R (plus , I⊗Z) • S1⁻¹ • H1 • S1⁻¹ • X0 • ε
          by in-context 4 5 auto (lemma-R (C.CZ • C.H1 • C.W⁻¹ • C.S0⁻¹) (plus , I⊗Z))
      equals R (plus , I⊗Y) • R (minus , Z⊗Y) • R (minus , I⊗X) • R (plus , Z⊗I) • R (plus , Z⊗X) • CZ • H1 • W⁻¹ • S0⁻¹ • S1⁻¹ • W • X0 • S1 • H1 • R (plus , I⊗Z) • CX1 • R (plus , I⊗Z) • S1⁻¹ • H1 • S1⁻¹ • X0 • ε
          by clifford-tactic 6 8 10000 auto
      equals R (plus , I⊗Y) • R (minus , Z⊗Y) • R (minus , I⊗X) • R (plus , Z⊗I) • R (plus , Z⊗X) • CZ • H0 • S0 • S0 • H0 • S0 • W ^ 6 • R (plus , I⊗Z) • CX1 • R (plus , I⊗Z) • S1⁻¹ • H1 • S1⁻¹ • X0 • ε
          by in-context 5 8 auto (lemma-R (C.CZ • C.H0 • C.S0 • C.S0 • C.H0 • C.S0 • C.W ^ 6) (plus , I⊗Z))
      equals R (plus , I⊗Y) • R (minus , Z⊗Y) • R (minus , I⊗X) • R (plus , Z⊗I) • R (plus , Z⊗X) • R (plus , I⊗Z) • CZ • H0 • S0 • S0 • H0 • S0 • W ^ 6 • CX1 • R (plus , I⊗Z) • S1⁻¹ • H1 • S1⁻¹ • X0 • ε
          by in-context 6 9 auto (lemma-R (C.CZ • C.H0 • C.S0 • C.S0 • C.H0 • C.S0 • C.W ^ 6 • C.CX1) (plus , I⊗Z))
      equals R (plus , I⊗Y) • R (minus , Z⊗Y) • R (minus , I⊗X) • R (plus , Z⊗I) • R (plus , Z⊗X) • R (plus , I⊗Z) • R (minus , Z⊗Z) • CZ • H0 • S0 • S0 • H0 • S0 • W ^ 6 • CX1 • S1⁻¹ • H1 • S1⁻¹ • X0 • ε
          by clifford-tactic 7 12 10000 auto
      equals R (plus , I⊗Y) • R (minus , Z⊗Y) • R (minus , I⊗X) • R (plus , Z⊗I) • R (plus , Z⊗X) • R (plus , I⊗Z) • R (minus , Z⊗Z) • S1 • H1 • CZ • S1 • W ^ 6 • ε
          by in-context 2 2 auto (symm (tactic-pauli-commute (plus , Z⊗I) (minus , I⊗X) auto))
      equals R (plus , I⊗Y) • R (minus , Z⊗Y) • R (plus , Z⊗I) • R (minus , I⊗X) • R (plus , Z⊗X) • R (plus , I⊗Z) • R (minus , Z⊗Z) • S1 • H1 • CZ • S1 • W ^ 6 • ε
          by in-context 1 2 auto (symm (tactic-pauli-commute (plus , Z⊗I) (minus , Z⊗Y) auto))
      equals R (plus , I⊗Y) • R (plus , Z⊗I) • R (minus , Z⊗Y) • R (minus , I⊗X) • R (plus , Z⊗X) • R (plus , I⊗Z) • R (minus , Z⊗Z) • S1 • H1 • CZ • S1 • W ^ 6 • ε
          by in-context 2 1 auto (lemma-correction Z⊗Y)
      equals R (plus , I⊗Y) • R (plus , Z⊗I) • R (plus , Z⊗Y) • S1 • H1 • H0 • CZ • H0 • S0⁻¹ • W • H0 • CZ • H0 • H1 • S1⁻¹ • R (minus , I⊗X) • R (plus , Z⊗X) • R (plus , I⊗Z) • R (minus , Z⊗Z) • S1 • H1 • CZ • S1 • W ^ 6 • ε
          by clifford-tactic 5 10 10000 auto
      equals R (plus , I⊗Y) • R (plus , Z⊗I) • R (plus , Z⊗Y) • S1 • H1 • CZ • S0 • S0 • S0 • H1 • S1 • H1 • R (minus , I⊗X) • R (plus , Z⊗X) • R (plus , I⊗Z) • R (minus , Z⊗Z) • S1 • H1 • CZ • S1 • W ^ 6 • ε
          by in-context 3 10 auto (lemma-R (C.S1 • C.H1 • C.CZ • C.S0 • C.S0 • C.S0 • C.H1 • C.S1 • C.H1) (minus , I⊗X))
      equals R (plus , I⊗Y) • R (plus , Z⊗I) • R (plus , Z⊗Y) • R (minus , Z⊗Z) • S1 • H1 • CZ • S0 • S0 • S0 • H1 • S1 • H1 • R (plus , Z⊗X) • R (plus , I⊗Z) • R (minus , Z⊗Z) • S1 • H1 • CZ • S1 • W ^ 6 • ε
          by in-context 3 1 auto (lemma-correction Z⊗Z)
      equals R (plus , I⊗Y) • R (plus , Z⊗I) • R (plus , Z⊗Y) • R (plus , Z⊗Z) • H0 • CZ • H0 • S0⁻¹ • W • H0 • CZ • H0 • S1 • H1 • CZ • S0 • S0 • S0 • H1 • S1 • H1 • R (plus , Z⊗X) • R (plus , I⊗Z) • R (minus , Z⊗Z) • S1 • H1 • CZ • S1 • W ^ 6 • ε
          by clifford-tactic 4 17 10000 auto
      equals R (plus , I⊗Y) • R (plus , Z⊗I) • R (plus , Z⊗Y) • R (plus , Z⊗Z) • S1 • H1 • CZ • S0 • S0 • S0 • W • R (plus , Z⊗X) • R (plus , I⊗Z) • R (minus , Z⊗Z) • S1 • H1 • CZ • S1 • W ^ 6 • ε
          by in-context 4 8 auto (lemma-R (C.S1 • C.H1 • C.CZ • C.S0 • C.S0 • C.S0 • C.W) (plus , Z⊗X))
      equals R (plus , I⊗Y) • R (plus , Z⊗I) • R (plus , Z⊗Y) • R (plus , Z⊗Z) • R (plus , I⊗Z) • S1 • H1 • CZ • S0 • S0 • S0 • W • R (plus , I⊗Z) • R (minus , Z⊗Z) • S1 • H1 • CZ • S1 • W ^ 6 • ε
          by in-context 5 8 auto (lemma-R (C.S1 • C.H1 • C.CZ • C.S0 • C.S0 • C.S0 • C.W) (plus , I⊗Z))
      equals R (plus , I⊗Y) • R (plus , Z⊗I) • R (plus , Z⊗Y) • R (plus , Z⊗Z) • R (plus , I⊗Z) • R (plus , I⊗Y) • S1 • H1 • CZ • S0 • S0 • S0 • W • R (minus , Z⊗Z) • S1 • H1 • CZ • S1 • W ^ 6 • ε
          by in-context 6 8 auto (lemma-R (C.S1 • C.H1 • C.CZ • C.S0 • C.S0 • C.S0 • C.W) (minus , Z⊗Z))
      equals R (plus , I⊗Y) • R (plus , Z⊗I) • R (plus , Z⊗Y) • R (plus , Z⊗Z) • R (plus , I⊗Z) • R (plus , I⊗Y) • R (minus , Z⊗Y) • S1 • H1 • CZ • S0 • S0 • S0 • W • S1 • H1 • CZ • S1 • W ^ 6 • ε
          by in-context 6 1 auto (lemma-correction Z⊗Y)
      equals R (plus , I⊗Y) • R (plus , Z⊗I) • R (plus , Z⊗Y) • R (plus , Z⊗Z) • R (plus , I⊗Z) • R (plus , I⊗Y) • R (plus , Z⊗Y) • S1 • H1 • H0 • CZ • H0 • S0⁻¹ • W • H0 • CZ • H0 • H1 • S1⁻¹ • S1 • H1 • CZ • S0 • S0 • S0 • W • S1 • H1 • CZ • S1 • W ^ 6 • ε
          by clifford-tactic 7 24 10000 auto
      equals R (plus , I⊗Y) • R (plus , Z⊗I) • R (plus , Z⊗Y) • R (plus , Z⊗Z) • R (plus , I⊗Z) • R (plus , I⊗Y) • R (plus , Z⊗Y) • CZ • S0 • S0 • S1 • S1 • ε
          by in-context 3 2 auto (symm (tactic-pauli-commute (plus , I⊗Z) (plus , Z⊗Z) auto))
      equals R (plus , I⊗Y) • R (plus , Z⊗I) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Z⊗Z) • R (plus , I⊗Y) • R (plus , Z⊗Y) • CZ • S0 • S0 • S1 • S1 • ε
          by clifford-tactic 12 0 10000 auto
      equals R (plus , I⊗Y) • R (plus , Z⊗I) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Z⊗Z) • R (plus , I⊗Y) • R (plus , Z⊗Y) • CZ • S0 • S0 • S1 • S1 • S1⁻¹ • S1⁻¹ • S0⁻¹ • S0⁻¹ • CZ • CZ • S0 • S0 • S1 • S1 • ε
          by clifford-tactic 17 0 10000 auto
      equals R (plus , I⊗Y) • R (plus , Z⊗I) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Z⊗Z) • R (plus , I⊗Y) • R (plus , Z⊗Y) • CZ • S0 • S0 • S1 • S1 • S1⁻¹ • S1⁻¹ • S0⁻¹ • S0⁻¹ • CZ • H0 • CZ • H0 • H0 • CZ • H0 • CZ • S0 • S0 • S1 • S1 • ε
          by in-context 20 0 auto (symm lemma-order-T0)
      equals R (plus , I⊗Y) • R (plus , Z⊗I) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Z⊗Z) • R (plus , I⊗Y) • R (plus , Z⊗Y) • CZ • S0 • S0 • S1 • S1 • S1⁻¹ • S1⁻¹ • S0⁻¹ • S0⁻¹ • CZ • H0 • CZ • H0 • T0 • T0 • T0 • T0 • T0 • T0 • T0 • T0 • H0 • CZ • H0 • CZ • S0 • S0 • S1 • S1 • ε
          by general-assoc auto
      equals R (plus , I⊗Y) • R (plus , Z⊗I) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Z⊗Z) • R (plus , I⊗Y) • R (plus , Z⊗Y) • CZ • S0 • S0 • S1 • S1 • S1⁻¹ • S1⁻¹ • S0⁻¹ • S0⁻¹ • CZ • H0 • CZ • H0 • T0⁻¹ • T0 • H0 • CZ • H0 • CZ • S0 • S0 • S1 • S1 • ε
          by clifford-tactic 21 0 10000 auto
      equals R (plus , I⊗Y) • R (plus , Z⊗I) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Z⊗Z) • R (plus , I⊗Y) • R (plus , Z⊗Y) • CZ • S0 • S0 • S1 • S1 • S1⁻¹ • S1⁻¹ • S0⁻¹ • S0⁻¹ • CZ • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H0 • CZ • H0 • T0 • H0 • CZ • H0 • CZ • S0 • S0 • S1 • S1 • ε
          by general-assoc auto
      equals R (plus , I⊗Y) • R (plus , Z⊗I) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Z⊗Z) • R (plus , I⊗Y) • R (plus , Z⊗Y) • CZ • S0 • S0 • S1 • S1 • S1⁻¹ • S1⁻¹ • S0⁻¹ • S0⁻¹ • CZ • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • R (plus , Z⊗Z) • CZ • S0 • S0 • S1 • S1 • ε
          by clifford-tactic 24 0 10000 auto
      equals R (plus , I⊗Y) • R (plus , Z⊗I) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Z⊗Z) • R (plus , I⊗Y) • R (plus , Z⊗Y) • CZ • S0 • S0 • S1 • S1 • S1⁻¹ • S1⁻¹ • S0⁻¹ • S0⁻¹ • CZ • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • R (plus , Z⊗Z) • CZ • S0 • S0 • S1 • S1 • ε
          by in-context 33 0 auto (symm lemma-order-T0)
      equals R (plus , I⊗Y) • R (plus , Z⊗I) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Z⊗Z) • R (plus , I⊗Y) • R (plus , Z⊗Y) • CZ • S0 • S0 • S1 • S1 • S1⁻¹ • S1⁻¹ • S0⁻¹ • S0⁻¹ • CZ • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0 • T0 • T0 • T0 • T0 • T0 • T0 • T0 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • R (plus , Z⊗Z) • CZ • S0 • S0 • S1 • S1 • ε
          by general-assoc auto
      equals R (plus , I⊗Y) • R (plus , Z⊗I) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Z⊗Z) • R (plus , I⊗Y) • R (plus , Z⊗Y) • CZ • S0 • S0 • S1 • S1 • S1⁻¹ • S1⁻¹ • S0⁻¹ • S0⁻¹ • CZ • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0⁻¹ • T0 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • R (plus , Z⊗Z) • CZ • S0 • S0 • S1 • S1 • ε
          by clifford-tactic 34 0 10000 auto
      equals R (plus , I⊗Y) • R (plus , Z⊗I) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Z⊗Z) • R (plus , I⊗Y) • R (plus , Z⊗Y) • CZ • S0 • S0 • S1 • S1 • S1⁻¹ • S1⁻¹ • S0⁻¹ • S0⁻¹ • CZ • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • R (plus , Z⊗Z) • CZ • S0 • S0 • S1 • S1 • ε
          by general-assoc auto
      equals R (plus , I⊗Y) • R (plus , Z⊗I) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Z⊗Z) • R (plus , I⊗Y) • R (plus , Z⊗Y) • CZ • S0 • S0 • S1 • S1 • S1⁻¹ • S1⁻¹ • S0⁻¹ • S0⁻¹ • CZ • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • R (plus , I⊗Z) • R (plus , Z⊗Z) • CZ • S0 • S0 • S1 • S1 • ε
          by clifford-tactic 43 0 10000 auto
      equals R (plus , I⊗Y) • R (plus , Z⊗I) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Z⊗Z) • R (plus , I⊗Y) • R (plus , Z⊗Y) • CZ • S0 • S0 • S1 • S1 • S1⁻¹ • S1⁻¹ • S0⁻¹ • S0⁻¹ • CZ • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • S1 • H1 • H0 • CZ • H0 • H0 • CZ • H0 • H1 • S1⁻¹ • R (plus , I⊗Z) • R (plus , Z⊗Z) • CZ • S0 • S0 • S1 • S1 • ε
          by in-context 48 0 auto (symm lemma-order-T0)
      equals R (plus , I⊗Y) • R (plus , Z⊗I) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Z⊗Z) • R (plus , I⊗Y) • R (plus , Z⊗Y) • CZ • S0 • S0 • S1 • S1 • S1⁻¹ • S1⁻¹ • S0⁻¹ • S0⁻¹ • CZ • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • S1 • H1 • H0 • CZ • H0 • T0 • T0 • T0 • T0 • T0 • T0 • T0 • T0 • H0 • CZ • H0 • H1 • S1⁻¹ • R (plus , I⊗Z) • R (plus , Z⊗Z) • CZ • S0 • S0 • S1 • S1 • ε
          by general-assoc auto
      equals R (plus , I⊗Y) • R (plus , Z⊗I) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Z⊗Z) • R (plus , I⊗Y) • R (plus , Z⊗Y) • CZ • S0 • S0 • S1 • S1 • S1⁻¹ • S1⁻¹ • S0⁻¹ • S0⁻¹ • CZ • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • S1 • H1 • H0 • CZ • H0 • T0⁻¹ • T0 • H0 • CZ • H0 • H1 • S1⁻¹ • R (plus , I⊗Z) • R (plus , Z⊗Z) • CZ • S0 • S0 • S1 • S1 • ε
          by clifford-tactic 49 0 10000 auto
      equals R (plus , I⊗Y) • R (plus , Z⊗I) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Z⊗Z) • R (plus , I⊗Y) • R (plus , Z⊗Y) • CZ • S0 • S0 • S1 • S1 • S1⁻¹ • S1⁻¹ • S0⁻¹ • S0⁻¹ • CZ • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • S1 • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • S1 • H1 • H0 • CZ • H0 • T0 • H0 • CZ • H0 • H1 • S1⁻¹ • R (plus , I⊗Z) • R (plus , Z⊗Z) • CZ • S0 • S0 • S1 • S1 • ε
          by general-assoc auto
      equals R (plus , I⊗Y) • R (plus , Z⊗I) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Z⊗Z) • R (plus , I⊗Y) • R (plus , Z⊗Y) • CZ • S0 • S0 • S1 • S1 • S1⁻¹ • S1⁻¹ • S0⁻¹ • S0⁻¹ • CZ • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • S1 • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Z⊗Z) • CZ • S0 • S0 • S1 • S1 • ε
          by clifford-tactic 54 0 10000 auto
      equals R (plus , I⊗Y) • R (plus , Z⊗I) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Z⊗Z) • R (plus , I⊗Y) • R (plus , Z⊗Y) • CZ • S0 • S0 • S1 • S1 • S1⁻¹ • S1⁻¹ • S0⁻¹ • S0⁻¹ • CZ • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • S1 • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • S1 • H1 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • H1 • S1⁻¹ • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Z⊗Z) • CZ • S0 • S0 • S1 • S1 • ε
          by in-context 65 0 auto (symm lemma-order-T0)
      equals R (plus , I⊗Y) • R (plus , Z⊗I) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Z⊗Z) • R (plus , I⊗Y) • R (plus , Z⊗Y) • CZ • S0 • S0 • S1 • S1 • S1⁻¹ • S1⁻¹ • S0⁻¹ • S0⁻¹ • CZ • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • S1 • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • S1 • H1 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0 • T0 • T0 • T0 • T0 • T0 • T0 • T0 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • H1 • S1⁻¹ • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Z⊗Z) • CZ • S0 • S0 • S1 • S1 • ε
          by general-assoc auto
      equals R (plus , I⊗Y) • R (plus , Z⊗I) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Z⊗Z) • R (plus , I⊗Y) • R (plus , Z⊗Y) • CZ • S0 • S0 • S1 • S1 • S1⁻¹ • S1⁻¹ • S0⁻¹ • S0⁻¹ • CZ • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • S1 • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • S1 • H1 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0⁻¹ • T0 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • H1 • S1⁻¹ • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Z⊗Z) • CZ • S0 • S0 • S1 • S1 • ε
          by clifford-tactic 66 0 10000 auto
      equals R (plus , I⊗Y) • R (plus , Z⊗I) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Z⊗Z) • R (plus , I⊗Y) • R (plus , Z⊗Y) • CZ • S0 • S0 • S1 • S1 • S1⁻¹ • S1⁻¹ • S0⁻¹ • S0⁻¹ • CZ • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • S1 • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • S1 • H1 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • H1 • S1⁻¹ • S1 • H1 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • H1 • S1⁻¹ • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Z⊗Z) • CZ • S0 • S0 • S1 • S1 • ε
          by general-assoc auto
      equals R (plus , I⊗Y) • R (plus , Z⊗I) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Z⊗Z) • R (plus , I⊗Y) • R (plus , Z⊗Y) • CZ • S0 • S0 • S1 • S1 • S1⁻¹ • S1⁻¹ • S0⁻¹ • S0⁻¹ • CZ • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • S1 • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • S1 • H1 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • H1 • S1⁻¹ • R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Z⊗Z) • CZ • S0 • S0 • S1 • S1 • ε
          by clifford-tactic 77 0 10000 auto
      equals R (plus , I⊗Y) • R (plus , Z⊗I) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Z⊗Z) • R (plus , I⊗Y) • R (plus , Z⊗Y) • CZ • S0 • S0 • S1 • S1 • S1⁻¹ • S1⁻¹ • S0⁻¹ • S0⁻¹ • CZ • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • S1 • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • S1 • H1 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • H1 • S1⁻¹ • H0 • CZ • H0 • H0 • CZ • H0 • R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Z⊗Z) • CZ • S0 • S0 • S1 • S1 • ε
          by in-context 80 0 auto (symm lemma-order-T0)
      equals R (plus , I⊗Y) • R (plus , Z⊗I) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Z⊗Z) • R (plus , I⊗Y) • R (plus , Z⊗Y) • CZ • S0 • S0 • S1 • S1 • S1⁻¹ • S1⁻¹ • S0⁻¹ • S0⁻¹ • CZ • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • S1 • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • S1 • H1 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • H1 • S1⁻¹ • H0 • CZ • H0 • T0 • T0 • T0 • T0 • T0 • T0 • T0 • T0 • H0 • CZ • H0 • R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Z⊗Z) • CZ • S0 • S0 • S1 • S1 • ε
          by general-assoc auto
      equals R (plus , I⊗Y) • R (plus , Z⊗I) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Z⊗Z) • R (plus , I⊗Y) • R (plus , Z⊗Y) • CZ • S0 • S0 • S1 • S1 • S1⁻¹ • S1⁻¹ • S0⁻¹ • S0⁻¹ • CZ • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • S1 • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • S1 • H1 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • H1 • S1⁻¹ • H0 • CZ • H0 • T0⁻¹ • T0 • H0 • CZ • H0 • R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Z⊗Z) • CZ • S0 • S0 • S1 • S1 • ε
          by clifford-tactic 81 0 10000 auto
      equals R (plus , I⊗Y) • R (plus , Z⊗I) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Z⊗Z) • R (plus , I⊗Y) • R (plus , Z⊗Y) • CZ • S0 • S0 • S1 • S1 • S1⁻¹ • S1⁻¹ • S0⁻¹ • S0⁻¹ • CZ • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • S1 • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • S1 • H1 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • H1 • S1⁻¹ • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H0 • CZ • H0 • T0 • H0 • CZ • H0 • R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Z⊗Z) • CZ • S0 • S0 • S1 • S1 • ε
          by general-assoc auto
      equals R (plus , I⊗Y) • R (plus , Z⊗I) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Z⊗Z) • R (plus , I⊗Y) • R (plus , Z⊗Y) • CZ • S0 • S0 • S1 • S1 • S1⁻¹ • S1⁻¹ • S0⁻¹ • S0⁻¹ • CZ • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • S1 • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • S1 • H1 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • H1 • S1⁻¹ • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • R (plus , Z⊗Z) • R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Z⊗Z) • CZ • S0 • S0 • S1 • S1 • ε
          by in-context 84 0 auto (symm lemma-order-T0)
      equals R (plus , I⊗Y) • R (plus , Z⊗I) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Z⊗Z) • R (plus , I⊗Y) • R (plus , Z⊗Y) • CZ • S0 • S0 • S1 • S1 • S1⁻¹ • S1⁻¹ • S0⁻¹ • S0⁻¹ • CZ • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • S1 • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • S1 • H1 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • H1 • S1⁻¹ • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • T0 • T0 • T0 • T0 • T0 • T0 • T0 • T0 • R (plus , Z⊗Z) • R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Z⊗Z) • CZ • S0 • S0 • S1 • S1 • ε
          by general-assoc auto
      equals R (plus , I⊗Y) • R (plus , Z⊗I) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Z⊗Z) • R (plus , I⊗Y) • R (plus , Z⊗Y) • CZ • S0 • S0 • S1 • S1 • S1⁻¹ • S1⁻¹ • S0⁻¹ • S0⁻¹ • CZ • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • S1 • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • S1 • H1 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • H1 • S1⁻¹ • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • T0⁻¹ • R (plus , Z⊗I) • R (plus , Z⊗Z) • R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Z⊗Z) • CZ • S0 • S0 • S1 • S1 • ε
          by clifford-tactic 85 0 10000 auto
      equals R (plus , I⊗Y) • R (plus , Z⊗I) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Z⊗Z) • R (plus , I⊗Y) • R (plus , Z⊗Y) • CZ • S0 • S0 • S1 • S1 • S1⁻¹ • S1⁻¹ • S0⁻¹ • S0⁻¹ • CZ • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • S1 • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • S1 • H1 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • H1 • S1⁻¹ • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • R (plus , Z⊗I) • R (plus , Z⊗Z) • R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Z⊗Z) • CZ • S0 • S0 • S1 • S1 • ε
          by in-context 94 0 auto (symm lemma-order-T0)
      equals R (plus , I⊗Y) • R (plus , Z⊗I) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Z⊗Z) • R (plus , I⊗Y) • R (plus , Z⊗Y) • CZ • S0 • S0 • S1 • S1 • S1⁻¹ • S1⁻¹ • S0⁻¹ • S0⁻¹ • CZ • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • S1 • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • S1 • H1 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • H1 • S1⁻¹ • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0 • T0 • T0 • T0 • T0 • T0 • T0 • T0 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • R (plus , Z⊗I) • R (plus , Z⊗Z) • R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Z⊗Z) • CZ • S0 • S0 • S1 • S1 • ε
          by general-assoc auto
      equals R (plus , I⊗Y) • R (plus , Z⊗I) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Z⊗Z) • R (plus , I⊗Y) • R (plus , Z⊗Y) • CZ • S0 • S0 • S1 • S1 • S1⁻¹ • S1⁻¹ • S0⁻¹ • S0⁻¹ • CZ • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • S1 • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • S1 • H1 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • H1 • S1⁻¹ • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0⁻¹ • T0 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • R (plus , Z⊗I) • R (plus , Z⊗Z) • R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Z⊗Z) • CZ • S0 • S0 • S1 • S1 • ε
          by clifford-tactic 95 0 10000 auto
      equals R (plus , I⊗Y) • R (plus , Z⊗I) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Z⊗Z) • R (plus , I⊗Y) • R (plus , Z⊗Y) • CZ • S0 • S0 • S1 • S1 • S1⁻¹ • S1⁻¹ • S0⁻¹ • S0⁻¹ • CZ • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • S1 • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • S1 • H1 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • H1 • S1⁻¹ • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • R (plus , Z⊗I) • R (plus , Z⊗Z) • R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Z⊗Z) • CZ • S0 • S0 • S1 • S1 • ε
          by general-assoc auto
      equals R (plus , I⊗Y) • R (plus , Z⊗I) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Z⊗Z) • R (plus , I⊗Y) • R (plus , Z⊗Y) • CZ • S0 • S0 • S1 • S1 • S1⁻¹ • S1⁻¹ • S0⁻¹ • S0⁻¹ • CZ • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • S1 • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • S1 • H1 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • H1 • S1⁻¹ • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • R (plus , I⊗Z) • R (plus , Z⊗I) • R (plus , Z⊗Z) • R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Z⊗Z) • CZ • S0 • S0 • S1 • S1 • ε
          by clifford-tactic 0 0 10000 auto
      equals S1 • H1 • H1 • S1⁻¹ • R (plus , I⊗Y) • R (plus , Z⊗I) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Z⊗Z) • R (plus , I⊗Y) • R (plus , Z⊗Y) • CZ • S0 • S0 • S1 • S1 • S1⁻¹ • S1⁻¹ • S0⁻¹ • S0⁻¹ • CZ • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • S1 • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • S1 • H1 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • H1 • S1⁻¹ • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • R (plus , I⊗Z) • R (plus , Z⊗I) • R (plus , Z⊗Z) • R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Z⊗Z) • CZ • S0 • S0 • S1 • S1 • ε
          by clifford-tactic 2 0 10000 auto
      equals S1 • H1 • H0 • CZ • H0 • H0 • CZ • H0 • H1 • S1⁻¹ • R (plus , I⊗Y) • R (plus , Z⊗I) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Z⊗Z) • R (plus , I⊗Y) • R (plus , Z⊗Y) • CZ • S0 • S0 • S1 • S1 • S1⁻¹ • S1⁻¹ • S0⁻¹ • S0⁻¹ • CZ • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • S1 • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • S1 • H1 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • H1 • S1⁻¹ • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • R (plus , I⊗Z) • R (plus , Z⊗I) • R (plus , Z⊗Z) • R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Z⊗Z) • CZ • S0 • S0 • S1 • S1 • ε
          by in-context 5 0 auto (symm lemma-order-T0)
      equals S1 • H1 • H0 • CZ • H0 • T0 • T0 • T0 • T0 • T0 • T0 • T0 • T0 • H0 • CZ • H0 • H1 • S1⁻¹ • R (plus , I⊗Y) • R (plus , Z⊗I) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Z⊗Z) • R (plus , I⊗Y) • R (plus , Z⊗Y) • CZ • S0 • S0 • S1 • S1 • S1⁻¹ • S1⁻¹ • S0⁻¹ • S0⁻¹ • CZ • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • S1 • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • S1 • H1 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • H1 • S1⁻¹ • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • R (plus , I⊗Z) • R (plus , Z⊗I) • R (plus , Z⊗Z) • R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Z⊗Z) • CZ • S0 • S0 • S1 • S1 • ε
          by general-assoc auto
      equals S1 • H1 • H0 • CZ • H0 • T0 • T0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • R (plus , I⊗Y) • R (plus , Z⊗I) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Z⊗Z) • R (plus , I⊗Y) • R (plus , Z⊗Y) • CZ • S0 • S0 • S1 • S1 • S1⁻¹ • S1⁻¹ • S0⁻¹ • S0⁻¹ • CZ • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • S1 • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • S1 • H1 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • H1 • S1⁻¹ • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • R (plus , I⊗Z) • R (plus , Z⊗I) • R (plus , Z⊗Z) • R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Z⊗Z) • CZ • S0 • S0 • S1 • S1 • ε
          by clifford-tactic 6 0 10000 auto
      equals S1 • H1 • H0 • CZ • H0 • T0 • H0 • CZ • H0 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • R (plus , I⊗Y) • R (plus , Z⊗I) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Z⊗Z) • R (plus , I⊗Y) • R (plus , Z⊗Y) • CZ • S0 • S0 • S1 • S1 • S1⁻¹ • S1⁻¹ • S0⁻¹ • S0⁻¹ • CZ • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • S1 • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • S1 • H1 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • H1 • S1⁻¹ • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • R (plus , I⊗Z) • R (plus , Z⊗I) • R (plus , Z⊗Z) • R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Z⊗Z) • CZ • S0 • S0 • S1 • S1 • ε
          by general-assoc auto
      equals S1 • H1 • R (plus , Z⊗Z) • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • R (plus , I⊗Y) • R (plus , Z⊗I) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Z⊗Z) • R (plus , I⊗Y) • R (plus , Z⊗Y) • CZ • S0 • S0 • S1 • S1 • S1⁻¹ • S1⁻¹ • S0⁻¹ • S0⁻¹ • CZ • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • S1 • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • S1 • H1 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • H1 • S1⁻¹ • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • R (plus , I⊗Z) • R (plus , Z⊗I) • R (plus , Z⊗Z) • R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Z⊗Z) • CZ • S0 • S0 • S1 • S1 • ε
          by in-context 3 0 auto (symm lemma-order-T1)
      equals S1 • H1 • R (plus , Z⊗Z) • T1 • T1 • T1 • T1 • T1 • T1 • T1 • T1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • R (plus , I⊗Y) • R (plus , Z⊗I) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Z⊗Z) • R (plus , I⊗Y) • R (plus , Z⊗Y) • CZ • S0 • S0 • S1 • S1 • S1⁻¹ • S1⁻¹ • S0⁻¹ • S0⁻¹ • CZ • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • S1 • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • S1 • H1 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • H1 • S1⁻¹ • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • R (plus , I⊗Z) • R (plus , Z⊗I) • R (plus , Z⊗Z) • R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Z⊗Z) • CZ • S0 • S0 • S1 • S1 • ε
          by general-assoc auto
      equals S1 • H1 • R (plus , Z⊗Z) • T1 • T1⁻¹ • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • R (plus , I⊗Y) • R (plus , Z⊗I) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Z⊗Z) • R (plus , I⊗Y) • R (plus , Z⊗Y) • CZ • S0 • S0 • S1 • S1 • S1⁻¹ • S1⁻¹ • S0⁻¹ • S0⁻¹ • CZ • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • S1 • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • S1 • H1 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • H1 • S1⁻¹ • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • R (plus , I⊗Z) • R (plus , Z⊗I) • R (plus , Z⊗Z) • R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Z⊗Z) • CZ • S0 • S0 • S1 • S1 • ε
          by clifford-tactic 4 0 10000 auto
      equals S1 • H1 • R (plus , Z⊗Z) • T1 • H1 • H1 • T1⁻¹ • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • R (plus , I⊗Y) • R (plus , Z⊗I) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Z⊗Z) • R (plus , I⊗Y) • R (plus , Z⊗Y) • CZ • S0 • S0 • S1 • S1 • S1⁻¹ • S1⁻¹ • S0⁻¹ • S0⁻¹ • CZ • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • S1 • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • S1 • H1 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • H1 • S1⁻¹ • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • R (plus , I⊗Z) • R (plus , Z⊗I) • R (plus , Z⊗Z) • R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Z⊗Z) • CZ • S0 • S0 • S1 • S1 • ε
          by in-context 5 0 auto (symm lemma-order-T1)
      equals S1 • H1 • R (plus , Z⊗Z) • T1 • H1 • T1 • T1 • T1 • T1 • T1 • T1 • T1 • T1 • H1 • T1⁻¹ • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • R (plus , I⊗Y) • R (plus , Z⊗I) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Z⊗Z) • R (plus , I⊗Y) • R (plus , Z⊗Y) • CZ • S0 • S0 • S1 • S1 • S1⁻¹ • S1⁻¹ • S0⁻¹ • S0⁻¹ • CZ • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • S1 • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • S1 • H1 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • H1 • S1⁻¹ • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • R (plus , I⊗Z) • R (plus , Z⊗I) • R (plus , Z⊗Z) • R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Z⊗Z) • CZ • S0 • S0 • S1 • S1 • ε
          by general-assoc auto
      equals S1 • H1 • R (plus , Z⊗Z) • T1 • H1 • T1⁻¹ • T1 • H1 • T1⁻¹ • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • R (plus , I⊗Y) • R (plus , Z⊗I) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Z⊗Z) • R (plus , I⊗Y) • R (plus , Z⊗Y) • CZ • S0 • S0 • S1 • S1 • S1⁻¹ • S1⁻¹ • S0⁻¹ • S0⁻¹ • CZ • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • S1 • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • S1 • H1 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • H1 • S1⁻¹ • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • R (plus , I⊗Z) • R (plus , Z⊗I) • R (plus , Z⊗Z) • R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Z⊗Z) • CZ • S0 • S0 • S1 • S1 • ε
          by clifford-tactic 6 0 10000 auto
      equals S1 • H1 • R (plus , Z⊗Z) • T1 • H1 • T1⁻¹ • CX1 • X1 • X1 • CX1 • T1 • H1 • T1⁻¹ • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • R (plus , I⊗Y) • R (plus , Z⊗I) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Z⊗Z) • R (plus , I⊗Y) • R (plus , Z⊗Y) • CZ • S0 • S0 • S1 • S1 • S1⁻¹ • S1⁻¹ • S0⁻¹ • S0⁻¹ • CZ • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • S1 • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • S1 • H1 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • H1 • S1⁻¹ • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • R (plus , I⊗Z) • R (plus , Z⊗I) • R (plus , Z⊗Z) • R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Z⊗Z) • CZ • S0 • S0 • S1 • S1 • ε
          by in-context 8 0 auto (symm lemma-order-T1)
      equals S1 • H1 • R (plus , Z⊗Z) • T1 • H1 • T1⁻¹ • CX1 • X1 • T1 • T1 • T1 • T1 • T1 • T1 • T1 • T1 • X1 • CX1 • T1 • H1 • T1⁻¹ • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • R (plus , I⊗Y) • R (plus , Z⊗I) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Z⊗Z) • R (plus , I⊗Y) • R (plus , Z⊗Y) • CZ • S0 • S0 • S1 • S1 • S1⁻¹ • S1⁻¹ • S0⁻¹ • S0⁻¹ • CZ • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • S1 • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • S1 • H1 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • H1 • S1⁻¹ • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • R (plus , I⊗Z) • R (plus , Z⊗I) • R (plus , Z⊗Z) • R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Z⊗Z) • CZ • S0 • S0 • S1 • S1 • ε
          by general-assoc auto
      equals S1 • H1 • R (plus , Z⊗Z) • T1 • H1 • T1⁻¹ • CX1 • X1 • T1 • T1⁻¹ • X1 • CX1 • T1 • H1 • T1⁻¹ • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • R (plus , I⊗Y) • R (plus , Z⊗I) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Z⊗Z) • R (plus , I⊗Y) • R (plus , Z⊗Y) • CZ • S0 • S0 • S1 • S1 • S1⁻¹ • S1⁻¹ • S0⁻¹ • S0⁻¹ • CZ • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • S1 • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • S1 • H1 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • H1 • S1⁻¹ • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • R (plus , I⊗Z) • R (plus , Z⊗I) • R (plus , Z⊗Z) • R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Z⊗Z) • CZ • S0 • S0 • S1 • S1 • ε
          by clifford-tactic 9 0 10000 auto
      equals S1 • H1 • R (plus , Z⊗Z) • T1 • H1 • T1⁻¹ • CX1 • X1 • T1 • H1 • H1 • T1⁻¹ • X1 • CX1 • T1 • H1 • T1⁻¹ • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • R (plus , I⊗Y) • R (plus , Z⊗I) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Z⊗Z) • R (plus , I⊗Y) • R (plus , Z⊗Y) • CZ • S0 • S0 • S1 • S1 • S1⁻¹ • S1⁻¹ • S0⁻¹ • S0⁻¹ • CZ • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • S1 • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • S1 • H1 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • H1 • S1⁻¹ • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • R (plus , I⊗Z) • R (plus , Z⊗I) • R (plus , Z⊗Z) • R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Z⊗Z) • CZ • S0 • S0 • S1 • S1 • ε
          by in-context 10 0 auto (symm lemma-order-T1)
      equals S1 • H1 • R (plus , Z⊗Z) • T1 • H1 • T1⁻¹ • CX1 • X1 • T1 • H1 • T1 • T1 • T1 • T1 • T1 • T1 • T1 • T1 • H1 • T1⁻¹ • X1 • CX1 • T1 • H1 • T1⁻¹ • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • R (plus , I⊗Y) • R (plus , Z⊗I) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Z⊗Z) • R (plus , I⊗Y) • R (plus , Z⊗Y) • CZ • S0 • S0 • S1 • S1 • S1⁻¹ • S1⁻¹ • S0⁻¹ • S0⁻¹ • CZ • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • S1 • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • S1 • H1 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • H1 • S1⁻¹ • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • R (plus , I⊗Z) • R (plus , Z⊗I) • R (plus , Z⊗Z) • R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Z⊗Z) • CZ • S0 • S0 • S1 • S1 • ε
          by general-assoc auto
      equals S1 • H1 • R (plus , Z⊗Z) • T1 • H1 • T1⁻¹ • CX1 • X1 • T1 • H1 • T1⁻¹ • T1 • H1 • T1⁻¹ • X1 • CX1 • T1 • H1 • T1⁻¹ • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • R (plus , I⊗Y) • R (plus , Z⊗I) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Z⊗Z) • R (plus , I⊗Y) • R (plus , Z⊗Y) • CZ • S0 • S0 • S1 • S1 • S1⁻¹ • S1⁻¹ • S0⁻¹ • S0⁻¹ • CZ • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • S1 • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • S1 • H1 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • H1 • S1⁻¹ • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • R (plus , I⊗Z) • R (plus , Z⊗I) • R (plus , Z⊗Z) • R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Z⊗Z) • CZ • S0 • S0 • S1 • S1 • ε
          by clifford-tactic 11 0 10000 auto
      equals S1 • H1 • R (plus , Z⊗Z) • T1 • H1 • T1⁻¹ • CX1 • X1 • T1 • H1 • T1⁻¹ • CX1 • CX1 • T1 • H1 • T1⁻¹ • X1 • CX1 • T1 • H1 • T1⁻¹ • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • R (plus , I⊗Y) • R (plus , Z⊗I) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Z⊗Z) • R (plus , I⊗Y) • R (plus , Z⊗Y) • CZ • S0 • S0 • S1 • S1 • S1⁻¹ • S1⁻¹ • S0⁻¹ • S0⁻¹ • CZ • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • S1 • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • S1 • H1 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • H1 • S1⁻¹ • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • R (plus , I⊗Z) • R (plus , Z⊗I) • R (plus , Z⊗Z) • R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Z⊗Z) • CZ • S0 • S0 • S1 • S1 • ε
          by in-context 12 0 auto (symm lemma-order-T1)
      equals S1 • H1 • R (plus , Z⊗Z) • T1 • H1 • T1⁻¹ • CX1 • X1 • T1 • H1 • T1⁻¹ • CX1 • T1 • T1 • T1 • T1 • T1 • T1 • T1 • T1 • CX1 • T1 • H1 • T1⁻¹ • X1 • CX1 • T1 • H1 • T1⁻¹ • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • R (plus , I⊗Y) • R (plus , Z⊗I) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Z⊗Z) • R (plus , I⊗Y) • R (plus , Z⊗Y) • CZ • S0 • S0 • S1 • S1 • S1⁻¹ • S1⁻¹ • S0⁻¹ • S0⁻¹ • CZ • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • S1 • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • S1 • H1 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • H1 • S1⁻¹ • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • R (plus , I⊗Z) • R (plus , Z⊗I) • R (plus , Z⊗Z) • R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Z⊗Z) • CZ • S0 • S0 • S1 • S1 • ε
          by general-assoc auto
      equals S1 • H1 • R (plus , Z⊗Z) • T1 • H1 • T1⁻¹ • CX1 • X1 • T1 • H1 • T1⁻¹ • CX1 • T1 • T1⁻¹ • CX1 • T1 • H1 • T1⁻¹ • X1 • CX1 • T1 • H1 • T1⁻¹ • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • R (plus , I⊗Y) • R (plus , Z⊗I) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Z⊗Z) • R (plus , I⊗Y) • R (plus , Z⊗Y) • CZ • S0 • S0 • S1 • S1 • S1⁻¹ • S1⁻¹ • S0⁻¹ • S0⁻¹ • CZ • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • S1 • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • S1 • H1 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • H1 • S1⁻¹ • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • R (plus , I⊗Z) • R (plus , Z⊗I) • R (plus , Z⊗Z) • R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Z⊗Z) • CZ • S0 • S0 • S1 • S1 • ε
          by clifford-tactic 13 0 10000 auto
      equals S1 • H1 • R (plus , Z⊗Z) • T1 • H1 • T1⁻¹ • CX1 • X1 • T1 • H1 • T1⁻¹ • CX1 • T1 • H1 • H1 • T1⁻¹ • CX1 • T1 • H1 • T1⁻¹ • X1 • CX1 • T1 • H1 • T1⁻¹ • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • R (plus , I⊗Y) • R (plus , Z⊗I) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Z⊗Z) • R (plus , I⊗Y) • R (plus , Z⊗Y) • CZ • S0 • S0 • S1 • S1 • S1⁻¹ • S1⁻¹ • S0⁻¹ • S0⁻¹ • CZ • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • S1 • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • S1 • H1 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • H1 • S1⁻¹ • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • R (plus , I⊗Z) • R (plus , Z⊗I) • R (plus , Z⊗Z) • R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Z⊗Z) • CZ • S0 • S0 • S1 • S1 • ε
          by in-context 14 0 auto (symm lemma-order-T1)
      equals S1 • H1 • R (plus , Z⊗Z) • T1 • H1 • T1⁻¹ • CX1 • X1 • T1 • H1 • T1⁻¹ • CX1 • T1 • H1 • T1 • T1 • T1 • T1 • T1 • T1 • T1 • T1 • H1 • T1⁻¹ • CX1 • T1 • H1 • T1⁻¹ • X1 • CX1 • T1 • H1 • T1⁻¹ • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • R (plus , I⊗Y) • R (plus , Z⊗I) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Z⊗Z) • R (plus , I⊗Y) • R (plus , Z⊗Y) • CZ • S0 • S0 • S1 • S1 • S1⁻¹ • S1⁻¹ • S0⁻¹ • S0⁻¹ • CZ • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • S1 • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • S1 • H1 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • H1 • S1⁻¹ • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • R (plus , I⊗Z) • R (plus , Z⊗I) • R (plus , Z⊗Z) • R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Z⊗Z) • CZ • S0 • S0 • S1 • S1 • ε
          by general-assoc auto
      equals S1 • H1 • R (plus , Z⊗Z) • T1 • H1 • T1⁻¹ • CX1 • X1 • T1 • H1 • T1⁻¹ • CX1 • T1 • H1 • T1⁻¹ • T1 • H1 • T1⁻¹ • CX1 • T1 • H1 • T1⁻¹ • X1 • CX1 • T1 • H1 • T1⁻¹ • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • R (plus , I⊗Y) • R (plus , Z⊗I) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Z⊗Z) • R (plus , I⊗Y) • R (plus , Z⊗Y) • CZ • S0 • S0 • S1 • S1 • S1⁻¹ • S1⁻¹ • S0⁻¹ • S0⁻¹ • CZ • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • S1 • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • S1 • H1 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • H1 • S1⁻¹ • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • R (plus , I⊗Z) • R (plus , Z⊗I) • R (plus , Z⊗Z) • R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Z⊗Z) • CZ • S0 • S0 • S1 • S1 • ε
          by clifford-tactic 15 0 10000 auto
      equals S1 • H1 • R (plus , Z⊗Z) • T1 • H1 • T1⁻¹ • CX1 • X1 • T1 • H1 • T1⁻¹ • CX1 • T1 • H1 • T1⁻¹ • CX1 • X1 • X1 • CX1 • T1 • H1 • T1⁻¹ • CX1 • T1 • H1 • T1⁻¹ • X1 • CX1 • T1 • H1 • T1⁻¹ • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • R (plus , I⊗Y) • R (plus , Z⊗I) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Z⊗Z) • R (plus , I⊗Y) • R (plus , Z⊗Y) • CZ • S0 • S0 • S1 • S1 • S1⁻¹ • S1⁻¹ • S0⁻¹ • S0⁻¹ • CZ • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • S1 • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • S1 • H1 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • H1 • S1⁻¹ • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • R (plus , I⊗Z) • R (plus , Z⊗I) • R (plus , Z⊗Z) • R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Z⊗Z) • CZ • S0 • S0 • S1 • S1 • ε
          by in-context 17 0 auto (symm lemma-order-T1)
      equals S1 • H1 • R (plus , Z⊗Z) • T1 • H1 • T1⁻¹ • CX1 • X1 • T1 • H1 • T1⁻¹ • CX1 • T1 • H1 • T1⁻¹ • CX1 • X1 • T1 • T1 • T1 • T1 • T1 • T1 • T1 • T1 • X1 • CX1 • T1 • H1 • T1⁻¹ • CX1 • T1 • H1 • T1⁻¹ • X1 • CX1 • T1 • H1 • T1⁻¹ • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • R (plus , I⊗Y) • R (plus , Z⊗I) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Z⊗Z) • R (plus , I⊗Y) • R (plus , Z⊗Y) • CZ • S0 • S0 • S1 • S1 • S1⁻¹ • S1⁻¹ • S0⁻¹ • S0⁻¹ • CZ • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • S1 • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • S1 • H1 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • H1 • S1⁻¹ • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • R (plus , I⊗Z) • R (plus , Z⊗I) • R (plus , Z⊗Z) • R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Z⊗Z) • CZ • S0 • S0 • S1 • S1 • ε
          by general-assoc auto
      equals S1 • H1 • R (plus , Z⊗Z) • T1 • H1 • T1⁻¹ • CX1 • X1 • T1 • H1 • T1⁻¹ • CX1 • T1 • H1 • T1⁻¹ • CX1 • X1 • T1 • T1⁻¹ • X1 • CX1 • T1 • H1 • T1⁻¹ • CX1 • T1 • H1 • T1⁻¹ • X1 • CX1 • T1 • H1 • T1⁻¹ • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • R (plus , I⊗Y) • R (plus , Z⊗I) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Z⊗Z) • R (plus , I⊗Y) • R (plus , Z⊗Y) • CZ • S0 • S0 • S1 • S1 • S1⁻¹ • S1⁻¹ • S0⁻¹ • S0⁻¹ • CZ • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • S1 • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • S1 • H1 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • H1 • S1⁻¹ • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • R (plus , I⊗Z) • R (plus , Z⊗I) • R (plus , Z⊗Z) • R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Z⊗Z) • CZ • S0 • S0 • S1 • S1 • ε
          by clifford-tactic 18 0 10000 auto
      equals S1 • H1 • R (plus , Z⊗Z) • T1 • H1 • T1⁻¹ • CX1 • X1 • T1 • H1 • T1⁻¹ • CX1 • T1 • H1 • T1⁻¹ • CX1 • X1 • T1 • H1 • H1 • T1⁻¹ • X1 • CX1 • T1 • H1 • T1⁻¹ • CX1 • T1 • H1 • T1⁻¹ • X1 • CX1 • T1 • H1 • T1⁻¹ • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • R (plus , I⊗Y) • R (plus , Z⊗I) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Z⊗Z) • R (plus , I⊗Y) • R (plus , Z⊗Y) • CZ • S0 • S0 • S1 • S1 • S1⁻¹ • S1⁻¹ • S0⁻¹ • S0⁻¹ • CZ • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • S1 • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • S1 • H1 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • H1 • S1⁻¹ • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • R (plus , I⊗Z) • R (plus , Z⊗I) • R (plus , Z⊗Z) • R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Z⊗Z) • CZ • S0 • S0 • S1 • S1 • ε
          by in-context 19 0 auto (symm lemma-order-T1)
      equals S1 • H1 • R (plus , Z⊗Z) • T1 • H1 • T1⁻¹ • CX1 • X1 • T1 • H1 • T1⁻¹ • CX1 • T1 • H1 • T1⁻¹ • CX1 • X1 • T1 • H1 • T1 • T1 • T1 • T1 • T1 • T1 • T1 • T1 • H1 • T1⁻¹ • X1 • CX1 • T1 • H1 • T1⁻¹ • CX1 • T1 • H1 • T1⁻¹ • X1 • CX1 • T1 • H1 • T1⁻¹ • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • R (plus , I⊗Y) • R (plus , Z⊗I) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Z⊗Z) • R (plus , I⊗Y) • R (plus , Z⊗Y) • CZ • S0 • S0 • S1 • S1 • S1⁻¹ • S1⁻¹ • S0⁻¹ • S0⁻¹ • CZ • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • S1 • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • S1 • H1 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • H1 • S1⁻¹ • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • R (plus , I⊗Z) • R (plus , Z⊗I) • R (plus , Z⊗Z) • R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Z⊗Z) • CZ • S0 • S0 • S1 • S1 • ε
          by general-assoc auto
      equals S1 • H1 • R (plus , Z⊗Z) • T1 • H1 • T1⁻¹ • CX1 • X1 • T1 • H1 • T1⁻¹ • CX1 • T1 • H1 • T1⁻¹ • CX1 • X1 • T1 • H1 • T1⁻¹ • T1 • H1 • T1⁻¹ • X1 • CX1 • T1 • H1 • T1⁻¹ • CX1 • T1 • H1 • T1⁻¹ • X1 • CX1 • T1 • H1 • T1⁻¹ • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • R (plus , I⊗Y) • R (plus , Z⊗I) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Z⊗Z) • R (plus , I⊗Y) • R (plus , Z⊗Y) • CZ • S0 • S0 • S1 • S1 • S1⁻¹ • S1⁻¹ • S0⁻¹ • S0⁻¹ • CZ • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • S1 • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • S1 • H1 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • H1 • S1⁻¹ • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • R (plus , I⊗Z) • R (plus , Z⊗I) • R (plus , Z⊗Z) • R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Z⊗Z) • CZ • S0 • S0 • S1 • S1 • ε
          by clifford-tactic 20 0 10000 auto
      equals S1 • H1 • R (plus , Z⊗Z) • T1 • H1 • T1⁻¹ • CX1 • X1 • T1 • H1 • T1⁻¹ • CX1 • T1 • H1 • T1⁻¹ • CX1 • X1 • T1 • H1 • T1⁻¹ • CX1 • H0 • CZ • H0 • H0 • CZ • H0 • CX1 • T1 • H1 • T1⁻¹ • X1 • CX1 • T1 • H1 • T1⁻¹ • CX1 • T1 • H1 • T1⁻¹ • X1 • CX1 • T1 • H1 • T1⁻¹ • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • R (plus , I⊗Y) • R (plus , Z⊗I) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Z⊗Z) • R (plus , I⊗Y) • R (plus , Z⊗Y) • CZ • S0 • S0 • S1 • S1 • S1⁻¹ • S1⁻¹ • S0⁻¹ • S0⁻¹ • CZ • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • S1 • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • S1 • H1 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • H1 • S1⁻¹ • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • R (plus , I⊗Z) • R (plus , Z⊗I) • R (plus , Z⊗Z) • R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Z⊗Z) • CZ • S0 • S0 • S1 • S1 • ε
          by in-context 24 0 auto (symm lemma-order-T0)
      equals S1 • H1 • R (plus , Z⊗Z) • T1 • H1 • T1⁻¹ • CX1 • X1 • T1 • H1 • T1⁻¹ • CX1 • T1 • H1 • T1⁻¹ • CX1 • X1 • T1 • H1 • T1⁻¹ • CX1 • H0 • CZ • H0 • T0 • T0 • T0 • T0 • T0 • T0 • T0 • T0 • H0 • CZ • H0 • CX1 • T1 • H1 • T1⁻¹ • X1 • CX1 • T1 • H1 • T1⁻¹ • CX1 • T1 • H1 • T1⁻¹ • X1 • CX1 • T1 • H1 • T1⁻¹ • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • R (plus , I⊗Y) • R (plus , Z⊗I) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Z⊗Z) • R (plus , I⊗Y) • R (plus , Z⊗Y) • CZ • S0 • S0 • S1 • S1 • S1⁻¹ • S1⁻¹ • S0⁻¹ • S0⁻¹ • CZ • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • S1 • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • S1 • H1 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • H1 • S1⁻¹ • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • R (plus , I⊗Z) • R (plus , Z⊗I) • R (plus , Z⊗Z) • R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Z⊗Z) • CZ • S0 • S0 • S1 • S1 • ε
          by general-assoc auto
      equals S1 • H1 • R (plus , Z⊗Z) • T1 • H1 • T1⁻¹ • CX1 • X1 • T1 • H1 • T1⁻¹ • CX1 • T1 • H1 • T1⁻¹ • CX1 • X1 • T1 • H1 • T1⁻¹ • CX1 • H0 • CZ • H0 • T0⁻¹ • T0 • H0 • CZ • H0 • CX1 • T1 • H1 • T1⁻¹ • X1 • CX1 • T1 • H1 • T1⁻¹ • CX1 • T1 • H1 • T1⁻¹ • X1 • CX1 • T1 • H1 • T1⁻¹ • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • R (plus , I⊗Y) • R (plus , Z⊗I) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Z⊗Z) • R (plus , I⊗Y) • R (plus , Z⊗Y) • CZ • S0 • S0 • S1 • S1 • S1⁻¹ • S1⁻¹ • S0⁻¹ • S0⁻¹ • CZ • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • S1 • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • S1 • H1 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • H1 • S1⁻¹ • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • R (plus , I⊗Z) • R (plus , Z⊗I) • R (plus , Z⊗Z) • R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Z⊗Z) • CZ • S0 • S0 • S1 • S1 • ε
          by clifford-tactic 25 0 10000 auto
      equals S1 • H1 • R (plus , Z⊗Z) • T1 • H1 • T1⁻¹ • CX1 • X1 • T1 • H1 • T1⁻¹ • CX1 • T1 • H1 • T1⁻¹ • CX1 • X1 • T1 • H1 • T1⁻¹ • CX1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • S1 • H1 • H0 • CZ • H0 • T0 • H0 • CZ • H0 • CX1 • T1 • H1 • T1⁻¹ • X1 • CX1 • T1 • H1 • T1⁻¹ • CX1 • T1 • H1 • T1⁻¹ • X1 • CX1 • T1 • H1 • T1⁻¹ • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • R (plus , I⊗Y) • R (plus , Z⊗I) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Z⊗Z) • R (plus , I⊗Y) • R (plus , Z⊗Y) • CZ • S0 • S0 • S1 • S1 • S1⁻¹ • S1⁻¹ • S0⁻¹ • S0⁻¹ • CZ • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • S1 • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • S1 • H1 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • H1 • S1⁻¹ • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • R (plus , I⊗Z) • R (plus , Z⊗I) • R (plus , Z⊗Z) • R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Z⊗Z) • CZ • S0 • S0 • S1 • S1 • ε
          by general-assoc auto
      equals S1 • H1 • R (plus , Z⊗Z) • T1 • H1 • T1⁻¹ • CX1 • X1 • T1 • H1 • T1⁻¹ • CX1 • T1 • H1 • T1⁻¹ • CX1 • X1 • T1 • H1 • T1⁻¹ • CX1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • S1 • H1 • H0 • CZ • H0 • R (plus , Z⊗I) • H0 • CZ • H0 • CX1 • T1 • H1 • T1⁻¹ • X1 • CX1 • T1 • H1 • T1⁻¹ • CX1 • T1 • H1 • T1⁻¹ • X1 • CX1 • T1 • H1 • T1⁻¹ • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • R (plus , I⊗Y) • R (plus , Z⊗I) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Z⊗Z) • R (plus , I⊗Y) • R (plus , Z⊗Y) • CZ • S0 • S0 • S1 • S1 • S1⁻¹ • S1⁻¹ • S0⁻¹ • S0⁻¹ • CZ • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • S1 • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • S1 • H1 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • H1 • S1⁻¹ • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • R (plus , I⊗Z) • R (plus , Z⊗I) • R (plus , Z⊗Z) • R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Z⊗Z) • CZ • S0 • S0 • S1 • S1 • ε
          by in-context 40 1 auto lemma-R-T1
      equals S1 • H1 • R (plus , Z⊗Z) • T1 • H1 • T1⁻¹ • CX1 • X1 • T1 • H1 • T1⁻¹ • CX1 • T1 • H1 • T1⁻¹ • CX1 • X1 • T1 • H1 • T1⁻¹ • CX1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • S1 • H1 • H0 • CZ • H0 • R (plus , Z⊗I) • H0 • CZ • H0 • CX1 • R (plus , I⊗Z) • H1 • T1⁻¹ • X1 • CX1 • T1 • H1 • T1⁻¹ • CX1 • T1 • H1 • T1⁻¹ • X1 • CX1 • T1 • H1 • T1⁻¹ • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • R (plus , I⊗Y) • R (plus , Z⊗I) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Z⊗Z) • R (plus , I⊗Y) • R (plus , Z⊗Y) • CZ • S0 • S0 • S1 • S1 • S1⁻¹ • S1⁻¹ • S0⁻¹ • S0⁻¹ • CZ • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • S1 • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • S1 • H1 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • H1 • S1⁻¹ • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • R (plus , I⊗Z) • R (plus , Z⊗I) • R (plus , Z⊗Z) • R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Z⊗Z) • CZ • S0 • S0 • S1 • S1 • ε
          by in-context 42 1 auto lemma-R-T1⁻¹
      equals S1 • H1 • R (plus , Z⊗Z) • T1 • H1 • T1⁻¹ • CX1 • X1 • T1 • H1 • T1⁻¹ • CX1 • T1 • H1 • T1⁻¹ • CX1 • X1 • T1 • H1 • T1⁻¹ • CX1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • S1 • H1 • H0 • CZ • H0 • R (plus , Z⊗I) • H0 • CZ • H0 • CX1 • R (plus , I⊗Z) • H1 • R (plus , I⊗Z) • S1⁻¹ • X1 • CX1 • T1 • H1 • T1⁻¹ • CX1 • T1 • H1 • T1⁻¹ • X1 • CX1 • T1 • H1 • T1⁻¹ • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • R (plus , I⊗Y) • R (plus , Z⊗I) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Z⊗Z) • R (plus , I⊗Y) • R (plus , Z⊗Y) • CZ • S0 • S0 • S1 • S1 • S1⁻¹ • S1⁻¹ • S0⁻¹ • S0⁻¹ • CZ • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • S1 • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • S1 • H1 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • H1 • S1⁻¹ • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • R (plus , I⊗Z) • R (plus , Z⊗I) • R (plus , Z⊗Z) • R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Z⊗Z) • CZ • S0 • S0 • S1 • S1 • ε
          by in-context 46 1 auto lemma-R-T1
      equals S1 • H1 • R (plus , Z⊗Z) • T1 • H1 • T1⁻¹ • CX1 • X1 • T1 • H1 • T1⁻¹ • CX1 • T1 • H1 • T1⁻¹ • CX1 • X1 • T1 • H1 • T1⁻¹ • CX1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • S1 • H1 • H0 • CZ • H0 • R (plus , Z⊗I) • H0 • CZ • H0 • CX1 • R (plus , I⊗Z) • H1 • R (plus , I⊗Z) • S1⁻¹ • X1 • CX1 • R (plus , I⊗Z) • H1 • T1⁻¹ • CX1 • T1 • H1 • T1⁻¹ • X1 • CX1 • T1 • H1 • T1⁻¹ • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • R (plus , I⊗Y) • R (plus , Z⊗I) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Z⊗Z) • R (plus , I⊗Y) • R (plus , Z⊗Y) • CZ • S0 • S0 • S1 • S1 • S1⁻¹ • S1⁻¹ • S0⁻¹ • S0⁻¹ • CZ • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • S1 • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • S1 • H1 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • H1 • S1⁻¹ • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • R (plus , I⊗Z) • R (plus , Z⊗I) • R (plus , Z⊗Z) • R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Z⊗Z) • CZ • S0 • S0 • S1 • S1 • ε
          by in-context 48 1 auto lemma-R-T1⁻¹
      equals S1 • H1 • R (plus , Z⊗Z) • T1 • H1 • T1⁻¹ • CX1 • X1 • T1 • H1 • T1⁻¹ • CX1 • T1 • H1 • T1⁻¹ • CX1 • X1 • T1 • H1 • T1⁻¹ • CX1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • S1 • H1 • H0 • CZ • H0 • R (plus , Z⊗I) • H0 • CZ • H0 • CX1 • R (plus , I⊗Z) • H1 • R (plus , I⊗Z) • S1⁻¹ • X1 • CX1 • R (plus , I⊗Z) • H1 • R (plus , I⊗Z) • S1⁻¹ • CX1 • T1 • H1 • T1⁻¹ • X1 • CX1 • T1 • H1 • T1⁻¹ • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • R (plus , I⊗Y) • R (plus , Z⊗I) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Z⊗Z) • R (plus , I⊗Y) • R (plus , Z⊗Y) • CZ • S0 • S0 • S1 • S1 • S1⁻¹ • S1⁻¹ • S0⁻¹ • S0⁻¹ • CZ • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • S1 • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • S1 • H1 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • H1 • S1⁻¹ • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • R (plus , I⊗Z) • R (plus , Z⊗I) • R (plus , Z⊗Z) • R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Z⊗Z) • CZ • S0 • S0 • S1 • S1 • ε
          by in-context 51 1 auto lemma-R-T1
      equals S1 • H1 • R (plus , Z⊗Z) • T1 • H1 • T1⁻¹ • CX1 • X1 • T1 • H1 • T1⁻¹ • CX1 • T1 • H1 • T1⁻¹ • CX1 • X1 • T1 • H1 • T1⁻¹ • CX1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • S1 • H1 • H0 • CZ • H0 • R (plus , Z⊗I) • H0 • CZ • H0 • CX1 • R (plus , I⊗Z) • H1 • R (plus , I⊗Z) • S1⁻¹ • X1 • CX1 • R (plus , I⊗Z) • H1 • R (plus , I⊗Z) • S1⁻¹ • CX1 • R (plus , I⊗Z) • H1 • T1⁻¹ • X1 • CX1 • T1 • H1 • T1⁻¹ • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • R (plus , I⊗Y) • R (plus , Z⊗I) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Z⊗Z) • R (plus , I⊗Y) • R (plus , Z⊗Y) • CZ • S0 • S0 • S1 • S1 • S1⁻¹ • S1⁻¹ • S0⁻¹ • S0⁻¹ • CZ • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • S1 • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • S1 • H1 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • H1 • S1⁻¹ • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • R (plus , I⊗Z) • R (plus , Z⊗I) • R (plus , Z⊗Z) • R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Z⊗Z) • CZ • S0 • S0 • S1 • S1 • ε
          by in-context 53 1 auto lemma-R-T1⁻¹
      equals S1 • H1 • R (plus , Z⊗Z) • T1 • H1 • T1⁻¹ • CX1 • X1 • T1 • H1 • T1⁻¹ • CX1 • T1 • H1 • T1⁻¹ • CX1 • X1 • T1 • H1 • T1⁻¹ • CX1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • S1 • H1 • H0 • CZ • H0 • R (plus , Z⊗I) • H0 • CZ • H0 • CX1 • R (plus , I⊗Z) • H1 • R (plus , I⊗Z) • S1⁻¹ • X1 • CX1 • R (plus , I⊗Z) • H1 • R (plus , I⊗Z) • S1⁻¹ • CX1 • R (plus , I⊗Z) • H1 • R (plus , I⊗Z) • S1⁻¹ • X1 • CX1 • T1 • H1 • T1⁻¹ • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • R (plus , I⊗Y) • R (plus , Z⊗I) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Z⊗Z) • R (plus , I⊗Y) • R (plus , Z⊗Y) • CZ • S0 • S0 • S1 • S1 • S1⁻¹ • S1⁻¹ • S0⁻¹ • S0⁻¹ • CZ • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • S1 • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • S1 • H1 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • H1 • S1⁻¹ • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • R (plus , I⊗Z) • R (plus , Z⊗I) • R (plus , Z⊗Z) • R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Z⊗Z) • CZ • S0 • S0 • S1 • S1 • ε
          by in-context 57 1 auto lemma-R-T1
      equals S1 • H1 • R (plus , Z⊗Z) • T1 • H1 • T1⁻¹ • CX1 • X1 • T1 • H1 • T1⁻¹ • CX1 • T1 • H1 • T1⁻¹ • CX1 • X1 • T1 • H1 • T1⁻¹ • CX1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • S1 • H1 • H0 • CZ • H0 • R (plus , Z⊗I) • H0 • CZ • H0 • CX1 • R (plus , I⊗Z) • H1 • R (plus , I⊗Z) • S1⁻¹ • X1 • CX1 • R (plus , I⊗Z) • H1 • R (plus , I⊗Z) • S1⁻¹ • CX1 • R (plus , I⊗Z) • H1 • R (plus , I⊗Z) • S1⁻¹ • X1 • CX1 • R (plus , I⊗Z) • H1 • T1⁻¹ • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • R (plus , I⊗Y) • R (plus , Z⊗I) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Z⊗Z) • R (plus , I⊗Y) • R (plus , Z⊗Y) • CZ • S0 • S0 • S1 • S1 • S1⁻¹ • S1⁻¹ • S0⁻¹ • S0⁻¹ • CZ • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • S1 • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • S1 • H1 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • H1 • S1⁻¹ • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • R (plus , I⊗Z) • R (plus , Z⊗I) • R (plus , Z⊗Z) • R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Z⊗Z) • CZ • S0 • S0 • S1 • S1 • ε
          by in-context 59 1 auto lemma-R-T1⁻¹
      equals S1 • H1 • R (plus , Z⊗Z) • T1 • H1 • T1⁻¹ • CX1 • X1 • T1 • H1 • T1⁻¹ • CX1 • T1 • H1 • T1⁻¹ • CX1 • X1 • T1 • H1 • T1⁻¹ • CX1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • S1 • H1 • H0 • CZ • H0 • R (plus , Z⊗I) • H0 • CZ • H0 • CX1 • R (plus , I⊗Z) • H1 • R (plus , I⊗Z) • S1⁻¹ • X1 • CX1 • R (plus , I⊗Z) • H1 • R (plus , I⊗Z) • S1⁻¹ • CX1 • R (plus , I⊗Z) • H1 • R (plus , I⊗Z) • S1⁻¹ • X1 • CX1 • R (plus , I⊗Z) • H1 • R (plus , I⊗Z) • S1⁻¹ • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • R (plus , I⊗Y) • R (plus , Z⊗I) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Z⊗Z) • R (plus , I⊗Y) • R (plus , Z⊗Y) • CZ • S0 • S0 • S1 • S1 • S1⁻¹ • S1⁻¹ • S0⁻¹ • S0⁻¹ • CZ • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • S1 • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • S1 • H1 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • H1 • S1⁻¹ • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • R (plus , I⊗Z) • R (plus , Z⊗I) • R (plus , Z⊗Z) • R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Z⊗Z) • CZ • S0 • S0 • S1 • S1 • ε
          by in-context 64 1 auto lemma-R-T0⁻¹
      equals S1 • H1 • R (plus , Z⊗Z) • T1 • H1 • T1⁻¹ • CX1 • X1 • T1 • H1 • T1⁻¹ • CX1 • T1 • H1 • T1⁻¹ • CX1 • X1 • T1 • H1 • T1⁻¹ • CX1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • S1 • H1 • H0 • CZ • H0 • R (plus , Z⊗I) • H0 • CZ • H0 • CX1 • R (plus , I⊗Z) • H1 • R (plus , I⊗Z) • S1⁻¹ • X1 • CX1 • R (plus , I⊗Z) • H1 • R (plus , I⊗Z) • S1⁻¹ • CX1 • R (plus , I⊗Z) • H1 • R (plus , I⊗Z) • S1⁻¹ • X1 • CX1 • R (plus , I⊗Z) • H1 • R (plus , I⊗Z) • S1⁻¹ • H0 • CZ • H0 • R (plus , Z⊗I) • S0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • R (plus , I⊗Y) • R (plus , Z⊗I) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Z⊗Z) • R (plus , I⊗Y) • R (plus , Z⊗Y) • CZ • S0 • S0 • S1 • S1 • S1⁻¹ • S1⁻¹ • S0⁻¹ • S0⁻¹ • CZ • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • S1 • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • S1 • H1 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • H1 • S1⁻¹ • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • R (plus , I⊗Z) • R (plus , Z⊗I) • R (plus , Z⊗Z) • R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Z⊗Z) • CZ • S0 • S0 • S1 • S1 • ε
          by in-context 91 1 auto lemma-R-T0⁻¹
      equals S1 • H1 • R (plus , Z⊗Z) • T1 • H1 • T1⁻¹ • CX1 • X1 • T1 • H1 • T1⁻¹ • CX1 • T1 • H1 • T1⁻¹ • CX1 • X1 • T1 • H1 • T1⁻¹ • CX1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • S1 • H1 • H0 • CZ • H0 • R (plus , Z⊗I) • H0 • CZ • H0 • CX1 • R (plus , I⊗Z) • H1 • R (plus , I⊗Z) • S1⁻¹ • X1 • CX1 • R (plus , I⊗Z) • H1 • R (plus , I⊗Z) • S1⁻¹ • CX1 • R (plus , I⊗Z) • H1 • R (plus , I⊗Z) • S1⁻¹ • X1 • CX1 • R (plus , I⊗Z) • H1 • R (plus , I⊗Z) • S1⁻¹ • H0 • CZ • H0 • R (plus , Z⊗I) • S0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • R (plus , I⊗Y) • R (plus , Z⊗I) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Z⊗Z) • R (plus , I⊗Y) • R (plus , Z⊗Y) • CZ • S0 • S0 • S1 • S1 • S1⁻¹ • S1⁻¹ • S0⁻¹ • S0⁻¹ • CZ • H0 • CZ • H0 • R (plus , Z⊗I) • S0⁻¹ • H0 • CZ • H0 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • S1 • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • S1 • H1 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • H1 • S1⁻¹ • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • R (plus , I⊗Z) • R (plus , Z⊗I) • R (plus , Z⊗Z) • R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Z⊗Z) • CZ • S0 • S0 • S1 • S1 • ε
          by in-context 105 1 auto lemma-R-T0⁻¹
      equals S1 • H1 • R (plus , Z⊗Z) • T1 • H1 • T1⁻¹ • CX1 • X1 • T1 • H1 • T1⁻¹ • CX1 • T1 • H1 • T1⁻¹ • CX1 • X1 • T1 • H1 • T1⁻¹ • CX1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • S1 • H1 • H0 • CZ • H0 • R (plus , Z⊗I) • H0 • CZ • H0 • CX1 • R (plus , I⊗Z) • H1 • R (plus , I⊗Z) • S1⁻¹ • X1 • CX1 • R (plus , I⊗Z) • H1 • R (plus , I⊗Z) • S1⁻¹ • CX1 • R (plus , I⊗Z) • H1 • R (plus , I⊗Z) • S1⁻¹ • X1 • CX1 • R (plus , I⊗Z) • H1 • R (plus , I⊗Z) • S1⁻¹ • H0 • CZ • H0 • R (plus , Z⊗I) • S0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • R (plus , I⊗Y) • R (plus , Z⊗I) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Z⊗Z) • R (plus , I⊗Y) • R (plus , Z⊗Y) • CZ • S0 • S0 • S1 • S1 • S1⁻¹ • S1⁻¹ • S0⁻¹ • S0⁻¹ • CZ • H0 • CZ • H0 • R (plus , Z⊗I) • S0⁻¹ • H0 • CZ • H0 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • R (plus , Z⊗I) • S0⁻¹ • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • S1 • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • S1 • H1 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • H1 • S1⁻¹ • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • R (plus , I⊗Z) • R (plus , Z⊗I) • R (plus , Z⊗Z) • R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Z⊗Z) • CZ • S0 • S0 • S1 • S1 • ε
          by in-context 121 1 auto lemma-R-T0⁻¹
      equals S1 • H1 • R (plus , Z⊗Z) • T1 • H1 • T1⁻¹ • CX1 • X1 • T1 • H1 • T1⁻¹ • CX1 • T1 • H1 • T1⁻¹ • CX1 • X1 • T1 • H1 • T1⁻¹ • CX1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • S1 • H1 • H0 • CZ • H0 • R (plus , Z⊗I) • H0 • CZ • H0 • CX1 • R (plus , I⊗Z) • H1 • R (plus , I⊗Z) • S1⁻¹ • X1 • CX1 • R (plus , I⊗Z) • H1 • R (plus , I⊗Z) • S1⁻¹ • CX1 • R (plus , I⊗Z) • H1 • R (plus , I⊗Z) • S1⁻¹ • X1 • CX1 • R (plus , I⊗Z) • H1 • R (plus , I⊗Z) • S1⁻¹ • H0 • CZ • H0 • R (plus , Z⊗I) • S0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • R (plus , I⊗Y) • R (plus , Z⊗I) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Z⊗Z) • R (plus , I⊗Y) • R (plus , Z⊗Y) • CZ • S0 • S0 • S1 • S1 • S1⁻¹ • S1⁻¹ • S0⁻¹ • S0⁻¹ • CZ • H0 • CZ • H0 • R (plus , Z⊗I) • S0⁻¹ • H0 • CZ • H0 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • R (plus , Z⊗I) • S0⁻¹ • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • S1 • H1 • H0 • CZ • H0 • R (plus , Z⊗I) • S0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • S1 • H1 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • H1 • S1⁻¹ • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • R (plus , I⊗Z) • R (plus , Z⊗I) • R (plus , Z⊗Z) • R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Z⊗Z) • CZ • S0 • S0 • S1 • S1 • ε
          by in-context 139 1 auto lemma-R-T0⁻¹
      equals S1 • H1 • R (plus , Z⊗Z) • T1 • H1 • T1⁻¹ • CX1 • X1 • T1 • H1 • T1⁻¹ • CX1 • T1 • H1 • T1⁻¹ • CX1 • X1 • T1 • H1 • T1⁻¹ • CX1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • S1 • H1 • H0 • CZ • H0 • R (plus , Z⊗I) • H0 • CZ • H0 • CX1 • R (plus , I⊗Z) • H1 • R (plus , I⊗Z) • S1⁻¹ • X1 • CX1 • R (plus , I⊗Z) • H1 • R (plus , I⊗Z) • S1⁻¹ • CX1 • R (plus , I⊗Z) • H1 • R (plus , I⊗Z) • S1⁻¹ • X1 • CX1 • R (plus , I⊗Z) • H1 • R (plus , I⊗Z) • S1⁻¹ • H0 • CZ • H0 • R (plus , Z⊗I) • S0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • R (plus , I⊗Y) • R (plus , Z⊗I) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Z⊗Z) • R (plus , I⊗Y) • R (plus , Z⊗Y) • CZ • S0 • S0 • S1 • S1 • S1⁻¹ • S1⁻¹ • S0⁻¹ • S0⁻¹ • CZ • H0 • CZ • H0 • R (plus , Z⊗I) • S0⁻¹ • H0 • CZ • H0 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • R (plus , Z⊗I) • S0⁻¹ • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • S1 • H1 • H0 • CZ • H0 • R (plus , Z⊗I) • S0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • S1 • H1 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • R (plus , Z⊗I) • S0⁻¹ • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • H1 • S1⁻¹ • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • R (plus , I⊗Z) • R (plus , Z⊗I) • R (plus , Z⊗Z) • R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Z⊗Z) • CZ • S0 • S0 • S1 • S1 • ε
          by in-context 155 1 auto lemma-R-T0⁻¹
      equals S1 • H1 • R (plus , Z⊗Z) • T1 • H1 • T1⁻¹ • CX1 • X1 • T1 • H1 • T1⁻¹ • CX1 • T1 • H1 • T1⁻¹ • CX1 • X1 • T1 • H1 • T1⁻¹ • CX1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • S1 • H1 • H0 • CZ • H0 • R (plus , Z⊗I) • H0 • CZ • H0 • CX1 • R (plus , I⊗Z) • H1 • R (plus , I⊗Z) • S1⁻¹ • X1 • CX1 • R (plus , I⊗Z) • H1 • R (plus , I⊗Z) • S1⁻¹ • CX1 • R (plus , I⊗Z) • H1 • R (plus , I⊗Z) • S1⁻¹ • X1 • CX1 • R (plus , I⊗Z) • H1 • R (plus , I⊗Z) • S1⁻¹ • H0 • CZ • H0 • R (plus , Z⊗I) • S0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • R (plus , I⊗Y) • R (plus , Z⊗I) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Z⊗Z) • R (plus , I⊗Y) • R (plus , Z⊗Y) • CZ • S0 • S0 • S1 • S1 • S1⁻¹ • S1⁻¹ • S0⁻¹ • S0⁻¹ • CZ • H0 • CZ • H0 • R (plus , Z⊗I) • S0⁻¹ • H0 • CZ • H0 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • R (plus , Z⊗I) • S0⁻¹ • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • S1 • H1 • H0 • CZ • H0 • R (plus , Z⊗I) • S0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • S1 • H1 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • R (plus , Z⊗I) • S0⁻¹ • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • H1 • S1⁻¹ • H0 • CZ • H0 • R (plus , Z⊗I) • S0⁻¹ • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • R (plus , I⊗Z) • R (plus , Z⊗I) • R (plus , Z⊗Z) • R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Z⊗Z) • CZ • S0 • S0 • S1 • S1 • ε
          by in-context 160 1 auto lemma-R-T0⁻¹
      equals S1 • H1 • R (plus , Z⊗Z) • T1 • H1 • T1⁻¹ • CX1 • X1 • T1 • H1 • T1⁻¹ • CX1 • T1 • H1 • T1⁻¹ • CX1 • X1 • T1 • H1 • T1⁻¹ • CX1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • S1 • H1 • H0 • CZ • H0 • R (plus , Z⊗I) • H0 • CZ • H0 • CX1 • R (plus , I⊗Z) • H1 • R (plus , I⊗Z) • S1⁻¹ • X1 • CX1 • R (plus , I⊗Z) • H1 • R (plus , I⊗Z) • S1⁻¹ • CX1 • R (plus , I⊗Z) • H1 • R (plus , I⊗Z) • S1⁻¹ • X1 • CX1 • R (plus , I⊗Z) • H1 • R (plus , I⊗Z) • S1⁻¹ • H0 • CZ • H0 • R (plus , Z⊗I) • S0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • R (plus , I⊗Y) • R (plus , Z⊗I) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Z⊗Z) • R (plus , I⊗Y) • R (plus , Z⊗Y) • CZ • S0 • S0 • S1 • S1 • S1⁻¹ • S1⁻¹ • S0⁻¹ • S0⁻¹ • CZ • H0 • CZ • H0 • R (plus , Z⊗I) • S0⁻¹ • H0 • CZ • H0 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • R (plus , Z⊗I) • S0⁻¹ • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • S1 • H1 • H0 • CZ • H0 • R (plus , Z⊗I) • S0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • S1 • H1 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • R (plus , Z⊗I) • S0⁻¹ • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • H1 • S1⁻¹ • H0 • CZ • H0 • R (plus , Z⊗I) • S0⁻¹ • H0 • CZ • H0 • R (plus , Z⊗I) • S0⁻¹ • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • R (plus , I⊗Z) • R (plus , Z⊗I) • R (plus , Z⊗Z) • R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Z⊗Z) • CZ • S0 • S0 • S1 • S1 • ε
          by in-context 171 1 auto lemma-R-T0⁻¹
      equals S1 • H1 • R (plus , Z⊗Z) • T1 • H1 • T1⁻¹ • CX1 • X1 • T1 • H1 • T1⁻¹ • CX1 • T1 • H1 • T1⁻¹ • CX1 • X1 • T1 • H1 • T1⁻¹ • CX1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • S1 • H1 • H0 • CZ • H0 • R (plus , Z⊗I) • H0 • CZ • H0 • CX1 • R (plus , I⊗Z) • H1 • R (plus , I⊗Z) • S1⁻¹ • X1 • CX1 • R (plus , I⊗Z) • H1 • R (plus , I⊗Z) • S1⁻¹ • CX1 • R (plus , I⊗Z) • H1 • R (plus , I⊗Z) • S1⁻¹ • X1 • CX1 • R (plus , I⊗Z) • H1 • R (plus , I⊗Z) • S1⁻¹ • H0 • CZ • H0 • R (plus , Z⊗I) • S0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • R (plus , I⊗Y) • R (plus , Z⊗I) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Z⊗Z) • R (plus , I⊗Y) • R (plus , Z⊗Y) • CZ • S0 • S0 • S1 • S1 • S1⁻¹ • S1⁻¹ • S0⁻¹ • S0⁻¹ • CZ • H0 • CZ • H0 • R (plus , Z⊗I) • S0⁻¹ • H0 • CZ • H0 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • R (plus , Z⊗I) • S0⁻¹ • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • S1 • H1 • H0 • CZ • H0 • R (plus , Z⊗I) • S0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • S1 • H1 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • R (plus , Z⊗I) • S0⁻¹ • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • H1 • S1⁻¹ • H0 • CZ • H0 • R (plus , Z⊗I) • S0⁻¹ • H0 • CZ • H0 • R (plus , Z⊗I) • S0⁻¹ • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • R (plus , Z⊗I) • S0⁻¹ • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • R (plus , I⊗Z) • R (plus , Z⊗I) • R (plus , Z⊗Z) • R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Z⊗Z) • CZ • S0 • S0 • S1 • S1 • ε
          by clifford-tactic 78 10 10000 auto
      equals S1 • H1 • R (plus , Z⊗Z) • T1 • H1 • T1⁻¹ • CX1 • X1 • T1 • H1 • T1⁻¹ • CX1 • T1 • H1 • T1⁻¹ • CX1 • X1 • T1 • H1 • T1⁻¹ • CX1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • S1 • H1 • H0 • CZ • H0 • R (plus , Z⊗I) • H0 • CZ • H0 • CX1 • R (plus , I⊗Z) • H1 • R (plus , I⊗Z) • S1⁻¹ • X1 • CX1 • R (plus , I⊗Z) • H1 • R (plus , I⊗Z) • S1⁻¹ • CX1 • R (plus , I⊗Z) • H1 • R (plus , I⊗Z) • S1⁻¹ • X1 • CX1 • R (plus , I⊗Z) • H1 • R (plus , I⊗Z) • S1⁻¹ • H0 • CZ • H0 • R (plus , Z⊗I) • S0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • R (plus , I⊗Y) • R (plus , Z⊗I) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Z⊗Z) • R (plus , I⊗Y) • R (plus , Z⊗Y) • H0 • CZ • H0 • R (plus , Z⊗I) • S0⁻¹ • H0 • CZ • H0 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • R (plus , Z⊗I) • S0⁻¹ • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • S1 • H1 • H0 • CZ • H0 • R (plus , Z⊗I) • S0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • S1 • H1 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • R (plus , Z⊗I) • S0⁻¹ • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • H1 • S1⁻¹ • H0 • CZ • H0 • R (plus , Z⊗I) • S0⁻¹ • H0 • CZ • H0 • R (plus , Z⊗I) • S0⁻¹ • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • R (plus , Z⊗I) • S0⁻¹ • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • R (plus , I⊗Z) • R (plus , Z⊗I) • R (plus , Z⊗Z) • R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Z⊗Z) • CZ • S0 • S0 • S1 • S1 • ε
          by clifford-tactic 82 13 10000 auto
      equals S1 • H1 • R (plus , Z⊗Z) • T1 • H1 • T1⁻¹ • CX1 • X1 • T1 • H1 • T1⁻¹ • CX1 • T1 • H1 • T1⁻¹ • CX1 • X1 • T1 • H1 • T1⁻¹ • CX1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • S1 • H1 • H0 • CZ • H0 • R (plus , Z⊗I) • H0 • CZ • H0 • CX1 • R (plus , I⊗Z) • H1 • R (plus , I⊗Z) • S1⁻¹ • X1 • CX1 • R (plus , I⊗Z) • H1 • R (plus , I⊗Z) • S1⁻¹ • CX1 • R (plus , I⊗Z) • H1 • R (plus , I⊗Z) • S1⁻¹ • X1 • CX1 • R (plus , I⊗Z) • H1 • R (plus , I⊗Z) • S1⁻¹ • H0 • CZ • H0 • R (plus , Z⊗I) • S0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • R (plus , I⊗Y) • R (plus , Z⊗I) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Z⊗Z) • R (plus , I⊗Y) • R (plus , Z⊗Y) • H0 • CZ • H0 • R (plus , Z⊗I) • S0 • H0 • CZ • H0 • S0 • S0 • S1 • S1 • Swap • R (plus , Z⊗I) • S0⁻¹ • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • S1 • H1 • H0 • CZ • H0 • R (plus , Z⊗I) • S0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • S1 • H1 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • R (plus , Z⊗I) • S0⁻¹ • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • H1 • S1⁻¹ • H0 • CZ • H0 • R (plus , Z⊗I) • S0⁻¹ • H0 • CZ • H0 • R (plus , Z⊗I) • S0⁻¹ • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • R (plus , Z⊗I) • S0⁻¹ • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • R (plus , I⊗Z) • R (plus , Z⊗I) • R (plus , Z⊗Z) • R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Z⊗Z) • CZ • S0 • S0 • S1 • S1 • ε
          by clifford-tactic 92 15 10000 auto
      equals S1 • H1 • R (plus , Z⊗Z) • T1 • H1 • T1⁻¹ • CX1 • X1 • T1 • H1 • T1⁻¹ • CX1 • T1 • H1 • T1⁻¹ • CX1 • X1 • T1 • H1 • T1⁻¹ • CX1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • S1 • H1 • H0 • CZ • H0 • R (plus , Z⊗I) • H0 • CZ • H0 • CX1 • R (plus , I⊗Z) • H1 • R (plus , I⊗Z) • S1⁻¹ • X1 • CX1 • R (plus , I⊗Z) • H1 • R (plus , I⊗Z) • S1⁻¹ • CX1 • R (plus , I⊗Z) • H1 • R (plus , I⊗Z) • S1⁻¹ • X1 • CX1 • R (plus , I⊗Z) • H1 • R (plus , I⊗Z) • S1⁻¹ • H0 • CZ • H0 • R (plus , Z⊗I) • S0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • R (plus , I⊗Y) • R (plus , Z⊗I) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Z⊗Z) • R (plus , I⊗Y) • R (plus , Z⊗Y) • H0 • CZ • H0 • R (plus , Z⊗I) • S0 • H0 • CZ • H0 • S0 • S0 • S1 • S1 • Swap • R (plus , Z⊗I) • CZ • H0 • H1 • CZ • H1 • R (plus , Z⊗I) • S0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • S1 • H1 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • R (plus , Z⊗I) • S0⁻¹ • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • H1 • S1⁻¹ • H0 • CZ • H0 • R (plus , Z⊗I) • S0⁻¹ • H0 • CZ • H0 • R (plus , Z⊗I) • S0⁻¹ • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • R (plus , Z⊗I) • S0⁻¹ • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • R (plus , I⊗Z) • R (plus , Z⊗I) • R (plus , Z⊗Z) • R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Z⊗Z) • CZ • S0 • S0 • S1 • S1 • ε
          by clifford-tactic 98 17 10000 auto
      equals S1 • H1 • R (plus , Z⊗Z) • T1 • H1 • T1⁻¹ • CX1 • X1 • T1 • H1 • T1⁻¹ • CX1 • T1 • H1 • T1⁻¹ • CX1 • X1 • T1 • H1 • T1⁻¹ • CX1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • S1 • H1 • H0 • CZ • H0 • R (plus , Z⊗I) • H0 • CZ • H0 • CX1 • R (plus , I⊗Z) • H1 • R (plus , I⊗Z) • S1⁻¹ • X1 • CX1 • R (plus , I⊗Z) • H1 • R (plus , I⊗Z) • S1⁻¹ • CX1 • R (plus , I⊗Z) • H1 • R (plus , I⊗Z) • S1⁻¹ • X1 • CX1 • R (plus , I⊗Z) • H1 • R (plus , I⊗Z) • S1⁻¹ • H0 • CZ • H0 • R (plus , Z⊗I) • S0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • R (plus , I⊗Y) • R (plus , Z⊗I) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Z⊗Z) • R (plus , I⊗Y) • R (plus , Z⊗Y) • H0 • CZ • H0 • R (plus , Z⊗I) • S0 • H0 • CZ • H0 • S0 • S0 • S1 • S1 • Swap • R (plus , Z⊗I) • CZ • H0 • H1 • CZ • H1 • R (plus , Z⊗I) • S0 • H0 • CZ • H0 • S0 • S0 • S1 • S1 • Swap • R (plus , Z⊗I) • S0⁻¹ • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • H1 • S1⁻¹ • H0 • CZ • H0 • R (plus , Z⊗I) • S0⁻¹ • H0 • CZ • H0 • R (plus , Z⊗I) • S0⁻¹ • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • R (plus , Z⊗I) • S0⁻¹ • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • R (plus , I⊗Z) • R (plus , Z⊗I) • R (plus , Z⊗Z) • R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Z⊗Z) • CZ • S0 • S0 • S1 • S1 • ε
          by clifford-tactic 108 15 10000 auto
      equals S1 • H1 • R (plus , Z⊗Z) • T1 • H1 • T1⁻¹ • CX1 • X1 • T1 • H1 • T1⁻¹ • CX1 • T1 • H1 • T1⁻¹ • CX1 • X1 • T1 • H1 • T1⁻¹ • CX1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • S1 • H1 • H0 • CZ • H0 • R (plus , Z⊗I) • H0 • CZ • H0 • CX1 • R (plus , I⊗Z) • H1 • R (plus , I⊗Z) • S1⁻¹ • X1 • CX1 • R (plus , I⊗Z) • H1 • R (plus , I⊗Z) • S1⁻¹ • CX1 • R (plus , I⊗Z) • H1 • R (plus , I⊗Z) • S1⁻¹ • X1 • CX1 • R (plus , I⊗Z) • H1 • R (plus , I⊗Z) • S1⁻¹ • H0 • CZ • H0 • R (plus , Z⊗I) • S0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • R (plus , I⊗Y) • R (plus , Z⊗I) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Z⊗Z) • R (plus , I⊗Y) • R (plus , Z⊗Y) • H0 • CZ • H0 • R (plus , Z⊗I) • S0 • H0 • CZ • H0 • S0 • S0 • S1 • S1 • Swap • R (plus , Z⊗I) • CZ • H0 • H1 • CZ • H1 • R (plus , Z⊗I) • S0 • H0 • CZ • H0 • S0 • S0 • S1 • S1 • Swap • R (plus , Z⊗I) • S0 • H0 • H1 • CZ • S0 • H0 • S0 • S0 • H0 • S1 • S1 • H1 • W ^ 6 • Swap • R (plus , Z⊗I) • S0⁻¹ • H0 • CZ • H0 • R (plus , Z⊗I) • S0⁻¹ • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • R (plus , Z⊗I) • S0⁻¹ • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • R (plus , I⊗Z) • R (plus , Z⊗I) • R (plus , Z⊗Z) • R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Z⊗Z) • CZ • S0 • S0 • S1 • S1 • ε
          by general-assoc auto
      equals S1 • H1 • R (plus , Z⊗Z) • T1 • H1 • T1⁻¹ • CX1 • X1 • T1 • H1 • T1⁻¹ • CX1 • T1 • H1 • T1⁻¹ • CX1 • X1 • T1 • H1 • T1⁻¹ • CX1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • S1 • H1 • H0 • CZ • H0 • R (plus , Z⊗I) • H0 • CZ • H0 • CX1 • R (plus , I⊗Z) • H1 • R (plus , I⊗Z) • S1⁻¹ • X1 • CX1 • R (plus , I⊗Z) • H1 • R (plus , I⊗Z) • S1⁻¹ • CX1 • R (plus , I⊗Z) • H1 • R (plus , I⊗Z) • S1⁻¹ • X1 • CX1 • R (plus , I⊗Z) • H1 • R (plus , I⊗Z) • S1⁻¹ • H0 • CZ • H0 • R (plus , Z⊗I) • S0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • R (plus , I⊗Y) • R (plus , Z⊗I) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Z⊗Z) • R (plus , I⊗Y) • R (plus , Z⊗Y) • H0 • CZ • H0 • R (plus , Z⊗I) • S0 • H0 • CZ • H0 • S0 • S0 • S1 • S1 • Swap • R (plus , Z⊗I) • CZ • H0 • H1 • CZ • H1 • R (plus , Z⊗I) • S0 • H0 • CZ • H0 • S0 • S0 • S1 • S1 • Swap • R (plus , Z⊗I) • S0 • H0 • H1 • CZ • S0 • H0 • S0 • S0 • H0 • S1 • S1 • H1 • W ^ 6 • Swap • R (plus , Z⊗I) • S0⁻¹ • H0 • CZ • H0 • R (plus , Z⊗I) • S0 • S0 • S0 • Swap • R (plus , Z⊗I) • S0 • S0 • S0 • Swap • R (plus , I⊗Z) • R (plus , Z⊗I) • R (plus , Z⊗Z) • R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Z⊗Z) • CZ • S0 • S0 • S1 • S1 • ε
          by in-context 30 6 auto (lemma-R (C.S1 • C.H1 • C.H0 • C.CZ • C.H0) (plus , Z⊗I))
      equals S1 • H1 • R (plus , Z⊗Z) • T1 • H1 • T1⁻¹ • CX1 • X1 • T1 • H1 • T1⁻¹ • CX1 • T1 • H1 • T1⁻¹ • CX1 • X1 • T1 • H1 • T1⁻¹ • CX1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • R (plus , Z⊗Y) • S1 • H1 • H0 • CZ • H0 • H0 • CZ • H0 • CX1 • R (plus , I⊗Z) • H1 • R (plus , I⊗Z) • S1⁻¹ • X1 • CX1 • R (plus , I⊗Z) • H1 • R (plus , I⊗Z) • S1⁻¹ • CX1 • R (plus , I⊗Z) • H1 • R (plus , I⊗Z) • S1⁻¹ • X1 • CX1 • R (plus , I⊗Z) • H1 • R (plus , I⊗Z) • S1⁻¹ • H0 • CZ • H0 • R (plus , Z⊗I) • S0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • R (plus , I⊗Y) • R (plus , Z⊗I) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Z⊗Z) • R (plus , I⊗Y) • R (plus , Z⊗Y) • H0 • CZ • H0 • R (plus , Z⊗I) • S0 • H0 • CZ • H0 • S0 • S0 • S1 • S1 • Swap • R (plus , Z⊗I) • CZ • H0 • H1 • CZ • H1 • R (plus , Z⊗I) • S0 • H0 • CZ • H0 • S0 • S0 • S1 • S1 • Swap • R (plus , Z⊗I) • S0 • H0 • H1 • CZ • S0 • H0 • S0 • S0 • H0 • S1 • S1 • H1 • W ^ 6 • Swap • R (plus , Z⊗I) • S0⁻¹ • H0 • CZ • H0 • R (plus , Z⊗I) • S0 • S0 • S0 • Swap • R (plus , Z⊗I) • S0 • S0 • S0 • Swap • R (plus , I⊗Z) • R (plus , Z⊗I) • R (plus , Z⊗Z) • R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Z⊗Z) • CZ • S0 • S0 • S1 • S1 • ε
          by clifford-tactic 31 9 10000 auto
      equals S1 • H1 • R (plus , Z⊗Z) • T1 • H1 • T1⁻¹ • CX1 • X1 • T1 • H1 • T1⁻¹ • CX1 • T1 • H1 • T1⁻¹ • CX1 • X1 • T1 • H1 • T1⁻¹ • CX1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • R (plus , Z⊗Y) • CZ • S1 • H1 • R (plus , I⊗Z) • H1 • R (plus , I⊗Z) • S1⁻¹ • X1 • CX1 • R (plus , I⊗Z) • H1 • R (plus , I⊗Z) • S1⁻¹ • CX1 • R (plus , I⊗Z) • H1 • R (plus , I⊗Z) • S1⁻¹ • X1 • CX1 • R (plus , I⊗Z) • H1 • R (plus , I⊗Z) • S1⁻¹ • H0 • CZ • H0 • R (plus , Z⊗I) • S0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • R (plus , I⊗Y) • R (plus , Z⊗I) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Z⊗Z) • R (plus , I⊗Y) • R (plus , Z⊗Y) • H0 • CZ • H0 • R (plus , Z⊗I) • S0 • H0 • CZ • H0 • S0 • S0 • S1 • S1 • Swap • R (plus , Z⊗I) • CZ • H0 • H1 • CZ • H1 • R (plus , Z⊗I) • S0 • H0 • CZ • H0 • S0 • S0 • S1 • S1 • Swap • R (plus , Z⊗I) • S0 • H0 • H1 • CZ • S0 • H0 • S0 • S0 • H0 • S1 • S1 • H1 • W ^ 6 • Swap • R (plus , Z⊗I) • S0⁻¹ • H0 • CZ • H0 • R (plus , Z⊗I) • S0 • S0 • S0 • Swap • R (plus , Z⊗I) • S0 • S0 • S0 • Swap • R (plus , I⊗Z) • R (plus , Z⊗I) • R (plus , Z⊗Z) • R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Z⊗Z) • CZ • S0 • S0 • S1 • S1 • ε
          by in-context 31 4 auto (lemma-R (C.CZ • C.S1 • C.H1) (plus , I⊗Z))
      equals S1 • H1 • R (plus , Z⊗Z) • T1 • H1 • T1⁻¹ • CX1 • X1 • T1 • H1 • T1⁻¹ • CX1 • T1 • H1 • T1⁻¹ • CX1 • X1 • T1 • H1 • T1⁻¹ • CX1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • R (plus , Z⊗Y) • R (plus , Z⊗Y) • CZ • S1 • H1 • H1 • R (plus , I⊗Z) • S1⁻¹ • X1 • CX1 • R (plus , I⊗Z) • H1 • R (plus , I⊗Z) • S1⁻¹ • CX1 • R (plus , I⊗Z) • H1 • R (plus , I⊗Z) • S1⁻¹ • X1 • CX1 • R (plus , I⊗Z) • H1 • R (plus , I⊗Z) • S1⁻¹ • H0 • CZ • H0 • R (plus , Z⊗I) • S0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • R (plus , I⊗Y) • R (plus , Z⊗I) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Z⊗Z) • R (plus , I⊗Y) • R (plus , Z⊗Y) • H0 • CZ • H0 • R (plus , Z⊗I) • S0 • H0 • CZ • H0 • S0 • S0 • S1 • S1 • Swap • R (plus , Z⊗I) • CZ • H0 • H1 • CZ • H1 • R (plus , Z⊗I) • S0 • H0 • CZ • H0 • S0 • S0 • S1 • S1 • Swap • R (plus , Z⊗I) • S0 • H0 • H1 • CZ • S0 • H0 • S0 • S0 • H0 • S1 • S1 • H1 • W ^ 6 • Swap • R (plus , Z⊗I) • S0⁻¹ • H0 • CZ • H0 • R (plus , Z⊗I) • S0 • S0 • S0 • Swap • R (plus , Z⊗I) • S0 • S0 • S0 • Swap • R (plus , I⊗Z) • R (plus , Z⊗I) • R (plus , Z⊗Z) • R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Z⊗Z) • CZ • S0 • S0 • S1 • S1 • ε
          by clifford-tactic 34 2 10000 auto
      equals S1 • H1 • R (plus , Z⊗Z) • T1 • H1 • T1⁻¹ • CX1 • X1 • T1 • H1 • T1⁻¹ • CX1 • T1 • H1 • T1⁻¹ • CX1 • X1 • T1 • H1 • T1⁻¹ • CX1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • R (plus , Z⊗Y) • R (plus , Z⊗Y) • CZ • S1 • R (plus , I⊗Z) • S1⁻¹ • X1 • CX1 • R (plus , I⊗Z) • H1 • R (plus , I⊗Z) • S1⁻¹ • CX1 • R (plus , I⊗Z) • H1 • R (plus , I⊗Z) • S1⁻¹ • X1 • CX1 • R (plus , I⊗Z) • H1 • R (plus , I⊗Z) • S1⁻¹ • H0 • CZ • H0 • R (plus , Z⊗I) • S0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • R (plus , I⊗Y) • R (plus , Z⊗I) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Z⊗Z) • R (plus , I⊗Y) • R (plus , Z⊗Y) • H0 • CZ • H0 • R (plus , Z⊗I) • S0 • H0 • CZ • H0 • S0 • S0 • S1 • S1 • Swap • R (plus , Z⊗I) • CZ • H0 • H1 • CZ • H1 • R (plus , Z⊗I) • S0 • H0 • CZ • H0 • S0 • S0 • S1 • S1 • Swap • R (plus , Z⊗I) • S0 • H0 • H1 • CZ • S0 • H0 • S0 • S0 • H0 • S1 • S1 • H1 • W ^ 6 • Swap • R (plus , Z⊗I) • S0⁻¹ • H0 • CZ • H0 • R (plus , Z⊗I) • S0 • S0 • S0 • Swap • R (plus , Z⊗I) • S0 • S0 • S0 • Swap • R (plus , I⊗Z) • R (plus , Z⊗I) • R (plus , Z⊗Z) • R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Z⊗Z) • CZ • S0 • S0 • S1 • S1 • ε
          by in-context 32 3 auto (lemma-R (C.CZ • C.S1) (plus , I⊗Z))
      equals S1 • H1 • R (plus , Z⊗Z) • T1 • H1 • T1⁻¹ • CX1 • X1 • T1 • H1 • T1⁻¹ • CX1 • T1 • H1 • T1⁻¹ • CX1 • X1 • T1 • H1 • T1⁻¹ • CX1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • R (plus , Z⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • CZ • S1 • S1⁻¹ • X1 • CX1 • R (plus , I⊗Z) • H1 • R (plus , I⊗Z) • S1⁻¹ • CX1 • R (plus , I⊗Z) • H1 • R (plus , I⊗Z) • S1⁻¹ • X1 • CX1 • R (plus , I⊗Z) • H1 • R (plus , I⊗Z) • S1⁻¹ • H0 • CZ • H0 • R (plus , Z⊗I) • S0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • R (plus , I⊗Y) • R (plus , Z⊗I) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Z⊗Z) • R (plus , I⊗Y) • R (plus , Z⊗Y) • H0 • CZ • H0 • R (plus , Z⊗I) • S0 • H0 • CZ • H0 • S0 • S0 • S1 • S1 • Swap • R (plus , Z⊗I) • CZ • H0 • H1 • CZ • H1 • R (plus , Z⊗I) • S0 • H0 • CZ • H0 • S0 • S0 • S1 • S1 • Swap • R (plus , Z⊗I) • S0 • H0 • H1 • CZ • S0 • H0 • S0 • S0 • H0 • S1 • S1 • H1 • W ^ 6 • Swap • R (plus , Z⊗I) • S0⁻¹ • H0 • CZ • H0 • R (plus , Z⊗I) • S0 • S0 • S0 • Swap • R (plus , Z⊗I) • S0 • S0 • S0 • Swap • R (plus , I⊗Z) • R (plus , Z⊗I) • R (plus , Z⊗Z) • R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Z⊗Z) • CZ • S0 • S0 • S1 • S1 • ε
          by in-context 33 6 auto (lemma-R (C.CZ • C.S1 • C.S1⁻¹ • C.X1 • C.CX1) (plus , I⊗Z))
      equals S1 • H1 • R (plus , Z⊗Z) • T1 • H1 • T1⁻¹ • CX1 • X1 • T1 • H1 • T1⁻¹ • CX1 • T1 • H1 • T1⁻¹ • CX1 • X1 • T1 • H1 • T1⁻¹ • CX1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • R (plus , Z⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (minus , Z⊗Z) • CZ • S1 • S1⁻¹ • X1 • CX1 • H1 • R (plus , I⊗Z) • S1⁻¹ • CX1 • R (plus , I⊗Z) • H1 • R (plus , I⊗Z) • S1⁻¹ • X1 • CX1 • R (plus , I⊗Z) • H1 • R (plus , I⊗Z) • S1⁻¹ • H0 • CZ • H0 • R (plus , Z⊗I) • S0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • R (plus , I⊗Y) • R (plus , Z⊗I) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Z⊗Z) • R (plus , I⊗Y) • R (plus , Z⊗Y) • H0 • CZ • H0 • R (plus , Z⊗I) • S0 • H0 • CZ • H0 • S0 • S0 • S1 • S1 • Swap • R (plus , Z⊗I) • CZ • H0 • H1 • CZ • H1 • R (plus , Z⊗I) • S0 • H0 • CZ • H0 • S0 • S0 • S1 • S1 • Swap • R (plus , Z⊗I) • S0 • H0 • H1 • CZ • S0 • H0 • S0 • S0 • H0 • S1 • S1 • H1 • W ^ 6 • Swap • R (plus , Z⊗I) • S0⁻¹ • H0 • CZ • H0 • R (plus , Z⊗I) • S0 • S0 • S0 • Swap • R (plus , Z⊗I) • S0 • S0 • S0 • Swap • R (plus , I⊗Z) • R (plus , Z⊗I) • R (plus , Z⊗Z) • R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Z⊗Z) • CZ • S0 • S0 • S1 • S1 • ε
          by in-context 34 7 auto (lemma-R (C.CZ • C.S1 • C.S1⁻¹ • C.X1 • C.CX1 • C.H1) (plus , I⊗Z))
      equals S1 • H1 • R (plus , Z⊗Z) • T1 • H1 • T1⁻¹ • CX1 • X1 • T1 • H1 • T1⁻¹ • CX1 • T1 • H1 • T1⁻¹ • CX1 • X1 • T1 • H1 • T1⁻¹ • CX1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • R (plus , Z⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (minus , Z⊗Z) • R (plus , Z⊗X) • CZ • S1 • S1⁻¹ • X1 • CX1 • H1 • S1⁻¹ • CX1 • R (plus , I⊗Z) • H1 • R (plus , I⊗Z) • S1⁻¹ • X1 • CX1 • R (plus , I⊗Z) • H1 • R (plus , I⊗Z) • S1⁻¹ • H0 • CZ • H0 • R (plus , Z⊗I) • S0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • R (plus , I⊗Y) • R (plus , Z⊗I) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Z⊗Z) • R (plus , I⊗Y) • R (plus , Z⊗Y) • H0 • CZ • H0 • R (plus , Z⊗I) • S0 • H0 • CZ • H0 • S0 • S0 • S1 • S1 • Swap • R (plus , Z⊗I) • CZ • H0 • H1 • CZ • H1 • R (plus , Z⊗I) • S0 • H0 • CZ • H0 • S0 • S0 • S1 • S1 • Swap • R (plus , Z⊗I) • S0 • H0 • H1 • CZ • S0 • H0 • S0 • S0 • H0 • S1 • S1 • H1 • W ^ 6 • Swap • R (plus , Z⊗I) • S0⁻¹ • H0 • CZ • H0 • R (plus , Z⊗I) • S0 • S0 • S0 • Swap • R (plus , Z⊗I) • S0 • S0 • S0 • Swap • R (plus , I⊗Z) • R (plus , Z⊗I) • R (plus , Z⊗Z) • R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Z⊗Z) • CZ • S0 • S0 • S1 • S1 • ε
          by clifford-tactic 35 8 10000 auto
      equals S1 • H1 • R (plus , Z⊗Z) • T1 • H1 • T1⁻¹ • CX1 • X1 • T1 • H1 • T1⁻¹ • CX1 • T1 • H1 • T1⁻¹ • CX1 • X1 • T1 • H1 • T1⁻¹ • CX1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • R (plus , Z⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (minus , Z⊗Z) • R (plus , Z⊗X) • S0 • S0 • S0 • H1 • S1 • R (plus , I⊗Z) • H1 • R (plus , I⊗Z) • S1⁻¹ • X1 • CX1 • R (plus , I⊗Z) • H1 • R (plus , I⊗Z) • S1⁻¹ • H0 • CZ • H0 • R (plus , Z⊗I) • S0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • R (plus , I⊗Y) • R (plus , Z⊗I) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Z⊗Z) • R (plus , I⊗Y) • R (plus , Z⊗Y) • H0 • CZ • H0 • R (plus , Z⊗I) • S0 • H0 • CZ • H0 • S0 • S0 • S1 • S1 • Swap • R (plus , Z⊗I) • CZ • H0 • H1 • CZ • H1 • R (plus , Z⊗I) • S0 • H0 • CZ • H0 • S0 • S0 • S1 • S1 • Swap • R (plus , Z⊗I) • S0 • H0 • H1 • CZ • S0 • H0 • S0 • S0 • H0 • S1 • S1 • H1 • W ^ 6 • Swap • R (plus , Z⊗I) • S0⁻¹ • H0 • CZ • H0 • R (plus , Z⊗I) • S0 • S0 • S0 • Swap • R (plus , Z⊗I) • S0 • S0 • S0 • Swap • R (plus , I⊗Z) • R (plus , Z⊗I) • R (plus , Z⊗Z) • R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Z⊗Z) • CZ • S0 • S0 • S1 • S1 • ε
          by in-context 35 6 auto (lemma-R (C.S0 • C.S0 • C.S0 • C.H1 • C.S1) (plus , I⊗Z))
      equals S1 • H1 • R (plus , Z⊗Z) • T1 • H1 • T1⁻¹ • CX1 • X1 • T1 • H1 • T1⁻¹ • CX1 • T1 • H1 • T1⁻¹ • CX1 • X1 • T1 • H1 • T1⁻¹ • CX1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • R (plus , Z⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (minus , Z⊗Z) • R (plus , Z⊗X) • R (plus , I⊗X) • S0 • S0 • S0 • H1 • S1 • H1 • R (plus , I⊗Z) • S1⁻¹ • X1 • CX1 • R (plus , I⊗Z) • H1 • R (plus , I⊗Z) • S1⁻¹ • H0 • CZ • H0 • R (plus , Z⊗I) • S0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • R (plus , I⊗Y) • R (plus , Z⊗I) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Z⊗Z) • R (plus , I⊗Y) • R (plus , Z⊗Y) • H0 • CZ • H0 • R (plus , Z⊗I) • S0 • H0 • CZ • H0 • S0 • S0 • S1 • S1 • Swap • R (plus , Z⊗I) • CZ • H0 • H1 • CZ • H1 • R (plus , Z⊗I) • S0 • H0 • CZ • H0 • S0 • S0 • S1 • S1 • Swap • R (plus , Z⊗I) • S0 • H0 • H1 • CZ • S0 • H0 • S0 • S0 • H0 • S1 • S1 • H1 • W ^ 6 • Swap • R (plus , Z⊗I) • S0⁻¹ • H0 • CZ • H0 • R (plus , Z⊗I) • S0 • S0 • S0 • Swap • R (plus , Z⊗I) • S0 • S0 • S0 • Swap • R (plus , I⊗Z) • R (plus , Z⊗I) • R (plus , Z⊗Z) • R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Z⊗Z) • CZ • S0 • S0 • S1 • S1 • ε
          by in-context 36 7 auto (lemma-R (C.S0 • C.S0 • C.S0 • C.H1 • C.S1 • C.H1) (plus , I⊗Z))
      equals S1 • H1 • R (plus , Z⊗Z) • T1 • H1 • T1⁻¹ • CX1 • X1 • T1 • H1 • T1⁻¹ • CX1 • T1 • H1 • T1⁻¹ • CX1 • X1 • T1 • H1 • T1⁻¹ • CX1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • R (plus , Z⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (minus , Z⊗Z) • R (plus , Z⊗X) • R (plus , I⊗X) • R (minus , I⊗Y) • S0 • S0 • S0 • H1 • S1 • H1 • S1⁻¹ • X1 • CX1 • R (plus , I⊗Z) • H1 • R (plus , I⊗Z) • S1⁻¹ • H0 • CZ • H0 • R (plus , Z⊗I) • S0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • R (plus , I⊗Y) • R (plus , Z⊗I) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Z⊗Z) • R (plus , I⊗Y) • R (plus , Z⊗Y) • H0 • CZ • H0 • R (plus , Z⊗I) • S0 • H0 • CZ • H0 • S0 • S0 • S1 • S1 • Swap • R (plus , Z⊗I) • CZ • H0 • H1 • CZ • H1 • R (plus , Z⊗I) • S0 • H0 • CZ • H0 • S0 • S0 • S1 • S1 • Swap • R (plus , Z⊗I) • S0 • H0 • H1 • CZ • S0 • H0 • S0 • S0 • H0 • S1 • S1 • H1 • W ^ 6 • Swap • R (plus , Z⊗I) • S0⁻¹ • H0 • CZ • H0 • R (plus , Z⊗I) • S0 • S0 • S0 • Swap • R (plus , Z⊗I) • S0 • S0 • S0 • Swap • R (plus , I⊗Z) • R (plus , Z⊗I) • R (plus , Z⊗Z) • R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Z⊗Z) • CZ • S0 • S0 • S1 • S1 • ε
          by clifford-tactic 37 9 10000 auto
      equals S1 • H1 • R (plus , Z⊗Z) • T1 • H1 • T1⁻¹ • CX1 • X1 • T1 • H1 • T1⁻¹ • CX1 • T1 • H1 • T1⁻¹ • CX1 • X1 • T1 • H1 • T1⁻¹ • CX1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • R (plus , Z⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (minus , Z⊗Z) • R (plus , Z⊗X) • R (plus , I⊗X) • R (minus , I⊗Y) • CZ • S0 • S1 • H1 • S1 • S1 • W ^ 5 • R (plus , I⊗Z) • H1 • R (plus , I⊗Z) • S1⁻¹ • H0 • CZ • H0 • R (plus , Z⊗I) • S0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • R (plus , I⊗Y) • R (plus , Z⊗I) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Z⊗Z) • R (plus , I⊗Y) • R (plus , Z⊗Y) • H0 • CZ • H0 • R (plus , Z⊗I) • S0 • H0 • CZ • H0 • S0 • S0 • S1 • S1 • Swap • R (plus , Z⊗I) • CZ • H0 • H1 • CZ • H1 • R (plus , Z⊗I) • S0 • H0 • CZ • H0 • S0 • S0 • S1 • S1 • Swap • R (plus , Z⊗I) • S0 • H0 • H1 • CZ • S0 • H0 • S0 • S0 • H0 • S1 • S1 • H1 • W ^ 6 • Swap • R (plus , Z⊗I) • S0⁻¹ • H0 • CZ • H0 • R (plus , Z⊗I) • S0 • S0 • S0 • Swap • R (plus , Z⊗I) • S0 • S0 • S0 • Swap • R (plus , I⊗Z) • R (plus , Z⊗I) • R (plus , Z⊗Z) • R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Z⊗Z) • CZ • S0 • S0 • S1 • S1 • ε
          by in-context 37 8 auto (lemma-R (C.CZ • C.S0 • C.S1 • C.H1 • C.S1 • C.S1 • C.W ^ 5) (plus , I⊗Z))
      equals S1 • H1 • R (plus , Z⊗Z) • T1 • H1 • T1⁻¹ • CX1 • X1 • T1 • H1 • T1⁻¹ • CX1 • T1 • H1 • T1⁻¹ • CX1 • X1 • T1 • H1 • T1⁻¹ • CX1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • R (plus , Z⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (minus , Z⊗Z) • R (plus , Z⊗X) • R (plus , I⊗X) • R (minus , I⊗Y) • R (plus , Z⊗Y) • CZ • S0 • S1 • H1 • S1 • S1 • W ^ 5 • H1 • R (plus , I⊗Z) • S1⁻¹ • H0 • CZ • H0 • R (plus , Z⊗I) • S0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • R (plus , I⊗Y) • R (plus , Z⊗I) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Z⊗Z) • R (plus , I⊗Y) • R (plus , Z⊗Y) • H0 • CZ • H0 • R (plus , Z⊗I) • S0 • H0 • CZ • H0 • S0 • S0 • S1 • S1 • Swap • R (plus , Z⊗I) • CZ • H0 • H1 • CZ • H1 • R (plus , Z⊗I) • S0 • H0 • CZ • H0 • S0 • S0 • S1 • S1 • Swap • R (plus , Z⊗I) • S0 • H0 • H1 • CZ • S0 • H0 • S0 • S0 • H0 • S1 • S1 • H1 • W ^ 6 • Swap • R (plus , Z⊗I) • S0⁻¹ • H0 • CZ • H0 • R (plus , Z⊗I) • S0 • S0 • S0 • Swap • R (plus , Z⊗I) • S0 • S0 • S0 • Swap • R (plus , I⊗Z) • R (plus , Z⊗I) • R (plus , Z⊗Z) • R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Z⊗Z) • CZ • S0 • S0 • S1 • S1 • ε
          by in-context 38 9 auto (lemma-R (C.CZ • C.S0 • C.S1 • C.H1 • C.S1 • C.S1 • C.W ^ 5 • C.H1) (plus , I⊗Z))
      equals S1 • H1 • R (plus , Z⊗Z) • T1 • H1 • T1⁻¹ • CX1 • X1 • T1 • H1 • T1⁻¹ • CX1 • T1 • H1 • T1⁻¹ • CX1 • X1 • T1 • H1 • T1⁻¹ • CX1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • R (plus , Z⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (minus , Z⊗Z) • R (plus , Z⊗X) • R (plus , I⊗X) • R (minus , I⊗Y) • R (plus , Z⊗Y) • R (minus , I⊗Z) • CZ • S0 • S1 • H1 • S1 • S1 • W ^ 5 • H1 • S1⁻¹ • H0 • CZ • H0 • R (plus , Z⊗I) • S0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • R (plus , I⊗Y) • R (plus , Z⊗I) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Z⊗Z) • R (plus , I⊗Y) • R (plus , Z⊗Y) • H0 • CZ • H0 • R (plus , Z⊗I) • S0 • H0 • CZ • H0 • S0 • S0 • S1 • S1 • Swap • R (plus , Z⊗I) • CZ • H0 • H1 • CZ • H1 • R (plus , Z⊗I) • S0 • H0 • CZ • H0 • S0 • S0 • S1 • S1 • Swap • R (plus , Z⊗I) • S0 • H0 • H1 • CZ • S0 • H0 • S0 • S0 • H0 • S1 • S1 • H1 • W ^ 6 • Swap • R (plus , Z⊗I) • S0⁻¹ • H0 • CZ • H0 • R (plus , Z⊗I) • S0 • S0 • S0 • Swap • R (plus , Z⊗I) • S0 • S0 • S0 • Swap • R (plus , I⊗Z) • R (plus , Z⊗I) • R (plus , Z⊗Z) • R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Z⊗Z) • CZ • S0 • S0 • S1 • S1 • ε
          by in-context 39 13 auto (lemma-R (C.CZ • C.S0 • C.S1 • C.H1 • C.S1 • C.S1 • C.W ^ 5 • C.H1 • C.S1⁻¹ • C.H0 • C.CZ • C.H0) (plus , Z⊗I))
      equals S1 • H1 • R (plus , Z⊗Z) • T1 • H1 • T1⁻¹ • CX1 • X1 • T1 • H1 • T1⁻¹ • CX1 • T1 • H1 • T1⁻¹ • CX1 • X1 • T1 • H1 • T1⁻¹ • CX1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • R (plus , Z⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (minus , Z⊗Z) • R (plus , Z⊗X) • R (plus , I⊗X) • R (minus , I⊗Y) • R (plus , Z⊗Y) • R (minus , I⊗Z) • R (minus , Z⊗Z) • CZ • S0 • S1 • H1 • S1 • S1 • W ^ 5 • H1 • S1⁻¹ • H0 • CZ • H0 • S0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • R (plus , I⊗Y) • R (plus , Z⊗I) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Z⊗Z) • R (plus , I⊗Y) • R (plus , Z⊗Y) • H0 • CZ • H0 • R (plus , Z⊗I) • S0 • H0 • CZ • H0 • S0 • S0 • S1 • S1 • Swap • R (plus , Z⊗I) • CZ • H0 • H1 • CZ • H1 • R (plus , Z⊗I) • S0 • H0 • CZ • H0 • S0 • S0 • S1 • S1 • Swap • R (plus , Z⊗I) • S0 • H0 • H1 • CZ • S0 • H0 • S0 • S0 • H0 • S1 • S1 • H1 • W ^ 6 • Swap • R (plus , Z⊗I) • S0⁻¹ • H0 • CZ • H0 • R (plus , Z⊗I) • S0 • S0 • S0 • Swap • R (plus , Z⊗I) • S0 • S0 • S0 • Swap • R (plus , I⊗Z) • R (plus , Z⊗I) • R (plus , Z⊗Z) • R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Z⊗Z) • CZ • S0 • S0 • S1 • S1 • ε
          by clifford-tactic 40 18 10000 auto
      equals S1 • H1 • R (plus , Z⊗Z) • T1 • H1 • T1⁻¹ • CX1 • X1 • T1 • H1 • T1⁻¹ • CX1 • T1 • H1 • T1⁻¹ • CX1 • X1 • T1 • H1 • T1⁻¹ • CX1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • R (plus , Z⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (minus , Z⊗Z) • R (plus , Z⊗X) • R (plus , I⊗X) • R (minus , I⊗Y) • R (plus , Z⊗Y) • R (minus , I⊗Z) • R (minus , Z⊗Z) • S0 • S0 • S1 • S1 • S1 • H1 • S1 • W • R (plus , I⊗Y) • R (plus , Z⊗I) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Z⊗Z) • R (plus , I⊗Y) • R (plus , Z⊗Y) • H0 • CZ • H0 • R (plus , Z⊗I) • S0 • H0 • CZ • H0 • S0 • S0 • S1 • S1 • Swap • R (plus , Z⊗I) • CZ • H0 • H1 • CZ • H1 • R (plus , Z⊗I) • S0 • H0 • CZ • H0 • S0 • S0 • S1 • S1 • Swap • R (plus , Z⊗I) • S0 • H0 • H1 • CZ • S0 • H0 • S0 • S0 • H0 • S1 • S1 • H1 • W ^ 6 • Swap • R (plus , Z⊗I) • S0⁻¹ • H0 • CZ • H0 • R (plus , Z⊗I) • S0 • S0 • S0 • Swap • R (plus , Z⊗I) • S0 • S0 • S0 • Swap • R (plus , I⊗Z) • R (plus , Z⊗I) • R (plus , Z⊗Z) • R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Z⊗Z) • CZ • S0 • S0 • S1 • S1 • ε
          by in-context 40 9 auto (lemma-R (C.S0 • C.S0 • C.S1 • C.S1 • C.S1 • C.H1 • C.S1 • C.W) (plus , I⊗Y))
      equals S1 • H1 • R (plus , Z⊗Z) • T1 • H1 • T1⁻¹ • CX1 • X1 • T1 • H1 • T1⁻¹ • CX1 • T1 • H1 • T1⁻¹ • CX1 • X1 • T1 • H1 • T1⁻¹ • CX1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • R (plus , Z⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (minus , Z⊗Z) • R (plus , Z⊗X) • R (plus , I⊗X) • R (minus , I⊗Y) • R (plus , Z⊗Y) • R (minus , I⊗Z) • R (minus , Z⊗Z) • R (minus , I⊗Z) • S0 • S0 • S1 • S1 • S1 • H1 • S1 • W • R (plus , Z⊗I) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Z⊗Z) • R (plus , I⊗Y) • R (plus , Z⊗Y) • H0 • CZ • H0 • R (plus , Z⊗I) • S0 • H0 • CZ • H0 • S0 • S0 • S1 • S1 • Swap • R (plus , Z⊗I) • CZ • H0 • H1 • CZ • H1 • R (plus , Z⊗I) • S0 • H0 • CZ • H0 • S0 • S0 • S1 • S1 • Swap • R (plus , Z⊗I) • S0 • H0 • H1 • CZ • S0 • H0 • S0 • S0 • H0 • S1 • S1 • H1 • W ^ 6 • Swap • R (plus , Z⊗I) • S0⁻¹ • H0 • CZ • H0 • R (plus , Z⊗I) • S0 • S0 • S0 • Swap • R (plus , Z⊗I) • S0 • S0 • S0 • Swap • R (plus , I⊗Z) • R (plus , Z⊗I) • R (plus , Z⊗Z) • R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Z⊗Z) • CZ • S0 • S0 • S1 • S1 • ε
          by in-context 41 9 auto (lemma-R (C.S0 • C.S0 • C.S1 • C.S1 • C.S1 • C.H1 • C.S1 • C.W) (plus , Z⊗I))
      equals S1 • H1 • R (plus , Z⊗Z) • T1 • H1 • T1⁻¹ • CX1 • X1 • T1 • H1 • T1⁻¹ • CX1 • T1 • H1 • T1⁻¹ • CX1 • X1 • T1 • H1 • T1⁻¹ • CX1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • R (plus , Z⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (minus , Z⊗Z) • R (plus , Z⊗X) • R (plus , I⊗X) • R (minus , I⊗Y) • R (plus , Z⊗Y) • R (minus , I⊗Z) • R (minus , Z⊗Z) • R (minus , I⊗Z) • R (plus , Z⊗I) • S0 • S0 • S1 • S1 • S1 • H1 • S1 • W • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Z⊗Z) • R (plus , I⊗Y) • R (plus , Z⊗Y) • H0 • CZ • H0 • R (plus , Z⊗I) • S0 • H0 • CZ • H0 • S0 • S0 • S1 • S1 • Swap • R (plus , Z⊗I) • CZ • H0 • H1 • CZ • H1 • R (plus , Z⊗I) • S0 • H0 • CZ • H0 • S0 • S0 • S1 • S1 • Swap • R (plus , Z⊗I) • S0 • H0 • H1 • CZ • S0 • H0 • S0 • S0 • H0 • S1 • S1 • H1 • W ^ 6 • Swap • R (plus , Z⊗I) • S0⁻¹ • H0 • CZ • H0 • R (plus , Z⊗I) • S0 • S0 • S0 • Swap • R (plus , Z⊗I) • S0 • S0 • S0 • Swap • R (plus , I⊗Z) • R (plus , Z⊗I) • R (plus , Z⊗Z) • R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Z⊗Z) • CZ • S0 • S0 • S1 • S1 • ε
          by in-context 42 9 auto (lemma-R (C.S0 • C.S0 • C.S1 • C.S1 • C.S1 • C.H1 • C.S1 • C.W) (plus , Z⊗Y))
      equals S1 • H1 • R (plus , Z⊗Z) • T1 • H1 • T1⁻¹ • CX1 • X1 • T1 • H1 • T1⁻¹ • CX1 • T1 • H1 • T1⁻¹ • CX1 • X1 • T1 • H1 • T1⁻¹ • CX1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • R (plus , Z⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (minus , Z⊗Z) • R (plus , Z⊗X) • R (plus , I⊗X) • R (minus , I⊗Y) • R (plus , Z⊗Y) • R (minus , I⊗Z) • R (minus , Z⊗Z) • R (minus , I⊗Z) • R (plus , Z⊗I) • R (minus , Z⊗Z) • S0 • S0 • S1 • S1 • S1 • H1 • S1 • W • R (plus , I⊗Z) • R (plus , Z⊗Z) • R (plus , I⊗Y) • R (plus , Z⊗Y) • H0 • CZ • H0 • R (plus , Z⊗I) • S0 • H0 • CZ • H0 • S0 • S0 • S1 • S1 • Swap • R (plus , Z⊗I) • CZ • H0 • H1 • CZ • H1 • R (plus , Z⊗I) • S0 • H0 • CZ • H0 • S0 • S0 • S1 • S1 • Swap • R (plus , Z⊗I) • S0 • H0 • H1 • CZ • S0 • H0 • S0 • S0 • H0 • S1 • S1 • H1 • W ^ 6 • Swap • R (plus , Z⊗I) • S0⁻¹ • H0 • CZ • H0 • R (plus , Z⊗I) • S0 • S0 • S0 • Swap • R (plus , Z⊗I) • S0 • S0 • S0 • Swap • R (plus , I⊗Z) • R (plus , Z⊗I) • R (plus , Z⊗Z) • R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Z⊗Z) • CZ • S0 • S0 • S1 • S1 • ε
          by in-context 43 9 auto (lemma-R (C.S0 • C.S0 • C.S1 • C.S1 • C.S1 • C.H1 • C.S1 • C.W) (plus , I⊗Z))
      equals S1 • H1 • R (plus , Z⊗Z) • T1 • H1 • T1⁻¹ • CX1 • X1 • T1 • H1 • T1⁻¹ • CX1 • T1 • H1 • T1⁻¹ • CX1 • X1 • T1 • H1 • T1⁻¹ • CX1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • R (plus , Z⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (minus , Z⊗Z) • R (plus , Z⊗X) • R (plus , I⊗X) • R (minus , I⊗Y) • R (plus , Z⊗Y) • R (minus , I⊗Z) • R (minus , Z⊗Z) • R (minus , I⊗Z) • R (plus , Z⊗I) • R (minus , Z⊗Z) • R (minus , I⊗Y) • S0 • S0 • S1 • S1 • S1 • H1 • S1 • W • R (plus , Z⊗Z) • R (plus , I⊗Y) • R (plus , Z⊗Y) • H0 • CZ • H0 • R (plus , Z⊗I) • S0 • H0 • CZ • H0 • S0 • S0 • S1 • S1 • Swap • R (plus , Z⊗I) • CZ • H0 • H1 • CZ • H1 • R (plus , Z⊗I) • S0 • H0 • CZ • H0 • S0 • S0 • S1 • S1 • Swap • R (plus , Z⊗I) • S0 • H0 • H1 • CZ • S0 • H0 • S0 • S0 • H0 • S1 • S1 • H1 • W ^ 6 • Swap • R (plus , Z⊗I) • S0⁻¹ • H0 • CZ • H0 • R (plus , Z⊗I) • S0 • S0 • S0 • Swap • R (plus , Z⊗I) • S0 • S0 • S0 • Swap • R (plus , I⊗Z) • R (plus , Z⊗I) • R (plus , Z⊗Z) • R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Z⊗Z) • CZ • S0 • S0 • S1 • S1 • ε
          by in-context 44 9 auto (lemma-R (C.S0 • C.S0 • C.S1 • C.S1 • C.S1 • C.H1 • C.S1 • C.W) (plus , Z⊗Z))
      equals S1 • H1 • R (plus , Z⊗Z) • T1 • H1 • T1⁻¹ • CX1 • X1 • T1 • H1 • T1⁻¹ • CX1 • T1 • H1 • T1⁻¹ • CX1 • X1 • T1 • H1 • T1⁻¹ • CX1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • R (plus , Z⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (minus , Z⊗Z) • R (plus , Z⊗X) • R (plus , I⊗X) • R (minus , I⊗Y) • R (plus , Z⊗Y) • R (minus , I⊗Z) • R (minus , Z⊗Z) • R (minus , I⊗Z) • R (plus , Z⊗I) • R (minus , Z⊗Z) • R (minus , I⊗Y) • R (minus , Z⊗Y) • S0 • S0 • S1 • S1 • S1 • H1 • S1 • W • R (plus , I⊗Y) • R (plus , Z⊗Y) • H0 • CZ • H0 • R (plus , Z⊗I) • S0 • H0 • CZ • H0 • S0 • S0 • S1 • S1 • Swap • R (plus , Z⊗I) • CZ • H0 • H1 • CZ • H1 • R (plus , Z⊗I) • S0 • H0 • CZ • H0 • S0 • S0 • S1 • S1 • Swap • R (plus , Z⊗I) • S0 • H0 • H1 • CZ • S0 • H0 • S0 • S0 • H0 • S1 • S1 • H1 • W ^ 6 • Swap • R (plus , Z⊗I) • S0⁻¹ • H0 • CZ • H0 • R (plus , Z⊗I) • S0 • S0 • S0 • Swap • R (plus , Z⊗I) • S0 • S0 • S0 • Swap • R (plus , I⊗Z) • R (plus , Z⊗I) • R (plus , Z⊗Z) • R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Z⊗Z) • CZ • S0 • S0 • S1 • S1 • ε
          by in-context 45 9 auto (lemma-R (C.S0 • C.S0 • C.S1 • C.S1 • C.S1 • C.H1 • C.S1 • C.W) (plus , I⊗Y))
      equals S1 • H1 • R (plus , Z⊗Z) • T1 • H1 • T1⁻¹ • CX1 • X1 • T1 • H1 • T1⁻¹ • CX1 • T1 • H1 • T1⁻¹ • CX1 • X1 • T1 • H1 • T1⁻¹ • CX1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • R (plus , Z⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (minus , Z⊗Z) • R (plus , Z⊗X) • R (plus , I⊗X) • R (minus , I⊗Y) • R (plus , Z⊗Y) • R (minus , I⊗Z) • R (minus , Z⊗Z) • R (minus , I⊗Z) • R (plus , Z⊗I) • R (minus , Z⊗Z) • R (minus , I⊗Y) • R (minus , Z⊗Y) • R (minus , I⊗Z) • S0 • S0 • S1 • S1 • S1 • H1 • S1 • W • R (plus , Z⊗Y) • H0 • CZ • H0 • R (plus , Z⊗I) • S0 • H0 • CZ • H0 • S0 • S0 • S1 • S1 • Swap • R (plus , Z⊗I) • CZ • H0 • H1 • CZ • H1 • R (plus , Z⊗I) • S0 • H0 • CZ • H0 • S0 • S0 • S1 • S1 • Swap • R (plus , Z⊗I) • S0 • H0 • H1 • CZ • S0 • H0 • S0 • S0 • H0 • S1 • S1 • H1 • W ^ 6 • Swap • R (plus , Z⊗I) • S0⁻¹ • H0 • CZ • H0 • R (plus , Z⊗I) • S0 • S0 • S0 • Swap • R (plus , Z⊗I) • S0 • S0 • S0 • Swap • R (plus , I⊗Z) • R (plus , Z⊗I) • R (plus , Z⊗Z) • R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Z⊗Z) • CZ • S0 • S0 • S1 • S1 • ε
          by in-context 46 9 auto (lemma-R (C.S0 • C.S0 • C.S1 • C.S1 • C.S1 • C.H1 • C.S1 • C.W) (plus , Z⊗Y))
      equals S1 • H1 • R (plus , Z⊗Z) • T1 • H1 • T1⁻¹ • CX1 • X1 • T1 • H1 • T1⁻¹ • CX1 • T1 • H1 • T1⁻¹ • CX1 • X1 • T1 • H1 • T1⁻¹ • CX1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • R (plus , Z⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (minus , Z⊗Z) • R (plus , Z⊗X) • R (plus , I⊗X) • R (minus , I⊗Y) • R (plus , Z⊗Y) • R (minus , I⊗Z) • R (minus , Z⊗Z) • R (minus , I⊗Z) • R (plus , Z⊗I) • R (minus , Z⊗Z) • R (minus , I⊗Y) • R (minus , Z⊗Y) • R (minus , I⊗Z) • R (minus , Z⊗Z) • S0 • S0 • S1 • S1 • S1 • H1 • S1 • W • H0 • CZ • H0 • R (plus , Z⊗I) • S0 • H0 • CZ • H0 • S0 • S0 • S1 • S1 • Swap • R (plus , Z⊗I) • CZ • H0 • H1 • CZ • H1 • R (plus , Z⊗I) • S0 • H0 • CZ • H0 • S0 • S0 • S1 • S1 • Swap • R (plus , Z⊗I) • S0 • H0 • H1 • CZ • S0 • H0 • S0 • S0 • H0 • S1 • S1 • H1 • W ^ 6 • Swap • R (plus , Z⊗I) • S0⁻¹ • H0 • CZ • H0 • R (plus , Z⊗I) • S0 • S0 • S0 • Swap • R (plus , Z⊗I) • S0 • S0 • S0 • Swap • R (plus , I⊗Z) • R (plus , Z⊗I) • R (plus , Z⊗Z) • R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Z⊗Z) • CZ • S0 • S0 • S1 • S1 • ε
          by in-context 47 12 auto (lemma-R (C.S0 • C.S0 • C.S1 • C.S1 • C.S1 • C.H1 • C.S1 • C.W • C.H0 • C.CZ • C.H0) (plus , Z⊗I))
      equals S1 • H1 • R (plus , Z⊗Z) • T1 • H1 • T1⁻¹ • CX1 • X1 • T1 • H1 • T1⁻¹ • CX1 • T1 • H1 • T1⁻¹ • CX1 • X1 • T1 • H1 • T1⁻¹ • CX1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • R (plus , Z⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (minus , Z⊗Z) • R (plus , Z⊗X) • R (plus , I⊗X) • R (minus , I⊗Y) • R (plus , Z⊗Y) • R (minus , I⊗Z) • R (minus , Z⊗Z) • R (minus , I⊗Z) • R (plus , Z⊗I) • R (minus , Z⊗Z) • R (minus , I⊗Y) • R (minus , Z⊗Y) • R (minus , I⊗Z) • R (minus , Z⊗Z) • R (minus , Z⊗Y) • S0 • S0 • S1 • S1 • S1 • H1 • S1 • W • H0 • CZ • H0 • S0 • H0 • CZ • H0 • S0 • S0 • S1 • S1 • Swap • R (plus , Z⊗I) • CZ • H0 • H1 • CZ • H1 • R (plus , Z⊗I) • S0 • H0 • CZ • H0 • S0 • S0 • S1 • S1 • Swap • R (plus , Z⊗I) • S0 • H0 • H1 • CZ • S0 • H0 • S0 • S0 • H0 • S1 • S1 • H1 • W ^ 6 • Swap • R (plus , Z⊗I) • S0⁻¹ • H0 • CZ • H0 • R (plus , Z⊗I) • S0 • S0 • S0 • Swap • R (plus , Z⊗I) • S0 • S0 • S0 • Swap • R (plus , I⊗Z) • R (plus , Z⊗I) • R (plus , Z⊗Z) • R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Z⊗Z) • CZ • S0 • S0 • S1 • S1 • ε
          by clifford-tactic 48 19 10000 auto
      equals S1 • H1 • R (plus , Z⊗Z) • T1 • H1 • T1⁻¹ • CX1 • X1 • T1 • H1 • T1⁻¹ • CX1 • T1 • H1 • T1⁻¹ • CX1 • X1 • T1 • H1 • T1⁻¹ • CX1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • R (plus , Z⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (minus , Z⊗Z) • R (plus , Z⊗X) • R (plus , I⊗X) • R (minus , I⊗Y) • R (plus , Z⊗Y) • R (minus , I⊗Z) • R (minus , Z⊗Z) • R (minus , I⊗Z) • R (plus , Z⊗I) • R (minus , Z⊗Z) • R (minus , I⊗Y) • R (minus , Z⊗Y) • R (minus , I⊗Z) • R (minus , Z⊗Z) • R (minus , Z⊗Y) • S1 • H1 • CZ • S0 • S0 • S0 • H1 • S1 • S1 • H1 • W • Swap • R (plus , Z⊗I) • CZ • H0 • H1 • CZ • H1 • R (plus , Z⊗I) • S0 • H0 • CZ • H0 • S0 • S0 • S1 • S1 • Swap • R (plus , Z⊗I) • S0 • H0 • H1 • CZ • S0 • H0 • S0 • S0 • H0 • S1 • S1 • H1 • W ^ 6 • Swap • R (plus , Z⊗I) • S0⁻¹ • H0 • CZ • H0 • R (plus , Z⊗I) • S0 • S0 • S0 • Swap • R (plus , Z⊗I) • S0 • S0 • S0 • Swap • R (plus , I⊗Z) • R (plus , Z⊗I) • R (plus , Z⊗Z) • R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Z⊗Z) • CZ • S0 • S0 • S1 • S1 • ε
          by in-context 48 13 auto (lemma-R (C.S1 • C.H1 • C.CZ • C.S0 • C.S0 • C.S0 • C.H1 • C.S1 • C.S1 • C.H1 • C.W • C.Swap) (plus , Z⊗I))
      equals S1 • H1 • R (plus , Z⊗Z) • T1 • H1 • T1⁻¹ • CX1 • X1 • T1 • H1 • T1⁻¹ • CX1 • T1 • H1 • T1⁻¹ • CX1 • X1 • T1 • H1 • T1⁻¹ • CX1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • R (plus , Z⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (minus , Z⊗Z) • R (plus , Z⊗X) • R (plus , I⊗X) • R (minus , I⊗Y) • R (plus , Z⊗Y) • R (minus , I⊗Z) • R (minus , Z⊗Z) • R (minus , I⊗Z) • R (plus , Z⊗I) • R (minus , Z⊗Z) • R (minus , I⊗Y) • R (minus , Z⊗Y) • R (minus , I⊗Z) • R (minus , Z⊗Z) • R (minus , Z⊗Y) • R (minus , I⊗Y) • S1 • H1 • CZ • S0 • S0 • S0 • H1 • S1 • S1 • H1 • W • Swap • CZ • H0 • H1 • CZ • H1 • R (plus , Z⊗I) • S0 • H0 • CZ • H0 • S0 • S0 • S1 • S1 • Swap • R (plus , Z⊗I) • S0 • H0 • H1 • CZ • S0 • H0 • S0 • S0 • H0 • S1 • S1 • H1 • W ^ 6 • Swap • R (plus , Z⊗I) • S0⁻¹ • H0 • CZ • H0 • R (plus , Z⊗I) • S0 • S0 • S0 • Swap • R (plus , Z⊗I) • S0 • S0 • S0 • Swap • R (plus , I⊗Z) • R (plus , Z⊗I) • R (plus , Z⊗Z) • R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Z⊗Z) • CZ • S0 • S0 • S1 • S1 • ε
          by clifford-tactic 49 17 10000 auto
      equals S1 • H1 • R (plus , Z⊗Z) • T1 • H1 • T1⁻¹ • CX1 • X1 • T1 • H1 • T1⁻¹ • CX1 • T1 • H1 • T1⁻¹ • CX1 • X1 • T1 • H1 • T1⁻¹ • CX1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • R (plus , Z⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (minus , Z⊗Z) • R (plus , Z⊗X) • R (plus , I⊗X) • R (minus , I⊗Y) • R (plus , Z⊗Y) • R (minus , I⊗Z) • R (minus , Z⊗Z) • R (minus , I⊗Z) • R (plus , Z⊗I) • R (minus , Z⊗Z) • R (minus , I⊗Y) • R (minus , Z⊗Y) • R (minus , I⊗Z) • R (minus , Z⊗Z) • R (minus , Z⊗Y) • R (minus , I⊗Y) • S0 • H0 • CZ • H0 • S1 • S1 • S1 • W • Swap • R (plus , Z⊗I) • S0 • H0 • CZ • H0 • S0 • S0 • S1 • S1 • Swap • R (plus , Z⊗I) • S0 • H0 • H1 • CZ • S0 • H0 • S0 • S0 • H0 • S1 • S1 • H1 • W ^ 6 • Swap • R (plus , Z⊗I) • S0⁻¹ • H0 • CZ • H0 • R (plus , Z⊗I) • S0 • S0 • S0 • Swap • R (plus , Z⊗I) • S0 • S0 • S0 • Swap • R (plus , I⊗Z) • R (plus , Z⊗I) • R (plus , Z⊗Z) • R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Z⊗Z) • CZ • S0 • S0 • S1 • S1 • ε
          by in-context 49 10 auto (lemma-R (C.S0 • C.H0 • C.CZ • C.H0 • C.S1 • C.S1 • C.S1 • C.W • C.Swap) (plus , Z⊗I))
      equals S1 • H1 • R (plus , Z⊗Z) • T1 • H1 • T1⁻¹ • CX1 • X1 • T1 • H1 • T1⁻¹ • CX1 • T1 • H1 • T1⁻¹ • CX1 • X1 • T1 • H1 • T1⁻¹ • CX1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • R (plus , Z⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (minus , Z⊗Z) • R (plus , Z⊗X) • R (plus , I⊗X) • R (minus , I⊗Y) • R (plus , Z⊗Y) • R (minus , I⊗Z) • R (minus , Z⊗Z) • R (minus , I⊗Z) • R (plus , Z⊗I) • R (minus , Z⊗Z) • R (minus , I⊗Y) • R (minus , Z⊗Y) • R (minus , I⊗Z) • R (minus , Z⊗Z) • R (minus , Z⊗Y) • R (minus , I⊗Y) • R (plus , I⊗Z) • S0 • H0 • CZ • H0 • S1 • S1 • S1 • W • Swap • S0 • H0 • CZ • H0 • S0 • S0 • S1 • S1 • Swap • R (plus , Z⊗I) • S0 • H0 • H1 • CZ • S0 • H0 • S0 • S0 • H0 • S1 • S1 • H1 • W ^ 6 • Swap • R (plus , Z⊗I) • S0⁻¹ • H0 • CZ • H0 • R (plus , Z⊗I) • S0 • S0 • S0 • Swap • R (plus , Z⊗I) • S0 • S0 • S0 • Swap • R (plus , I⊗Z) • R (plus , Z⊗I) • R (plus , Z⊗Z) • R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Z⊗Z) • CZ • S0 • S0 • S1 • S1 • ε
          by clifford-tactic 50 17 10000 auto
      equals S1 • H1 • R (plus , Z⊗Z) • T1 • H1 • T1⁻¹ • CX1 • X1 • T1 • H1 • T1⁻¹ • CX1 • T1 • H1 • T1⁻¹ • CX1 • X1 • T1 • H1 • T1⁻¹ • CX1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • R (plus , Z⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (minus , Z⊗Z) • R (plus , Z⊗X) • R (plus , I⊗X) • R (minus , I⊗Y) • R (plus , Z⊗Y) • R (minus , I⊗Z) • R (minus , Z⊗Z) • R (minus , I⊗Z) • R (plus , Z⊗I) • R (minus , Z⊗Z) • R (minus , I⊗Y) • R (minus , Z⊗Y) • R (minus , I⊗Z) • R (minus , Z⊗Z) • R (minus , Z⊗Y) • R (minus , I⊗Y) • R (plus , I⊗Z) • H1 • CZ • S0 • S0 • S0 • H1 • S1 • S1 • W • Swap • R (plus , Z⊗I) • S0 • H0 • H1 • CZ • S0 • H0 • S0 • S0 • H0 • S1 • S1 • H1 • W ^ 6 • Swap • R (plus , Z⊗I) • S0⁻¹ • H0 • CZ • H0 • R (plus , Z⊗I) • S0 • S0 • S0 • Swap • R (plus , Z⊗I) • S0 • S0 • S0 • Swap • R (plus , I⊗Z) • R (plus , Z⊗I) • R (plus , Z⊗Z) • R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Z⊗Z) • CZ • S0 • S0 • S1 • S1 • ε
          by in-context 50 11 auto (lemma-R (C.H1 • C.CZ • C.S0 • C.S0 • C.S0 • C.H1 • C.S1 • C.S1 • C.W • C.Swap) (plus , Z⊗I))
      equals S1 • H1 • R (plus , Z⊗Z) • T1 • H1 • T1⁻¹ • CX1 • X1 • T1 • H1 • T1⁻¹ • CX1 • T1 • H1 • T1⁻¹ • CX1 • X1 • T1 • H1 • T1⁻¹ • CX1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • R (plus , Z⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (minus , Z⊗Z) • R (plus , Z⊗X) • R (plus , I⊗X) • R (minus , I⊗Y) • R (plus , Z⊗Y) • R (minus , I⊗Z) • R (minus , Z⊗Z) • R (minus , I⊗Z) • R (plus , Z⊗I) • R (minus , Z⊗Z) • R (minus , I⊗Y) • R (minus , Z⊗Y) • R (minus , I⊗Z) • R (minus , Z⊗Z) • R (minus , Z⊗Y) • R (minus , I⊗Y) • R (plus , I⊗Z) • R (plus , Z⊗Z) • H1 • CZ • S0 • S0 • S0 • H1 • S1 • S1 • W • Swap • S0 • H0 • H1 • CZ • S0 • H0 • S0 • S0 • H0 • S1 • S1 • H1 • W ^ 6 • Swap • R (plus , Z⊗I) • S0⁻¹ • H0 • CZ • H0 • R (plus , Z⊗I) • S0 • S0 • S0 • Swap • R (plus , Z⊗I) • S0 • S0 • S0 • Swap • R (plus , I⊗Z) • R (plus , Z⊗I) • R (plus , Z⊗Z) • R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Z⊗Z) • CZ • S0 • S0 • S1 • S1 • ε
          by clifford-tactic 51 24 10000 auto
      equals S1 • H1 • R (plus , Z⊗Z) • T1 • H1 • T1⁻¹ • CX1 • X1 • T1 • H1 • T1⁻¹ • CX1 • T1 • H1 • T1⁻¹ • CX1 • X1 • T1 • H1 • T1⁻¹ • CX1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • R (plus , Z⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (minus , Z⊗Z) • R (plus , Z⊗X) • R (plus , I⊗X) • R (minus , I⊗Y) • R (plus , Z⊗Y) • R (minus , I⊗Z) • R (minus , Z⊗Z) • R (minus , I⊗Z) • R (plus , Z⊗I) • R (minus , Z⊗Z) • R (minus , I⊗Y) • R (minus , Z⊗Y) • R (minus , I⊗Z) • R (minus , Z⊗Z) • R (minus , Z⊗Y) • R (minus , I⊗Y) • R (plus , I⊗Z) • R (plus , Z⊗Z) • CZ • S0 • H0 • S1 • H1 • CZ • H0 • S0 • S0 • S0 • W • R (plus , Z⊗I) • S0⁻¹ • H0 • CZ • H0 • R (plus , Z⊗I) • S0 • S0 • S0 • Swap • R (plus , Z⊗I) • S0 • S0 • S0 • Swap • R (plus , I⊗Z) • R (plus , Z⊗I) • R (plus , Z⊗Z) • R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Z⊗Z) • CZ • S0 • S0 • S1 • S1 • ε
          by in-context 51 12 auto (lemma-R (C.CZ • C.S0 • C.H0 • C.S1 • C.H1 • C.CZ • C.H0 • C.S0 • C.S0 • C.S0 • C.W) (plus , Z⊗I))
      equals S1 • H1 • R (plus , Z⊗Z) • T1 • H1 • T1⁻¹ • CX1 • X1 • T1 • H1 • T1⁻¹ • CX1 • T1 • H1 • T1⁻¹ • CX1 • X1 • T1 • H1 • T1⁻¹ • CX1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • R (plus , Z⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (minus , Z⊗Z) • R (plus , Z⊗X) • R (plus , I⊗X) • R (minus , I⊗Y) • R (plus , Z⊗Y) • R (minus , I⊗Z) • R (minus , Z⊗Z) • R (minus , I⊗Z) • R (plus , Z⊗I) • R (minus , Z⊗Z) • R (minus , I⊗Y) • R (minus , Z⊗Y) • R (minus , I⊗Z) • R (minus , Z⊗Z) • R (minus , Z⊗Y) • R (minus , I⊗Y) • R (plus , I⊗Z) • R (plus , Z⊗Z) • R (plus , I⊗Y) • CZ • S0 • H0 • S1 • H1 • CZ • H0 • S0 • S0 • S0 • W • S0⁻¹ • H0 • CZ • H0 • R (plus , Z⊗I) • S0 • S0 • S0 • Swap • R (plus , Z⊗I) • S0 • S0 • S0 • Swap • R (plus , I⊗Z) • R (plus , Z⊗I) • R (plus , Z⊗Z) • R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Z⊗Z) • CZ • S0 • S0 • S1 • S1 • ε
          by clifford-tactic 54 13 10000 auto
      equals S1 • H1 • R (plus , Z⊗Z) • T1 • H1 • T1⁻¹ • CX1 • X1 • T1 • H1 • T1⁻¹ • CX1 • T1 • H1 • T1⁻¹ • CX1 • X1 • T1 • H1 • T1⁻¹ • CX1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • R (plus , Z⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (minus , Z⊗Z) • R (plus , Z⊗X) • R (plus , I⊗X) • R (minus , I⊗Y) • R (plus , Z⊗Y) • R (minus , I⊗Z) • R (minus , Z⊗Z) • R (minus , I⊗Z) • R (plus , Z⊗I) • R (minus , Z⊗Z) • R (minus , I⊗Y) • R (minus , Z⊗Y) • R (minus , I⊗Z) • R (minus , Z⊗Z) • R (minus , Z⊗Y) • R (minus , I⊗Y) • R (plus , I⊗Z) • R (plus , Z⊗Z) • R (plus , I⊗Y) • CZ • S0 • S0 • S0 • S1 • H1 • S1 • S1 • W • R (plus , Z⊗I) • S0 • S0 • S0 • Swap • R (plus , Z⊗I) • S0 • S0 • S0 • Swap • R (plus , I⊗Z) • R (plus , Z⊗I) • R (plus , Z⊗Z) • R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Z⊗Z) • CZ • S0 • S0 • S1 • S1 • ε
          by in-context 52 10 auto (lemma-R (C.CZ • C.S0 • C.S0 • C.S0 • C.S1 • C.H1 • C.S1 • C.S1 • C.W) (plus , Z⊗I))
      equals S1 • H1 • R (plus , Z⊗Z) • T1 • H1 • T1⁻¹ • CX1 • X1 • T1 • H1 • T1⁻¹ • CX1 • T1 • H1 • T1⁻¹ • CX1 • X1 • T1 • H1 • T1⁻¹ • CX1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • R (plus , Z⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (minus , Z⊗Z) • R (plus , Z⊗X) • R (plus , I⊗X) • R (minus , I⊗Y) • R (plus , Z⊗Y) • R (minus , I⊗Z) • R (minus , Z⊗Z) • R (minus , I⊗Z) • R (plus , Z⊗I) • R (minus , Z⊗Z) • R (minus , I⊗Y) • R (minus , Z⊗Y) • R (minus , I⊗Z) • R (minus , Z⊗Z) • R (minus , Z⊗Y) • R (minus , I⊗Y) • R (plus , I⊗Z) • R (plus , Z⊗Z) • R (plus , I⊗Y) • R (plus , Z⊗I) • CZ • S0 • S0 • S0 • S1 • H1 • S1 • S1 • W • S0 • S0 • S0 • Swap • R (plus , Z⊗I) • S0 • S0 • S0 • Swap • R (plus , I⊗Z) • R (plus , Z⊗I) • R (plus , Z⊗Z) • R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Z⊗Z) • CZ • S0 • S0 • S1 • S1 • ε
          by clifford-tactic 56 9 10000 auto
      equals S1 • H1 • R (plus , Z⊗Z) • T1 • H1 • T1⁻¹ • CX1 • X1 • T1 • H1 • T1⁻¹ • CX1 • T1 • H1 • T1⁻¹ • CX1 • X1 • T1 • H1 • T1⁻¹ • CX1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • R (plus , Z⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (minus , Z⊗Z) • R (plus , Z⊗X) • R (plus , I⊗X) • R (minus , I⊗Y) • R (plus , Z⊗Y) • R (minus , I⊗Z) • R (minus , Z⊗Z) • R (minus , I⊗Z) • R (plus , Z⊗I) • R (minus , Z⊗Z) • R (minus , I⊗Y) • R (minus , Z⊗Y) • R (minus , I⊗Z) • R (minus , Z⊗Z) • R (minus , Z⊗Y) • R (minus , I⊗Y) • R (plus , I⊗Z) • R (plus , Z⊗Z) • R (plus , I⊗Y) • R (plus , Z⊗I) • CZ • S0 • S0 • S1 • H1 • S1 • S1 • W • Swap • R (plus , Z⊗I) • S0 • S0 • S0 • Swap • R (plus , I⊗Z) • R (plus , Z⊗I) • R (plus , Z⊗Z) • R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Z⊗Z) • CZ • S0 • S0 • S1 • S1 • ε
          by in-context 53 10 auto (lemma-R (C.CZ • C.S0 • C.S0 • C.S1 • C.H1 • C.S1 • C.S1 • C.W • C.Swap) (plus , Z⊗I))
      equals S1 • H1 • R (plus , Z⊗Z) • T1 • H1 • T1⁻¹ • CX1 • X1 • T1 • H1 • T1⁻¹ • CX1 • T1 • H1 • T1⁻¹ • CX1 • X1 • T1 • H1 • T1⁻¹ • CX1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • R (plus , Z⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (minus , Z⊗Z) • R (plus , Z⊗X) • R (plus , I⊗X) • R (minus , I⊗Y) • R (plus , Z⊗Y) • R (minus , I⊗Z) • R (minus , Z⊗Z) • R (minus , I⊗Z) • R (plus , Z⊗I) • R (minus , Z⊗Z) • R (minus , I⊗Y) • R (minus , Z⊗Y) • R (minus , I⊗Z) • R (minus , Z⊗Z) • R (minus , Z⊗Y) • R (minus , I⊗Y) • R (plus , I⊗Z) • R (plus , Z⊗Z) • R (plus , I⊗Y) • R (plus , Z⊗I) • R (plus , Z⊗Y) • CZ • S0 • S0 • S1 • H1 • S1 • S1 • W • Swap • S0 • S0 • S0 • Swap • R (plus , I⊗Z) • R (plus , Z⊗I) • R (plus , Z⊗Z) • R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Z⊗Z) • CZ • S0 • S0 • S1 • S1 • ε
          by clifford-tactic 60 7 10000 auto
      equals S1 • H1 • R (plus , Z⊗Z) • T1 • H1 • T1⁻¹ • CX1 • X1 • T1 • H1 • T1⁻¹ • CX1 • T1 • H1 • T1⁻¹ • CX1 • X1 • T1 • H1 • T1⁻¹ • CX1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • R (plus , Z⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (minus , Z⊗Z) • R (plus , Z⊗X) • R (plus , I⊗X) • R (minus , I⊗Y) • R (plus , Z⊗Y) • R (minus , I⊗Z) • R (minus , Z⊗Z) • R (minus , I⊗Z) • R (plus , Z⊗I) • R (minus , Z⊗Z) • R (minus , I⊗Y) • R (minus , Z⊗Y) • R (minus , I⊗Z) • R (minus , Z⊗Z) • R (minus , Z⊗Y) • R (minus , I⊗Y) • R (plus , I⊗Z) • R (plus , Z⊗Z) • R (plus , I⊗Y) • R (plus , Z⊗I) • R (plus , Z⊗Y) • CZ • S0 • S0 • S1 • H1 • S1 • W • R (plus , I⊗Z) • R (plus , Z⊗I) • R (plus , Z⊗Z) • R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Z⊗Z) • CZ • S0 • S0 • S1 • S1 • ε
          by in-context 40 2 auto (symm (tactic-pauli-commute (plus , Z⊗I) (minus , I⊗Z) auto))
      equals S1 • H1 • R (plus , Z⊗Z) • T1 • H1 • T1⁻¹ • CX1 • X1 • T1 • H1 • T1⁻¹ • CX1 • T1 • H1 • T1⁻¹ • CX1 • X1 • T1 • H1 • T1⁻¹ • CX1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • R (plus , Z⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (minus , Z⊗Z) • R (plus , Z⊗X) • R (plus , I⊗X) • R (minus , I⊗Y) • R (plus , Z⊗Y) • R (minus , I⊗Z) • R (minus , Z⊗Z) • R (plus , Z⊗I) • R (minus , I⊗Z) • R (minus , Z⊗Z) • R (minus , I⊗Y) • R (minus , Z⊗Y) • R (minus , I⊗Z) • R (minus , Z⊗Z) • R (minus , Z⊗Y) • R (minus , I⊗Y) • R (plus , I⊗Z) • R (plus , Z⊗Z) • R (plus , I⊗Y) • R (plus , Z⊗I) • R (plus , Z⊗Y) • CZ • S0 • S0 • S1 • H1 • S1 • W • R (plus , I⊗Z) • R (plus , Z⊗I) • R (plus , Z⊗Z) • R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Z⊗Z) • CZ • S0 • S0 • S1 • S1 • ε
          by in-context 39 2 auto (symm (tactic-pauli-commute (plus , Z⊗I) (minus , Z⊗Z) auto))
      equals S1 • H1 • R (plus , Z⊗Z) • T1 • H1 • T1⁻¹ • CX1 • X1 • T1 • H1 • T1⁻¹ • CX1 • T1 • H1 • T1⁻¹ • CX1 • X1 • T1 • H1 • T1⁻¹ • CX1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • R (plus , Z⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (minus , Z⊗Z) • R (plus , Z⊗X) • R (plus , I⊗X) • R (minus , I⊗Y) • R (plus , Z⊗Y) • R (minus , I⊗Z) • R (plus , Z⊗I) • R (minus , Z⊗Z) • R (minus , I⊗Z) • R (minus , Z⊗Z) • R (minus , I⊗Y) • R (minus , Z⊗Y) • R (minus , I⊗Z) • R (minus , Z⊗Z) • R (minus , Z⊗Y) • R (minus , I⊗Y) • R (plus , I⊗Z) • R (plus , Z⊗Z) • R (plus , I⊗Y) • R (plus , Z⊗I) • R (plus , Z⊗Y) • CZ • S0 • S0 • S1 • H1 • S1 • W • R (plus , I⊗Z) • R (plus , Z⊗I) • R (plus , Z⊗Z) • R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Z⊗Z) • CZ • S0 • S0 • S1 • S1 • ε
          by in-context 38 2 auto (symm (tactic-pauli-commute (plus , Z⊗I) (minus , I⊗Z) auto))
      equals S1 • H1 • R (plus , Z⊗Z) • T1 • H1 • T1⁻¹ • CX1 • X1 • T1 • H1 • T1⁻¹ • CX1 • T1 • H1 • T1⁻¹ • CX1 • X1 • T1 • H1 • T1⁻¹ • CX1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • R (plus , Z⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (minus , Z⊗Z) • R (plus , Z⊗X) • R (plus , I⊗X) • R (minus , I⊗Y) • R (plus , Z⊗Y) • R (plus , Z⊗I) • R (minus , I⊗Z) • R (minus , Z⊗Z) • R (minus , I⊗Z) • R (minus , Z⊗Z) • R (minus , I⊗Y) • R (minus , Z⊗Y) • R (minus , I⊗Z) • R (minus , Z⊗Z) • R (minus , Z⊗Y) • R (minus , I⊗Y) • R (plus , I⊗Z) • R (plus , Z⊗Z) • R (plus , I⊗Y) • R (plus , Z⊗I) • R (plus , Z⊗Y) • CZ • S0 • S0 • S1 • H1 • S1 • W • R (plus , I⊗Z) • R (plus , Z⊗I) • R (plus , Z⊗Z) • R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Z⊗Z) • CZ • S0 • S0 • S1 • S1 • ε
          by in-context 37 2 auto (symm (tactic-pauli-commute (plus , Z⊗I) (plus , Z⊗Y) auto))
      equals S1 • H1 • R (plus , Z⊗Z) • T1 • H1 • T1⁻¹ • CX1 • X1 • T1 • H1 • T1⁻¹ • CX1 • T1 • H1 • T1⁻¹ • CX1 • X1 • T1 • H1 • T1⁻¹ • CX1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • R (plus , Z⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (minus , Z⊗Z) • R (plus , Z⊗X) • R (plus , I⊗X) • R (minus , I⊗Y) • R (plus , Z⊗I) • R (plus , Z⊗Y) • R (minus , I⊗Z) • R (minus , Z⊗Z) • R (minus , I⊗Z) • R (minus , Z⊗Z) • R (minus , I⊗Y) • R (minus , Z⊗Y) • R (minus , I⊗Z) • R (minus , Z⊗Z) • R (minus , Z⊗Y) • R (minus , I⊗Y) • R (plus , I⊗Z) • R (plus , Z⊗Z) • R (plus , I⊗Y) • R (plus , Z⊗I) • R (plus , Z⊗Y) • CZ • S0 • S0 • S1 • H1 • S1 • W • R (plus , I⊗Z) • R (plus , Z⊗I) • R (plus , Z⊗Z) • R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Z⊗Z) • CZ • S0 • S0 • S1 • S1 • ε
          by in-context 36 2 auto (symm (tactic-pauli-commute (plus , Z⊗I) (minus , I⊗Y) auto))
      equals S1 • H1 • R (plus , Z⊗Z) • T1 • H1 • T1⁻¹ • CX1 • X1 • T1 • H1 • T1⁻¹ • CX1 • T1 • H1 • T1⁻¹ • CX1 • X1 • T1 • H1 • T1⁻¹ • CX1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • R (plus , Z⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (minus , Z⊗Z) • R (plus , Z⊗X) • R (plus , I⊗X) • R (plus , Z⊗I) • R (minus , I⊗Y) • R (plus , Z⊗Y) • R (minus , I⊗Z) • R (minus , Z⊗Z) • R (minus , I⊗Z) • R (minus , Z⊗Z) • R (minus , I⊗Y) • R (minus , Z⊗Y) • R (minus , I⊗Z) • R (minus , Z⊗Z) • R (minus , Z⊗Y) • R (minus , I⊗Y) • R (plus , I⊗Z) • R (plus , Z⊗Z) • R (plus , I⊗Y) • R (plus , Z⊗I) • R (plus , Z⊗Y) • CZ • S0 • S0 • S1 • H1 • S1 • W • R (plus , I⊗Z) • R (plus , Z⊗I) • R (plus , Z⊗Z) • R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Z⊗Z) • CZ • S0 • S0 • S1 • S1 • ε
          by in-context 35 2 auto (symm (tactic-pauli-commute (plus , Z⊗I) (plus , I⊗X) auto))
      equals S1 • H1 • R (plus , Z⊗Z) • T1 • H1 • T1⁻¹ • CX1 • X1 • T1 • H1 • T1⁻¹ • CX1 • T1 • H1 • T1⁻¹ • CX1 • X1 • T1 • H1 • T1⁻¹ • CX1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • R (plus , Z⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (minus , Z⊗Z) • R (plus , Z⊗X) • R (plus , Z⊗I) • R (plus , I⊗X) • R (minus , I⊗Y) • R (plus , Z⊗Y) • R (minus , I⊗Z) • R (minus , Z⊗Z) • R (minus , I⊗Z) • R (minus , Z⊗Z) • R (minus , I⊗Y) • R (minus , Z⊗Y) • R (minus , I⊗Z) • R (minus , Z⊗Z) • R (minus , Z⊗Y) • R (minus , I⊗Y) • R (plus , I⊗Z) • R (plus , Z⊗Z) • R (plus , I⊗Y) • R (plus , Z⊗I) • R (plus , Z⊗Y) • CZ • S0 • S0 • S1 • H1 • S1 • W • R (plus , I⊗Z) • R (plus , Z⊗I) • R (plus , Z⊗Z) • R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Z⊗Z) • CZ • S0 • S0 • S1 • S1 • ε
          by in-context 34 2 auto (symm (tactic-pauli-commute (plus , Z⊗I) (plus , Z⊗X) auto))
      equals S1 • H1 • R (plus , Z⊗Z) • T1 • H1 • T1⁻¹ • CX1 • X1 • T1 • H1 • T1⁻¹ • CX1 • T1 • H1 • T1⁻¹ • CX1 • X1 • T1 • H1 • T1⁻¹ • CX1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • R (plus , Z⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (minus , Z⊗Z) • R (plus , Z⊗I) • R (plus , Z⊗X) • R (plus , I⊗X) • R (minus , I⊗Y) • R (plus , Z⊗Y) • R (minus , I⊗Z) • R (minus , Z⊗Z) • R (minus , I⊗Z) • R (minus , Z⊗Z) • R (minus , I⊗Y) • R (minus , Z⊗Y) • R (minus , I⊗Z) • R (minus , Z⊗Z) • R (minus , Z⊗Y) • R (minus , I⊗Y) • R (plus , I⊗Z) • R (plus , Z⊗Z) • R (plus , I⊗Y) • R (plus , Z⊗I) • R (plus , Z⊗Y) • CZ • S0 • S0 • S1 • H1 • S1 • W • R (plus , I⊗Z) • R (plus , Z⊗I) • R (plus , Z⊗Z) • R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Z⊗Z) • CZ • S0 • S0 • S1 • S1 • ε
          by in-context 33 2 auto (symm (tactic-pauli-commute (plus , Z⊗I) (minus , Z⊗Z) auto))
      equals S1 • H1 • R (plus , Z⊗Z) • T1 • H1 • T1⁻¹ • CX1 • X1 • T1 • H1 • T1⁻¹ • CX1 • T1 • H1 • T1⁻¹ • CX1 • X1 • T1 • H1 • T1⁻¹ • CX1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • R (plus , Z⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Z⊗I) • R (minus , Z⊗Z) • R (plus , Z⊗X) • R (plus , I⊗X) • R (minus , I⊗Y) • R (plus , Z⊗Y) • R (minus , I⊗Z) • R (minus , Z⊗Z) • R (minus , I⊗Z) • R (minus , Z⊗Z) • R (minus , I⊗Y) • R (minus , Z⊗Y) • R (minus , I⊗Z) • R (minus , Z⊗Z) • R (minus , Z⊗Y) • R (minus , I⊗Y) • R (plus , I⊗Z) • R (plus , Z⊗Z) • R (plus , I⊗Y) • R (plus , Z⊗I) • R (plus , Z⊗Y) • CZ • S0 • S0 • S1 • H1 • S1 • W • R (plus , I⊗Z) • R (plus , Z⊗I) • R (plus , Z⊗Z) • R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Z⊗Z) • CZ • S0 • S0 • S1 • S1 • ε
          by in-context 32 2 auto (symm (tactic-pauli-commute (plus , Z⊗I) (plus , I⊗Z) auto))
      equals S1 • H1 • R (plus , Z⊗Z) • T1 • H1 • T1⁻¹ • CX1 • X1 • T1 • H1 • T1⁻¹ • CX1 • T1 • H1 • T1⁻¹ • CX1 • X1 • T1 • H1 • T1⁻¹ • CX1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • R (plus , Z⊗Y) • R (plus , Z⊗Y) • R (plus , Z⊗I) • R (plus , I⊗Z) • R (minus , Z⊗Z) • R (plus , Z⊗X) • R (plus , I⊗X) • R (minus , I⊗Y) • R (plus , Z⊗Y) • R (minus , I⊗Z) • R (minus , Z⊗Z) • R (minus , I⊗Z) • R (minus , Z⊗Z) • R (minus , I⊗Y) • R (minus , Z⊗Y) • R (minus , I⊗Z) • R (minus , Z⊗Z) • R (minus , Z⊗Y) • R (minus , I⊗Y) • R (plus , I⊗Z) • R (plus , Z⊗Z) • R (plus , I⊗Y) • R (plus , Z⊗I) • R (plus , Z⊗Y) • CZ • S0 • S0 • S1 • H1 • S1 • W • R (plus , I⊗Z) • R (plus , Z⊗I) • R (plus , Z⊗Z) • R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Z⊗Z) • CZ • S0 • S0 • S1 • S1 • ε
          by in-context 31 2 auto (symm (tactic-pauli-commute (plus , Z⊗I) (plus , Z⊗Y) auto))
      equals S1 • H1 • R (plus , Z⊗Z) • T1 • H1 • T1⁻¹ • CX1 • X1 • T1 • H1 • T1⁻¹ • CX1 • T1 • H1 • T1⁻¹ • CX1 • X1 • T1 • H1 • T1⁻¹ • CX1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • R (plus , Z⊗Y) • R (plus , Z⊗I) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (minus , Z⊗Z) • R (plus , Z⊗X) • R (plus , I⊗X) • R (minus , I⊗Y) • R (plus , Z⊗Y) • R (minus , I⊗Z) • R (minus , Z⊗Z) • R (minus , I⊗Z) • R (minus , Z⊗Z) • R (minus , I⊗Y) • R (minus , Z⊗Y) • R (minus , I⊗Z) • R (minus , Z⊗Z) • R (minus , Z⊗Y) • R (minus , I⊗Y) • R (plus , I⊗Z) • R (plus , Z⊗Z) • R (plus , I⊗Y) • R (plus , Z⊗I) • R (plus , Z⊗Y) • CZ • S0 • S0 • S1 • H1 • S1 • W • R (plus , I⊗Z) • R (plus , Z⊗I) • R (plus , Z⊗Z) • R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Z⊗Z) • CZ • S0 • S0 • S1 • S1 • ε
          by in-context 30 2 auto (symm (tactic-pauli-commute (plus , Z⊗I) (plus , Z⊗Y) auto))
      equals S1 • H1 • R (plus , Z⊗Z) • T1 • H1 • T1⁻¹ • CX1 • X1 • T1 • H1 • T1⁻¹ • CX1 • T1 • H1 • T1⁻¹ • CX1 • X1 • T1 • H1 • T1⁻¹ • CX1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • R (plus , Z⊗I) • R (plus , Z⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (minus , Z⊗Z) • R (plus , Z⊗X) • R (plus , I⊗X) • R (minus , I⊗Y) • R (plus , Z⊗Y) • R (minus , I⊗Z) • R (minus , Z⊗Z) • R (minus , I⊗Z) • R (minus , Z⊗Z) • R (minus , I⊗Y) • R (minus , Z⊗Y) • R (minus , I⊗Z) • R (minus , Z⊗Z) • R (minus , Z⊗Y) • R (minus , I⊗Y) • R (plus , I⊗Z) • R (plus , Z⊗Z) • R (plus , I⊗Y) • R (plus , Z⊗I) • R (plus , Z⊗Y) • CZ • S0 • S0 • S1 • H1 • S1 • W • R (plus , I⊗Z) • R (plus , Z⊗I) • R (plus , Z⊗Z) • R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Z⊗Z) • CZ • S0 • S0 • S1 • S1 • ε
          by in-context 51 2 auto (symm (tactic-pauli-commute (plus , Z⊗I) (plus , I⊗Y) auto))
      equals S1 • H1 • R (plus , Z⊗Z) • T1 • H1 • T1⁻¹ • CX1 • X1 • T1 • H1 • T1⁻¹ • CX1 • T1 • H1 • T1⁻¹ • CX1 • X1 • T1 • H1 • T1⁻¹ • CX1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • R (plus , Z⊗I) • R (plus , Z⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (minus , Z⊗Z) • R (plus , Z⊗X) • R (plus , I⊗X) • R (minus , I⊗Y) • R (plus , Z⊗Y) • R (minus , I⊗Z) • R (minus , Z⊗Z) • R (minus , I⊗Z) • R (minus , Z⊗Z) • R (minus , I⊗Y) • R (minus , Z⊗Y) • R (minus , I⊗Z) • R (minus , Z⊗Z) • R (minus , Z⊗Y) • R (minus , I⊗Y) • R (plus , I⊗Z) • R (plus , Z⊗Z) • R (plus , Z⊗I) • R (plus , I⊗Y) • R (plus , Z⊗Y) • CZ • S0 • S0 • S1 • H1 • S1 • W • R (plus , I⊗Z) • R (plus , Z⊗I) • R (plus , Z⊗Z) • R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Z⊗Z) • CZ • S0 • S0 • S1 • S1 • ε
          by in-context 50 2 auto (symm (tactic-pauli-commute (plus , Z⊗I) (plus , Z⊗Z) auto))
      equals S1 • H1 • R (plus , Z⊗Z) • T1 • H1 • T1⁻¹ • CX1 • X1 • T1 • H1 • T1⁻¹ • CX1 • T1 • H1 • T1⁻¹ • CX1 • X1 • T1 • H1 • T1⁻¹ • CX1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • R (plus , Z⊗I) • R (plus , Z⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (minus , Z⊗Z) • R (plus , Z⊗X) • R (plus , I⊗X) • R (minus , I⊗Y) • R (plus , Z⊗Y) • R (minus , I⊗Z) • R (minus , Z⊗Z) • R (minus , I⊗Z) • R (minus , Z⊗Z) • R (minus , I⊗Y) • R (minus , Z⊗Y) • R (minus , I⊗Z) • R (minus , Z⊗Z) • R (minus , Z⊗Y) • R (minus , I⊗Y) • R (plus , I⊗Z) • R (plus , Z⊗I) • R (plus , Z⊗Z) • R (plus , I⊗Y) • R (plus , Z⊗Y) • CZ • S0 • S0 • S1 • H1 • S1 • W • R (plus , I⊗Z) • R (plus , Z⊗I) • R (plus , Z⊗Z) • R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Z⊗Z) • CZ • S0 • S0 • S1 • S1 • ε
          by in-context 49 2 auto (symm (tactic-pauli-commute (plus , Z⊗I) (plus , I⊗Z) auto))
      equals S1 • H1 • R (plus , Z⊗Z) • T1 • H1 • T1⁻¹ • CX1 • X1 • T1 • H1 • T1⁻¹ • CX1 • T1 • H1 • T1⁻¹ • CX1 • X1 • T1 • H1 • T1⁻¹ • CX1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • R (plus , Z⊗I) • R (plus , Z⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (minus , Z⊗Z) • R (plus , Z⊗X) • R (plus , I⊗X) • R (minus , I⊗Y) • R (plus , Z⊗Y) • R (minus , I⊗Z) • R (minus , Z⊗Z) • R (minus , I⊗Z) • R (minus , Z⊗Z) • R (minus , I⊗Y) • R (minus , Z⊗Y) • R (minus , I⊗Z) • R (minus , Z⊗Z) • R (minus , Z⊗Y) • R (minus , I⊗Y) • R (plus , Z⊗I) • R (plus , I⊗Z) • R (plus , Z⊗Z) • R (plus , I⊗Y) • R (plus , Z⊗Y) • CZ • S0 • S0 • S1 • H1 • S1 • W • R (plus , I⊗Z) • R (plus , Z⊗I) • R (plus , Z⊗Z) • R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Z⊗Z) • CZ • S0 • S0 • S1 • S1 • ε
          by in-context 48 2 auto (symm (tactic-pauli-commute (plus , Z⊗I) (minus , I⊗Y) auto))
      equals S1 • H1 • R (plus , Z⊗Z) • T1 • H1 • T1⁻¹ • CX1 • X1 • T1 • H1 • T1⁻¹ • CX1 • T1 • H1 • T1⁻¹ • CX1 • X1 • T1 • H1 • T1⁻¹ • CX1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • R (plus , Z⊗I) • R (plus , Z⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (minus , Z⊗Z) • R (plus , Z⊗X) • R (plus , I⊗X) • R (minus , I⊗Y) • R (plus , Z⊗Y) • R (minus , I⊗Z) • R (minus , Z⊗Z) • R (minus , I⊗Z) • R (minus , Z⊗Z) • R (minus , I⊗Y) • R (minus , Z⊗Y) • R (minus , I⊗Z) • R (minus , Z⊗Z) • R (minus , Z⊗Y) • R (plus , Z⊗I) • R (minus , I⊗Y) • R (plus , I⊗Z) • R (plus , Z⊗Z) • R (plus , I⊗Y) • R (plus , Z⊗Y) • CZ • S0 • S0 • S1 • H1 • S1 • W • R (plus , I⊗Z) • R (plus , Z⊗I) • R (plus , Z⊗Z) • R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Z⊗Z) • CZ • S0 • S0 • S1 • S1 • ε
          by in-context 47 2 auto (symm (tactic-pauli-commute (plus , Z⊗I) (minus , Z⊗Y) auto))
      equals S1 • H1 • R (plus , Z⊗Z) • T1 • H1 • T1⁻¹ • CX1 • X1 • T1 • H1 • T1⁻¹ • CX1 • T1 • H1 • T1⁻¹ • CX1 • X1 • T1 • H1 • T1⁻¹ • CX1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • R (plus , Z⊗I) • R (plus , Z⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (minus , Z⊗Z) • R (plus , Z⊗X) • R (plus , I⊗X) • R (minus , I⊗Y) • R (plus , Z⊗Y) • R (minus , I⊗Z) • R (minus , Z⊗Z) • R (minus , I⊗Z) • R (minus , Z⊗Z) • R (minus , I⊗Y) • R (minus , Z⊗Y) • R (minus , I⊗Z) • R (minus , Z⊗Z) • R (plus , Z⊗I) • R (minus , Z⊗Y) • R (minus , I⊗Y) • R (plus , I⊗Z) • R (plus , Z⊗Z) • R (plus , I⊗Y) • R (plus , Z⊗Y) • CZ • S0 • S0 • S1 • H1 • S1 • W • R (plus , I⊗Z) • R (plus , Z⊗I) • R (plus , Z⊗Z) • R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Z⊗Z) • CZ • S0 • S0 • S1 • S1 • ε
          by in-context 46 2 auto (symm (tactic-pauli-commute (plus , Z⊗I) (minus , Z⊗Z) auto))
      equals S1 • H1 • R (plus , Z⊗Z) • T1 • H1 • T1⁻¹ • CX1 • X1 • T1 • H1 • T1⁻¹ • CX1 • T1 • H1 • T1⁻¹ • CX1 • X1 • T1 • H1 • T1⁻¹ • CX1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • R (plus , Z⊗I) • R (plus , Z⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (minus , Z⊗Z) • R (plus , Z⊗X) • R (plus , I⊗X) • R (minus , I⊗Y) • R (plus , Z⊗Y) • R (minus , I⊗Z) • R (minus , Z⊗Z) • R (minus , I⊗Z) • R (minus , Z⊗Z) • R (minus , I⊗Y) • R (minus , Z⊗Y) • R (minus , I⊗Z) • R (plus , Z⊗I) • R (minus , Z⊗Z) • R (minus , Z⊗Y) • R (minus , I⊗Y) • R (plus , I⊗Z) • R (plus , Z⊗Z) • R (plus , I⊗Y) • R (plus , Z⊗Y) • CZ • S0 • S0 • S1 • H1 • S1 • W • R (plus , I⊗Z) • R (plus , Z⊗I) • R (plus , Z⊗Z) • R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Z⊗Z) • CZ • S0 • S0 • S1 • S1 • ε
          by in-context 45 2 auto (symm (tactic-pauli-commute (plus , Z⊗I) (minus , I⊗Z) auto))
      equals S1 • H1 • R (plus , Z⊗Z) • T1 • H1 • T1⁻¹ • CX1 • X1 • T1 • H1 • T1⁻¹ • CX1 • T1 • H1 • T1⁻¹ • CX1 • X1 • T1 • H1 • T1⁻¹ • CX1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • R (plus , Z⊗I) • R (plus , Z⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (minus , Z⊗Z) • R (plus , Z⊗X) • R (plus , I⊗X) • R (minus , I⊗Y) • R (plus , Z⊗Y) • R (minus , I⊗Z) • R (minus , Z⊗Z) • R (minus , I⊗Z) • R (minus , Z⊗Z) • R (minus , I⊗Y) • R (minus , Z⊗Y) • R (plus , Z⊗I) • R (minus , I⊗Z) • R (minus , Z⊗Z) • R (minus , Z⊗Y) • R (minus , I⊗Y) • R (plus , I⊗Z) • R (plus , Z⊗Z) • R (plus , I⊗Y) • R (plus , Z⊗Y) • CZ • S0 • S0 • S1 • H1 • S1 • W • R (plus , I⊗Z) • R (plus , Z⊗I) • R (plus , Z⊗Z) • R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Z⊗Z) • CZ • S0 • S0 • S1 • S1 • ε
          by in-context 44 2 auto (symm (tactic-pauli-commute (plus , Z⊗I) (minus , Z⊗Y) auto))
      equals S1 • H1 • R (plus , Z⊗Z) • T1 • H1 • T1⁻¹ • CX1 • X1 • T1 • H1 • T1⁻¹ • CX1 • T1 • H1 • T1⁻¹ • CX1 • X1 • T1 • H1 • T1⁻¹ • CX1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • R (plus , Z⊗I) • R (plus , Z⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (minus , Z⊗Z) • R (plus , Z⊗X) • R (plus , I⊗X) • R (minus , I⊗Y) • R (plus , Z⊗Y) • R (minus , I⊗Z) • R (minus , Z⊗Z) • R (minus , I⊗Z) • R (minus , Z⊗Z) • R (minus , I⊗Y) • R (plus , Z⊗I) • R (minus , Z⊗Y) • R (minus , I⊗Z) • R (minus , Z⊗Z) • R (minus , Z⊗Y) • R (minus , I⊗Y) • R (plus , I⊗Z) • R (plus , Z⊗Z) • R (plus , I⊗Y) • R (plus , Z⊗Y) • CZ • S0 • S0 • S1 • H1 • S1 • W • R (plus , I⊗Z) • R (plus , Z⊗I) • R (plus , Z⊗Z) • R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Z⊗Z) • CZ • S0 • S0 • S1 • S1 • ε
          by in-context 43 2 auto (symm (tactic-pauli-commute (plus , Z⊗I) (minus , I⊗Y) auto))
      equals S1 • H1 • R (plus , Z⊗Z) • T1 • H1 • T1⁻¹ • CX1 • X1 • T1 • H1 • T1⁻¹ • CX1 • T1 • H1 • T1⁻¹ • CX1 • X1 • T1 • H1 • T1⁻¹ • CX1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • R (plus , Z⊗I) • R (plus , Z⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (minus , Z⊗Z) • R (plus , Z⊗X) • R (plus , I⊗X) • R (minus , I⊗Y) • R (plus , Z⊗Y) • R (minus , I⊗Z) • R (minus , Z⊗Z) • R (minus , I⊗Z) • R (minus , Z⊗Z) • R (plus , Z⊗I) • R (minus , I⊗Y) • R (minus , Z⊗Y) • R (minus , I⊗Z) • R (minus , Z⊗Z) • R (minus , Z⊗Y) • R (minus , I⊗Y) • R (plus , I⊗Z) • R (plus , Z⊗Z) • R (plus , I⊗Y) • R (plus , Z⊗Y) • CZ • S0 • S0 • S1 • H1 • S1 • W • R (plus , I⊗Z) • R (plus , Z⊗I) • R (plus , Z⊗Z) • R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Z⊗Z) • CZ • S0 • S0 • S1 • S1 • ε
          by in-context 42 2 auto (symm (tactic-pauli-commute (plus , Z⊗I) (minus , Z⊗Z) auto))
      equals S1 • H1 • R (plus , Z⊗Z) • T1 • H1 • T1⁻¹ • CX1 • X1 • T1 • H1 • T1⁻¹ • CX1 • T1 • H1 • T1⁻¹ • CX1 • X1 • T1 • H1 • T1⁻¹ • CX1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • R (plus , Z⊗I) • R (plus , Z⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (minus , Z⊗Z) • R (plus , Z⊗X) • R (plus , I⊗X) • R (minus , I⊗Y) • R (plus , Z⊗Y) • R (minus , I⊗Z) • R (minus , Z⊗Z) • R (minus , I⊗Z) • R (plus , Z⊗I) • R (minus , Z⊗Z) • R (minus , I⊗Y) • R (minus , Z⊗Y) • R (minus , I⊗Z) • R (minus , Z⊗Z) • R (minus , Z⊗Y) • R (minus , I⊗Y) • R (plus , I⊗Z) • R (plus , Z⊗Z) • R (plus , I⊗Y) • R (plus , Z⊗Y) • CZ • S0 • S0 • S1 • H1 • S1 • W • R (plus , I⊗Z) • R (plus , Z⊗I) • R (plus , Z⊗Z) • R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Z⊗Z) • CZ • S0 • S0 • S1 • S1 • ε
          by in-context 41 2 auto (symm (tactic-pauli-commute (plus , Z⊗I) (minus , I⊗Z) auto))
      equals S1 • H1 • R (plus , Z⊗Z) • T1 • H1 • T1⁻¹ • CX1 • X1 • T1 • H1 • T1⁻¹ • CX1 • T1 • H1 • T1⁻¹ • CX1 • X1 • T1 • H1 • T1⁻¹ • CX1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • R (plus , Z⊗I) • R (plus , Z⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (minus , Z⊗Z) • R (plus , Z⊗X) • R (plus , I⊗X) • R (minus , I⊗Y) • R (plus , Z⊗Y) • R (minus , I⊗Z) • R (minus , Z⊗Z) • R (plus , Z⊗I) • R (minus , I⊗Z) • R (minus , Z⊗Z) • R (minus , I⊗Y) • R (minus , Z⊗Y) • R (minus , I⊗Z) • R (minus , Z⊗Z) • R (minus , Z⊗Y) • R (minus , I⊗Y) • R (plus , I⊗Z) • R (plus , Z⊗Z) • R (plus , I⊗Y) • R (plus , Z⊗Y) • CZ • S0 • S0 • S1 • H1 • S1 • W • R (plus , I⊗Z) • R (plus , Z⊗I) • R (plus , Z⊗Z) • R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Z⊗Z) • CZ • S0 • S0 • S1 • S1 • ε
          by in-context 40 2 auto (symm (tactic-pauli-commute (plus , Z⊗I) (minus , Z⊗Z) auto))
      equals S1 • H1 • R (plus , Z⊗Z) • T1 • H1 • T1⁻¹ • CX1 • X1 • T1 • H1 • T1⁻¹ • CX1 • T1 • H1 • T1⁻¹ • CX1 • X1 • T1 • H1 • T1⁻¹ • CX1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • R (plus , Z⊗I) • R (plus , Z⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (minus , Z⊗Z) • R (plus , Z⊗X) • R (plus , I⊗X) • R (minus , I⊗Y) • R (plus , Z⊗Y) • R (minus , I⊗Z) • R (plus , Z⊗I) • R (minus , Z⊗Z) • R (minus , I⊗Z) • R (minus , Z⊗Z) • R (minus , I⊗Y) • R (minus , Z⊗Y) • R (minus , I⊗Z) • R (minus , Z⊗Z) • R (minus , Z⊗Y) • R (minus , I⊗Y) • R (plus , I⊗Z) • R (plus , Z⊗Z) • R (plus , I⊗Y) • R (plus , Z⊗Y) • CZ • S0 • S0 • S1 • H1 • S1 • W • R (plus , I⊗Z) • R (plus , Z⊗I) • R (plus , Z⊗Z) • R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Z⊗Z) • CZ • S0 • S0 • S1 • S1 • ε
          by in-context 39 2 auto (symm (tactic-pauli-commute (plus , Z⊗I) (minus , I⊗Z) auto))
      equals S1 • H1 • R (plus , Z⊗Z) • T1 • H1 • T1⁻¹ • CX1 • X1 • T1 • H1 • T1⁻¹ • CX1 • T1 • H1 • T1⁻¹ • CX1 • X1 • T1 • H1 • T1⁻¹ • CX1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • R (plus , Z⊗I) • R (plus , Z⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (minus , Z⊗Z) • R (plus , Z⊗X) • R (plus , I⊗X) • R (minus , I⊗Y) • R (plus , Z⊗Y) • R (plus , Z⊗I) • R (minus , I⊗Z) • R (minus , Z⊗Z) • R (minus , I⊗Z) • R (minus , Z⊗Z) • R (minus , I⊗Y) • R (minus , Z⊗Y) • R (minus , I⊗Z) • R (minus , Z⊗Z) • R (minus , Z⊗Y) • R (minus , I⊗Y) • R (plus , I⊗Z) • R (plus , Z⊗Z) • R (plus , I⊗Y) • R (plus , Z⊗Y) • CZ • S0 • S0 • S1 • H1 • S1 • W • R (plus , I⊗Z) • R (plus , Z⊗I) • R (plus , Z⊗Z) • R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Z⊗Z) • CZ • S0 • S0 • S1 • S1 • ε
          by in-context 38 2 auto (symm (tactic-pauli-commute (plus , Z⊗I) (plus , Z⊗Y) auto))
      equals S1 • H1 • R (plus , Z⊗Z) • T1 • H1 • T1⁻¹ • CX1 • X1 • T1 • H1 • T1⁻¹ • CX1 • T1 • H1 • T1⁻¹ • CX1 • X1 • T1 • H1 • T1⁻¹ • CX1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • R (plus , Z⊗I) • R (plus , Z⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (minus , Z⊗Z) • R (plus , Z⊗X) • R (plus , I⊗X) • R (minus , I⊗Y) • R (plus , Z⊗I) • R (plus , Z⊗Y) • R (minus , I⊗Z) • R (minus , Z⊗Z) • R (minus , I⊗Z) • R (minus , Z⊗Z) • R (minus , I⊗Y) • R (minus , Z⊗Y) • R (minus , I⊗Z) • R (minus , Z⊗Z) • R (minus , Z⊗Y) • R (minus , I⊗Y) • R (plus , I⊗Z) • R (plus , Z⊗Z) • R (plus , I⊗Y) • R (plus , Z⊗Y) • CZ • S0 • S0 • S1 • H1 • S1 • W • R (plus , I⊗Z) • R (plus , Z⊗I) • R (plus , Z⊗Z) • R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Z⊗Z) • CZ • S0 • S0 • S1 • S1 • ε
          by in-context 37 2 auto (symm (tactic-pauli-commute (plus , Z⊗I) (minus , I⊗Y) auto))
      equals S1 • H1 • R (plus , Z⊗Z) • T1 • H1 • T1⁻¹ • CX1 • X1 • T1 • H1 • T1⁻¹ • CX1 • T1 • H1 • T1⁻¹ • CX1 • X1 • T1 • H1 • T1⁻¹ • CX1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • R (plus , Z⊗I) • R (plus , Z⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (minus , Z⊗Z) • R (plus , Z⊗X) • R (plus , I⊗X) • R (plus , Z⊗I) • R (minus , I⊗Y) • R (plus , Z⊗Y) • R (minus , I⊗Z) • R (minus , Z⊗Z) • R (minus , I⊗Z) • R (minus , Z⊗Z) • R (minus , I⊗Y) • R (minus , Z⊗Y) • R (minus , I⊗Z) • R (minus , Z⊗Z) • R (minus , Z⊗Y) • R (minus , I⊗Y) • R (plus , I⊗Z) • R (plus , Z⊗Z) • R (plus , I⊗Y) • R (plus , Z⊗Y) • CZ • S0 • S0 • S1 • H1 • S1 • W • R (plus , I⊗Z) • R (plus , Z⊗I) • R (plus , Z⊗Z) • R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Z⊗Z) • CZ • S0 • S0 • S1 • S1 • ε
          by in-context 36 2 auto (symm (tactic-pauli-commute (plus , Z⊗I) (plus , I⊗X) auto))
      equals S1 • H1 • R (plus , Z⊗Z) • T1 • H1 • T1⁻¹ • CX1 • X1 • T1 • H1 • T1⁻¹ • CX1 • T1 • H1 • T1⁻¹ • CX1 • X1 • T1 • H1 • T1⁻¹ • CX1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • R (plus , Z⊗I) • R (plus , Z⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (minus , Z⊗Z) • R (plus , Z⊗X) • R (plus , Z⊗I) • R (plus , I⊗X) • R (minus , I⊗Y) • R (plus , Z⊗Y) • R (minus , I⊗Z) • R (minus , Z⊗Z) • R (minus , I⊗Z) • R (minus , Z⊗Z) • R (minus , I⊗Y) • R (minus , Z⊗Y) • R (minus , I⊗Z) • R (minus , Z⊗Z) • R (minus , Z⊗Y) • R (minus , I⊗Y) • R (plus , I⊗Z) • R (plus , Z⊗Z) • R (plus , I⊗Y) • R (plus , Z⊗Y) • CZ • S0 • S0 • S1 • H1 • S1 • W • R (plus , I⊗Z) • R (plus , Z⊗I) • R (plus , Z⊗Z) • R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Z⊗Z) • CZ • S0 • S0 • S1 • S1 • ε
          by in-context 35 2 auto (symm (tactic-pauli-commute (plus , Z⊗I) (plus , Z⊗X) auto))
      equals S1 • H1 • R (plus , Z⊗Z) • T1 • H1 • T1⁻¹ • CX1 • X1 • T1 • H1 • T1⁻¹ • CX1 • T1 • H1 • T1⁻¹ • CX1 • X1 • T1 • H1 • T1⁻¹ • CX1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • R (plus , Z⊗I) • R (plus , Z⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (minus , Z⊗Z) • R (plus , Z⊗I) • R (plus , Z⊗X) • R (plus , I⊗X) • R (minus , I⊗Y) • R (plus , Z⊗Y) • R (minus , I⊗Z) • R (minus , Z⊗Z) • R (minus , I⊗Z) • R (minus , Z⊗Z) • R (minus , I⊗Y) • R (minus , Z⊗Y) • R (minus , I⊗Z) • R (minus , Z⊗Z) • R (minus , Z⊗Y) • R (minus , I⊗Y) • R (plus , I⊗Z) • R (plus , Z⊗Z) • R (plus , I⊗Y) • R (plus , Z⊗Y) • CZ • S0 • S0 • S1 • H1 • S1 • W • R (plus , I⊗Z) • R (plus , Z⊗I) • R (plus , Z⊗Z) • R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Z⊗Z) • CZ • S0 • S0 • S1 • S1 • ε
          by in-context 34 2 auto (symm (tactic-pauli-commute (plus , Z⊗I) (minus , Z⊗Z) auto))
      equals S1 • H1 • R (plus , Z⊗Z) • T1 • H1 • T1⁻¹ • CX1 • X1 • T1 • H1 • T1⁻¹ • CX1 • T1 • H1 • T1⁻¹ • CX1 • X1 • T1 • H1 • T1⁻¹ • CX1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • R (plus , Z⊗I) • R (plus , Z⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Z⊗I) • R (minus , Z⊗Z) • R (plus , Z⊗X) • R (plus , I⊗X) • R (minus , I⊗Y) • R (plus , Z⊗Y) • R (minus , I⊗Z) • R (minus , Z⊗Z) • R (minus , I⊗Z) • R (minus , Z⊗Z) • R (minus , I⊗Y) • R (minus , Z⊗Y) • R (minus , I⊗Z) • R (minus , Z⊗Z) • R (minus , Z⊗Y) • R (minus , I⊗Y) • R (plus , I⊗Z) • R (plus , Z⊗Z) • R (plus , I⊗Y) • R (plus , Z⊗Y) • CZ • S0 • S0 • S1 • H1 • S1 • W • R (plus , I⊗Z) • R (plus , Z⊗I) • R (plus , Z⊗Z) • R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Z⊗Z) • CZ • S0 • S0 • S1 • S1 • ε
          by in-context 33 2 auto (symm (tactic-pauli-commute (plus , Z⊗I) (plus , I⊗Z) auto))
      equals S1 • H1 • R (plus , Z⊗Z) • T1 • H1 • T1⁻¹ • CX1 • X1 • T1 • H1 • T1⁻¹ • CX1 • T1 • H1 • T1⁻¹ • CX1 • X1 • T1 • H1 • T1⁻¹ • CX1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • R (plus , Z⊗I) • R (plus , Z⊗Y) • R (plus , Z⊗Y) • R (plus , Z⊗I) • R (plus , I⊗Z) • R (minus , Z⊗Z) • R (plus , Z⊗X) • R (plus , I⊗X) • R (minus , I⊗Y) • R (plus , Z⊗Y) • R (minus , I⊗Z) • R (minus , Z⊗Z) • R (minus , I⊗Z) • R (minus , Z⊗Z) • R (minus , I⊗Y) • R (minus , Z⊗Y) • R (minus , I⊗Z) • R (minus , Z⊗Z) • R (minus , Z⊗Y) • R (minus , I⊗Y) • R (plus , I⊗Z) • R (plus , Z⊗Z) • R (plus , I⊗Y) • R (plus , Z⊗Y) • CZ • S0 • S0 • S1 • H1 • S1 • W • R (plus , I⊗Z) • R (plus , Z⊗I) • R (plus , Z⊗Z) • R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Z⊗Z) • CZ • S0 • S0 • S1 • S1 • ε
          by in-context 32 2 auto (symm (tactic-pauli-commute (plus , Z⊗I) (plus , Z⊗Y) auto))
      equals S1 • H1 • R (plus , Z⊗Z) • T1 • H1 • T1⁻¹ • CX1 • X1 • T1 • H1 • T1⁻¹ • CX1 • T1 • H1 • T1⁻¹ • CX1 • X1 • T1 • H1 • T1⁻¹ • CX1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • R (plus , Z⊗I) • R (plus , Z⊗Y) • R (plus , Z⊗I) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (minus , Z⊗Z) • R (plus , Z⊗X) • R (plus , I⊗X) • R (minus , I⊗Y) • R (plus , Z⊗Y) • R (minus , I⊗Z) • R (minus , Z⊗Z) • R (minus , I⊗Z) • R (minus , Z⊗Z) • R (minus , I⊗Y) • R (minus , Z⊗Y) • R (minus , I⊗Z) • R (minus , Z⊗Z) • R (minus , Z⊗Y) • R (minus , I⊗Y) • R (plus , I⊗Z) • R (plus , Z⊗Z) • R (plus , I⊗Y) • R (plus , Z⊗Y) • CZ • S0 • S0 • S1 • H1 • S1 • W • R (plus , I⊗Z) • R (plus , Z⊗I) • R (plus , Z⊗Z) • R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Z⊗Z) • CZ • S0 • S0 • S1 • S1 • ε
          by in-context 31 2 auto (symm (tactic-pauli-commute (plus , Z⊗I) (plus , Z⊗Y) auto))
      equals S1 • H1 • R (plus , Z⊗Z) • T1 • H1 • T1⁻¹ • CX1 • X1 • T1 • H1 • T1⁻¹ • CX1 • T1 • H1 • T1⁻¹ • CX1 • X1 • T1 • H1 • T1⁻¹ • CX1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • R (plus , Z⊗I) • R (plus , Z⊗I) • R (plus , Z⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (minus , Z⊗Z) • R (plus , Z⊗X) • R (plus , I⊗X) • R (minus , I⊗Y) • R (plus , Z⊗Y) • R (minus , I⊗Z) • R (minus , Z⊗Z) • R (minus , I⊗Z) • R (minus , Z⊗Z) • R (minus , I⊗Y) • R (minus , Z⊗Y) • R (minus , I⊗Z) • R (minus , Z⊗Z) • R (minus , Z⊗Y) • R (minus , I⊗Y) • R (plus , I⊗Z) • R (plus , Z⊗Z) • R (plus , I⊗Y) • R (plus , Z⊗Y) • CZ • S0 • S0 • S1 • H1 • S1 • W • R (plus , I⊗Z) • R (plus , Z⊗I) • R (plus , Z⊗Z) • R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Z⊗Z) • CZ • S0 • S0 • S1 • S1 • ε
          by in-context 36 2 auto (symm (tactic-pauli-commute (plus , I⊗X) (plus , Z⊗X) auto))
      equals S1 • H1 • R (plus , Z⊗Z) • T1 • H1 • T1⁻¹ • CX1 • X1 • T1 • H1 • T1⁻¹ • CX1 • T1 • H1 • T1⁻¹ • CX1 • X1 • T1 • H1 • T1⁻¹ • CX1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • R (plus , Z⊗I) • R (plus , Z⊗I) • R (plus , Z⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (minus , Z⊗Z) • R (plus , I⊗X) • R (plus , Z⊗X) • R (minus , I⊗Y) • R (plus , Z⊗Y) • R (minus , I⊗Z) • R (minus , Z⊗Z) • R (minus , I⊗Z) • R (minus , Z⊗Z) • R (minus , I⊗Y) • R (minus , Z⊗Y) • R (minus , I⊗Z) • R (minus , Z⊗Z) • R (minus , Z⊗Y) • R (minus , I⊗Y) • R (plus , I⊗Z) • R (plus , Z⊗Z) • R (plus , I⊗Y) • R (plus , Z⊗Y) • CZ • S0 • S0 • S1 • H1 • S1 • W • R (plus , I⊗Z) • R (plus , Z⊗I) • R (plus , Z⊗Z) • R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Z⊗Z) • CZ • S0 • S0 • S1 • S1 • ε
          by in-context 41 2 auto (symm (tactic-pauli-commute (minus , I⊗Z) (minus , Z⊗Z) auto))
      equals S1 • H1 • R (plus , Z⊗Z) • T1 • H1 • T1⁻¹ • CX1 • X1 • T1 • H1 • T1⁻¹ • CX1 • T1 • H1 • T1⁻¹ • CX1 • X1 • T1 • H1 • T1⁻¹ • CX1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • R (plus , Z⊗I) • R (plus , Z⊗I) • R (plus , Z⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (minus , Z⊗Z) • R (plus , I⊗X) • R (plus , Z⊗X) • R (minus , I⊗Y) • R (plus , Z⊗Y) • R (minus , I⊗Z) • R (minus , I⊗Z) • R (minus , Z⊗Z) • R (minus , Z⊗Z) • R (minus , I⊗Y) • R (minus , Z⊗Y) • R (minus , I⊗Z) • R (minus , Z⊗Z) • R (minus , Z⊗Y) • R (minus , I⊗Y) • R (plus , I⊗Z) • R (plus , Z⊗Z) • R (plus , I⊗Y) • R (plus , Z⊗Y) • CZ • S0 • S0 • S1 • H1 • S1 • W • R (plus , I⊗Z) • R (plus , Z⊗I) • R (plus , Z⊗Z) • R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Z⊗Z) • CZ • S0 • S0 • S1 • S1 • ε
          by in-context 48 2 auto (symm (tactic-pauli-commute (minus , I⊗Y) (minus , Z⊗Y) auto))
      equals S1 • H1 • R (plus , Z⊗Z) • T1 • H1 • T1⁻¹ • CX1 • X1 • T1 • H1 • T1⁻¹ • CX1 • T1 • H1 • T1⁻¹ • CX1 • X1 • T1 • H1 • T1⁻¹ • CX1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • R (plus , Z⊗I) • R (plus , Z⊗I) • R (plus , Z⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (minus , Z⊗Z) • R (plus , I⊗X) • R (plus , Z⊗X) • R (minus , I⊗Y) • R (plus , Z⊗Y) • R (minus , I⊗Z) • R (minus , I⊗Z) • R (minus , Z⊗Z) • R (minus , Z⊗Z) • R (minus , I⊗Y) • R (minus , Z⊗Y) • R (minus , I⊗Z) • R (minus , Z⊗Z) • R (minus , I⊗Y) • R (minus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Z⊗Z) • R (plus , I⊗Y) • R (plus , Z⊗Y) • CZ • S0 • S0 • S1 • H1 • S1 • W • R (plus , I⊗Z) • R (plus , Z⊗I) • R (plus , Z⊗Z) • R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Z⊗Z) • CZ • S0 • S0 • S1 • S1 • ε
          by in-context 30 2 auto (lemma-combine plus plus Z⊗I)
      equals S1 • H1 • R (plus , Z⊗Z) • T1 • H1 • T1⁻¹ • CX1 • X1 • T1 • H1 • T1⁻¹ • CX1 • T1 • H1 • T1⁻¹ • CX1 • X1 • T1 • H1 • T1⁻¹ • CX1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • S0 • R (plus , Z⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (minus , Z⊗Z) • R (plus , I⊗X) • R (plus , Z⊗X) • R (minus , I⊗Y) • R (plus , Z⊗Y) • R (minus , I⊗Z) • R (minus , I⊗Z) • R (minus , Z⊗Z) • R (minus , Z⊗Z) • R (minus , I⊗Y) • R (minus , Z⊗Y) • R (minus , I⊗Z) • R (minus , Z⊗Z) • R (minus , I⊗Y) • R (minus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Z⊗Z) • R (plus , I⊗Y) • R (plus , Z⊗Y) • CZ • S0 • S0 • S1 • H1 • S1 • W • R (plus , I⊗Z) • R (plus , Z⊗I) • R (plus , Z⊗Z) • R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Z⊗Z) • CZ • S0 • S0 • S1 • S1 • ε
          by in-context 31 2 auto (lemma-combine plus plus Z⊗Y)
      equals S1 • H1 • R (plus , Z⊗Z) • T1 • H1 • T1⁻¹ • CX1 • X1 • T1 • H1 • T1⁻¹ • CX1 • T1 • H1 • T1⁻¹ • CX1 • X1 • T1 • H1 • T1⁻¹ • CX1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • S0 • S1 • H1 • H0 • CZ • H0 • S0 • H0 • CZ • H0 • H1 • S1⁻¹ • R (plus , I⊗Z) • R (minus , Z⊗Z) • R (plus , I⊗X) • R (plus , Z⊗X) • R (minus , I⊗Y) • R (plus , Z⊗Y) • R (minus , I⊗Z) • R (minus , I⊗Z) • R (minus , Z⊗Z) • R (minus , Z⊗Z) • R (minus , I⊗Y) • R (minus , Z⊗Y) • R (minus , I⊗Z) • R (minus , Z⊗Z) • R (minus , I⊗Y) • R (minus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Z⊗Z) • R (plus , I⊗Y) • R (plus , Z⊗Y) • CZ • S0 • S0 • S1 • H1 • S1 • W • R (plus , I⊗Z) • R (plus , Z⊗I) • R (plus , Z⊗Z) • R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Z⊗Z) • CZ • S0 • S0 • S1 • S1 • ε
          by in-context 48 2 auto (lemma-combine minus minus I⊗Z)
      equals S1 • H1 • R (plus , Z⊗Z) • T1 • H1 • T1⁻¹ • CX1 • X1 • T1 • H1 • T1⁻¹ • CX1 • T1 • H1 • T1⁻¹ • CX1 • X1 • T1 • H1 • T1⁻¹ • CX1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • S0 • S1 • H1 • H0 • CZ • H0 • S0 • H0 • CZ • H0 • H1 • S1⁻¹ • R (plus , I⊗Z) • R (minus , Z⊗Z) • R (plus , I⊗X) • R (plus , Z⊗X) • R (minus , I⊗Y) • R (plus , Z⊗Y) • Swap • S0⁻¹ • W ^ 2 • Swap • R (minus , Z⊗Z) • R (minus , Z⊗Z) • R (minus , I⊗Y) • R (minus , Z⊗Y) • R (minus , I⊗Z) • R (minus , Z⊗Z) • R (minus , I⊗Y) • R (minus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Z⊗Z) • R (plus , I⊗Y) • R (plus , Z⊗Y) • CZ • S0 • S0 • S1 • H1 • S1 • W • R (plus , I⊗Z) • R (plus , Z⊗I) • R (plus , Z⊗Z) • R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Z⊗Z) • CZ • S0 • S0 • S1 • S1 • ε
          by in-context 52 2 auto (lemma-combine minus minus Z⊗Z)
      equals S1 • H1 • R (plus , Z⊗Z) • T1 • H1 • T1⁻¹ • CX1 • X1 • T1 • H1 • T1⁻¹ • CX1 • T1 • H1 • T1⁻¹ • CX1 • X1 • T1 • H1 • T1⁻¹ • CX1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • S0 • S1 • H1 • H0 • CZ • H0 • S0 • H0 • CZ • H0 • H1 • S1⁻¹ • R (plus , I⊗Z) • R (minus , Z⊗Z) • R (plus , I⊗X) • R (plus , Z⊗X) • R (minus , I⊗Y) • R (plus , Z⊗Y) • Swap • S0⁻¹ • W ^ 2 • Swap • H0 • CZ • H0 • S0⁻¹ • W ^ 2 • H0 • CZ • H0 • R (minus , I⊗Y) • R (minus , Z⊗Y) • R (minus , I⊗Z) • R (minus , Z⊗Z) • R (minus , I⊗Y) • R (minus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Z⊗Z) • R (plus , I⊗Y) • R (plus , Z⊗Y) • CZ • S0 • S0 • S1 • H1 • S1 • W • R (plus , I⊗Z) • R (plus , Z⊗I) • R (plus , Z⊗Z) • R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Z⊗Z) • CZ • S0 • S0 • S1 • S1 • ε
          by clifford-tactic 30 12 10000 auto
      equals S1 • H1 • R (plus , Z⊗Z) • T1 • H1 • T1⁻¹ • CX1 • X1 • T1 • H1 • T1⁻¹ • CX1 • T1 • H1 • T1⁻¹ • CX1 • X1 • T1 • H1 • T1⁻¹ • CX1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • S1 • H1 • CZ • S0 • S0 • S1 • H1 • S1 • S1 • S1 • R (plus , I⊗Z) • R (minus , Z⊗Z) • R (plus , I⊗X) • R (plus , Z⊗X) • R (minus , I⊗Y) • R (plus , Z⊗Y) • Swap • S0⁻¹ • W ^ 2 • Swap • H0 • CZ • H0 • S0⁻¹ • W ^ 2 • H0 • CZ • H0 • R (minus , I⊗Y) • R (minus , Z⊗Y) • R (minus , I⊗Z) • R (minus , Z⊗Z) • R (minus , I⊗Y) • R (minus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Z⊗Z) • R (plus , I⊗Y) • R (plus , Z⊗Y) • CZ • S0 • S0 • S1 • H1 • S1 • W • R (plus , I⊗Z) • R (plus , Z⊗I) • R (plus , Z⊗Z) • R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Z⊗Z) • CZ • S0 • S0 • S1 • S1 • ε
          by clifford-tactic 46 12 10000 auto
      equals S1 • H1 • R (plus , Z⊗Z) • T1 • H1 • T1⁻¹ • CX1 • X1 • T1 • H1 • T1⁻¹ • CX1 • T1 • H1 • T1⁻¹ • CX1 • X1 • T1 • H1 • T1⁻¹ • CX1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • S1 • H1 • CZ • S0 • S0 • S1 • H1 • S1 • S1 • S1 • R (plus , I⊗Z) • R (minus , Z⊗Z) • R (plus , I⊗X) • R (plus , Z⊗X) • R (minus , I⊗Y) • R (plus , Z⊗Y) • CZ • S0 • S0 • S0 • S1 • S1 • W ^ 4 • R (minus , I⊗Y) • R (minus , Z⊗Y) • R (minus , I⊗Z) • R (minus , Z⊗Z) • R (minus , I⊗Y) • R (minus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Z⊗Z) • R (plus , I⊗Y) • R (plus , Z⊗Y) • CZ • S0 • S0 • S1 • H1 • S1 • W • R (plus , I⊗Z) • R (plus , Z⊗I) • R (plus , Z⊗Z) • R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Z⊗Z) • CZ • S0 • S0 • S1 • S1 • ε
          by in-context 30 11 auto (lemma-R (C.S1 • C.H1 • C.CZ • C.S0 • C.S0 • C.S1 • C.H1 • C.S1 • C.S1 • C.S1) (plus , I⊗Z))
      equals S1 • H1 • R (plus , Z⊗Z) • T1 • H1 • T1⁻¹ • CX1 • X1 • T1 • H1 • T1⁻¹ • CX1 • T1 • H1 • T1⁻¹ • CX1 • X1 • T1 • H1 • T1⁻¹ • CX1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • R (plus , Z⊗X) • S1 • H1 • CZ • S0 • S0 • S1 • H1 • S1 • S1 • S1 • R (minus , Z⊗Z) • R (plus , I⊗X) • R (plus , Z⊗X) • R (minus , I⊗Y) • R (plus , Z⊗Y) • CZ • S0 • S0 • S0 • S1 • S1 • W ^ 4 • R (minus , I⊗Y) • R (minus , Z⊗Y) • R (minus , I⊗Z) • R (minus , Z⊗Z) • R (minus , I⊗Y) • R (minus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Z⊗Z) • R (plus , I⊗Y) • R (plus , Z⊗Y) • CZ • S0 • S0 • S1 • H1 • S1 • W • R (plus , I⊗Z) • R (plus , Z⊗I) • R (plus , Z⊗Z) • R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Z⊗Z) • CZ • S0 • S0 • S1 • S1 • ε
          by in-context 31 11 auto (lemma-R (C.S1 • C.H1 • C.CZ • C.S0 • C.S0 • C.S1 • C.H1 • C.S1 • C.S1 • C.S1) (minus , Z⊗Z))
      equals S1 • H1 • R (plus , Z⊗Z) • T1 • H1 • T1⁻¹ • CX1 • X1 • T1 • H1 • T1⁻¹ • CX1 • T1 • H1 • T1⁻¹ • CX1 • X1 • T1 • H1 • T1⁻¹ • CX1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • R (plus , Z⊗X) • R (minus , I⊗X) • S1 • H1 • CZ • S0 • S0 • S1 • H1 • S1 • S1 • S1 • R (plus , I⊗X) • R (plus , Z⊗X) • R (minus , I⊗Y) • R (plus , Z⊗Y) • CZ • S0 • S0 • S0 • S1 • S1 • W ^ 4 • R (minus , I⊗Y) • R (minus , Z⊗Y) • R (minus , I⊗Z) • R (minus , Z⊗Z) • R (minus , I⊗Y) • R (minus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Z⊗Z) • R (plus , I⊗Y) • R (plus , Z⊗Y) • CZ • S0 • S0 • S1 • H1 • S1 • W • R (plus , I⊗Z) • R (plus , Z⊗I) • R (plus , Z⊗Z) • R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Z⊗Z) • CZ • S0 • S0 • S1 • S1 • ε
          by in-context 32 11 auto (lemma-R (C.S1 • C.H1 • C.CZ • C.S0 • C.S0 • C.S1 • C.H1 • C.S1 • C.S1 • C.S1) (plus , I⊗X))
      equals S1 • H1 • R (plus , Z⊗Z) • T1 • H1 • T1⁻¹ • CX1 • X1 • T1 • H1 • T1⁻¹ • CX1 • T1 • H1 • T1⁻¹ • CX1 • X1 • T1 • H1 • T1⁻¹ • CX1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • R (plus , Z⊗X) • R (minus , I⊗X) • R (minus , Z⊗Z) • S1 • H1 • CZ • S0 • S0 • S1 • H1 • S1 • S1 • S1 • R (plus , Z⊗X) • R (minus , I⊗Y) • R (plus , Z⊗Y) • CZ • S0 • S0 • S0 • S1 • S1 • W ^ 4 • R (minus , I⊗Y) • R (minus , Z⊗Y) • R (minus , I⊗Z) • R (minus , Z⊗Z) • R (minus , I⊗Y) • R (minus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Z⊗Z) • R (plus , I⊗Y) • R (plus , Z⊗Y) • CZ • S0 • S0 • S1 • H1 • S1 • W • R (plus , I⊗Z) • R (plus , Z⊗I) • R (plus , Z⊗Z) • R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Z⊗Z) • CZ • S0 • S0 • S1 • S1 • ε
          by in-context 33 11 auto (lemma-R (C.S1 • C.H1 • C.CZ • C.S0 • C.S0 • C.S1 • C.H1 • C.S1 • C.S1 • C.S1) (plus , Z⊗X))
      equals S1 • H1 • R (plus , Z⊗Z) • T1 • H1 • T1⁻¹ • CX1 • X1 • T1 • H1 • T1⁻¹ • CX1 • T1 • H1 • T1⁻¹ • CX1 • X1 • T1 • H1 • T1⁻¹ • CX1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • R (plus , Z⊗X) • R (minus , I⊗X) • R (minus , Z⊗Z) • R (minus , I⊗Z) • S1 • H1 • CZ • S0 • S0 • S1 • H1 • S1 • S1 • S1 • R (minus , I⊗Y) • R (plus , Z⊗Y) • CZ • S0 • S0 • S0 • S1 • S1 • W ^ 4 • R (minus , I⊗Y) • R (minus , Z⊗Y) • R (minus , I⊗Z) • R (minus , Z⊗Z) • R (minus , I⊗Y) • R (minus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Z⊗Z) • R (plus , I⊗Y) • R (plus , Z⊗Y) • CZ • S0 • S0 • S1 • H1 • S1 • W • R (plus , I⊗Z) • R (plus , Z⊗I) • R (plus , Z⊗Z) • R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Z⊗Z) • CZ • S0 • S0 • S1 • S1 • ε
          by in-context 34 11 auto (lemma-R (C.S1 • C.H1 • C.CZ • C.S0 • C.S0 • C.S1 • C.H1 • C.S1 • C.S1 • C.S1) (minus , I⊗Y))
      equals S1 • H1 • R (plus , Z⊗Z) • T1 • H1 • T1⁻¹ • CX1 • X1 • T1 • H1 • T1⁻¹ • CX1 • T1 • H1 • T1⁻¹ • CX1 • X1 • T1 • H1 • T1⁻¹ • CX1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • R (plus , Z⊗X) • R (minus , I⊗X) • R (minus , Z⊗Z) • R (minus , I⊗Z) • R (minus , I⊗Y) • S1 • H1 • CZ • S0 • S0 • S1 • H1 • S1 • S1 • S1 • R (plus , Z⊗Y) • CZ • S0 • S0 • S0 • S1 • S1 • W ^ 4 • R (minus , I⊗Y) • R (minus , Z⊗Y) • R (minus , I⊗Z) • R (minus , Z⊗Z) • R (minus , I⊗Y) • R (minus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Z⊗Z) • R (plus , I⊗Y) • R (plus , Z⊗Y) • CZ • S0 • S0 • S1 • H1 • S1 • W • R (plus , I⊗Z) • R (plus , Z⊗I) • R (plus , Z⊗Z) • R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Z⊗Z) • CZ • S0 • S0 • S1 • S1 • ε
          by in-context 35 11 auto (lemma-R (C.S1 • C.H1 • C.CZ • C.S0 • C.S0 • C.S1 • C.H1 • C.S1 • C.S1 • C.S1) (plus , Z⊗Y))
      equals S1 • H1 • R (plus , Z⊗Z) • T1 • H1 • T1⁻¹ • CX1 • X1 • T1 • H1 • T1⁻¹ • CX1 • T1 • H1 • T1⁻¹ • CX1 • X1 • T1 • H1 • T1⁻¹ • CX1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • R (plus , Z⊗X) • R (minus , I⊗X) • R (minus , Z⊗Z) • R (minus , I⊗Z) • R (minus , I⊗Y) • R (plus , Z⊗Y) • S1 • H1 • CZ • S0 • S0 • S1 • H1 • S1 • S1 • S1 • CZ • S0 • S0 • S0 • S1 • S1 • W ^ 4 • R (minus , I⊗Y) • R (minus , Z⊗Y) • R (minus , I⊗Z) • R (minus , Z⊗Z) • R (minus , I⊗Y) • R (minus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Z⊗Z) • R (plus , I⊗Y) • R (plus , Z⊗Y) • CZ • S0 • S0 • S1 • H1 • S1 • W • R (plus , I⊗Z) • R (plus , Z⊗I) • R (plus , Z⊗Z) • R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Z⊗Z) • CZ • S0 • S0 • S1 • S1 • ε
          by clifford-tactic 36 17 10000 auto
      equals S1 • H1 • R (plus , Z⊗Z) • T1 • H1 • T1⁻¹ • CX1 • X1 • T1 • H1 • T1⁻¹ • CX1 • T1 • H1 • T1⁻¹ • CX1 • X1 • T1 • H1 • T1⁻¹ • CX1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • R (plus , Z⊗X) • R (minus , I⊗X) • R (minus , Z⊗Z) • R (minus , I⊗Z) • R (minus , I⊗Y) • R (plus , Z⊗Y) • CZ • H1 • W ^ 5 • R (minus , I⊗Y) • R (minus , Z⊗Y) • R (minus , I⊗Z) • R (minus , Z⊗Z) • R (minus , I⊗Y) • R (minus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Z⊗Z) • R (plus , I⊗Y) • R (plus , Z⊗Y) • CZ • S0 • S0 • S1 • H1 • S1 • W • R (plus , I⊗Z) • R (plus , Z⊗I) • R (plus , Z⊗Z) • R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Z⊗Z) • CZ • S0 • S0 • S1 • S1 • ε
          by in-context 36 4 auto (lemma-R (C.CZ • C.H1 • C.W ^ 5) (minus , I⊗Y))
      equals S1 • H1 • R (plus , Z⊗Z) • T1 • H1 • T1⁻¹ • CX1 • X1 • T1 • H1 • T1⁻¹ • CX1 • T1 • H1 • T1⁻¹ • CX1 • X1 • T1 • H1 • T1⁻¹ • CX1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • R (plus , Z⊗X) • R (minus , I⊗X) • R (minus , Z⊗Z) • R (minus , I⊗Z) • R (minus , I⊗Y) • R (plus , Z⊗Y) • R (plus , Z⊗Y) • CZ • H1 • W ^ 5 • R (minus , Z⊗Y) • R (minus , I⊗Z) • R (minus , Z⊗Z) • R (minus , I⊗Y) • R (minus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Z⊗Z) • R (plus , I⊗Y) • R (plus , Z⊗Y) • CZ • S0 • S0 • S1 • H1 • S1 • W • R (plus , I⊗Z) • R (plus , Z⊗I) • R (plus , Z⊗Z) • R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Z⊗Z) • CZ • S0 • S0 • S1 • S1 • ε
          by in-context 37 4 auto (lemma-R (C.CZ • C.H1 • C.W ^ 5) (minus , Z⊗Y))
      equals S1 • H1 • R (plus , Z⊗Z) • T1 • H1 • T1⁻¹ • CX1 • X1 • T1 • H1 • T1⁻¹ • CX1 • T1 • H1 • T1⁻¹ • CX1 • X1 • T1 • H1 • T1⁻¹ • CX1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • R (plus , Z⊗X) • R (minus , I⊗X) • R (minus , Z⊗Z) • R (minus , I⊗Z) • R (minus , I⊗Y) • R (plus , Z⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Y) • CZ • H1 • W ^ 5 • R (minus , I⊗Z) • R (minus , Z⊗Z) • R (minus , I⊗Y) • R (minus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Z⊗Z) • R (plus , I⊗Y) • R (plus , Z⊗Y) • CZ • S0 • S0 • S1 • H1 • S1 • W • R (plus , I⊗Z) • R (plus , Z⊗I) • R (plus , Z⊗Z) • R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Z⊗Z) • CZ • S0 • S0 • S1 • S1 • ε
          by in-context 38 4 auto (lemma-R (C.CZ • C.H1 • C.W ^ 5) (minus , I⊗Z))
      equals S1 • H1 • R (plus , Z⊗Z) • T1 • H1 • T1⁻¹ • CX1 • X1 • T1 • H1 • T1⁻¹ • CX1 • T1 • H1 • T1⁻¹ • CX1 • X1 • T1 • H1 • T1⁻¹ • CX1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • R (plus , Z⊗X) • R (minus , I⊗X) • R (minus , Z⊗Z) • R (minus , I⊗Z) • R (minus , I⊗Y) • R (plus , Z⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Y) • R (minus , Z⊗X) • CZ • H1 • W ^ 5 • R (minus , Z⊗Z) • R (minus , I⊗Y) • R (minus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Z⊗Z) • R (plus , I⊗Y) • R (plus , Z⊗Y) • CZ • S0 • S0 • S1 • H1 • S1 • W • R (plus , I⊗Z) • R (plus , Z⊗I) • R (plus , Z⊗Z) • R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Z⊗Z) • CZ • S0 • S0 • S1 • S1 • ε
          by in-context 39 4 auto (lemma-R (C.CZ • C.H1 • C.W ^ 5) (minus , Z⊗Z))
      equals S1 • H1 • R (plus , Z⊗Z) • T1 • H1 • T1⁻¹ • CX1 • X1 • T1 • H1 • T1⁻¹ • CX1 • T1 • H1 • T1⁻¹ • CX1 • X1 • T1 • H1 • T1⁻¹ • CX1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • R (plus , Z⊗X) • R (minus , I⊗X) • R (minus , Z⊗Z) • R (minus , I⊗Z) • R (minus , I⊗Y) • R (plus , Z⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Y) • R (minus , Z⊗X) • R (minus , I⊗X) • CZ • H1 • W ^ 5 • R (minus , I⊗Y) • R (minus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Z⊗Z) • R (plus , I⊗Y) • R (plus , Z⊗Y) • CZ • S0 • S0 • S1 • H1 • S1 • W • R (plus , I⊗Z) • R (plus , Z⊗I) • R (plus , Z⊗Z) • R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Z⊗Z) • CZ • S0 • S0 • S1 • S1 • ε
          by in-context 40 4 auto (lemma-R (C.CZ • C.H1 • C.W ^ 5) (minus , I⊗Y))
      equals S1 • H1 • R (plus , Z⊗Z) • T1 • H1 • T1⁻¹ • CX1 • X1 • T1 • H1 • T1⁻¹ • CX1 • T1 • H1 • T1⁻¹ • CX1 • X1 • T1 • H1 • T1⁻¹ • CX1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • R (plus , Z⊗X) • R (minus , I⊗X) • R (minus , Z⊗Z) • R (minus , I⊗Z) • R (minus , I⊗Y) • R (plus , Z⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Y) • R (minus , Z⊗X) • R (minus , I⊗X) • R (plus , Z⊗Y) • CZ • H1 • W ^ 5 • R (minus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Z⊗Z) • R (plus , I⊗Y) • R (plus , Z⊗Y) • CZ • S0 • S0 • S1 • H1 • S1 • W • R (plus , I⊗Z) • R (plus , Z⊗I) • R (plus , Z⊗Z) • R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Z⊗Z) • CZ • S0 • S0 • S1 • S1 • ε
          by in-context 41 4 auto (lemma-R (C.CZ • C.H1 • C.W ^ 5) (minus , Z⊗Y))
      equals S1 • H1 • R (plus , Z⊗Z) • T1 • H1 • T1⁻¹ • CX1 • X1 • T1 • H1 • T1⁻¹ • CX1 • T1 • H1 • T1⁻¹ • CX1 • X1 • T1 • H1 • T1⁻¹ • CX1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • R (plus , Z⊗X) • R (minus , I⊗X) • R (minus , Z⊗Z) • R (minus , I⊗Z) • R (minus , I⊗Y) • R (plus , Z⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Y) • R (minus , Z⊗X) • R (minus , I⊗X) • R (plus , Z⊗Y) • R (plus , I⊗Y) • CZ • H1 • W ^ 5 • R (plus , I⊗Z) • R (plus , Z⊗Z) • R (plus , I⊗Y) • R (plus , Z⊗Y) • CZ • S0 • S0 • S1 • H1 • S1 • W • R (plus , I⊗Z) • R (plus , Z⊗I) • R (plus , Z⊗Z) • R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Z⊗Z) • CZ • S0 • S0 • S1 • S1 • ε
          by in-context 42 4 auto (lemma-R (C.CZ • C.H1 • C.W ^ 5) (plus , I⊗Z))
      equals S1 • H1 • R (plus , Z⊗Z) • T1 • H1 • T1⁻¹ • CX1 • X1 • T1 • H1 • T1⁻¹ • CX1 • T1 • H1 • T1⁻¹ • CX1 • X1 • T1 • H1 • T1⁻¹ • CX1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • R (plus , Z⊗X) • R (minus , I⊗X) • R (minus , Z⊗Z) • R (minus , I⊗Z) • R (minus , I⊗Y) • R (plus , Z⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Y) • R (minus , Z⊗X) • R (minus , I⊗X) • R (plus , Z⊗Y) • R (plus , I⊗Y) • R (plus , Z⊗X) • CZ • H1 • W ^ 5 • R (plus , Z⊗Z) • R (plus , I⊗Y) • R (plus , Z⊗Y) • CZ • S0 • S0 • S1 • H1 • S1 • W • R (plus , I⊗Z) • R (plus , Z⊗I) • R (plus , Z⊗Z) • R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Z⊗Z) • CZ • S0 • S0 • S1 • S1 • ε
          by in-context 43 4 auto (lemma-R (C.CZ • C.H1 • C.W ^ 5) (plus , Z⊗Z))
      equals S1 • H1 • R (plus , Z⊗Z) • T1 • H1 • T1⁻¹ • CX1 • X1 • T1 • H1 • T1⁻¹ • CX1 • T1 • H1 • T1⁻¹ • CX1 • X1 • T1 • H1 • T1⁻¹ • CX1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • R (plus , Z⊗X) • R (minus , I⊗X) • R (minus , Z⊗Z) • R (minus , I⊗Z) • R (minus , I⊗Y) • R (plus , Z⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Y) • R (minus , Z⊗X) • R (minus , I⊗X) • R (plus , Z⊗Y) • R (plus , I⊗Y) • R (plus , Z⊗X) • R (plus , I⊗X) • CZ • H1 • W ^ 5 • R (plus , I⊗Y) • R (plus , Z⊗Y) • CZ • S0 • S0 • S1 • H1 • S1 • W • R (plus , I⊗Z) • R (plus , Z⊗I) • R (plus , Z⊗Z) • R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Z⊗Z) • CZ • S0 • S0 • S1 • S1 • ε
          by in-context 44 4 auto (lemma-R (C.CZ • C.H1 • C.W ^ 5) (plus , I⊗Y))
      equals S1 • H1 • R (plus , Z⊗Z) • T1 • H1 • T1⁻¹ • CX1 • X1 • T1 • H1 • T1⁻¹ • CX1 • T1 • H1 • T1⁻¹ • CX1 • X1 • T1 • H1 • T1⁻¹ • CX1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • R (plus , Z⊗X) • R (minus , I⊗X) • R (minus , Z⊗Z) • R (minus , I⊗Z) • R (minus , I⊗Y) • R (plus , Z⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Y) • R (minus , Z⊗X) • R (minus , I⊗X) • R (plus , Z⊗Y) • R (plus , I⊗Y) • R (plus , Z⊗X) • R (plus , I⊗X) • R (minus , Z⊗Y) • CZ • H1 • W ^ 5 • R (plus , Z⊗Y) • CZ • S0 • S0 • S1 • H1 • S1 • W • R (plus , I⊗Z) • R (plus , Z⊗I) • R (plus , Z⊗Z) • R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Z⊗Z) • CZ • S0 • S0 • S1 • S1 • ε
          by in-context 45 4 auto (lemma-R (C.CZ • C.H1 • C.W ^ 5) (plus , Z⊗Y))
      equals S1 • H1 • R (plus , Z⊗Z) • T1 • H1 • T1⁻¹ • CX1 • X1 • T1 • H1 • T1⁻¹ • CX1 • T1 • H1 • T1⁻¹ • CX1 • X1 • T1 • H1 • T1⁻¹ • CX1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • R (plus , Z⊗X) • R (minus , I⊗X) • R (minus , Z⊗Z) • R (minus , I⊗Z) • R (minus , I⊗Y) • R (plus , Z⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Y) • R (minus , Z⊗X) • R (minus , I⊗X) • R (plus , Z⊗Y) • R (plus , I⊗Y) • R (plus , Z⊗X) • R (plus , I⊗X) • R (minus , Z⊗Y) • R (minus , I⊗Y) • CZ • H1 • W ^ 5 • CZ • S0 • S0 • S1 • H1 • S1 • W • R (plus , I⊗Z) • R (plus , Z⊗I) • R (plus , Z⊗Z) • R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Z⊗Z) • CZ • S0 • S0 • S1 • S1 • ε
          by in-context 30 2 auto (symm (tactic-pauli-commute (minus , I⊗X) (plus , Z⊗X) auto))
      equals S1 • H1 • R (plus , Z⊗Z) • T1 • H1 • T1⁻¹ • CX1 • X1 • T1 • H1 • T1⁻¹ • CX1 • T1 • H1 • T1⁻¹ • CX1 • X1 • T1 • H1 • T1⁻¹ • CX1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • R (minus , I⊗X) • R (plus , Z⊗X) • R (minus , Z⊗Z) • R (minus , I⊗Z) • R (minus , I⊗Y) • R (plus , Z⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Y) • R (minus , Z⊗X) • R (minus , I⊗X) • R (plus , Z⊗Y) • R (plus , I⊗Y) • R (plus , Z⊗X) • R (plus , I⊗X) • R (minus , Z⊗Y) • R (minus , I⊗Y) • CZ • H1 • W ^ 5 • CZ • S0 • S0 • S1 • H1 • S1 • W • R (plus , I⊗Z) • R (plus , Z⊗I) • R (plus , Z⊗Z) • R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Z⊗Z) • CZ • S0 • S0 • S1 • S1 • ε
          by in-context 32 2 auto (symm (tactic-pauli-commute (minus , I⊗Z) (minus , Z⊗Z) auto))
      equals S1 • H1 • R (plus , Z⊗Z) • T1 • H1 • T1⁻¹ • CX1 • X1 • T1 • H1 • T1⁻¹ • CX1 • T1 • H1 • T1⁻¹ • CX1 • X1 • T1 • H1 • T1⁻¹ • CX1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • R (minus , I⊗X) • R (plus , Z⊗X) • R (minus , I⊗Z) • R (minus , Z⊗Z) • R (minus , I⊗Y) • R (plus , Z⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Y) • R (minus , Z⊗X) • R (minus , I⊗X) • R (plus , Z⊗Y) • R (plus , I⊗Y) • R (plus , Z⊗X) • R (plus , I⊗X) • R (minus , Z⊗Y) • R (minus , I⊗Y) • CZ • H1 • W ^ 5 • CZ • S0 • S0 • S1 • H1 • S1 • W • R (plus , I⊗Z) • R (plus , Z⊗I) • R (plus , Z⊗Z) • R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Z⊗Z) • CZ • S0 • S0 • S1 • S1 • ε
          by in-context 36 2 auto (symm (tactic-pauli-commute (plus , I⊗Y) (plus , Z⊗Y) auto))
      equals S1 • H1 • R (plus , Z⊗Z) • T1 • H1 • T1⁻¹ • CX1 • X1 • T1 • H1 • T1⁻¹ • CX1 • T1 • H1 • T1⁻¹ • CX1 • X1 • T1 • H1 • T1⁻¹ • CX1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • R (minus , I⊗X) • R (plus , Z⊗X) • R (minus , I⊗Z) • R (minus , Z⊗Z) • R (minus , I⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Y) • R (plus , Z⊗Y) • R (minus , Z⊗X) • R (minus , I⊗X) • R (plus , Z⊗Y) • R (plus , I⊗Y) • R (plus , Z⊗X) • R (plus , I⊗X) • R (minus , Z⊗Y) • R (minus , I⊗Y) • CZ • H1 • W ^ 5 • CZ • S0 • S0 • S1 • H1 • S1 • W • R (plus , I⊗Z) • R (plus , Z⊗I) • R (plus , Z⊗Z) • R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Z⊗Z) • CZ • S0 • S0 • S1 • S1 • ε
          by in-context 35 2 auto (symm (tactic-pauli-commute (plus , I⊗Y) (plus , Z⊗Y) auto))
      equals S1 • H1 • R (plus , Z⊗Z) • T1 • H1 • T1⁻¹ • CX1 • X1 • T1 • H1 • T1⁻¹ • CX1 • T1 • H1 • T1⁻¹ • CX1 • X1 • T1 • H1 • T1⁻¹ • CX1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • R (minus , I⊗X) • R (plus , Z⊗X) • R (minus , I⊗Z) • R (minus , Z⊗Z) • R (minus , I⊗Y) • R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , Z⊗Y) • R (minus , Z⊗X) • R (minus , I⊗X) • R (plus , Z⊗Y) • R (plus , I⊗Y) • R (plus , Z⊗X) • R (plus , I⊗X) • R (minus , Z⊗Y) • R (minus , I⊗Y) • CZ • H1 • W ^ 5 • CZ • S0 • S0 • S1 • H1 • S1 • W • R (plus , I⊗Z) • R (plus , Z⊗I) • R (plus , Z⊗Z) • R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Z⊗Z) • CZ • S0 • S0 • S1 • S1 • ε
          by in-context 34 2 auto (symm (tactic-pauli-commute (plus , I⊗Y) (minus , I⊗Y) auto))
      equals S1 • H1 • R (plus , Z⊗Z) • T1 • H1 • T1⁻¹ • CX1 • X1 • T1 • H1 • T1⁻¹ • CX1 • T1 • H1 • T1⁻¹ • CX1 • X1 • T1 • H1 • T1⁻¹ • CX1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • R (minus , I⊗X) • R (plus , Z⊗X) • R (minus , I⊗Z) • R (minus , Z⊗Z) • R (plus , I⊗Y) • R (minus , I⊗Y) • R (plus , Z⊗Y) • R (plus , Z⊗Y) • R (minus , Z⊗X) • R (minus , I⊗X) • R (plus , Z⊗Y) • R (plus , I⊗Y) • R (plus , Z⊗X) • R (plus , I⊗X) • R (minus , Z⊗Y) • R (minus , I⊗Y) • CZ • H1 • W ^ 5 • CZ • S0 • S0 • S1 • H1 • S1 • W • R (plus , I⊗Z) • R (plus , Z⊗I) • R (plus , Z⊗Z) • R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Z⊗Z) • CZ • S0 • S0 • S1 • S1 • ε
          by in-context 38 2 auto (symm (tactic-pauli-commute (minus , I⊗X) (minus , Z⊗X) auto))
      equals S1 • H1 • R (plus , Z⊗Z) • T1 • H1 • T1⁻¹ • CX1 • X1 • T1 • H1 • T1⁻¹ • CX1 • T1 • H1 • T1⁻¹ • CX1 • X1 • T1 • H1 • T1⁻¹ • CX1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • R (minus , I⊗X) • R (plus , Z⊗X) • R (minus , I⊗Z) • R (minus , Z⊗Z) • R (plus , I⊗Y) • R (minus , I⊗Y) • R (plus , Z⊗Y) • R (plus , Z⊗Y) • R (minus , I⊗X) • R (minus , Z⊗X) • R (plus , Z⊗Y) • R (plus , I⊗Y) • R (plus , Z⊗X) • R (plus , I⊗X) • R (minus , Z⊗Y) • R (minus , I⊗Y) • CZ • H1 • W ^ 5 • CZ • S0 • S0 • S1 • H1 • S1 • W • R (plus , I⊗Z) • R (plus , Z⊗I) • R (plus , Z⊗Z) • R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Z⊗Z) • CZ • S0 • S0 • S1 • S1 • ε
          by in-context 40 2 auto (symm (tactic-pauli-commute (plus , I⊗Y) (plus , Z⊗Y) auto))
      equals S1 • H1 • R (plus , Z⊗Z) • T1 • H1 • T1⁻¹ • CX1 • X1 • T1 • H1 • T1⁻¹ • CX1 • T1 • H1 • T1⁻¹ • CX1 • X1 • T1 • H1 • T1⁻¹ • CX1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • R (minus , I⊗X) • R (plus , Z⊗X) • R (minus , I⊗Z) • R (minus , Z⊗Z) • R (plus , I⊗Y) • R (minus , I⊗Y) • R (plus , Z⊗Y) • R (plus , Z⊗Y) • R (minus , I⊗X) • R (minus , Z⊗X) • R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , Z⊗X) • R (plus , I⊗X) • R (minus , Z⊗Y) • R (minus , I⊗Y) • CZ • H1 • W ^ 5 • CZ • S0 • S0 • S1 • H1 • S1 • W • R (plus , I⊗Z) • R (plus , Z⊗I) • R (plus , Z⊗Z) • R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Z⊗Z) • CZ • S0 • S0 • S1 • S1 • ε
          by in-context 42 2 auto (symm (tactic-pauli-commute (plus , I⊗X) (plus , Z⊗X) auto))
      equals S1 • H1 • R (plus , Z⊗Z) • T1 • H1 • T1⁻¹ • CX1 • X1 • T1 • H1 • T1⁻¹ • CX1 • T1 • H1 • T1⁻¹ • CX1 • X1 • T1 • H1 • T1⁻¹ • CX1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • R (minus , I⊗X) • R (plus , Z⊗X) • R (minus , I⊗Z) • R (minus , Z⊗Z) • R (plus , I⊗Y) • R (minus , I⊗Y) • R (plus , Z⊗Y) • R (plus , Z⊗Y) • R (minus , I⊗X) • R (minus , Z⊗X) • R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗X) • R (plus , Z⊗X) • R (minus , Z⊗Y) • R (minus , I⊗Y) • CZ • H1 • W ^ 5 • CZ • S0 • S0 • S1 • H1 • S1 • W • R (plus , I⊗Z) • R (plus , Z⊗I) • R (plus , Z⊗Z) • R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Z⊗Z) • CZ • S0 • S0 • S1 • S1 • ε
          by in-context 44 2 auto (symm (tactic-pauli-commute (minus , I⊗Y) (minus , Z⊗Y) auto))
      equals S1 • H1 • R (plus , Z⊗Z) • T1 • H1 • T1⁻¹ • CX1 • X1 • T1 • H1 • T1⁻¹ • CX1 • T1 • H1 • T1⁻¹ • CX1 • X1 • T1 • H1 • T1⁻¹ • CX1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • R (minus , I⊗X) • R (plus , Z⊗X) • R (minus , I⊗Z) • R (minus , Z⊗Z) • R (plus , I⊗Y) • R (minus , I⊗Y) • R (plus , Z⊗Y) • R (plus , Z⊗Y) • R (minus , I⊗X) • R (minus , Z⊗X) • R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗X) • R (plus , Z⊗X) • R (minus , I⊗Y) • R (minus , Z⊗Y) • CZ • H1 • W ^ 5 • CZ • S0 • S0 • S1 • H1 • S1 • W • R (plus , I⊗Z) • R (plus , Z⊗I) • R (plus , Z⊗Z) • R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Z⊗Z) • CZ • S0 • S0 • S1 • S1 • ε
          by in-context 34 2 auto (lemma-combine plus minus I⊗Y)
      equals S1 • H1 • R (plus , Z⊗Z) • T1 • H1 • T1⁻¹ • CX1 • X1 • T1 • H1 • T1⁻¹ • CX1 • T1 • H1 • T1⁻¹ • CX1 • X1 • T1 • H1 • T1⁻¹ • CX1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • R (minus , I⊗X) • R (plus , Z⊗X) • R (minus , I⊗Z) • R (minus , Z⊗Z) • S1 • H1 • Swap • W • Swap • H1 • S1⁻¹ • R (plus , Z⊗Y) • R (plus , Z⊗Y) • R (minus , I⊗X) • R (minus , Z⊗X) • R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗X) • R (plus , Z⊗X) • R (minus , I⊗Y) • R (minus , Z⊗Y) • CZ • H1 • W ^ 5 • CZ • S0 • S0 • S1 • H1 • S1 • W • R (plus , I⊗Z) • R (plus , Z⊗I) • R (plus , Z⊗Z) • R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Z⊗Z) • CZ • S0 • S0 • S1 • S1 • ε
          by in-context 41 2 auto (lemma-combine plus plus Z⊗Y)
      equals S1 • H1 • R (plus , Z⊗Z) • T1 • H1 • T1⁻¹ • CX1 • X1 • T1 • H1 • T1⁻¹ • CX1 • T1 • H1 • T1⁻¹ • CX1 • X1 • T1 • H1 • T1⁻¹ • CX1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • R (minus , I⊗X) • R (plus , Z⊗X) • R (minus , I⊗Z) • R (minus , Z⊗Z) • S1 • H1 • Swap • W • Swap • H1 • S1⁻¹ • S1 • H1 • H0 • CZ • H0 • S0 • H0 • CZ • H0 • H1 • S1⁻¹ • R (minus , I⊗X) • R (minus , Z⊗X) • R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗X) • R (plus , Z⊗X) • R (minus , I⊗Y) • R (minus , Z⊗Y) • CZ • H1 • W ^ 5 • CZ • S0 • S0 • S1 • H1 • S1 • W • R (plus , I⊗Z) • R (plus , Z⊗I) • R (plus , Z⊗Z) • R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Z⊗Z) • CZ • S0 • S0 • S1 • S1 • ε
          by clifford-tactic 36 16 10000 auto
      equals S1 • H1 • R (plus , Z⊗Z) • T1 • H1 • T1⁻¹ • CX1 • X1 • T1 • H1 • T1⁻¹ • CX1 • T1 • H1 • T1⁻¹ • CX1 • X1 • T1 • H1 • T1⁻¹ • CX1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • R (minus , I⊗X) • R (plus , Z⊗X) • R (minus , I⊗Z) • R (minus , Z⊗Z) • S1 • H1 • CZ • S0 • S1 • H1 • S1 • S1 • S1 • W • R (minus , I⊗X) • R (minus , Z⊗X) • R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗X) • R (plus , Z⊗X) • R (minus , I⊗Y) • R (minus , Z⊗Y) • CZ • H1 • W ^ 5 • CZ • S0 • S0 • S1 • H1 • S1 • W • R (plus , I⊗Z) • R (plus , Z⊗I) • R (plus , Z⊗Z) • R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Z⊗Z) • CZ • S0 • S0 • S1 • S1 • ε
          by in-context 34 11 auto (lemma-R (C.S1 • C.H1 • C.CZ • C.S0 • C.S1 • C.H1 • C.S1 • C.S1 • C.S1 • C.W) (minus , I⊗X))
      equals S1 • H1 • R (plus , Z⊗Z) • T1 • H1 • T1⁻¹ • CX1 • X1 • T1 • H1 • T1⁻¹ • CX1 • T1 • H1 • T1⁻¹ • CX1 • X1 • T1 • H1 • T1⁻¹ • CX1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • R (minus , I⊗X) • R (plus , Z⊗X) • R (minus , I⊗Z) • R (minus , Z⊗Z) • R (plus , Z⊗Z) • S1 • H1 • CZ • S0 • S1 • H1 • S1 • S1 • S1 • W • R (minus , Z⊗X) • R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗X) • R (plus , Z⊗X) • R (minus , I⊗Y) • R (minus , Z⊗Y) • CZ • H1 • W ^ 5 • CZ • S0 • S0 • S1 • H1 • S1 • W • R (plus , I⊗Z) • R (plus , Z⊗I) • R (plus , Z⊗Z) • R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Z⊗Z) • CZ • S0 • S0 • S1 • S1 • ε
          by in-context 35 11 auto (lemma-R (C.S1 • C.H1 • C.CZ • C.S0 • C.S1 • C.H1 • C.S1 • C.S1 • C.S1 • C.W) (minus , Z⊗X))
      equals S1 • H1 • R (plus , Z⊗Z) • T1 • H1 • T1⁻¹ • CX1 • X1 • T1 • H1 • T1⁻¹ • CX1 • T1 • H1 • T1⁻¹ • CX1 • X1 • T1 • H1 • T1⁻¹ • CX1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • R (minus , I⊗X) • R (plus , Z⊗X) • R (minus , I⊗Z) • R (minus , Z⊗Z) • R (plus , Z⊗Z) • R (plus , I⊗Z) • S1 • H1 • CZ • S0 • S1 • H1 • S1 • S1 • S1 • W • R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗X) • R (plus , Z⊗X) • R (minus , I⊗Y) • R (minus , Z⊗Y) • CZ • H1 • W ^ 5 • CZ • S0 • S0 • S1 • H1 • S1 • W • R (plus , I⊗Z) • R (plus , Z⊗I) • R (plus , Z⊗Z) • R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Z⊗Z) • CZ • S0 • S0 • S1 • S1 • ε
          by in-context 36 11 auto (lemma-R (C.S1 • C.H1 • C.CZ • C.S0 • C.S1 • C.H1 • C.S1 • C.S1 • C.S1 • C.W) (plus , I⊗Y))
      equals S1 • H1 • R (plus , Z⊗Z) • T1 • H1 • T1⁻¹ • CX1 • X1 • T1 • H1 • T1⁻¹ • CX1 • T1 • H1 • T1⁻¹ • CX1 • X1 • T1 • H1 • T1⁻¹ • CX1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • R (minus , I⊗X) • R (plus , Z⊗X) • R (minus , I⊗Z) • R (minus , Z⊗Z) • R (plus , Z⊗Z) • R (plus , I⊗Z) • R (plus , I⊗Y) • S1 • H1 • CZ • S0 • S1 • H1 • S1 • S1 • S1 • W • R (plus , Z⊗Y) • R (plus , I⊗X) • R (plus , Z⊗X) • R (minus , I⊗Y) • R (minus , Z⊗Y) • CZ • H1 • W ^ 5 • CZ • S0 • S0 • S1 • H1 • S1 • W • R (plus , I⊗Z) • R (plus , Z⊗I) • R (plus , Z⊗Z) • R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Z⊗Z) • CZ • S0 • S0 • S1 • S1 • ε
          by in-context 37 11 auto (lemma-R (C.S1 • C.H1 • C.CZ • C.S0 • C.S1 • C.H1 • C.S1 • C.S1 • C.S1 • C.W) (plus , Z⊗Y))
      equals S1 • H1 • R (plus , Z⊗Z) • T1 • H1 • T1⁻¹ • CX1 • X1 • T1 • H1 • T1⁻¹ • CX1 • T1 • H1 • T1⁻¹ • CX1 • X1 • T1 • H1 • T1⁻¹ • CX1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • R (minus , I⊗X) • R (plus , Z⊗X) • R (minus , I⊗Z) • R (minus , Z⊗Z) • R (plus , Z⊗Z) • R (plus , I⊗Z) • R (plus , I⊗Y) • R (plus , Z⊗Y) • S1 • H1 • CZ • S0 • S1 • H1 • S1 • S1 • S1 • W • R (plus , I⊗X) • R (plus , Z⊗X) • R (minus , I⊗Y) • R (minus , Z⊗Y) • CZ • H1 • W ^ 5 • CZ • S0 • S0 • S1 • H1 • S1 • W • R (plus , I⊗Z) • R (plus , Z⊗I) • R (plus , Z⊗Z) • R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Z⊗Z) • CZ • S0 • S0 • S1 • S1 • ε
          by in-context 38 11 auto (lemma-R (C.S1 • C.H1 • C.CZ • C.S0 • C.S1 • C.H1 • C.S1 • C.S1 • C.S1 • C.W) (plus , I⊗X))
      equals S1 • H1 • R (plus , Z⊗Z) • T1 • H1 • T1⁻¹ • CX1 • X1 • T1 • H1 • T1⁻¹ • CX1 • T1 • H1 • T1⁻¹ • CX1 • X1 • T1 • H1 • T1⁻¹ • CX1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • R (minus , I⊗X) • R (plus , Z⊗X) • R (minus , I⊗Z) • R (minus , Z⊗Z) • R (plus , Z⊗Z) • R (plus , I⊗Z) • R (plus , I⊗Y) • R (plus , Z⊗Y) • R (minus , Z⊗Z) • S1 • H1 • CZ • S0 • S1 • H1 • S1 • S1 • S1 • W • R (plus , Z⊗X) • R (minus , I⊗Y) • R (minus , Z⊗Y) • CZ • H1 • W ^ 5 • CZ • S0 • S0 • S1 • H1 • S1 • W • R (plus , I⊗Z) • R (plus , Z⊗I) • R (plus , Z⊗Z) • R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Z⊗Z) • CZ • S0 • S0 • S1 • S1 • ε
          by in-context 39 11 auto (lemma-R (C.S1 • C.H1 • C.CZ • C.S0 • C.S1 • C.H1 • C.S1 • C.S1 • C.S1 • C.W) (plus , Z⊗X))
      equals S1 • H1 • R (plus , Z⊗Z) • T1 • H1 • T1⁻¹ • CX1 • X1 • T1 • H1 • T1⁻¹ • CX1 • T1 • H1 • T1⁻¹ • CX1 • X1 • T1 • H1 • T1⁻¹ • CX1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • R (minus , I⊗X) • R (plus , Z⊗X) • R (minus , I⊗Z) • R (minus , Z⊗Z) • R (plus , Z⊗Z) • R (plus , I⊗Z) • R (plus , I⊗Y) • R (plus , Z⊗Y) • R (minus , Z⊗Z) • R (minus , I⊗Z) • S1 • H1 • CZ • S0 • S1 • H1 • S1 • S1 • S1 • W • R (minus , I⊗Y) • R (minus , Z⊗Y) • CZ • H1 • W ^ 5 • CZ • S0 • S0 • S1 • H1 • S1 • W • R (plus , I⊗Z) • R (plus , Z⊗I) • R (plus , Z⊗Z) • R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Z⊗Z) • CZ • S0 • S0 • S1 • S1 • ε
          by in-context 40 11 auto (lemma-R (C.S1 • C.H1 • C.CZ • C.S0 • C.S1 • C.H1 • C.S1 • C.S1 • C.S1 • C.W) (minus , I⊗Y))
      equals S1 • H1 • R (plus , Z⊗Z) • T1 • H1 • T1⁻¹ • CX1 • X1 • T1 • H1 • T1⁻¹ • CX1 • T1 • H1 • T1⁻¹ • CX1 • X1 • T1 • H1 • T1⁻¹ • CX1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • R (minus , I⊗X) • R (plus , Z⊗X) • R (minus , I⊗Z) • R (minus , Z⊗Z) • R (plus , Z⊗Z) • R (plus , I⊗Z) • R (plus , I⊗Y) • R (plus , Z⊗Y) • R (minus , Z⊗Z) • R (minus , I⊗Z) • R (minus , I⊗Y) • S1 • H1 • CZ • S0 • S1 • H1 • S1 • S1 • S1 • W • R (minus , Z⊗Y) • CZ • H1 • W ^ 5 • CZ • S0 • S0 • S1 • H1 • S1 • W • R (plus , I⊗Z) • R (plus , Z⊗I) • R (plus , Z⊗Z) • R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Z⊗Z) • CZ • S0 • S0 • S1 • S1 • ε
          by in-context 41 11 auto (lemma-R (C.S1 • C.H1 • C.CZ • C.S0 • C.S1 • C.H1 • C.S1 • C.S1 • C.S1 • C.W) (minus , Z⊗Y))
      equals S1 • H1 • R (plus , Z⊗Z) • T1 • H1 • T1⁻¹ • CX1 • X1 • T1 • H1 • T1⁻¹ • CX1 • T1 • H1 • T1⁻¹ • CX1 • X1 • T1 • H1 • T1⁻¹ • CX1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • R (minus , I⊗X) • R (plus , Z⊗X) • R (minus , I⊗Z) • R (minus , Z⊗Z) • R (plus , Z⊗Z) • R (plus , I⊗Z) • R (plus , I⊗Y) • R (plus , Z⊗Y) • R (minus , Z⊗Z) • R (minus , I⊗Z) • R (minus , I⊗Y) • R (minus , Z⊗Y) • S1 • H1 • CZ • S0 • S1 • H1 • S1 • S1 • S1 • W • CZ • H1 • W ^ 5 • CZ • S0 • S0 • S1 • H1 • S1 • W • R (plus , I⊗Z) • R (plus , Z⊗I) • R (plus , Z⊗Z) • R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Z⊗Z) • CZ • S0 • S0 • S1 • S1 • ε
          by clifford-tactic 42 19 10000 auto
      equals S1 • H1 • R (plus , Z⊗Z) • T1 • H1 • T1⁻¹ • CX1 • X1 • T1 • H1 • T1⁻¹ • CX1 • T1 • H1 • T1⁻¹ • CX1 • X1 • T1 • H1 • T1⁻¹ • CX1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • R (minus , I⊗X) • R (plus , Z⊗X) • R (minus , I⊗Z) • R (minus , Z⊗Z) • R (plus , Z⊗Z) • R (plus , I⊗Z) • R (plus , I⊗Y) • R (plus , Z⊗Y) • R (minus , Z⊗Z) • R (minus , I⊗Z) • R (minus , I⊗Y) • R (minus , Z⊗Y) • H1 • S1 • H1 • W • R (plus , I⊗Z) • R (plus , Z⊗I) • R (plus , Z⊗Z) • R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Z⊗Z) • CZ • S0 • S0 • S1 • S1 • ε
          by in-context 34 2 auto (symm (tactic-pauli-commute (plus , I⊗Z) (plus , Z⊗Z) auto))
      equals S1 • H1 • R (plus , Z⊗Z) • T1 • H1 • T1⁻¹ • CX1 • X1 • T1 • H1 • T1⁻¹ • CX1 • T1 • H1 • T1⁻¹ • CX1 • X1 • T1 • H1 • T1⁻¹ • CX1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • R (minus , I⊗X) • R (plus , Z⊗X) • R (minus , I⊗Z) • R (minus , Z⊗Z) • R (plus , I⊗Z) • R (plus , Z⊗Z) • R (plus , I⊗Y) • R (plus , Z⊗Y) • R (minus , Z⊗Z) • R (minus , I⊗Z) • R (minus , I⊗Y) • R (minus , Z⊗Y) • H1 • S1 • H1 • W • R (plus , I⊗Z) • R (plus , Z⊗I) • R (plus , Z⊗Z) • R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Z⊗Z) • CZ • S0 • S0 • S1 • S1 • ε
          by in-context 33 2 auto (symm (tactic-pauli-commute (plus , I⊗Z) (minus , Z⊗Z) auto))
      equals S1 • H1 • R (plus , Z⊗Z) • T1 • H1 • T1⁻¹ • CX1 • X1 • T1 • H1 • T1⁻¹ • CX1 • T1 • H1 • T1⁻¹ • CX1 • X1 • T1 • H1 • T1⁻¹ • CX1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • R (minus , I⊗X) • R (plus , Z⊗X) • R (minus , I⊗Z) • R (plus , I⊗Z) • R (minus , Z⊗Z) • R (plus , Z⊗Z) • R (plus , I⊗Y) • R (plus , Z⊗Y) • R (minus , Z⊗Z) • R (minus , I⊗Z) • R (minus , I⊗Y) • R (minus , Z⊗Y) • H1 • S1 • H1 • W • R (plus , I⊗Z) • R (plus , Z⊗I) • R (plus , Z⊗Z) • R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Z⊗Z) • CZ • S0 • S0 • S1 • S1 • ε
          by in-context 32 2 auto (symm (tactic-pauli-commute (plus , I⊗Z) (minus , I⊗Z) auto))
      equals S1 • H1 • R (plus , Z⊗Z) • T1 • H1 • T1⁻¹ • CX1 • X1 • T1 • H1 • T1⁻¹ • CX1 • T1 • H1 • T1⁻¹ • CX1 • X1 • T1 • H1 • T1⁻¹ • CX1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • R (minus , I⊗X) • R (plus , Z⊗X) • R (plus , I⊗Z) • R (minus , I⊗Z) • R (minus , Z⊗Z) • R (plus , Z⊗Z) • R (plus , I⊗Y) • R (plus , Z⊗Y) • R (minus , Z⊗Z) • R (minus , I⊗Z) • R (minus , I⊗Y) • R (minus , Z⊗Y) • H1 • S1 • H1 • W • R (plus , I⊗Z) • R (plus , Z⊗I) • R (plus , Z⊗Z) • R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Z⊗Z) • CZ • S0 • S0 • S1 • S1 • ε
          by in-context 34 2 auto (symm (tactic-pauli-commute (plus , Z⊗Z) (minus , Z⊗Z) auto))
      equals S1 • H1 • R (plus , Z⊗Z) • T1 • H1 • T1⁻¹ • CX1 • X1 • T1 • H1 • T1⁻¹ • CX1 • T1 • H1 • T1⁻¹ • CX1 • X1 • T1 • H1 • T1⁻¹ • CX1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • R (minus , I⊗X) • R (plus , Z⊗X) • R (plus , I⊗Z) • R (minus , I⊗Z) • R (plus , Z⊗Z) • R (minus , Z⊗Z) • R (plus , I⊗Y) • R (plus , Z⊗Y) • R (minus , Z⊗Z) • R (minus , I⊗Z) • R (minus , I⊗Y) • R (minus , Z⊗Y) • H1 • S1 • H1 • W • R (plus , I⊗Z) • R (plus , Z⊗I) • R (plus , Z⊗Z) • R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Z⊗Z) • CZ • S0 • S0 • S1 • S1 • ε
          by in-context 38 2 auto (symm (tactic-pauli-commute (minus , I⊗Z) (minus , Z⊗Z) auto))
      equals S1 • H1 • R (plus , Z⊗Z) • T1 • H1 • T1⁻¹ • CX1 • X1 • T1 • H1 • T1⁻¹ • CX1 • T1 • H1 • T1⁻¹ • CX1 • X1 • T1 • H1 • T1⁻¹ • CX1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • R (minus , I⊗X) • R (plus , Z⊗X) • R (plus , I⊗Z) • R (minus , I⊗Z) • R (plus , Z⊗Z) • R (minus , Z⊗Z) • R (plus , I⊗Y) • R (plus , Z⊗Y) • R (minus , I⊗Z) • R (minus , Z⊗Z) • R (minus , I⊗Y) • R (minus , Z⊗Y) • H1 • S1 • H1 • W • R (plus , I⊗Z) • R (plus , Z⊗I) • R (plus , Z⊗Z) • R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Z⊗Z) • CZ • S0 • S0 • S1 • S1 • ε
          by in-context 32 2 auto (lemma-combine plus minus I⊗Z)
      equals S1 • H1 • R (plus , Z⊗Z) • T1 • H1 • T1⁻¹ • CX1 • X1 • T1 • H1 • T1⁻¹ • CX1 • T1 • H1 • T1⁻¹ • CX1 • X1 • T1 • H1 • T1⁻¹ • CX1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • R (minus , I⊗X) • R (plus , Z⊗X) • Swap • W • Swap • R (plus , Z⊗Z) • R (minus , Z⊗Z) • R (plus , I⊗Y) • R (plus , Z⊗Y) • R (minus , I⊗Z) • R (minus , Z⊗Z) • R (minus , I⊗Y) • R (minus , Z⊗Y) • H1 • S1 • H1 • W • R (plus , I⊗Z) • R (plus , Z⊗I) • R (plus , Z⊗Z) • R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Z⊗Z) • CZ • S0 • S0 • S1 • S1 • ε
          by in-context 35 2 auto (lemma-combine plus minus Z⊗Z)
      equals S1 • H1 • R (plus , Z⊗Z) • T1 • H1 • T1⁻¹ • CX1 • X1 • T1 • H1 • T1⁻¹ • CX1 • T1 • H1 • T1⁻¹ • CX1 • X1 • T1 • H1 • T1⁻¹ • CX1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • R (minus , I⊗X) • R (plus , Z⊗X) • Swap • W • Swap • H0 • CZ • H0 • W • H0 • CZ • H0 • R (plus , I⊗Y) • R (plus , Z⊗Y) • R (minus , I⊗Z) • R (minus , Z⊗Z) • R (minus , I⊗Y) • R (minus , Z⊗Y) • H1 • S1 • H1 • W • R (plus , I⊗Z) • R (plus , Z⊗I) • R (plus , Z⊗Z) • R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Z⊗Z) • CZ • S0 • S0 • S1 • S1 • ε
          by clifford-tactic 32 10 10000 auto
      equals S1 • H1 • R (plus , Z⊗Z) • T1 • H1 • T1⁻¹ • CX1 • X1 • T1 • H1 • T1⁻¹ • CX1 • T1 • H1 • T1⁻¹ • CX1 • X1 • T1 • H1 • T1⁻¹ • CX1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • R (minus , I⊗X) • R (plus , Z⊗X) • W ^ 2 • R (plus , I⊗Y) • R (plus , Z⊗Y) • R (minus , I⊗Z) • R (minus , Z⊗Z) • R (minus , I⊗Y) • R (minus , Z⊗Y) • H1 • S1 • H1 • W • R (plus , I⊗Z) • R (plus , Z⊗I) • R (plus , Z⊗Z) • R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Z⊗Z) • CZ • S0 • S0 • S1 • S1 • ε
          by in-context 32 2 auto (lemma-R (C.W ^ 2) (plus , I⊗Y))
      equals S1 • H1 • R (plus , Z⊗Z) • T1 • H1 • T1⁻¹ • CX1 • X1 • T1 • H1 • T1⁻¹ • CX1 • T1 • H1 • T1⁻¹ • CX1 • X1 • T1 • H1 • T1⁻¹ • CX1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • R (minus , I⊗X) • R (plus , Z⊗X) • R (plus , I⊗Y) • W ^ 2 • R (plus , Z⊗Y) • R (minus , I⊗Z) • R (minus , Z⊗Z) • R (minus , I⊗Y) • R (minus , Z⊗Y) • H1 • S1 • H1 • W • R (plus , I⊗Z) • R (plus , Z⊗I) • R (plus , Z⊗Z) • R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Z⊗Z) • CZ • S0 • S0 • S1 • S1 • ε
          by in-context 33 2 auto (lemma-R (C.W ^ 2) (plus , Z⊗Y))
      equals S1 • H1 • R (plus , Z⊗Z) • T1 • H1 • T1⁻¹ • CX1 • X1 • T1 • H1 • T1⁻¹ • CX1 • T1 • H1 • T1⁻¹ • CX1 • X1 • T1 • H1 • T1⁻¹ • CX1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • R (minus , I⊗X) • R (plus , Z⊗X) • R (plus , I⊗Y) • R (plus , Z⊗Y) • W ^ 2 • R (minus , I⊗Z) • R (minus , Z⊗Z) • R (minus , I⊗Y) • R (minus , Z⊗Y) • H1 • S1 • H1 • W • R (plus , I⊗Z) • R (plus , Z⊗I) • R (plus , Z⊗Z) • R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Z⊗Z) • CZ • S0 • S0 • S1 • S1 • ε
          by in-context 34 2 auto (lemma-R (C.W ^ 2) (minus , I⊗Z))
      equals S1 • H1 • R (plus , Z⊗Z) • T1 • H1 • T1⁻¹ • CX1 • X1 • T1 • H1 • T1⁻¹ • CX1 • T1 • H1 • T1⁻¹ • CX1 • X1 • T1 • H1 • T1⁻¹ • CX1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • R (minus , I⊗X) • R (plus , Z⊗X) • R (plus , I⊗Y) • R (plus , Z⊗Y) • R (minus , I⊗Z) • W ^ 2 • R (minus , Z⊗Z) • R (minus , I⊗Y) • R (minus , Z⊗Y) • H1 • S1 • H1 • W • R (plus , I⊗Z) • R (plus , Z⊗I) • R (plus , Z⊗Z) • R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Z⊗Z) • CZ • S0 • S0 • S1 • S1 • ε
          by in-context 35 2 auto (lemma-R (C.W ^ 2) (minus , Z⊗Z))
      equals S1 • H1 • R (plus , Z⊗Z) • T1 • H1 • T1⁻¹ • CX1 • X1 • T1 • H1 • T1⁻¹ • CX1 • T1 • H1 • T1⁻¹ • CX1 • X1 • T1 • H1 • T1⁻¹ • CX1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • R (minus , I⊗X) • R (plus , Z⊗X) • R (plus , I⊗Y) • R (plus , Z⊗Y) • R (minus , I⊗Z) • R (minus , Z⊗Z) • W ^ 2 • R (minus , I⊗Y) • R (minus , Z⊗Y) • H1 • S1 • H1 • W • R (plus , I⊗Z) • R (plus , Z⊗I) • R (plus , Z⊗Z) • R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Z⊗Z) • CZ • S0 • S0 • S1 • S1 • ε
          by in-context 36 2 auto (lemma-R (C.W ^ 2) (minus , I⊗Y))
      equals S1 • H1 • R (plus , Z⊗Z) • T1 • H1 • T1⁻¹ • CX1 • X1 • T1 • H1 • T1⁻¹ • CX1 • T1 • H1 • T1⁻¹ • CX1 • X1 • T1 • H1 • T1⁻¹ • CX1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • R (minus , I⊗X) • R (plus , Z⊗X) • R (plus , I⊗Y) • R (plus , Z⊗Y) • R (minus , I⊗Z) • R (minus , Z⊗Z) • R (minus , I⊗Y) • W ^ 2 • R (minus , Z⊗Y) • H1 • S1 • H1 • W • R (plus , I⊗Z) • R (plus , Z⊗I) • R (plus , Z⊗Z) • R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Z⊗Z) • CZ • S0 • S0 • S1 • S1 • ε
          by in-context 37 2 auto (lemma-R (C.W ^ 2) (minus , Z⊗Y))
      equals S1 • H1 • R (plus , Z⊗Z) • T1 • H1 • T1⁻¹ • CX1 • X1 • T1 • H1 • T1⁻¹ • CX1 • T1 • H1 • T1⁻¹ • CX1 • X1 • T1 • H1 • T1⁻¹ • CX1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • R (minus , I⊗X) • R (plus , Z⊗X) • R (plus , I⊗Y) • R (plus , Z⊗Y) • R (minus , I⊗Z) • R (minus , Z⊗Z) • R (minus , I⊗Y) • R (minus , Z⊗Y) • W ^ 2 • H1 • S1 • H1 • W • R (plus , I⊗Z) • R (plus , Z⊗I) • R (plus , Z⊗Z) • R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Z⊗Z) • CZ • S0 • S0 • S1 • S1 • ε
          by clifford-tactic 38 5 10000 auto
      equals S1 • H1 • R (plus , Z⊗Z) • T1 • H1 • T1⁻¹ • CX1 • X1 • T1 • H1 • T1⁻¹ • CX1 • T1 • H1 • T1⁻¹ • CX1 • X1 • T1 • H1 • T1⁻¹ • CX1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • R (minus , I⊗X) • R (plus , Z⊗X) • R (plus , I⊗Y) • R (plus , Z⊗Y) • R (minus , I⊗Z) • R (minus , Z⊗Z) • R (minus , I⊗Y) • R (minus , Z⊗Y) • H1 • S1 • H1 • W ^ 3 • R (plus , I⊗Z) • R (plus , Z⊗I) • R (plus , Z⊗Z) • R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Z⊗Z) • CZ • S0 • S0 • S1 • S1 • ε
          by in-context 30 1 auto (lemma-correction I⊗X)
      equals S1 • H1 • R (plus , Z⊗Z) • T1 • H1 • T1⁻¹ • CX1 • X1 • T1 • H1 • T1⁻¹ • CX1 • T1 • H1 • T1⁻¹ • CX1 • X1 • T1 • H1 • T1⁻¹ • CX1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • R (plus , I⊗X) • H1 • Swap • S0⁻¹ • W • Swap • H1 • R (plus , Z⊗X) • R (plus , I⊗Y) • R (plus , Z⊗Y) • R (minus , I⊗Z) • R (minus , Z⊗Z) • R (minus , I⊗Y) • R (minus , Z⊗Y) • H1 • S1 • H1 • W ^ 3 • R (plus , I⊗Z) • R (plus , Z⊗I) • R (plus , Z⊗Z) • R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Z⊗Z) • CZ • S0 • S0 • S1 • S1 • ε
          by clifford-tactic 31 6 10000 auto
      equals S1 • H1 • R (plus , Z⊗Z) • T1 • H1 • T1⁻¹ • CX1 • X1 • T1 • H1 • T1⁻¹ • CX1 • T1 • H1 • T1⁻¹ • CX1 • X1 • T1 • H1 • T1⁻¹ • CX1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • R (plus , I⊗X) • S1 • H1 • S1 • R (plus , Z⊗X) • R (plus , I⊗Y) • R (plus , Z⊗Y) • R (minus , I⊗Z) • R (minus , Z⊗Z) • R (minus , I⊗Y) • R (minus , Z⊗Y) • H1 • S1 • H1 • W ^ 3 • R (plus , I⊗Z) • R (plus , Z⊗I) • R (plus , Z⊗Z) • R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Z⊗Z) • CZ • S0 • S0 • S1 • S1 • ε
          by in-context 31 4 auto (lemma-R (C.S1 • C.H1 • C.S1) (plus , Z⊗X))
      equals S1 • H1 • R (plus , Z⊗Z) • T1 • H1 • T1⁻¹ • CX1 • X1 • T1 • H1 • T1⁻¹ • CX1 • T1 • H1 • T1⁻¹ • CX1 • X1 • T1 • H1 • T1⁻¹ • CX1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • R (plus , I⊗X) • R (plus , Z⊗X) • S1 • H1 • S1 • R (plus , I⊗Y) • R (plus , Z⊗Y) • R (minus , I⊗Z) • R (minus , Z⊗Z) • R (minus , I⊗Y) • R (minus , Z⊗Y) • H1 • S1 • H1 • W ^ 3 • R (plus , I⊗Z) • R (plus , Z⊗I) • R (plus , Z⊗Z) • R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Z⊗Z) • CZ • S0 • S0 • S1 • S1 • ε
          by in-context 32 4 auto (lemma-R (C.S1 • C.H1 • C.S1) (plus , I⊗Y))
      equals S1 • H1 • R (plus , Z⊗Z) • T1 • H1 • T1⁻¹ • CX1 • X1 • T1 • H1 • T1⁻¹ • CX1 • T1 • H1 • T1⁻¹ • CX1 • X1 • T1 • H1 • T1⁻¹ • CX1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • R (plus , I⊗X) • R (plus , Z⊗X) • R (minus , I⊗Z) • S1 • H1 • S1 • R (plus , Z⊗Y) • R (minus , I⊗Z) • R (minus , Z⊗Z) • R (minus , I⊗Y) • R (minus , Z⊗Y) • H1 • S1 • H1 • W ^ 3 • R (plus , I⊗Z) • R (plus , Z⊗I) • R (plus , Z⊗Z) • R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Z⊗Z) • CZ • S0 • S0 • S1 • S1 • ε
          by in-context 32 1 auto (lemma-correction I⊗Z)
      equals S1 • H1 • R (plus , Z⊗Z) • T1 • H1 • T1⁻¹ • CX1 • X1 • T1 • H1 • T1⁻¹ • CX1 • T1 • H1 • T1⁻¹ • CX1 • X1 • T1 • H1 • T1⁻¹ • CX1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • R (plus , I⊗X) • R (plus , Z⊗X) • R (plus , I⊗Z) • Swap • S0⁻¹ • W • Swap • S1 • H1 • S1 • R (plus , Z⊗Y) • R (minus , I⊗Z) • R (minus , Z⊗Z) • R (minus , I⊗Y) • R (minus , Z⊗Y) • H1 • S1 • H1 • W ^ 3 • R (plus , I⊗Z) • R (plus , Z⊗I) • R (plus , Z⊗Z) • R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Z⊗Z) • CZ • S0 • S0 • S1 • S1 • ε
          by clifford-tactic 33 7 10000 auto
      equals S1 • H1 • R (plus , Z⊗Z) • T1 • H1 • T1⁻¹ • CX1 • X1 • T1 • H1 • T1⁻¹ • CX1 • T1 • H1 • T1⁻¹ • CX1 • X1 • T1 • H1 • T1⁻¹ • CX1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • R (plus , I⊗X) • R (plus , Z⊗X) • R (plus , I⊗Z) • H1 • S1 • W • R (plus , Z⊗Y) • R (minus , I⊗Z) • R (minus , Z⊗Z) • R (minus , I⊗Y) • R (minus , Z⊗Y) • H1 • S1 • H1 • W ^ 3 • R (plus , I⊗Z) • R (plus , Z⊗I) • R (plus , Z⊗Z) • R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Z⊗Z) • CZ • S0 • S0 • S1 • S1 • ε
          by in-context 33 4 auto (lemma-R (C.H1 • C.S1 • C.W) (plus , Z⊗Y))
      equals S1 • H1 • R (plus , Z⊗Z) • T1 • H1 • T1⁻¹ • CX1 • X1 • T1 • H1 • T1⁻¹ • CX1 • T1 • H1 • T1⁻¹ • CX1 • X1 • T1 • H1 • T1⁻¹ • CX1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • R (plus , I⊗X) • R (plus , Z⊗X) • R (plus , I⊗Z) • R (minus , Z⊗Z) • H1 • S1 • W • R (minus , I⊗Z) • R (minus , Z⊗Z) • R (minus , I⊗Y) • R (minus , Z⊗Y) • H1 • S1 • H1 • W ^ 3 • R (plus , I⊗Z) • R (plus , Z⊗I) • R (plus , Z⊗Z) • R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Z⊗Z) • CZ • S0 • S0 • S1 • S1 • ε
          by in-context 33 1 auto (lemma-correction Z⊗Z)
      equals S1 • H1 • R (plus , Z⊗Z) • T1 • H1 • T1⁻¹ • CX1 • X1 • T1 • H1 • T1⁻¹ • CX1 • T1 • H1 • T1⁻¹ • CX1 • X1 • T1 • H1 • T1⁻¹ • CX1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • R (plus , I⊗X) • R (plus , Z⊗X) • R (plus , I⊗Z) • R (plus , Z⊗Z) • H0 • CZ • H0 • S0⁻¹ • W • H0 • CZ • H0 • H1 • S1 • W • R (minus , I⊗Z) • R (minus , Z⊗Z) • R (minus , I⊗Y) • R (minus , Z⊗Y) • H1 • S1 • H1 • W ^ 3 • R (plus , I⊗Z) • R (plus , Z⊗I) • R (plus , Z⊗Z) • R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Z⊗Z) • CZ • S0 • S0 • S1 • S1 • ε
          by clifford-tactic 34 11 10000 auto
      equals S1 • H1 • R (plus , Z⊗Z) • T1 • H1 • T1⁻¹ • CX1 • X1 • T1 • H1 • T1⁻¹ • CX1 • T1 • H1 • T1⁻¹ • CX1 • X1 • T1 • H1 • T1⁻¹ • CX1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • R (plus , I⊗X) • R (plus , Z⊗X) • R (plus , I⊗Z) • R (plus , Z⊗Z) • CZ • S0 • S0 • S0 • S1 • S1 • S1 • H1 • S1 • W ^ 2 • R (minus , I⊗Z) • R (minus , Z⊗Z) • R (minus , I⊗Y) • R (minus , Z⊗Y) • H1 • S1 • H1 • W ^ 3 • R (plus , I⊗Z) • R (plus , Z⊗I) • R (plus , Z⊗Z) • R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Z⊗Z) • CZ • S0 • S0 • S1 • S1 • ε
          by in-context 34 11 auto (lemma-R (C.CZ • C.S0 • C.S0 • C.S0 • C.S1 • C.S1 • C.S1 • C.H1 • C.S1 • C.W ^ 2) (minus , I⊗Z))
      equals S1 • H1 • R (plus , Z⊗Z) • T1 • H1 • T1⁻¹ • CX1 • X1 • T1 • H1 • T1⁻¹ • CX1 • T1 • H1 • T1⁻¹ • CX1 • X1 • T1 • H1 • T1⁻¹ • CX1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • R (plus , I⊗X) • R (plus , Z⊗X) • R (plus , I⊗Z) • R (plus , Z⊗Z) • R (plus , Z⊗Y) • CZ • S0 • S0 • S0 • S1 • S1 • S1 • H1 • S1 • W ^ 2 • R (minus , Z⊗Z) • R (minus , I⊗Y) • R (minus , Z⊗Y) • H1 • S1 • H1 • W ^ 3 • R (plus , I⊗Z) • R (plus , Z⊗I) • R (plus , Z⊗Z) • R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Z⊗Z) • CZ • S0 • S0 • S1 • S1 • ε
          by in-context 35 11 auto (lemma-R (C.CZ • C.S0 • C.S0 • C.S0 • C.S1 • C.S1 • C.S1 • C.H1 • C.S1 • C.W ^ 2) (minus , Z⊗Z))
      equals S1 • H1 • R (plus , Z⊗Z) • T1 • H1 • T1⁻¹ • CX1 • X1 • T1 • H1 • T1⁻¹ • CX1 • T1 • H1 • T1⁻¹ • CX1 • X1 • T1 • H1 • T1⁻¹ • CX1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • R (plus , I⊗X) • R (plus , Z⊗X) • R (plus , I⊗Z) • R (plus , Z⊗Z) • R (plus , Z⊗Y) • R (plus , I⊗Y) • CZ • S0 • S0 • S0 • S1 • S1 • S1 • H1 • S1 • W ^ 2 • R (minus , I⊗Y) • R (minus , Z⊗Y) • H1 • S1 • H1 • W ^ 3 • R (plus , I⊗Z) • R (plus , Z⊗I) • R (plus , Z⊗Z) • R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Z⊗Z) • CZ • S0 • S0 • S1 • S1 • ε
          by in-context 36 11 auto (lemma-R (C.CZ • C.S0 • C.S0 • C.S0 • C.S1 • C.S1 • C.S1 • C.H1 • C.S1 • C.W ^ 2) (minus , I⊗Y))
      equals S1 • H1 • R (plus , Z⊗Z) • T1 • H1 • T1⁻¹ • CX1 • X1 • T1 • H1 • T1⁻¹ • CX1 • T1 • H1 • T1⁻¹ • CX1 • X1 • T1 • H1 • T1⁻¹ • CX1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • R (plus , I⊗X) • R (plus , Z⊗X) • R (plus , I⊗Z) • R (plus , Z⊗Z) • R (plus , Z⊗Y) • R (plus , I⊗Y) • R (plus , I⊗Z) • CZ • S0 • S0 • S0 • S1 • S1 • S1 • H1 • S1 • W ^ 2 • R (minus , Z⊗Y) • H1 • S1 • H1 • W ^ 3 • R (plus , I⊗Z) • R (plus , Z⊗I) • R (plus , Z⊗Z) • R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Z⊗Z) • CZ • S0 • S0 • S1 • S1 • ε
          by in-context 37 11 auto (lemma-R (C.CZ • C.S0 • C.S0 • C.S0 • C.S1 • C.S1 • C.S1 • C.H1 • C.S1 • C.W ^ 2) (minus , Z⊗Y))
      equals S1 • H1 • R (plus , Z⊗Z) • T1 • H1 • T1⁻¹ • CX1 • X1 • T1 • H1 • T1⁻¹ • CX1 • T1 • H1 • T1⁻¹ • CX1 • X1 • T1 • H1 • T1⁻¹ • CX1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • R (plus , I⊗X) • R (plus , Z⊗X) • R (plus , I⊗Z) • R (plus , Z⊗Z) • R (plus , Z⊗Y) • R (plus , I⊗Y) • R (plus , I⊗Z) • R (plus , Z⊗Z) • CZ • S0 • S0 • S0 • S1 • S1 • S1 • H1 • S1 • W ^ 2 • H1 • S1 • H1 • W ^ 3 • R (plus , I⊗Z) • R (plus , Z⊗I) • R (plus , Z⊗Z) • R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Z⊗Z) • CZ • S0 • S0 • S1 • S1 • ε
          by clifford-tactic 44 8 10000 auto
      equals S1 • H1 • R (plus , Z⊗Z) • T1 • H1 • T1⁻¹ • CX1 • X1 • T1 • H1 • T1⁻¹ • CX1 • T1 • H1 • T1⁻¹ • CX1 • X1 • T1 • H1 • T1⁻¹ • CX1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • R (plus , I⊗X) • R (plus , Z⊗X) • R (plus , I⊗Z) • R (plus , Z⊗Z) • R (plus , Z⊗Y) • R (plus , I⊗Y) • R (plus , I⊗Z) • R (plus , Z⊗Z) • CZ • S0 • S0 • S0 • S1 • S1 • W ^ 6 • R (plus , I⊗Z) • R (plus , Z⊗I) • R (plus , Z⊗Z) • R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Z⊗Z) • CZ • S0 • S0 • S1 • S1 • ε
          by in-context 34 2 auto (symm (tactic-pauli-commute (plus , I⊗Y) (plus , Z⊗Y) auto))
      equals S1 • H1 • R (plus , Z⊗Z) • T1 • H1 • T1⁻¹ • CX1 • X1 • T1 • H1 • T1⁻¹ • CX1 • T1 • H1 • T1⁻¹ • CX1 • X1 • T1 • H1 • T1⁻¹ • CX1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • R (plus , I⊗X) • R (plus , Z⊗X) • R (plus , I⊗Z) • R (plus , Z⊗Z) • R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Z⊗Z) • CZ • S0 • S0 • S0 • S1 • S1 • W ^ 6 • R (plus , I⊗Z) • R (plus , Z⊗I) • R (plus , Z⊗Z) • R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Z⊗Z) • CZ • S0 • S0 • S1 • S1 • ε
          by in-context 36 2 auto (tactic-pauli-commute (plus , I⊗Z) (plus , Z⊗Z) auto)
      equals S1 • H1 • R (plus , Z⊗Z) • T1 • H1 • T1⁻¹ • CX1 • X1 • T1 • H1 • T1⁻¹ • CX1 • T1 • H1 • T1⁻¹ • CX1 • X1 • T1 • H1 • T1⁻¹ • CX1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • R (plus , I⊗X) • R (plus , Z⊗X) • R (plus , I⊗Z) • R (plus , Z⊗Z) • R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , Z⊗Z) • R (plus , I⊗Z) • CZ • S0 • S0 • S0 • S1 • S1 • W ^ 6 • R (plus , I⊗Z) • R (plus , Z⊗I) • R (plus , Z⊗Z) • R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Z⊗Z) • CZ • S0 • S0 • S1 • S1 • ε
          by in-context 34 2 auto (tactic-pauli-commute (plus , I⊗Y) (plus , Z⊗Y) auto)
      equals S1 • H1 • R (plus , Z⊗Z) • T1 • H1 • T1⁻¹ • CX1 • X1 • T1 • H1 • T1⁻¹ • CX1 • T1 • H1 • T1⁻¹ • CX1 • X1 • T1 • H1 • T1⁻¹ • CX1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • R (plus , I⊗X) • R (plus , Z⊗X) • R (plus , I⊗Z) • R (plus , Z⊗Z) • R (plus , Z⊗Y) • R (plus , I⊗Y) • R (plus , Z⊗Z) • R (plus , I⊗Z) • CZ • S0 • S0 • S0 • S1 • S1 • W ^ 6 • R (plus , I⊗Z) • R (plus , Z⊗I) • R (plus , Z⊗Z) • R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Z⊗Z) • CZ • S0 • S0 • S1 • S1 • ε
          by in-context 32 2 auto (tactic-pauli-commute (plus , I⊗Z) (plus , Z⊗Z) auto)
      equals S1 • H1 • R (plus , Z⊗Z) • T1 • H1 • T1⁻¹ • CX1 • X1 • T1 • H1 • T1⁻¹ • CX1 • T1 • H1 • T1⁻¹ • CX1 • X1 • T1 • H1 • T1⁻¹ • CX1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • R (plus , I⊗X) • R (plus , Z⊗X) • R (plus , Z⊗Z) • R (plus , I⊗Z) • R (plus , Z⊗Y) • R (plus , I⊗Y) • R (plus , Z⊗Z) • R (plus , I⊗Z) • CZ • S0 • S0 • S0 • S1 • S1 • W ^ 6 • R (plus , I⊗Z) • R (plus , Z⊗I) • R (plus , Z⊗Z) • R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Z⊗Z) • CZ • S0 • S0 • S1 • S1 • ε
          by clifford-tactic 38 7 10000 auto
      equals S1 • H1 • R (plus , Z⊗Z) • T1 • H1 • T1⁻¹ • CX1 • X1 • T1 • H1 • T1⁻¹ • CX1 • T1 • H1 • T1⁻¹ • CX1 • X1 • T1 • H1 • T1⁻¹ • CX1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • R (plus , I⊗X) • R (plus , Z⊗X) • R (plus , Z⊗Z) • R (plus , I⊗Z) • R (plus , Z⊗Y) • R (plus , I⊗Y) • R (plus , Z⊗Z) • R (plus , I⊗Z) • H1 • CZ • S0 • S0 • S0 • H1 • S1 • H1 • W • CZ • S0 • S0 • S0 • H1 • S1 • W ^ 5 • R (plus , I⊗Z) • R (plus , Z⊗I) • R (plus , Z⊗Z) • R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Z⊗Z) • CZ • S0 • S0 • S1 • S1 • ε
          by in-context 37 10 auto (symm (lemma-R (C.H1 • C.CZ • C.S0 • C.S0 • C.S0 • C.H1 • C.S1 • C.H1 • C.W) (plus , Z⊗X)))
      equals S1 • H1 • R (plus , Z⊗Z) • T1 • H1 • T1⁻¹ • CX1 • X1 • T1 • H1 • T1⁻¹ • CX1 • T1 • H1 • T1⁻¹ • CX1 • X1 • T1 • H1 • T1⁻¹ • CX1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • R (plus , I⊗X) • R (plus , Z⊗X) • R (plus , Z⊗Z) • R (plus , I⊗Z) • R (plus , Z⊗Y) • R (plus , I⊗Y) • R (plus , Z⊗Z) • H1 • CZ • S0 • S0 • S0 • H1 • S1 • H1 • W • R (plus , Z⊗X) • CZ • S0 • S0 • S0 • H1 • S1 • W ^ 5 • R (plus , I⊗Z) • R (plus , Z⊗I) • R (plus , Z⊗Z) • R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Z⊗Z) • CZ • S0 • S0 • S1 • S1 • ε
          by in-context 36 10 auto (symm (lemma-R (C.H1 • C.CZ • C.S0 • C.S0 • C.S0 • C.H1 • C.S1 • C.H1 • C.W) (plus , I⊗X)))
      equals S1 • H1 • R (plus , Z⊗Z) • T1 • H1 • T1⁻¹ • CX1 • X1 • T1 • H1 • T1⁻¹ • CX1 • T1 • H1 • T1⁻¹ • CX1 • X1 • T1 • H1 • T1⁻¹ • CX1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • R (plus , I⊗X) • R (plus , Z⊗X) • R (plus , Z⊗Z) • R (plus , I⊗Z) • R (plus , Z⊗Y) • R (plus , I⊗Y) • H1 • CZ • S0 • S0 • S0 • H1 • S1 • H1 • W • R (plus , I⊗X) • R (plus , Z⊗X) • CZ • S0 • S0 • S0 • H1 • S1 • W ^ 5 • R (plus , I⊗Z) • R (plus , Z⊗I) • R (plus , Z⊗Z) • R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Z⊗Z) • CZ • S0 • S0 • S1 • S1 • ε
          by in-context 35 10 auto (symm (lemma-R (C.H1 • C.CZ • C.S0 • C.S0 • C.S0 • C.H1 • C.S1 • C.H1 • C.W) (plus , Z⊗Z)))
      equals S1 • H1 • R (plus , Z⊗Z) • T1 • H1 • T1⁻¹ • CX1 • X1 • T1 • H1 • T1⁻¹ • CX1 • T1 • H1 • T1⁻¹ • CX1 • X1 • T1 • H1 • T1⁻¹ • CX1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • R (plus , I⊗X) • R (plus , Z⊗X) • R (plus , Z⊗Z) • R (plus , I⊗Z) • R (plus , Z⊗Y) • H1 • CZ • S0 • S0 • S0 • H1 • S1 • H1 • W • R (plus , Z⊗Z) • R (plus , I⊗X) • R (plus , Z⊗X) • CZ • S0 • S0 • S0 • H1 • S1 • W ^ 5 • R (plus , I⊗Z) • R (plus , Z⊗I) • R (plus , Z⊗Z) • R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Z⊗Z) • CZ • S0 • S0 • S1 • S1 • ε
          by clifford-tactic 35 9 10000 auto
      equals S1 • H1 • R (plus , Z⊗Z) • T1 • H1 • T1⁻¹ • CX1 • X1 • T1 • H1 • T1⁻¹ • CX1 • T1 • H1 • T1⁻¹ • CX1 • X1 • T1 • H1 • T1⁻¹ • CX1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • R (plus , I⊗X) • R (plus , Z⊗X) • R (plus , Z⊗Z) • R (plus , I⊗Z) • R (plus , Z⊗Y) • S1 • H1 • H0 • CZ • H0 • S0⁻¹ • W • H0 • CZ • H0 • H1 • S1⁻¹ • H1 • H0 • CZ • H0 • S0⁻¹ • W • H0 • CZ • H0 • H1 • R (plus , Z⊗Z) • R (plus , I⊗X) • R (plus , Z⊗X) • CZ • S0 • S0 • S0 • H1 • S1 • W ^ 5 • R (plus , I⊗Z) • R (plus , Z⊗I) • R (plus , Z⊗Z) • R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Z⊗Z) • CZ • S0 • S0 • S1 • S1 • ε
          by in-context 34 13 auto (symm (lemma-correction Z⊗Y))
      equals S1 • H1 • R (plus , Z⊗Z) • T1 • H1 • T1⁻¹ • CX1 • X1 • T1 • H1 • T1⁻¹ • CX1 • T1 • H1 • T1⁻¹ • CX1 • X1 • T1 • H1 • T1⁻¹ • CX1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • R (plus , I⊗X) • R (plus , Z⊗X) • R (plus , Z⊗Z) • R (plus , I⊗Z) • R (minus , Z⊗Y) • H1 • H0 • CZ • H0 • S0⁻¹ • W • H0 • CZ • H0 • H1 • R (plus , Z⊗Z) • R (plus , I⊗X) • R (plus , Z⊗X) • CZ • S0 • S0 • S0 • H1 • S1 • W ^ 5 • R (plus , I⊗Z) • R (plus , Z⊗I) • R (plus , Z⊗Z) • R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Z⊗Z) • CZ • S0 • S0 • S1 • S1 • ε
          by in-context 34 11 auto (symm (lemma-R (C.H1 • C.H0 • C.CZ • C.H0 • C.S0⁻¹ • C.W • C.H0 • C.CZ • C.H0 • C.H1) (minus , I⊗Z)))
      equals S1 • H1 • R (plus , Z⊗Z) • T1 • H1 • T1⁻¹ • CX1 • X1 • T1 • H1 • T1⁻¹ • CX1 • T1 • H1 • T1⁻¹ • CX1 • X1 • T1 • H1 • T1⁻¹ • CX1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • R (plus , I⊗X) • R (plus , Z⊗X) • R (plus , Z⊗Z) • R (plus , I⊗Z) • H1 • H0 • CZ • H0 • S0⁻¹ • W • H0 • CZ • H0 • H1 • R (minus , I⊗Z) • R (plus , Z⊗Z) • R (plus , I⊗X) • R (plus , Z⊗X) • CZ • S0 • S0 • S0 • H1 • S1 • W ^ 5 • R (plus , I⊗Z) • R (plus , Z⊗I) • R (plus , Z⊗Z) • R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Z⊗Z) • CZ • S0 • S0 • S1 • S1 • ε
          by in-context 33 11 auto (symm (lemma-R (C.H1 • C.H0 • C.CZ • C.H0 • C.S0⁻¹ • C.W • C.H0 • C.CZ • C.H0 • C.H1) (minus , Z⊗Y)))
      equals S1 • H1 • R (plus , Z⊗Z) • T1 • H1 • T1⁻¹ • CX1 • X1 • T1 • H1 • T1⁻¹ • CX1 • T1 • H1 • T1⁻¹ • CX1 • X1 • T1 • H1 • T1⁻¹ • CX1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • R (plus , I⊗X) • R (plus , Z⊗X) • R (plus , Z⊗Z) • H1 • H0 • CZ • H0 • S0⁻¹ • W • H0 • CZ • H0 • H1 • R (minus , Z⊗Y) • R (minus , I⊗Z) • R (plus , Z⊗Z) • R (plus , I⊗X) • R (plus , Z⊗X) • CZ • S0 • S0 • S0 • H1 • S1 • W ^ 5 • R (plus , I⊗Z) • R (plus , Z⊗I) • R (plus , Z⊗Z) • R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Z⊗Z) • CZ • S0 • S0 • S1 • S1 • ε
          by in-context 32 11 auto (symm (lemma-R (C.H1 • C.H0 • C.CZ • C.H0 • C.S0⁻¹ • C.W • C.H0 • C.CZ • C.H0 • C.H1) (minus , I⊗Y)))
      equals S1 • H1 • R (plus , Z⊗Z) • T1 • H1 • T1⁻¹ • CX1 • X1 • T1 • H1 • T1⁻¹ • CX1 • T1 • H1 • T1⁻¹ • CX1 • X1 • T1 • H1 • T1⁻¹ • CX1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • R (plus , I⊗X) • R (plus , Z⊗X) • H1 • H0 • CZ • H0 • S0⁻¹ • W • H0 • CZ • H0 • H1 • R (minus , I⊗Y) • R (minus , Z⊗Y) • R (minus , I⊗Z) • R (plus , Z⊗Z) • R (plus , I⊗X) • R (plus , Z⊗X) • CZ • S0 • S0 • S0 • H1 • S1 • W ^ 5 • R (plus , I⊗Z) • R (plus , Z⊗I) • R (plus , Z⊗Z) • R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Z⊗Z) • CZ • S0 • S0 • S1 • S1 • ε
          by in-context 31 11 auto (symm (lemma-correction Z⊗X))
      equals S1 • H1 • R (plus , Z⊗Z) • T1 • H1 • T1⁻¹ • CX1 • X1 • T1 • H1 • T1⁻¹ • CX1 • T1 • H1 • T1⁻¹ • CX1 • X1 • T1 • H1 • T1⁻¹ • CX1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • R (plus , I⊗X) • R (minus , Z⊗X) • R (minus , I⊗Y) • R (minus , Z⊗Y) • R (minus , I⊗Z) • R (plus , Z⊗Z) • R (plus , I⊗X) • R (plus , Z⊗X) • CZ • S0 • S0 • S0 • H1 • S1 • W ^ 5 • R (plus , I⊗Z) • R (plus , Z⊗I) • R (plus , Z⊗Z) • R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Z⊗Z) • CZ • S0 • S0 • S1 • S1 • ε
          by clifford-tactic 38 7 10000 auto
      equals S1 • H1 • R (plus , Z⊗Z) • T1 • H1 • T1⁻¹ • CX1 • X1 • T1 • H1 • T1⁻¹ • CX1 • T1 • H1 • T1⁻¹ • CX1 • X1 • T1 • H1 • T1⁻¹ • CX1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • R (plus , I⊗X) • R (minus , Z⊗X) • R (minus , I⊗Y) • R (minus , Z⊗Y) • R (minus , I⊗Z) • R (plus , Z⊗Z) • R (plus , I⊗X) • R (plus , Z⊗X) • S1 • H1 • Swap • S0 • Swap • H1 • S1⁻¹ • H1 • CZ • S0 • H1 • S1 • S1 • S1 • W ^ 4 • R (plus , I⊗Z) • R (plus , Z⊗I) • R (plus , Z⊗Z) • R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Z⊗Z) • CZ • S0 • S0 • S1 • S1 • ε
          by in-context 38 7 auto (symm (lemma-combine plus plus I⊗Y))
      equals S1 • H1 • R (plus , Z⊗Z) • T1 • H1 • T1⁻¹ • CX1 • X1 • T1 • H1 • T1⁻¹ • CX1 • T1 • H1 • T1⁻¹ • CX1 • X1 • T1 • H1 • T1⁻¹ • CX1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • R (plus , I⊗X) • R (minus , Z⊗X) • R (minus , I⊗Y) • R (minus , Z⊗Y) • R (minus , I⊗Z) • R (plus , Z⊗Z) • R (plus , I⊗X) • R (plus , Z⊗X) • R (plus , I⊗Y) • R (plus , I⊗Y) • H1 • CZ • S0 • H1 • S1 • S1 • S1 • W ^ 4 • R (plus , I⊗Z) • R (plus , Z⊗I) • R (plus , Z⊗Z) • R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Z⊗Z) • CZ • S0 • S0 • S1 • S1 • ε
          by in-context 36 2 auto (tactic-pauli-commute (plus , I⊗X) (plus , Z⊗X) auto)
      equals S1 • H1 • R (plus , Z⊗Z) • T1 • H1 • T1⁻¹ • CX1 • X1 • T1 • H1 • T1⁻¹ • CX1 • T1 • H1 • T1⁻¹ • CX1 • X1 • T1 • H1 • T1⁻¹ • CX1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • R (plus , I⊗X) • R (minus , Z⊗X) • R (minus , I⊗Y) • R (minus , Z⊗Y) • R (minus , I⊗Z) • R (plus , Z⊗Z) • R (plus , Z⊗X) • R (plus , I⊗X) • R (plus , I⊗Y) • R (plus , I⊗Y) • H1 • CZ • S0 • H1 • S1 • S1 • S1 • W ^ 4 • R (plus , I⊗Z) • R (plus , Z⊗I) • R (plus , Z⊗Z) • R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Z⊗Z) • CZ • S0 • S0 • S1 • S1 • ε
          by in-context 30 2 auto (tactic-pauli-commute (plus , I⊗X) (minus , Z⊗X) auto)
      equals S1 • H1 • R (plus , Z⊗Z) • T1 • H1 • T1⁻¹ • CX1 • X1 • T1 • H1 • T1⁻¹ • CX1 • T1 • H1 • T1⁻¹ • CX1 • X1 • T1 • H1 • T1⁻¹ • CX1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • R (minus , Z⊗X) • R (plus , I⊗X) • R (minus , I⊗Y) • R (minus , Z⊗Y) • R (minus , I⊗Z) • R (plus , Z⊗Z) • R (plus , Z⊗X) • R (plus , I⊗X) • R (plus , I⊗Y) • R (plus , I⊗Y) • H1 • CZ • S0 • H1 • S1 • S1 • S1 • W ^ 4 • R (plus , I⊗Z) • R (plus , Z⊗I) • R (plus , Z⊗Z) • R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Z⊗Z) • CZ • S0 • S0 • S1 • S1 • ε
          by clifford-tactic 40 8 10000 auto
      equals S1 • H1 • R (plus , Z⊗Z) • T1 • H1 • T1⁻¹ • CX1 • X1 • T1 • H1 • T1⁻¹ • CX1 • T1 • H1 • T1⁻¹ • CX1 • X1 • T1 • H1 • T1⁻¹ • CX1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • R (minus , Z⊗X) • R (plus , I⊗X) • R (minus , I⊗Y) • R (minus , Z⊗Y) • R (minus , I⊗Z) • R (plus , Z⊗Z) • R (plus , Z⊗X) • R (plus , I⊗X) • R (plus , I⊗Y) • R (plus , I⊗Y) • H0 • S0 • S0 • H0 • S0 • S1 • H1 • S1 • W ^ 4 • S1⁻¹ • CX1 • H0 • CZ • H0 • S0⁻¹ • H0 • CZ • H0 • S1⁻¹ • H1 • X0 • R (plus , I⊗Z) • R (plus , Z⊗I) • R (plus , Z⊗Z) • R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Z⊗Z) • CZ • S0 • S0 • S1 • S1 • ε
          by in-context 39 15 auto (symm (lemma-R (C.H0 • C.S0 • C.S0 • C.H0 • C.S0 • C.S1 • C.H1 • C.S1 • C.W ^ 4 • C.S1⁻¹ • C.CX1 • C.H0 • C.CZ • C.H0) (plus , Z⊗I)))
      equals S1 • H1 • R (plus , Z⊗Z) • T1 • H1 • T1⁻¹ • CX1 • X1 • T1 • H1 • T1⁻¹ • CX1 • T1 • H1 • T1⁻¹ • CX1 • X1 • T1 • H1 • T1⁻¹ • CX1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • R (minus , Z⊗X) • R (plus , I⊗X) • R (minus , I⊗Y) • R (minus , Z⊗Y) • R (minus , I⊗Z) • R (plus , Z⊗Z) • R (plus , Z⊗X) • R (plus , I⊗X) • R (plus , I⊗Y) • H0 • S0 • S0 • H0 • S0 • S1 • H1 • S1 • W ^ 4 • S1⁻¹ • CX1 • H0 • CZ • H0 • R (plus , Z⊗I) • S0⁻¹ • H0 • CZ • H0 • S1⁻¹ • H1 • X0 • R (plus , I⊗Z) • R (plus , Z⊗I) • R (plus , Z⊗Z) • R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Z⊗Z) • CZ • S0 • S0 • S1 • S1 • ε
          by in-context 38 10 auto (symm (lemma-R (C.H0 • C.S0 • C.S0 • C.H0 • C.S0 • C.S1 • C.H1 • C.S1 • C.W ^ 4) (plus , I⊗Z)))
      equals S1 • H1 • R (plus , Z⊗Z) • T1 • H1 • T1⁻¹ • CX1 • X1 • T1 • H1 • T1⁻¹ • CX1 • T1 • H1 • T1⁻¹ • CX1 • X1 • T1 • H1 • T1⁻¹ • CX1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • R (minus , Z⊗X) • R (plus , I⊗X) • R (minus , I⊗Y) • R (minus , Z⊗Y) • R (minus , I⊗Z) • R (plus , Z⊗Z) • R (plus , Z⊗X) • R (plus , I⊗X) • H0 • S0 • S0 • H0 • S0 • S1 • H1 • S1 • W ^ 4 • R (plus , I⊗Z) • S1⁻¹ • CX1 • H0 • CZ • H0 • R (plus , Z⊗I) • S0⁻¹ • H0 • CZ • H0 • S1⁻¹ • H1 • X0 • R (plus , I⊗Z) • R (plus , Z⊗I) • R (plus , Z⊗Z) • R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Z⊗Z) • CZ • S0 • S0 • S1 • S1 • ε
          by clifford-tactic 43 4 10000 auto
      equals S1 • H1 • R (plus , Z⊗Z) • T1 • H1 • T1⁻¹ • CX1 • X1 • T1 • H1 • T1⁻¹ • CX1 • T1 • H1 • T1⁻¹ • CX1 • X1 • T1 • H1 • T1⁻¹ • CX1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • R (minus , Z⊗X) • R (plus , I⊗X) • R (minus , I⊗Y) • R (minus , Z⊗Y) • R (minus , I⊗Z) • R (plus , Z⊗Z) • R (plus , Z⊗X) • R (plus , I⊗X) • H0 • S0 • S0 • H0 • S0 • H1 • S1 • S1 • S1 • W ^ 5 • H1 • R (plus , I⊗Z) • S1⁻¹ • CX1 • H0 • CZ • H0 • R (plus , Z⊗I) • S0⁻¹ • H0 • CZ • H0 • S1⁻¹ • H1 • X0 • R (plus , I⊗Z) • R (plus , Z⊗I) • R (plus , Z⊗Z) • R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Z⊗Z) • CZ • S0 • S0 • S1 • S1 • ε
          by in-context 37 11 auto (symm (lemma-R (C.H0 • C.S0 • C.S0 • C.H0 • C.S0 • C.H1 • C.S1 • C.S1 • C.S1 • C.W ^ 5) (plus , I⊗Z)))
      equals S1 • H1 • R (plus , Z⊗Z) • T1 • H1 • T1⁻¹ • CX1 • X1 • T1 • H1 • T1⁻¹ • CX1 • T1 • H1 • T1⁻¹ • CX1 • X1 • T1 • H1 • T1⁻¹ • CX1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • R (minus , Z⊗X) • R (plus , I⊗X) • R (minus , I⊗Y) • R (minus , Z⊗Y) • R (minus , I⊗Z) • R (plus , Z⊗Z) • R (plus , Z⊗X) • H0 • S0 • S0 • H0 • S0 • H1 • S1 • S1 • S1 • W ^ 5 • R (plus , I⊗Z) • H1 • R (plus , I⊗Z) • S1⁻¹ • CX1 • H0 • CZ • H0 • R (plus , Z⊗I) • S0⁻¹ • H0 • CZ • H0 • S1⁻¹ • H1 • X0 • R (plus , I⊗Z) • R (plus , Z⊗I) • R (plus , Z⊗Z) • R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Z⊗Z) • CZ • S0 • S0 • S1 • S1 • ε
          by clifford-tactic 37 10 10000 auto
      equals S1 • H1 • R (plus , Z⊗Z) • T1 • H1 • T1⁻¹ • CX1 • X1 • T1 • H1 • T1⁻¹ • CX1 • T1 • H1 • T1⁻¹ • CX1 • X1 • T1 • H1 • T1⁻¹ • CX1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • R (minus , Z⊗X) • R (plus , I⊗X) • R (minus , I⊗Y) • R (minus , Z⊗Y) • R (minus , I⊗Z) • R (plus , Z⊗Z) • R (plus , Z⊗X) • X0 • H1 • S1 • H1 • S1⁻¹ • CX1 • X1 • H1 • S1⁻¹ • CX1 • H1 • S1⁻¹ • CX1 • X1 • R (plus , I⊗Z) • H1 • R (plus , I⊗Z) • S1⁻¹ • CX1 • H0 • CZ • H0 • R (plus , Z⊗I) • S0⁻¹ • H0 • CZ • H0 • S1⁻¹ • H1 • X0 • R (plus , I⊗Z) • R (plus , Z⊗I) • R (plus , Z⊗Z) • R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Z⊗Z) • CZ • S0 • S0 • S1 • S1 • ε
          by in-context 36 12 auto (symm (lemma-R (C.X0 • C.H1 • C.S1 • C.H1 • C.S1⁻¹ • C.CX1 • C.X1 • C.H1 • C.S1⁻¹ • C.CX1 • C.H1) (plus , I⊗Z)))
      equals S1 • H1 • R (plus , Z⊗Z) • T1 • H1 • T1⁻¹ • CX1 • X1 • T1 • H1 • T1⁻¹ • CX1 • T1 • H1 • T1⁻¹ • CX1 • X1 • T1 • H1 • T1⁻¹ • CX1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • R (minus , Z⊗X) • R (plus , I⊗X) • R (minus , I⊗Y) • R (minus , Z⊗Y) • R (minus , I⊗Z) • R (plus , Z⊗Z) • X0 • H1 • S1 • H1 • S1⁻¹ • CX1 • X1 • H1 • S1⁻¹ • CX1 • H1 • R (plus , I⊗Z) • S1⁻¹ • CX1 • X1 • R (plus , I⊗Z) • H1 • R (plus , I⊗Z) • S1⁻¹ • CX1 • H0 • CZ • H0 • R (plus , Z⊗I) • S0⁻¹ • H0 • CZ • H0 • S1⁻¹ • H1 • X0 • R (plus , I⊗Z) • R (plus , Z⊗I) • R (plus , Z⊗Z) • R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Z⊗Z) • CZ • S0 • S0 • S1 • S1 • ε
          by in-context 35 11 auto (symm (lemma-R (C.X0 • C.H1 • C.S1 • C.H1 • C.S1⁻¹ • C.CX1 • C.X1 • C.H1 • C.S1⁻¹ • C.CX1) (plus , I⊗Z)))
      equals S1 • H1 • R (plus , Z⊗Z) • T1 • H1 • T1⁻¹ • CX1 • X1 • T1 • H1 • T1⁻¹ • CX1 • T1 • H1 • T1⁻¹ • CX1 • X1 • T1 • H1 • T1⁻¹ • CX1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • R (minus , Z⊗X) • R (plus , I⊗X) • R (minus , I⊗Y) • R (minus , Z⊗Y) • R (minus , I⊗Z) • X0 • H1 • S1 • H1 • S1⁻¹ • CX1 • X1 • H1 • S1⁻¹ • CX1 • R (plus , I⊗Z) • H1 • R (plus , I⊗Z) • S1⁻¹ • CX1 • X1 • R (plus , I⊗Z) • H1 • R (plus , I⊗Z) • S1⁻¹ • CX1 • H0 • CZ • H0 • R (plus , Z⊗I) • S0⁻¹ • H0 • CZ • H0 • S1⁻¹ • H1 • X0 • R (plus , I⊗Z) • R (plus , Z⊗I) • R (plus , Z⊗Z) • R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Z⊗Z) • CZ • S0 • S0 • S1 • S1 • ε
          by in-context 34 9 auto (symm (lemma-R (C.X0 • C.H1 • C.S1 • C.H1 • C.S1⁻¹ • C.CX1 • C.X1 • C.H1) (plus , I⊗Z)))
      equals S1 • H1 • R (plus , Z⊗Z) • T1 • H1 • T1⁻¹ • CX1 • X1 • T1 • H1 • T1⁻¹ • CX1 • T1 • H1 • T1⁻¹ • CX1 • X1 • T1 • H1 • T1⁻¹ • CX1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • R (minus , Z⊗X) • R (plus , I⊗X) • R (minus , I⊗Y) • R (minus , Z⊗Y) • X0 • H1 • S1 • H1 • S1⁻¹ • CX1 • X1 • H1 • R (plus , I⊗Z) • S1⁻¹ • CX1 • R (plus , I⊗Z) • H1 • R (plus , I⊗Z) • S1⁻¹ • CX1 • X1 • R (plus , I⊗Z) • H1 • R (plus , I⊗Z) • S1⁻¹ • CX1 • H0 • CZ • H0 • R (plus , Z⊗I) • S0⁻¹ • H0 • CZ • H0 • S1⁻¹ • H1 • X0 • R (plus , I⊗Z) • R (plus , Z⊗I) • R (plus , Z⊗Z) • R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Z⊗Z) • CZ • S0 • S0 • S1 • S1 • ε
          by in-context 33 8 auto (symm (lemma-R (C.X0 • C.H1 • C.S1 • C.H1 • C.S1⁻¹ • C.CX1 • C.X1) (plus , I⊗Z)))
      equals S1 • H1 • R (plus , Z⊗Z) • T1 • H1 • T1⁻¹ • CX1 • X1 • T1 • H1 • T1⁻¹ • CX1 • T1 • H1 • T1⁻¹ • CX1 • X1 • T1 • H1 • T1⁻¹ • CX1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • R (minus , Z⊗X) • R (plus , I⊗X) • R (minus , I⊗Y) • X0 • H1 • S1 • H1 • S1⁻¹ • CX1 • X1 • R (plus , I⊗Z) • H1 • R (plus , I⊗Z) • S1⁻¹ • CX1 • R (plus , I⊗Z) • H1 • R (plus , I⊗Z) • S1⁻¹ • CX1 • X1 • R (plus , I⊗Z) • H1 • R (plus , I⊗Z) • S1⁻¹ • CX1 • H0 • CZ • H0 • R (plus , Z⊗I) • S0⁻¹ • H0 • CZ • H0 • S1⁻¹ • H1 • X0 • R (plus , I⊗Z) • R (plus , Z⊗I) • R (plus , Z⊗Z) • R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Z⊗Z) • CZ • S0 • S0 • S1 • S1 • ε
          by in-context 32 5 auto (symm (lemma-R (C.X0 • C.H1 • C.S1 • C.H1) (plus , I⊗Z)))
      equals S1 • H1 • R (plus , Z⊗Z) • T1 • H1 • T1⁻¹ • CX1 • X1 • T1 • H1 • T1⁻¹ • CX1 • T1 • H1 • T1⁻¹ • CX1 • X1 • T1 • H1 • T1⁻¹ • CX1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • R (minus , Z⊗X) • R (plus , I⊗X) • X0 • H1 • S1 • H1 • R (plus , I⊗Z) • S1⁻¹ • CX1 • X1 • R (plus , I⊗Z) • H1 • R (plus , I⊗Z) • S1⁻¹ • CX1 • R (plus , I⊗Z) • H1 • R (plus , I⊗Z) • S1⁻¹ • CX1 • X1 • R (plus , I⊗Z) • H1 • R (plus , I⊗Z) • S1⁻¹ • CX1 • H0 • CZ • H0 • R (plus , Z⊗I) • S0⁻¹ • H0 • CZ • H0 • S1⁻¹ • H1 • X0 • R (plus , I⊗Z) • R (plus , Z⊗I) • R (plus , Z⊗Z) • R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Z⊗Z) • CZ • S0 • S0 • S1 • S1 • ε
          by in-context 31 4 auto (symm (lemma-R (C.X0 • C.H1 • C.S1) (plus , I⊗Z)))
      equals S1 • H1 • R (plus , Z⊗Z) • T1 • H1 • T1⁻¹ • CX1 • X1 • T1 • H1 • T1⁻¹ • CX1 • T1 • H1 • T1⁻¹ • CX1 • X1 • T1 • H1 • T1⁻¹ • CX1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • R (minus , Z⊗X) • X0 • H1 • S1 • R (plus , I⊗Z) • H1 • R (plus , I⊗Z) • S1⁻¹ • CX1 • X1 • R (plus , I⊗Z) • H1 • R (plus , I⊗Z) • S1⁻¹ • CX1 • R (plus , I⊗Z) • H1 • R (plus , I⊗Z) • S1⁻¹ • CX1 • X1 • R (plus , I⊗Z) • H1 • R (plus , I⊗Z) • S1⁻¹ • CX1 • H0 • CZ • H0 • R (plus , Z⊗I) • S0⁻¹ • H0 • CZ • H0 • S1⁻¹ • H1 • X0 • R (plus , I⊗Z) • R (plus , Z⊗I) • R (plus , Z⊗Z) • R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Z⊗Z) • CZ • S0 • S0 • S1 • S1 • ε
          by in-context 30 4 auto (symm (lemma-R (C.X0 • C.H1 • C.S1) (plus , Z⊗Z)))
      equals S1 • H1 • R (plus , Z⊗Z) • T1 • H1 • T1⁻¹ • CX1 • X1 • T1 • H1 • T1⁻¹ • CX1 • T1 • H1 • T1⁻¹ • CX1 • X1 • T1 • H1 • T1⁻¹ • CX1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • X0 • H1 • S1 • R (plus , Z⊗Z) • R (plus , I⊗Z) • H1 • R (plus , I⊗Z) • S1⁻¹ • CX1 • X1 • R (plus , I⊗Z) • H1 • R (plus , I⊗Z) • S1⁻¹ • CX1 • R (plus , I⊗Z) • H1 • R (plus , I⊗Z) • S1⁻¹ • CX1 • X1 • R (plus , I⊗Z) • H1 • R (plus , I⊗Z) • S1⁻¹ • CX1 • H0 • CZ • H0 • R (plus , Z⊗I) • S0⁻¹ • H0 • CZ • H0 • S1⁻¹ • H1 • X0 • R (plus , I⊗Z) • R (plus , Z⊗I) • R (plus , Z⊗Z) • R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Z⊗Z) • CZ • S0 • S0 • S1 • S1 • ε
          by in-context 59 2 auto (symm lemma-R-T0⁻¹)
      equals S1 • H1 • R (plus , Z⊗Z) • T1 • H1 • T1⁻¹ • CX1 • X1 • T1 • H1 • T1⁻¹ • CX1 • T1 • H1 • T1⁻¹ • CX1 • X1 • T1 • H1 • T1⁻¹ • CX1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • X0 • H1 • S1 • R (plus , Z⊗Z) • R (plus , I⊗Z) • H1 • R (plus , I⊗Z) • S1⁻¹ • CX1 • X1 • R (plus , I⊗Z) • H1 • R (plus , I⊗Z) • S1⁻¹ • CX1 • R (plus , I⊗Z) • H1 • R (plus , I⊗Z) • S1⁻¹ • CX1 • X1 • R (plus , I⊗Z) • H1 • R (plus , I⊗Z) • S1⁻¹ • CX1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • S1⁻¹ • H1 • X0 • R (plus , I⊗Z) • R (plus , Z⊗I) • R (plus , Z⊗Z) • R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Z⊗Z) • CZ • S0 • S0 • S1 • S1 • ε
          by in-context 53 2 auto (symm lemma-R-T1⁻¹)
      equals S1 • H1 • R (plus , Z⊗Z) • T1 • H1 • T1⁻¹ • CX1 • X1 • T1 • H1 • T1⁻¹ • CX1 • T1 • H1 • T1⁻¹ • CX1 • X1 • T1 • H1 • T1⁻¹ • CX1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • X0 • H1 • S1 • R (plus , Z⊗Z) • R (plus , I⊗Z) • H1 • R (plus , I⊗Z) • S1⁻¹ • CX1 • X1 • R (plus , I⊗Z) • H1 • R (plus , I⊗Z) • S1⁻¹ • CX1 • R (plus , I⊗Z) • H1 • R (plus , I⊗Z) • S1⁻¹ • CX1 • X1 • R (plus , I⊗Z) • H1 • T1⁻¹ • CX1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • S1⁻¹ • H1 • X0 • R (plus , I⊗Z) • R (plus , Z⊗I) • R (plus , Z⊗Z) • R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Z⊗Z) • CZ • S0 • S0 • S1 • S1 • ε
          by in-context 51 1 auto (symm lemma-R-T1)
      equals S1 • H1 • R (plus , Z⊗Z) • T1 • H1 • T1⁻¹ • CX1 • X1 • T1 • H1 • T1⁻¹ • CX1 • T1 • H1 • T1⁻¹ • CX1 • X1 • T1 • H1 • T1⁻¹ • CX1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • X0 • H1 • S1 • R (plus , Z⊗Z) • R (plus , I⊗Z) • H1 • R (plus , I⊗Z) • S1⁻¹ • CX1 • X1 • R (plus , I⊗Z) • H1 • R (plus , I⊗Z) • S1⁻¹ • CX1 • R (plus , I⊗Z) • H1 • R (plus , I⊗Z) • S1⁻¹ • CX1 • X1 • T1 • H1 • T1⁻¹ • CX1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • S1⁻¹ • H1 • X0 • R (plus , I⊗Z) • R (plus , Z⊗I) • R (plus , Z⊗Z) • R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Z⊗Z) • CZ • S0 • S0 • S1 • S1 • ε
          by in-context 47 2 auto (symm lemma-R-T1⁻¹)
      equals S1 • H1 • R (plus , Z⊗Z) • T1 • H1 • T1⁻¹ • CX1 • X1 • T1 • H1 • T1⁻¹ • CX1 • T1 • H1 • T1⁻¹ • CX1 • X1 • T1 • H1 • T1⁻¹ • CX1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • X0 • H1 • S1 • R (plus , Z⊗Z) • R (plus , I⊗Z) • H1 • R (plus , I⊗Z) • S1⁻¹ • CX1 • X1 • R (plus , I⊗Z) • H1 • R (plus , I⊗Z) • S1⁻¹ • CX1 • R (plus , I⊗Z) • H1 • T1⁻¹ • CX1 • X1 • T1 • H1 • T1⁻¹ • CX1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • S1⁻¹ • H1 • X0 • R (plus , I⊗Z) • R (plus , Z⊗I) • R (plus , Z⊗Z) • R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Z⊗Z) • CZ • S0 • S0 • S1 • S1 • ε
          by in-context 45 1 auto (symm lemma-R-T1)
      equals S1 • H1 • R (plus , Z⊗Z) • T1 • H1 • T1⁻¹ • CX1 • X1 • T1 • H1 • T1⁻¹ • CX1 • T1 • H1 • T1⁻¹ • CX1 • X1 • T1 • H1 • T1⁻¹ • CX1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • X0 • H1 • S1 • R (plus , Z⊗Z) • R (plus , I⊗Z) • H1 • R (plus , I⊗Z) • S1⁻¹ • CX1 • X1 • R (plus , I⊗Z) • H1 • R (plus , I⊗Z) • S1⁻¹ • CX1 • T1 • H1 • T1⁻¹ • CX1 • X1 • T1 • H1 • T1⁻¹ • CX1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • S1⁻¹ • H1 • X0 • R (plus , I⊗Z) • R (plus , Z⊗I) • R (plus , Z⊗Z) • R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Z⊗Z) • CZ • S0 • S0 • S1 • S1 • ε
          by in-context 42 2 auto (symm lemma-R-T1⁻¹)
      equals S1 • H1 • R (plus , Z⊗Z) • T1 • H1 • T1⁻¹ • CX1 • X1 • T1 • H1 • T1⁻¹ • CX1 • T1 • H1 • T1⁻¹ • CX1 • X1 • T1 • H1 • T1⁻¹ • CX1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • X0 • H1 • S1 • R (plus , Z⊗Z) • R (plus , I⊗Z) • H1 • R (plus , I⊗Z) • S1⁻¹ • CX1 • X1 • R (plus , I⊗Z) • H1 • T1⁻¹ • CX1 • T1 • H1 • T1⁻¹ • CX1 • X1 • T1 • H1 • T1⁻¹ • CX1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • S1⁻¹ • H1 • X0 • R (plus , I⊗Z) • R (plus , Z⊗I) • R (plus , Z⊗Z) • R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Z⊗Z) • CZ • S0 • S0 • S1 • S1 • ε
          by in-context 40 1 auto (symm lemma-R-T1)
      equals S1 • H1 • R (plus , Z⊗Z) • T1 • H1 • T1⁻¹ • CX1 • X1 • T1 • H1 • T1⁻¹ • CX1 • T1 • H1 • T1⁻¹ • CX1 • X1 • T1 • H1 • T1⁻¹ • CX1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • X0 • H1 • S1 • R (plus , Z⊗Z) • R (plus , I⊗Z) • H1 • R (plus , I⊗Z) • S1⁻¹ • CX1 • X1 • T1 • H1 • T1⁻¹ • CX1 • T1 • H1 • T1⁻¹ • CX1 • X1 • T1 • H1 • T1⁻¹ • CX1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • S1⁻¹ • H1 • X0 • R (plus , I⊗Z) • R (plus , Z⊗I) • R (plus , Z⊗Z) • R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Z⊗Z) • CZ • S0 • S0 • S1 • S1 • ε
          by in-context 36 2 auto (symm lemma-R-T1⁻¹)
      equals S1 • H1 • R (plus , Z⊗Z) • T1 • H1 • T1⁻¹ • CX1 • X1 • T1 • H1 • T1⁻¹ • CX1 • T1 • H1 • T1⁻¹ • CX1 • X1 • T1 • H1 • T1⁻¹ • CX1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • X0 • H1 • S1 • R (plus , Z⊗Z) • R (plus , I⊗Z) • H1 • T1⁻¹ • CX1 • X1 • T1 • H1 • T1⁻¹ • CX1 • T1 • H1 • T1⁻¹ • CX1 • X1 • T1 • H1 • T1⁻¹ • CX1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • S1⁻¹ • H1 • X0 • R (plus , I⊗Z) • R (plus , Z⊗I) • R (plus , Z⊗Z) • R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Z⊗Z) • CZ • S0 • S0 • S1 • S1 • ε
          by in-context 34 1 auto (symm lemma-R-T1)
      equals S1 • H1 • R (plus , Z⊗Z) • T1 • H1 • T1⁻¹ • CX1 • X1 • T1 • H1 • T1⁻¹ • CX1 • T1 • H1 • T1⁻¹ • CX1 • X1 • T1 • H1 • T1⁻¹ • CX1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • X0 • H1 • S1 • R (plus , Z⊗Z) • T1 • H1 • T1⁻¹ • CX1 • X1 • T1 • H1 • T1⁻¹ • CX1 • T1 • H1 • T1⁻¹ • CX1 • X1 • T1 • H1 • T1⁻¹ • CX1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • S1⁻¹ • H1 • X0 • R (plus , I⊗Z) • R (plus , Z⊗I) • R (plus , Z⊗Z) • R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Z⊗Z) • CZ • S0 • S0 • S1 • S1 • ε
          by in-context 34 18 auto lemma-rel-A
      equals S1 • H1 • R (plus , Z⊗Z) • T1 • H1 • T1⁻¹ • CX1 • X1 • T1 • H1 • T1⁻¹ • CX1 • T1 • H1 • T1⁻¹ • CX1 • X1 • T1 • H1 • T1⁻¹ • CX1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • X0 • H1 • S1 • R (plus , Z⊗Z) • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • S1⁻¹ • H1 • X0 • R (plus , I⊗Z) • R (plus , Z⊗I) • R (plus , Z⊗Z) • R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Z⊗Z) • CZ • S0 • S0 • S1 • S1 • ε
          by general-assoc auto
      equals S1 • H1 • R (plus , Z⊗Z) • T1 • H1 • T1⁻¹ • CX1 • X1 • T1 • H1 • T1⁻¹ • CX1 • T1 • H1 • T1⁻¹ • CX1 • X1 • T1 • H1 • T1⁻¹ • CX1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • X0 • H1 • S1 • H0 • CZ • H0 • T0 • H0 • CZ • H0 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • S1⁻¹ • H1 • X0 • R (plus , I⊗Z) • R (plus , Z⊗I) • R (plus , Z⊗Z) • R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Z⊗Z) • CZ • S0 • S0 • S1 • S1 • ε
          by clifford-tactic 37 6 10000 auto
      equals S1 • H1 • R (plus , Z⊗Z) • T1 • H1 • T1⁻¹ • CX1 • X1 • T1 • H1 • T1⁻¹ • CX1 • T1 • H1 • T1⁻¹ • CX1 • X1 • T1 • H1 • T1⁻¹ • CX1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • X0 • H1 • S1 • H0 • CZ • H0 • T0 • T0⁻¹ • H0 • CZ • H0 • S1⁻¹ • H1 • X0 • R (plus , I⊗Z) • R (plus , Z⊗I) • R (plus , Z⊗Z) • R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Z⊗Z) • CZ • S0 • S0 • S1 • S1 • ε
          by general-assoc auto
      equals S1 • H1 • R (plus , Z⊗Z) • T1 • H1 • T1⁻¹ • CX1 • X1 • T1 • H1 • T1⁻¹ • CX1 • T1 • H1 • T1⁻¹ • CX1 • X1 • T1 • H1 • T1⁻¹ • CX1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • X0 • H1 • S1 • H0 • CZ • H0 • T0 • T0 • T0 • T0 • T0 • T0 • T0 • T0 • H0 • CZ • H0 • S1⁻¹ • H1 • X0 • R (plus , I⊗Z) • R (plus , Z⊗I) • R (plus , Z⊗Z) • R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Z⊗Z) • CZ • S0 • S0 • S1 • S1 • ε
          by in-context 36 8 auto lemma-order-T0
      equals S1 • H1 • R (plus , Z⊗Z) • T1 • H1 • T1⁻¹ • CX1 • X1 • T1 • H1 • T1⁻¹ • CX1 • T1 • H1 • T1⁻¹ • CX1 • X1 • T1 • H1 • T1⁻¹ • CX1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • X0 • H1 • S1 • H0 • CZ • H0 • H0 • CZ • H0 • S1⁻¹ • H1 • X0 • R (plus , I⊗Z) • R (plus , Z⊗I) • R (plus , Z⊗Z) • R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Z⊗Z) • CZ • S0 • S0 • S1 • S1 • ε
          by clifford-tactic 33 6 10000 auto
      equals S1 • H1 • R (plus , Z⊗Z) • T1 • H1 • T1⁻¹ • CX1 • X1 • T1 • H1 • T1⁻¹ • CX1 • T1 • H1 • T1⁻¹ • CX1 • X1 • T1 • H1 • T1⁻¹ • CX1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • X0 • H1 • S1 • S1⁻¹ • H1 • X0 • R (plus , I⊗Z) • R (plus , Z⊗I) • R (plus , Z⊗Z) • R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Z⊗Z) • CZ • S0 • S0 • S1 • S1 • ε
          by clifford-tactic 30 6 10000 auto
      equals S1 • H1 • R (plus , Z⊗Z) • T1 • H1 • T1⁻¹ • CX1 • X1 • T1 • H1 • T1⁻¹ • CX1 • T1 • H1 • T1⁻¹ • CX1 • X1 • T1 • H1 • T1⁻¹ • CX1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • R (plus , I⊗Z) • R (plus , Z⊗I) • R (plus , Z⊗Z) • R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Z⊗Z) • CZ • S0 • S0 • S1 • S1 • ε
          by in-context 3 18 auto lemma-rel-A
      equals S1 • H1 • R (plus , Z⊗Z) • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • R (plus , I⊗Z) • R (plus , Z⊗I) • R (plus , Z⊗Z) • R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Z⊗Z) • CZ • S0 • S0 • S1 • S1 • ε
          by general-assoc auto
      equals S1 • H1 • H0 • CZ • H0 • T0 • H0 • CZ • H0 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • R (plus , I⊗Z) • R (plus , Z⊗I) • R (plus , Z⊗Z) • R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Z⊗Z) • CZ • S0 • S0 • S1 • S1 • ε
          by clifford-tactic 6 6 10000 auto
      equals S1 • H1 • H0 • CZ • H0 • T0 • T0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • R (plus , I⊗Z) • R (plus , Z⊗I) • R (plus , Z⊗Z) • R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Z⊗Z) • CZ • S0 • S0 • S1 • S1 • ε
          by general-assoc auto
      equals S1 • H1 • H0 • CZ • H0 • T0 • T0 • T0 • T0 • T0 • T0 • T0 • T0 • H0 • CZ • H0 • H1 • S1⁻¹ • R (plus , I⊗Z) • R (plus , Z⊗I) • R (plus , Z⊗Z) • R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Z⊗Z) • CZ • S0 • S0 • S1 • S1 • ε
          by in-context 5 8 auto lemma-order-T0
      equals S1 • H1 • H0 • CZ • H0 • H0 • CZ • H0 • H1 • S1⁻¹ • R (plus , I⊗Z) • R (plus , Z⊗I) • R (plus , Z⊗Z) • R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Z⊗Z) • CZ • S0 • S0 • S1 • S1 • ε
          by clifford-tactic 2 6 10000 auto
      equals S1 • H1 • H1 • S1⁻¹ • R (plus , I⊗Z) • R (plus , Z⊗I) • R (plus , Z⊗Z) • R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Z⊗Z) • CZ • S0 • S0 • S1 • S1 • ε
          by clifford-tactic 0 4 10000 auto
      equals R (plus , I⊗Z) • R (plus , Z⊗I) • R (plus , Z⊗Z) • R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Z⊗Z) • CZ • S0 • S0 • S1 • S1 • ε
          by in-context 3 2 auto (tactic-pauli-commute (plus , I⊗Y) (plus , Z⊗Y) auto)
      equals R (plus , I⊗Z) • R (plus , Z⊗I) • R (plus , Z⊗Z) • R (plus , Z⊗Y) • R (plus , I⊗Y) • R (plus , I⊗Z) • R (plus , Z⊗Z) • CZ • S0 • S0 • S1 • S1 • ε
          by clifford-tactic 7 5 10000 auto
      equals R (plus , I⊗Z) • R (plus , Z⊗I) • R (plus , Z⊗Z) • R (plus , Z⊗Y) • R (plus , I⊗Y) • R (plus , I⊗Z) • R (plus , Z⊗Z) • H0 • CZ • H0 • S0⁻¹ • W • H0 • CZ • H0 • CZ • S0 • S0 • S0 • S1 • S1 • H1 • S1 • S1 • S1 • W • S1 • H1 • CZ • S1 • W ^ 6 • ε
          by in-context 6 9 auto (symm (lemma-correction Z⊗Z))
      equals R (plus , I⊗Z) • R (plus , Z⊗I) • R (plus , Z⊗Z) • R (plus , Z⊗Y) • R (plus , I⊗Y) • R (plus , I⊗Z) • R (minus , Z⊗Z) • CZ • S0 • S0 • S0 • S1 • S1 • H1 • S1 • S1 • S1 • W • S1 • H1 • CZ • S1 • W ^ 6 • ε
          by in-context 6 12 auto (symm (lemma-R (C.CZ • C.S0 • C.S0 • C.S0 • C.S1 • C.S1 • C.H1 • C.S1 • C.S1 • C.S1 • C.W) (minus , Z⊗Y)))
      equals R (plus , I⊗Z) • R (plus , Z⊗I) • R (plus , Z⊗Z) • R (plus , Z⊗Y) • R (plus , I⊗Y) • R (plus , I⊗Z) • CZ • S0 • S0 • S0 • S1 • S1 • H1 • S1 • S1 • S1 • W • R (minus , Z⊗Y) • S1 • H1 • CZ • S1 • W ^ 6 • ε
          by in-context 5 12 auto (symm (lemma-R (C.CZ • C.S0 • C.S0 • C.S0 • C.S1 • C.S1 • C.H1 • C.S1 • C.S1 • C.S1 • C.W) (plus , I⊗Y)))
      equals R (plus , I⊗Z) • R (plus , Z⊗I) • R (plus , Z⊗Z) • R (plus , Z⊗Y) • R (plus , I⊗Y) • CZ • S0 • S0 • S0 • S1 • S1 • H1 • S1 • S1 • S1 • W • R (plus , I⊗Y) • R (minus , Z⊗Y) • S1 • H1 • CZ • S1 • W ^ 6 • ε
          by in-context 4 12 auto (symm (lemma-R (C.CZ • C.S0 • C.S0 • C.S0 • C.S1 • C.S1 • C.H1 • C.S1 • C.S1 • C.S1 • C.W) (minus , Z⊗X)))
      equals R (plus , I⊗Z) • R (plus , Z⊗I) • R (plus , Z⊗Z) • R (plus , Z⊗Y) • CZ • S0 • S0 • S0 • S1 • S1 • H1 • S1 • S1 • S1 • W • R (minus , Z⊗X) • R (plus , I⊗Y) • R (minus , Z⊗Y) • S1 • H1 • CZ • S1 • W ^ 6 • ε
          by clifford-tactic 4 11 10000 auto
      equals R (plus , I⊗Z) • R (plus , Z⊗I) • R (plus , Z⊗Z) • R (plus , Z⊗Y) • S1 • H1 • H0 • CZ • H0 • S0⁻¹ • W • H0 • CZ • H0 • H1 • S1⁻¹ • H0 • CZ • H0 • S0⁻¹ • W • H0 • CZ • H0 • R (minus , Z⊗X) • R (plus , I⊗Y) • R (minus , Z⊗Y) • S1 • H1 • CZ • S1 • W ^ 6 • ε
          by in-context 3 13 auto (symm (lemma-correction Z⊗Y))
      equals R (plus , I⊗Z) • R (plus , Z⊗I) • R (plus , Z⊗Z) • R (minus , Z⊗Y) • H0 • CZ • H0 • S0⁻¹ • W • H0 • CZ • H0 • R (minus , Z⊗X) • R (plus , I⊗Y) • R (minus , Z⊗Y) • S1 • H1 • CZ • S1 • W ^ 6 • ε
          by in-context 3 9 auto (symm (lemma-R (C.H0 • C.CZ • C.H0 • C.S0⁻¹ • C.W • C.H0 • C.CZ • C.H0) (plus , I⊗X)))
      equals R (plus , I⊗Z) • R (plus , Z⊗I) • R (plus , Z⊗Z) • H0 • CZ • H0 • S0⁻¹ • W • H0 • CZ • H0 • R (plus , I⊗X) • R (minus , Z⊗X) • R (plus , I⊗Y) • R (minus , Z⊗Y) • S1 • H1 • CZ • S1 • W ^ 6 • ε
          by in-context 2 9 auto (symm (lemma-correction Z⊗Z))
      equals R (plus , I⊗Z) • R (plus , Z⊗I) • R (minus , Z⊗Z) • R (plus , I⊗X) • R (minus , Z⊗X) • R (plus , I⊗Y) • R (minus , Z⊗Y) • S1 • H1 • CZ • S1 • W ^ 6 • ε
          by in-context 5 2 auto (tactic-pauli-commute (plus , I⊗Y) (minus , Z⊗Y) auto)
      equals R (plus , I⊗Z) • R (plus , Z⊗I) • R (minus , Z⊗Z) • R (plus , I⊗X) • R (minus , Z⊗X) • R (minus , Z⊗Y) • R (plus , I⊗Y) • S1 • H1 • CZ • S1 • W ^ 6 • ε
          by in-context 3 2 auto (tactic-pauli-commute (plus , I⊗X) (minus , Z⊗X) auto)
      equals R (plus , I⊗Z) • R (plus , Z⊗I) • R (minus , Z⊗Z) • R (minus , Z⊗X) • R (plus , I⊗X) • R (minus , Z⊗Y) • R (plus , I⊗Y) • S1 • H1 • CZ • S1 • W ^ 6 • ε
          by clifford-tactic 7 5 10000 auto
      equals R (plus , I⊗Z) • R (plus , Z⊗I) • R (minus , Z⊗Z) • R (minus , Z⊗X) • R (plus , I⊗X) • R (minus , Z⊗Y) • R (plus , I⊗Y) • H1 • CZ • S0 • S0 • H1 • S1 • S1 • H1 • W ^ 5 • H1 • CZ • S0 • S0 • S0 • S1 • S1 • S1 • H1 • S1 • W • ε
          by in-context 6 10 auto (symm (lemma-R (C.H1 • C.CZ • C.S0 • C.S0 • C.H1 • C.S1 • C.S1 • C.H1 • C.W ^ 5) (plus , Z⊗Y)))
      equals R (plus , I⊗Z) • R (plus , Z⊗I) • R (minus , Z⊗Z) • R (minus , Z⊗X) • R (plus , I⊗X) • R (minus , Z⊗Y) • H1 • CZ • S0 • S0 • H1 • S1 • S1 • H1 • W ^ 5 • R (plus , Z⊗Y) • H1 • CZ • S0 • S0 • S0 • S1 • S1 • S1 • H1 • S1 • W • ε
          by clifford-tactic 6 9 10000 auto
      equals R (plus , I⊗Z) • R (plus , Z⊗I) • R (minus , Z⊗Z) • R (minus , Z⊗X) • R (plus , I⊗X) • R (minus , Z⊗Y) • CZ • S0 • S0 • S1 • S1 • H1 • S1 • S1 • H1 • W ^ 4 • S1 • H1 • CZ • S0 • S1 • H1 • S1 • S1 • S1 • R (plus , Z⊗Y) • H1 • CZ • S0 • S0 • S0 • S1 • S1 • S1 • H1 • S1 • W • ε
          by in-context 5 11 auto (symm (lemma-R (C.CZ • C.S0 • C.S0 • C.S1 • C.S1 • C.H1 • C.S1 • C.S1 • C.H1 • C.W ^ 4) (minus , I⊗Y)))
      equals R (plus , I⊗Z) • R (plus , Z⊗I) • R (minus , Z⊗Z) • R (minus , Z⊗X) • R (plus , I⊗X) • CZ • S0 • S0 • S1 • S1 • H1 • S1 • S1 • H1 • W ^ 4 • R (minus , I⊗Y) • S1 • H1 • CZ • S0 • S1 • H1 • S1 • S1 • S1 • R (plus , Z⊗Y) • H1 • CZ • S0 • S0 • S0 • S1 • S1 • S1 • H1 • S1 • W • ε
          by clifford-tactic 8 7 10000 auto
      equals R (plus , I⊗Z) • R (plus , Z⊗I) • R (minus , Z⊗Z) • R (minus , Z⊗X) • R (plus , I⊗X) • CZ • S0 • S0 • W ^ 2 • S1 • S1 • H1 • S1 • S1 • H1 • W ^ 2 • R (minus , I⊗Y) • S1 • H1 • CZ • S0 • S1 • H1 • S1 • S1 • S1 • R (plus , Z⊗Y) • H1 • CZ • S0 • S0 • S0 • S1 • S1 • S1 • H1 • S1 • W • ε
          by in-context 4 5 auto (symm (lemma-R (C.CZ • C.S0 • C.S0 • C.W ^ 2) (plus , Z⊗X)))
      equals R (plus , I⊗Z) • R (plus , Z⊗I) • R (minus , Z⊗Z) • R (minus , Z⊗X) • CZ • S0 • S0 • W ^ 2 • R (plus , Z⊗X) • S1 • S1 • H1 • S1 • S1 • H1 • W ^ 2 • R (minus , I⊗Y) • S1 • H1 • CZ • S0 • S1 • H1 • S1 • S1 • S1 • R (plus , Z⊗Y) • H1 • CZ • S0 • S0 • S0 • S1 • S1 • S1 • H1 • S1 • W • ε
          by in-context 3 5 auto (symm (lemma-R (C.CZ • C.S0 • C.S0 • C.W ^ 2) (minus , I⊗X)))
      equals R (plus , I⊗Z) • R (plus , Z⊗I) • R (minus , Z⊗Z) • CZ • S0 • S0 • W ^ 2 • R (minus , I⊗X) • R (plus , Z⊗X) • S1 • S1 • H1 • S1 • S1 • H1 • W ^ 2 • R (minus , I⊗Y) • S1 • H1 • CZ • S0 • S1 • H1 • S1 • S1 • S1 • R (plus , Z⊗Y) • H1 • CZ • S0 • S0 • S0 • S1 • S1 • S1 • H1 • S1 • W • ε
          by in-context 2 5 auto (symm (lemma-R (C.CZ • C.S0 • C.S0 • C.W ^ 2) (minus , Z⊗Z)))
      equals R (plus , I⊗Z) • R (plus , Z⊗I) • CZ • S0 • S0 • W ^ 2 • R (minus , Z⊗Z) • R (minus , I⊗X) • R (plus , Z⊗X) • S1 • S1 • H1 • S1 • S1 • H1 • W ^ 2 • R (minus , I⊗Y) • S1 • H1 • CZ • S0 • S1 • H1 • S1 • S1 • S1 • R (plus , Z⊗Y) • H1 • CZ • S0 • S0 • S0 • S1 • S1 • S1 • H1 • S1 • W • ε
          by clifford-tactic 2 4 10000 auto
      equals R (plus , I⊗Z) • R (plus , Z⊗I) • S1 • S0 • S0 • S0 • H0 • CZ • H0 • S0⁻¹ • W ^ 2 • H0 • CZ • H0 • R (minus , Z⊗Z) • R (minus , I⊗X) • R (plus , Z⊗X) • S1 • S1 • H1 • S1 • S1 • H1 • W ^ 2 • R (minus , I⊗Y) • S1 • H1 • CZ • S0 • S1 • H1 • S1 • S1 • S1 • R (plus , Z⊗Y) • H1 • CZ • S0 • S0 • S0 • S1 • S1 • S1 • H1 • S1 • W • ε
          by in-context 1 5 auto (symm (lemma-R (C.S1 • C.S0 • C.S0 • C.S0) (plus , Z⊗I)))
      equals R (plus , I⊗Z) • S1 • S0 • S0 • S0 • R (plus , Z⊗I) • H0 • CZ • H0 • S0⁻¹ • W ^ 2 • H0 • CZ • H0 • R (minus , Z⊗Z) • R (minus , I⊗X) • R (plus , Z⊗X) • S1 • S1 • H1 • S1 • S1 • H1 • W ^ 2 • R (minus , I⊗Y) • S1 • H1 • CZ • S0 • S1 • H1 • S1 • S1 • S1 • R (plus , Z⊗Y) • H1 • CZ • S0 • S0 • S0 • S1 • S1 • S1 • H1 • S1 • W • ε
          by in-context 0 2 auto (symm (lemma-R (C.S1) (plus , I⊗Z)))
      equals S1 • R (plus , I⊗Z) • S0 • S0 • S0 • R (plus , Z⊗I) • H0 • CZ • H0 • S0⁻¹ • W ^ 2 • H0 • CZ • H0 • R (minus , Z⊗Z) • R (minus , I⊗X) • R (plus , Z⊗X) • S1 • S1 • H1 • S1 • S1 • H1 • W ^ 2 • R (minus , I⊗Y) • S1 • H1 • CZ • S0 • S1 • H1 • S1 • S1 • S1 • R (plus , Z⊗Y) • H1 • CZ • S0 • S0 • S0 • S1 • S1 • S1 • H1 • S1 • W • ε
          by clifford-tactic 27 7 10000 auto
      equals S1 • R (plus , I⊗Z) • S0 • S0 • S0 • R (plus , Z⊗I) • H0 • CZ • H0 • S0⁻¹ • W ^ 2 • H0 • CZ • H0 • R (minus , Z⊗Z) • R (minus , I⊗X) • R (plus , Z⊗X) • S1 • S1 • H1 • S1 • S1 • H1 • W ^ 2 • R (minus , I⊗Y) • S1 • H1 • H0 • CZ • H0 • S0 • H0 • CZ • H0 • H1 • S1⁻¹ • R (plus , Z⊗Y) • H1 • CZ • S0 • S0 • S0 • S1 • S1 • S1 • H1 • S1 • W • ε
          by clifford-tactic 18 6 10000 auto
      equals S1 • R (plus , I⊗Z) • S0 • S0 • S0 • R (plus , Z⊗I) • H0 • CZ • H0 • S0⁻¹ • W ^ 2 • H0 • CZ • H0 • R (minus , Z⊗Z) • R (minus , I⊗X) • R (plus , Z⊗X) • S1 • H1 • Swap • S0⁻¹ • W ^ 2 • Swap • H1 • S1⁻¹ • S1 • H1 • Swap • S0⁻¹ • W ^ 2 • Swap • H1 • S1⁻¹ • R (minus , I⊗Y) • S1 • H1 • H0 • CZ • H0 • S0 • H0 • CZ • H0 • H1 • S1⁻¹ • R (plus , Z⊗Y) • H1 • CZ • S0 • S0 • S0 • S1 • S1 • S1 • H1 • S1 • W • ε
          by clifford-tactic 0 1 10000 auto
      equals Swap • S0 • Swap • R (plus , I⊗Z) • S0 • S0 • S0 • R (plus , Z⊗I) • H0 • CZ • H0 • S0⁻¹ • W ^ 2 • H0 • CZ • H0 • R (minus , Z⊗Z) • R (minus , I⊗X) • R (plus , Z⊗X) • S1 • H1 • Swap • S0⁻¹ • W ^ 2 • Swap • H1 • S1⁻¹ • S1 • H1 • Swap • S0⁻¹ • W ^ 2 • Swap • H1 • S1⁻¹ • R (minus , I⊗Y) • S1 • H1 • H0 • CZ • H0 • S0 • H0 • CZ • H0 • H1 • S1⁻¹ • R (plus , Z⊗Y) • H1 • CZ • S0 • S0 • S0 • S1 • S1 • S1 • H1 • S1 • W • ε
          by in-context 36 11 auto (symm (lemma-combine plus plus Z⊗Y))
      equals Swap • S0 • Swap • R (plus , I⊗Z) • S0 • S0 • S0 • R (plus , Z⊗I) • H0 • CZ • H0 • S0⁻¹ • W ^ 2 • H0 • CZ • H0 • R (minus , Z⊗Z) • R (minus , I⊗X) • R (plus , Z⊗X) • S1 • H1 • Swap • S0⁻¹ • W ^ 2 • Swap • H1 • S1⁻¹ • S1 • H1 • Swap • S0⁻¹ • W ^ 2 • Swap • H1 • S1⁻¹ • R (minus , I⊗Y) • R (plus , Z⊗Y) • R (plus , Z⊗Y) • R (plus , Z⊗Y) • H1 • CZ • S0 • S0 • S0 • S1 • S1 • S1 • H1 • S1 • W • ε
          by in-context 27 8 auto (symm (lemma-combine minus minus I⊗Y))
      equals Swap • S0 • Swap • R (plus , I⊗Z) • S0 • S0 • S0 • R (plus , Z⊗I) • H0 • CZ • H0 • S0⁻¹ • W ^ 2 • H0 • CZ • H0 • R (minus , Z⊗Z) • R (minus , I⊗X) • R (plus , Z⊗X) • S1 • H1 • Swap • S0⁻¹ • W ^ 2 • Swap • H1 • S1⁻¹ • R (minus , I⊗Y) • R (minus , I⊗Y) • R (minus , I⊗Y) • R (plus , Z⊗Y) • R (plus , Z⊗Y) • R (plus , Z⊗Y) • H1 • CZ • S0 • S0 • S0 • S1 • S1 • S1 • H1 • S1 • W • ε
          by in-context 19 8 auto (symm (lemma-combine minus minus I⊗Y))
      equals Swap • S0 • Swap • R (plus , I⊗Z) • S0 • S0 • S0 • R (plus , Z⊗I) • H0 • CZ • H0 • S0⁻¹ • W ^ 2 • H0 • CZ • H0 • R (minus , Z⊗Z) • R (minus , I⊗X) • R (plus , Z⊗X) • R (minus , I⊗Y) • R (minus , I⊗Y) • R (minus , I⊗Y) • R (minus , I⊗Y) • R (minus , I⊗Y) • R (plus , Z⊗Y) • R (plus , Z⊗Y) • R (plus , Z⊗Y) • H1 • CZ • S0 • S0 • S0 • S1 • S1 • S1 • H1 • S1 • W • ε
          by in-context 8 8 auto (symm (lemma-combine minus minus Z⊗Z))
      equals Swap • S0 • Swap • R (plus , I⊗Z) • S0 • S0 • S0 • R (plus , Z⊗I) • R (minus , Z⊗Z) • R (minus , Z⊗Z) • R (minus , Z⊗Z) • R (minus , I⊗X) • R (plus , Z⊗X) • R (minus , I⊗Y) • R (minus , I⊗Y) • R (minus , I⊗Y) • R (minus , I⊗Y) • R (minus , I⊗Y) • R (plus , Z⊗Y) • R (plus , Z⊗Y) • R (plus , Z⊗Y) • H1 • CZ • S0 • S0 • S0 • S1 • S1 • S1 • H1 • S1 • W • ε
          by in-context 6 1 auto (symm (lemma-combine plus plus Z⊗I))
      equals Swap • S0 • Swap • R (plus , I⊗Z) • S0 • S0 • R (plus , Z⊗I) • R (plus , Z⊗I) • R (plus , Z⊗I) • R (minus , Z⊗Z) • R (minus , Z⊗Z) • R (minus , Z⊗Z) • R (minus , I⊗X) • R (plus , Z⊗X) • R (minus , I⊗Y) • R (minus , I⊗Y) • R (minus , I⊗Y) • R (minus , I⊗Y) • R (minus , I⊗Y) • R (plus , Z⊗Y) • R (plus , Z⊗Y) • R (plus , Z⊗Y) • H1 • CZ • S0 • S0 • S0 • S1 • S1 • S1 • H1 • S1 • W • ε
          by in-context 5 1 auto (symm (lemma-combine plus plus Z⊗I))
      equals Swap • S0 • Swap • R (plus , I⊗Z) • S0 • R (plus , Z⊗I) • R (plus , Z⊗I) • R (plus , Z⊗I) • R (plus , Z⊗I) • R (plus , Z⊗I) • R (minus , Z⊗Z) • R (minus , Z⊗Z) • R (minus , Z⊗Z) • R (minus , I⊗X) • R (plus , Z⊗X) • R (minus , I⊗Y) • R (minus , I⊗Y) • R (minus , I⊗Y) • R (minus , I⊗Y) • R (minus , I⊗Y) • R (plus , Z⊗Y) • R (plus , Z⊗Y) • R (plus , Z⊗Y) • H1 • CZ • S0 • S0 • S0 • S1 • S1 • S1 • H1 • S1 • W • ε
          by in-context 4 1 auto (symm (lemma-combine plus plus Z⊗I))
      equals Swap • S0 • Swap • R (plus , I⊗Z) • R (plus , Z⊗I) • R (plus , Z⊗I) • R (plus , Z⊗I) • R (plus , Z⊗I) • R (plus , Z⊗I) • R (plus , Z⊗I) • R (plus , Z⊗I) • R (minus , Z⊗Z) • R (minus , Z⊗Z) • R (minus , Z⊗Z) • R (minus , I⊗X) • R (plus , Z⊗X) • R (minus , I⊗Y) • R (minus , I⊗Y) • R (minus , I⊗Y) • R (minus , I⊗Y) • R (minus , I⊗Y) • R (plus , Z⊗Y) • R (plus , Z⊗Y) • R (plus , Z⊗Y) • H1 • CZ • S0 • S0 • S0 • S1 • S1 • S1 • H1 • S1 • W • ε
          by in-context 0 3 auto (symm (lemma-combine plus plus I⊗Z))
      equals R (plus , I⊗Z) • R (plus , I⊗Z) • R (plus , I⊗Z) • R (plus , Z⊗I) • R (plus , Z⊗I) • R (plus , Z⊗I) • R (plus , Z⊗I) • R (plus , Z⊗I) • R (plus , Z⊗I) • R (plus , Z⊗I) • R (minus , Z⊗Z) • R (minus , Z⊗Z) • R (minus , Z⊗Z) • R (minus , I⊗X) • R (plus , Z⊗X) • R (minus , I⊗Y) • R (minus , I⊗Y) • R (minus , I⊗Y) • R (minus , I⊗Y) • R (minus , I⊗Y) • R (plus , Z⊗Y) • R (plus , Z⊗Y) • R (plus , Z⊗Y) • H1 • CZ • S0 • S0 • S0 • S1 • S1 • S1 • H1 • S1 • W • ε
          by in-context 19 2 auto (tactic-pauli-commute (minus , I⊗Y) (plus , Z⊗Y) auto)
      equals R (plus , I⊗Z) • R (plus , I⊗Z) • R (plus , I⊗Z) • R (plus , Z⊗I) • R (plus , Z⊗I) • R (plus , Z⊗I) • R (plus , Z⊗I) • R (plus , Z⊗I) • R (plus , Z⊗I) • R (plus , Z⊗I) • R (minus , Z⊗Z) • R (minus , Z⊗Z) • R (minus , Z⊗Z) • R (minus , I⊗X) • R (plus , Z⊗X) • R (minus , I⊗Y) • R (minus , I⊗Y) • R (minus , I⊗Y) • R (minus , I⊗Y) • R (plus , Z⊗Y) • R (minus , I⊗Y) • R (plus , Z⊗Y) • R (plus , Z⊗Y) • H1 • CZ • S0 • S0 • S0 • S1 • S1 • S1 • H1 • S1 • W • ε
          by in-context 20 2 auto (tactic-pauli-commute (minus , I⊗Y) (plus , Z⊗Y) auto)
      equals R (plus , I⊗Z) • R (plus , I⊗Z) • R (plus , I⊗Z) • R (plus , Z⊗I) • R (plus , Z⊗I) • R (plus , Z⊗I) • R (plus , Z⊗I) • R (plus , Z⊗I) • R (plus , Z⊗I) • R (plus , Z⊗I) • R (minus , Z⊗Z) • R (minus , Z⊗Z) • R (minus , Z⊗Z) • R (minus , I⊗X) • R (plus , Z⊗X) • R (minus , I⊗Y) • R (minus , I⊗Y) • R (minus , I⊗Y) • R (minus , I⊗Y) • R (plus , Z⊗Y) • R (plus , Z⊗Y) • R (minus , I⊗Y) • R (plus , Z⊗Y) • H1 • CZ • S0 • S0 • S0 • S1 • S1 • S1 • H1 • S1 • W • ε
          by in-context 21 2 auto (tactic-pauli-commute (minus , I⊗Y) (plus , Z⊗Y) auto)
      equals R (plus , I⊗Z) • R (plus , I⊗Z) • R (plus , I⊗Z) • R (plus , Z⊗I) • R (plus , Z⊗I) • R (plus , Z⊗I) • R (plus , Z⊗I) • R (plus , Z⊗I) • R (plus , Z⊗I) • R (plus , Z⊗I) • R (minus , Z⊗Z) • R (minus , Z⊗Z) • R (minus , Z⊗Z) • R (minus , I⊗X) • R (plus , Z⊗X) • R (minus , I⊗Y) • R (minus , I⊗Y) • R (minus , I⊗Y) • R (minus , I⊗Y) • R (plus , Z⊗Y) • R (plus , Z⊗Y) • R (plus , Z⊗Y) • R (minus , I⊗Y) • H1 • CZ • S0 • S0 • S0 • S1 • S1 • S1 • H1 • S1 • W • ε
          by in-context 18 2 auto (tactic-pauli-commute (minus , I⊗Y) (plus , Z⊗Y) auto)
      equals R (plus , I⊗Z) • R (plus , I⊗Z) • R (plus , I⊗Z) • R (plus , Z⊗I) • R (plus , Z⊗I) • R (plus , Z⊗I) • R (plus , Z⊗I) • R (plus , Z⊗I) • R (plus , Z⊗I) • R (plus , Z⊗I) • R (minus , Z⊗Z) • R (minus , Z⊗Z) • R (minus , Z⊗Z) • R (minus , I⊗X) • R (plus , Z⊗X) • R (minus , I⊗Y) • R (minus , I⊗Y) • R (minus , I⊗Y) • R (plus , Z⊗Y) • R (minus , I⊗Y) • R (plus , Z⊗Y) • R (plus , Z⊗Y) • R (minus , I⊗Y) • H1 • CZ • S0 • S0 • S0 • S1 • S1 • S1 • H1 • S1 • W • ε
          by in-context 19 2 auto (tactic-pauli-commute (minus , I⊗Y) (plus , Z⊗Y) auto)
      equals R (plus , I⊗Z) • R (plus , I⊗Z) • R (plus , I⊗Z) • R (plus , Z⊗I) • R (plus , Z⊗I) • R (plus , Z⊗I) • R (plus , Z⊗I) • R (plus , Z⊗I) • R (plus , Z⊗I) • R (plus , Z⊗I) • R (minus , Z⊗Z) • R (minus , Z⊗Z) • R (minus , Z⊗Z) • R (minus , I⊗X) • R (plus , Z⊗X) • R (minus , I⊗Y) • R (minus , I⊗Y) • R (minus , I⊗Y) • R (plus , Z⊗Y) • R (plus , Z⊗Y) • R (minus , I⊗Y) • R (plus , Z⊗Y) • R (minus , I⊗Y) • H1 • CZ • S0 • S0 • S0 • S1 • S1 • S1 • H1 • S1 • W • ε
          by in-context 17 2 auto (tactic-pauli-commute (minus , I⊗Y) (plus , Z⊗Y) auto)
      equals R (plus , I⊗Z) • R (plus , I⊗Z) • R (plus , I⊗Z) • R (plus , Z⊗I) • R (plus , Z⊗I) • R (plus , Z⊗I) • R (plus , Z⊗I) • R (plus , Z⊗I) • R (plus , Z⊗I) • R (plus , Z⊗I) • R (minus , Z⊗Z) • R (minus , Z⊗Z) • R (minus , Z⊗Z) • R (minus , I⊗X) • R (plus , Z⊗X) • R (minus , I⊗Y) • R (minus , I⊗Y) • R (plus , Z⊗Y) • R (minus , I⊗Y) • R (plus , Z⊗Y) • R (minus , I⊗Y) • R (plus , Z⊗Y) • R (minus , I⊗Y) • H1 • CZ • S0 • S0 • S0 • S1 • S1 • S1 • H1 • S1 • W • ε
          by in-context 16 2 auto (tactic-pauli-commute (minus , I⊗Y) (plus , Z⊗Y) auto)
      equals R (plus , I⊗Z) • R (plus , I⊗Z) • R (plus , I⊗Z) • R (plus , Z⊗I) • R (plus , Z⊗I) • R (plus , Z⊗I) • R (plus , Z⊗I) • R (plus , Z⊗I) • R (plus , Z⊗I) • R (plus , Z⊗I) • R (minus , Z⊗Z) • R (minus , Z⊗Z) • R (minus , Z⊗Z) • R (minus , I⊗X) • R (plus , Z⊗X) • R (minus , I⊗Y) • R (plus , Z⊗Y) • R (minus , I⊗Y) • R (minus , I⊗Y) • R (plus , Z⊗Y) • R (minus , I⊗Y) • R (plus , Z⊗Y) • R (minus , I⊗Y) • H1 • CZ • S0 • S0 • S0 • S1 • S1 • S1 • H1 • S1 • W • ε
          by in-context 9 2 auto (tactic-pauli-commute (plus , Z⊗I) (minus , Z⊗Z) auto)
      equals R (plus , I⊗Z) • R (plus , I⊗Z) • R (plus , I⊗Z) • R (plus , Z⊗I) • R (plus , Z⊗I) • R (plus , Z⊗I) • R (plus , Z⊗I) • R (plus , Z⊗I) • R (plus , Z⊗I) • R (minus , Z⊗Z) • R (plus , Z⊗I) • R (minus , Z⊗Z) • R (minus , Z⊗Z) • R (minus , I⊗X) • R (plus , Z⊗X) • R (minus , I⊗Y) • R (plus , Z⊗Y) • R (minus , I⊗Y) • R (minus , I⊗Y) • R (plus , Z⊗Y) • R (minus , I⊗Y) • R (plus , Z⊗Y) • R (minus , I⊗Y) • H1 • CZ • S0 • S0 • S0 • S1 • S1 • S1 • H1 • S1 • W • ε
          by in-context 10 2 auto (tactic-pauli-commute (plus , Z⊗I) (minus , Z⊗Z) auto)
      equals R (plus , I⊗Z) • R (plus , I⊗Z) • R (plus , I⊗Z) • R (plus , Z⊗I) • R (plus , Z⊗I) • R (plus , Z⊗I) • R (plus , Z⊗I) • R (plus , Z⊗I) • R (plus , Z⊗I) • R (minus , Z⊗Z) • R (minus , Z⊗Z) • R (plus , Z⊗I) • R (minus , Z⊗Z) • R (minus , I⊗X) • R (plus , Z⊗X) • R (minus , I⊗Y) • R (plus , Z⊗Y) • R (minus , I⊗Y) • R (minus , I⊗Y) • R (plus , Z⊗Y) • R (minus , I⊗Y) • R (plus , Z⊗Y) • R (minus , I⊗Y) • H1 • CZ • S0 • S0 • S0 • S1 • S1 • S1 • H1 • S1 • W • ε
          by in-context 11 2 auto (tactic-pauli-commute (plus , Z⊗I) (minus , Z⊗Z) auto)
      equals R (plus , I⊗Z) • R (plus , I⊗Z) • R (plus , I⊗Z) • R (plus , Z⊗I) • R (plus , Z⊗I) • R (plus , Z⊗I) • R (plus , Z⊗I) • R (plus , Z⊗I) • R (plus , Z⊗I) • R (minus , Z⊗Z) • R (minus , Z⊗Z) • R (minus , Z⊗Z) • R (plus , Z⊗I) • R (minus , I⊗X) • R (plus , Z⊗X) • R (minus , I⊗Y) • R (plus , Z⊗Y) • R (minus , I⊗Y) • R (minus , I⊗Y) • R (plus , Z⊗Y) • R (minus , I⊗Y) • R (plus , Z⊗Y) • R (minus , I⊗Y) • H1 • CZ • S0 • S0 • S0 • S1 • S1 • S1 • H1 • S1 • W • ε
          by in-context 12 2 auto (tactic-pauli-commute (plus , Z⊗I) (minus , I⊗X) auto)
      equals R (plus , I⊗Z) • R (plus , I⊗Z) • R (plus , I⊗Z) • R (plus , Z⊗I) • R (plus , Z⊗I) • R (plus , Z⊗I) • R (plus , Z⊗I) • R (plus , Z⊗I) • R (plus , Z⊗I) • R (minus , Z⊗Z) • R (minus , Z⊗Z) • R (minus , Z⊗Z) • R (minus , I⊗X) • R (plus , Z⊗I) • R (plus , Z⊗X) • R (minus , I⊗Y) • R (plus , Z⊗Y) • R (minus , I⊗Y) • R (minus , I⊗Y) • R (plus , Z⊗Y) • R (minus , I⊗Y) • R (plus , Z⊗Y) • R (minus , I⊗Y) • H1 • CZ • S0 • S0 • S0 • S1 • S1 • S1 • H1 • S1 • W • ε
          by in-context 13 2 auto (tactic-pauli-commute (plus , Z⊗I) (plus , Z⊗X) auto)
      equals R (plus , I⊗Z) • R (plus , I⊗Z) • R (plus , I⊗Z) • R (plus , Z⊗I) • R (plus , Z⊗I) • R (plus , Z⊗I) • R (plus , Z⊗I) • R (plus , Z⊗I) • R (plus , Z⊗I) • R (minus , Z⊗Z) • R (minus , Z⊗Z) • R (minus , Z⊗Z) • R (minus , I⊗X) • R (plus , Z⊗X) • R (plus , Z⊗I) • R (minus , I⊗Y) • R (plus , Z⊗Y) • R (minus , I⊗Y) • R (minus , I⊗Y) • R (plus , Z⊗Y) • R (minus , I⊗Y) • R (plus , Z⊗Y) • R (minus , I⊗Y) • H1 • CZ • S0 • S0 • S0 • S1 • S1 • S1 • H1 • S1 • W • ε
          by in-context 14 2 auto (tactic-pauli-commute (plus , Z⊗I) (minus , I⊗Y) auto)
      equals R (plus , I⊗Z) • R (plus , I⊗Z) • R (plus , I⊗Z) • R (plus , Z⊗I) • R (plus , Z⊗I) • R (plus , Z⊗I) • R (plus , Z⊗I) • R (plus , Z⊗I) • R (plus , Z⊗I) • R (minus , Z⊗Z) • R (minus , Z⊗Z) • R (minus , Z⊗Z) • R (minus , I⊗X) • R (plus , Z⊗X) • R (minus , I⊗Y) • R (plus , Z⊗I) • R (plus , Z⊗Y) • R (minus , I⊗Y) • R (minus , I⊗Y) • R (plus , Z⊗Y) • R (minus , I⊗Y) • R (plus , Z⊗Y) • R (minus , I⊗Y) • H1 • CZ • S0 • S0 • S0 • S1 • S1 • S1 • H1 • S1 • W • ε
          by in-context 15 2 auto (tactic-pauli-commute (plus , Z⊗I) (plus , Z⊗Y) auto)
      equals R (plus , I⊗Z) • R (plus , I⊗Z) • R (plus , I⊗Z) • R (plus , Z⊗I) • R (plus , Z⊗I) • R (plus , Z⊗I) • R (plus , Z⊗I) • R (plus , Z⊗I) • R (plus , Z⊗I) • R (minus , Z⊗Z) • R (minus , Z⊗Z) • R (minus , Z⊗Z) • R (minus , I⊗X) • R (plus , Z⊗X) • R (minus , I⊗Y) • R (plus , Z⊗Y) • R (plus , Z⊗I) • R (minus , I⊗Y) • R (minus , I⊗Y) • R (plus , Z⊗Y) • R (minus , I⊗Y) • R (plus , Z⊗Y) • R (minus , I⊗Y) • H1 • CZ • S0 • S0 • S0 • S1 • S1 • S1 • H1 • S1 • W • ε
          by in-context 16 2 auto (tactic-pauli-commute (plus , Z⊗I) (minus , I⊗Y) auto)
      equals R (plus , I⊗Z) • R (plus , I⊗Z) • R (plus , I⊗Z) • R (plus , Z⊗I) • R (plus , Z⊗I) • R (plus , Z⊗I) • R (plus , Z⊗I) • R (plus , Z⊗I) • R (plus , Z⊗I) • R (minus , Z⊗Z) • R (minus , Z⊗Z) • R (minus , Z⊗Z) • R (minus , I⊗X) • R (plus , Z⊗X) • R (minus , I⊗Y) • R (plus , Z⊗Y) • R (minus , I⊗Y) • R (plus , Z⊗I) • R (minus , I⊗Y) • R (plus , Z⊗Y) • R (minus , I⊗Y) • R (plus , Z⊗Y) • R (minus , I⊗Y) • H1 • CZ • S0 • S0 • S0 • S1 • S1 • S1 • H1 • S1 • W • ε
          by in-context 17 2 auto (tactic-pauli-commute (plus , Z⊗I) (minus , I⊗Y) auto)
      equals R (plus , I⊗Z) • R (plus , I⊗Z) • R (plus , I⊗Z) • R (plus , Z⊗I) • R (plus , Z⊗I) • R (plus , Z⊗I) • R (plus , Z⊗I) • R (plus , Z⊗I) • R (plus , Z⊗I) • R (minus , Z⊗Z) • R (minus , Z⊗Z) • R (minus , Z⊗Z) • R (minus , I⊗X) • R (plus , Z⊗X) • R (minus , I⊗Y) • R (plus , Z⊗Y) • R (minus , I⊗Y) • R (minus , I⊗Y) • R (plus , Z⊗I) • R (plus , Z⊗Y) • R (minus , I⊗Y) • R (plus , Z⊗Y) • R (minus , I⊗Y) • H1 • CZ • S0 • S0 • S0 • S1 • S1 • S1 • H1 • S1 • W • ε
          by in-context 18 2 auto (tactic-pauli-commute (plus , Z⊗I) (plus , Z⊗Y) auto)
      equals R (plus , I⊗Z) • R (plus , I⊗Z) • R (plus , I⊗Z) • R (plus , Z⊗I) • R (plus , Z⊗I) • R (plus , Z⊗I) • R (plus , Z⊗I) • R (plus , Z⊗I) • R (plus , Z⊗I) • R (minus , Z⊗Z) • R (minus , Z⊗Z) • R (minus , Z⊗Z) • R (minus , I⊗X) • R (plus , Z⊗X) • R (minus , I⊗Y) • R (plus , Z⊗Y) • R (minus , I⊗Y) • R (minus , I⊗Y) • R (plus , Z⊗Y) • R (plus , Z⊗I) • R (minus , I⊗Y) • R (plus , Z⊗Y) • R (minus , I⊗Y) • H1 • CZ • S0 • S0 • S0 • S1 • S1 • S1 • H1 • S1 • W • ε
          by in-context 19 2 auto (tactic-pauli-commute (plus , Z⊗I) (minus , I⊗Y) auto)
      equals R (plus , I⊗Z) • R (plus , I⊗Z) • R (plus , I⊗Z) • R (plus , Z⊗I) • R (plus , Z⊗I) • R (plus , Z⊗I) • R (plus , Z⊗I) • R (plus , Z⊗I) • R (plus , Z⊗I) • R (minus , Z⊗Z) • R (minus , Z⊗Z) • R (minus , Z⊗Z) • R (minus , I⊗X) • R (plus , Z⊗X) • R (minus , I⊗Y) • R (plus , Z⊗Y) • R (minus , I⊗Y) • R (minus , I⊗Y) • R (plus , Z⊗Y) • R (minus , I⊗Y) • R (plus , Z⊗I) • R (plus , Z⊗Y) • R (minus , I⊗Y) • H1 • CZ • S0 • S0 • S0 • S1 • S1 • S1 • H1 • S1 • W • ε
          by in-context 20 2 auto (tactic-pauli-commute (plus , Z⊗I) (plus , Z⊗Y) auto)
      equals R (plus , I⊗Z) • R (plus , I⊗Z) • R (plus , I⊗Z) • R (plus , Z⊗I) • R (plus , Z⊗I) • R (plus , Z⊗I) • R (plus , Z⊗I) • R (plus , Z⊗I) • R (plus , Z⊗I) • R (minus , Z⊗Z) • R (minus , Z⊗Z) • R (minus , Z⊗Z) • R (minus , I⊗X) • R (plus , Z⊗X) • R (minus , I⊗Y) • R (plus , Z⊗Y) • R (minus , I⊗Y) • R (minus , I⊗Y) • R (plus , Z⊗Y) • R (minus , I⊗Y) • R (plus , Z⊗Y) • R (plus , Z⊗I) • R (minus , I⊗Y) • H1 • CZ • S0 • S0 • S0 • S1 • S1 • S1 • H1 • S1 • W • ε
          by in-context 8 2 auto (tactic-pauli-commute (plus , Z⊗I) (minus , Z⊗Z) auto)
      equals R (plus , I⊗Z) • R (plus , I⊗Z) • R (plus , I⊗Z) • R (plus , Z⊗I) • R (plus , Z⊗I) • R (plus , Z⊗I) • R (plus , Z⊗I) • R (plus , Z⊗I) • R (minus , Z⊗Z) • R (plus , Z⊗I) • R (minus , Z⊗Z) • R (minus , Z⊗Z) • R (minus , I⊗X) • R (plus , Z⊗X) • R (minus , I⊗Y) • R (plus , Z⊗Y) • R (minus , I⊗Y) • R (minus , I⊗Y) • R (plus , Z⊗Y) • R (minus , I⊗Y) • R (plus , Z⊗Y) • R (plus , Z⊗I) • R (minus , I⊗Y) • H1 • CZ • S0 • S0 • S0 • S1 • S1 • S1 • H1 • S1 • W • ε
          by in-context 9 2 auto (tactic-pauli-commute (plus , Z⊗I) (minus , Z⊗Z) auto)
      equals R (plus , I⊗Z) • R (plus , I⊗Z) • R (plus , I⊗Z) • R (plus , Z⊗I) • R (plus , Z⊗I) • R (plus , Z⊗I) • R (plus , Z⊗I) • R (plus , Z⊗I) • R (minus , Z⊗Z) • R (minus , Z⊗Z) • R (plus , Z⊗I) • R (minus , Z⊗Z) • R (minus , I⊗X) • R (plus , Z⊗X) • R (minus , I⊗Y) • R (plus , Z⊗Y) • R (minus , I⊗Y) • R (minus , I⊗Y) • R (plus , Z⊗Y) • R (minus , I⊗Y) • R (plus , Z⊗Y) • R (plus , Z⊗I) • R (minus , I⊗Y) • H1 • CZ • S0 • S0 • S0 • S1 • S1 • S1 • H1 • S1 • W • ε
          by in-context 10 2 auto (tactic-pauli-commute (plus , Z⊗I) (minus , Z⊗Z) auto)
      equals R (plus , I⊗Z) • R (plus , I⊗Z) • R (plus , I⊗Z) • R (plus , Z⊗I) • R (plus , Z⊗I) • R (plus , Z⊗I) • R (plus , Z⊗I) • R (plus , Z⊗I) • R (minus , Z⊗Z) • R (minus , Z⊗Z) • R (minus , Z⊗Z) • R (plus , Z⊗I) • R (minus , I⊗X) • R (plus , Z⊗X) • R (minus , I⊗Y) • R (plus , Z⊗Y) • R (minus , I⊗Y) • R (minus , I⊗Y) • R (plus , Z⊗Y) • R (minus , I⊗Y) • R (plus , Z⊗Y) • R (plus , Z⊗I) • R (minus , I⊗Y) • H1 • CZ • S0 • S0 • S0 • S1 • S1 • S1 • H1 • S1 • W • ε
          by in-context 11 2 auto (tactic-pauli-commute (plus , Z⊗I) (minus , I⊗X) auto)
      equals R (plus , I⊗Z) • R (plus , I⊗Z) • R (plus , I⊗Z) • R (plus , Z⊗I) • R (plus , Z⊗I) • R (plus , Z⊗I) • R (plus , Z⊗I) • R (plus , Z⊗I) • R (minus , Z⊗Z) • R (minus , Z⊗Z) • R (minus , Z⊗Z) • R (minus , I⊗X) • R (plus , Z⊗I) • R (plus , Z⊗X) • R (minus , I⊗Y) • R (plus , Z⊗Y) • R (minus , I⊗Y) • R (minus , I⊗Y) • R (plus , Z⊗Y) • R (minus , I⊗Y) • R (plus , Z⊗Y) • R (plus , Z⊗I) • R (minus , I⊗Y) • H1 • CZ • S0 • S0 • S0 • S1 • S1 • S1 • H1 • S1 • W • ε
          by in-context 12 2 auto (tactic-pauli-commute (plus , Z⊗I) (plus , Z⊗X) auto)
      equals R (plus , I⊗Z) • R (plus , I⊗Z) • R (plus , I⊗Z) • R (plus , Z⊗I) • R (plus , Z⊗I) • R (plus , Z⊗I) • R (plus , Z⊗I) • R (plus , Z⊗I) • R (minus , Z⊗Z) • R (minus , Z⊗Z) • R (minus , Z⊗Z) • R (minus , I⊗X) • R (plus , Z⊗X) • R (plus , Z⊗I) • R (minus , I⊗Y) • R (plus , Z⊗Y) • R (minus , I⊗Y) • R (minus , I⊗Y) • R (plus , Z⊗Y) • R (minus , I⊗Y) • R (plus , Z⊗Y) • R (plus , Z⊗I) • R (minus , I⊗Y) • H1 • CZ • S0 • S0 • S0 • S1 • S1 • S1 • H1 • S1 • W • ε
          by in-context 13 2 auto (tactic-pauli-commute (plus , Z⊗I) (minus , I⊗Y) auto)
      equals R (plus , I⊗Z) • R (plus , I⊗Z) • R (plus , I⊗Z) • R (plus , Z⊗I) • R (plus , Z⊗I) • R (plus , Z⊗I) • R (plus , Z⊗I) • R (plus , Z⊗I) • R (minus , Z⊗Z) • R (minus , Z⊗Z) • R (minus , Z⊗Z) • R (minus , I⊗X) • R (plus , Z⊗X) • R (minus , I⊗Y) • R (plus , Z⊗I) • R (plus , Z⊗Y) • R (minus , I⊗Y) • R (minus , I⊗Y) • R (plus , Z⊗Y) • R (minus , I⊗Y) • R (plus , Z⊗Y) • R (plus , Z⊗I) • R (minus , I⊗Y) • H1 • CZ • S0 • S0 • S0 • S1 • S1 • S1 • H1 • S1 • W • ε
          by in-context 14 2 auto (tactic-pauli-commute (plus , Z⊗I) (plus , Z⊗Y) auto)
      equals R (plus , I⊗Z) • R (plus , I⊗Z) • R (plus , I⊗Z) • R (plus , Z⊗I) • R (plus , Z⊗I) • R (plus , Z⊗I) • R (plus , Z⊗I) • R (plus , Z⊗I) • R (minus , Z⊗Z) • R (minus , Z⊗Z) • R (minus , Z⊗Z) • R (minus , I⊗X) • R (plus , Z⊗X) • R (minus , I⊗Y) • R (plus , Z⊗Y) • R (plus , Z⊗I) • R (minus , I⊗Y) • R (minus , I⊗Y) • R (plus , Z⊗Y) • R (minus , I⊗Y) • R (plus , Z⊗Y) • R (plus , Z⊗I) • R (minus , I⊗Y) • H1 • CZ • S0 • S0 • S0 • S1 • S1 • S1 • H1 • S1 • W • ε
          by in-context 15 2 auto (tactic-pauli-commute (plus , Z⊗I) (minus , I⊗Y) auto)
      equals R (plus , I⊗Z) • R (plus , I⊗Z) • R (plus , I⊗Z) • R (plus , Z⊗I) • R (plus , Z⊗I) • R (plus , Z⊗I) • R (plus , Z⊗I) • R (plus , Z⊗I) • R (minus , Z⊗Z) • R (minus , Z⊗Z) • R (minus , Z⊗Z) • R (minus , I⊗X) • R (plus , Z⊗X) • R (minus , I⊗Y) • R (plus , Z⊗Y) • R (minus , I⊗Y) • R (plus , Z⊗I) • R (minus , I⊗Y) • R (plus , Z⊗Y) • R (minus , I⊗Y) • R (plus , Z⊗Y) • R (plus , Z⊗I) • R (minus , I⊗Y) • H1 • CZ • S0 • S0 • S0 • S1 • S1 • S1 • H1 • S1 • W • ε
          by in-context 16 2 auto (tactic-pauli-commute (plus , Z⊗I) (minus , I⊗Y) auto)
      equals R (plus , I⊗Z) • R (plus , I⊗Z) • R (plus , I⊗Z) • R (plus , Z⊗I) • R (plus , Z⊗I) • R (plus , Z⊗I) • R (plus , Z⊗I) • R (plus , Z⊗I) • R (minus , Z⊗Z) • R (minus , Z⊗Z) • R (minus , Z⊗Z) • R (minus , I⊗X) • R (plus , Z⊗X) • R (minus , I⊗Y) • R (plus , Z⊗Y) • R (minus , I⊗Y) • R (minus , I⊗Y) • R (plus , Z⊗I) • R (plus , Z⊗Y) • R (minus , I⊗Y) • R (plus , Z⊗Y) • R (plus , Z⊗I) • R (minus , I⊗Y) • H1 • CZ • S0 • S0 • S0 • S1 • S1 • S1 • H1 • S1 • W • ε
          by in-context 17 2 auto (tactic-pauli-commute (plus , Z⊗I) (plus , Z⊗Y) auto)
      equals R (plus , I⊗Z) • R (plus , I⊗Z) • R (plus , I⊗Z) • R (plus , Z⊗I) • R (plus , Z⊗I) • R (plus , Z⊗I) • R (plus , Z⊗I) • R (plus , Z⊗I) • R (minus , Z⊗Z) • R (minus , Z⊗Z) • R (minus , Z⊗Z) • R (minus , I⊗X) • R (plus , Z⊗X) • R (minus , I⊗Y) • R (plus , Z⊗Y) • R (minus , I⊗Y) • R (minus , I⊗Y) • R (plus , Z⊗Y) • R (plus , Z⊗I) • R (minus , I⊗Y) • R (plus , Z⊗Y) • R (plus , Z⊗I) • R (minus , I⊗Y) • H1 • CZ • S0 • S0 • S0 • S1 • S1 • S1 • H1 • S1 • W • ε
          by in-context 7 2 auto (tactic-pauli-commute (plus , Z⊗I) (minus , Z⊗Z) auto)
      equals R (plus , I⊗Z) • R (plus , I⊗Z) • R (plus , I⊗Z) • R (plus , Z⊗I) • R (plus , Z⊗I) • R (plus , Z⊗I) • R (plus , Z⊗I) • R (minus , Z⊗Z) • R (plus , Z⊗I) • R (minus , Z⊗Z) • R (minus , Z⊗Z) • R (minus , I⊗X) • R (plus , Z⊗X) • R (minus , I⊗Y) • R (plus , Z⊗Y) • R (minus , I⊗Y) • R (minus , I⊗Y) • R (plus , Z⊗Y) • R (plus , Z⊗I) • R (minus , I⊗Y) • R (plus , Z⊗Y) • R (plus , Z⊗I) • R (minus , I⊗Y) • H1 • CZ • S0 • S0 • S0 • S1 • S1 • S1 • H1 • S1 • W • ε
          by in-context 8 2 auto (tactic-pauli-commute (plus , Z⊗I) (minus , Z⊗Z) auto)
      equals R (plus , I⊗Z) • R (plus , I⊗Z) • R (plus , I⊗Z) • R (plus , Z⊗I) • R (plus , Z⊗I) • R (plus , Z⊗I) • R (plus , Z⊗I) • R (minus , Z⊗Z) • R (minus , Z⊗Z) • R (plus , Z⊗I) • R (minus , Z⊗Z) • R (minus , I⊗X) • R (plus , Z⊗X) • R (minus , I⊗Y) • R (plus , Z⊗Y) • R (minus , I⊗Y) • R (minus , I⊗Y) • R (plus , Z⊗Y) • R (plus , Z⊗I) • R (minus , I⊗Y) • R (plus , Z⊗Y) • R (plus , Z⊗I) • R (minus , I⊗Y) • H1 • CZ • S0 • S0 • S0 • S1 • S1 • S1 • H1 • S1 • W • ε
          by in-context 9 2 auto (tactic-pauli-commute (plus , Z⊗I) (minus , Z⊗Z) auto)
      equals R (plus , I⊗Z) • R (plus , I⊗Z) • R (plus , I⊗Z) • R (plus , Z⊗I) • R (plus , Z⊗I) • R (plus , Z⊗I) • R (plus , Z⊗I) • R (minus , Z⊗Z) • R (minus , Z⊗Z) • R (minus , Z⊗Z) • R (plus , Z⊗I) • R (minus , I⊗X) • R (plus , Z⊗X) • R (minus , I⊗Y) • R (plus , Z⊗Y) • R (minus , I⊗Y) • R (minus , I⊗Y) • R (plus , Z⊗Y) • R (plus , Z⊗I) • R (minus , I⊗Y) • R (plus , Z⊗Y) • R (plus , Z⊗I) • R (minus , I⊗Y) • H1 • CZ • S0 • S0 • S0 • S1 • S1 • S1 • H1 • S1 • W • ε
          by in-context 10 2 auto (tactic-pauli-commute (plus , Z⊗I) (minus , I⊗X) auto)
      equals R (plus , I⊗Z) • R (plus , I⊗Z) • R (plus , I⊗Z) • R (plus , Z⊗I) • R (plus , Z⊗I) • R (plus , Z⊗I) • R (plus , Z⊗I) • R (minus , Z⊗Z) • R (minus , Z⊗Z) • R (minus , Z⊗Z) • R (minus , I⊗X) • R (plus , Z⊗I) • R (plus , Z⊗X) • R (minus , I⊗Y) • R (plus , Z⊗Y) • R (minus , I⊗Y) • R (minus , I⊗Y) • R (plus , Z⊗Y) • R (plus , Z⊗I) • R (minus , I⊗Y) • R (plus , Z⊗Y) • R (plus , Z⊗I) • R (minus , I⊗Y) • H1 • CZ • S0 • S0 • S0 • S1 • S1 • S1 • H1 • S1 • W • ε
          by in-context 11 2 auto (tactic-pauli-commute (plus , Z⊗I) (plus , Z⊗X) auto)
      equals R (plus , I⊗Z) • R (plus , I⊗Z) • R (plus , I⊗Z) • R (plus , Z⊗I) • R (plus , Z⊗I) • R (plus , Z⊗I) • R (plus , Z⊗I) • R (minus , Z⊗Z) • R (minus , Z⊗Z) • R (minus , Z⊗Z) • R (minus , I⊗X) • R (plus , Z⊗X) • R (plus , Z⊗I) • R (minus , I⊗Y) • R (plus , Z⊗Y) • R (minus , I⊗Y) • R (minus , I⊗Y) • R (plus , Z⊗Y) • R (plus , Z⊗I) • R (minus , I⊗Y) • R (plus , Z⊗Y) • R (plus , Z⊗I) • R (minus , I⊗Y) • H1 • CZ • S0 • S0 • S0 • S1 • S1 • S1 • H1 • S1 • W • ε
          by in-context 12 2 auto (tactic-pauli-commute (plus , Z⊗I) (minus , I⊗Y) auto)
      equals R (plus , I⊗Z) • R (plus , I⊗Z) • R (plus , I⊗Z) • R (plus , Z⊗I) • R (plus , Z⊗I) • R (plus , Z⊗I) • R (plus , Z⊗I) • R (minus , Z⊗Z) • R (minus , Z⊗Z) • R (minus , Z⊗Z) • R (minus , I⊗X) • R (plus , Z⊗X) • R (minus , I⊗Y) • R (plus , Z⊗I) • R (plus , Z⊗Y) • R (minus , I⊗Y) • R (minus , I⊗Y) • R (plus , Z⊗Y) • R (plus , Z⊗I) • R (minus , I⊗Y) • R (plus , Z⊗Y) • R (plus , Z⊗I) • R (minus , I⊗Y) • H1 • CZ • S0 • S0 • S0 • S1 • S1 • S1 • H1 • S1 • W • ε
          by in-context 13 2 auto (tactic-pauli-commute (plus , Z⊗I) (plus , Z⊗Y) auto)
      equals R (plus , I⊗Z) • R (plus , I⊗Z) • R (plus , I⊗Z) • R (plus , Z⊗I) • R (plus , Z⊗I) • R (plus , Z⊗I) • R (plus , Z⊗I) • R (minus , Z⊗Z) • R (minus , Z⊗Z) • R (minus , Z⊗Z) • R (minus , I⊗X) • R (plus , Z⊗X) • R (minus , I⊗Y) • R (plus , Z⊗Y) • R (plus , Z⊗I) • R (minus , I⊗Y) • R (minus , I⊗Y) • R (plus , Z⊗Y) • R (plus , Z⊗I) • R (minus , I⊗Y) • R (plus , Z⊗Y) • R (plus , Z⊗I) • R (minus , I⊗Y) • H1 • CZ • S0 • S0 • S0 • S1 • S1 • S1 • H1 • S1 • W • ε
          by in-context 14 2 auto (tactic-pauli-commute (plus , Z⊗I) (minus , I⊗Y) auto)
      equals R (plus , I⊗Z) • R (plus , I⊗Z) • R (plus , I⊗Z) • R (plus , Z⊗I) • R (plus , Z⊗I) • R (plus , Z⊗I) • R (plus , Z⊗I) • R (minus , Z⊗Z) • R (minus , Z⊗Z) • R (minus , Z⊗Z) • R (minus , I⊗X) • R (plus , Z⊗X) • R (minus , I⊗Y) • R (plus , Z⊗Y) • R (minus , I⊗Y) • R (plus , Z⊗I) • R (minus , I⊗Y) • R (plus , Z⊗Y) • R (plus , Z⊗I) • R (minus , I⊗Y) • R (plus , Z⊗Y) • R (plus , Z⊗I) • R (minus , I⊗Y) • H1 • CZ • S0 • S0 • S0 • S1 • S1 • S1 • H1 • S1 • W • ε
          by in-context 6 2 auto (tactic-pauli-commute (plus , Z⊗I) (minus , Z⊗Z) auto)
      equals R (plus , I⊗Z) • R (plus , I⊗Z) • R (plus , I⊗Z) • R (plus , Z⊗I) • R (plus , Z⊗I) • R (plus , Z⊗I) • R (minus , Z⊗Z) • R (plus , Z⊗I) • R (minus , Z⊗Z) • R (minus , Z⊗Z) • R (minus , I⊗X) • R (plus , Z⊗X) • R (minus , I⊗Y) • R (plus , Z⊗Y) • R (minus , I⊗Y) • R (plus , Z⊗I) • R (minus , I⊗Y) • R (plus , Z⊗Y) • R (plus , Z⊗I) • R (minus , I⊗Y) • R (plus , Z⊗Y) • R (plus , Z⊗I) • R (minus , I⊗Y) • H1 • CZ • S0 • S0 • S0 • S1 • S1 • S1 • H1 • S1 • W • ε
          by in-context 7 2 auto (tactic-pauli-commute (plus , Z⊗I) (minus , Z⊗Z) auto)
      equals R (plus , I⊗Z) • R (plus , I⊗Z) • R (plus , I⊗Z) • R (plus , Z⊗I) • R (plus , Z⊗I) • R (plus , Z⊗I) • R (minus , Z⊗Z) • R (minus , Z⊗Z) • R (plus , Z⊗I) • R (minus , Z⊗Z) • R (minus , I⊗X) • R (plus , Z⊗X) • R (minus , I⊗Y) • R (plus , Z⊗Y) • R (minus , I⊗Y) • R (plus , Z⊗I) • R (minus , I⊗Y) • R (plus , Z⊗Y) • R (plus , Z⊗I) • R (minus , I⊗Y) • R (plus , Z⊗Y) • R (plus , Z⊗I) • R (minus , I⊗Y) • H1 • CZ • S0 • S0 • S0 • S1 • S1 • S1 • H1 • S1 • W • ε
          by in-context 8 2 auto (tactic-pauli-commute (plus , Z⊗I) (minus , Z⊗Z) auto)
      equals R (plus , I⊗Z) • R (plus , I⊗Z) • R (plus , I⊗Z) • R (plus , Z⊗I) • R (plus , Z⊗I) • R (plus , Z⊗I) • R (minus , Z⊗Z) • R (minus , Z⊗Z) • R (minus , Z⊗Z) • R (plus , Z⊗I) • R (minus , I⊗X) • R (plus , Z⊗X) • R (minus , I⊗Y) • R (plus , Z⊗Y) • R (minus , I⊗Y) • R (plus , Z⊗I) • R (minus , I⊗Y) • R (plus , Z⊗Y) • R (plus , Z⊗I) • R (minus , I⊗Y) • R (plus , Z⊗Y) • R (plus , Z⊗I) • R (minus , I⊗Y) • H1 • CZ • S0 • S0 • S0 • S1 • S1 • S1 • H1 • S1 • W • ε
          by in-context 9 2 auto (tactic-pauli-commute (plus , Z⊗I) (minus , I⊗X) auto)
      equals R (plus , I⊗Z) • R (plus , I⊗Z) • R (plus , I⊗Z) • R (plus , Z⊗I) • R (plus , Z⊗I) • R (plus , Z⊗I) • R (minus , Z⊗Z) • R (minus , Z⊗Z) • R (minus , Z⊗Z) • R (minus , I⊗X) • R (plus , Z⊗I) • R (plus , Z⊗X) • R (minus , I⊗Y) • R (plus , Z⊗Y) • R (minus , I⊗Y) • R (plus , Z⊗I) • R (minus , I⊗Y) • R (plus , Z⊗Y) • R (plus , Z⊗I) • R (minus , I⊗Y) • R (plus , Z⊗Y) • R (plus , Z⊗I) • R (minus , I⊗Y) • H1 • CZ • S0 • S0 • S0 • S1 • S1 • S1 • H1 • S1 • W • ε
          by in-context 10 2 auto (tactic-pauli-commute (plus , Z⊗I) (plus , Z⊗X) auto)
      equals R (plus , I⊗Z) • R (plus , I⊗Z) • R (plus , I⊗Z) • R (plus , Z⊗I) • R (plus , Z⊗I) • R (plus , Z⊗I) • R (minus , Z⊗Z) • R (minus , Z⊗Z) • R (minus , Z⊗Z) • R (minus , I⊗X) • R (plus , Z⊗X) • R (plus , Z⊗I) • R (minus , I⊗Y) • R (plus , Z⊗Y) • R (minus , I⊗Y) • R (plus , Z⊗I) • R (minus , I⊗Y) • R (plus , Z⊗Y) • R (plus , Z⊗I) • R (minus , I⊗Y) • R (plus , Z⊗Y) • R (plus , Z⊗I) • R (minus , I⊗Y) • H1 • CZ • S0 • S0 • S0 • S1 • S1 • S1 • H1 • S1 • W • ε
          by in-context 11 2 auto (tactic-pauli-commute (plus , Z⊗I) (minus , I⊗Y) auto)
      equals R (plus , I⊗Z) • R (plus , I⊗Z) • R (plus , I⊗Z) • R (plus , Z⊗I) • R (plus , Z⊗I) • R (plus , Z⊗I) • R (minus , Z⊗Z) • R (minus , Z⊗Z) • R (minus , Z⊗Z) • R (minus , I⊗X) • R (plus , Z⊗X) • R (minus , I⊗Y) • R (plus , Z⊗I) • R (plus , Z⊗Y) • R (minus , I⊗Y) • R (plus , Z⊗I) • R (minus , I⊗Y) • R (plus , Z⊗Y) • R (plus , Z⊗I) • R (minus , I⊗Y) • R (plus , Z⊗Y) • R (plus , Z⊗I) • R (minus , I⊗Y) • H1 • CZ • S0 • S0 • S0 • S1 • S1 • S1 • H1 • S1 • W • ε
          by in-context 5 2 auto (tactic-pauli-commute (plus , Z⊗I) (minus , Z⊗Z) auto)
      equals R (plus , I⊗Z) • R (plus , I⊗Z) • R (plus , I⊗Z) • R (plus , Z⊗I) • R (plus , Z⊗I) • R (minus , Z⊗Z) • R (plus , Z⊗I) • R (minus , Z⊗Z) • R (minus , Z⊗Z) • R (minus , I⊗X) • R (plus , Z⊗X) • R (minus , I⊗Y) • R (plus , Z⊗I) • R (plus , Z⊗Y) • R (minus , I⊗Y) • R (plus , Z⊗I) • R (minus , I⊗Y) • R (plus , Z⊗Y) • R (plus , Z⊗I) • R (minus , I⊗Y) • R (plus , Z⊗Y) • R (plus , Z⊗I) • R (minus , I⊗Y) • H1 • CZ • S0 • S0 • S0 • S1 • S1 • S1 • H1 • S1 • W • ε
          by in-context 6 2 auto (tactic-pauli-commute (plus , Z⊗I) (minus , Z⊗Z) auto)
      equals R (plus , I⊗Z) • R (plus , I⊗Z) • R (plus , I⊗Z) • R (plus , Z⊗I) • R (plus , Z⊗I) • R (minus , Z⊗Z) • R (minus , Z⊗Z) • R (plus , Z⊗I) • R (minus , Z⊗Z) • R (minus , I⊗X) • R (plus , Z⊗X) • R (minus , I⊗Y) • R (plus , Z⊗I) • R (plus , Z⊗Y) • R (minus , I⊗Y) • R (plus , Z⊗I) • R (minus , I⊗Y) • R (plus , Z⊗Y) • R (plus , Z⊗I) • R (minus , I⊗Y) • R (plus , Z⊗Y) • R (plus , Z⊗I) • R (minus , I⊗Y) • H1 • CZ • S0 • S0 • S0 • S1 • S1 • S1 • H1 • S1 • W • ε
          by in-context 7 2 auto (tactic-pauli-commute (plus , Z⊗I) (minus , Z⊗Z) auto)
      equals R (plus , I⊗Z) • R (plus , I⊗Z) • R (plus , I⊗Z) • R (plus , Z⊗I) • R (plus , Z⊗I) • R (minus , Z⊗Z) • R (minus , Z⊗Z) • R (minus , Z⊗Z) • R (plus , Z⊗I) • R (minus , I⊗X) • R (plus , Z⊗X) • R (minus , I⊗Y) • R (plus , Z⊗I) • R (plus , Z⊗Y) • R (minus , I⊗Y) • R (plus , Z⊗I) • R (minus , I⊗Y) • R (plus , Z⊗Y) • R (plus , Z⊗I) • R (minus , I⊗Y) • R (plus , Z⊗Y) • R (plus , Z⊗I) • R (minus , I⊗Y) • H1 • CZ • S0 • S0 • S0 • S1 • S1 • S1 • H1 • S1 • W • ε
          by in-context 4 2 auto (tactic-pauli-commute (plus , Z⊗I) (minus , Z⊗Z) auto)
      equals R (plus , I⊗Z) • R (plus , I⊗Z) • R (plus , I⊗Z) • R (plus , Z⊗I) • R (minus , Z⊗Z) • R (plus , Z⊗I) • R (minus , Z⊗Z) • R (minus , Z⊗Z) • R (plus , Z⊗I) • R (minus , I⊗X) • R (plus , Z⊗X) • R (minus , I⊗Y) • R (plus , Z⊗I) • R (plus , Z⊗Y) • R (minus , I⊗Y) • R (plus , Z⊗I) • R (minus , I⊗Y) • R (plus , Z⊗Y) • R (plus , Z⊗I) • R (minus , I⊗Y) • R (plus , Z⊗Y) • R (plus , Z⊗I) • R (minus , I⊗Y) • H1 • CZ • S0 • S0 • S0 • S1 • S1 • S1 • H1 • S1 • W • ε
          by in-context 5 2 auto (tactic-pauli-commute (plus , Z⊗I) (minus , Z⊗Z) auto)
      equals R (plus , I⊗Z) • R (plus , I⊗Z) • R (plus , I⊗Z) • R (plus , Z⊗I) • R (minus , Z⊗Z) • R (minus , Z⊗Z) • R (plus , Z⊗I) • R (minus , Z⊗Z) • R (plus , Z⊗I) • R (minus , I⊗X) • R (plus , Z⊗X) • R (minus , I⊗Y) • R (plus , Z⊗I) • R (plus , Z⊗Y) • R (minus , I⊗Y) • R (plus , Z⊗I) • R (minus , I⊗Y) • R (plus , Z⊗Y) • R (plus , Z⊗I) • R (minus , I⊗Y) • R (plus , Z⊗Y) • R (plus , Z⊗I) • R (minus , I⊗Y) • H1 • CZ • S0 • S0 • S0 • S1 • S1 • S1 • H1 • S1 • W • ε
          by in-context 3 2 auto (tactic-pauli-commute (plus , Z⊗I) (minus , Z⊗Z) auto)
      equals R (plus , I⊗Z) • R (plus , I⊗Z) • R (plus , I⊗Z) • R (minus , Z⊗Z) • R (plus , Z⊗I) • R (minus , Z⊗Z) • R (plus , Z⊗I) • R (minus , Z⊗Z) • R (plus , Z⊗I) • R (minus , I⊗X) • R (plus , Z⊗X) • R (minus , I⊗Y) • R (plus , Z⊗I) • R (plus , Z⊗Y) • R (minus , I⊗Y) • R (plus , Z⊗I) • R (minus , I⊗Y) • R (plus , Z⊗Y) • R (plus , Z⊗I) • R (minus , I⊗Y) • R (plus , Z⊗Y) • R (plus , Z⊗I) • R (minus , I⊗Y) • H1 • CZ • S0 • S0 • S0 • S1 • S1 • S1 • H1 • S1 • W • ε
          by in-context 2 2 auto (tactic-pauli-commute (plus , I⊗Z) (minus , Z⊗Z) auto)
      equals R (plus , I⊗Z) • R (plus , I⊗Z) • R (minus , Z⊗Z) • R (plus , I⊗Z) • R (plus , Z⊗I) • R (minus , Z⊗Z) • R (plus , Z⊗I) • R (minus , Z⊗Z) • R (plus , Z⊗I) • R (minus , I⊗X) • R (plus , Z⊗X) • R (minus , I⊗Y) • R (plus , Z⊗I) • R (plus , Z⊗Y) • R (minus , I⊗Y) • R (plus , Z⊗I) • R (minus , I⊗Y) • R (plus , Z⊗Y) • R (plus , Z⊗I) • R (minus , I⊗Y) • R (plus , Z⊗Y) • R (plus , Z⊗I) • R (minus , I⊗Y) • H1 • CZ • S0 • S0 • S0 • S1 • S1 • S1 • H1 • S1 • W • ε
          by in-context 3 2 auto (tactic-pauli-commute (plus , I⊗Z) (plus , Z⊗I) auto)
      equals R (plus , I⊗Z) • R (plus , I⊗Z) • R (minus , Z⊗Z) • R (plus , Z⊗I) • R (plus , I⊗Z) • R (minus , Z⊗Z) • R (plus , Z⊗I) • R (minus , Z⊗Z) • R (plus , Z⊗I) • R (minus , I⊗X) • R (plus , Z⊗X) • R (minus , I⊗Y) • R (plus , Z⊗I) • R (plus , Z⊗Y) • R (minus , I⊗Y) • R (plus , Z⊗I) • R (minus , I⊗Y) • R (plus , Z⊗Y) • R (plus , Z⊗I) • R (minus , I⊗Y) • R (plus , Z⊗Y) • R (plus , Z⊗I) • R (minus , I⊗Y) • H1 • CZ • S0 • S0 • S0 • S1 • S1 • S1 • H1 • S1 • W • ε
          by in-context 4 2 auto (tactic-pauli-commute (plus , I⊗Z) (minus , Z⊗Z) auto)
      equals R (plus , I⊗Z) • R (plus , I⊗Z) • R (minus , Z⊗Z) • R (plus , Z⊗I) • R (minus , Z⊗Z) • R (plus , I⊗Z) • R (plus , Z⊗I) • R (minus , Z⊗Z) • R (plus , Z⊗I) • R (minus , I⊗X) • R (plus , Z⊗X) • R (minus , I⊗Y) • R (plus , Z⊗I) • R (plus , Z⊗Y) • R (minus , I⊗Y) • R (plus , Z⊗I) • R (minus , I⊗Y) • R (plus , Z⊗Y) • R (plus , Z⊗I) • R (minus , I⊗Y) • R (plus , Z⊗Y) • R (plus , Z⊗I) • R (minus , I⊗Y) • H1 • CZ • S0 • S0 • S0 • S1 • S1 • S1 • H1 • S1 • W • ε
          by in-context 5 2 auto (tactic-pauli-commute (plus , I⊗Z) (plus , Z⊗I) auto)
      equals R (plus , I⊗Z) • R (plus , I⊗Z) • R (minus , Z⊗Z) • R (plus , Z⊗I) • R (minus , Z⊗Z) • R (plus , Z⊗I) • R (plus , I⊗Z) • R (minus , Z⊗Z) • R (plus , Z⊗I) • R (minus , I⊗X) • R (plus , Z⊗X) • R (minus , I⊗Y) • R (plus , Z⊗I) • R (plus , Z⊗Y) • R (minus , I⊗Y) • R (plus , Z⊗I) • R (minus , I⊗Y) • R (plus , Z⊗Y) • R (plus , Z⊗I) • R (minus , I⊗Y) • R (plus , Z⊗Y) • R (plus , Z⊗I) • R (minus , I⊗Y) • H1 • CZ • S0 • S0 • S0 • S1 • S1 • S1 • H1 • S1 • W • ε
          by in-context 6 2 auto (tactic-pauli-commute (plus , I⊗Z) (minus , Z⊗Z) auto)
      equals R (plus , I⊗Z) • R (plus , I⊗Z) • R (minus , Z⊗Z) • R (plus , Z⊗I) • R (minus , Z⊗Z) • R (plus , Z⊗I) • R (minus , Z⊗Z) • R (plus , I⊗Z) • R (plus , Z⊗I) • R (minus , I⊗X) • R (plus , Z⊗X) • R (minus , I⊗Y) • R (plus , Z⊗I) • R (plus , Z⊗Y) • R (minus , I⊗Y) • R (plus , Z⊗I) • R (minus , I⊗Y) • R (plus , Z⊗Y) • R (plus , Z⊗I) • R (minus , I⊗Y) • R (plus , Z⊗Y) • R (plus , Z⊗I) • R (minus , I⊗Y) • H1 • CZ • S0 • S0 • S0 • S1 • S1 • S1 • H1 • S1 • W • ε
          by in-context 7 2 auto (tactic-pauli-commute (plus , I⊗Z) (plus , Z⊗I) auto)
      equals R (plus , I⊗Z) • R (plus , I⊗Z) • R (minus , Z⊗Z) • R (plus , Z⊗I) • R (minus , Z⊗Z) • R (plus , Z⊗I) • R (minus , Z⊗Z) • R (plus , Z⊗I) • R (plus , I⊗Z) • R (minus , I⊗X) • R (plus , Z⊗X) • R (minus , I⊗Y) • R (plus , Z⊗I) • R (plus , Z⊗Y) • R (minus , I⊗Y) • R (plus , Z⊗I) • R (minus , I⊗Y) • R (plus , Z⊗Y) • R (plus , Z⊗I) • R (minus , I⊗Y) • R (plus , Z⊗Y) • R (plus , Z⊗I) • R (minus , I⊗Y) • H1 • CZ • S0 • S0 • S0 • S1 • S1 • S1 • H1 • S1 • W • ε
          by in-context 1 2 auto (tactic-pauli-commute (plus , I⊗Z) (minus , Z⊗Z) auto)
      equals R (plus , I⊗Z) • R (minus , Z⊗Z) • R (plus , I⊗Z) • R (plus , Z⊗I) • R (minus , Z⊗Z) • R (plus , Z⊗I) • R (minus , Z⊗Z) • R (plus , Z⊗I) • R (plus , I⊗Z) • R (minus , I⊗X) • R (plus , Z⊗X) • R (minus , I⊗Y) • R (plus , Z⊗I) • R (plus , Z⊗Y) • R (minus , I⊗Y) • R (plus , Z⊗I) • R (minus , I⊗Y) • R (plus , Z⊗Y) • R (plus , Z⊗I) • R (minus , I⊗Y) • R (plus , Z⊗Y) • R (plus , Z⊗I) • R (minus , I⊗Y) • H1 • CZ • S0 • S0 • S0 • S1 • S1 • S1 • H1 • S1 • W • ε
          by in-context 2 2 auto (tactic-pauli-commute (plus , I⊗Z) (plus , Z⊗I) auto)
      equals R (plus , I⊗Z) • R (minus , Z⊗Z) • R (plus , Z⊗I) • R (plus , I⊗Z) • R (minus , Z⊗Z) • R (plus , Z⊗I) • R (minus , Z⊗Z) • R (plus , Z⊗I) • R (plus , I⊗Z) • R (minus , I⊗X) • R (plus , Z⊗X) • R (minus , I⊗Y) • R (plus , Z⊗I) • R (plus , Z⊗Y) • R (minus , I⊗Y) • R (plus , Z⊗I) • R (minus , I⊗Y) • R (plus , Z⊗Y) • R (plus , Z⊗I) • R (minus , I⊗Y) • R (plus , Z⊗Y) • R (plus , Z⊗I) • R (minus , I⊗Y) • H1 • CZ • S0 • S0 • S0 • S1 • S1 • S1 • H1 • S1 • W • ε
          by in-context 3 2 auto (tactic-pauli-commute (plus , I⊗Z) (minus , Z⊗Z) auto)
      equals R (plus , I⊗Z) • R (minus , Z⊗Z) • R (plus , Z⊗I) • R (minus , Z⊗Z) • R (plus , I⊗Z) • R (plus , Z⊗I) • R (minus , Z⊗Z) • R (plus , Z⊗I) • R (plus , I⊗Z) • R (minus , I⊗X) • R (plus , Z⊗X) • R (minus , I⊗Y) • R (plus , Z⊗I) • R (plus , Z⊗Y) • R (minus , I⊗Y) • R (plus , Z⊗I) • R (minus , I⊗Y) • R (plus , Z⊗Y) • R (plus , Z⊗I) • R (minus , I⊗Y) • R (plus , Z⊗Y) • R (plus , Z⊗I) • R (minus , I⊗Y) • H1 • CZ • S0 • S0 • S0 • S1 • S1 • S1 • H1 • S1 • W • ε
          by in-context 4 2 auto (tactic-pauli-commute (plus , I⊗Z) (plus , Z⊗I) auto)
      equals R (plus , I⊗Z) • R (minus , Z⊗Z) • R (plus , Z⊗I) • R (minus , Z⊗Z) • R (plus , Z⊗I) • R (plus , I⊗Z) • R (minus , Z⊗Z) • R (plus , Z⊗I) • R (plus , I⊗Z) • R (minus , I⊗X) • R (plus , Z⊗X) • R (minus , I⊗Y) • R (plus , Z⊗I) • R (plus , Z⊗Y) • R (minus , I⊗Y) • R (plus , Z⊗I) • R (minus , I⊗Y) • R (plus , Z⊗Y) • R (plus , Z⊗I) • R (minus , I⊗Y) • R (plus , Z⊗Y) • R (plus , Z⊗I) • R (minus , I⊗Y) • H1 • CZ • S0 • S0 • S0 • S1 • S1 • S1 • H1 • S1 • W • ε
          by in-context 0 2 auto (tactic-pauli-commute (plus , I⊗Z) (minus , Z⊗Z) auto)
      equals R (minus , Z⊗Z) • R (plus , I⊗Z) • R (plus , Z⊗I) • R (minus , Z⊗Z) • R (plus , Z⊗I) • R (plus , I⊗Z) • R (minus , Z⊗Z) • R (plus , Z⊗I) • R (plus , I⊗Z) • R (minus , I⊗X) • R (plus , Z⊗X) • R (minus , I⊗Y) • R (plus , Z⊗I) • R (plus , Z⊗Y) • R (minus , I⊗Y) • R (plus , Z⊗I) • R (minus , I⊗Y) • R (plus , Z⊗Y) • R (plus , Z⊗I) • R (minus , I⊗Y) • R (plus , Z⊗Y) • R (plus , Z⊗I) • R (minus , I⊗Y) • H1 • CZ • S0 • S0 • S0 • S1 • S1 • S1 • H1 • S1 • W • ε
          by in-context 1 2 auto (tactic-pauli-commute (plus , I⊗Z) (plus , Z⊗I) auto)
      equals R (minus , Z⊗Z) • R (plus , Z⊗I) • R (plus , I⊗Z) • R (minus , Z⊗Z) • R (plus , Z⊗I) • R (plus , I⊗Z) • R (minus , Z⊗Z) • R (plus , Z⊗I) • R (plus , I⊗Z) • R (minus , I⊗X) • R (plus , Z⊗X) • R (minus , I⊗Y) • R (plus , Z⊗I) • R (plus , Z⊗Y) • R (minus , I⊗Y) • R (plus , Z⊗I) • R (minus , I⊗Y) • R (plus , Z⊗Y) • R (plus , Z⊗I) • R (minus , I⊗Y) • R (plus , Z⊗Y) • R (plus , Z⊗I) • R (minus , I⊗Y) • H1 • CZ • S0 • S0 • S0 • S1 • S1 • S1 • H1 • S1 • W • ε
          by clifford-tactic 23 11 10000 auto
      equals R (minus , Z⊗Z) • R (plus , Z⊗I) • R (plus , I⊗Z) • R (minus , Z⊗Z) • R (plus , Z⊗I) • R (plus , I⊗Z) • R (minus , Z⊗Z) • R (plus , Z⊗I) • R (plus , I⊗Z) • R (minus , I⊗X) • R (plus , Z⊗X) • R (minus , I⊗Y) • R (plus , Z⊗I) • R (plus , Z⊗Y) • R (minus , I⊗Y) • R (plus , Z⊗I) • R (minus , I⊗Y) • R (plus , Z⊗Y) • R (plus , Z⊗I) • R (minus , I⊗Y) • R (plus , Z⊗Y) • R (plus , Z⊗I) • R (minus , I⊗Y) • S1 • H1 • CZ • S1 • H1 • S1 • S1 • H1 • W • S1⁻¹ • W • X1 • CX1 • ε
          by in-context 22 10 auto (symm (lemma-R (C.S1 • C.H1 • C.CZ • C.S1 • C.H1 • C.S1 • C.S1 • C.H1 • C.W) (plus , I⊗Z)))
      equals R (minus , Z⊗Z) • R (plus , Z⊗I) • R (plus , I⊗Z) • R (minus , Z⊗Z) • R (plus , Z⊗I) • R (plus , I⊗Z) • R (minus , Z⊗Z) • R (plus , Z⊗I) • R (plus , I⊗Z) • R (minus , I⊗X) • R (plus , Z⊗X) • R (minus , I⊗Y) • R (plus , Z⊗I) • R (plus , Z⊗Y) • R (minus , I⊗Y) • R (plus , Z⊗I) • R (minus , I⊗Y) • R (plus , Z⊗Y) • R (plus , Z⊗I) • R (minus , I⊗Y) • R (plus , Z⊗Y) • R (plus , Z⊗I) • S1 • H1 • CZ • S1 • H1 • S1 • S1 • H1 • W • R (plus , I⊗Z) • S1⁻¹ • W • X1 • CX1 • ε
          by clifford-tactic 25 6 10000 auto
      equals R (minus , Z⊗Z) • R (plus , Z⊗I) • R (plus , I⊗Z) • R (minus , Z⊗Z) • R (plus , Z⊗I) • R (plus , I⊗Z) • R (minus , Z⊗Z) • R (plus , Z⊗I) • R (plus , I⊗Z) • R (minus , I⊗X) • R (plus , Z⊗X) • R (minus , I⊗Y) • R (plus , Z⊗I) • R (plus , Z⊗Y) • R (minus , I⊗Y) • R (plus , Z⊗I) • R (minus , I⊗Y) • R (plus , Z⊗Y) • R (plus , Z⊗I) • R (minus , I⊗Y) • R (plus , Z⊗Y) • R (plus , Z⊗I) • S1 • H1 • CZ • S0 • S1 • H1 • S1 • S1 • H1 • W • S0⁻¹ • R (plus , I⊗Z) • S1⁻¹ • W • X1 • CX1 • ε
          by in-context 21 11 auto (symm (lemma-R (C.S1 • C.H1 • C.CZ • C.S0 • C.S1 • C.H1 • C.S1 • C.S1 • C.H1 • C.W) (plus , Z⊗I)))
      equals R (minus , Z⊗Z) • R (plus , Z⊗I) • R (plus , I⊗Z) • R (minus , Z⊗Z) • R (plus , Z⊗I) • R (plus , I⊗Z) • R (minus , Z⊗Z) • R (plus , Z⊗I) • R (plus , I⊗Z) • R (minus , I⊗X) • R (plus , Z⊗X) • R (minus , I⊗Y) • R (plus , Z⊗I) • R (plus , Z⊗Y) • R (minus , I⊗Y) • R (plus , Z⊗I) • R (minus , I⊗Y) • R (plus , Z⊗Y) • R (plus , Z⊗I) • R (minus , I⊗Y) • R (plus , Z⊗Y) • S1 • H1 • CZ • S0 • S1 • H1 • S1 • S1 • H1 • W • R (plus , Z⊗I) • S0⁻¹ • R (plus , I⊗Z) • S1⁻¹ • W • X1 • CX1 • ε
          by clifford-tactic 21 10 10000 auto
      equals R (minus , Z⊗Z) • R (plus , Z⊗I) • R (plus , I⊗Z) • R (minus , Z⊗Z) • R (plus , Z⊗I) • R (plus , I⊗Z) • R (minus , Z⊗Z) • R (plus , Z⊗I) • R (plus , I⊗Z) • R (minus , I⊗X) • R (plus , Z⊗X) • R (minus , I⊗Y) • R (plus , Z⊗I) • R (plus , Z⊗Y) • R (minus , I⊗Y) • R (plus , Z⊗I) • R (minus , I⊗Y) • R (plus , Z⊗Y) • R (plus , Z⊗I) • R (minus , I⊗Y) • R (plus , Z⊗Y) • H0 • S1 • H1 • CZ • H0 • S0 • H1 • S1 • S1 • H1 • W • H0 • CZ • S0 • S0 • H0 • R (plus , Z⊗I) • S0⁻¹ • R (plus , I⊗Z) • S1⁻¹ • W • X1 • CX1 • ε
          by in-context 20 12 auto (symm (lemma-R (C.H0 • C.S1 • C.H1 • C.CZ • C.H0 • C.S0 • C.H1 • C.S1 • C.S1 • C.H1 • C.W) (plus , Z⊗I)))
      equals R (minus , Z⊗Z) • R (plus , Z⊗I) • R (plus , I⊗Z) • R (minus , Z⊗Z) • R (plus , Z⊗I) • R (plus , I⊗Z) • R (minus , Z⊗Z) • R (plus , Z⊗I) • R (plus , I⊗Z) • R (minus , I⊗X) • R (plus , Z⊗X) • R (minus , I⊗Y) • R (plus , Z⊗I) • R (plus , Z⊗Y) • R (minus , I⊗Y) • R (plus , Z⊗I) • R (minus , I⊗Y) • R (plus , Z⊗Y) • R (plus , Z⊗I) • R (minus , I⊗Y) • H0 • S1 • H1 • CZ • H0 • S0 • H1 • S1 • S1 • H1 • W • R (plus , Z⊗I) • H0 • CZ • S0 • S0 • H0 • R (plus , Z⊗I) • S0⁻¹ • R (plus , I⊗Z) • S1⁻¹ • W • X1 • CX1 • ε
          by clifford-tactic 20 11 10000 auto
      equals R (minus , Z⊗Z) • R (plus , Z⊗I) • R (plus , I⊗Z) • R (minus , Z⊗Z) • R (plus , Z⊗I) • R (plus , I⊗Z) • R (minus , Z⊗Z) • R (plus , Z⊗I) • R (plus , I⊗Z) • R (minus , I⊗X) • R (plus , Z⊗X) • R (minus , I⊗Y) • R (plus , Z⊗I) • R (plus , Z⊗Y) • R (minus , I⊗Y) • R (plus , Z⊗I) • R (minus , I⊗Y) • R (plus , Z⊗Y) • R (plus , Z⊗I) • R (minus , I⊗Y) • S1 • H1 • CZ • S0 • H1 • S1 • S1 • H1 • W ^ 2 • S1⁻¹ • W • X1 • CX1 • X1 • CX1 • X0 • CX0 • R (plus , Z⊗I) • H0 • CZ • S0 • S0 • H0 • R (plus , Z⊗I) • S0⁻¹ • R (plus , I⊗Z) • S1⁻¹ • W • X1 • CX1 • ε
          by in-context 19 10 auto (symm (lemma-R (C.S1 • C.H1 • C.CZ • C.S0 • C.H1 • C.S1 • C.S1 • C.H1 • C.W ^ 2) (plus , I⊗Z)))
      equals R (minus , Z⊗Z) • R (plus , Z⊗I) • R (plus , I⊗Z) • R (minus , Z⊗Z) • R (plus , Z⊗I) • R (plus , I⊗Z) • R (minus , Z⊗Z) • R (plus , Z⊗I) • R (plus , I⊗Z) • R (minus , I⊗X) • R (plus , Z⊗X) • R (minus , I⊗Y) • R (plus , Z⊗I) • R (plus , Z⊗Y) • R (minus , I⊗Y) • R (plus , Z⊗I) • R (minus , I⊗Y) • R (plus , Z⊗Y) • R (plus , Z⊗I) • S1 • H1 • CZ • S0 • H1 • S1 • S1 • H1 • W ^ 2 • R (plus , I⊗Z) • S1⁻¹ • W • X1 • CX1 • X1 • CX1 • X0 • CX0 • R (plus , Z⊗I) • H0 • CZ • S0 • S0 • H0 • R (plus , Z⊗I) • S0⁻¹ • R (plus , I⊗Z) • S1⁻¹ • W • X1 • CX1 • ε
          by clifford-tactic 23 5 10000 auto
      equals R (minus , Z⊗Z) • R (plus , Z⊗I) • R (plus , I⊗Z) • R (minus , Z⊗Z) • R (plus , Z⊗I) • R (plus , I⊗Z) • R (minus , Z⊗Z) • R (plus , Z⊗I) • R (plus , I⊗Z) • R (minus , I⊗X) • R (plus , Z⊗X) • R (minus , I⊗Y) • R (plus , Z⊗I) • R (plus , Z⊗Y) • R (minus , I⊗Y) • R (plus , Z⊗I) • R (minus , I⊗Y) • R (plus , Z⊗Y) • R (plus , Z⊗I) • S1 • H1 • CZ • S0 • S0 • H1 • S1 • S1 • H1 • W ^ 2 • S0⁻¹ • R (plus , I⊗Z) • S1⁻¹ • W • X1 • CX1 • X1 • CX1 • X0 • CX0 • R (plus , Z⊗I) • H0 • CZ • S0 • S0 • H0 • R (plus , Z⊗I) • S0⁻¹ • R (plus , I⊗Z) • S1⁻¹ • W • X1 • CX1 • ε
          by in-context 18 11 auto (symm (lemma-R (C.S1 • C.H1 • C.CZ • C.S0 • C.S0 • C.H1 • C.S1 • C.S1 • C.H1 • C.W ^ 2) (plus , Z⊗I)))
      equals R (minus , Z⊗Z) • R (plus , Z⊗I) • R (plus , I⊗Z) • R (minus , Z⊗Z) • R (plus , Z⊗I) • R (plus , I⊗Z) • R (minus , Z⊗Z) • R (plus , Z⊗I) • R (plus , I⊗Z) • R (minus , I⊗X) • R (plus , Z⊗X) • R (minus , I⊗Y) • R (plus , Z⊗I) • R (plus , Z⊗Y) • R (minus , I⊗Y) • R (plus , Z⊗I) • R (minus , I⊗Y) • R (plus , Z⊗Y) • S1 • H1 • CZ • S0 • S0 • H1 • S1 • S1 • H1 • W ^ 2 • R (plus , Z⊗I) • S0⁻¹ • R (plus , I⊗Z) • S1⁻¹ • W • X1 • CX1 • X1 • CX1 • X0 • CX0 • R (plus , Z⊗I) • H0 • CZ • S0 • S0 • H0 • R (plus , Z⊗I) • S0⁻¹ • R (plus , I⊗Z) • S1⁻¹ • W • X1 • CX1 • ε
          by clifford-tactic 18 10 10000 auto
      equals R (minus , Z⊗Z) • R (plus , Z⊗I) • R (plus , I⊗Z) • R (minus , Z⊗Z) • R (plus , Z⊗I) • R (plus , I⊗Z) • R (minus , Z⊗Z) • R (plus , Z⊗I) • R (plus , I⊗Z) • R (minus , I⊗X) • R (plus , Z⊗X) • R (minus , I⊗Y) • R (plus , Z⊗I) • R (plus , Z⊗Y) • R (minus , I⊗Y) • R (plus , Z⊗I) • R (minus , I⊗Y) • R (plus , Z⊗Y) • S0 • H0 • S1 • H1 • CZ • H0 • S0 • H1 • S1 • S1 • H1 • S1 • H0 • CZ • S0 • S0 • H0 • R (plus , Z⊗I) • S0⁻¹ • R (plus , I⊗Z) • S1⁻¹ • W • X1 • CX1 • X1 • CX1 • X0 • CX0 • R (plus , Z⊗I) • H0 • CZ • S0 • S0 • H0 • R (plus , Z⊗I) • S0⁻¹ • R (plus , I⊗Z) • S1⁻¹ • W • X1 • CX1 • ε
          by in-context 17 13 auto (symm (lemma-R (C.S0 • C.H0 • C.S1 • C.H1 • C.CZ • C.H0 • C.S0 • C.H1 • C.S1 • C.S1 • C.H1 • C.S1) (plus , Z⊗I)))
      equals R (minus , Z⊗Z) • R (plus , Z⊗I) • R (plus , I⊗Z) • R (minus , Z⊗Z) • R (plus , Z⊗I) • R (plus , I⊗Z) • R (minus , Z⊗Z) • R (plus , Z⊗I) • R (plus , I⊗Z) • R (minus , I⊗X) • R (plus , Z⊗X) • R (minus , I⊗Y) • R (plus , Z⊗I) • R (plus , Z⊗Y) • R (minus , I⊗Y) • R (plus , Z⊗I) • R (minus , I⊗Y) • S0 • H0 • S1 • H1 • CZ • H0 • S0 • H1 • S1 • S1 • H1 • S1 • R (plus , Z⊗I) • H0 • CZ • S0 • S0 • H0 • R (plus , Z⊗I) • S0⁻¹ • R (plus , I⊗Z) • S1⁻¹ • W • X1 • CX1 • X1 • CX1 • X0 • CX0 • R (plus , Z⊗I) • H0 • CZ • S0 • S0 • H0 • R (plus , Z⊗I) • S0⁻¹ • R (plus , I⊗Z) • S1⁻¹ • W • X1 • CX1 • ε
          by clifford-tactic 17 12 10000 auto
      equals R (minus , Z⊗Z) • R (plus , Z⊗I) • R (plus , I⊗Z) • R (minus , Z⊗Z) • R (plus , Z⊗I) • R (plus , I⊗Z) • R (minus , Z⊗Z) • R (plus , Z⊗I) • R (plus , I⊗Z) • R (minus , I⊗X) • R (plus , Z⊗X) • R (minus , I⊗Y) • R (plus , Z⊗I) • R (plus , Z⊗Y) • R (minus , I⊗Y) • R (plus , Z⊗I) • R (minus , I⊗Y) • S1 • H1 • CZ • S0 • S0 • H1 • S1 • S1 • H1 • S1 • W • S1⁻¹ • W • X1 • CX1 • X1 • CX1 • X0 • CX0 • R (plus , Z⊗I) • H0 • CZ • S0 • S0 • H0 • R (plus , Z⊗I) • S0⁻¹ • R (plus , I⊗Z) • S1⁻¹ • W • X1 • CX1 • X1 • CX1 • X0 • CX0 • R (plus , Z⊗I) • H0 • CZ • S0 • S0 • H0 • R (plus , Z⊗I) • S0⁻¹ • R (plus , I⊗Z) • S1⁻¹ • W • X1 • CX1 • ε
          by in-context 16 12 auto (symm (lemma-R (C.S1 • C.H1 • C.CZ • C.S0 • C.S0 • C.H1 • C.S1 • C.S1 • C.H1 • C.S1 • C.W) (plus , I⊗Z)))
      equals R (minus , Z⊗Z) • R (plus , Z⊗I) • R (plus , I⊗Z) • R (minus , Z⊗Z) • R (plus , Z⊗I) • R (plus , I⊗Z) • R (minus , Z⊗Z) • R (plus , Z⊗I) • R (plus , I⊗Z) • R (minus , I⊗X) • R (plus , Z⊗X) • R (minus , I⊗Y) • R (plus , Z⊗I) • R (plus , Z⊗Y) • R (minus , I⊗Y) • R (plus , Z⊗I) • S1 • H1 • CZ • S0 • S0 • H1 • S1 • S1 • H1 • S1 • W • R (plus , I⊗Z) • S1⁻¹ • W • X1 • CX1 • X1 • CX1 • X0 • CX0 • R (plus , Z⊗I) • H0 • CZ • S0 • S0 • H0 • R (plus , Z⊗I) • S0⁻¹ • R (plus , I⊗Z) • S1⁻¹ • W • X1 • CX1 • X1 • CX1 • X0 • CX0 • R (plus , Z⊗I) • H0 • CZ • S0 • S0 • H0 • R (plus , Z⊗I) • S0⁻¹ • R (plus , I⊗Z) • S1⁻¹ • W • X1 • CX1 • ε
          by clifford-tactic 16 11 10000 auto
      equals R (minus , Z⊗Z) • R (plus , Z⊗I) • R (plus , I⊗Z) • R (minus , Z⊗Z) • R (plus , Z⊗I) • R (plus , I⊗Z) • R (minus , Z⊗Z) • R (plus , Z⊗I) • R (plus , I⊗Z) • R (minus , I⊗X) • R (plus , Z⊗X) • R (minus , I⊗Y) • R (plus , Z⊗I) • R (plus , Z⊗Y) • R (minus , I⊗Y) • R (plus , Z⊗I) • CZ • S1 • H1 • W ^ 2 • S1⁻¹ • W • X0 • CX0 • CX0 • X0 • X1 • CX1 • S0⁻¹ • R (plus , I⊗Z) • S1⁻¹ • W • X1 • CX1 • X1 • CX1 • X0 • CX0 • R (plus , Z⊗I) • H0 • CZ • S0 • S0 • H0 • R (plus , Z⊗I) • S0⁻¹ • R (plus , I⊗Z) • S1⁻¹ • W • X1 • CX1 • X1 • CX1 • X0 • CX0 • R (plus , Z⊗I) • H0 • CZ • S0 • S0 • H0 • R (plus , Z⊗I) • S0⁻¹ • R (plus , I⊗Z) • S1⁻¹ • W • X1 • CX1 • ε
          by in-context 15 13 auto (symm (lemma-R (C.CZ • C.S1 • C.H1 • C.W ^ 2 • C.S1⁻¹ • C.W • C.X0 • C.CX0 • C.CX0 • C.X0 • C.X1 • C.CX1) (plus , Z⊗I)))
      equals R (minus , Z⊗Z) • R (plus , Z⊗I) • R (plus , I⊗Z) • R (minus , Z⊗Z) • R (plus , Z⊗I) • R (plus , I⊗Z) • R (minus , Z⊗Z) • R (plus , Z⊗I) • R (plus , I⊗Z) • R (minus , I⊗X) • R (plus , Z⊗X) • R (minus , I⊗Y) • R (plus , Z⊗I) • R (plus , Z⊗Y) • R (minus , I⊗Y) • CZ • S1 • H1 • W ^ 2 • S1⁻¹ • W • X0 • CX0 • CX0 • X0 • X1 • CX1 • R (plus , Z⊗I) • S0⁻¹ • R (plus , I⊗Z) • S1⁻¹ • W • X1 • CX1 • X1 • CX1 • X0 • CX0 • R (plus , Z⊗I) • H0 • CZ • S0 • S0 • H0 • R (plus , Z⊗I) • S0⁻¹ • R (plus , I⊗Z) • S1⁻¹ • W • X1 • CX1 • X1 • CX1 • X0 • CX0 • R (plus , Z⊗I) • H0 • CZ • S0 • S0 • H0 • R (plus , Z⊗I) • S0⁻¹ • R (plus , I⊗Z) • S1⁻¹ • W • X1 • CX1 • ε
          by in-context 14 9 auto (symm (lemma-R (C.CZ • C.S1 • C.H1 • C.W ^ 2 • C.S1⁻¹ • C.W • C.X0 • C.CX0) (plus , Z⊗I)))
      equals R (minus , Z⊗Z) • R (plus , Z⊗I) • R (plus , I⊗Z) • R (minus , Z⊗Z) • R (plus , Z⊗I) • R (plus , I⊗Z) • R (minus , Z⊗Z) • R (plus , Z⊗I) • R (plus , I⊗Z) • R (minus , I⊗X) • R (plus , Z⊗X) • R (minus , I⊗Y) • R (plus , Z⊗I) • R (plus , Z⊗Y) • CZ • S1 • H1 • W ^ 2 • S1⁻¹ • W • X0 • CX0 • R (plus , Z⊗I) • CX0 • X0 • X1 • CX1 • R (plus , Z⊗I) • S0⁻¹ • R (plus , I⊗Z) • S1⁻¹ • W • X1 • CX1 • X1 • CX1 • X0 • CX0 • R (plus , Z⊗I) • H0 • CZ • S0 • S0 • H0 • R (plus , Z⊗I) • S0⁻¹ • R (plus , I⊗Z) • S1⁻¹ • W • X1 • CX1 • X1 • CX1 • X0 • CX0 • R (plus , Z⊗I) • H0 • CZ • S0 • S0 • H0 • R (plus , Z⊗I) • S0⁻¹ • R (plus , I⊗Z) • S1⁻¹ • W • X1 • CX1 • ε
          by in-context 13 5 auto (symm (lemma-R (C.CZ • C.S1 • C.H1 • C.W ^ 2) (plus , I⊗Z)))
      equals R (minus , Z⊗Z) • R (plus , Z⊗I) • R (plus , I⊗Z) • R (minus , Z⊗Z) • R (plus , Z⊗I) • R (plus , I⊗Z) • R (minus , Z⊗Z) • R (plus , Z⊗I) • R (plus , I⊗Z) • R (minus , I⊗X) • R (plus , Z⊗X) • R (minus , I⊗Y) • R (plus , Z⊗I) • CZ • S1 • H1 • W ^ 2 • R (plus , I⊗Z) • S1⁻¹ • W • X0 • CX0 • R (plus , Z⊗I) • CX0 • X0 • X1 • CX1 • R (plus , Z⊗I) • S0⁻¹ • R (plus , I⊗Z) • S1⁻¹ • W • X1 • CX1 • X1 • CX1 • X0 • CX0 • R (plus , Z⊗I) • H0 • CZ • S0 • S0 • H0 • R (plus , Z⊗I) • S0⁻¹ • R (plus , I⊗Z) • S1⁻¹ • W • X1 • CX1 • X1 • CX1 • X0 • CX0 • R (plus , Z⊗I) • H0 • CZ • S0 • S0 • H0 • R (plus , Z⊗I) • S0⁻¹ • R (plus , I⊗Z) • S1⁻¹ • W • X1 • CX1 • ε
          by clifford-tactic 14 3 10000 auto
      equals R (minus , Z⊗Z) • R (plus , Z⊗I) • R (plus , I⊗Z) • R (minus , Z⊗Z) • R (plus , Z⊗I) • R (plus , I⊗Z) • R (minus , Z⊗Z) • R (plus , Z⊗I) • R (plus , I⊗Z) • R (minus , I⊗X) • R (plus , Z⊗X) • R (minus , I⊗Y) • R (plus , Z⊗I) • CZ • S0 • S1 • H1 • W ^ 2 • S0⁻¹ • R (plus , I⊗Z) • S1⁻¹ • W • X0 • CX0 • R (plus , Z⊗I) • CX0 • X0 • X1 • CX1 • R (plus , Z⊗I) • S0⁻¹ • R (plus , I⊗Z) • S1⁻¹ • W • X1 • CX1 • X1 • CX1 • X0 • CX0 • R (plus , Z⊗I) • H0 • CZ • S0 • S0 • H0 • R (plus , Z⊗I) • S0⁻¹ • R (plus , I⊗Z) • S1⁻¹ • W • X1 • CX1 • X1 • CX1 • X0 • CX0 • R (plus , Z⊗I) • H0 • CZ • S0 • S0 • H0 • R (plus , Z⊗I) • S0⁻¹ • R (plus , I⊗Z) • S1⁻¹ • W • X1 • CX1 • ε
          by in-context 12 6 auto (symm (lemma-R (C.CZ • C.S0 • C.S1 • C.H1 • C.W ^ 2) (plus , Z⊗I)))
      equals R (minus , Z⊗Z) • R (plus , Z⊗I) • R (plus , I⊗Z) • R (minus , Z⊗Z) • R (plus , Z⊗I) • R (plus , I⊗Z) • R (minus , Z⊗Z) • R (plus , Z⊗I) • R (plus , I⊗Z) • R (minus , I⊗X) • R (plus , Z⊗X) • R (minus , I⊗Y) • CZ • S0 • S1 • H1 • W ^ 2 • R (plus , Z⊗I) • S0⁻¹ • R (plus , I⊗Z) • S1⁻¹ • W • X0 • CX0 • R (plus , Z⊗I) • CX0 • X0 • X1 • CX1 • R (plus , Z⊗I) • S0⁻¹ • R (plus , I⊗Z) • S1⁻¹ • W • X1 • CX1 • X1 • CX1 • X0 • CX0 • R (plus , Z⊗I) • H0 • CZ • S0 • S0 • H0 • R (plus , Z⊗I) • S0⁻¹ • R (plus , I⊗Z) • S1⁻¹ • W • X1 • CX1 • X1 • CX1 • X0 • CX0 • R (plus , Z⊗I) • H0 • CZ • S0 • S0 • H0 • R (plus , Z⊗I) • S0⁻¹ • R (plus , I⊗Z) • S1⁻¹ • W • X1 • CX1 • ε
          by clifford-tactic 14 3 10000 auto
      equals R (minus , Z⊗Z) • R (plus , Z⊗I) • R (plus , I⊗Z) • R (minus , Z⊗Z) • R (plus , Z⊗I) • R (plus , I⊗Z) • R (minus , Z⊗Z) • R (plus , Z⊗I) • R (plus , I⊗Z) • R (minus , I⊗X) • R (plus , Z⊗X) • R (minus , I⊗Y) • CZ • S0 • H0 • S1 • H1 • CZ • S0 • S0 • H0 • W ^ 2 • CX0 • X0 • R (plus , Z⊗I) • S0⁻¹ • R (plus , I⊗Z) • S1⁻¹ • W • X0 • CX0 • R (plus , Z⊗I) • CX0 • X0 • X1 • CX1 • R (plus , Z⊗I) • S0⁻¹ • R (plus , I⊗Z) • S1⁻¹ • W • X1 • CX1 • X1 • CX1 • X0 • CX0 • R (plus , Z⊗I) • H0 • CZ • S0 • S0 • H0 • R (plus , Z⊗I) • S0⁻¹ • R (plus , I⊗Z) • S1⁻¹ • W • X1 • CX1 • X1 • CX1 • X0 • CX0 • R (plus , Z⊗I) • H0 • CZ • S0 • S0 • H0 • R (plus , Z⊗I) • S0⁻¹ • R (plus , I⊗Z) • S1⁻¹ • W • X1 • CX1 • ε
          by in-context 11 11 auto (symm (lemma-R (C.CZ • C.S0 • C.H0 • C.S1 • C.H1 • C.CZ • C.S0 • C.S0 • C.H0 • C.W ^ 2) (plus , Z⊗I)))
      equals R (minus , Z⊗Z) • R (plus , Z⊗I) • R (plus , I⊗Z) • R (minus , Z⊗Z) • R (plus , Z⊗I) • R (plus , I⊗Z) • R (minus , Z⊗Z) • R (plus , Z⊗I) • R (plus , I⊗Z) • R (minus , I⊗X) • R (plus , Z⊗X) • CZ • S0 • H0 • S1 • H1 • CZ • S0 • S0 • H0 • W ^ 2 • R (plus , Z⊗I) • CX0 • X0 • R (plus , Z⊗I) • S0⁻¹ • R (plus , I⊗Z) • S1⁻¹ • W • X0 • CX0 • R (plus , Z⊗I) • CX0 • X0 • X1 • CX1 • R (plus , Z⊗I) • S0⁻¹ • R (plus , I⊗Z) • S1⁻¹ • W • X1 • CX1 • X1 • CX1 • X0 • CX0 • R (plus , Z⊗I) • H0 • CZ • S0 • S0 • H0 • R (plus , Z⊗I) • S0⁻¹ • R (plus , I⊗Z) • S1⁻¹ • W • X1 • CX1 • X1 • CX1 • X0 • CX0 • R (plus , Z⊗I) • H0 • CZ • S0 • S0 • H0 • R (plus , Z⊗I) • S0⁻¹ • R (plus , I⊗Z) • S1⁻¹ • W • X1 • CX1 • ε
          by clifford-tactic 14 7 10000 auto
      equals R (minus , Z⊗Z) • R (plus , Z⊗I) • R (plus , I⊗Z) • R (minus , Z⊗Z) • R (plus , Z⊗I) • R (plus , I⊗Z) • R (minus , Z⊗Z) • R (plus , Z⊗I) • R (plus , I⊗Z) • R (minus , I⊗X) • R (plus , Z⊗X) • CZ • S0 • H0 • S0 • S0 • H0 • H1 • W ^ 3 • S1⁻¹ • H1 • S1⁻¹ • X0 • X0 • CX0 • R (plus , Z⊗I) • CX0 • X0 • R (plus , Z⊗I) • S0⁻¹ • R (plus , I⊗Z) • S1⁻¹ • W • X0 • CX0 • R (plus , Z⊗I) • CX0 • X0 • X1 • CX1 • R (plus , Z⊗I) • S0⁻¹ • R (plus , I⊗Z) • S1⁻¹ • W • X1 • CX1 • X1 • CX1 • X0 • CX0 • R (plus , Z⊗I) • H0 • CZ • S0 • S0 • H0 • R (plus , Z⊗I) • S0⁻¹ • R (plus , I⊗Z) • S1⁻¹ • W • X1 • CX1 • X1 • CX1 • X0 • CX0 • R (plus , Z⊗I) • H0 • CZ • S0 • S0 • H0 • R (plus , Z⊗I) • S0⁻¹ • R (plus , I⊗Z) • S1⁻¹ • W • X1 • CX1 • ε
          by in-context 10 9 auto (symm (lemma-R (C.CZ • C.S0 • C.H0 • C.S0 • C.S0 • C.H0 • C.H1 • C.W ^ 3) (plus , I⊗Z)))
      equals R (minus , Z⊗Z) • R (plus , Z⊗I) • R (plus , I⊗Z) • R (minus , Z⊗Z) • R (plus , Z⊗I) • R (plus , I⊗Z) • R (minus , Z⊗Z) • R (plus , Z⊗I) • R (plus , I⊗Z) • R (minus , I⊗X) • CZ • S0 • H0 • S0 • S0 • H0 • H1 • W ^ 3 • R (plus , I⊗Z) • S1⁻¹ • H1 • S1⁻¹ • X0 • X0 • CX0 • R (plus , Z⊗I) • CX0 • X0 • R (plus , Z⊗I) • S0⁻¹ • R (plus , I⊗Z) • S1⁻¹ • W • X0 • CX0 • R (plus , Z⊗I) • CX0 • X0 • X1 • CX1 • R (plus , Z⊗I) • S0⁻¹ • R (plus , I⊗Z) • S1⁻¹ • W • X1 • CX1 • X1 • CX1 • X0 • CX0 • R (plus , Z⊗I) • H0 • CZ • S0 • S0 • H0 • R (plus , Z⊗I) • S0⁻¹ • R (plus , I⊗Z) • S1⁻¹ • W • X1 • CX1 • X1 • CX1 • X0 • CX0 • R (plus , Z⊗I) • H0 • CZ • S0 • S0 • H0 • R (plus , Z⊗I) • S0⁻¹ • R (plus , I⊗Z) • S1⁻¹ • W • X1 • CX1 • ε
          by clifford-tactic 10 8 10000 auto
      equals R (minus , Z⊗Z) • R (plus , Z⊗I) • R (plus , I⊗Z) • R (minus , Z⊗Z) • R (plus , Z⊗I) • R (plus , I⊗Z) • R (minus , Z⊗Z) • R (plus , Z⊗I) • R (plus , I⊗Z) • R (minus , I⊗X) • S0 • S1 • S1 • W ^ 2 • S1⁻¹ • W • X0 • S1 • H1 • CX1 • R (plus , I⊗Z) • S1⁻¹ • H1 • S1⁻¹ • X0 • X0 • CX0 • R (plus , Z⊗I) • CX0 • X0 • R (plus , Z⊗I) • S0⁻¹ • R (plus , I⊗Z) • S1⁻¹ • W • X0 • CX0 • R (plus , Z⊗I) • CX0 • X0 • X1 • CX1 • R (plus , Z⊗I) • S0⁻¹ • R (plus , I⊗Z) • S1⁻¹ • W • X1 • CX1 • X1 • CX1 • X0 • CX0 • R (plus , Z⊗I) • H0 • CZ • S0 • S0 • H0 • R (plus , Z⊗I) • S0⁻¹ • R (plus , I⊗Z) • S1⁻¹ • W • X1 • CX1 • X1 • CX1 • X0 • CX0 • R (plus , Z⊗I) • H0 • CZ • S0 • S0 • H0 • R (plus , Z⊗I) • S0⁻¹ • R (plus , I⊗Z) • S1⁻¹ • W • X1 • CX1 • ε
          by in-context 9 10 auto (symm (lemma-R (C.S0 • C.S1 • C.S1 • C.W ^ 2 • C.S1⁻¹ • C.W • C.X0 • C.S1 • C.H1) (plus , I⊗Z)))
      equals R (minus , Z⊗Z) • R (plus , Z⊗I) • R (plus , I⊗Z) • R (minus , Z⊗Z) • R (plus , Z⊗I) • R (plus , I⊗Z) • R (minus , Z⊗Z) • R (plus , Z⊗I) • R (plus , I⊗Z) • S0 • S1 • S1 • W ^ 2 • S1⁻¹ • W • X0 • S1 • H1 • R (plus , I⊗Z) • CX1 • R (plus , I⊗Z) • S1⁻¹ • H1 • S1⁻¹ • X0 • X0 • CX0 • R (plus , Z⊗I) • CX0 • X0 • R (plus , Z⊗I) • S0⁻¹ • R (plus , I⊗Z) • S1⁻¹ • W • X0 • CX0 • R (plus , Z⊗I) • CX0 • X0 • X1 • CX1 • R (plus , Z⊗I) • S0⁻¹ • R (plus , I⊗Z) • S1⁻¹ • W • X1 • CX1 • X1 • CX1 • X0 • CX0 • R (plus , Z⊗I) • H0 • CZ • S0 • S0 • H0 • R (plus , Z⊗I) • S0⁻¹ • R (plus , I⊗Z) • S1⁻¹ • W • X1 • CX1 • X1 • CX1 • X0 • CX0 • R (plus , Z⊗I) • H0 • CZ • S0 • S0 • H0 • R (plus , Z⊗I) • S0⁻¹ • R (plus , I⊗Z) • S1⁻¹ • W • X1 • CX1 • ε
          by in-context 8 5 auto (symm (lemma-R (C.S0 • C.S1 • C.S1 • C.W ^ 2) (plus , I⊗Z)))
      equals R (minus , Z⊗Z) • R (plus , Z⊗I) • R (plus , I⊗Z) • R (minus , Z⊗Z) • R (plus , Z⊗I) • R (plus , I⊗Z) • R (minus , Z⊗Z) • R (plus , Z⊗I) • S0 • S1 • S1 • W ^ 2 • R (plus , I⊗Z) • S1⁻¹ • W • X0 • S1 • H1 • R (plus , I⊗Z) • CX1 • R (plus , I⊗Z) • S1⁻¹ • H1 • S1⁻¹ • X0 • X0 • CX0 • R (plus , Z⊗I) • CX0 • X0 • R (plus , Z⊗I) • S0⁻¹ • R (plus , I⊗Z) • S1⁻¹ • W • X0 • CX0 • R (plus , Z⊗I) • CX0 • X0 • X1 • CX1 • R (plus , Z⊗I) • S0⁻¹ • R (plus , I⊗Z) • S1⁻¹ • W • X1 • CX1 • X1 • CX1 • X0 • CX0 • R (plus , Z⊗I) • H0 • CZ • S0 • S0 • H0 • R (plus , Z⊗I) • S0⁻¹ • R (plus , I⊗Z) • S1⁻¹ • W • X1 • CX1 • X1 • CX1 • X0 • CX0 • R (plus , Z⊗I) • H0 • CZ • S0 • S0 • H0 • R (plus , Z⊗I) • S0⁻¹ • R (plus , I⊗Z) • S1⁻¹ • W • X1 • CX1 • ε
          by clifford-tactic 9 3 10000 auto
      equals R (minus , Z⊗Z) • R (plus , Z⊗I) • R (plus , I⊗Z) • R (minus , Z⊗Z) • R (plus , Z⊗I) • R (plus , I⊗Z) • R (minus , Z⊗Z) • R (plus , Z⊗I) • S0 • S0 • S1 • S1 • W ^ 2 • S0⁻¹ • R (plus , I⊗Z) • S1⁻¹ • W • X0 • S1 • H1 • R (plus , I⊗Z) • CX1 • R (plus , I⊗Z) • S1⁻¹ • H1 • S1⁻¹ • X0 • X0 • CX0 • R (plus , Z⊗I) • CX0 • X0 • R (plus , Z⊗I) • S0⁻¹ • R (plus , I⊗Z) • S1⁻¹ • W • X0 • CX0 • R (plus , Z⊗I) • CX0 • X0 • X1 • CX1 • R (plus , Z⊗I) • S0⁻¹ • R (plus , I⊗Z) • S1⁻¹ • W • X1 • CX1 • X1 • CX1 • X0 • CX0 • R (plus , Z⊗I) • H0 • CZ • S0 • S0 • H0 • R (plus , Z⊗I) • S0⁻¹ • R (plus , I⊗Z) • S1⁻¹ • W • X1 • CX1 • X1 • CX1 • X0 • CX0 • R (plus , Z⊗I) • H0 • CZ • S0 • S0 • H0 • R (plus , Z⊗I) • S0⁻¹ • R (plus , I⊗Z) • S1⁻¹ • W • X1 • CX1 • ε
          by in-context 7 6 auto (symm (lemma-R (C.S0 • C.S0 • C.S1 • C.S1 • C.W ^ 2) (plus , Z⊗I)))
      equals R (minus , Z⊗Z) • R (plus , Z⊗I) • R (plus , I⊗Z) • R (minus , Z⊗Z) • R (plus , Z⊗I) • R (plus , I⊗Z) • R (minus , Z⊗Z) • S0 • S0 • S1 • S1 • W ^ 2 • R (plus , Z⊗I) • S0⁻¹ • R (plus , I⊗Z) • S1⁻¹ • W • X0 • S1 • H1 • R (plus , I⊗Z) • CX1 • R (plus , I⊗Z) • S1⁻¹ • H1 • S1⁻¹ • X0 • X0 • CX0 • R (plus , Z⊗I) • CX0 • X0 • R (plus , Z⊗I) • S0⁻¹ • R (plus , I⊗Z) • S1⁻¹ • W • X0 • CX0 • R (plus , Z⊗I) • CX0 • X0 • X1 • CX1 • R (plus , Z⊗I) • S0⁻¹ • R (plus , I⊗Z) • S1⁻¹ • W • X1 • CX1 • X1 • CX1 • X0 • CX0 • R (plus , Z⊗I) • H0 • CZ • S0 • S0 • H0 • R (plus , Z⊗I) • S0⁻¹ • R (plus , I⊗Z) • S1⁻¹ • W • X1 • CX1 • X1 • CX1 • X0 • CX0 • R (plus , Z⊗I) • H0 • CZ • S0 • S0 • H0 • R (plus , Z⊗I) • S0⁻¹ • R (plus , I⊗Z) • S1⁻¹ • W • X1 • CX1 • ε
          by clifford-tactic 7 5 10000 auto
      equals R (minus , Z⊗Z) • R (plus , Z⊗I) • R (plus , I⊗Z) • R (minus , Z⊗Z) • R (plus , Z⊗I) • R (plus , I⊗Z) • R (minus , Z⊗Z) • H0 • CZ • S0 • S0 • H0 • S0 • S0 • W ^ 6 • CX0 • X0 • R (plus , Z⊗I) • S0⁻¹ • R (plus , I⊗Z) • S1⁻¹ • W • X0 • S1 • H1 • R (plus , I⊗Z) • CX1 • R (plus , I⊗Z) • S1⁻¹ • H1 • S1⁻¹ • X0 • X0 • CX0 • R (plus , Z⊗I) • CX0 • X0 • R (plus , Z⊗I) • S0⁻¹ • R (plus , I⊗Z) • S1⁻¹ • W • X0 • CX0 • R (plus , Z⊗I) • CX0 • X0 • X1 • CX1 • R (plus , Z⊗I) • S0⁻¹ • R (plus , I⊗Z) • S1⁻¹ • W • X1 • CX1 • X1 • CX1 • X0 • CX0 • R (plus , Z⊗I) • H0 • CZ • S0 • S0 • H0 • R (plus , Z⊗I) • S0⁻¹ • R (plus , I⊗Z) • S1⁻¹ • W • X1 • CX1 • X1 • CX1 • X0 • CX0 • R (plus , Z⊗I) • H0 • CZ • S0 • S0 • H0 • R (plus , Z⊗I) • S0⁻¹ • R (plus , I⊗Z) • S1⁻¹ • W • X1 • CX1 • ε
          by in-context 6 9 auto (symm (lemma-R (C.H0 • C.CZ • C.S0 • C.S0 • C.H0 • C.S0 • C.S0 • C.W ^ 6) (plus , Z⊗I)))
      equals R (minus , Z⊗Z) • R (plus , Z⊗I) • R (plus , I⊗Z) • R (minus , Z⊗Z) • R (plus , Z⊗I) • R (plus , I⊗Z) • H0 • CZ • S0 • S0 • H0 • S0 • S0 • W ^ 6 • R (plus , Z⊗I) • CX0 • X0 • R (plus , Z⊗I) • S0⁻¹ • R (plus , I⊗Z) • S1⁻¹ • W • X0 • S1 • H1 • R (plus , I⊗Z) • CX1 • R (plus , I⊗Z) • S1⁻¹ • H1 • S1⁻¹ • X0 • X0 • CX0 • R (plus , Z⊗I) • CX0 • X0 • R (plus , Z⊗I) • S0⁻¹ • R (plus , I⊗Z) • S1⁻¹ • W • X0 • CX0 • R (plus , Z⊗I) • CX0 • X0 • X1 • CX1 • R (plus , Z⊗I) • S0⁻¹ • R (plus , I⊗Z) • S1⁻¹ • W • X1 • CX1 • X1 • CX1 • X0 • CX0 • R (plus , Z⊗I) • H0 • CZ • S0 • S0 • H0 • R (plus , Z⊗I) • S0⁻¹ • R (plus , I⊗Z) • S1⁻¹ • W • X1 • CX1 • X1 • CX1 • X0 • CX0 • R (plus , Z⊗I) • H0 • CZ • S0 • S0 • H0 • R (plus , Z⊗I) • S0⁻¹ • R (plus , I⊗Z) • S1⁻¹ • W • X1 • CX1 • ε
          by clifford-tactic 6 8 10000 auto
      equals R (minus , Z⊗Z) • R (plus , Z⊗I) • R (plus , I⊗Z) • R (minus , Z⊗Z) • R (plus , Z⊗I) • R (plus , I⊗Z) • S0 • S0 • S1 • S1 • S1 • W • S1⁻¹ • W • X0 • CX0 • R (plus , Z⊗I) • CX0 • X0 • R (plus , Z⊗I) • S0⁻¹ • R (plus , I⊗Z) • S1⁻¹ • W • X0 • S1 • H1 • R (plus , I⊗Z) • CX1 • R (plus , I⊗Z) • S1⁻¹ • H1 • S1⁻¹ • X0 • X0 • CX0 • R (plus , Z⊗I) • CX0 • X0 • R (plus , Z⊗I) • S0⁻¹ • R (plus , I⊗Z) • S1⁻¹ • W • X0 • CX0 • R (plus , Z⊗I) • CX0 • X0 • X1 • CX1 • R (plus , Z⊗I) • S0⁻¹ • R (plus , I⊗Z) • S1⁻¹ • W • X1 • CX1 • X1 • CX1 • X0 • CX0 • R (plus , Z⊗I) • H0 • CZ • S0 • S0 • H0 • R (plus , Z⊗I) • S0⁻¹ • R (plus , I⊗Z) • S1⁻¹ • W • X1 • CX1 • X1 • CX1 • X0 • CX0 • R (plus , Z⊗I) • H0 • CZ • S0 • S0 • H0 • R (plus , Z⊗I) • S0⁻¹ • R (plus , I⊗Z) • S1⁻¹ • W • X1 • CX1 • ε
          by in-context 5 7 auto (symm (lemma-R (C.S0 • C.S0 • C.S1 • C.S1 • C.S1 • C.W) (plus , I⊗Z)))
      equals R (minus , Z⊗Z) • R (plus , Z⊗I) • R (plus , I⊗Z) • R (minus , Z⊗Z) • R (plus , Z⊗I) • S0 • S0 • S1 • S1 • S1 • W • R (plus , I⊗Z) • S1⁻¹ • W • X0 • CX0 • R (plus , Z⊗I) • CX0 • X0 • R (plus , Z⊗I) • S0⁻¹ • R (plus , I⊗Z) • S1⁻¹ • W • X0 • S1 • H1 • R (plus , I⊗Z) • CX1 • R (plus , I⊗Z) • S1⁻¹ • H1 • S1⁻¹ • X0 • X0 • CX0 • R (plus , Z⊗I) • CX0 • X0 • R (plus , Z⊗I) • S0⁻¹ • R (plus , I⊗Z) • S1⁻¹ • W • X0 • CX0 • R (plus , Z⊗I) • CX0 • X0 • X1 • CX1 • R (plus , Z⊗I) • S0⁻¹ • R (plus , I⊗Z) • S1⁻¹ • W • X1 • CX1 • X1 • CX1 • X0 • CX0 • R (plus , Z⊗I) • H0 • CZ • S0 • S0 • H0 • R (plus , Z⊗I) • S0⁻¹ • R (plus , I⊗Z) • S1⁻¹ • W • X1 • CX1 • X1 • CX1 • X0 • CX0 • R (plus , Z⊗I) • H0 • CZ • S0 • S0 • H0 • R (plus , Z⊗I) • S0⁻¹ • R (plus , I⊗Z) • S1⁻¹ • W • X1 • CX1 • ε
          by clifford-tactic 5 6 10000 auto
      equals R (minus , Z⊗Z) • R (plus , Z⊗I) • R (plus , I⊗Z) • R (minus , Z⊗Z) • R (plus , Z⊗I) • S0⁻¹ • S1⁻¹ • W • X0 • CX0 • CX0 • X0 • S0⁻¹ • R (plus , I⊗Z) • S1⁻¹ • W • X0 • CX0 • R (plus , Z⊗I) • CX0 • X0 • R (plus , Z⊗I) • S0⁻¹ • R (plus , I⊗Z) • S1⁻¹ • W • X0 • S1 • H1 • R (plus , I⊗Z) • CX1 • R (plus , I⊗Z) • S1⁻¹ • H1 • S1⁻¹ • X0 • X0 • CX0 • R (plus , Z⊗I) • CX0 • X0 • R (plus , Z⊗I) • S0⁻¹ • R (plus , I⊗Z) • S1⁻¹ • W • X0 • CX0 • R (plus , Z⊗I) • CX0 • X0 • X1 • CX1 • R (plus , Z⊗I) • S0⁻¹ • R (plus , I⊗Z) • S1⁻¹ • W • X1 • CX1 • X1 • CX1 • X0 • CX0 • R (plus , Z⊗I) • H0 • CZ • S0 • S0 • H0 • R (plus , Z⊗I) • S0⁻¹ • R (plus , I⊗Z) • S1⁻¹ • W • X1 • CX1 • X1 • CX1 • X0 • CX0 • R (plus , Z⊗I) • H0 • CZ • S0 • S0 • H0 • R (plus , Z⊗I) • S0⁻¹ • R (plus , I⊗Z) • S1⁻¹ • W • X1 • CX1 • ε
          by in-context 4 8 auto (symm (lemma-R (C.S0⁻¹ • C.S1⁻¹ • C.W • C.X0 • C.CX0 • C.CX0 • C.X0) (plus , Z⊗I)))
      equals R (minus , Z⊗Z) • R (plus , Z⊗I) • R (plus , I⊗Z) • R (minus , Z⊗Z) • S0⁻¹ • S1⁻¹ • W • X0 • CX0 • CX0 • X0 • R (plus , Z⊗I) • S0⁻¹ • R (plus , I⊗Z) • S1⁻¹ • W • X0 • CX0 • R (plus , Z⊗I) • CX0 • X0 • R (plus , Z⊗I) • S0⁻¹ • R (plus , I⊗Z) • S1⁻¹ • W • X0 • S1 • H1 • R (plus , I⊗Z) • CX1 • R (plus , I⊗Z) • S1⁻¹ • H1 • S1⁻¹ • X0 • X0 • CX0 • R (plus , Z⊗I) • CX0 • X0 • R (plus , Z⊗I) • S0⁻¹ • R (plus , I⊗Z) • S1⁻¹ • W • X0 • CX0 • R (plus , Z⊗I) • CX0 • X0 • X1 • CX1 • R (plus , Z⊗I) • S0⁻¹ • R (plus , I⊗Z) • S1⁻¹ • W • X1 • CX1 • X1 • CX1 • X0 • CX0 • R (plus , Z⊗I) • H0 • CZ • S0 • S0 • H0 • R (plus , Z⊗I) • S0⁻¹ • R (plus , I⊗Z) • S1⁻¹ • W • X1 • CX1 • X1 • CX1 • X0 • CX0 • R (plus , Z⊗I) • H0 • CZ • S0 • S0 • H0 • R (plus , Z⊗I) • S0⁻¹ • R (plus , I⊗Z) • S1⁻¹ • W • X1 • CX1 • ε
          by in-context 3 6 auto (symm (lemma-R (C.S0⁻¹ • C.S1⁻¹ • C.W • C.X0 • C.CX0) (plus , Z⊗I)))
      equals R (minus , Z⊗Z) • R (plus , Z⊗I) • R (plus , I⊗Z) • S0⁻¹ • S1⁻¹ • W • X0 • CX0 • R (plus , Z⊗I) • CX0 • X0 • R (plus , Z⊗I) • S0⁻¹ • R (plus , I⊗Z) • S1⁻¹ • W • X0 • CX0 • R (plus , Z⊗I) • CX0 • X0 • R (plus , Z⊗I) • S0⁻¹ • R (plus , I⊗Z) • S1⁻¹ • W • X0 • S1 • H1 • R (plus , I⊗Z) • CX1 • R (plus , I⊗Z) • S1⁻¹ • H1 • S1⁻¹ • X0 • X0 • CX0 • R (plus , Z⊗I) • CX0 • X0 • R (plus , Z⊗I) • S0⁻¹ • R (plus , I⊗Z) • S1⁻¹ • W • X0 • CX0 • R (plus , Z⊗I) • CX0 • X0 • X1 • CX1 • R (plus , Z⊗I) • S0⁻¹ • R (plus , I⊗Z) • S1⁻¹ • W • X1 • CX1 • X1 • CX1 • X0 • CX0 • R (plus , Z⊗I) • H0 • CZ • S0 • S0 • H0 • R (plus , Z⊗I) • S0⁻¹ • R (plus , I⊗Z) • S1⁻¹ • W • X1 • CX1 • X1 • CX1 • X0 • CX0 • R (plus , Z⊗I) • H0 • CZ • S0 • S0 • H0 • R (plus , Z⊗I) • S0⁻¹ • R (plus , I⊗Z) • S1⁻¹ • W • X1 • CX1 • ε
          by in-context 2 2 auto (symm (lemma-R (C.S0⁻¹) (plus , I⊗Z)))
      equals R (minus , Z⊗Z) • R (plus , Z⊗I) • S0⁻¹ • R (plus , I⊗Z) • S1⁻¹ • W • X0 • CX0 • R (plus , Z⊗I) • CX0 • X0 • R (plus , Z⊗I) • S0⁻¹ • R (plus , I⊗Z) • S1⁻¹ • W • X0 • CX0 • R (plus , Z⊗I) • CX0 • X0 • R (plus , Z⊗I) • S0⁻¹ • R (plus , I⊗Z) • S1⁻¹ • W • X0 • S1 • H1 • R (plus , I⊗Z) • CX1 • R (plus , I⊗Z) • S1⁻¹ • H1 • S1⁻¹ • X0 • X0 • CX0 • R (plus , Z⊗I) • CX0 • X0 • R (plus , Z⊗I) • S0⁻¹ • R (plus , I⊗Z) • S1⁻¹ • W • X0 • CX0 • R (plus , Z⊗I) • CX0 • X0 • X1 • CX1 • R (plus , Z⊗I) • S0⁻¹ • R (plus , I⊗Z) • S1⁻¹ • W • X1 • CX1 • X1 • CX1 • X0 • CX0 • R (plus , Z⊗I) • H0 • CZ • S0 • S0 • H0 • R (plus , Z⊗I) • S0⁻¹ • R (plus , I⊗Z) • S1⁻¹ • W • X1 • CX1 • X1 • CX1 • X0 • CX0 • R (plus , Z⊗I) • H0 • CZ • S0 • S0 • H0 • R (plus , Z⊗I) • S0⁻¹ • R (plus , I⊗Z) • S1⁻¹ • W • X1 • CX1 • ε
          by clifford-tactic 1 0 10000 auto
      equals R (minus , Z⊗Z) • X0 • CX0 • CX0 • X0 • R (plus , Z⊗I) • S0⁻¹ • R (plus , I⊗Z) • S1⁻¹ • W • X0 • CX0 • R (plus , Z⊗I) • CX0 • X0 • R (plus , Z⊗I) • S0⁻¹ • R (plus , I⊗Z) • S1⁻¹ • W • X0 • CX0 • R (plus , Z⊗I) • CX0 • X0 • R (plus , Z⊗I) • S0⁻¹ • R (plus , I⊗Z) • S1⁻¹ • W • X0 • S1 • H1 • R (plus , I⊗Z) • CX1 • R (plus , I⊗Z) • S1⁻¹ • H1 • S1⁻¹ • X0 • X0 • CX0 • R (plus , Z⊗I) • CX0 • X0 • R (plus , Z⊗I) • S0⁻¹ • R (plus , I⊗Z) • S1⁻¹ • W • X0 • CX0 • R (plus , Z⊗I) • CX0 • X0 • X1 • CX1 • R (plus , Z⊗I) • S0⁻¹ • R (plus , I⊗Z) • S1⁻¹ • W • X1 • CX1 • X1 • CX1 • X0 • CX0 • R (plus , Z⊗I) • H0 • CZ • S0 • S0 • H0 • R (plus , Z⊗I) • S0⁻¹ • R (plus , I⊗Z) • S1⁻¹ • W • X1 • CX1 • X1 • CX1 • X0 • CX0 • R (plus , Z⊗I) • H0 • CZ • S0 • S0 • H0 • R (plus , Z⊗I) • S0⁻¹ • R (plus , I⊗Z) • S1⁻¹ • W • X1 • CX1 • ε
          by in-context 0 3 auto (symm (lemma-R (C.X0 • C.CX0) (plus , Z⊗I)))
      equals X0 • CX0 • R (plus , Z⊗I) • CX0 • X0 • R (plus , Z⊗I) • S0⁻¹ • R (plus , I⊗Z) • S1⁻¹ • W • X0 • CX0 • R (plus , Z⊗I) • CX0 • X0 • R (plus , Z⊗I) • S0⁻¹ • R (plus , I⊗Z) • S1⁻¹ • W • X0 • CX0 • R (plus , Z⊗I) • CX0 • X0 • R (plus , Z⊗I) • S0⁻¹ • R (plus , I⊗Z) • S1⁻¹ • W • X0 • S1 • H1 • R (plus , I⊗Z) • CX1 • R (plus , I⊗Z) • S1⁻¹ • H1 • S1⁻¹ • X0 • X0 • CX0 • R (plus , Z⊗I) • CX0 • X0 • R (plus , Z⊗I) • S0⁻¹ • R (plus , I⊗Z) • S1⁻¹ • W • X0 • CX0 • R (plus , Z⊗I) • CX0 • X0 • X1 • CX1 • R (plus , Z⊗I) • S0⁻¹ • R (plus , I⊗Z) • S1⁻¹ • W • X1 • CX1 • X1 • CX1 • X0 • CX0 • R (plus , Z⊗I) • H0 • CZ • S0 • S0 • H0 • R (plus , Z⊗I) • S0⁻¹ • R (plus , I⊗Z) • S1⁻¹ • W • X1 • CX1 • X1 • CX1 • X0 • CX0 • R (plus , Z⊗I) • H0 • CZ • S0 • S0 • H0 • R (plus , Z⊗I) • S0⁻¹ • R (plus , I⊗Z) • S1⁻¹ • W • X1 • CX1 • ε
          by clifford-tactic 86 5 10000 auto
      equals X0 • CX0 • R (plus , Z⊗I) • CX0 • X0 • R (plus , Z⊗I) • S0⁻¹ • R (plus , I⊗Z) • S1⁻¹ • W • X0 • CX0 • R (plus , Z⊗I) • CX0 • X0 • R (plus , Z⊗I) • S0⁻¹ • R (plus , I⊗Z) • S1⁻¹ • W • X0 • CX0 • R (plus , Z⊗I) • CX0 • X0 • R (plus , Z⊗I) • S0⁻¹ • R (plus , I⊗Z) • S1⁻¹ • W • X0 • S1 • H1 • R (plus , I⊗Z) • CX1 • R (plus , I⊗Z) • S1⁻¹ • H1 • S1⁻¹ • X0 • X0 • CX0 • R (plus , Z⊗I) • CX0 • X0 • R (plus , Z⊗I) • S0⁻¹ • R (plus , I⊗Z) • S1⁻¹ • W • X0 • CX0 • R (plus , Z⊗I) • CX0 • X0 • X1 • CX1 • R (plus , Z⊗I) • S0⁻¹ • R (plus , I⊗Z) • S1⁻¹ • W • X1 • CX1 • X1 • CX1 • X0 • CX0 • R (plus , Z⊗I) • H0 • CZ • S0 • S0 • H0 • R (plus , Z⊗I) • S0⁻¹ • R (plus , I⊗Z) • S1⁻¹ • W • X1 • CX1 • X1 • CX1 • X0 • CX0 • R (plus , Z⊗I) • CX0 • X0 • X1 • CX1 • X1 • CX1 • R (plus , Z⊗I) • S0⁻¹ • R (plus , I⊗Z) • S1⁻¹ • W • X1 • CX1 • ε
          by clifford-tactic 69 5 10000 auto
      equals X0 • CX0 • R (plus , Z⊗I) • CX0 • X0 • R (plus , Z⊗I) • S0⁻¹ • R (plus , I⊗Z) • S1⁻¹ • W • X0 • CX0 • R (plus , Z⊗I) • CX0 • X0 • R (plus , Z⊗I) • S0⁻¹ • R (plus , I⊗Z) • S1⁻¹ • W • X0 • CX0 • R (plus , Z⊗I) • CX0 • X0 • R (plus , Z⊗I) • S0⁻¹ • R (plus , I⊗Z) • S1⁻¹ • W • X0 • S1 • H1 • R (plus , I⊗Z) • CX1 • R (plus , I⊗Z) • S1⁻¹ • H1 • S1⁻¹ • X0 • X0 • CX0 • R (plus , Z⊗I) • CX0 • X0 • R (plus , Z⊗I) • S0⁻¹ • R (plus , I⊗Z) • S1⁻¹ • W • X0 • CX0 • R (plus , Z⊗I) • CX0 • X0 • X1 • CX1 • R (plus , Z⊗I) • S0⁻¹ • R (plus , I⊗Z) • S1⁻¹ • W • X1 • CX1 • X1 • CX1 • X0 • CX0 • R (plus , Z⊗I) • CX0 • X0 • X1 • CX1 • X1 • CX1 • R (plus , Z⊗I) • S0⁻¹ • R (plus , I⊗Z) • S1⁻¹ • W • X1 • CX1 • X1 • CX1 • X0 • CX0 • R (plus , Z⊗I) • CX0 • X0 • X1 • CX1 • X1 • CX1 • R (plus , Z⊗I) • S0⁻¹ • R (plus , I⊗Z) • S1⁻¹ • W • X1 • CX1 • ε
          by in-context 95 2 auto (symm lemma-R-T1⁻¹)
      equals X0 • CX0 • R (plus , Z⊗I) • CX0 • X0 • R (plus , Z⊗I) • S0⁻¹ • R (plus , I⊗Z) • S1⁻¹ • W • X0 • CX0 • R (plus , Z⊗I) • CX0 • X0 • R (plus , Z⊗I) • S0⁻¹ • R (plus , I⊗Z) • S1⁻¹ • W • X0 • CX0 • R (plus , Z⊗I) • CX0 • X0 • R (plus , Z⊗I) • S0⁻¹ • R (plus , I⊗Z) • S1⁻¹ • W • X0 • S1 • H1 • R (plus , I⊗Z) • CX1 • R (plus , I⊗Z) • S1⁻¹ • H1 • S1⁻¹ • X0 • X0 • CX0 • R (plus , Z⊗I) • CX0 • X0 • R (plus , Z⊗I) • S0⁻¹ • R (plus , I⊗Z) • S1⁻¹ • W • X0 • CX0 • R (plus , Z⊗I) • CX0 • X0 • X1 • CX1 • R (plus , Z⊗I) • S0⁻¹ • R (plus , I⊗Z) • S1⁻¹ • W • X1 • CX1 • X1 • CX1 • X0 • CX0 • R (plus , Z⊗I) • CX0 • X0 • X1 • CX1 • X1 • CX1 • R (plus , Z⊗I) • S0⁻¹ • R (plus , I⊗Z) • S1⁻¹ • W • X1 • CX1 • X1 • CX1 • X0 • CX0 • R (plus , Z⊗I) • CX0 • X0 • X1 • CX1 • X1 • CX1 • R (plus , Z⊗I) • S0⁻¹ • T1⁻¹ • W • X1 • CX1 • ε
          by in-context 93 2 auto (symm lemma-R-T0⁻¹)
      equals X0 • CX0 • R (plus , Z⊗I) • CX0 • X0 • R (plus , Z⊗I) • S0⁻¹ • R (plus , I⊗Z) • S1⁻¹ • W • X0 • CX0 • R (plus , Z⊗I) • CX0 • X0 • R (plus , Z⊗I) • S0⁻¹ • R (plus , I⊗Z) • S1⁻¹ • W • X0 • CX0 • R (plus , Z⊗I) • CX0 • X0 • R (plus , Z⊗I) • S0⁻¹ • R (plus , I⊗Z) • S1⁻¹ • W • X0 • S1 • H1 • R (plus , I⊗Z) • CX1 • R (plus , I⊗Z) • S1⁻¹ • H1 • S1⁻¹ • X0 • X0 • CX0 • R (plus , Z⊗I) • CX0 • X0 • R (plus , Z⊗I) • S0⁻¹ • R (plus , I⊗Z) • S1⁻¹ • W • X0 • CX0 • R (plus , Z⊗I) • CX0 • X0 • X1 • CX1 • R (plus , Z⊗I) • S0⁻¹ • R (plus , I⊗Z) • S1⁻¹ • W • X1 • CX1 • X1 • CX1 • X0 • CX0 • R (plus , Z⊗I) • CX0 • X0 • X1 • CX1 • X1 • CX1 • R (plus , Z⊗I) • S0⁻¹ • R (plus , I⊗Z) • S1⁻¹ • W • X1 • CX1 • X1 • CX1 • X0 • CX0 • R (plus , Z⊗I) • CX0 • X0 • X1 • CX1 • X1 • CX1 • T0⁻¹ • T1⁻¹ • W • X1 • CX1 • ε
          by general-assoc auto
      equals X0 • CX0 • R (plus , Z⊗I) • CX0 • X0 • R (plus , Z⊗I) • S0⁻¹ • R (plus , I⊗Z) • S1⁻¹ • W • X0 • CX0 • R (plus , Z⊗I) • CX0 • X0 • R (plus , Z⊗I) • S0⁻¹ • R (plus , I⊗Z) • S1⁻¹ • W • X0 • CX0 • R (plus , Z⊗I) • CX0 • X0 • R (plus , Z⊗I) • S0⁻¹ • R (plus , I⊗Z) • S1⁻¹ • W • X0 • S1 • H1 • R (plus , I⊗Z) • CX1 • R (plus , I⊗Z) • S1⁻¹ • H1 • S1⁻¹ • X0 • X0 • CX0 • R (plus , Z⊗I) • CX0 • X0 • R (plus , Z⊗I) • S0⁻¹ • R (plus , I⊗Z) • S1⁻¹ • W • X0 • CX0 • R (plus , Z⊗I) • CX0 • X0 • X1 • CX1 • R (plus , Z⊗I) • S0⁻¹ • R (plus , I⊗Z) • S1⁻¹ • W • X1 • CX1 • X1 • CX1 • X0 • CX0 • R (plus , Z⊗I) • CX0 • X0 • X1 • CX1 • X1 • CX1 • R (plus , Z⊗I) • S0⁻¹ • R (plus , I⊗Z) • S1⁻¹ • W • X1 • CX1 • X1 • CX1 • X0 • CX0 • T0 • CX0 • X0 • X1 • CX1 • X1 • CX1 • T0⁻¹ • T1⁻¹ • W • X1 • CX1 • ε
          by in-context 77 2 auto (symm lemma-R-T1⁻¹)
      equals X0 • CX0 • R (plus , Z⊗I) • CX0 • X0 • R (plus , Z⊗I) • S0⁻¹ • R (plus , I⊗Z) • S1⁻¹ • W • X0 • CX0 • R (plus , Z⊗I) • CX0 • X0 • R (plus , Z⊗I) • S0⁻¹ • R (plus , I⊗Z) • S1⁻¹ • W • X0 • CX0 • R (plus , Z⊗I) • CX0 • X0 • R (plus , Z⊗I) • S0⁻¹ • R (plus , I⊗Z) • S1⁻¹ • W • X0 • S1 • H1 • R (plus , I⊗Z) • CX1 • R (plus , I⊗Z) • S1⁻¹ • H1 • S1⁻¹ • X0 • X0 • CX0 • R (plus , Z⊗I) • CX0 • X0 • R (plus , Z⊗I) • S0⁻¹ • R (plus , I⊗Z) • S1⁻¹ • W • X0 • CX0 • R (plus , Z⊗I) • CX0 • X0 • X1 • CX1 • R (plus , Z⊗I) • S0⁻¹ • R (plus , I⊗Z) • S1⁻¹ • W • X1 • CX1 • X1 • CX1 • X0 • CX0 • R (plus , Z⊗I) • CX0 • X0 • X1 • CX1 • X1 • CX1 • R (plus , Z⊗I) • S0⁻¹ • T1⁻¹ • W • X1 • CX1 • X1 • CX1 • X0 • CX0 • T0 • CX0 • X0 • X1 • CX1 • X1 • CX1 • T0⁻¹ • T1⁻¹ • W • X1 • CX1 • ε
          by in-context 75 2 auto (symm lemma-R-T0⁻¹)
      equals X0 • CX0 • R (plus , Z⊗I) • CX0 • X0 • R (plus , Z⊗I) • S0⁻¹ • R (plus , I⊗Z) • S1⁻¹ • W • X0 • CX0 • R (plus , Z⊗I) • CX0 • X0 • R (plus , Z⊗I) • S0⁻¹ • R (plus , I⊗Z) • S1⁻¹ • W • X0 • CX0 • R (plus , Z⊗I) • CX0 • X0 • R (plus , Z⊗I) • S0⁻¹ • R (plus , I⊗Z) • S1⁻¹ • W • X0 • S1 • H1 • R (plus , I⊗Z) • CX1 • R (plus , I⊗Z) • S1⁻¹ • H1 • S1⁻¹ • X0 • X0 • CX0 • R (plus , Z⊗I) • CX0 • X0 • R (plus , Z⊗I) • S0⁻¹ • R (plus , I⊗Z) • S1⁻¹ • W • X0 • CX0 • R (plus , Z⊗I) • CX0 • X0 • X1 • CX1 • R (plus , Z⊗I) • S0⁻¹ • R (plus , I⊗Z) • S1⁻¹ • W • X1 • CX1 • X1 • CX1 • X0 • CX0 • R (plus , Z⊗I) • CX0 • X0 • X1 • CX1 • X1 • CX1 • T0⁻¹ • T1⁻¹ • W • X1 • CX1 • X1 • CX1 • X0 • CX0 • T0 • CX0 • X0 • X1 • CX1 • X1 • CX1 • T0⁻¹ • T1⁻¹ • W • X1 • CX1 • ε
          by general-assoc auto
      equals X0 • CX0 • R (plus , Z⊗I) • CX0 • X0 • R (plus , Z⊗I) • S0⁻¹ • R (plus , I⊗Z) • S1⁻¹ • W • X0 • CX0 • R (plus , Z⊗I) • CX0 • X0 • R (plus , Z⊗I) • S0⁻¹ • R (plus , I⊗Z) • S1⁻¹ • W • X0 • CX0 • R (plus , Z⊗I) • CX0 • X0 • R (plus , Z⊗I) • S0⁻¹ • R (plus , I⊗Z) • S1⁻¹ • W • X0 • S1 • H1 • R (plus , I⊗Z) • CX1 • R (plus , I⊗Z) • S1⁻¹ • H1 • S1⁻¹ • X0 • X0 • CX0 • R (plus , Z⊗I) • CX0 • X0 • R (plus , Z⊗I) • S0⁻¹ • R (plus , I⊗Z) • S1⁻¹ • W • X0 • CX0 • R (plus , Z⊗I) • CX0 • X0 • X1 • CX1 • R (plus , Z⊗I) • S0⁻¹ • R (plus , I⊗Z) • S1⁻¹ • W • X1 • CX1 • X1 • CX1 • X0 • CX0 • T0 • CX0 • X0 • X1 • CX1 • X1 • CX1 • T0⁻¹ • T1⁻¹ • W • X1 • CX1 • X1 • CX1 • X0 • CX0 • T0 • CX0 • X0 • X1 • CX1 • X1 • CX1 • T0⁻¹ • T1⁻¹ • W • X1 • CX1 • ε
          by in-context 59 2 auto (symm lemma-R-T1⁻¹)
      equals X0 • CX0 • R (plus , Z⊗I) • CX0 • X0 • R (plus , Z⊗I) • S0⁻¹ • R (plus , I⊗Z) • S1⁻¹ • W • X0 • CX0 • R (plus , Z⊗I) • CX0 • X0 • R (plus , Z⊗I) • S0⁻¹ • R (plus , I⊗Z) • S1⁻¹ • W • X0 • CX0 • R (plus , Z⊗I) • CX0 • X0 • R (plus , Z⊗I) • S0⁻¹ • R (plus , I⊗Z) • S1⁻¹ • W • X0 • S1 • H1 • R (plus , I⊗Z) • CX1 • R (plus , I⊗Z) • S1⁻¹ • H1 • S1⁻¹ • X0 • X0 • CX0 • R (plus , Z⊗I) • CX0 • X0 • R (plus , Z⊗I) • S0⁻¹ • R (plus , I⊗Z) • S1⁻¹ • W • X0 • CX0 • R (plus , Z⊗I) • CX0 • X0 • X1 • CX1 • R (plus , Z⊗I) • S0⁻¹ • T1⁻¹ • W • X1 • CX1 • X1 • CX1 • X0 • CX0 • T0 • CX0 • X0 • X1 • CX1 • X1 • CX1 • T0⁻¹ • T1⁻¹ • W • X1 • CX1 • X1 • CX1 • X0 • CX0 • T0 • CX0 • X0 • X1 • CX1 • X1 • CX1 • T0⁻¹ • T1⁻¹ • W • X1 • CX1 • ε
          by in-context 57 2 auto (symm lemma-R-T0⁻¹)
      equals X0 • CX0 • R (plus , Z⊗I) • CX0 • X0 • R (plus , Z⊗I) • S0⁻¹ • R (plus , I⊗Z) • S1⁻¹ • W • X0 • CX0 • R (plus , Z⊗I) • CX0 • X0 • R (plus , Z⊗I) • S0⁻¹ • R (plus , I⊗Z) • S1⁻¹ • W • X0 • CX0 • R (plus , Z⊗I) • CX0 • X0 • R (plus , Z⊗I) • S0⁻¹ • R (plus , I⊗Z) • S1⁻¹ • W • X0 • S1 • H1 • R (plus , I⊗Z) • CX1 • R (plus , I⊗Z) • S1⁻¹ • H1 • S1⁻¹ • X0 • X0 • CX0 • R (plus , Z⊗I) • CX0 • X0 • R (plus , Z⊗I) • S0⁻¹ • R (plus , I⊗Z) • S1⁻¹ • W • X0 • CX0 • R (plus , Z⊗I) • CX0 • X0 • X1 • CX1 • T0⁻¹ • T1⁻¹ • W • X1 • CX1 • X1 • CX1 • X0 • CX0 • T0 • CX0 • X0 • X1 • CX1 • X1 • CX1 • T0⁻¹ • T1⁻¹ • W • X1 • CX1 • X1 • CX1 • X0 • CX0 • T0 • CX0 • X0 • X1 • CX1 • X1 • CX1 • T0⁻¹ • T1⁻¹ • W • X1 • CX1 • ε
          by general-assoc auto
      equals X0 • CX0 • R (plus , Z⊗I) • CX0 • X0 • R (plus , Z⊗I) • S0⁻¹ • R (plus , I⊗Z) • S1⁻¹ • W • X0 • CX0 • R (plus , Z⊗I) • CX0 • X0 • R (plus , Z⊗I) • S0⁻¹ • R (plus , I⊗Z) • S1⁻¹ • W • X0 • CX0 • R (plus , Z⊗I) • CX0 • X0 • R (plus , Z⊗I) • S0⁻¹ • R (plus , I⊗Z) • S1⁻¹ • W • X0 • S1 • H1 • R (plus , I⊗Z) • CX1 • R (plus , I⊗Z) • S1⁻¹ • H1 • S1⁻¹ • X0 • X0 • CX0 • R (plus , Z⊗I) • CX0 • X0 • R (plus , Z⊗I) • S0⁻¹ • R (plus , I⊗Z) • S1⁻¹ • W • X0 • CX0 • T0 • CX0 • X0 • X1 • CX1 • T0⁻¹ • T1⁻¹ • W • X1 • CX1 • X1 • CX1 • X0 • CX0 • T0 • CX0 • X0 • X1 • CX1 • X1 • CX1 • T0⁻¹ • T1⁻¹ • W • X1 • CX1 • X1 • CX1 • X0 • CX0 • T0 • CX0 • X0 • X1 • CX1 • X1 • CX1 • T0⁻¹ • T1⁻¹ • W • X1 • CX1 • ε
          by in-context 47 2 auto (symm lemma-R-T1⁻¹)
      equals X0 • CX0 • R (plus , Z⊗I) • CX0 • X0 • R (plus , Z⊗I) • S0⁻¹ • R (plus , I⊗Z) • S1⁻¹ • W • X0 • CX0 • R (plus , Z⊗I) • CX0 • X0 • R (plus , Z⊗I) • S0⁻¹ • R (plus , I⊗Z) • S1⁻¹ • W • X0 • CX0 • R (plus , Z⊗I) • CX0 • X0 • R (plus , Z⊗I) • S0⁻¹ • R (plus , I⊗Z) • S1⁻¹ • W • X0 • S1 • H1 • R (plus , I⊗Z) • CX1 • R (plus , I⊗Z) • S1⁻¹ • H1 • S1⁻¹ • X0 • X0 • CX0 • R (plus , Z⊗I) • CX0 • X0 • R (plus , Z⊗I) • S0⁻¹ • T1⁻¹ • W • X0 • CX0 • T0 • CX0 • X0 • X1 • CX1 • T0⁻¹ • T1⁻¹ • W • X1 • CX1 • X1 • CX1 • X0 • CX0 • T0 • CX0 • X0 • X1 • CX1 • X1 • CX1 • T0⁻¹ • T1⁻¹ • W • X1 • CX1 • X1 • CX1 • X0 • CX0 • T0 • CX0 • X0 • X1 • CX1 • X1 • CX1 • T0⁻¹ • T1⁻¹ • W • X1 • CX1 • ε
          by in-context 45 2 auto (symm lemma-R-T0⁻¹)
      equals X0 • CX0 • R (plus , Z⊗I) • CX0 • X0 • R (plus , Z⊗I) • S0⁻¹ • R (plus , I⊗Z) • S1⁻¹ • W • X0 • CX0 • R (plus , Z⊗I) • CX0 • X0 • R (plus , Z⊗I) • S0⁻¹ • R (plus , I⊗Z) • S1⁻¹ • W • X0 • CX0 • R (plus , Z⊗I) • CX0 • X0 • R (plus , Z⊗I) • S0⁻¹ • R (plus , I⊗Z) • S1⁻¹ • W • X0 • S1 • H1 • R (plus , I⊗Z) • CX1 • R (plus , I⊗Z) • S1⁻¹ • H1 • S1⁻¹ • X0 • X0 • CX0 • R (plus , Z⊗I) • CX0 • X0 • T0⁻¹ • T1⁻¹ • W • X0 • CX0 • T0 • CX0 • X0 • X1 • CX1 • T0⁻¹ • T1⁻¹ • W • X1 • CX1 • X1 • CX1 • X0 • CX0 • T0 • CX0 • X0 • X1 • CX1 • X1 • CX1 • T0⁻¹ • T1⁻¹ • W • X1 • CX1 • X1 • CX1 • X0 • CX0 • T0 • CX0 • X0 • X1 • CX1 • X1 • CX1 • T0⁻¹ • T1⁻¹ • W • X1 • CX1 • ε
          by general-assoc auto
      equals X0 • CX0 • R (plus , Z⊗I) • CX0 • X0 • R (plus , Z⊗I) • S0⁻¹ • R (plus , I⊗Z) • S1⁻¹ • W • X0 • CX0 • R (plus , Z⊗I) • CX0 • X0 • R (plus , Z⊗I) • S0⁻¹ • R (plus , I⊗Z) • S1⁻¹ • W • X0 • CX0 • R (plus , Z⊗I) • CX0 • X0 • R (plus , Z⊗I) • S0⁻¹ • R (plus , I⊗Z) • S1⁻¹ • W • X0 • S1 • H1 • R (plus , I⊗Z) • CX1 • R (plus , I⊗Z) • S1⁻¹ • H1 • S1⁻¹ • X0 • X0 • CX0 • T0 • CX0 • X0 • T0⁻¹ • T1⁻¹ • W • X0 • CX0 • T0 • CX0 • X0 • X1 • CX1 • T0⁻¹ • T1⁻¹ • W • X1 • CX1 • X1 • CX1 • X0 • CX0 • T0 • CX0 • X0 • X1 • CX1 • X1 • CX1 • T0⁻¹ • T1⁻¹ • W • X1 • CX1 • X1 • CX1 • X0 • CX0 • T0 • CX0 • X0 • X1 • CX1 • X1 • CX1 • T0⁻¹ • T1⁻¹ • W • X1 • CX1 • ε
          by in-context 35 2 auto (symm lemma-R-T1⁻¹)
      equals X0 • CX0 • R (plus , Z⊗I) • CX0 • X0 • R (plus , Z⊗I) • S0⁻¹ • R (plus , I⊗Z) • S1⁻¹ • W • X0 • CX0 • R (plus , Z⊗I) • CX0 • X0 • R (plus , Z⊗I) • S0⁻¹ • R (plus , I⊗Z) • S1⁻¹ • W • X0 • CX0 • R (plus , Z⊗I) • CX0 • X0 • R (plus , Z⊗I) • S0⁻¹ • R (plus , I⊗Z) • S1⁻¹ • W • X0 • S1 • H1 • R (plus , I⊗Z) • CX1 • T1⁻¹ • H1 • S1⁻¹ • X0 • X0 • CX0 • T0 • CX0 • X0 • T0⁻¹ • T1⁻¹ • W • X0 • CX0 • T0 • CX0 • X0 • X1 • CX1 • T0⁻¹ • T1⁻¹ • W • X1 • CX1 • X1 • CX1 • X0 • CX0 • T0 • CX0 • X0 • X1 • CX1 • X1 • CX1 • T0⁻¹ • T1⁻¹ • W • X1 • CX1 • X1 • CX1 • X0 • CX0 • T0 • CX0 • X0 • X1 • CX1 • X1 • CX1 • T0⁻¹ • T1⁻¹ • W • X1 • CX1 • ε
          by in-context 33 1 auto (symm lemma-R-T1)
      equals X0 • CX0 • R (plus , Z⊗I) • CX0 • X0 • R (plus , Z⊗I) • S0⁻¹ • R (plus , I⊗Z) • S1⁻¹ • W • X0 • CX0 • R (plus , Z⊗I) • CX0 • X0 • R (plus , Z⊗I) • S0⁻¹ • R (plus , I⊗Z) • S1⁻¹ • W • X0 • CX0 • R (plus , Z⊗I) • CX0 • X0 • R (plus , Z⊗I) • S0⁻¹ • R (plus , I⊗Z) • S1⁻¹ • W • X0 • S1 • H1 • T1 • CX1 • T1⁻¹ • H1 • S1⁻¹ • X0 • X0 • CX0 • T0 • CX0 • X0 • T0⁻¹ • T1⁻¹ • W • X0 • CX0 • T0 • CX0 • X0 • X1 • CX1 • T0⁻¹ • T1⁻¹ • W • X1 • CX1 • X1 • CX1 • X0 • CX0 • T0 • CX0 • X0 • X1 • CX1 • X1 • CX1 • T0⁻¹ • T1⁻¹ • W • X1 • CX1 • X1 • CX1 • X0 • CX0 • T0 • CX0 • X0 • X1 • CX1 • X1 • CX1 • T0⁻¹ • T1⁻¹ • W • X1 • CX1 • ε
          by general-assoc auto
      equals X0 • CX0 • R (plus , Z⊗I) • CX0 • X0 • R (plus , Z⊗I) • S0⁻¹ • R (plus , I⊗Z) • S1⁻¹ • W • X0 • CX0 • R (plus , Z⊗I) • CX0 • X0 • R (plus , Z⊗I) • S0⁻¹ • R (plus , I⊗Z) • S1⁻¹ • W • X0 • CX0 • R (plus , Z⊗I) • CX0 • X0 • R (plus , Z⊗I) • S0⁻¹ • R (plus , I⊗Z) • S1⁻¹ • W • X0 • CH1 • X0 • X0 • CX0 • T0 • CX0 • X0 • T0⁻¹ • T1⁻¹ • W • X0 • CX0 • T0 • CX0 • X0 • X1 • CX1 • T0⁻¹ • T1⁻¹ • W • X1 • CX1 • X1 • CX1 • X0 • CX0 • T0 • CX0 • X0 • X1 • CX1 • X1 • CX1 • T0⁻¹ • T1⁻¹ • W • X1 • CX1 • X1 • CX1 • X0 • CX0 • T0 • CX0 • X0 • X1 • CX1 • X1 • CX1 • T0⁻¹ • T1⁻¹ • W • X1 • CX1 • ε
          by in-context 27 2 auto (symm lemma-R-T1⁻¹)
      equals X0 • CX0 • R (plus , Z⊗I) • CX0 • X0 • R (plus , Z⊗I) • S0⁻¹ • R (plus , I⊗Z) • S1⁻¹ • W • X0 • CX0 • R (plus , Z⊗I) • CX0 • X0 • R (plus , Z⊗I) • S0⁻¹ • R (plus , I⊗Z) • S1⁻¹ • W • X0 • CX0 • R (plus , Z⊗I) • CX0 • X0 • R (plus , Z⊗I) • S0⁻¹ • T1⁻¹ • W • X0 • CH1 • X0 • X0 • CX0 • T0 • CX0 • X0 • T0⁻¹ • T1⁻¹ • W • X0 • CX0 • T0 • CX0 • X0 • X1 • CX1 • T0⁻¹ • T1⁻¹ • W • X1 • CX1 • X1 • CX1 • X0 • CX0 • T0 • CX0 • X0 • X1 • CX1 • X1 • CX1 • T0⁻¹ • T1⁻¹ • W • X1 • CX1 • X1 • CX1 • X0 • CX0 • T0 • CX0 • X0 • X1 • CX1 • X1 • CX1 • T0⁻¹ • T1⁻¹ • W • X1 • CX1 • ε
          by in-context 25 2 auto (symm lemma-R-T0⁻¹)
      equals X0 • CX0 • R (plus , Z⊗I) • CX0 • X0 • R (plus , Z⊗I) • S0⁻¹ • R (plus , I⊗Z) • S1⁻¹ • W • X0 • CX0 • R (plus , Z⊗I) • CX0 • X0 • R (plus , Z⊗I) • S0⁻¹ • R (plus , I⊗Z) • S1⁻¹ • W • X0 • CX0 • R (plus , Z⊗I) • CX0 • X0 • T0⁻¹ • T1⁻¹ • W • X0 • CH1 • X0 • X0 • CX0 • T0 • CX0 • X0 • T0⁻¹ • T1⁻¹ • W • X0 • CX0 • T0 • CX0 • X0 • X1 • CX1 • T0⁻¹ • T1⁻¹ • W • X1 • CX1 • X1 • CX1 • X0 • CX0 • T0 • CX0 • X0 • X1 • CX1 • X1 • CX1 • T0⁻¹ • T1⁻¹ • W • X1 • CX1 • X1 • CX1 • X0 • CX0 • T0 • CX0 • X0 • X1 • CX1 • X1 • CX1 • T0⁻¹ • T1⁻¹ • W • X1 • CX1 • ε
          by general-assoc auto
      equals X0 • CX0 • R (plus , Z⊗I) • CX0 • X0 • R (plus , Z⊗I) • S0⁻¹ • R (plus , I⊗Z) • S1⁻¹ • W • X0 • CX0 • R (plus , Z⊗I) • CX0 • X0 • R (plus , Z⊗I) • S0⁻¹ • R (plus , I⊗Z) • S1⁻¹ • W • X0 • CX0 • T0 • CX0 • X0 • T0⁻¹ • T1⁻¹ • W • X0 • CH1 • X0 • X0 • CX0 • T0 • CX0 • X0 • T0⁻¹ • T1⁻¹ • W • X0 • CX0 • T0 • CX0 • X0 • X1 • CX1 • T0⁻¹ • T1⁻¹ • W • X1 • CX1 • X1 • CX1 • X0 • CX0 • T0 • CX0 • X0 • X1 • CX1 • X1 • CX1 • T0⁻¹ • T1⁻¹ • W • X1 • CX1 • X1 • CX1 • X0 • CX0 • T0 • CX0 • X0 • X1 • CX1 • X1 • CX1 • T0⁻¹ • T1⁻¹ • W • X1 • CX1 • ε
          by in-context 17 2 auto (symm lemma-R-T1⁻¹)
      equals X0 • CX0 • R (plus , Z⊗I) • CX0 • X0 • R (plus , Z⊗I) • S0⁻¹ • R (plus , I⊗Z) • S1⁻¹ • W • X0 • CX0 • R (plus , Z⊗I) • CX0 • X0 • R (plus , Z⊗I) • S0⁻¹ • T1⁻¹ • W • X0 • CX0 • T0 • CX0 • X0 • T0⁻¹ • T1⁻¹ • W • X0 • CH1 • X0 • X0 • CX0 • T0 • CX0 • X0 • T0⁻¹ • T1⁻¹ • W • X0 • CX0 • T0 • CX0 • X0 • X1 • CX1 • T0⁻¹ • T1⁻¹ • W • X1 • CX1 • X1 • CX1 • X0 • CX0 • T0 • CX0 • X0 • X1 • CX1 • X1 • CX1 • T0⁻¹ • T1⁻¹ • W • X1 • CX1 • X1 • CX1 • X0 • CX0 • T0 • CX0 • X0 • X1 • CX1 • X1 • CX1 • T0⁻¹ • T1⁻¹ • W • X1 • CX1 • ε
          by in-context 15 2 auto (symm lemma-R-T0⁻¹)
      equals X0 • CX0 • R (plus , Z⊗I) • CX0 • X0 • R (plus , Z⊗I) • S0⁻¹ • R (plus , I⊗Z) • S1⁻¹ • W • X0 • CX0 • R (plus , Z⊗I) • CX0 • X0 • T0⁻¹ • T1⁻¹ • W • X0 • CX0 • T0 • CX0 • X0 • T0⁻¹ • T1⁻¹ • W • X0 • CH1 • X0 • X0 • CX0 • T0 • CX0 • X0 • T0⁻¹ • T1⁻¹ • W • X0 • CX0 • T0 • CX0 • X0 • X1 • CX1 • T0⁻¹ • T1⁻¹ • W • X1 • CX1 • X1 • CX1 • X0 • CX0 • T0 • CX0 • X0 • X1 • CX1 • X1 • CX1 • T0⁻¹ • T1⁻¹ • W • X1 • CX1 • X1 • CX1 • X0 • CX0 • T0 • CX0 • X0 • X1 • CX1 • X1 • CX1 • T0⁻¹ • T1⁻¹ • W • X1 • CX1 • ε
          by general-assoc auto
      equals X0 • CX0 • R (plus , Z⊗I) • CX0 • X0 • R (plus , Z⊗I) • S0⁻¹ • R (plus , I⊗Z) • S1⁻¹ • W • X0 • CX0 • T0 • CX0 • X0 • T0⁻¹ • T1⁻¹ • W • X0 • CX0 • T0 • CX0 • X0 • T0⁻¹ • T1⁻¹ • W • X0 • CH1 • X0 • X0 • CX0 • T0 • CX0 • X0 • T0⁻¹ • T1⁻¹ • W • X0 • CX0 • T0 • CX0 • X0 • X1 • CX1 • T0⁻¹ • T1⁻¹ • W • X1 • CX1 • X1 • CX1 • X0 • CX0 • T0 • CX0 • X0 • X1 • CX1 • X1 • CX1 • T0⁻¹ • T1⁻¹ • W • X1 • CX1 • X1 • CX1 • X0 • CX0 • T0 • CX0 • X0 • X1 • CX1 • X1 • CX1 • T0⁻¹ • T1⁻¹ • W • X1 • CX1 • ε
          by in-context 7 2 auto (symm lemma-R-T1⁻¹)
      equals X0 • CX0 • R (plus , Z⊗I) • CX0 • X0 • R (plus , Z⊗I) • S0⁻¹ • T1⁻¹ • W • X0 • CX0 • T0 • CX0 • X0 • T0⁻¹ • T1⁻¹ • W • X0 • CX0 • T0 • CX0 • X0 • T0⁻¹ • T1⁻¹ • W • X0 • CH1 • X0 • X0 • CX0 • T0 • CX0 • X0 • T0⁻¹ • T1⁻¹ • W • X0 • CX0 • T0 • CX0 • X0 • X1 • CX1 • T0⁻¹ • T1⁻¹ • W • X1 • CX1 • X1 • CX1 • X0 • CX0 • T0 • CX0 • X0 • X1 • CX1 • X1 • CX1 • T0⁻¹ • T1⁻¹ • W • X1 • CX1 • X1 • CX1 • X0 • CX0 • T0 • CX0 • X0 • X1 • CX1 • X1 • CX1 • T0⁻¹ • T1⁻¹ • W • X1 • CX1 • ε
          by in-context 5 2 auto (symm lemma-R-T0⁻¹)
      equals X0 • CX0 • R (plus , Z⊗I) • CX0 • X0 • T0⁻¹ • T1⁻¹ • W • X0 • CX0 • T0 • CX0 • X0 • T0⁻¹ • T1⁻¹ • W • X0 • CX0 • T0 • CX0 • X0 • T0⁻¹ • T1⁻¹ • W • X0 • CH1 • X0 • X0 • CX0 • T0 • CX0 • X0 • T0⁻¹ • T1⁻¹ • W • X0 • CX0 • T0 • CX0 • X0 • X1 • CX1 • T0⁻¹ • T1⁻¹ • W • X1 • CX1 • X1 • CX1 • X0 • CX0 • T0 • CX0 • X0 • X1 • CX1 • X1 • CX1 • T0⁻¹ • T1⁻¹ • W • X1 • CX1 • X1 • CX1 • X0 • CX0 • T0 • CX0 • X0 • X1 • CX1 • X1 • CX1 • T0⁻¹ • T1⁻¹ • W • X1 • CX1 • ε
          by general-assoc auto
      equals X0 • CX0 • T0 • CX0 • X0 • T0⁻¹ • T1⁻¹ • W • X0 • CX0 • T0 • CX0 • X0 • T0⁻¹ • T1⁻¹ • W • X0 • CX0 • T0 • CX0 • X0 • T0⁻¹ • T1⁻¹ • W • X0 • CH1 • X0 • X0 • CX0 • T0 • CX0 • X0 • T0⁻¹ • T1⁻¹ • W • X0 • CX0 • T0 • CX0 • X0 • X1 • CX1 • T0⁻¹ • T1⁻¹ • W • X1 • CX1 • X1 • CX1 • X0 • CX0 • T0 • CX0 • X0 • X1 • CX1 • X1 • CX1 • T0⁻¹ • T1⁻¹ • W • X1 • CX1 • X1 • CX1 • X0 • CX0 • T0 • CX0 • X0 • X1 • CX1 • X1 • CX1 • T0⁻¹ • T1⁻¹ • W • X1 • CX1 • ε


