-- The proof of Equation 46.

import Proposition
import Equality

import Word
import Generator
import Word-Lemmas
import Word-Tactics
import Clifford-Lemmas
import CliffordT-Lemmas
import PauliRotations

open Proposition
open Equality using (auto)

open Word
open Generator
open Generator.Clifford+T
open Word-Lemmas.Monoid-Equational
open Word-Tactics.InContext
open Word-Tactics.Associative
open Clifford-Lemmas.Clifford-Rewriting
open CliffordT-Lemmas
open PauliRotations.Pauli
open PauliRotations.PauliRotRep
open PauliRotations.Commutativity
open PauliRotations.Combine
open PauliRotations.Correction

private module C = PauliRotations.Clifford

lemma-eqn46a : Clifford+T.Rel ⊢ T1 • CX1 • T1⁻¹ • X1 • CX1 • Swap • X0 • CH1 • X0 • Swap • X1 • CX1 • T1 • CX1 • T1⁻¹ • ε === T0 • CH0 • T0⁻¹ • ε
lemma-eqn46a = 
  equational T1 • CX1 • T1⁻¹ • X1 • CX1 • Swap • X0 • CH1 • X0 • Swap • X1 • CX1 • T1 • CX1 • T1⁻¹ • ε
          by in-context 15 0 auto (symm lemma-order-T0)
      equals T1 • CX1 • T1⁻¹ • X1 • CX1 • Swap • X0 • CH1 • X0 • Swap • X1 • CX1 • T1 • CX1 • T1⁻¹ • T0 • T0 • T0 • T0 • T0 • T0 • T0 • T0 • ε
          by general-assoc auto
      equals T1 • CX1 • T1⁻¹ • X1 • CX1 • Swap • X0 • CH1 • X0 • Swap • X1 • CX1 • T1 • CX1 • T1⁻¹ • T0 • T0⁻¹ • ε
          by in-context 16 0 auto (symm lemma-order-CH0)
      equals T1 • CX1 • T1⁻¹ • X1 • CX1 • Swap • X0 • CH1 • X0 • Swap • X1 • CX1 • T1 • CX1 • T1⁻¹ • T0 • CH0 • CH0 • T0⁻¹ • ε
          by in-context 17 0 auto (symm lemma-order-T0)
      equals T1 • CX1 • T1⁻¹ • X1 • CX1 • Swap • X0 • CH1 • X0 • Swap • X1 • CX1 • T1 • CX1 • T1⁻¹ • T0 • CH0 • T0 • T0 • T0 • T0 • T0 • T0 • T0 • T0 • CH0 • T0⁻¹ • ε
          by general-assoc auto
      equals T1 • CX1 • T1⁻¹ • X1 • CX1 • Swap • X0 • CH1 • X0 • Swap • X1 • CX1 • T1 • CX1 • T1⁻¹ • T0 • CH0 • T0⁻¹ • T0 • CH0 • T0⁻¹ • ε
          by clifford-tactic 18 0 10000 auto
      equals T1 • CX1 • T1⁻¹ • X1 • CX1 • Swap • X0 • CH1 • X0 • Swap • X1 • CX1 • T1 • CX1 • T1⁻¹ • T0 • CH0 • T0⁻¹ • CX1 • CX0 • X0 • X0 • CX0 • CX1 • T0 • CH0 • T0⁻¹ • ε
          by clifford-tactic 0 0 10000 auto
      equals CX1 • CX0 • X0 • X0 • CX0 • CX1 • T1 • CX1 • T1⁻¹ • X1 • CX1 • Swap • X0 • CH1 • X0 • Swap • X1 • CX1 • T1 • CX1 • T1⁻¹ • T0 • CH0 • T0⁻¹ • CX1 • CX0 • X0 • X0 • CX0 • CX1 • T0 • CH0 • T0⁻¹ • ε
          by in-context 6 1 auto lemma-R-T1
      equals CX1 • CX0 • X0 • X0 • CX0 • CX1 • R (plus , I⊗Z) • CX1 • T1⁻¹ • X1 • CX1 • Swap • X0 • CH1 • X0 • Swap • X1 • CX1 • T1 • CX1 • T1⁻¹ • T0 • CH0 • T0⁻¹ • CX1 • CX0 • X0 • X0 • CX0 • CX1 • T0 • CH0 • T0⁻¹ • ε
          by in-context 8 1 auto lemma-R-T1⁻¹
      equals CX1 • CX0 • X0 • X0 • CX0 • CX1 • R (plus , I⊗Z) • CX1 • R (plus , I⊗Z) • S1⁻¹ • X1 • CX1 • Swap • X0 • CH1 • X0 • Swap • X1 • CX1 • T1 • CX1 • T1⁻¹ • T0 • CH0 • T0⁻¹ • CX1 • CX0 • X0 • X0 • CX0 • CX1 • T0 • CH0 • T0⁻¹ • ε
          by general-assoc auto
      equals CX1 • CX0 • X0 • X0 • CX0 • CX1 • R (plus , I⊗Z) • CX1 • R (plus , I⊗Z) • S1⁻¹ • X1 • CX1 • Swap • X0 • S1 • H1 • T1 • CX1 • T1⁻¹ • H1 • S1⁻¹ • X0 • Swap • X1 • CX1 • T1 • CX1 • T1⁻¹ • T0 • CH0 • T0⁻¹ • CX1 • CX0 • X0 • X0 • CX0 • CX1 • T0 • CH0 • T0⁻¹ • ε
          by in-context 16 1 auto lemma-R-T1
      equals CX1 • CX0 • X0 • X0 • CX0 • CX1 • R (plus , I⊗Z) • CX1 • R (plus , I⊗Z) • S1⁻¹ • X1 • CX1 • Swap • X0 • S1 • H1 • R (plus , I⊗Z) • CX1 • T1⁻¹ • H1 • S1⁻¹ • X0 • Swap • X1 • CX1 • T1 • CX1 • T1⁻¹ • T0 • CH0 • T0⁻¹ • CX1 • CX0 • X0 • X0 • CX0 • CX1 • T0 • CH0 • T0⁻¹ • ε
          by in-context 18 1 auto lemma-R-T1⁻¹
      equals CX1 • CX0 • X0 • X0 • CX0 • CX1 • R (plus , I⊗Z) • CX1 • R (plus , I⊗Z) • S1⁻¹ • X1 • CX1 • Swap • X0 • S1 • H1 • R (plus , I⊗Z) • CX1 • R (plus , I⊗Z) • S1⁻¹ • H1 • S1⁻¹ • X0 • Swap • X1 • CX1 • T1 • CX1 • T1⁻¹ • T0 • CH0 • T0⁻¹ • CX1 • CX0 • X0 • X0 • CX0 • CX1 • T0 • CH0 • T0⁻¹ • ε
          by in-context 26 1 auto lemma-R-T1
      equals CX1 • CX0 • X0 • X0 • CX0 • CX1 • R (plus , I⊗Z) • CX1 • R (plus , I⊗Z) • S1⁻¹ • X1 • CX1 • Swap • X0 • S1 • H1 • R (plus , I⊗Z) • CX1 • R (plus , I⊗Z) • S1⁻¹ • H1 • S1⁻¹ • X0 • Swap • X1 • CX1 • R (plus , I⊗Z) • CX1 • T1⁻¹ • T0 • CH0 • T0⁻¹ • CX1 • CX0 • X0 • X0 • CX0 • CX1 • T0 • CH0 • T0⁻¹ • ε
          by in-context 28 1 auto lemma-R-T1⁻¹
      equals CX1 • CX0 • X0 • X0 • CX0 • CX1 • R (plus , I⊗Z) • CX1 • R (plus , I⊗Z) • S1⁻¹ • X1 • CX1 • Swap • X0 • S1 • H1 • R (plus , I⊗Z) • CX1 • R (plus , I⊗Z) • S1⁻¹ • H1 • S1⁻¹ • X0 • Swap • X1 • CX1 • R (plus , I⊗Z) • CX1 • R (plus , I⊗Z) • S1⁻¹ • T0 • CH0 • T0⁻¹ • CX1 • CX0 • X0 • X0 • CX0 • CX1 • T0 • CH0 • T0⁻¹ • ε
          by general-assoc auto
      equals CX1 • CX0 • X0 • X0 • CX0 • CX1 • R (plus , I⊗Z) • CX1 • R (plus , I⊗Z) • S1⁻¹ • X1 • CX1 • Swap • X0 • S1 • H1 • R (plus , I⊗Z) • CX1 • R (plus , I⊗Z) • S1⁻¹ • H1 • S1⁻¹ • X0 • Swap • X1 • CX1 • R (plus , I⊗Z) • CX1 • R (plus , I⊗Z) • S1⁻¹ • R (plus , Z⊗I) • S0 • H0 • R (plus , Z⊗I) • CX0 • T0⁻¹ • H0 • S0⁻¹ • T0⁻¹ • CX1 • CX0 • X0 • X0 • CX0 • CX1 • T0 • CH0 • T0⁻¹ • ε
          by in-context 35 1 auto lemma-R-T0⁻¹
      equals CX1 • CX0 • X0 • X0 • CX0 • CX1 • R (plus , I⊗Z) • CX1 • R (plus , I⊗Z) • S1⁻¹ • X1 • CX1 • Swap • X0 • S1 • H1 • R (plus , I⊗Z) • CX1 • R (plus , I⊗Z) • S1⁻¹ • H1 • S1⁻¹ • X0 • Swap • X1 • CX1 • R (plus , I⊗Z) • CX1 • R (plus , I⊗Z) • S1⁻¹ • R (plus , Z⊗I) • S0 • H0 • R (plus , Z⊗I) • CX0 • R (plus , Z⊗I) • S0⁻¹ • H0 • S0⁻¹ • T0⁻¹ • CX1 • CX0 • X0 • X0 • CX0 • CX1 • T0 • CH0 • T0⁻¹ • ε
          by in-context 39 1 auto lemma-R-T0⁻¹
      equals CX1 • CX0 • X0 • X0 • CX0 • CX1 • R (plus , I⊗Z) • CX1 • R (plus , I⊗Z) • S1⁻¹ • X1 • CX1 • Swap • X0 • S1 • H1 • R (plus , I⊗Z) • CX1 • R (plus , I⊗Z) • S1⁻¹ • H1 • S1⁻¹ • X0 • Swap • X1 • CX1 • R (plus , I⊗Z) • CX1 • R (plus , I⊗Z) • S1⁻¹ • R (plus , Z⊗I) • S0 • H0 • R (plus , Z⊗I) • CX0 • R (plus , Z⊗I) • S0⁻¹ • H0 • S0⁻¹ • R (plus , Z⊗I) • S0⁻¹ • CX1 • CX0 • X0 • X0 • CX0 • CX1 • T0 • CH0 • T0⁻¹ • ε
          by in-context 3 4 auto (lemma-R (C.X0 • C.CX0 • C.CX1) (plus , I⊗Z))
      equals CX1 • CX0 • X0 • R (minus , Z⊗I) • X0 • CX0 • CX1 • CX1 • R (plus , I⊗Z) • S1⁻¹ • X1 • CX1 • Swap • X0 • S1 • H1 • R (plus , I⊗Z) • CX1 • R (plus , I⊗Z) • S1⁻¹ • H1 • S1⁻¹ • X0 • Swap • X1 • CX1 • R (plus , I⊗Z) • CX1 • R (plus , I⊗Z) • S1⁻¹ • R (plus , Z⊗I) • S0 • H0 • R (plus , Z⊗I) • CX0 • R (plus , Z⊗I) • S0⁻¹ • H0 • S0⁻¹ • R (plus , Z⊗I) • S0⁻¹ • CX1 • CX0 • X0 • X0 • CX0 • CX1 • T0 • CH0 • T0⁻¹ • ε
          by in-context 4 5 auto (lemma-R (C.X0 • C.CX0 • C.CX1 • C.CX1) (plus , I⊗Z))
      equals CX1 • CX0 • X0 • R (minus , Z⊗I) • R (plus , I⊗Z) • X0 • CX0 • CX1 • CX1 • S1⁻¹ • X1 • CX1 • Swap • X0 • S1 • H1 • R (plus , I⊗Z) • CX1 • R (plus , I⊗Z) • S1⁻¹ • H1 • S1⁻¹ • X0 • Swap • X1 • CX1 • R (plus , I⊗Z) • CX1 • R (plus , I⊗Z) • S1⁻¹ • R (plus , Z⊗I) • S0 • H0 • R (plus , Z⊗I) • CX0 • R (plus , Z⊗I) • S0⁻¹ • H0 • S0⁻¹ • R (plus , Z⊗I) • S0⁻¹ • CX1 • CX0 • X0 • X0 • CX0 • CX1 • T0 • CH0 • T0⁻¹ • ε
          by in-context 5 12 auto (lemma-R (C.X0 • C.CX0 • C.CX1 • C.CX1 • C.S1⁻¹ • C.X1 • C.CX1 • C.Swap • C.X0 • C.S1 • C.H1) (plus , I⊗Z))
      equals CX1 • CX0 • X0 • R (minus , Z⊗I) • R (plus , I⊗Z) • R (minus , Z⊗X) • X0 • CX0 • CX1 • CX1 • S1⁻¹ • X1 • CX1 • Swap • X0 • S1 • H1 • CX1 • R (plus , I⊗Z) • S1⁻¹ • H1 • S1⁻¹ • X0 • Swap • X1 • CX1 • R (plus , I⊗Z) • CX1 • R (plus , I⊗Z) • S1⁻¹ • R (plus , Z⊗I) • S0 • H0 • R (plus , Z⊗I) • CX0 • R (plus , Z⊗I) • S0⁻¹ • H0 • S0⁻¹ • R (plus , Z⊗I) • S0⁻¹ • CX1 • CX0 • X0 • X0 • CX0 • CX1 • T0 • CH0 • T0⁻¹ • ε
          by clifford-tactic 6 12 10000 auto
      equals CX1 • CX0 • X0 • R (minus , Z⊗I) • R (plus , I⊗Z) • R (minus , Z⊗X) • H1 • CZ • S0 • H0 • S0 • S0 • H0 • S1 • S1 • W ^ 6 • R (plus , I⊗Z) • S1⁻¹ • H1 • S1⁻¹ • X0 • Swap • X1 • CX1 • R (plus , I⊗Z) • CX1 • R (plus , I⊗Z) • S1⁻¹ • R (plus , Z⊗I) • S0 • H0 • R (plus , Z⊗I) • CX0 • R (plus , Z⊗I) • S0⁻¹ • H0 • S0⁻¹ • R (plus , Z⊗I) • S0⁻¹ • CX1 • CX0 • X0 • X0 • CX0 • CX1 • T0 • CH0 • T0⁻¹ • ε
          by in-context 6 11 auto (lemma-R (C.H1 • C.CZ • C.S0 • C.H0 • C.S0 • C.S0 • C.H0 • C.S1 • C.S1 • C.W ^ 6) (plus , I⊗Z))
      equals CX1 • CX0 • X0 • R (minus , Z⊗I) • R (plus , I⊗Z) • R (minus , Z⊗X) • R (plus , I⊗X) • H1 • CZ • S0 • H0 • S0 • S0 • H0 • S1 • S1 • W ^ 6 • S1⁻¹ • H1 • S1⁻¹ • X0 • Swap • X1 • CX1 • R (plus , I⊗Z) • CX1 • R (plus , I⊗Z) • S1⁻¹ • R (plus , Z⊗I) • S0 • H0 • R (plus , Z⊗I) • CX0 • R (plus , Z⊗I) • S0⁻¹ • H0 • S0⁻¹ • R (plus , Z⊗I) • S0⁻¹ • CX1 • CX0 • X0 • X0 • CX0 • CX1 • T0 • CH0 • T0⁻¹ • ε
          by clifford-tactic 7 17 10000 auto
      equals CX1 • CX0 • X0 • R (minus , Z⊗I) • R (plus , I⊗Z) • R (minus , Z⊗X) • R (plus , I⊗X) • S0 • H0 • S1 • H1 • CZ • S0 • S0 • H0 • S0 • S0 • S0 • S1 • W ^ 5 • R (plus , I⊗Z) • CX1 • R (plus , I⊗Z) • S1⁻¹ • R (plus , Z⊗I) • S0 • H0 • R (plus , Z⊗I) • CX0 • R (plus , Z⊗I) • S0⁻¹ • H0 • S0⁻¹ • R (plus , Z⊗I) • S0⁻¹ • CX1 • CX0 • X0 • X0 • CX0 • CX1 • T0 • CH0 • T0⁻¹ • ε
          by in-context 7 14 auto (lemma-R (C.S0 • C.H0 • C.S1 • C.H1 • C.CZ • C.S0 • C.S0 • C.H0 • C.S0 • C.S0 • C.S0 • C.S1 • C.W ^ 5) (plus , I⊗Z))
      equals CX1 • CX0 • X0 • R (minus , Z⊗I) • R (plus , I⊗Z) • R (minus , Z⊗X) • R (plus , I⊗X) • R (plus , I⊗Y) • S0 • H0 • S1 • H1 • CZ • S0 • S0 • H0 • S0 • S0 • S0 • S1 • W ^ 5 • CX1 • R (plus , I⊗Z) • S1⁻¹ • R (plus , Z⊗I) • S0 • H0 • R (plus , Z⊗I) • CX0 • R (plus , Z⊗I) • S0⁻¹ • H0 • S0⁻¹ • R (plus , Z⊗I) • S0⁻¹ • CX1 • CX0 • X0 • X0 • CX0 • CX1 • T0 • CH0 • T0⁻¹ • ε
          by in-context 8 15 auto (lemma-R (C.S0 • C.H0 • C.S1 • C.H1 • C.CZ • C.S0 • C.S0 • C.H0 • C.S0 • C.S0 • C.S0 • C.S1 • C.W ^ 5 • C.CX1) (plus , I⊗Z))
      equals CX1 • CX0 • X0 • R (minus , Z⊗I) • R (plus , I⊗Z) • R (minus , Z⊗X) • R (plus , I⊗X) • R (plus , I⊗Y) • R (minus , Z⊗I) • S0 • H0 • S1 • H1 • CZ • S0 • S0 • H0 • S0 • S0 • S0 • S1 • W ^ 5 • CX1 • S1⁻¹ • R (plus , Z⊗I) • S0 • H0 • R (plus , Z⊗I) • CX0 • R (plus , Z⊗I) • S0⁻¹ • H0 • S0⁻¹ • R (plus , Z⊗I) • S0⁻¹ • CX1 • CX0 • X0 • X0 • CX0 • CX1 • T0 • CH0 • T0⁻¹ • ε
          by in-context 9 16 auto (lemma-R (C.S0 • C.H0 • C.S1 • C.H1 • C.CZ • C.S0 • C.S0 • C.H0 • C.S0 • C.S0 • C.S0 • C.S1 • C.W ^ 5 • C.CX1 • C.S1⁻¹) (plus , Z⊗I))
      equals CX1 • CX0 • X0 • R (minus , Z⊗I) • R (plus , I⊗Z) • R (minus , Z⊗X) • R (plus , I⊗X) • R (plus , I⊗Y) • R (minus , Z⊗I) • R (minus , Z⊗Y) • S0 • H0 • S1 • H1 • CZ • S0 • S0 • H0 • S0 • S0 • S0 • S1 • W ^ 5 • CX1 • S1⁻¹ • S0 • H0 • R (plus , Z⊗I) • CX0 • R (plus , Z⊗I) • S0⁻¹ • H0 • S0⁻¹ • R (plus , Z⊗I) • S0⁻¹ • CX1 • CX0 • X0 • X0 • CX0 • CX1 • T0 • CH0 • T0⁻¹ • ε
          by clifford-tactic 10 17 10000 auto
      equals CX1 • CX0 • X0 • R (minus , Z⊗I) • R (plus , I⊗Z) • R (minus , Z⊗X) • R (plus , I⊗X) • R (plus , I⊗Y) • R (minus , Z⊗I) • R (minus , Z⊗Y) • H1 • CZ • S0 • S0 • H0 • S0 • S0 • H0 • S1 • W ^ 4 • Swap • R (plus , Z⊗I) • CX0 • R (plus , Z⊗I) • S0⁻¹ • H0 • S0⁻¹ • R (plus , Z⊗I) • S0⁻¹ • CX1 • CX0 • X0 • X0 • CX0 • CX1 • T0 • CH0 • T0⁻¹ • ε
          by in-context 10 12 auto (lemma-R (C.H1 • C.CZ • C.S0 • C.S0 • C.H0 • C.S0 • C.S0 • C.H0 • C.S1 • C.W ^ 4 • C.Swap) (plus , Z⊗I))
      equals CX1 • CX0 • X0 • R (minus , Z⊗I) • R (plus , I⊗Z) • R (minus , Z⊗X) • R (plus , I⊗X) • R (plus , I⊗Y) • R (minus , Z⊗I) • R (minus , Z⊗Y) • R (plus , I⊗X) • H1 • CZ • S0 • S0 • H0 • S0 • S0 • H0 • S1 • W ^ 4 • Swap • CX0 • R (plus , Z⊗I) • S0⁻¹ • H0 • S0⁻¹ • R (plus , Z⊗I) • S0⁻¹ • CX1 • CX0 • X0 • X0 • CX0 • CX1 • T0 • CH0 • T0⁻¹ • ε
          by in-context 11 13 auto (lemma-R (C.H1 • C.CZ • C.S0 • C.S0 • C.H0 • C.S0 • C.S0 • C.H0 • C.S1 • C.W ^ 4 • C.Swap • C.CX0) (plus , Z⊗I))
      equals CX1 • CX0 • X0 • R (minus , Z⊗I) • R (plus , I⊗Z) • R (minus , Z⊗X) • R (plus , I⊗X) • R (plus , I⊗Y) • R (minus , Z⊗I) • R (minus , Z⊗Y) • R (plus , I⊗X) • R (minus , Z⊗X) • H1 • CZ • S0 • S0 • H0 • S0 • S0 • H0 • S1 • W ^ 4 • Swap • CX0 • S0⁻¹ • H0 • S0⁻¹ • R (plus , Z⊗I) • S0⁻¹ • CX1 • CX0 • X0 • X0 • CX0 • CX1 • T0 • CH0 • T0⁻¹ • ε
          by clifford-tactic 12 15 10000 auto
      equals CX1 • CX0 • X0 • R (minus , Z⊗I) • R (plus , I⊗Z) • R (minus , Z⊗X) • R (plus , I⊗X) • R (plus , I⊗Y) • R (minus , Z⊗I) • R (minus , Z⊗Y) • R (plus , I⊗X) • R (minus , Z⊗X) • CZ • S0 • H0 • S0 • S0 • H0 • H1 • S1 • S1 • H1 • S1 • W ^ 2 • Swap • R (plus , Z⊗I) • S0⁻¹ • CX1 • CX0 • X0 • X0 • CX0 • CX1 • T0 • CH0 • T0⁻¹ • ε
          by in-context 12 14 auto (lemma-R (C.CZ • C.S0 • C.H0 • C.S0 • C.S0 • C.H0 • C.H1 • C.S1 • C.S1 • C.H1 • C.S1 • C.W ^ 2 • C.Swap) (plus , Z⊗I))
      equals CX1 • CX0 • X0 • R (minus , Z⊗I) • R (plus , I⊗Z) • R (minus , Z⊗X) • R (plus , I⊗X) • R (plus , I⊗Y) • R (minus , Z⊗I) • R (minus , Z⊗Y) • R (plus , I⊗X) • R (minus , Z⊗X) • R (minus , I⊗Z) • CZ • S0 • H0 • S0 • S0 • H0 • H1 • S1 • S1 • H1 • S1 • W ^ 2 • Swap • S0⁻¹ • CX1 • CX0 • X0 • X0 • CX0 • CX1 • T0 • CH0 • T0⁻¹ • ε
          by clifford-tactic 13 17 10000 auto
      equals CX1 • CX0 • X0 • R (minus , Z⊗I) • R (plus , I⊗Z) • R (minus , Z⊗X) • R (plus , I⊗X) • R (plus , I⊗Y) • R (minus , Z⊗I) • R (minus , Z⊗Y) • R (plus , I⊗X) • R (minus , Z⊗X) • R (minus , I⊗Z) • S1 • H1 • CZ • S0 • S0 • H1 • S1 • S1 • S1 • W ^ 2 • X0 • CX0 • CX1 • T0 • CH0 • T0⁻¹ • ε
          by in-context 3 2 auto (symm (tactic-pauli-commute (plus , I⊗Z) (minus , Z⊗I) auto))
      equals CX1 • CX0 • X0 • R (plus , I⊗Z) • R (minus , Z⊗I) • R (minus , Z⊗X) • R (plus , I⊗X) • R (plus , I⊗Y) • R (minus , Z⊗I) • R (minus , Z⊗Y) • R (plus , I⊗X) • R (minus , Z⊗X) • R (minus , I⊗Z) • S1 • H1 • CZ • S0 • S0 • H1 • S1 • S1 • S1 • W ^ 2 • X0 • CX0 • CX1 • T0 • CH0 • T0⁻¹ • ε
          by in-context 5 2 auto (symm (tactic-pauli-commute (plus , I⊗X) (minus , Z⊗X) auto))
      equals CX1 • CX0 • X0 • R (plus , I⊗Z) • R (minus , Z⊗I) • R (plus , I⊗X) • R (minus , Z⊗X) • R (plus , I⊗Y) • R (minus , Z⊗I) • R (minus , Z⊗Y) • R (plus , I⊗X) • R (minus , Z⊗X) • R (minus , I⊗Z) • S1 • H1 • CZ • S0 • S0 • H1 • S1 • S1 • S1 • W ^ 2 • X0 • CX0 • CX1 • T0 • CH0 • T0⁻¹ • ε
          by in-context 4 2 auto (symm (tactic-pauli-commute (plus , I⊗X) (minus , Z⊗I) auto))
      equals CX1 • CX0 • X0 • R (plus , I⊗Z) • R (plus , I⊗X) • R (minus , Z⊗I) • R (minus , Z⊗X) • R (plus , I⊗Y) • R (minus , Z⊗I) • R (minus , Z⊗Y) • R (plus , I⊗X) • R (minus , Z⊗X) • R (minus , I⊗Z) • S1 • H1 • CZ • S0 • S0 • H1 • S1 • S1 • S1 • W ^ 2 • X0 • CX0 • CX1 • T0 • CH0 • T0⁻¹ • ε
          by in-context 7 2 auto (symm (tactic-pauli-commute (minus , Z⊗I) (plus , I⊗Y) auto))
      equals CX1 • CX0 • X0 • R (plus , I⊗Z) • R (plus , I⊗X) • R (minus , Z⊗I) • R (minus , Z⊗X) • R (minus , Z⊗I) • R (plus , I⊗Y) • R (minus , Z⊗Y) • R (plus , I⊗X) • R (minus , Z⊗X) • R (minus , I⊗Z) • S1 • H1 • CZ • S0 • S0 • H1 • S1 • S1 • S1 • W ^ 2 • X0 • CX0 • CX1 • T0 • CH0 • T0⁻¹ • ε
          by in-context 6 2 auto (symm (tactic-pauli-commute (minus , Z⊗I) (minus , Z⊗X) auto))
      equals CX1 • CX0 • X0 • R (plus , I⊗Z) • R (plus , I⊗X) • R (minus , Z⊗I) • R (minus , Z⊗I) • R (minus , Z⊗X) • R (plus , I⊗Y) • R (minus , Z⊗Y) • R (plus , I⊗X) • R (minus , Z⊗X) • R (minus , I⊗Z) • S1 • H1 • CZ • S0 • S0 • H1 • S1 • S1 • S1 • W ^ 2 • X0 • CX0 • CX1 • T0 • CH0 • T0⁻¹ • ε
          by in-context 5 2 auto (lemma-combine minus minus Z⊗I)
      equals CX1 • CX0 • X0 • R (plus , I⊗Z) • R (plus , I⊗X) • S0⁻¹ • W ^ 2 • R (minus , Z⊗X) • R (plus , I⊗Y) • R (minus , Z⊗Y) • R (plus , I⊗X) • R (minus , Z⊗X) • R (minus , I⊗Z) • S1 • H1 • CZ • S0 • S0 • H1 • S1 • S1 • S1 • W ^ 2 • X0 • CX0 • CX1 • T0 • CH0 • T0⁻¹ • ε
          by in-context 5 3 auto (lemma-R (C.S0⁻¹ • C.W ^ 2) (minus , Z⊗X))
      equals CX1 • CX0 • X0 • R (plus , I⊗Z) • R (plus , I⊗X) • R (minus , Z⊗X) • S0⁻¹ • W ^ 2 • R (plus , I⊗Y) • R (minus , Z⊗Y) • R (plus , I⊗X) • R (minus , Z⊗X) • R (minus , I⊗Z) • S1 • H1 • CZ • S0 • S0 • H1 • S1 • S1 • S1 • W ^ 2 • X0 • CX0 • CX1 • T0 • CH0 • T0⁻¹ • ε
          by in-context 6 3 auto (lemma-R (C.S0⁻¹ • C.W ^ 2) (plus , I⊗Y))
      equals CX1 • CX0 • X0 • R (plus , I⊗Z) • R (plus , I⊗X) • R (minus , Z⊗X) • R (plus , I⊗Y) • S0⁻¹ • W ^ 2 • R (minus , Z⊗Y) • R (plus , I⊗X) • R (minus , Z⊗X) • R (minus , I⊗Z) • S1 • H1 • CZ • S0 • S0 • H1 • S1 • S1 • S1 • W ^ 2 • X0 • CX0 • CX1 • T0 • CH0 • T0⁻¹ • ε
          by in-context 7 3 auto (lemma-R (C.S0⁻¹ • C.W ^ 2) (minus , Z⊗Y))
      equals CX1 • CX0 • X0 • R (plus , I⊗Z) • R (plus , I⊗X) • R (minus , Z⊗X) • R (plus , I⊗Y) • R (minus , Z⊗Y) • S0⁻¹ • W ^ 2 • R (plus , I⊗X) • R (minus , Z⊗X) • R (minus , I⊗Z) • S1 • H1 • CZ • S0 • S0 • H1 • S1 • S1 • S1 • W ^ 2 • X0 • CX0 • CX1 • T0 • CH0 • T0⁻¹ • ε
          by in-context 8 3 auto (lemma-R (C.S0⁻¹ • C.W ^ 2) (plus , I⊗X))
      equals CX1 • CX0 • X0 • R (plus , I⊗Z) • R (plus , I⊗X) • R (minus , Z⊗X) • R (plus , I⊗Y) • R (minus , Z⊗Y) • R (plus , I⊗X) • S0⁻¹ • W ^ 2 • R (minus , Z⊗X) • R (minus , I⊗Z) • S1 • H1 • CZ • S0 • S0 • H1 • S1 • S1 • S1 • W ^ 2 • X0 • CX0 • CX1 • T0 • CH0 • T0⁻¹ • ε
          by in-context 9 3 auto (lemma-R (C.S0⁻¹ • C.W ^ 2) (minus , Z⊗X))
      equals CX1 • CX0 • X0 • R (plus , I⊗Z) • R (plus , I⊗X) • R (minus , Z⊗X) • R (plus , I⊗Y) • R (minus , Z⊗Y) • R (plus , I⊗X) • R (minus , Z⊗X) • S0⁻¹ • W ^ 2 • R (minus , I⊗Z) • S1 • H1 • CZ • S0 • S0 • H1 • S1 • S1 • S1 • W ^ 2 • X0 • CX0 • CX1 • T0 • CH0 • T0⁻¹ • ε
          by in-context 10 3 auto (lemma-R (C.S0⁻¹ • C.W ^ 2) (minus , I⊗Z))
      equals CX1 • CX0 • X0 • R (plus , I⊗Z) • R (plus , I⊗X) • R (minus , Z⊗X) • R (plus , I⊗Y) • R (minus , Z⊗Y) • R (plus , I⊗X) • R (minus , Z⊗X) • R (minus , I⊗Z) • S0⁻¹ • W ^ 2 • S1 • H1 • CZ • S0 • S0 • H1 • S1 • S1 • S1 • W ^ 2 • X0 • CX0 • CX1 • T0 • CH0 • T0⁻¹ • ε
          by clifford-tactic 11 12 10000 auto
      equals CX1 • CX0 • X0 • R (plus , I⊗Z) • R (plus , I⊗X) • R (minus , Z⊗X) • R (plus , I⊗Y) • R (minus , Z⊗Y) • R (plus , I⊗X) • R (minus , Z⊗X) • R (minus , I⊗Z) • S1 • H1 • CZ • S0 • H1 • S1 • S1 • S1 • W ^ 4 • X0 • CX0 • CX1 • T0 • CH0 • T0⁻¹ • ε
          by in-context 5 1 auto (lemma-correction Z⊗X)
      equals CX1 • CX0 • X0 • R (plus , I⊗Z) • R (plus , I⊗X) • R (plus , Z⊗X) • H1 • H0 • CZ • H0 • S0⁻¹ • W • H0 • CZ • H0 • H1 • R (plus , I⊗Y) • R (minus , Z⊗Y) • R (plus , I⊗X) • R (minus , Z⊗X) • R (minus , I⊗Z) • S1 • H1 • CZ • S0 • H1 • S1 • S1 • S1 • W ^ 4 • X0 • CX0 • CX1 • T0 • CH0 • T0⁻¹ • ε
          by in-context 6 11 auto (lemma-R (C.H1 • C.H0 • C.CZ • C.H0 • C.S0⁻¹ • C.W • C.H0 • C.CZ • C.H0 • C.H1) (plus , I⊗Y))
      equals CX1 • CX0 • X0 • R (plus , I⊗Z) • R (plus , I⊗X) • R (plus , Z⊗X) • R (minus , Z⊗Z) • H1 • H0 • CZ • H0 • S0⁻¹ • W • H0 • CZ • H0 • H1 • R (minus , Z⊗Y) • R (plus , I⊗X) • R (minus , Z⊗X) • R (minus , I⊗Z) • S1 • H1 • CZ • S0 • H1 • S1 • S1 • S1 • W ^ 4 • X0 • CX0 • CX1 • T0 • CH0 • T0⁻¹ • ε
          by in-context 6 1 auto (lemma-correction Z⊗Z)
      equals CX1 • CX0 • X0 • R (plus , I⊗Z) • R (plus , I⊗X) • R (plus , Z⊗X) • R (plus , Z⊗Z) • H0 • CZ • H0 • S0⁻¹ • W • H0 • CZ • H0 • H1 • H0 • CZ • H0 • S0⁻¹ • W • H0 • CZ • H0 • H1 • R (minus , Z⊗Y) • R (plus , I⊗X) • R (minus , Z⊗X) • R (minus , I⊗Z) • S1 • H1 • CZ • S0 • H1 • S1 • S1 • S1 • W ^ 4 • X0 • CX0 • CX1 • T0 • CH0 • T0⁻¹ • ε
          by clifford-tactic 7 18 10000 auto
      equals CX1 • CX0 • X0 • R (plus , I⊗Z) • R (plus , I⊗X) • R (plus , Z⊗X) • R (plus , Z⊗Z) • H1 • CZ • S0 • S0 • S0 • S1 • W • R (minus , Z⊗Y) • R (plus , I⊗X) • R (minus , Z⊗X) • R (minus , I⊗Z) • S1 • H1 • CZ • S0 • H1 • S1 • S1 • S1 • W ^ 4 • X0 • CX0 • CX1 • T0 • CH0 • T0⁻¹ • ε
          by in-context 7 8 auto (lemma-R (C.H1 • C.CZ • C.S0 • C.S0 • C.S0 • C.S1 • C.W) (minus , Z⊗Y))
      equals CX1 • CX0 • X0 • R (plus , I⊗Z) • R (plus , I⊗X) • R (plus , Z⊗X) • R (plus , Z⊗Z) • R (plus , I⊗Z) • H1 • CZ • S0 • S0 • S0 • S1 • W • R (plus , I⊗X) • R (minus , Z⊗X) • R (minus , I⊗Z) • S1 • H1 • CZ • S0 • H1 • S1 • S1 • S1 • W ^ 4 • X0 • CX0 • CX1 • T0 • CH0 • T0⁻¹ • ε
          by in-context 8 8 auto (lemma-R (C.H1 • C.CZ • C.S0 • C.S0 • C.S0 • C.S1 • C.W) (plus , I⊗X))
      equals CX1 • CX0 • X0 • R (plus , I⊗Z) • R (plus , I⊗X) • R (plus , Z⊗X) • R (plus , Z⊗Z) • R (plus , I⊗Z) • R (minus , Z⊗Y) • H1 • CZ • S0 • S0 • S0 • S1 • W • R (minus , Z⊗X) • R (minus , I⊗Z) • S1 • H1 • CZ • S0 • H1 • S1 • S1 • S1 • W ^ 4 • X0 • CX0 • CX1 • T0 • CH0 • T0⁻¹ • ε
          by in-context 8 1 auto (lemma-correction Z⊗Y)
      equals CX1 • CX0 • X0 • R (plus , I⊗Z) • R (plus , I⊗X) • R (plus , Z⊗X) • R (plus , Z⊗Z) • R (plus , I⊗Z) • R (plus , Z⊗Y) • S1 • H1 • H0 • CZ • H0 • S0⁻¹ • W • H0 • CZ • H0 • H1 • S1⁻¹ • H1 • CZ • S0 • S0 • S0 • S1 • W • R (minus , Z⊗X) • R (minus , I⊗Z) • S1 • H1 • CZ • S0 • H1 • S1 • S1 • S1 • W ^ 4 • X0 • CX0 • CX1 • T0 • CH0 • T0⁻¹ • ε
          by clifford-tactic 9 17 10000 auto
      equals CX1 • CX0 • X0 • R (plus , I⊗Z) • R (plus , I⊗X) • R (plus , Z⊗X) • R (plus , Z⊗Z) • R (plus , I⊗Z) • R (plus , Z⊗Y) • H1 • CZ • S0 • S0 • S0 • H1 • S1 • S1 • S1 • W • R (minus , Z⊗X) • R (minus , I⊗Z) • S1 • H1 • CZ • S0 • H1 • S1 • S1 • S1 • W ^ 4 • X0 • CX0 • CX1 • T0 • CH0 • T0⁻¹ • ε
          by in-context 9 11 auto (lemma-R (C.H1 • C.CZ • C.S0 • C.S0 • C.S0 • C.H1 • C.S1 • C.S1 • C.S1 • C.W) (minus , Z⊗X))
      equals CX1 • CX0 • X0 • R (plus , I⊗Z) • R (plus , I⊗X) • R (plus , Z⊗X) • R (plus , Z⊗Z) • R (plus , I⊗Z) • R (plus , Z⊗Y) • R (plus , I⊗Y) • H1 • CZ • S0 • S0 • S0 • H1 • S1 • S1 • S1 • W • R (minus , I⊗Z) • S1 • H1 • CZ • S0 • H1 • S1 • S1 • S1 • W ^ 4 • X0 • CX0 • CX1 • T0 • CH0 • T0⁻¹ • ε
          by in-context 10 11 auto (lemma-R (C.H1 • C.CZ • C.S0 • C.S0 • C.S0 • C.H1 • C.S1 • C.S1 • C.S1 • C.W) (minus , I⊗Z))
      equals CX1 • CX0 • X0 • R (plus , I⊗Z) • R (plus , I⊗X) • R (plus , Z⊗X) • R (plus , Z⊗Z) • R (plus , I⊗Z) • R (plus , Z⊗Y) • R (plus , I⊗Y) • R (minus , Z⊗Z) • H1 • CZ • S0 • S0 • S0 • H1 • S1 • S1 • S1 • W • S1 • H1 • CZ • S0 • H1 • S1 • S1 • S1 • W ^ 4 • X0 • CX0 • CX1 • T0 • CH0 • T0⁻¹ • ε
          by in-context 10 1 auto (lemma-correction Z⊗Z)
      equals CX1 • CX0 • X0 • R (plus , I⊗Z) • R (plus , I⊗X) • R (plus , Z⊗X) • R (plus , Z⊗Z) • R (plus , I⊗Z) • R (plus , Z⊗Y) • R (plus , I⊗Y) • R (plus , Z⊗Z) • H0 • CZ • H0 • S0⁻¹ • W • H0 • CZ • H0 • H1 • CZ • S0 • S0 • S0 • H1 • S1 • S1 • S1 • W • S1 • H1 • CZ • S0 • H1 • S1 • S1 • S1 • W ^ 4 • X0 • CX0 • CX1 • T0 • CH0 • T0⁻¹ • ε
          by clifford-tactic 11 27 10000 auto
      equals CX1 • CX0 • X0 • R (plus , I⊗Z) • R (plus , I⊗X) • R (plus , Z⊗X) • R (plus , Z⊗Z) • R (plus , I⊗Z) • R (plus , Z⊗Y) • R (plus , I⊗Y) • R (plus , Z⊗Z) • CZ • S0 • S0 • S0 • S1 • S1 • W ^ 6 • X0 • CX0 • CX1 • T0 • CH0 • T0⁻¹ • ε
          by in-context 6 2 auto (symm (tactic-pauli-commute (plus , I⊗Z) (plus , Z⊗Z) auto))
      equals CX1 • CX0 • X0 • R (plus , I⊗Z) • R (plus , I⊗X) • R (plus , Z⊗X) • R (plus , I⊗Z) • R (plus , Z⊗Z) • R (plus , Z⊗Y) • R (plus , I⊗Y) • R (plus , Z⊗Z) • CZ • S0 • S0 • S0 • S1 • S1 • W ^ 6 • X0 • CX0 • CX1 • T0 • CH0 • T0⁻¹ • ε
          by in-context 8 2 auto (symm (tactic-pauli-commute (plus , I⊗Y) (plus , Z⊗Y) auto))
      equals CX1 • CX0 • X0 • R (plus , I⊗Z) • R (plus , I⊗X) • R (plus , Z⊗X) • R (plus , I⊗Z) • R (plus , Z⊗Z) • R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , Z⊗Z) • CZ • S0 • S0 • S0 • S1 • S1 • W ^ 6 • X0 • CX0 • CX1 • T0 • CH0 • T0⁻¹ • ε
          by in-context 6 2 auto (tactic-pauli-commute (plus , I⊗Z) (plus , Z⊗Z) auto)
      equals CX1 • CX0 • X0 • R (plus , I⊗Z) • R (plus , I⊗X) • R (plus , Z⊗X) • R (plus , Z⊗Z) • R (plus , I⊗Z) • R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , Z⊗Z) • CZ • S0 • S0 • S0 • S1 • S1 • W ^ 6 • X0 • CX0 • CX1 • T0 • CH0 • T0⁻¹ • ε
          by clifford-tactic 11 7 10000 auto
      equals CX1 • CX0 • X0 • R (plus , I⊗Z) • R (plus , I⊗X) • R (plus , Z⊗X) • R (plus , Z⊗Z) • R (plus , I⊗Z) • R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , Z⊗Z) • S1 • H1 • CZ • S0 • S1 • S1 • H1 • S1 • S1 • H1 • W ^ 5 • S0 • S1 • S1 • W ^ 5 • H1 • S1⁻¹ • CX1 • X0 • CX0 • CX1 • T0 • CH0 • T0⁻¹ • ε
          by in-context 10 12 auto (symm (lemma-R (C.S1 • C.H1 • C.CZ • C.S0 • C.S1 • C.S1 • C.H1 • C.S1 • C.S1 • C.H1 • C.W ^ 5) (minus , I⊗X)))
      equals CX1 • CX0 • X0 • R (plus , I⊗Z) • R (plus , I⊗X) • R (plus , Z⊗X) • R (plus , Z⊗Z) • R (plus , I⊗Z) • R (plus , I⊗Y) • R (plus , Z⊗Y) • S1 • H1 • CZ • S0 • S1 • S1 • H1 • S1 • S1 • H1 • W ^ 5 • R (minus , I⊗X) • S0 • S1 • S1 • W ^ 5 • H1 • S1⁻¹ • CX1 • X0 • CX0 • CX1 • T0 • CH0 • T0⁻¹ • ε
          by in-context 9 12 auto (symm (lemma-R (C.S1 • C.H1 • C.CZ • C.S0 • C.S1 • C.S1 • C.H1 • C.S1 • C.S1 • C.H1 • C.W ^ 5) (minus , Z⊗Z)))
      equals CX1 • CX0 • X0 • R (plus , I⊗Z) • R (plus , I⊗X) • R (plus , Z⊗X) • R (plus , Z⊗Z) • R (plus , I⊗Z) • R (plus , I⊗Y) • S1 • H1 • CZ • S0 • S1 • S1 • H1 • S1 • S1 • H1 • W ^ 5 • R (minus , Z⊗Z) • R (minus , I⊗X) • S0 • S1 • S1 • W ^ 5 • H1 • S1⁻¹ • CX1 • X0 • CX0 • CX1 • T0 • CH0 • T0⁻¹ • ε
          by clifford-tactic 11 9 10000 auto
      equals CX1 • CX0 • X0 • R (plus , I⊗Z) • R (plus , I⊗X) • R (plus , Z⊗X) • R (plus , Z⊗Z) • R (plus , I⊗Z) • R (plus , I⊗Y) • S1 • H1 • Swap • S0⁻¹ • W • Swap • H1 • S1⁻¹ • S1 • H1 • CZ • S0 • H1 • S1 • S1 • H1 • S1 • W ^ 2 • R (minus , Z⊗Z) • R (minus , I⊗X) • S0 • S1 • S1 • W ^ 5 • H1 • S1⁻¹ • CX1 • X0 • CX0 • CX1 • T0 • CH0 • T0⁻¹ • ε
          by in-context 8 9 auto (symm (lemma-correction I⊗Y))
      equals CX1 • CX0 • X0 • R (plus , I⊗Z) • R (plus , I⊗X) • R (plus , Z⊗X) • R (plus , Z⊗Z) • R (plus , I⊗Z) • R (minus , I⊗Y) • S1 • H1 • CZ • S0 • H1 • S1 • S1 • H1 • S1 • W ^ 2 • R (minus , Z⊗Z) • R (minus , I⊗X) • S0 • S1 • S1 • W ^ 5 • H1 • S1⁻¹ • CX1 • X0 • CX0 • CX1 • T0 • CH0 • T0⁻¹ • ε
          by in-context 8 11 auto (symm (lemma-R (C.S1 • C.H1 • C.CZ • C.S0 • C.H1 • C.S1 • C.S1 • C.H1 • C.S1 • C.W ^ 2) (plus , I⊗Z)))
      equals CX1 • CX0 • X0 • R (plus , I⊗Z) • R (plus , I⊗X) • R (plus , Z⊗X) • R (plus , Z⊗Z) • R (plus , I⊗Z) • S1 • H1 • CZ • S0 • H1 • S1 • S1 • H1 • S1 • W ^ 2 • R (plus , I⊗Z) • R (minus , Z⊗Z) • R (minus , I⊗X) • S0 • S1 • S1 • W ^ 5 • H1 • S1⁻¹ • CX1 • X0 • CX0 • CX1 • T0 • CH0 • T0⁻¹ • ε
          by clifford-tactic 8 10 10000 auto
      equals CX1 • CX0 • X0 • R (plus , I⊗Z) • R (plus , I⊗X) • R (plus , Z⊗X) • R (plus , Z⊗Z) • R (plus , I⊗Z) • Swap • S0⁻¹ • W • Swap • H1 • CZ • S0 • S0 • S0 • S1 • W • R (plus , I⊗Z) • R (minus , Z⊗Z) • R (minus , I⊗X) • S0 • S1 • S1 • W ^ 5 • H1 • S1⁻¹ • CX1 • X0 • CX0 • CX1 • T0 • CH0 • T0⁻¹ • ε
          by in-context 7 5 auto (symm (lemma-correction I⊗Z))
      equals CX1 • CX0 • X0 • R (plus , I⊗Z) • R (plus , I⊗X) • R (plus , Z⊗X) • R (plus , Z⊗Z) • R (minus , I⊗Z) • H1 • CZ • S0 • S0 • S0 • S1 • W • R (plus , I⊗Z) • R (minus , Z⊗Z) • R (minus , I⊗X) • S0 • S1 • S1 • W ^ 5 • H1 • S1⁻¹ • CX1 • X0 • CX0 • CX1 • T0 • CH0 • T0⁻¹ • ε
          by in-context 7 8 auto (symm (lemma-R (C.H1 • C.CZ • C.S0 • C.S0 • C.S0 • C.S1 • C.W) (plus , Z⊗Y)))
      equals CX1 • CX0 • X0 • R (plus , I⊗Z) • R (plus , I⊗X) • R (plus , Z⊗X) • R (plus , Z⊗Z) • H1 • CZ • S0 • S0 • S0 • S1 • W • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (minus , Z⊗Z) • R (minus , I⊗X) • S0 • S1 • S1 • W ^ 5 • H1 • S1⁻¹ • CX1 • X0 • CX0 • CX1 • T0 • CH0 • T0⁻¹ • ε
          by clifford-tactic 7 7 10000 auto
      equals CX1 • CX0 • X0 • R (plus , I⊗Z) • R (plus , I⊗X) • R (plus , Z⊗X) • R (plus , Z⊗Z) • H0 • CZ • H0 • S0⁻¹ • W • H0 • CZ • H0 • H1 • H0 • CZ • H0 • S0⁻¹ • W • H0 • CZ • H0 • H1 • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (minus , Z⊗Z) • R (minus , I⊗X) • S0 • S1 • S1 • W ^ 5 • H1 • S1⁻¹ • CX1 • X0 • CX0 • CX1 • T0 • CH0 • T0⁻¹ • ε
          by in-context 6 9 auto (symm (lemma-correction Z⊗Z))
      equals CX1 • CX0 • X0 • R (plus , I⊗Z) • R (plus , I⊗X) • R (plus , Z⊗X) • R (minus , Z⊗Z) • H1 • H0 • CZ • H0 • S0⁻¹ • W • H0 • CZ • H0 • H1 • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (minus , Z⊗Z) • R (minus , I⊗X) • S0 • S1 • S1 • W ^ 5 • H1 • S1⁻¹ • CX1 • X0 • CX0 • CX1 • T0 • CH0 • T0⁻¹ • ε
          by in-context 6 11 auto (symm (lemma-R (C.H1 • C.H0 • C.CZ • C.H0 • C.S0⁻¹ • C.W • C.H0 • C.CZ • C.H0 • C.H1) (plus , I⊗Y)))
      equals CX1 • CX0 • X0 • R (plus , I⊗Z) • R (plus , I⊗X) • R (plus , Z⊗X) • H1 • H0 • CZ • H0 • S0⁻¹ • W • H0 • CZ • H0 • H1 • R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (minus , Z⊗Z) • R (minus , I⊗X) • S0 • S1 • S1 • W ^ 5 • H1 • S1⁻¹ • CX1 • X0 • CX0 • CX1 • T0 • CH0 • T0⁻¹ • ε
          by in-context 5 11 auto (symm (lemma-correction Z⊗X))
      equals CX1 • CX0 • X0 • R (plus , I⊗Z) • R (plus , I⊗X) • R (minus , Z⊗X) • R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (minus , Z⊗Z) • R (minus , I⊗X) • S0 • S1 • S1 • W ^ 5 • H1 • S1⁻¹ • CX1 • X0 • CX0 • CX1 • T0 • CH0 • T0⁻¹ • ε
          by in-context 8 2 auto (tactic-pauli-commute (plus , I⊗Z) (minus , Z⊗Z) auto)
      equals CX1 • CX0 • X0 • R (plus , I⊗Z) • R (plus , I⊗X) • R (minus , Z⊗X) • R (plus , I⊗Y) • R (plus , Z⊗Y) • R (minus , Z⊗Z) • R (plus , I⊗Z) • R (minus , I⊗X) • S0 • S1 • S1 • W ^ 5 • H1 • S1⁻¹ • CX1 • X0 • CX0 • CX1 • T0 • CH0 • T0⁻¹ • ε
          by in-context 10 6 auto (symm (lemma-R (C.S0 • C.S1 • C.S1 • C.W ^ 5 • C.H1) (plus , I⊗Z)))
      equals CX1 • CX0 • X0 • R (plus , I⊗Z) • R (plus , I⊗X) • R (minus , Z⊗X) • R (plus , I⊗Y) • R (plus , Z⊗Y) • R (minus , Z⊗Z) • R (plus , I⊗Z) • S0 • S1 • S1 • W ^ 5 • H1 • R (plus , I⊗Z) • S1⁻¹ • CX1 • X0 • CX0 • CX1 • T0 • CH0 • T0⁻¹ • ε
          by in-context 9 5 auto (symm (lemma-R (C.S0 • C.S1 • C.S1 • C.W ^ 5) (plus , I⊗Z)))
      equals CX1 • CX0 • X0 • R (plus , I⊗Z) • R (plus , I⊗X) • R (minus , Z⊗X) • R (plus , I⊗Y) • R (plus , Z⊗Y) • R (minus , Z⊗Z) • S0 • S1 • S1 • W ^ 5 • R (plus , I⊗Z) • H1 • R (plus , I⊗Z) • S1⁻¹ • CX1 • X0 • CX0 • CX1 • T0 • CH0 • T0⁻¹ • ε
          by clifford-tactic 9 4 10000 auto
      equals CX1 • CX0 • X0 • R (plus , I⊗Z) • R (plus , I⊗X) • R (minus , Z⊗X) • R (plus , I⊗Y) • R (plus , Z⊗Y) • R (minus , Z⊗Z) • H1 • S1⁻¹ • CX1 • X1 • H1 • S1⁻¹ • CX1 • H1 • S1⁻¹ • CX1 • X1 • R (plus , I⊗Z) • H1 • R (plus , I⊗Z) • S1⁻¹ • CX1 • X0 • CX0 • CX1 • T0 • CH0 • T0⁻¹ • ε
          by in-context 8 9 auto (symm (lemma-R (C.H1 • C.S1⁻¹ • C.CX1 • C.X1 • C.H1 • C.S1⁻¹ • C.CX1 • C.H1) (plus , I⊗Z)))
      equals CX1 • CX0 • X0 • R (plus , I⊗Z) • R (plus , I⊗X) • R (minus , Z⊗X) • R (plus , I⊗Y) • R (plus , Z⊗Y) • H1 • S1⁻¹ • CX1 • X1 • H1 • S1⁻¹ • CX1 • H1 • R (plus , I⊗Z) • S1⁻¹ • CX1 • X1 • R (plus , I⊗Z) • H1 • R (plus , I⊗Z) • S1⁻¹ • CX1 • X0 • CX0 • CX1 • T0 • CH0 • T0⁻¹ • ε
          by in-context 7 8 auto (symm (lemma-R (C.H1 • C.S1⁻¹ • C.CX1 • C.X1 • C.H1 • C.S1⁻¹ • C.CX1) (plus , I⊗Z)))
      equals CX1 • CX0 • X0 • R (plus , I⊗Z) • R (plus , I⊗X) • R (minus , Z⊗X) • R (plus , I⊗Y) • H1 • S1⁻¹ • CX1 • X1 • H1 • S1⁻¹ • CX1 • R (plus , I⊗Z) • H1 • R (plus , I⊗Z) • S1⁻¹ • CX1 • X1 • R (plus , I⊗Z) • H1 • R (plus , I⊗Z) • S1⁻¹ • CX1 • X0 • CX0 • CX1 • T0 • CH0 • T0⁻¹ • ε
          by in-context 6 6 auto (symm (lemma-R (C.H1 • C.S1⁻¹ • C.CX1 • C.X1 • C.H1) (plus , I⊗Z)))
      equals CX1 • CX0 • X0 • R (plus , I⊗Z) • R (plus , I⊗X) • R (minus , Z⊗X) • H1 • S1⁻¹ • CX1 • X1 • H1 • R (plus , I⊗Z) • S1⁻¹ • CX1 • R (plus , I⊗Z) • H1 • R (plus , I⊗Z) • S1⁻¹ • CX1 • X1 • R (plus , I⊗Z) • H1 • R (plus , I⊗Z) • S1⁻¹ • CX1 • X0 • CX0 • CX1 • T0 • CH0 • T0⁻¹ • ε
          by in-context 5 5 auto (symm (lemma-R (C.H1 • C.S1⁻¹ • C.CX1 • C.X1) (plus , I⊗Z)))
      equals CX1 • CX0 • X0 • R (plus , I⊗Z) • R (plus , I⊗X) • H1 • S1⁻¹ • CX1 • X1 • R (plus , I⊗Z) • H1 • R (plus , I⊗Z) • S1⁻¹ • CX1 • R (plus , I⊗Z) • H1 • R (plus , I⊗Z) • S1⁻¹ • CX1 • X1 • R (plus , I⊗Z) • H1 • R (plus , I⊗Z) • S1⁻¹ • CX1 • X0 • CX0 • CX1 • T0 • CH0 • T0⁻¹ • ε
          by in-context 4 2 auto (symm (lemma-R (C.H1) (plus , I⊗Z)))
      equals CX1 • CX0 • X0 • R (plus , I⊗Z) • H1 • R (plus , I⊗Z) • S1⁻¹ • CX1 • X1 • R (plus , I⊗Z) • H1 • R (plus , I⊗Z) • S1⁻¹ • CX1 • R (plus , I⊗Z) • H1 • R (plus , I⊗Z) • S1⁻¹ • CX1 • X1 • R (plus , I⊗Z) • H1 • R (plus , I⊗Z) • S1⁻¹ • CX1 • X0 • CX0 • CX1 • T0 • CH0 • T0⁻¹ • ε
          by in-context 22 2 auto (symm lemma-R-T1⁻¹)
      equals CX1 • CX0 • X0 • R (plus , I⊗Z) • H1 • R (plus , I⊗Z) • S1⁻¹ • CX1 • X1 • R (plus , I⊗Z) • H1 • R (plus , I⊗Z) • S1⁻¹ • CX1 • R (plus , I⊗Z) • H1 • R (plus , I⊗Z) • S1⁻¹ • CX1 • X1 • R (plus , I⊗Z) • H1 • T1⁻¹ • CX1 • X0 • CX0 • CX1 • T0 • CH0 • T0⁻¹ • ε
          by in-context 20 1 auto (symm lemma-R-T1)
      equals CX1 • CX0 • X0 • R (plus , I⊗Z) • H1 • R (plus , I⊗Z) • S1⁻¹ • CX1 • X1 • R (plus , I⊗Z) • H1 • R (plus , I⊗Z) • S1⁻¹ • CX1 • R (plus , I⊗Z) • H1 • R (plus , I⊗Z) • S1⁻¹ • CX1 • X1 • T1 • H1 • T1⁻¹ • CX1 • X0 • CX0 • CX1 • T0 • CH0 • T0⁻¹ • ε
          by in-context 16 2 auto (symm lemma-R-T1⁻¹)
      equals CX1 • CX0 • X0 • R (plus , I⊗Z) • H1 • R (plus , I⊗Z) • S1⁻¹ • CX1 • X1 • R (plus , I⊗Z) • H1 • R (plus , I⊗Z) • S1⁻¹ • CX1 • R (plus , I⊗Z) • H1 • T1⁻¹ • CX1 • X1 • T1 • H1 • T1⁻¹ • CX1 • X0 • CX0 • CX1 • T0 • CH0 • T0⁻¹ • ε
          by in-context 14 1 auto (symm lemma-R-T1)
      equals CX1 • CX0 • X0 • R (plus , I⊗Z) • H1 • R (plus , I⊗Z) • S1⁻¹ • CX1 • X1 • R (plus , I⊗Z) • H1 • R (plus , I⊗Z) • S1⁻¹ • CX1 • T1 • H1 • T1⁻¹ • CX1 • X1 • T1 • H1 • T1⁻¹ • CX1 • X0 • CX0 • CX1 • T0 • CH0 • T0⁻¹ • ε
          by in-context 11 2 auto (symm lemma-R-T1⁻¹)
      equals CX1 • CX0 • X0 • R (plus , I⊗Z) • H1 • R (plus , I⊗Z) • S1⁻¹ • CX1 • X1 • R (plus , I⊗Z) • H1 • T1⁻¹ • CX1 • T1 • H1 • T1⁻¹ • CX1 • X1 • T1 • H1 • T1⁻¹ • CX1 • X0 • CX0 • CX1 • T0 • CH0 • T0⁻¹ • ε
          by in-context 9 1 auto (symm lemma-R-T1)
      equals CX1 • CX0 • X0 • R (plus , I⊗Z) • H1 • R (plus , I⊗Z) • S1⁻¹ • CX1 • X1 • T1 • H1 • T1⁻¹ • CX1 • T1 • H1 • T1⁻¹ • CX1 • X1 • T1 • H1 • T1⁻¹ • CX1 • X0 • CX0 • CX1 • T0 • CH0 • T0⁻¹ • ε
          by in-context 5 2 auto (symm lemma-R-T1⁻¹)
      equals CX1 • CX0 • X0 • R (plus , I⊗Z) • H1 • T1⁻¹ • CX1 • X1 • T1 • H1 • T1⁻¹ • CX1 • T1 • H1 • T1⁻¹ • CX1 • X1 • T1 • H1 • T1⁻¹ • CX1 • X0 • CX0 • CX1 • T0 • CH0 • T0⁻¹ • ε
          by in-context 3 1 auto (symm lemma-R-T1)
      equals CX1 • CX0 • X0 • T1 • H1 • T1⁻¹ • CX1 • X1 • T1 • H1 • T1⁻¹ • CX1 • T1 • H1 • T1⁻¹ • CX1 • X1 • T1 • H1 • T1⁻¹ • CX1 • X0 • CX0 • CX1 • T0 • CH0 • T0⁻¹ • ε
          by in-context 3 18 auto lemma-rel-A
      equals CX1 • CX0 • X0 • X0 • CX0 • CX1 • T0 • CH0 • T0⁻¹ • ε
          by clifford-tactic 0 6 10000 auto
      equals T0 • CH0 • T0⁻¹ • ε


eqn46 : Clifford+T.Rel ⊢ X0 • CH1 • X0 • Swap • T1 • CX1 • T1⁻¹ • X1 • CX1 • Swap • X0 • CH1 • X0 • Swap • X1 • CX1 • T1 • CX1 • T1⁻¹ • Swap • Swap • X0 • CH1 • X0 • Swap • T1 • CX1 • T1⁻¹ • X1 • CX1 • Swap • X0 • CH1 • X0 • Swap • X1 • CX1 • T1 • CX1 • T1⁻¹ • ε === Swap • X0 • CH1 • X0 • Swap • T1 • CX1 • T1⁻¹ • X1 • CX1 • Swap • X0 • CH1 • X0 • Swap • X1 • CX1 • T1 • CX1 • T1⁻¹ • X0 • CH1 • X0 • Swap • T1 • CX1 • T1⁻¹ • X1 • CX1 • Swap • X0 • CH1 • X0 • Swap • X1 • CX1 • T1 • CX1 • T1⁻¹ • Swap • ε
eqn46 = 
  equational X0 • CH1 • X0 • Swap • T1 • CX1 • T1⁻¹ • X1 • CX1 • Swap • X0 • CH1 • X0 • Swap • X1 • CX1 • T1 • CX1 • T1⁻¹ • Swap • Swap • X0 • CH1 • X0 • Swap • T1 • CX1 • T1⁻¹ • X1 • CX1 • Swap • X0 • CH1 • X0 • Swap • X1 • CX1 • T1 • CX1 • T1⁻¹ • ε
          by in-context 4 15 auto lemma-eqn46a
      equals X0 • CH1 • X0 • Swap • T0 • CH0 • T0⁻¹ • Swap • Swap • X0 • CH1 • X0 • Swap • T1 • CX1 • T1⁻¹ • X1 • CX1 • Swap • X0 • CH1 • X0 • Swap • X1 • CX1 • T1 • CX1 • T1⁻¹ • ε
          by in-context 13 15 auto lemma-eqn46a
      equals X0 • CH1 • X0 • Swap • T0 • CH0 • T0⁻¹ • Swap • Swap • X0 • CH1 • X0 • Swap • T0 • CH0 • T0⁻¹ • ε
          by general-assoc auto
      equals X0 • S1 • H1 • T1 • CX1 • T1⁻¹ • H1 • S1⁻¹ • X0 • Swap • T0 • CH0 • T0⁻¹ • Swap • Swap • X0 • CH1 • X0 • Swap • T0 • CH0 • T0⁻¹ • ε
          by in-context 3 1 auto lemma-R-T1
      equals X0 • S1 • H1 • R (plus , I⊗Z) • CX1 • T1⁻¹ • H1 • S1⁻¹ • X0 • Swap • T0 • CH0 • T0⁻¹ • Swap • Swap • X0 • CH1 • X0 • Swap • T0 • CH0 • T0⁻¹ • ε
          by in-context 5 1 auto lemma-R-T1⁻¹
      equals X0 • S1 • H1 • R (plus , I⊗Z) • CX1 • R (plus , I⊗Z) • S1⁻¹ • H1 • S1⁻¹ • X0 • Swap • T0 • CH0 • T0⁻¹ • Swap • Swap • X0 • CH1 • X0 • Swap • T0 • CH0 • T0⁻¹ • ε
          by general-assoc auto
      equals X0 • S1 • H1 • R (plus , I⊗Z) • CX1 • R (plus , I⊗Z) • S1⁻¹ • H1 • S1⁻¹ • X0 • Swap • R (plus , Z⊗I) • S0 • H0 • R (plus , Z⊗I) • CX0 • T0⁻¹ • H0 • S0⁻¹ • T0⁻¹ • Swap • Swap • X0 • CH1 • X0 • Swap • T0 • CH0 • T0⁻¹ • ε
          by in-context 16 1 auto lemma-R-T0⁻¹
      equals X0 • S1 • H1 • R (plus , I⊗Z) • CX1 • R (plus , I⊗Z) • S1⁻¹ • H1 • S1⁻¹ • X0 • Swap • R (plus , Z⊗I) • S0 • H0 • R (plus , Z⊗I) • CX0 • R (plus , Z⊗I) • S0⁻¹ • H0 • S0⁻¹ • T0⁻¹ • Swap • Swap • X0 • CH1 • X0 • Swap • T0 • CH0 • T0⁻¹ • ε
          by in-context 20 1 auto lemma-R-T0⁻¹
      equals X0 • S1 • H1 • R (plus , I⊗Z) • CX1 • R (plus , I⊗Z) • S1⁻¹ • H1 • S1⁻¹ • X0 • Swap • R (plus , Z⊗I) • S0 • H0 • R (plus , Z⊗I) • CX0 • R (plus , Z⊗I) • S0⁻¹ • H0 • S0⁻¹ • R (plus , Z⊗I) • S0⁻¹ • Swap • Swap • X0 • CH1 • X0 • Swap • T0 • CH0 • T0⁻¹ • ε
          by general-assoc auto
      equals X0 • S1 • H1 • R (plus , I⊗Z) • CX1 • R (plus , I⊗Z) • S1⁻¹ • H1 • S1⁻¹ • X0 • Swap • R (plus , Z⊗I) • S0 • H0 • R (plus , Z⊗I) • CX0 • R (plus , Z⊗I) • S0⁻¹ • H0 • S0⁻¹ • R (plus , Z⊗I) • S0⁻¹ • Swap • Swap • X0 • S1 • H1 • T1 • CX1 • T1⁻¹ • H1 • S1⁻¹ • X0 • Swap • T0 • CH0 • T0⁻¹ • ε
          by in-context 27 1 auto lemma-R-T1
      equals X0 • S1 • H1 • R (plus , I⊗Z) • CX1 • R (plus , I⊗Z) • S1⁻¹ • H1 • S1⁻¹ • X0 • Swap • R (plus , Z⊗I) • S0 • H0 • R (plus , Z⊗I) • CX0 • R (plus , Z⊗I) • S0⁻¹ • H0 • S0⁻¹ • R (plus , Z⊗I) • S0⁻¹ • Swap • Swap • X0 • S1 • H1 • R (plus , I⊗Z) • CX1 • T1⁻¹ • H1 • S1⁻¹ • X0 • Swap • T0 • CH0 • T0⁻¹ • ε
          by in-context 29 1 auto lemma-R-T1⁻¹
      equals X0 • S1 • H1 • R (plus , I⊗Z) • CX1 • R (plus , I⊗Z) • S1⁻¹ • H1 • S1⁻¹ • X0 • Swap • R (plus , Z⊗I) • S0 • H0 • R (plus , Z⊗I) • CX0 • R (plus , Z⊗I) • S0⁻¹ • H0 • S0⁻¹ • R (plus , Z⊗I) • S0⁻¹ • Swap • Swap • X0 • S1 • H1 • R (plus , I⊗Z) • CX1 • R (plus , I⊗Z) • S1⁻¹ • H1 • S1⁻¹ • X0 • Swap • T0 • CH0 • T0⁻¹ • ε
          by general-assoc auto
      equals X0 • S1 • H1 • R (plus , I⊗Z) • CX1 • R (plus , I⊗Z) • S1⁻¹ • H1 • S1⁻¹ • X0 • Swap • R (plus , Z⊗I) • S0 • H0 • R (plus , Z⊗I) • CX0 • R (plus , Z⊗I) • S0⁻¹ • H0 • S0⁻¹ • R (plus , Z⊗I) • S0⁻¹ • Swap • Swap • X0 • S1 • H1 • R (plus , I⊗Z) • CX1 • R (plus , I⊗Z) • S1⁻¹ • H1 • S1⁻¹ • X0 • Swap • R (plus , Z⊗I) • S0 • H0 • R (plus , Z⊗I) • CX0 • T0⁻¹ • H0 • S0⁻¹ • T0⁻¹ • ε
          by in-context 40 1 auto lemma-R-T0⁻¹
      equals X0 • S1 • H1 • R (plus , I⊗Z) • CX1 • R (plus , I⊗Z) • S1⁻¹ • H1 • S1⁻¹ • X0 • Swap • R (plus , Z⊗I) • S0 • H0 • R (plus , Z⊗I) • CX0 • R (plus , Z⊗I) • S0⁻¹ • H0 • S0⁻¹ • R (plus , Z⊗I) • S0⁻¹ • Swap • Swap • X0 • S1 • H1 • R (plus , I⊗Z) • CX1 • R (plus , I⊗Z) • S1⁻¹ • H1 • S1⁻¹ • X0 • Swap • R (plus , Z⊗I) • S0 • H0 • R (plus , Z⊗I) • CX0 • R (plus , Z⊗I) • S0⁻¹ • H0 • S0⁻¹ • T0⁻¹ • ε
          by in-context 44 1 auto lemma-R-T0⁻¹
      equals X0 • S1 • H1 • R (plus , I⊗Z) • CX1 • R (plus , I⊗Z) • S1⁻¹ • H1 • S1⁻¹ • X0 • Swap • R (plus , Z⊗I) • S0 • H0 • R (plus , Z⊗I) • CX0 • R (plus , Z⊗I) • S0⁻¹ • H0 • S0⁻¹ • R (plus , Z⊗I) • S0⁻¹ • Swap • Swap • X0 • S1 • H1 • R (plus , I⊗Z) • CX1 • R (plus , I⊗Z) • S1⁻¹ • H1 • S1⁻¹ • X0 • Swap • R (plus , Z⊗I) • S0 • H0 • R (plus , Z⊗I) • CX0 • R (plus , Z⊗I) • S0⁻¹ • H0 • S0⁻¹ • R (plus , Z⊗I) • S0⁻¹ • ε
          by in-context 0 4 auto (lemma-R (C.X0 • C.S1 • C.H1) (plus , I⊗Z))
      equals R (plus , I⊗Y) • X0 • S1 • H1 • CX1 • R (plus , I⊗Z) • S1⁻¹ • H1 • S1⁻¹ • X0 • Swap • R (plus , Z⊗I) • S0 • H0 • R (plus , Z⊗I) • CX0 • R (plus , Z⊗I) • S0⁻¹ • H0 • S0⁻¹ • R (plus , Z⊗I) • S0⁻¹ • Swap • Swap • X0 • S1 • H1 • R (plus , I⊗Z) • CX1 • R (plus , I⊗Z) • S1⁻¹ • H1 • S1⁻¹ • X0 • Swap • R (plus , Z⊗I) • S0 • H0 • R (plus , Z⊗I) • CX0 • R (plus , Z⊗I) • S0⁻¹ • H0 • S0⁻¹ • R (plus , Z⊗I) • S0⁻¹ • ε
          by in-context 1 5 auto (lemma-R (C.X0 • C.S1 • C.H1 • C.CX1) (plus , I⊗Z))
      equals R (plus , I⊗Y) • R (minus , Z⊗Y) • X0 • S1 • H1 • CX1 • S1⁻¹ • H1 • S1⁻¹ • X0 • Swap • R (plus , Z⊗I) • S0 • H0 • R (plus , Z⊗I) • CX0 • R (plus , Z⊗I) • S0⁻¹ • H0 • S0⁻¹ • R (plus , Z⊗I) • S0⁻¹ • Swap • Swap • X0 • S1 • H1 • R (plus , I⊗Z) • CX1 • R (plus , I⊗Z) • S1⁻¹ • H1 • S1⁻¹ • X0 • Swap • R (plus , Z⊗I) • S0 • H0 • R (plus , Z⊗I) • CX0 • R (plus , Z⊗I) • S0⁻¹ • H0 • S0⁻¹ • R (plus , Z⊗I) • S0⁻¹ • ε
          by clifford-tactic 2 8 10000 auto
      equals R (plus , I⊗Y) • R (minus , Z⊗Y) • CZ • H1 • W⁻¹ • Swap • R (plus , Z⊗I) • S0 • H0 • R (plus , Z⊗I) • CX0 • R (plus , Z⊗I) • S0⁻¹ • H0 • S0⁻¹ • R (plus , Z⊗I) • S0⁻¹ • Swap • Swap • X0 • S1 • H1 • R (plus , I⊗Z) • CX1 • R (plus , I⊗Z) • S1⁻¹ • H1 • S1⁻¹ • X0 • Swap • R (plus , Z⊗I) • S0 • H0 • R (plus , Z⊗I) • CX0 • R (plus , Z⊗I) • S0⁻¹ • H0 • S0⁻¹ • R (plus , Z⊗I) • S0⁻¹ • ε
          by in-context 2 5 auto (lemma-R (C.CZ • C.H1 • C.W⁻¹ • C.Swap) (plus , Z⊗I))
      equals R (plus , I⊗Y) • R (minus , Z⊗Y) • R (plus , Z⊗X) • CZ • H1 • W⁻¹ • Swap • S0 • H0 • R (plus , Z⊗I) • CX0 • R (plus , Z⊗I) • S0⁻¹ • H0 • S0⁻¹ • R (plus , Z⊗I) • S0⁻¹ • Swap • Swap • X0 • S1 • H1 • R (plus , I⊗Z) • CX1 • R (plus , I⊗Z) • S1⁻¹ • H1 • S1⁻¹ • X0 • Swap • R (plus , Z⊗I) • S0 • H0 • R (plus , Z⊗I) • CX0 • R (plus , Z⊗I) • S0⁻¹ • H0 • S0⁻¹ • R (plus , Z⊗I) • S0⁻¹ • ε
          by in-context 3 7 auto (lemma-R (C.CZ • C.H1 • C.W⁻¹ • C.Swap • C.S0 • C.H0) (plus , Z⊗I))
      equals R (plus , I⊗Y) • R (minus , Z⊗Y) • R (plus , Z⊗X) • R (minus , Z⊗Y) • CZ • H1 • W⁻¹ • Swap • S0 • H0 • CX0 • R (plus , Z⊗I) • S0⁻¹ • H0 • S0⁻¹ • R (plus , Z⊗I) • S0⁻¹ • Swap • Swap • X0 • S1 • H1 • R (plus , I⊗Z) • CX1 • R (plus , I⊗Z) • S1⁻¹ • H1 • S1⁻¹ • X0 • Swap • R (plus , Z⊗I) • S0 • H0 • R (plus , Z⊗I) • CX0 • R (plus , Z⊗I) • S0⁻¹ • H0 • S0⁻¹ • R (plus , Z⊗I) • S0⁻¹ • ε
          by in-context 4 8 auto (lemma-R (C.CZ • C.H1 • C.W⁻¹ • C.Swap • C.S0 • C.H0 • C.CX0) (plus , Z⊗I))
      equals R (plus , I⊗Y) • R (minus , Z⊗Y) • R (plus , Z⊗X) • R (minus , Z⊗Y) • R (minus , I⊗Y) • CZ • H1 • W⁻¹ • Swap • S0 • H0 • CX0 • S0⁻¹ • H0 • S0⁻¹ • R (plus , Z⊗I) • S0⁻¹ • Swap • Swap • X0 • S1 • H1 • R (plus , I⊗Z) • CX1 • R (plus , I⊗Z) • S1⁻¹ • H1 • S1⁻¹ • X0 • Swap • R (plus , Z⊗I) • S0 • H0 • R (plus , Z⊗I) • CX0 • R (plus , Z⊗I) • S0⁻¹ • H0 • S0⁻¹ • R (plus , Z⊗I) • S0⁻¹ • ε
          by in-context 5 11 auto (lemma-R (C.CZ • C.H1 • C.W⁻¹ • C.Swap • C.S0 • C.H0 • C.CX0 • C.S0⁻¹ • C.H0 • C.S0⁻¹) (plus , Z⊗I))
      equals R (plus , I⊗Y) • R (minus , Z⊗Y) • R (plus , Z⊗X) • R (minus , Z⊗Y) • R (minus , I⊗Y) • R (minus , Z⊗Z) • CZ • H1 • W⁻¹ • Swap • S0 • H0 • CX0 • S0⁻¹ • H0 • S0⁻¹ • S0⁻¹ • Swap • Swap • X0 • S1 • H1 • R (plus , I⊗Z) • CX1 • R (plus , I⊗Z) • S1⁻¹ • H1 • S1⁻¹ • X0 • Swap • R (plus , Z⊗I) • S0 • H0 • R (plus , Z⊗I) • CX0 • R (plus , Z⊗I) • S0⁻¹ • H0 • S0⁻¹ • R (plus , Z⊗I) • S0⁻¹ • ε
          by clifford-tactic 6 16 10000 auto
      equals R (plus , I⊗Y) • R (minus , Z⊗Y) • R (plus , Z⊗X) • R (minus , Z⊗Y) • R (minus , I⊗Y) • R (minus , Z⊗Z) • S1 • H1 • CZ • S0 • S0 • H0 • H1 • W ^ 4 • Swap • R (plus , I⊗Z) • CX1 • R (plus , I⊗Z) • S1⁻¹ • H1 • S1⁻¹ • X0 • Swap • R (plus , Z⊗I) • S0 • H0 • R (plus , Z⊗I) • CX0 • R (plus , Z⊗I) • S0⁻¹ • H0 • S0⁻¹ • R (plus , Z⊗I) • S0⁻¹ • ε
          by in-context 6 10 auto (lemma-R (C.S1 • C.H1 • C.CZ • C.S0 • C.S0 • C.H0 • C.H1 • C.W ^ 4 • C.Swap) (plus , I⊗Z))
      equals R (plus , I⊗Y) • R (minus , Z⊗Y) • R (plus , Z⊗X) • R (minus , Z⊗Y) • R (minus , I⊗Y) • R (minus , Z⊗Z) • R (minus , X⊗Y) • S1 • H1 • CZ • S0 • S0 • H0 • H1 • W ^ 4 • Swap • CX1 • R (plus , I⊗Z) • S1⁻¹ • H1 • S1⁻¹ • X0 • Swap • R (plus , Z⊗I) • S0 • H0 • R (plus , Z⊗I) • CX0 • R (plus , Z⊗I) • S0⁻¹ • H0 • S0⁻¹ • R (plus , Z⊗I) • S0⁻¹ • ε
          by in-context 7 11 auto (lemma-R (C.S1 • C.H1 • C.CZ • C.S0 • C.S0 • C.H0 • C.H1 • C.W ^ 4 • C.Swap • C.CX1) (plus , I⊗Z))
      equals R (plus , I⊗Y) • R (minus , Z⊗Y) • R (plus , Z⊗X) • R (minus , Z⊗Y) • R (minus , I⊗Y) • R (minus , Z⊗Z) • R (minus , X⊗Y) • R (minus , Y⊗X) • S1 • H1 • CZ • S0 • S0 • H0 • H1 • W ^ 4 • Swap • CX1 • S1⁻¹ • H1 • S1⁻¹ • X0 • Swap • R (plus , Z⊗I) • S0 • H0 • R (plus , Z⊗I) • CX0 • R (plus , Z⊗I) • S0⁻¹ • H0 • S0⁻¹ • R (plus , Z⊗I) • S0⁻¹ • ε
          by clifford-tactic 8 15 10000 auto
      equals R (plus , I⊗Y) • R (minus , Z⊗Y) • R (plus , Z⊗X) • R (minus , Z⊗Y) • R (minus , I⊗Y) • R (minus , Z⊗Z) • R (minus , X⊗Y) • R (minus , Y⊗X) • H1 • CZ • H0 • S1 • S1 • H1 • S1 • S1 • S1 • W ^ 5 • R (plus , Z⊗I) • S0 • H0 • R (plus , Z⊗I) • CX0 • R (plus , Z⊗I) • S0⁻¹ • H0 • S0⁻¹ • R (plus , Z⊗I) • S0⁻¹ • ε
          by in-context 8 11 auto (lemma-R (C.H1 • C.CZ • C.H0 • C.S1 • C.S1 • C.H1 • C.S1 • C.S1 • C.S1 • C.W ^ 5) (plus , Z⊗I))
      equals R (plus , I⊗Y) • R (minus , Z⊗Y) • R (plus , Z⊗X) • R (minus , Z⊗Y) • R (minus , I⊗Y) • R (minus , Z⊗Z) • R (minus , X⊗Y) • R (minus , Y⊗X) • R (plus , X⊗X) • H1 • CZ • H0 • S1 • S1 • H1 • S1 • S1 • S1 • W ^ 5 • S0 • H0 • R (plus , Z⊗I) • CX0 • R (plus , Z⊗I) • S0⁻¹ • H0 • S0⁻¹ • R (plus , Z⊗I) • S0⁻¹ • ε
          by in-context 9 13 auto (lemma-R (C.H1 • C.CZ • C.H0 • C.S1 • C.S1 • C.H1 • C.S1 • C.S1 • C.S1 • C.W ^ 5 • C.S0 • C.H0) (plus , Z⊗I))
      equals R (plus , I⊗Y) • R (minus , Z⊗Y) • R (plus , Z⊗X) • R (minus , Z⊗Y) • R (minus , I⊗Y) • R (minus , Z⊗Z) • R (minus , X⊗Y) • R (minus , Y⊗X) • R (plus , X⊗X) • R (minus , Y⊗X) • H1 • CZ • H0 • S1 • S1 • H1 • S1 • S1 • S1 • W ^ 5 • S0 • H0 • CX0 • R (plus , Z⊗I) • S0⁻¹ • H0 • S0⁻¹ • R (plus , Z⊗I) • S0⁻¹ • ε
          by in-context 10 14 auto (lemma-R (C.H1 • C.CZ • C.H0 • C.S1 • C.S1 • C.H1 • C.S1 • C.S1 • C.S1 • C.W ^ 5 • C.S0 • C.H0 • C.CX0) (plus , Z⊗I))
      equals R (plus , I⊗Y) • R (minus , Z⊗Y) • R (plus , Z⊗X) • R (minus , Z⊗Y) • R (minus , I⊗Y) • R (minus , Z⊗Z) • R (minus , X⊗Y) • R (minus , Y⊗X) • R (plus , X⊗X) • R (minus , Y⊗X) • R (plus , X⊗Y) • H1 • CZ • H0 • S1 • S1 • H1 • S1 • S1 • S1 • W ^ 5 • S0 • H0 • CX0 • S0⁻¹ • H0 • S0⁻¹ • R (plus , Z⊗I) • S0⁻¹ • ε
          by clifford-tactic 11 16 10000 auto
      equals R (plus , I⊗Y) • R (minus , Z⊗Y) • R (plus , Z⊗X) • R (minus , Z⊗Y) • R (minus , I⊗Y) • R (minus , Z⊗Z) • R (minus , X⊗Y) • R (minus , Y⊗X) • R (plus , X⊗X) • R (minus , Y⊗X) • R (plus , X⊗Y) • H0 • CZ • S0 • S0 • H0 • S0 • S0 • S0 • W ^ 4 • Swap • R (plus , Z⊗I) • S0⁻¹ • ε
          by in-context 11 11 auto (lemma-R (C.H0 • C.CZ • C.S0 • C.S0 • C.H0 • C.S0 • C.S0 • C.S0 • C.W ^ 4 • C.Swap) (plus , Z⊗I))
      equals R (plus , I⊗Y) • R (minus , Z⊗Y) • R (plus , Z⊗X) • R (minus , Z⊗Y) • R (minus , I⊗Y) • R (minus , Z⊗Z) • R (minus , X⊗Y) • R (minus , Y⊗X) • R (plus , X⊗X) • R (minus , Y⊗X) • R (plus , X⊗Y) • R (plus , I⊗Z) • H0 • CZ • S0 • S0 • H0 • S0 • S0 • S0 • W ^ 4 • Swap • S0⁻¹ • ε
          by in-context 3 2 auto (symm (tactic-pauli-commute (minus , I⊗Y) (minus , Z⊗Y) auto))
      equals R (plus , I⊗Y) • R (minus , Z⊗Y) • R (plus , Z⊗X) • R (minus , I⊗Y) • R (minus , Z⊗Y) • R (minus , Z⊗Z) • R (minus , X⊗Y) • R (minus , Y⊗X) • R (plus , X⊗X) • R (minus , Y⊗X) • R (plus , X⊗Y) • R (plus , I⊗Z) • H0 • CZ • S0 • S0 • H0 • S0 • S0 • S0 • W ^ 4 • Swap • S0⁻¹ • ε
          by in-context 6 2 auto (symm (tactic-pauli-commute (minus , Y⊗X) (minus , X⊗Y) auto))
      equals R (plus , I⊗Y) • R (minus , Z⊗Y) • R (plus , Z⊗X) • R (minus , I⊗Y) • R (minus , Z⊗Y) • R (minus , Z⊗Z) • R (minus , Y⊗X) • R (minus , X⊗Y) • R (plus , X⊗X) • R (minus , Y⊗X) • R (plus , X⊗Y) • R (plus , I⊗Z) • H0 • CZ • S0 • S0 • H0 • S0 • S0 • S0 • W ^ 4 • Swap • S0⁻¹ • ε
          by in-context 5 2 auto (symm (tactic-pauli-commute (minus , Y⊗X) (minus , Z⊗Z) auto))
      equals R (plus , I⊗Y) • R (minus , Z⊗Y) • R (plus , Z⊗X) • R (minus , I⊗Y) • R (minus , Z⊗Y) • R (minus , Y⊗X) • R (minus , Z⊗Z) • R (minus , X⊗Y) • R (plus , X⊗X) • R (minus , Y⊗X) • R (plus , X⊗Y) • R (plus , I⊗Z) • H0 • CZ • S0 • S0 • H0 • S0 • S0 • S0 • W ^ 4 • Swap • S0⁻¹ • ε
          by in-context 4 2 auto (symm (tactic-pauli-commute (minus , Y⊗X) (minus , Z⊗Y) auto))
      equals R (plus , I⊗Y) • R (minus , Z⊗Y) • R (plus , Z⊗X) • R (minus , I⊗Y) • R (minus , Y⊗X) • R (minus , Z⊗Y) • R (minus , Z⊗Z) • R (minus , X⊗Y) • R (plus , X⊗X) • R (minus , Y⊗X) • R (plus , X⊗Y) • R (plus , I⊗Z) • H0 • CZ • S0 • S0 • H0 • S0 • S0 • S0 • W ^ 4 • Swap • S0⁻¹ • ε
          by in-context 6 2 auto (symm (tactic-pauli-commute (minus , X⊗Y) (minus , Z⊗Z) auto))
      equals R (plus , I⊗Y) • R (minus , Z⊗Y) • R (plus , Z⊗X) • R (minus , I⊗Y) • R (minus , Y⊗X) • R (minus , Z⊗Y) • R (minus , X⊗Y) • R (minus , Z⊗Z) • R (plus , X⊗X) • R (minus , Y⊗X) • R (plus , X⊗Y) • R (plus , I⊗Z) • H0 • CZ • S0 • S0 • H0 • S0 • S0 • S0 • W ^ 4 • Swap • S0⁻¹ • ε
          by in-context 7 2 auto (symm (tactic-pauli-commute (plus , X⊗X) (minus , Z⊗Z) auto))
      equals R (plus , I⊗Y) • R (minus , Z⊗Y) • R (plus , Z⊗X) • R (minus , I⊗Y) • R (minus , Y⊗X) • R (minus , Z⊗Y) • R (minus , X⊗Y) • R (plus , X⊗X) • R (minus , Z⊗Z) • R (minus , Y⊗X) • R (plus , X⊗Y) • R (plus , I⊗Z) • H0 • CZ • S0 • S0 • H0 • S0 • S0 • S0 • W ^ 4 • Swap • S0⁻¹ • ε
          by in-context 9 2 auto (symm (tactic-pauli-commute (plus , X⊗Y) (minus , Y⊗X) auto))
      equals R (plus , I⊗Y) • R (minus , Z⊗Y) • R (plus , Z⊗X) • R (minus , I⊗Y) • R (minus , Y⊗X) • R (minus , Z⊗Y) • R (minus , X⊗Y) • R (plus , X⊗X) • R (minus , Z⊗Z) • R (plus , X⊗Y) • R (minus , Y⊗X) • R (plus , I⊗Z) • H0 • CZ • S0 • S0 • H0 • S0 • S0 • S0 • W ^ 4 • Swap • S0⁻¹ • ε
          by in-context 8 2 auto (symm (tactic-pauli-commute (plus , X⊗Y) (minus , Z⊗Z) auto))
      equals R (plus , I⊗Y) • R (minus , Z⊗Y) • R (plus , Z⊗X) • R (minus , I⊗Y) • R (minus , Y⊗X) • R (minus , Z⊗Y) • R (minus , X⊗Y) • R (plus , X⊗X) • R (plus , X⊗Y) • R (minus , Z⊗Z) • R (minus , Y⊗X) • R (plus , I⊗Z) • H0 • CZ • S0 • S0 • H0 • S0 • S0 • S0 • W ^ 4 • Swap • S0⁻¹ • ε
          by in-context 9 2 auto (symm (tactic-pauli-commute (minus , Y⊗X) (minus , Z⊗Z) auto))
      equals R (plus , I⊗Y) • R (minus , Z⊗Y) • R (plus , Z⊗X) • R (minus , I⊗Y) • R (minus , Y⊗X) • R (minus , Z⊗Y) • R (minus , X⊗Y) • R (plus , X⊗X) • R (plus , X⊗Y) • R (minus , Y⊗X) • R (minus , Z⊗Z) • R (plus , I⊗Z) • H0 • CZ • S0 • S0 • H0 • S0 • S0 • S0 • W ^ 4 • Swap • S0⁻¹ • ε
          by in-context 10 2 auto (symm (tactic-pauli-commute (plus , I⊗Z) (minus , Z⊗Z) auto))
      equals R (plus , I⊗Y) • R (minus , Z⊗Y) • R (plus , Z⊗X) • R (minus , I⊗Y) • R (minus , Y⊗X) • R (minus , Z⊗Y) • R (minus , X⊗Y) • R (plus , X⊗X) • R (plus , X⊗Y) • R (minus , Y⊗X) • R (plus , I⊗Z) • R (minus , Z⊗Z) • H0 • CZ • S0 • S0 • H0 • S0 • S0 • S0 • W ^ 4 • Swap • S0⁻¹ • ε
          by in-context 1 1 auto (lemma-correction Z⊗Y)
      equals R (plus , I⊗Y) • R (plus , Z⊗Y) • S1 • H1 • H0 • CZ • H0 • S0⁻¹ • W • H0 • CZ • H0 • H1 • S1⁻¹ • R (plus , Z⊗X) • R (minus , I⊗Y) • R (minus , Y⊗X) • R (minus , Z⊗Y) • R (minus , X⊗Y) • R (plus , X⊗X) • R (plus , X⊗Y) • R (minus , Y⊗X) • R (plus , I⊗Z) • R (minus , Z⊗Z) • H0 • CZ • S0 • S0 • H0 • S0 • S0 • S0 • W ^ 4 • Swap • S0⁻¹ • ε
          by clifford-tactic 4 10 10000 auto
      equals R (plus , I⊗Y) • R (plus , Z⊗Y) • S1 • H1 • CZ • S0 • S0 • S0 • H1 • S1 • H1 • R (plus , Z⊗X) • R (minus , I⊗Y) • R (minus , Y⊗X) • R (minus , Z⊗Y) • R (minus , X⊗Y) • R (plus , X⊗X) • R (plus , X⊗Y) • R (minus , Y⊗X) • R (plus , I⊗Z) • R (minus , Z⊗Z) • H0 • CZ • S0 • S0 • H0 • S0 • S0 • S0 • W ^ 4 • Swap • S0⁻¹ • ε
          by in-context 2 10 auto (lemma-R (C.S1 • C.H1 • C.CZ • C.S0 • C.S0 • C.S0 • C.H1 • C.S1 • C.H1) (plus , Z⊗X))
      equals R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • S1 • H1 • CZ • S0 • S0 • S0 • H1 • S1 • H1 • R (minus , I⊗Y) • R (minus , Y⊗X) • R (minus , Z⊗Y) • R (minus , X⊗Y) • R (plus , X⊗X) • R (plus , X⊗Y) • R (minus , Y⊗X) • R (plus , I⊗Z) • R (minus , Z⊗Z) • H0 • CZ • S0 • S0 • H0 • S0 • S0 • S0 • W ^ 4 • Swap • S0⁻¹ • ε
          by in-context 3 10 auto (lemma-R (C.S1 • C.H1 • C.CZ • C.S0 • C.S0 • C.S0 • C.H1 • C.S1 • C.H1) (minus , I⊗Y))
      equals R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (minus , I⊗Y) • S1 • H1 • CZ • S0 • S0 • S0 • H1 • S1 • H1 • R (minus , Y⊗X) • R (minus , Z⊗Y) • R (minus , X⊗Y) • R (plus , X⊗X) • R (plus , X⊗Y) • R (minus , Y⊗X) • R (plus , I⊗Z) • R (minus , Z⊗Z) • H0 • CZ • S0 • S0 • H0 • S0 • S0 • S0 • W ^ 4 • Swap • S0⁻¹ • ε
          by in-context 3 1 auto (lemma-correction I⊗Y)
      equals R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , I⊗Y) • S1 • H1 • Swap • S0⁻¹ • W • Swap • H1 • S1⁻¹ • S1 • H1 • CZ • S0 • S0 • S0 • H1 • S1 • H1 • R (minus , Y⊗X) • R (minus , Z⊗Y) • R (minus , X⊗Y) • R (plus , X⊗X) • R (plus , X⊗Y) • R (minus , Y⊗X) • R (plus , I⊗Z) • R (minus , Z⊗Z) • H0 • CZ • S0 • S0 • H0 • S0 • S0 • S0 • W ^ 4 • Swap • S0⁻¹ • ε
          by clifford-tactic 6 15 10000 auto
      equals R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , I⊗Y) • S1 • H1 • CZ • S0 • S0 • S0 • S1 • S1 • H1 • S1 • S1 • S1 • W ^ 2 • R (minus , Y⊗X) • R (minus , Z⊗Y) • R (minus , X⊗Y) • R (plus , X⊗X) • R (plus , X⊗Y) • R (minus , Y⊗X) • R (plus , I⊗Z) • R (minus , Z⊗Z) • H0 • CZ • S0 • S0 • H0 • S0 • S0 • S0 • W ^ 4 • Swap • S0⁻¹ • ε
          by in-context 4 14 auto (lemma-R (C.S1 • C.H1 • C.CZ • C.S0 • C.S0 • C.S0 • C.S1 • C.S1 • C.H1 • C.S1 • C.S1 • C.S1 • C.W ^ 2) (minus , Y⊗X))
      equals R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , I⊗Y) • R (minus , Y⊗Z) • S1 • H1 • CZ • S0 • S0 • S0 • S1 • S1 • H1 • S1 • S1 • S1 • W ^ 2 • R (minus , Z⊗Y) • R (minus , X⊗Y) • R (plus , X⊗X) • R (plus , X⊗Y) • R (minus , Y⊗X) • R (plus , I⊗Z) • R (minus , Z⊗Z) • H0 • CZ • S0 • S0 • H0 • S0 • S0 • S0 • W ^ 4 • Swap • S0⁻¹ • ε
          by in-context 4 1 auto (lemma-correction Y⊗Z)
      equals R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , I⊗Y) • R (plus , Y⊗Z) • S0 • CZ • H0 • S0⁻¹ • W • H0 • CZ • S0⁻¹ • S1 • H1 • CZ • S0 • S0 • S0 • S1 • S1 • H1 • S1 • S1 • S1 • W ^ 2 • R (minus , Z⊗Y) • R (minus , X⊗Y) • R (plus , X⊗X) • R (plus , X⊗Y) • R (minus , Y⊗X) • R (plus , I⊗Z) • R (minus , Z⊗Z) • H0 • CZ • S0 • S0 • H0 • S0 • S0 • S0 • W ^ 4 • Swap • S0⁻¹ • ε
          by clifford-tactic 5 21 10000 auto
      equals R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , I⊗Y) • R (plus , Y⊗Z) • H0 • H1 • CZ • S0 • S0 • S1 • S1 • H1 • S1 • S1 • W ^ 4 • Swap • R (minus , Z⊗Y) • R (minus , X⊗Y) • R (plus , X⊗X) • R (plus , X⊗Y) • R (minus , Y⊗X) • R (plus , I⊗Z) • R (minus , Z⊗Z) • H0 • CZ • S0 • S0 • H0 • S0 • S0 • S0 • W ^ 4 • Swap • S0⁻¹ • ε
          by in-context 5 13 auto (lemma-R (C.H0 • C.H1 • C.CZ • C.S0 • C.S0 • C.S1 • C.S1 • C.H1 • C.S1 • C.S1 • C.W ^ 4 • C.Swap) (minus , Z⊗Y))
      equals R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , I⊗Y) • R (plus , Y⊗Z) • R (minus , Z⊗Y) • H0 • H1 • CZ • S0 • S0 • S1 • S1 • H1 • S1 • S1 • W ^ 4 • Swap • R (minus , X⊗Y) • R (plus , X⊗X) • R (plus , X⊗Y) • R (minus , Y⊗X) • R (plus , I⊗Z) • R (minus , Z⊗Z) • H0 • CZ • S0 • S0 • H0 • S0 • S0 • S0 • W ^ 4 • Swap • S0⁻¹ • ε
          by in-context 5 1 auto (lemma-correction Z⊗Y)
      equals R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , I⊗Y) • R (plus , Y⊗Z) • R (plus , Z⊗Y) • S1 • H1 • H0 • CZ • H0 • S0⁻¹ • W • H0 • CZ • H0 • H1 • S1⁻¹ • H0 • H1 • CZ • S0 • S0 • S1 • S1 • H1 • S1 • S1 • W ^ 4 • Swap • R (minus , X⊗Y) • R (plus , X⊗X) • R (plus , X⊗Y) • R (minus , Y⊗X) • R (plus , I⊗Z) • R (minus , Z⊗Z) • H0 • CZ • S0 • S0 • H0 • S0 • S0 • S0 • W ^ 4 • Swap • S0⁻¹ • ε
          by clifford-tactic 6 24 10000 auto
      equals R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , I⊗Y) • R (plus , Y⊗Z) • R (plus , Z⊗Y) • S0 • H0 • CZ • S0 • S0 • S0 • H0 • S0 • S1 • S1 • S1 • H1 • S1 • S1 • W ^ 5 • R (minus , X⊗Y) • R (plus , X⊗X) • R (plus , X⊗Y) • R (minus , Y⊗X) • R (plus , I⊗Z) • R (minus , Z⊗Z) • H0 • CZ • S0 • S0 • H0 • S0 • S0 • S0 • W ^ 4 • Swap • S0⁻¹ • ε
          by in-context 6 16 auto (lemma-R (C.S0 • C.H0 • C.CZ • C.S0 • C.S0 • C.S0 • C.H0 • C.S0 • C.S1 • C.S1 • C.S1 • C.H1 • C.S1 • C.S1 • C.W ^ 5) (minus , X⊗Y))
      equals R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , I⊗Y) • R (plus , Y⊗Z) • R (plus , Z⊗Y) • R (plus , X⊗Y) • S0 • H0 • CZ • S0 • S0 • S0 • H0 • S0 • S1 • S1 • S1 • H1 • S1 • S1 • W ^ 5 • R (plus , X⊗X) • R (plus , X⊗Y) • R (minus , Y⊗X) • R (plus , I⊗Z) • R (minus , Z⊗Z) • H0 • CZ • S0 • S0 • H0 • S0 • S0 • S0 • W ^ 4 • Swap • S0⁻¹ • ε
          by in-context 7 16 auto (lemma-R (C.S0 • C.H0 • C.CZ • C.S0 • C.S0 • C.S0 • C.H0 • C.S0 • C.S1 • C.S1 • C.S1 • C.H1 • C.S1 • C.S1 • C.W ^ 5) (plus , X⊗X))
      equals R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , I⊗Y) • R (plus , Y⊗Z) • R (plus , Z⊗Y) • R (plus , X⊗Y) • R (plus , Z⊗I) • S0 • H0 • CZ • S0 • S0 • S0 • H0 • S0 • S1 • S1 • S1 • H1 • S1 • S1 • W ^ 5 • R (plus , X⊗Y) • R (minus , Y⊗X) • R (plus , I⊗Z) • R (minus , Z⊗Z) • H0 • CZ • S0 • S0 • H0 • S0 • S0 • S0 • W ^ 4 • Swap • S0⁻¹ • ε
          by in-context 8 16 auto (lemma-R (C.S0 • C.H0 • C.CZ • C.S0 • C.S0 • C.S0 • C.H0 • C.S0 • C.S1 • C.S1 • C.S1 • C.H1 • C.S1 • C.S1 • C.W ^ 5) (plus , X⊗Y))
      equals R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , I⊗Y) • R (plus , Y⊗Z) • R (plus , Z⊗Y) • R (plus , X⊗Y) • R (plus , Z⊗I) • R (minus , X⊗Y) • S0 • H0 • CZ • S0 • S0 • S0 • H0 • S0 • S1 • S1 • S1 • H1 • S1 • S1 • W ^ 5 • R (minus , Y⊗X) • R (plus , I⊗Z) • R (minus , Z⊗Z) • H0 • CZ • S0 • S0 • H0 • S0 • S0 • S0 • W ^ 4 • Swap • S0⁻¹ • ε
          by in-context 8 1 auto (lemma-correction X⊗Y)
      equals R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , I⊗Y) • R (plus , Y⊗Z) • R (plus , Z⊗Y) • R (plus , X⊗Y) • R (plus , Z⊗I) • R (plus , X⊗Y) • S1 • H1 • CZ • H0 • S0⁻¹ • W • H0 • CZ • H1 • S1⁻¹ • S0 • H0 • CZ • S0 • S0 • S0 • H0 • S0 • S1 • S1 • S1 • H1 • S1 • S1 • W ^ 5 • R (minus , Y⊗X) • R (plus , I⊗Z) • R (minus , Z⊗Z) • H0 • CZ • S0 • S0 • H0 • S0 • S0 • S0 • W ^ 4 • Swap • S0⁻¹ • ε
          by clifford-tactic 9 25 10000 auto
      equals R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , I⊗Y) • R (plus , Y⊗Z) • R (plus , Z⊗Y) • R (plus , X⊗Y) • R (plus , Z⊗I) • R (plus , X⊗Y) • H1 • CZ • S1 • S1 • W ^ 4 • Swap • R (minus , Y⊗X) • R (plus , I⊗Z) • R (minus , Z⊗Z) • H0 • CZ • S0 • S0 • H0 • S0 • S0 • S0 • W ^ 4 • Swap • S0⁻¹ • ε
          by in-context 9 7 auto (lemma-R (C.H1 • C.CZ • C.S1 • C.S1 • C.W ^ 4 • C.Swap) (minus , Y⊗X))
      equals R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , I⊗Y) • R (plus , Y⊗Z) • R (plus , Z⊗Y) • R (plus , X⊗Y) • R (plus , Z⊗I) • R (plus , X⊗Y) • R (minus , Y⊗Z) • H1 • CZ • S1 • S1 • W ^ 4 • Swap • R (plus , I⊗Z) • R (minus , Z⊗Z) • H0 • CZ • S0 • S0 • H0 • S0 • S0 • S0 • W ^ 4 • Swap • S0⁻¹ • ε
          by in-context 9 1 auto (lemma-correction Y⊗Z)
      equals R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , I⊗Y) • R (plus , Y⊗Z) • R (plus , Z⊗Y) • R (plus , X⊗Y) • R (plus , Z⊗I) • R (plus , X⊗Y) • R (plus , Y⊗Z) • S0 • CZ • H0 • S0⁻¹ • W • H0 • CZ • S0⁻¹ • H1 • CZ • S1 • S1 • W ^ 4 • Swap • R (plus , I⊗Z) • R (minus , Z⊗Z) • H0 • CZ • S0 • S0 • H0 • S0 • S0 • S0 • W ^ 4 • Swap • S0⁻¹ • ε
          by clifford-tactic 10 14 10000 auto
      equals R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , I⊗Y) • R (plus , Y⊗Z) • R (plus , Z⊗Y) • R (plus , X⊗Y) • R (plus , Z⊗I) • R (plus , X⊗Y) • R (plus , Y⊗Z) • H0 • S1 • H1 • CZ • S0 • H0 • S1 • S1 • H1 • S1 • W ^ 2 • R (plus , I⊗Z) • R (minus , Z⊗Z) • H0 • CZ • S0 • S0 • H0 • S0 • S0 • S0 • W ^ 4 • Swap • S0⁻¹ • ε
          by in-context 10 12 auto (lemma-R (C.H0 • C.S1 • C.H1 • C.CZ • C.S0 • C.H0 • C.S1 • C.S1 • C.H1 • C.S1 • C.W ^ 2) (plus , I⊗Z))
      equals R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , I⊗Y) • R (plus , Y⊗Z) • R (plus , Z⊗Y) • R (plus , X⊗Y) • R (plus , Z⊗I) • R (plus , X⊗Y) • R (plus , Y⊗Z) • R (minus , X⊗Z) • H0 • S1 • H1 • CZ • S0 • H0 • S1 • S1 • H1 • S1 • W ^ 2 • R (minus , Z⊗Z) • H0 • CZ • S0 • S0 • H0 • S0 • S0 • S0 • W ^ 4 • Swap • S0⁻¹ • ε
          by in-context 10 1 auto (lemma-correction X⊗Z)
      equals R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , I⊗Y) • R (plus , Y⊗Z) • R (plus , Z⊗Y) • R (plus , X⊗Y) • R (plus , Z⊗I) • R (plus , X⊗Y) • R (plus , Y⊗Z) • R (plus , X⊗Z) • CZ • H0 • S0⁻¹ • W • H0 • CZ • H0 • S1 • H1 • CZ • S0 • H0 • S1 • S1 • H1 • S1 • W ^ 2 • R (minus , Z⊗Z) • H0 • CZ • S0 • S0 • H0 • S0 • S0 • S0 • W ^ 4 • Swap • S0⁻¹ • ε
          by clifford-tactic 11 17 10000 auto
      equals R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , I⊗Y) • R (plus , Y⊗Z) • R (plus , Z⊗Y) • R (plus , X⊗Y) • R (plus , Z⊗I) • R (plus , X⊗Y) • R (plus , Y⊗Z) • R (plus , X⊗Z) • H0 • S1 • H1 • CZ • S0 • H0 • S1 • S1 • H1 • S1 • S1 • W • R (minus , Z⊗Z) • H0 • CZ • S0 • S0 • H0 • S0 • S0 • S0 • W ^ 4 • Swap • S0⁻¹ • ε
          by in-context 11 13 auto (lemma-R (C.H0 • C.S1 • C.H1 • C.CZ • C.S0 • C.H0 • C.S1 • C.S1 • C.H1 • C.S1 • C.S1 • C.W) (minus , Z⊗Z))
      equals R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , I⊗Y) • R (plus , Y⊗Z) • R (plus , Z⊗Y) • R (plus , X⊗Y) • R (plus , Z⊗I) • R (plus , X⊗Y) • R (plus , Y⊗Z) • R (plus , X⊗Z) • R (minus , Z⊗X) • H0 • S1 • H1 • CZ • S0 • H0 • S1 • S1 • H1 • S1 • S1 • W • H0 • CZ • S0 • S0 • H0 • S0 • S0 • S0 • W ^ 4 • Swap • S0⁻¹ • ε
          by in-context 11 1 auto (lemma-correction Z⊗X)
      equals R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , I⊗Y) • R (plus , Y⊗Z) • R (plus , Z⊗Y) • R (plus , X⊗Y) • R (plus , Z⊗I) • R (plus , X⊗Y) • R (plus , Y⊗Z) • R (plus , X⊗Z) • R (plus , Z⊗X) • H1 • H0 • CZ • H0 • S0⁻¹ • W • H0 • CZ • H0 • H1 • H0 • S1 • H1 • CZ • S0 • H0 • S1 • S1 • H1 • S1 • S1 • W • H0 • CZ • S0 • S0 • H0 • S0 • S0 • S0 • W ^ 4 • Swap • S0⁻¹ • ε
          by clifford-tactic 12 33 10000 auto
      equals R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , I⊗Y) • R (plus , Y⊗Z) • R (plus , Z⊗Y) • R (plus , X⊗Y) • R (plus , Z⊗I) • R (plus , X⊗Y) • R (plus , Y⊗Z) • R (plus , X⊗Z) • R (plus , Z⊗X) • H0 • H1 • CZ • S0 • S0 • H0 • S1 • S1 • H1 • W ^ 6 • Swap • ε
          by clifford-tactic 12 11 10000 auto
      equals R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , I⊗Y) • R (plus , Y⊗Z) • R (plus , Z⊗Y) • R (plus , X⊗Y) • R (plus , Z⊗I) • R (plus , X⊗Y) • R (plus , Y⊗Z) • R (plus , X⊗Z) • R (plus , Z⊗X) • CZ • H0 • H1 • CZ • H0 • S0 • S0 • H0 • H1 • S1 • S1 • H1 • W ^ 6 • ε
          by clifford-tactic 25 0 10000 auto
      equals R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , I⊗Y) • R (plus , Y⊗Z) • R (plus , Z⊗Y) • R (plus , X⊗Y) • R (plus , Z⊗I) • R (plus , X⊗Y) • R (plus , Y⊗Z) • R (plus , X⊗Z) • R (plus , Z⊗X) • CZ • H0 • H1 • CZ • H0 • S0 • S0 • H0 • H1 • S1 • S1 • H1 • W ^ 6 • W ^ 2 • H1 • S1⁻¹ • S1⁻¹ • H1 • H0 • S0⁻¹ • S0⁻¹ • H0 • CZ • H1 • H0 • CZ • CZ • H0 • H1 • CZ • H0 • S0 • S0 • H0 • H1 • S1 • S1 • H1 • W ^ 6 • ε
          by clifford-tactic 38 0 10000 auto
      equals R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , I⊗Y) • R (plus , Y⊗Z) • R (plus , Z⊗Y) • R (plus , X⊗Y) • R (plus , Z⊗I) • R (plus , X⊗Y) • R (plus , Y⊗Z) • R (plus , X⊗Z) • R (plus , Z⊗X) • CZ • H0 • H1 • CZ • H0 • S0 • S0 • H0 • H1 • S1 • S1 • H1 • W ^ 6 • W ^ 2 • H1 • S1⁻¹ • S1⁻¹ • H1 • H0 • S0⁻¹ • S0⁻¹ • H0 • CZ • H1 • H0 • CZ • H1 • H0 • CZ • H0 • H0 • CZ • H0 • H1 • CZ • H0 • H1 • CZ • H0 • S0 • S0 • H0 • H1 • S1 • S1 • H1 • W ^ 6 • ε
          by in-context 42 0 auto (symm lemma-order-T0)
      equals R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , I⊗Y) • R (plus , Y⊗Z) • R (plus , Z⊗Y) • R (plus , X⊗Y) • R (plus , Z⊗I) • R (plus , X⊗Y) • R (plus , Y⊗Z) • R (plus , X⊗Z) • R (plus , Z⊗X) • CZ • H0 • H1 • CZ • H0 • S0 • S0 • H0 • H1 • S1 • S1 • H1 • W ^ 6 • W ^ 2 • H1 • S1⁻¹ • S1⁻¹ • H1 • H0 • S0⁻¹ • S0⁻¹ • H0 • CZ • H1 • H0 • CZ • H1 • H0 • CZ • H0 • T0 • T0 • T0 • T0 • T0 • T0 • T0 • T0 • H0 • CZ • H0 • H1 • CZ • H0 • H1 • CZ • H0 • S0 • S0 • H0 • H1 • S1 • S1 • H1 • W ^ 6 • ε
          by general-assoc auto
      equals R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , I⊗Y) • R (plus , Y⊗Z) • R (plus , Z⊗Y) • R (plus , X⊗Y) • R (plus , Z⊗I) • R (plus , X⊗Y) • R (plus , Y⊗Z) • R (plus , X⊗Z) • R (plus , Z⊗X) • CZ • H0 • H1 • CZ • H0 • S0 • S0 • H0 • H1 • S1 • S1 • H1 • W ^ 6 • W ^ 2 • H1 • S1⁻¹ • S1⁻¹ • H1 • H0 • S0⁻¹ • S0⁻¹ • H0 • CZ • H1 • H0 • CZ • H1 • H0 • CZ • H0 • T0⁻¹ • T0 • H0 • CZ • H0 • H1 • CZ • H0 • H1 • CZ • H0 • S0 • S0 • H0 • H1 • S1 • S1 • H1 • W ^ 6 • ε
          by clifford-tactic 43 0 10000 auto
      equals R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , I⊗Y) • R (plus , Y⊗Z) • R (plus , Z⊗Y) • R (plus , X⊗Y) • R (plus , Z⊗I) • R (plus , X⊗Y) • R (plus , Y⊗Z) • R (plus , X⊗Z) • R (plus , Z⊗X) • CZ • H0 • H1 • CZ • H0 • S0 • S0 • H0 • H1 • S1 • S1 • H1 • W ^ 6 • W ^ 2 • H1 • S1⁻¹ • S1⁻¹ • H1 • H0 • S0⁻¹ • S0⁻¹ • H0 • CZ • H1 • H0 • CZ • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • H1 • H0 • CZ • H0 • T0 • H0 • CZ • H0 • H1 • CZ • H0 • H1 • CZ • H0 • S0 • S0 • H0 • H1 • S1 • S1 • H1 • W ^ 6 • ε
          by general-assoc auto
      equals R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , I⊗Y) • R (plus , Y⊗Z) • R (plus , Z⊗Y) • R (plus , X⊗Y) • R (plus , Z⊗I) • R (plus , X⊗Y) • R (plus , Y⊗Z) • R (plus , X⊗Z) • R (plus , Z⊗X) • CZ • H0 • H1 • CZ • H0 • S0 • S0 • H0 • H1 • S1 • S1 • H1 • W ^ 6 • W ^ 2 • H1 • S1⁻¹ • S1⁻¹ • H1 • H0 • S0⁻¹ • S0⁻¹ • H0 • CZ • H1 • H0 • CZ • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • R (plus , Z⊗X) • CZ • H0 • H1 • CZ • H0 • S0 • S0 • H0 • H1 • S1 • S1 • H1 • W ^ 6 • ε
          by clifford-tactic 47 0 10000 auto
      equals R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , I⊗Y) • R (plus , Y⊗Z) • R (plus , Z⊗Y) • R (plus , X⊗Y) • R (plus , Z⊗I) • R (plus , X⊗Y) • R (plus , Y⊗Z) • R (plus , X⊗Z) • R (plus , Z⊗X) • CZ • H0 • H1 • CZ • H0 • S0 • S0 • H0 • H1 • S1 • S1 • H1 • W ^ 6 • W ^ 2 • H1 • S1⁻¹ • S1⁻¹ • H1 • H0 • S0⁻¹ • S0⁻¹ • H0 • CZ • H1 • H0 • CZ • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • S1 • H1 • H0 • CZ • H0 • H0 • CZ • H0 • H1 • S1⁻¹ • R (plus , Z⊗X) • CZ • H0 • H1 • CZ • H0 • S0 • S0 • H0 • H1 • S1 • S1 • H1 • W ^ 6 • ε
          by in-context 52 0 auto (symm lemma-order-T0)
      equals R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , I⊗Y) • R (plus , Y⊗Z) • R (plus , Z⊗Y) • R (plus , X⊗Y) • R (plus , Z⊗I) • R (plus , X⊗Y) • R (plus , Y⊗Z) • R (plus , X⊗Z) • R (plus , Z⊗X) • CZ • H0 • H1 • CZ • H0 • S0 • S0 • H0 • H1 • S1 • S1 • H1 • W ^ 6 • W ^ 2 • H1 • S1⁻¹ • S1⁻¹ • H1 • H0 • S0⁻¹ • S0⁻¹ • H0 • CZ • H1 • H0 • CZ • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • S1 • H1 • H0 • CZ • H0 • T0 • T0 • T0 • T0 • T0 • T0 • T0 • T0 • H0 • CZ • H0 • H1 • S1⁻¹ • R (plus , Z⊗X) • CZ • H0 • H1 • CZ • H0 • S0 • S0 • H0 • H1 • S1 • S1 • H1 • W ^ 6 • ε
          by general-assoc auto
      equals R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , I⊗Y) • R (plus , Y⊗Z) • R (plus , Z⊗Y) • R (plus , X⊗Y) • R (plus , Z⊗I) • R (plus , X⊗Y) • R (plus , Y⊗Z) • R (plus , X⊗Z) • R (plus , Z⊗X) • CZ • H0 • H1 • CZ • H0 • S0 • S0 • H0 • H1 • S1 • S1 • H1 • W ^ 6 • W ^ 2 • H1 • S1⁻¹ • S1⁻¹ • H1 • H0 • S0⁻¹ • S0⁻¹ • H0 • CZ • H1 • H0 • CZ • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • S1 • H1 • H0 • CZ • H0 • T0⁻¹ • T0 • H0 • CZ • H0 • H1 • S1⁻¹ • R (plus , Z⊗X) • CZ • H0 • H1 • CZ • H0 • S0 • S0 • H0 • H1 • S1 • S1 • H1 • W ^ 6 • ε
          by clifford-tactic 53 0 10000 auto
      equals R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , I⊗Y) • R (plus , Y⊗Z) • R (plus , Z⊗Y) • R (plus , X⊗Y) • R (plus , Z⊗I) • R (plus , X⊗Y) • R (plus , Y⊗Z) • R (plus , X⊗Z) • R (plus , Z⊗X) • CZ • H0 • H1 • CZ • H0 • S0 • S0 • H0 • H1 • S1 • S1 • H1 • W ^ 6 • W ^ 2 • H1 • S1⁻¹ • S1⁻¹ • H1 • H0 • S0⁻¹ • S0⁻¹ • H0 • CZ • H1 • H0 • CZ • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • S1 • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • S1 • H1 • H0 • CZ • H0 • T0 • H0 • CZ • H0 • H1 • S1⁻¹ • R (plus , Z⊗X) • CZ • H0 • H1 • CZ • H0 • S0 • S0 • H0 • H1 • S1 • S1 • H1 • W ^ 6 • ε
          by general-assoc auto
      equals R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , I⊗Y) • R (plus , Y⊗Z) • R (plus , Z⊗Y) • R (plus , X⊗Y) • R (plus , Z⊗I) • R (plus , X⊗Y) • R (plus , Y⊗Z) • R (plus , X⊗Z) • R (plus , Z⊗X) • CZ • H0 • H1 • CZ • H0 • S0 • S0 • H0 • H1 • S1 • S1 • H1 • W ^ 6 • W ^ 2 • H1 • S1⁻¹ • S1⁻¹ • H1 • H0 • S0⁻¹ • S0⁻¹ • H0 • CZ • H1 • H0 • CZ • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • S1 • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • R (plus , Z⊗Y) • R (plus , Z⊗X) • CZ • H0 • H1 • CZ • H0 • S0 • S0 • H0 • H1 • S1 • S1 • H1 • W ^ 6 • ε
          by clifford-tactic 58 0 10000 auto
      equals R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , I⊗Y) • R (plus , Y⊗Z) • R (plus , Z⊗Y) • R (plus , X⊗Y) • R (plus , Z⊗I) • R (plus , X⊗Y) • R (plus , Y⊗Z) • R (plus , X⊗Z) • R (plus , Z⊗X) • CZ • H0 • H1 • CZ • H0 • S0 • S0 • H0 • H1 • S1 • S1 • H1 • W ^ 6 • W ^ 2 • H1 • S1⁻¹ • S1⁻¹ • H1 • H0 • S0⁻¹ • S0⁻¹ • H0 • CZ • H1 • H0 • CZ • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • S1 • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • H1 • S0 • CZ • H0 • H0 • CZ • S0⁻¹ • H1 • R (plus , Z⊗Y) • R (plus , Z⊗X) • CZ • H0 • H1 • CZ • H0 • S0 • S0 • H0 • H1 • S1 • S1 • H1 • W ^ 6 • ε
          by in-context 62 0 auto (symm lemma-order-T0)
      equals R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , I⊗Y) • R (plus , Y⊗Z) • R (plus , Z⊗Y) • R (plus , X⊗Y) • R (plus , Z⊗I) • R (plus , X⊗Y) • R (plus , Y⊗Z) • R (plus , X⊗Z) • R (plus , Z⊗X) • CZ • H0 • H1 • CZ • H0 • S0 • S0 • H0 • H1 • S1 • S1 • H1 • W ^ 6 • W ^ 2 • H1 • S1⁻¹ • S1⁻¹ • H1 • H0 • S0⁻¹ • S0⁻¹ • H0 • CZ • H1 • H0 • CZ • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • S1 • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • H1 • S0 • CZ • H0 • T0 • T0 • T0 • T0 • T0 • T0 • T0 • T0 • H0 • CZ • S0⁻¹ • H1 • R (plus , Z⊗Y) • R (plus , Z⊗X) • CZ • H0 • H1 • CZ • H0 • S0 • S0 • H0 • H1 • S1 • S1 • H1 • W ^ 6 • ε
          by general-assoc auto
      equals R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , I⊗Y) • R (plus , Y⊗Z) • R (plus , Z⊗Y) • R (plus , X⊗Y) • R (plus , Z⊗I) • R (plus , X⊗Y) • R (plus , Y⊗Z) • R (plus , X⊗Z) • R (plus , Z⊗X) • CZ • H0 • H1 • CZ • H0 • S0 • S0 • H0 • H1 • S1 • S1 • H1 • W ^ 6 • W ^ 2 • H1 • S1⁻¹ • S1⁻¹ • H1 • H0 • S0⁻¹ • S0⁻¹ • H0 • CZ • H1 • H0 • CZ • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • S1 • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • H1 • S0 • CZ • H0 • T0⁻¹ • T0 • H0 • CZ • S0⁻¹ • H1 • R (plus , Z⊗Y) • R (plus , Z⊗X) • CZ • H0 • H1 • CZ • H0 • S0 • S0 • H0 • H1 • S1 • S1 • H1 • W ^ 6 • ε
          by clifford-tactic 63 0 10000 auto
      equals R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , I⊗Y) • R (plus , Y⊗Z) • R (plus , Z⊗Y) • R (plus , X⊗Y) • R (plus , Z⊗I) • R (plus , X⊗Y) • R (plus , Y⊗Z) • R (plus , X⊗Z) • R (plus , Z⊗X) • CZ • H0 • H1 • CZ • H0 • S0 • S0 • H0 • H1 • S1 • S1 • H1 • W ^ 6 • W ^ 2 • H1 • S1⁻¹ • S1⁻¹ • H1 • H0 • S0⁻¹ • S0⁻¹ • H0 • CZ • H1 • H0 • CZ • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • S1 • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • H1 • S0 • CZ • H0 • T0⁻¹ • H0 • CZ • S0⁻¹ • H1 • H1 • S0 • CZ • H0 • T0 • H0 • CZ • S0⁻¹ • H1 • R (plus , Z⊗Y) • R (plus , Z⊗X) • CZ • H0 • H1 • CZ • H0 • S0 • S0 • H0 • H1 • S1 • S1 • H1 • W ^ 6 • ε
          by general-assoc auto
      equals R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , I⊗Y) • R (plus , Y⊗Z) • R (plus , Z⊗Y) • R (plus , X⊗Y) • R (plus , Z⊗I) • R (plus , X⊗Y) • R (plus , Y⊗Z) • R (plus , X⊗Z) • R (plus , Z⊗X) • CZ • H0 • H1 • CZ • H0 • S0 • S0 • H0 • H1 • S1 • S1 • H1 • W ^ 6 • W ^ 2 • H1 • S1⁻¹ • S1⁻¹ • H1 • H0 • S0⁻¹ • S0⁻¹ • H0 • CZ • H1 • H0 • CZ • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • S1 • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • H1 • S0 • CZ • H0 • T0⁻¹ • H0 • CZ • S0⁻¹ • H1 • R (plus , Y⊗X) • R (plus , Z⊗Y) • R (plus , Z⊗X) • CZ • H0 • H1 • CZ • H0 • S0 • S0 • H0 • H1 • S1 • S1 • H1 • W ^ 6 • ε
          by clifford-tactic 67 0 10000 auto
      equals R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , I⊗Y) • R (plus , Y⊗Z) • R (plus , Z⊗Y) • R (plus , X⊗Y) • R (plus , Z⊗I) • R (plus , X⊗Y) • R (plus , Y⊗Z) • R (plus , X⊗Z) • R (plus , Z⊗X) • CZ • H0 • H1 • CZ • H0 • S0 • S0 • H0 • H1 • S1 • S1 • H1 • W ^ 6 • W ^ 2 • H1 • S1⁻¹ • S1⁻¹ • H1 • H0 • S0⁻¹ • S0⁻¹ • H0 • CZ • H1 • H0 • CZ • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • S1 • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • H1 • S0 • CZ • H0 • T0⁻¹ • H0 • CZ • S0⁻¹ • H1 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • R (plus , Y⊗X) • R (plus , Z⊗Y) • R (plus , Z⊗X) • CZ • H0 • H1 • CZ • H0 • S0 • S0 • H0 • H1 • S1 • S1 • H1 • W ^ 6 • ε
          by in-context 76 0 auto (symm lemma-order-T0)
      equals R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , I⊗Y) • R (plus , Y⊗Z) • R (plus , Z⊗Y) • R (plus , X⊗Y) • R (plus , Z⊗I) • R (plus , X⊗Y) • R (plus , Y⊗Z) • R (plus , X⊗Z) • R (plus , Z⊗X) • CZ • H0 • H1 • CZ • H0 • S0 • S0 • H0 • H1 • S1 • S1 • H1 • W ^ 6 • W ^ 2 • H1 • S1⁻¹ • S1⁻¹ • H1 • H0 • S0⁻¹ • S0⁻¹ • H0 • CZ • H1 • H0 • CZ • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • S1 • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • H1 • S0 • CZ • H0 • T0⁻¹ • H0 • CZ • S0⁻¹ • H1 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0 • T0 • T0 • T0 • T0 • T0 • T0 • T0 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • R (plus , Y⊗X) • R (plus , Z⊗Y) • R (plus , Z⊗X) • CZ • H0 • H1 • CZ • H0 • S0 • S0 • H0 • H1 • S1 • S1 • H1 • W ^ 6 • ε
          by general-assoc auto
      equals R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , I⊗Y) • R (plus , Y⊗Z) • R (plus , Z⊗Y) • R (plus , X⊗Y) • R (plus , Z⊗I) • R (plus , X⊗Y) • R (plus , Y⊗Z) • R (plus , X⊗Z) • R (plus , Z⊗X) • CZ • H0 • H1 • CZ • H0 • S0 • S0 • H0 • H1 • S1 • S1 • H1 • W ^ 6 • W ^ 2 • H1 • S1⁻¹ • S1⁻¹ • H1 • H0 • S0⁻¹ • S0⁻¹ • H0 • CZ • H1 • H0 • CZ • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • S1 • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • H1 • S0 • CZ • H0 • T0⁻¹ • H0 • CZ • S0⁻¹ • H1 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0⁻¹ • T0 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • R (plus , Y⊗X) • R (plus , Z⊗Y) • R (plus , Z⊗X) • CZ • H0 • H1 • CZ • H0 • S0 • S0 • H0 • H1 • S1 • S1 • H1 • W ^ 6 • ε
          by clifford-tactic 77 0 10000 auto
      equals R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , I⊗Y) • R (plus , Y⊗Z) • R (plus , Z⊗Y) • R (plus , X⊗Y) • R (plus , Z⊗I) • R (plus , X⊗Y) • R (plus , Y⊗Z) • R (plus , X⊗Z) • R (plus , Z⊗X) • CZ • H0 • H1 • CZ • H0 • S0 • S0 • H0 • H1 • S1 • S1 • H1 • W ^ 6 • W ^ 2 • H1 • S1⁻¹ • S1⁻¹ • H1 • H0 • S0⁻¹ • S0⁻¹ • H0 • CZ • H1 • H0 • CZ • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • S1 • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • H1 • S0 • CZ • H0 • T0⁻¹ • H0 • CZ • S0⁻¹ • H1 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • R (plus , Y⊗X) • R (plus , Z⊗Y) • R (plus , Z⊗X) • CZ • H0 • H1 • CZ • H0 • S0 • S0 • H0 • H1 • S1 • S1 • H1 • W ^ 6 • ε
          by general-assoc auto
      equals R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , I⊗Y) • R (plus , Y⊗Z) • R (plus , Z⊗Y) • R (plus , X⊗Y) • R (plus , Z⊗I) • R (plus , X⊗Y) • R (plus , Y⊗Z) • R (plus , X⊗Z) • R (plus , Z⊗X) • CZ • H0 • H1 • CZ • H0 • S0 • S0 • H0 • H1 • S1 • S1 • H1 • W ^ 6 • W ^ 2 • H1 • S1⁻¹ • S1⁻¹ • H1 • H0 • S0⁻¹ • S0⁻¹ • H0 • CZ • H1 • H0 • CZ • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • S1 • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • H1 • S0 • CZ • H0 • T0⁻¹ • H0 • CZ • S0⁻¹ • H1 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • R (plus , I⊗Z) • R (plus , Y⊗X) • R (plus , Z⊗Y) • R (plus , Z⊗X) • CZ • H0 • H1 • CZ • H0 • S0 • S0 • H0 • H1 • S1 • S1 • H1 • W ^ 6 • ε
          by clifford-tactic 86 0 10000 auto
      equals R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , I⊗Y) • R (plus , Y⊗Z) • R (plus , Z⊗Y) • R (plus , X⊗Y) • R (plus , Z⊗I) • R (plus , X⊗Y) • R (plus , Y⊗Z) • R (plus , X⊗Z) • R (plus , Z⊗X) • CZ • H0 • H1 • CZ • H0 • S0 • S0 • H0 • H1 • S1 • S1 • H1 • W ^ 6 • W ^ 2 • H1 • S1⁻¹ • S1⁻¹ • H1 • H0 • S0⁻¹ • S0⁻¹ • H0 • CZ • H1 • H0 • CZ • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • S1 • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • H1 • S0 • CZ • H0 • T0⁻¹ • H0 • CZ • S0⁻¹ • H1 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • S1 • H1 • H0 • CZ • H0 • H0 • CZ • H0 • H1 • S1⁻¹ • R (plus , I⊗Z) • R (plus , Y⊗X) • R (plus , Z⊗Y) • R (plus , Z⊗X) • CZ • H0 • H1 • CZ • H0 • S0 • S0 • H0 • H1 • S1 • S1 • H1 • W ^ 6 • ε
          by in-context 91 0 auto (symm lemma-order-T0)
      equals R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , I⊗Y) • R (plus , Y⊗Z) • R (plus , Z⊗Y) • R (plus , X⊗Y) • R (plus , Z⊗I) • R (plus , X⊗Y) • R (plus , Y⊗Z) • R (plus , X⊗Z) • R (plus , Z⊗X) • CZ • H0 • H1 • CZ • H0 • S0 • S0 • H0 • H1 • S1 • S1 • H1 • W ^ 6 • W ^ 2 • H1 • S1⁻¹ • S1⁻¹ • H1 • H0 • S0⁻¹ • S0⁻¹ • H0 • CZ • H1 • H0 • CZ • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • S1 • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • H1 • S0 • CZ • H0 • T0⁻¹ • H0 • CZ • S0⁻¹ • H1 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • S1 • H1 • H0 • CZ • H0 • T0 • T0 • T0 • T0 • T0 • T0 • T0 • T0 • H0 • CZ • H0 • H1 • S1⁻¹ • R (plus , I⊗Z) • R (plus , Y⊗X) • R (plus , Z⊗Y) • R (plus , Z⊗X) • CZ • H0 • H1 • CZ • H0 • S0 • S0 • H0 • H1 • S1 • S1 • H1 • W ^ 6 • ε
          by general-assoc auto
      equals R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , I⊗Y) • R (plus , Y⊗Z) • R (plus , Z⊗Y) • R (plus , X⊗Y) • R (plus , Z⊗I) • R (plus , X⊗Y) • R (plus , Y⊗Z) • R (plus , X⊗Z) • R (plus , Z⊗X) • CZ • H0 • H1 • CZ • H0 • S0 • S0 • H0 • H1 • S1 • S1 • H1 • W ^ 6 • W ^ 2 • H1 • S1⁻¹ • S1⁻¹ • H1 • H0 • S0⁻¹ • S0⁻¹ • H0 • CZ • H1 • H0 • CZ • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • S1 • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • H1 • S0 • CZ • H0 • T0⁻¹ • H0 • CZ • S0⁻¹ • H1 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • S1 • H1 • H0 • CZ • H0 • T0⁻¹ • T0 • H0 • CZ • H0 • H1 • S1⁻¹ • R (plus , I⊗Z) • R (plus , Y⊗X) • R (plus , Z⊗Y) • R (plus , Z⊗X) • CZ • H0 • H1 • CZ • H0 • S0 • S0 • H0 • H1 • S1 • S1 • H1 • W ^ 6 • ε
          by clifford-tactic 92 0 10000 auto
      equals R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , I⊗Y) • R (plus , Y⊗Z) • R (plus , Z⊗Y) • R (plus , X⊗Y) • R (plus , Z⊗I) • R (plus , X⊗Y) • R (plus , Y⊗Z) • R (plus , X⊗Z) • R (plus , Z⊗X) • CZ • H0 • H1 • CZ • H0 • S0 • S0 • H0 • H1 • S1 • S1 • H1 • W ^ 6 • W ^ 2 • H1 • S1⁻¹ • S1⁻¹ • H1 • H0 • S0⁻¹ • S0⁻¹ • H0 • CZ • H1 • H0 • CZ • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • S1 • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • H1 • S0 • CZ • H0 • T0⁻¹ • H0 • CZ • S0⁻¹ • H1 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • S1 • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • S1 • H1 • H0 • CZ • H0 • T0 • H0 • CZ • H0 • H1 • S1⁻¹ • R (plus , I⊗Z) • R (plus , Y⊗X) • R (plus , Z⊗Y) • R (plus , Z⊗X) • CZ • H0 • H1 • CZ • H0 • S0 • S0 • H0 • H1 • S1 • S1 • H1 • W ^ 6 • ε
          by general-assoc auto
      equals R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , I⊗Y) • R (plus , Y⊗Z) • R (plus , Z⊗Y) • R (plus , X⊗Y) • R (plus , Z⊗I) • R (plus , X⊗Y) • R (plus , Y⊗Z) • R (plus , X⊗Z) • R (plus , Z⊗X) • CZ • H0 • H1 • CZ • H0 • S0 • S0 • H0 • H1 • S1 • S1 • H1 • W ^ 6 • W ^ 2 • H1 • S1⁻¹ • S1⁻¹ • H1 • H0 • S0⁻¹ • S0⁻¹ • H0 • CZ • H1 • H0 • CZ • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • S1 • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • H1 • S0 • CZ • H0 • T0⁻¹ • H0 • CZ • S0⁻¹ • H1 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • S1 • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Y⊗X) • R (plus , Z⊗Y) • R (plus , Z⊗X) • CZ • H0 • H1 • CZ • H0 • S0 • S0 • H0 • H1 • S1 • S1 • H1 • W ^ 6 • ε
          by clifford-tactic 97 0 10000 auto
      equals R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , I⊗Y) • R (plus , Y⊗Z) • R (plus , Z⊗Y) • R (plus , X⊗Y) • R (plus , Z⊗I) • R (plus , X⊗Y) • R (plus , Y⊗Z) • R (plus , X⊗Z) • R (plus , Z⊗X) • CZ • H0 • H1 • CZ • H0 • S0 • S0 • H0 • H1 • S1 • S1 • H1 • W ^ 6 • W ^ 2 • H1 • S1⁻¹ • S1⁻¹ • H1 • H0 • S0⁻¹ • S0⁻¹ • H0 • CZ • H1 • H0 • CZ • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • S1 • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • H1 • S0 • CZ • H0 • T0⁻¹ • H0 • CZ • S0⁻¹ • H1 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • S1 • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • H1 • S0 • CZ • H0 • H0 • CZ • S0⁻¹ • H1 • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Y⊗X) • R (plus , Z⊗Y) • R (plus , Z⊗X) • CZ • H0 • H1 • CZ • H0 • S0 • S0 • H0 • H1 • S1 • S1 • H1 • W ^ 6 • ε
          by in-context 101 0 auto (symm lemma-order-T0)
      equals R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , I⊗Y) • R (plus , Y⊗Z) • R (plus , Z⊗Y) • R (plus , X⊗Y) • R (plus , Z⊗I) • R (plus , X⊗Y) • R (plus , Y⊗Z) • R (plus , X⊗Z) • R (plus , Z⊗X) • CZ • H0 • H1 • CZ • H0 • S0 • S0 • H0 • H1 • S1 • S1 • H1 • W ^ 6 • W ^ 2 • H1 • S1⁻¹ • S1⁻¹ • H1 • H0 • S0⁻¹ • S0⁻¹ • H0 • CZ • H1 • H0 • CZ • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • S1 • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • H1 • S0 • CZ • H0 • T0⁻¹ • H0 • CZ • S0⁻¹ • H1 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • S1 • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • H1 • S0 • CZ • H0 • T0 • T0 • T0 • T0 • T0 • T0 • T0 • T0 • H0 • CZ • S0⁻¹ • H1 • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Y⊗X) • R (plus , Z⊗Y) • R (plus , Z⊗X) • CZ • H0 • H1 • CZ • H0 • S0 • S0 • H0 • H1 • S1 • S1 • H1 • W ^ 6 • ε
          by general-assoc auto
      equals R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , I⊗Y) • R (plus , Y⊗Z) • R (plus , Z⊗Y) • R (plus , X⊗Y) • R (plus , Z⊗I) • R (plus , X⊗Y) • R (plus , Y⊗Z) • R (plus , X⊗Z) • R (plus , Z⊗X) • CZ • H0 • H1 • CZ • H0 • S0 • S0 • H0 • H1 • S1 • S1 • H1 • W ^ 6 • W ^ 2 • H1 • S1⁻¹ • S1⁻¹ • H1 • H0 • S0⁻¹ • S0⁻¹ • H0 • CZ • H1 • H0 • CZ • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • S1 • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • H1 • S0 • CZ • H0 • T0⁻¹ • H0 • CZ • S0⁻¹ • H1 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • S1 • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • H1 • S0 • CZ • H0 • T0⁻¹ • T0 • H0 • CZ • S0⁻¹ • H1 • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Y⊗X) • R (plus , Z⊗Y) • R (plus , Z⊗X) • CZ • H0 • H1 • CZ • H0 • S0 • S0 • H0 • H1 • S1 • S1 • H1 • W ^ 6 • ε
          by clifford-tactic 102 0 10000 auto
      equals R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , I⊗Y) • R (plus , Y⊗Z) • R (plus , Z⊗Y) • R (plus , X⊗Y) • R (plus , Z⊗I) • R (plus , X⊗Y) • R (plus , Y⊗Z) • R (plus , X⊗Z) • R (plus , Z⊗X) • CZ • H0 • H1 • CZ • H0 • S0 • S0 • H0 • H1 • S1 • S1 • H1 • W ^ 6 • W ^ 2 • H1 • S1⁻¹ • S1⁻¹ • H1 • H0 • S0⁻¹ • S0⁻¹ • H0 • CZ • H1 • H0 • CZ • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • S1 • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • H1 • S0 • CZ • H0 • T0⁻¹ • H0 • CZ • S0⁻¹ • H1 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • S1 • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • H1 • S0 • CZ • H0 • T0⁻¹ • H0 • CZ • S0⁻¹ • H1 • H1 • S0 • CZ • H0 • T0 • H0 • CZ • S0⁻¹ • H1 • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Y⊗X) • R (plus , Z⊗Y) • R (plus , Z⊗X) • CZ • H0 • H1 • CZ • H0 • S0 • S0 • H0 • H1 • S1 • S1 • H1 • W ^ 6 • ε
          by general-assoc auto
      equals R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , I⊗Y) • R (plus , Y⊗Z) • R (plus , Z⊗Y) • R (plus , X⊗Y) • R (plus , Z⊗I) • R (plus , X⊗Y) • R (plus , Y⊗Z) • R (plus , X⊗Z) • R (plus , Z⊗X) • CZ • H0 • H1 • CZ • H0 • S0 • S0 • H0 • H1 • S1 • S1 • H1 • W ^ 6 • W ^ 2 • H1 • S1⁻¹ • S1⁻¹ • H1 • H0 • S0⁻¹ • S0⁻¹ • H0 • CZ • H1 • H0 • CZ • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • S1 • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • H1 • S0 • CZ • H0 • T0⁻¹ • H0 • CZ • S0⁻¹ • H1 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • S1 • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • H1 • S0 • CZ • H0 • T0⁻¹ • H0 • CZ • S0⁻¹ • H1 • R (plus , Y⊗X) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Y⊗X) • R (plus , Z⊗Y) • R (plus , Z⊗X) • CZ • H0 • H1 • CZ • H0 • S0 • S0 • H0 • H1 • S1 • S1 • H1 • W ^ 6 • ε
          by clifford-tactic 106 0 10000 auto
      equals R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , I⊗Y) • R (plus , Y⊗Z) • R (plus , Z⊗Y) • R (plus , X⊗Y) • R (plus , Z⊗I) • R (plus , X⊗Y) • R (plus , Y⊗Z) • R (plus , X⊗Z) • R (plus , Z⊗X) • CZ • H0 • H1 • CZ • H0 • S0 • S0 • H0 • H1 • S1 • S1 • H1 • W ^ 6 • W ^ 2 • H1 • S1⁻¹ • S1⁻¹ • H1 • H0 • S0⁻¹ • S0⁻¹ • H0 • CZ • H1 • H0 • CZ • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • S1 • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • H1 • S0 • CZ • H0 • T0⁻¹ • H0 • CZ • S0⁻¹ • H1 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • S1 • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • H1 • S0 • CZ • H0 • T0⁻¹ • H0 • CZ • S0⁻¹ • H1 • CZ • H0 • H0 • CZ • R (plus , Y⊗X) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Y⊗X) • R (plus , Z⊗Y) • R (plus , Z⊗X) • CZ • H0 • H1 • CZ • H0 • S0 • S0 • H0 • H1 • S1 • S1 • H1 • W ^ 6 • ε
          by in-context 108 0 auto (symm lemma-order-T0)
      equals R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , I⊗Y) • R (plus , Y⊗Z) • R (plus , Z⊗Y) • R (plus , X⊗Y) • R (plus , Z⊗I) • R (plus , X⊗Y) • R (plus , Y⊗Z) • R (plus , X⊗Z) • R (plus , Z⊗X) • CZ • H0 • H1 • CZ • H0 • S0 • S0 • H0 • H1 • S1 • S1 • H1 • W ^ 6 • W ^ 2 • H1 • S1⁻¹ • S1⁻¹ • H1 • H0 • S0⁻¹ • S0⁻¹ • H0 • CZ • H1 • H0 • CZ • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • S1 • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • H1 • S0 • CZ • H0 • T0⁻¹ • H0 • CZ • S0⁻¹ • H1 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • S1 • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • H1 • S0 • CZ • H0 • T0⁻¹ • H0 • CZ • S0⁻¹ • H1 • CZ • H0 • T0 • T0 • T0 • T0 • T0 • T0 • T0 • T0 • H0 • CZ • R (plus , Y⊗X) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Y⊗X) • R (plus , Z⊗Y) • R (plus , Z⊗X) • CZ • H0 • H1 • CZ • H0 • S0 • S0 • H0 • H1 • S1 • S1 • H1 • W ^ 6 • ε
          by general-assoc auto
      equals R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , I⊗Y) • R (plus , Y⊗Z) • R (plus , Z⊗Y) • R (plus , X⊗Y) • R (plus , Z⊗I) • R (plus , X⊗Y) • R (plus , Y⊗Z) • R (plus , X⊗Z) • R (plus , Z⊗X) • CZ • H0 • H1 • CZ • H0 • S0 • S0 • H0 • H1 • S1 • S1 • H1 • W ^ 6 • W ^ 2 • H1 • S1⁻¹ • S1⁻¹ • H1 • H0 • S0⁻¹ • S0⁻¹ • H0 • CZ • H1 • H0 • CZ • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • S1 • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • H1 • S0 • CZ • H0 • T0⁻¹ • H0 • CZ • S0⁻¹ • H1 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • S1 • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • H1 • S0 • CZ • H0 • T0⁻¹ • H0 • CZ • S0⁻¹ • H1 • CZ • H0 • T0⁻¹ • T0 • H0 • CZ • R (plus , Y⊗X) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Y⊗X) • R (plus , Z⊗Y) • R (plus , Z⊗X) • CZ • H0 • H1 • CZ • H0 • S0 • S0 • H0 • H1 • S1 • S1 • H1 • W ^ 6 • ε
          by clifford-tactic 109 0 10000 auto
      equals R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , I⊗Y) • R (plus , Y⊗Z) • R (plus , Z⊗Y) • R (plus , X⊗Y) • R (plus , Z⊗I) • R (plus , X⊗Y) • R (plus , Y⊗Z) • R (plus , X⊗Z) • R (plus , Z⊗X) • CZ • H0 • H1 • CZ • H0 • S0 • S0 • H0 • H1 • S1 • S1 • H1 • W ^ 6 • W ^ 2 • H1 • S1⁻¹ • S1⁻¹ • H1 • H0 • S0⁻¹ • S0⁻¹ • H0 • CZ • H1 • H0 • CZ • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • S1 • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • H1 • S0 • CZ • H0 • T0⁻¹ • H0 • CZ • S0⁻¹ • H1 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • S1 • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • H1 • S0 • CZ • H0 • T0⁻¹ • H0 • CZ • S0⁻¹ • H1 • CZ • H0 • T0⁻¹ • H0 • CZ • CZ • H0 • T0 • H0 • CZ • R (plus , Y⊗X) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Y⊗X) • R (plus , Z⊗Y) • R (plus , Z⊗X) • CZ • H0 • H1 • CZ • H0 • S0 • S0 • H0 • H1 • S1 • S1 • H1 • W ^ 6 • ε
          by general-assoc auto
      equals R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , I⊗Y) • R (plus , Y⊗Z) • R (plus , Z⊗Y) • R (plus , X⊗Y) • R (plus , Z⊗I) • R (plus , X⊗Y) • R (plus , Y⊗Z) • R (plus , X⊗Z) • R (plus , Z⊗X) • CZ • H0 • H1 • CZ • H0 • S0 • S0 • H0 • H1 • S1 • S1 • H1 • W ^ 6 • W ^ 2 • H1 • S1⁻¹ • S1⁻¹ • H1 • H0 • S0⁻¹ • S0⁻¹ • H0 • CZ • H1 • H0 • CZ • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • S1 • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • H1 • S0 • CZ • H0 • T0⁻¹ • H0 • CZ • S0⁻¹ • H1 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • S1 • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • H1 • S0 • CZ • H0 • T0⁻¹ • H0 • CZ • S0⁻¹ • H1 • CZ • H0 • T0⁻¹ • H0 • CZ • R (plus , X⊗Z) • R (plus , Y⊗X) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Y⊗X) • R (plus , Z⊗Y) • R (plus , Z⊗X) • CZ • H0 • H1 • CZ • H0 • S0 • S0 • H0 • H1 • S1 • S1 • H1 • W ^ 6 • ε
          by clifford-tactic 111 0 10000 auto
      equals R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , I⊗Y) • R (plus , Y⊗Z) • R (plus , Z⊗Y) • R (plus , X⊗Y) • R (plus , Z⊗I) • R (plus , X⊗Y) • R (plus , Y⊗Z) • R (plus , X⊗Z) • R (plus , Z⊗X) • CZ • H0 • H1 • CZ • H0 • S0 • S0 • H0 • H1 • S1 • S1 • H1 • W ^ 6 • W ^ 2 • H1 • S1⁻¹ • S1⁻¹ • H1 • H0 • S0⁻¹ • S0⁻¹ • H0 • CZ • H1 • H0 • CZ • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • S1 • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • H1 • S0 • CZ • H0 • T0⁻¹ • H0 • CZ • S0⁻¹ • H1 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • S1 • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • H1 • S0 • CZ • H0 • T0⁻¹ • H0 • CZ • S0⁻¹ • H1 • CZ • H0 • T0⁻¹ • H0 • CZ • S0 • CZ • H0 • H0 • CZ • S0⁻¹ • R (plus , X⊗Z) • R (plus , Y⊗X) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Y⊗X) • R (plus , Z⊗Y) • R (plus , Z⊗X) • CZ • H0 • H1 • CZ • H0 • S0 • S0 • H0 • H1 • S1 • S1 • H1 • W ^ 6 • ε
          by in-context 114 0 auto (symm lemma-order-T0)
      equals R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , I⊗Y) • R (plus , Y⊗Z) • R (plus , Z⊗Y) • R (plus , X⊗Y) • R (plus , Z⊗I) • R (plus , X⊗Y) • R (plus , Y⊗Z) • R (plus , X⊗Z) • R (plus , Z⊗X) • CZ • H0 • H1 • CZ • H0 • S0 • S0 • H0 • H1 • S1 • S1 • H1 • W ^ 6 • W ^ 2 • H1 • S1⁻¹ • S1⁻¹ • H1 • H0 • S0⁻¹ • S0⁻¹ • H0 • CZ • H1 • H0 • CZ • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • S1 • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • H1 • S0 • CZ • H0 • T0⁻¹ • H0 • CZ • S0⁻¹ • H1 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • S1 • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • H1 • S0 • CZ • H0 • T0⁻¹ • H0 • CZ • S0⁻¹ • H1 • CZ • H0 • T0⁻¹ • H0 • CZ • S0 • CZ • H0 • T0 • T0 • T0 • T0 • T0 • T0 • T0 • T0 • H0 • CZ • S0⁻¹ • R (plus , X⊗Z) • R (plus , Y⊗X) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Y⊗X) • R (plus , Z⊗Y) • R (plus , Z⊗X) • CZ • H0 • H1 • CZ • H0 • S0 • S0 • H0 • H1 • S1 • S1 • H1 • W ^ 6 • ε
          by general-assoc auto
      equals R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , I⊗Y) • R (plus , Y⊗Z) • R (plus , Z⊗Y) • R (plus , X⊗Y) • R (plus , Z⊗I) • R (plus , X⊗Y) • R (plus , Y⊗Z) • R (plus , X⊗Z) • R (plus , Z⊗X) • CZ • H0 • H1 • CZ • H0 • S0 • S0 • H0 • H1 • S1 • S1 • H1 • W ^ 6 • W ^ 2 • H1 • S1⁻¹ • S1⁻¹ • H1 • H0 • S0⁻¹ • S0⁻¹ • H0 • CZ • H1 • H0 • CZ • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • S1 • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • H1 • S0 • CZ • H0 • T0⁻¹ • H0 • CZ • S0⁻¹ • H1 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • S1 • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • H1 • S0 • CZ • H0 • T0⁻¹ • H0 • CZ • S0⁻¹ • H1 • CZ • H0 • T0⁻¹ • H0 • CZ • S0 • CZ • H0 • T0⁻¹ • T0 • H0 • CZ • S0⁻¹ • R (plus , X⊗Z) • R (plus , Y⊗X) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Y⊗X) • R (plus , Z⊗Y) • R (plus , Z⊗X) • CZ • H0 • H1 • CZ • H0 • S0 • S0 • H0 • H1 • S1 • S1 • H1 • W ^ 6 • ε
          by clifford-tactic 115 0 10000 auto
      equals R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , I⊗Y) • R (plus , Y⊗Z) • R (plus , Z⊗Y) • R (plus , X⊗Y) • R (plus , Z⊗I) • R (plus , X⊗Y) • R (plus , Y⊗Z) • R (plus , X⊗Z) • R (plus , Z⊗X) • CZ • H0 • H1 • CZ • H0 • S0 • S0 • H0 • H1 • S1 • S1 • H1 • W ^ 6 • W ^ 2 • H1 • S1⁻¹ • S1⁻¹ • H1 • H0 • S0⁻¹ • S0⁻¹ • H0 • CZ • H1 • H0 • CZ • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • S1 • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • H1 • S0 • CZ • H0 • T0⁻¹ • H0 • CZ • S0⁻¹ • H1 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • S1 • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • H1 • S0 • CZ • H0 • T0⁻¹ • H0 • CZ • S0⁻¹ • H1 • CZ • H0 • T0⁻¹ • H0 • CZ • S0 • CZ • H0 • T0⁻¹ • H0 • CZ • S0⁻¹ • S0 • CZ • H0 • T0 • H0 • CZ • S0⁻¹ • R (plus , X⊗Z) • R (plus , Y⊗X) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Y⊗X) • R (plus , Z⊗Y) • R (plus , Z⊗X) • CZ • H0 • H1 • CZ • H0 • S0 • S0 • H0 • H1 • S1 • S1 • H1 • W ^ 6 • ε
          by general-assoc auto
      equals R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , I⊗Y) • R (plus , Y⊗Z) • R (plus , Z⊗Y) • R (plus , X⊗Y) • R (plus , Z⊗I) • R (plus , X⊗Y) • R (plus , Y⊗Z) • R (plus , X⊗Z) • R (plus , Z⊗X) • CZ • H0 • H1 • CZ • H0 • S0 • S0 • H0 • H1 • S1 • S1 • H1 • W ^ 6 • W ^ 2 • H1 • S1⁻¹ • S1⁻¹ • H1 • H0 • S0⁻¹ • S0⁻¹ • H0 • CZ • H1 • H0 • CZ • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • S1 • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • H1 • S0 • CZ • H0 • T0⁻¹ • H0 • CZ • S0⁻¹ • H1 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • S1 • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • H1 • S0 • CZ • H0 • T0⁻¹ • H0 • CZ • S0⁻¹ • H1 • CZ • H0 • T0⁻¹ • H0 • CZ • S0 • CZ • H0 • T0⁻¹ • H0 • CZ • S0⁻¹ • R (plus , Y⊗Z) • R (plus , X⊗Z) • R (plus , Y⊗X) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Y⊗X) • R (plus , Z⊗Y) • R (plus , Z⊗X) • CZ • H0 • H1 • CZ • H0 • S0 • S0 • H0 • H1 • S1 • S1 • H1 • W ^ 6 • ε
          by clifford-tactic 118 0 10000 auto
      equals R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , I⊗Y) • R (plus , Y⊗Z) • R (plus , Z⊗Y) • R (plus , X⊗Y) • R (plus , Z⊗I) • R (plus , X⊗Y) • R (plus , Y⊗Z) • R (plus , X⊗Z) • R (plus , Z⊗X) • CZ • H0 • H1 • CZ • H0 • S0 • S0 • H0 • H1 • S1 • S1 • H1 • W ^ 6 • W ^ 2 • H1 • S1⁻¹ • S1⁻¹ • H1 • H0 • S0⁻¹ • S0⁻¹ • H0 • CZ • H1 • H0 • CZ • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • S1 • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • H1 • S0 • CZ • H0 • T0⁻¹ • H0 • CZ • S0⁻¹ • H1 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • S1 • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • H1 • S0 • CZ • H0 • T0⁻¹ • H0 • CZ • S0⁻¹ • H1 • CZ • H0 • T0⁻¹ • H0 • CZ • S0 • CZ • H0 • T0⁻¹ • H0 • CZ • S0⁻¹ • S0 • H0 • H0 • S0⁻¹ • R (plus , Y⊗Z) • R (plus , X⊗Z) • R (plus , Y⊗X) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Y⊗X) • R (plus , Z⊗Y) • R (plus , Z⊗X) • CZ • H0 • H1 • CZ • H0 • S0 • S0 • H0 • H1 • S1 • S1 • H1 • W ^ 6 • ε
          by in-context 120 0 auto (symm lemma-order-T0)
      equals R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , I⊗Y) • R (plus , Y⊗Z) • R (plus , Z⊗Y) • R (plus , X⊗Y) • R (plus , Z⊗I) • R (plus , X⊗Y) • R (plus , Y⊗Z) • R (plus , X⊗Z) • R (plus , Z⊗X) • CZ • H0 • H1 • CZ • H0 • S0 • S0 • H0 • H1 • S1 • S1 • H1 • W ^ 6 • W ^ 2 • H1 • S1⁻¹ • S1⁻¹ • H1 • H0 • S0⁻¹ • S0⁻¹ • H0 • CZ • H1 • H0 • CZ • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • S1 • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • H1 • S0 • CZ • H0 • T0⁻¹ • H0 • CZ • S0⁻¹ • H1 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • S1 • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • H1 • S0 • CZ • H0 • T0⁻¹ • H0 • CZ • S0⁻¹ • H1 • CZ • H0 • T0⁻¹ • H0 • CZ • S0 • CZ • H0 • T0⁻¹ • H0 • CZ • S0⁻¹ • S0 • H0 • T0 • T0 • T0 • T0 • T0 • T0 • T0 • T0 • H0 • S0⁻¹ • R (plus , Y⊗Z) • R (plus , X⊗Z) • R (plus , Y⊗X) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Y⊗X) • R (plus , Z⊗Y) • R (plus , Z⊗X) • CZ • H0 • H1 • CZ • H0 • S0 • S0 • H0 • H1 • S1 • S1 • H1 • W ^ 6 • ε
          by general-assoc auto
      equals R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , I⊗Y) • R (plus , Y⊗Z) • R (plus , Z⊗Y) • R (plus , X⊗Y) • R (plus , Z⊗I) • R (plus , X⊗Y) • R (plus , Y⊗Z) • R (plus , X⊗Z) • R (plus , Z⊗X) • CZ • H0 • H1 • CZ • H0 • S0 • S0 • H0 • H1 • S1 • S1 • H1 • W ^ 6 • W ^ 2 • H1 • S1⁻¹ • S1⁻¹ • H1 • H0 • S0⁻¹ • S0⁻¹ • H0 • CZ • H1 • H0 • CZ • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • S1 • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • H1 • S0 • CZ • H0 • T0⁻¹ • H0 • CZ • S0⁻¹ • H1 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • S1 • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • H1 • S0 • CZ • H0 • T0⁻¹ • H0 • CZ • S0⁻¹ • H1 • CZ • H0 • T0⁻¹ • H0 • CZ • S0 • CZ • H0 • T0⁻¹ • H0 • CZ • S0⁻¹ • S0 • H0 • T0⁻¹ • T0 • H0 • S0⁻¹ • R (plus , Y⊗Z) • R (plus , X⊗Z) • R (plus , Y⊗X) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Y⊗X) • R (plus , Z⊗Y) • R (plus , Z⊗X) • CZ • H0 • H1 • CZ • H0 • S0 • S0 • H0 • H1 • S1 • S1 • H1 • W ^ 6 • ε
          by clifford-tactic 121 0 10000 auto
      equals R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , I⊗Y) • R (plus , Y⊗Z) • R (plus , Z⊗Y) • R (plus , X⊗Y) • R (plus , Z⊗I) • R (plus , X⊗Y) • R (plus , Y⊗Z) • R (plus , X⊗Z) • R (plus , Z⊗X) • CZ • H0 • H1 • CZ • H0 • S0 • S0 • H0 • H1 • S1 • S1 • H1 • W ^ 6 • W ^ 2 • H1 • S1⁻¹ • S1⁻¹ • H1 • H0 • S0⁻¹ • S0⁻¹ • H0 • CZ • H1 • H0 • CZ • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • S1 • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • H1 • S0 • CZ • H0 • T0⁻¹ • H0 • CZ • S0⁻¹ • H1 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • S1 • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • H1 • S0 • CZ • H0 • T0⁻¹ • H0 • CZ • S0⁻¹ • H1 • CZ • H0 • T0⁻¹ • H0 • CZ • S0 • CZ • H0 • T0⁻¹ • H0 • CZ • S0⁻¹ • S0 • H0 • T0⁻¹ • H0 • S0⁻¹ • S0 • H0 • T0 • H0 • S0⁻¹ • R (plus , Y⊗Z) • R (plus , X⊗Z) • R (plus , Y⊗X) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Y⊗X) • R (plus , Z⊗Y) • R (plus , Z⊗X) • CZ • H0 • H1 • CZ • H0 • S0 • S0 • H0 • H1 • S1 • S1 • H1 • W ^ 6 • ε
          by general-assoc auto
      equals R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , I⊗Y) • R (plus , Y⊗Z) • R (plus , Z⊗Y) • R (plus , X⊗Y) • R (plus , Z⊗I) • R (plus , X⊗Y) • R (plus , Y⊗Z) • R (plus , X⊗Z) • R (plus , Z⊗X) • CZ • H0 • H1 • CZ • H0 • S0 • S0 • H0 • H1 • S1 • S1 • H1 • W ^ 6 • W ^ 2 • H1 • S1⁻¹ • S1⁻¹ • H1 • H0 • S0⁻¹ • S0⁻¹ • H0 • CZ • H1 • H0 • CZ • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • S1 • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • H1 • S0 • CZ • H0 • T0⁻¹ • H0 • CZ • S0⁻¹ • H1 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • S1 • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • H1 • S0 • CZ • H0 • T0⁻¹ • H0 • CZ • S0⁻¹ • H1 • CZ • H0 • T0⁻¹ • H0 • CZ • S0 • CZ • H0 • T0⁻¹ • H0 • CZ • S0⁻¹ • S0 • H0 • T0⁻¹ • H0 • S0⁻¹ • R (plus , Y⊗I) • R (plus , Y⊗Z) • R (plus , X⊗Z) • R (plus , Y⊗X) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Y⊗X) • R (plus , Z⊗Y) • R (plus , Z⊗X) • CZ • H0 • H1 • CZ • H0 • S0 • S0 • H0 • H1 • S1 • S1 • H1 • W ^ 6 • ε
          by in-context 123 0 auto (symm lemma-order-T0)
      equals R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , I⊗Y) • R (plus , Y⊗Z) • R (plus , Z⊗Y) • R (plus , X⊗Y) • R (plus , Z⊗I) • R (plus , X⊗Y) • R (plus , Y⊗Z) • R (plus , X⊗Z) • R (plus , Z⊗X) • CZ • H0 • H1 • CZ • H0 • S0 • S0 • H0 • H1 • S1 • S1 • H1 • W ^ 6 • W ^ 2 • H1 • S1⁻¹ • S1⁻¹ • H1 • H0 • S0⁻¹ • S0⁻¹ • H0 • CZ • H1 • H0 • CZ • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • S1 • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • H1 • S0 • CZ • H0 • T0⁻¹ • H0 • CZ • S0⁻¹ • H1 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • S1 • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • H1 • S0 • CZ • H0 • T0⁻¹ • H0 • CZ • S0⁻¹ • H1 • CZ • H0 • T0⁻¹ • H0 • CZ • S0 • CZ • H0 • T0⁻¹ • H0 • CZ • S0⁻¹ • S0 • H0 • T0⁻¹ • H0 • S0⁻¹ • T0 • T0 • T0 • T0 • T0 • T0 • T0 • T0 • R (plus , Y⊗I) • R (plus , Y⊗Z) • R (plus , X⊗Z) • R (plus , Y⊗X) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Y⊗X) • R (plus , Z⊗Y) • R (plus , Z⊗X) • CZ • H0 • H1 • CZ • H0 • S0 • S0 • H0 • H1 • S1 • S1 • H1 • W ^ 6 • ε
          by general-assoc auto
      equals R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , I⊗Y) • R (plus , Y⊗Z) • R (plus , Z⊗Y) • R (plus , X⊗Y) • R (plus , Z⊗I) • R (plus , X⊗Y) • R (plus , Y⊗Z) • R (plus , X⊗Z) • R (plus , Z⊗X) • CZ • H0 • H1 • CZ • H0 • S0 • S0 • H0 • H1 • S1 • S1 • H1 • W ^ 6 • W ^ 2 • H1 • S1⁻¹ • S1⁻¹ • H1 • H0 • S0⁻¹ • S0⁻¹ • H0 • CZ • H1 • H0 • CZ • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • S1 • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • H1 • S0 • CZ • H0 • T0⁻¹ • H0 • CZ • S0⁻¹ • H1 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • S1 • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • H1 • S0 • CZ • H0 • T0⁻¹ • H0 • CZ • S0⁻¹ • H1 • CZ • H0 • T0⁻¹ • H0 • CZ • S0 • CZ • H0 • T0⁻¹ • H0 • CZ • S0⁻¹ • S0 • H0 • T0⁻¹ • H0 • S0⁻¹ • T0⁻¹ • R (plus , Z⊗I) • R (plus , Y⊗I) • R (plus , Y⊗Z) • R (plus , X⊗Z) • R (plus , Y⊗X) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Y⊗X) • R (plus , Z⊗Y) • R (plus , Z⊗X) • CZ • H0 • H1 • CZ • H0 • S0 • S0 • H0 • H1 • S1 • S1 • H1 • W ^ 6 • ε
          by clifford-tactic 124 0 10000 auto
      equals R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , I⊗Y) • R (plus , Y⊗Z) • R (plus , Z⊗Y) • R (plus , X⊗Y) • R (plus , Z⊗I) • R (plus , X⊗Y) • R (plus , Y⊗Z) • R (plus , X⊗Z) • R (plus , Z⊗X) • CZ • H0 • H1 • CZ • H0 • S0 • S0 • H0 • H1 • S1 • S1 • H1 • W ^ 6 • W ^ 2 • H1 • S1⁻¹ • S1⁻¹ • H1 • H0 • S0⁻¹ • S0⁻¹ • H0 • CZ • H1 • H0 • CZ • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • S1 • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • H1 • S0 • CZ • H0 • T0⁻¹ • H0 • CZ • S0⁻¹ • H1 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • S1 • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • H1 • S0 • CZ • H0 • T0⁻¹ • H0 • CZ • S0⁻¹ • H1 • CZ • H0 • T0⁻¹ • H0 • CZ • S0 • CZ • H0 • T0⁻¹ • H0 • CZ • S0⁻¹ • S0 • H0 • T0⁻¹ • H0 • S0⁻¹ • T0⁻¹ • S0 • CZ • H0 • H0 • CZ • S0⁻¹ • R (plus , Z⊗I) • R (plus , Y⊗I) • R (plus , Y⊗Z) • R (plus , X⊗Z) • R (plus , Y⊗X) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Y⊗X) • R (plus , Z⊗Y) • R (plus , Z⊗X) • CZ • H0 • H1 • CZ • H0 • S0 • S0 • H0 • H1 • S1 • S1 • H1 • W ^ 6 • ε
          by in-context 127 0 auto (symm lemma-order-T0)
      equals R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , I⊗Y) • R (plus , Y⊗Z) • R (plus , Z⊗Y) • R (plus , X⊗Y) • R (plus , Z⊗I) • R (plus , X⊗Y) • R (plus , Y⊗Z) • R (plus , X⊗Z) • R (plus , Z⊗X) • CZ • H0 • H1 • CZ • H0 • S0 • S0 • H0 • H1 • S1 • S1 • H1 • W ^ 6 • W ^ 2 • H1 • S1⁻¹ • S1⁻¹ • H1 • H0 • S0⁻¹ • S0⁻¹ • H0 • CZ • H1 • H0 • CZ • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • S1 • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • H1 • S0 • CZ • H0 • T0⁻¹ • H0 • CZ • S0⁻¹ • H1 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • S1 • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • H1 • S0 • CZ • H0 • T0⁻¹ • H0 • CZ • S0⁻¹ • H1 • CZ • H0 • T0⁻¹ • H0 • CZ • S0 • CZ • H0 • T0⁻¹ • H0 • CZ • S0⁻¹ • S0 • H0 • T0⁻¹ • H0 • S0⁻¹ • T0⁻¹ • S0 • CZ • H0 • T0 • T0 • T0 • T0 • T0 • T0 • T0 • T0 • H0 • CZ • S0⁻¹ • R (plus , Z⊗I) • R (plus , Y⊗I) • R (plus , Y⊗Z) • R (plus , X⊗Z) • R (plus , Y⊗X) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Y⊗X) • R (plus , Z⊗Y) • R (plus , Z⊗X) • CZ • H0 • H1 • CZ • H0 • S0 • S0 • H0 • H1 • S1 • S1 • H1 • W ^ 6 • ε
          by general-assoc auto
      equals R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , I⊗Y) • R (plus , Y⊗Z) • R (plus , Z⊗Y) • R (plus , X⊗Y) • R (plus , Z⊗I) • R (plus , X⊗Y) • R (plus , Y⊗Z) • R (plus , X⊗Z) • R (plus , Z⊗X) • CZ • H0 • H1 • CZ • H0 • S0 • S0 • H0 • H1 • S1 • S1 • H1 • W ^ 6 • W ^ 2 • H1 • S1⁻¹ • S1⁻¹ • H1 • H0 • S0⁻¹ • S0⁻¹ • H0 • CZ • H1 • H0 • CZ • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • S1 • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • H1 • S0 • CZ • H0 • T0⁻¹ • H0 • CZ • S0⁻¹ • H1 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • S1 • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • H1 • S0 • CZ • H0 • T0⁻¹ • H0 • CZ • S0⁻¹ • H1 • CZ • H0 • T0⁻¹ • H0 • CZ • S0 • CZ • H0 • T0⁻¹ • H0 • CZ • S0⁻¹ • S0 • H0 • T0⁻¹ • H0 • S0⁻¹ • T0⁻¹ • S0 • CZ • H0 • T0⁻¹ • T0 • H0 • CZ • S0⁻¹ • R (plus , Z⊗I) • R (plus , Y⊗I) • R (plus , Y⊗Z) • R (plus , X⊗Z) • R (plus , Y⊗X) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Y⊗X) • R (plus , Z⊗Y) • R (plus , Z⊗X) • CZ • H0 • H1 • CZ • H0 • S0 • S0 • H0 • H1 • S1 • S1 • H1 • W ^ 6 • ε
          by clifford-tactic 128 0 10000 auto
      equals R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , I⊗Y) • R (plus , Y⊗Z) • R (plus , Z⊗Y) • R (plus , X⊗Y) • R (plus , Z⊗I) • R (plus , X⊗Y) • R (plus , Y⊗Z) • R (plus , X⊗Z) • R (plus , Z⊗X) • CZ • H0 • H1 • CZ • H0 • S0 • S0 • H0 • H1 • S1 • S1 • H1 • W ^ 6 • W ^ 2 • H1 • S1⁻¹ • S1⁻¹ • H1 • H0 • S0⁻¹ • S0⁻¹ • H0 • CZ • H1 • H0 • CZ • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • S1 • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • H1 • S0 • CZ • H0 • T0⁻¹ • H0 • CZ • S0⁻¹ • H1 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • S1 • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • H1 • S0 • CZ • H0 • T0⁻¹ • H0 • CZ • S0⁻¹ • H1 • CZ • H0 • T0⁻¹ • H0 • CZ • S0 • CZ • H0 • T0⁻¹ • H0 • CZ • S0⁻¹ • S0 • H0 • T0⁻¹ • H0 • S0⁻¹ • T0⁻¹ • S0 • CZ • H0 • T0⁻¹ • H0 • CZ • S0⁻¹ • S0 • CZ • H0 • T0 • H0 • CZ • S0⁻¹ • R (plus , Z⊗I) • R (plus , Y⊗I) • R (plus , Y⊗Z) • R (plus , X⊗Z) • R (plus , Y⊗X) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Y⊗X) • R (plus , Z⊗Y) • R (plus , Z⊗X) • CZ • H0 • H1 • CZ • H0 • S0 • S0 • H0 • H1 • S1 • S1 • H1 • W ^ 6 • ε
          by general-assoc auto
      equals R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , I⊗Y) • R (plus , Y⊗Z) • R (plus , Z⊗Y) • R (plus , X⊗Y) • R (plus , Z⊗I) • R (plus , X⊗Y) • R (plus , Y⊗Z) • R (plus , X⊗Z) • R (plus , Z⊗X) • CZ • H0 • H1 • CZ • H0 • S0 • S0 • H0 • H1 • S1 • S1 • H1 • W ^ 6 • W ^ 2 • H1 • S1⁻¹ • S1⁻¹ • H1 • H0 • S0⁻¹ • S0⁻¹ • H0 • CZ • H1 • H0 • CZ • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • S1 • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • H1 • S0 • CZ • H0 • T0⁻¹ • H0 • CZ • S0⁻¹ • H1 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • S1 • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • H1 • S0 • CZ • H0 • T0⁻¹ • H0 • CZ • S0⁻¹ • H1 • CZ • H0 • T0⁻¹ • H0 • CZ • S0 • CZ • H0 • T0⁻¹ • H0 • CZ • S0⁻¹ • S0 • H0 • T0⁻¹ • H0 • S0⁻¹ • T0⁻¹ • S0 • CZ • H0 • T0⁻¹ • H0 • CZ • S0⁻¹ • R (plus , Y⊗Z) • R (plus , Z⊗I) • R (plus , Y⊗I) • R (plus , Y⊗Z) • R (plus , X⊗Z) • R (plus , Y⊗X) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Y⊗X) • R (plus , Z⊗Y) • R (plus , Z⊗X) • CZ • H0 • H1 • CZ • H0 • S0 • S0 • H0 • H1 • S1 • S1 • H1 • W ^ 6 • ε
          by clifford-tactic 131 0 10000 auto
      equals R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , I⊗Y) • R (plus , Y⊗Z) • R (plus , Z⊗Y) • R (plus , X⊗Y) • R (plus , Z⊗I) • R (plus , X⊗Y) • R (plus , Y⊗Z) • R (plus , X⊗Z) • R (plus , Z⊗X) • CZ • H0 • H1 • CZ • H0 • S0 • S0 • H0 • H1 • S1 • S1 • H1 • W ^ 6 • W ^ 2 • H1 • S1⁻¹ • S1⁻¹ • H1 • H0 • S0⁻¹ • S0⁻¹ • H0 • CZ • H1 • H0 • CZ • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • S1 • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • H1 • S0 • CZ • H0 • T0⁻¹ • H0 • CZ • S0⁻¹ • H1 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • S1 • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • H1 • S0 • CZ • H0 • T0⁻¹ • H0 • CZ • S0⁻¹ • H1 • CZ • H0 • T0⁻¹ • H0 • CZ • S0 • CZ • H0 • T0⁻¹ • H0 • CZ • S0⁻¹ • S0 • H0 • T0⁻¹ • H0 • S0⁻¹ • T0⁻¹ • S0 • CZ • H0 • T0⁻¹ • H0 • CZ • S0⁻¹ • S0 • H0 • H0 • S0⁻¹ • R (plus , Y⊗Z) • R (plus , Z⊗I) • R (plus , Y⊗I) • R (plus , Y⊗Z) • R (plus , X⊗Z) • R (plus , Y⊗X) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Y⊗X) • R (plus , Z⊗Y) • R (plus , Z⊗X) • CZ • H0 • H1 • CZ • H0 • S0 • S0 • H0 • H1 • S1 • S1 • H1 • W ^ 6 • ε
          by in-context 133 0 auto (symm lemma-order-T0)
      equals R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , I⊗Y) • R (plus , Y⊗Z) • R (plus , Z⊗Y) • R (plus , X⊗Y) • R (plus , Z⊗I) • R (plus , X⊗Y) • R (plus , Y⊗Z) • R (plus , X⊗Z) • R (plus , Z⊗X) • CZ • H0 • H1 • CZ • H0 • S0 • S0 • H0 • H1 • S1 • S1 • H1 • W ^ 6 • W ^ 2 • H1 • S1⁻¹ • S1⁻¹ • H1 • H0 • S0⁻¹ • S0⁻¹ • H0 • CZ • H1 • H0 • CZ • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • S1 • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • H1 • S0 • CZ • H0 • T0⁻¹ • H0 • CZ • S0⁻¹ • H1 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • S1 • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • H1 • S0 • CZ • H0 • T0⁻¹ • H0 • CZ • S0⁻¹ • H1 • CZ • H0 • T0⁻¹ • H0 • CZ • S0 • CZ • H0 • T0⁻¹ • H0 • CZ • S0⁻¹ • S0 • H0 • T0⁻¹ • H0 • S0⁻¹ • T0⁻¹ • S0 • CZ • H0 • T0⁻¹ • H0 • CZ • S0⁻¹ • S0 • H0 • T0 • T0 • T0 • T0 • T0 • T0 • T0 • T0 • H0 • S0⁻¹ • R (plus , Y⊗Z) • R (plus , Z⊗I) • R (plus , Y⊗I) • R (plus , Y⊗Z) • R (plus , X⊗Z) • R (plus , Y⊗X) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Y⊗X) • R (plus , Z⊗Y) • R (plus , Z⊗X) • CZ • H0 • H1 • CZ • H0 • S0 • S0 • H0 • H1 • S1 • S1 • H1 • W ^ 6 • ε
          by general-assoc auto
      equals R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , I⊗Y) • R (plus , Y⊗Z) • R (plus , Z⊗Y) • R (plus , X⊗Y) • R (plus , Z⊗I) • R (plus , X⊗Y) • R (plus , Y⊗Z) • R (plus , X⊗Z) • R (plus , Z⊗X) • CZ • H0 • H1 • CZ • H0 • S0 • S0 • H0 • H1 • S1 • S1 • H1 • W ^ 6 • W ^ 2 • H1 • S1⁻¹ • S1⁻¹ • H1 • H0 • S0⁻¹ • S0⁻¹ • H0 • CZ • H1 • H0 • CZ • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • S1 • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • H1 • S0 • CZ • H0 • T0⁻¹ • H0 • CZ • S0⁻¹ • H1 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • S1 • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • H1 • S0 • CZ • H0 • T0⁻¹ • H0 • CZ • S0⁻¹ • H1 • CZ • H0 • T0⁻¹ • H0 • CZ • S0 • CZ • H0 • T0⁻¹ • H0 • CZ • S0⁻¹ • S0 • H0 • T0⁻¹ • H0 • S0⁻¹ • T0⁻¹ • S0 • CZ • H0 • T0⁻¹ • H0 • CZ • S0⁻¹ • S0 • H0 • T0⁻¹ • T0 • H0 • S0⁻¹ • R (plus , Y⊗Z) • R (plus , Z⊗I) • R (plus , Y⊗I) • R (plus , Y⊗Z) • R (plus , X⊗Z) • R (plus , Y⊗X) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Y⊗X) • R (plus , Z⊗Y) • R (plus , Z⊗X) • CZ • H0 • H1 • CZ • H0 • S0 • S0 • H0 • H1 • S1 • S1 • H1 • W ^ 6 • ε
          by clifford-tactic 134 0 10000 auto
      equals R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , I⊗Y) • R (plus , Y⊗Z) • R (plus , Z⊗Y) • R (plus , X⊗Y) • R (plus , Z⊗I) • R (plus , X⊗Y) • R (plus , Y⊗Z) • R (plus , X⊗Z) • R (plus , Z⊗X) • CZ • H0 • H1 • CZ • H0 • S0 • S0 • H0 • H1 • S1 • S1 • H1 • W ^ 6 • W ^ 2 • H1 • S1⁻¹ • S1⁻¹ • H1 • H0 • S0⁻¹ • S0⁻¹ • H0 • CZ • H1 • H0 • CZ • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • S1 • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • H1 • S0 • CZ • H0 • T0⁻¹ • H0 • CZ • S0⁻¹ • H1 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • S1 • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • H1 • S0 • CZ • H0 • T0⁻¹ • H0 • CZ • S0⁻¹ • H1 • CZ • H0 • T0⁻¹ • H0 • CZ • S0 • CZ • H0 • T0⁻¹ • H0 • CZ • S0⁻¹ • S0 • H0 • T0⁻¹ • H0 • S0⁻¹ • T0⁻¹ • S0 • CZ • H0 • T0⁻¹ • H0 • CZ • S0⁻¹ • S0 • H0 • T0⁻¹ • H0 • S0⁻¹ • S0 • H0 • T0 • H0 • S0⁻¹ • R (plus , Y⊗Z) • R (plus , Z⊗I) • R (plus , Y⊗I) • R (plus , Y⊗Z) • R (plus , X⊗Z) • R (plus , Y⊗X) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Y⊗X) • R (plus , Z⊗Y) • R (plus , Z⊗X) • CZ • H0 • H1 • CZ • H0 • S0 • S0 • H0 • H1 • S1 • S1 • H1 • W ^ 6 • ε
          by general-assoc auto
      equals R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , I⊗Y) • R (plus , Y⊗Z) • R (plus , Z⊗Y) • R (plus , X⊗Y) • R (plus , Z⊗I) • R (plus , X⊗Y) • R (plus , Y⊗Z) • R (plus , X⊗Z) • R (plus , Z⊗X) • CZ • H0 • H1 • CZ • H0 • S0 • S0 • H0 • H1 • S1 • S1 • H1 • W ^ 6 • W ^ 2 • H1 • S1⁻¹ • S1⁻¹ • H1 • H0 • S0⁻¹ • S0⁻¹ • H0 • CZ • H1 • H0 • CZ • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • S1 • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • H1 • S0 • CZ • H0 • T0⁻¹ • H0 • CZ • S0⁻¹ • H1 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • S1 • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • H1 • S0 • CZ • H0 • T0⁻¹ • H0 • CZ • S0⁻¹ • H1 • CZ • H0 • T0⁻¹ • H0 • CZ • S0 • CZ • H0 • T0⁻¹ • H0 • CZ • S0⁻¹ • S0 • H0 • T0⁻¹ • H0 • S0⁻¹ • T0⁻¹ • S0 • CZ • H0 • T0⁻¹ • H0 • CZ • S0⁻¹ • S0 • H0 • T0⁻¹ • H0 • S0⁻¹ • R (plus , Y⊗I) • R (plus , Y⊗Z) • R (plus , Z⊗I) • R (plus , Y⊗I) • R (plus , Y⊗Z) • R (plus , X⊗Z) • R (plus , Y⊗X) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Y⊗X) • R (plus , Z⊗Y) • R (plus , Z⊗X) • CZ • H0 • H1 • CZ • H0 • S0 • S0 • H0 • H1 • S1 • S1 • H1 • W ^ 6 • ε
          by in-context 42 1 auto lemma-R-T0⁻¹
      equals R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , I⊗Y) • R (plus , Y⊗Z) • R (plus , Z⊗Y) • R (plus , X⊗Y) • R (plus , Z⊗I) • R (plus , X⊗Y) • R (plus , Y⊗Z) • R (plus , X⊗Z) • R (plus , Z⊗X) • CZ • H0 • H1 • CZ • H0 • S0 • S0 • H0 • H1 • S1 • S1 • H1 • W ^ 6 • W ^ 2 • H1 • S1⁻¹ • S1⁻¹ • H1 • H0 • S0⁻¹ • S0⁻¹ • H0 • CZ • H1 • H0 • CZ • H1 • H0 • CZ • H0 • R (plus , Z⊗I) • S0⁻¹ • H0 • CZ • H0 • H1 • S1 • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • H1 • S0 • CZ • H0 • T0⁻¹ • H0 • CZ • S0⁻¹ • H1 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • S1 • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • H1 • S0 • CZ • H0 • T0⁻¹ • H0 • CZ • S0⁻¹ • H1 • CZ • H0 • T0⁻¹ • H0 • CZ • S0 • CZ • H0 • T0⁻¹ • H0 • CZ • S0⁻¹ • S0 • H0 • T0⁻¹ • H0 • S0⁻¹ • T0⁻¹ • S0 • CZ • H0 • T0⁻¹ • H0 • CZ • S0⁻¹ • S0 • H0 • T0⁻¹ • H0 • S0⁻¹ • R (plus , Y⊗I) • R (plus , Y⊗Z) • R (plus , Z⊗I) • R (plus , Y⊗I) • R (plus , Y⊗Z) • R (plus , X⊗Z) • R (plus , Y⊗X) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Y⊗X) • R (plus , Z⊗Y) • R (plus , Z⊗X) • CZ • H0 • H1 • CZ • H0 • S0 • S0 • H0 • H1 • S1 • S1 • H1 • W ^ 6 • ε
          by in-context 53 1 auto lemma-R-T0⁻¹
      equals R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , I⊗Y) • R (plus , Y⊗Z) • R (plus , Z⊗Y) • R (plus , X⊗Y) • R (plus , Z⊗I) • R (plus , X⊗Y) • R (plus , Y⊗Z) • R (plus , X⊗Z) • R (plus , Z⊗X) • CZ • H0 • H1 • CZ • H0 • S0 • S0 • H0 • H1 • S1 • S1 • H1 • W ^ 6 • W ^ 2 • H1 • S1⁻¹ • S1⁻¹ • H1 • H0 • S0⁻¹ • S0⁻¹ • H0 • CZ • H1 • H0 • CZ • H1 • H0 • CZ • H0 • R (plus , Z⊗I) • S0⁻¹ • H0 • CZ • H0 • H1 • S1 • H1 • H0 • CZ • H0 • R (plus , Z⊗I) • S0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • H1 • S0 • CZ • H0 • T0⁻¹ • H0 • CZ • S0⁻¹ • H1 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • S1 • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • H1 • S0 • CZ • H0 • T0⁻¹ • H0 • CZ • S0⁻¹ • H1 • CZ • H0 • T0⁻¹ • H0 • CZ • S0 • CZ • H0 • T0⁻¹ • H0 • CZ • S0⁻¹ • S0 • H0 • T0⁻¹ • H0 • S0⁻¹ • T0⁻¹ • S0 • CZ • H0 • T0⁻¹ • H0 • CZ • S0⁻¹ • S0 • H0 • T0⁻¹ • H0 • S0⁻¹ • R (plus , Y⊗I) • R (plus , Y⊗Z) • R (plus , Z⊗I) • R (plus , Y⊗I) • R (plus , Y⊗Z) • R (plus , X⊗Z) • R (plus , Y⊗X) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Y⊗X) • R (plus , Z⊗Y) • R (plus , Z⊗X) • CZ • H0 • H1 • CZ • H0 • S0 • S0 • H0 • H1 • S1 • S1 • H1 • W ^ 6 • ε
          by in-context 64 1 auto lemma-R-T0⁻¹
      equals R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , I⊗Y) • R (plus , Y⊗Z) • R (plus , Z⊗Y) • R (plus , X⊗Y) • R (plus , Z⊗I) • R (plus , X⊗Y) • R (plus , Y⊗Z) • R (plus , X⊗Z) • R (plus , Z⊗X) • CZ • H0 • H1 • CZ • H0 • S0 • S0 • H0 • H1 • S1 • S1 • H1 • W ^ 6 • W ^ 2 • H1 • S1⁻¹ • S1⁻¹ • H1 • H0 • S0⁻¹ • S0⁻¹ • H0 • CZ • H1 • H0 • CZ • H1 • H0 • CZ • H0 • R (plus , Z⊗I) • S0⁻¹ • H0 • CZ • H0 • H1 • S1 • H1 • H0 • CZ • H0 • R (plus , Z⊗I) • S0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • H1 • S0 • CZ • H0 • R (plus , Z⊗I) • S0⁻¹ • H0 • CZ • S0⁻¹ • H1 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • S1 • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • H1 • S0 • CZ • H0 • T0⁻¹ • H0 • CZ • S0⁻¹ • H1 • CZ • H0 • T0⁻¹ • H0 • CZ • S0 • CZ • H0 • T0⁻¹ • H0 • CZ • S0⁻¹ • S0 • H0 • T0⁻¹ • H0 • S0⁻¹ • T0⁻¹ • S0 • CZ • H0 • T0⁻¹ • H0 • CZ • S0⁻¹ • S0 • H0 • T0⁻¹ • H0 • S0⁻¹ • R (plus , Y⊗I) • R (plus , Y⊗Z) • R (plus , Z⊗I) • R (plus , Y⊗I) • R (plus , Y⊗Z) • R (plus , X⊗Z) • R (plus , Y⊗X) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Y⊗X) • R (plus , Z⊗Y) • R (plus , Z⊗X) • CZ • H0 • H1 • CZ • H0 • S0 • S0 • H0 • H1 • S1 • S1 • H1 • W ^ 6 • ε
          by in-context 79 1 auto lemma-R-T0⁻¹
      equals R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , I⊗Y) • R (plus , Y⊗Z) • R (plus , Z⊗Y) • R (plus , X⊗Y) • R (plus , Z⊗I) • R (plus , X⊗Y) • R (plus , Y⊗Z) • R (plus , X⊗Z) • R (plus , Z⊗X) • CZ • H0 • H1 • CZ • H0 • S0 • S0 • H0 • H1 • S1 • S1 • H1 • W ^ 6 • W ^ 2 • H1 • S1⁻¹ • S1⁻¹ • H1 • H0 • S0⁻¹ • S0⁻¹ • H0 • CZ • H1 • H0 • CZ • H1 • H0 • CZ • H0 • R (plus , Z⊗I) • S0⁻¹ • H0 • CZ • H0 • H1 • S1 • H1 • H0 • CZ • H0 • R (plus , Z⊗I) • S0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • H1 • S0 • CZ • H0 • R (plus , Z⊗I) • S0⁻¹ • H0 • CZ • S0⁻¹ • H1 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • R (plus , Z⊗I) • S0⁻¹ • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • S1 • H1 • H0 • CZ • H0 • T0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • H1 • S0 • CZ • H0 • T0⁻¹ • H0 • CZ • S0⁻¹ • H1 • CZ • H0 • T0⁻¹ • H0 • CZ • S0 • CZ • H0 • T0⁻¹ • H0 • CZ • S0⁻¹ • S0 • H0 • T0⁻¹ • H0 • S0⁻¹ • T0⁻¹ • S0 • CZ • H0 • T0⁻¹ • H0 • CZ • S0⁻¹ • S0 • H0 • T0⁻¹ • H0 • S0⁻¹ • R (plus , Y⊗I) • R (plus , Y⊗Z) • R (plus , Z⊗I) • R (plus , Y⊗I) • R (plus , Y⊗Z) • R (plus , X⊗Z) • R (plus , Y⊗X) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Y⊗X) • R (plus , Z⊗Y) • R (plus , Z⊗X) • CZ • H0 • H1 • CZ • H0 • S0 • S0 • H0 • H1 • S1 • S1 • H1 • W ^ 6 • ε
          by in-context 95 1 auto lemma-R-T0⁻¹
      equals R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , I⊗Y) • R (plus , Y⊗Z) • R (plus , Z⊗Y) • R (plus , X⊗Y) • R (plus , Z⊗I) • R (plus , X⊗Y) • R (plus , Y⊗Z) • R (plus , X⊗Z) • R (plus , Z⊗X) • CZ • H0 • H1 • CZ • H0 • S0 • S0 • H0 • H1 • S1 • S1 • H1 • W ^ 6 • W ^ 2 • H1 • S1⁻¹ • S1⁻¹ • H1 • H0 • S0⁻¹ • S0⁻¹ • H0 • CZ • H1 • H0 • CZ • H1 • H0 • CZ • H0 • R (plus , Z⊗I) • S0⁻¹ • H0 • CZ • H0 • H1 • S1 • H1 • H0 • CZ • H0 • R (plus , Z⊗I) • S0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • H1 • S0 • CZ • H0 • R (plus , Z⊗I) • S0⁻¹ • H0 • CZ • S0⁻¹ • H1 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • R (plus , Z⊗I) • S0⁻¹ • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • S1 • H1 • H0 • CZ • H0 • R (plus , Z⊗I) • S0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • H1 • S0 • CZ • H0 • T0⁻¹ • H0 • CZ • S0⁻¹ • H1 • CZ • H0 • T0⁻¹ • H0 • CZ • S0 • CZ • H0 • T0⁻¹ • H0 • CZ • S0⁻¹ • S0 • H0 • T0⁻¹ • H0 • S0⁻¹ • T0⁻¹ • S0 • CZ • H0 • T0⁻¹ • H0 • CZ • S0⁻¹ • S0 • H0 • T0⁻¹ • H0 • S0⁻¹ • R (plus , Y⊗I) • R (plus , Y⊗Z) • R (plus , Z⊗I) • R (plus , Y⊗I) • R (plus , Y⊗Z) • R (plus , X⊗Z) • R (plus , Y⊗X) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Y⊗X) • R (plus , Z⊗Y) • R (plus , Z⊗X) • CZ • H0 • H1 • CZ • H0 • S0 • S0 • H0 • H1 • S1 • S1 • H1 • W ^ 6 • ε
          by in-context 106 1 auto lemma-R-T0⁻¹
      equals R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , I⊗Y) • R (plus , Y⊗Z) • R (plus , Z⊗Y) • R (plus , X⊗Y) • R (plus , Z⊗I) • R (plus , X⊗Y) • R (plus , Y⊗Z) • R (plus , X⊗Z) • R (plus , Z⊗X) • CZ • H0 • H1 • CZ • H0 • S0 • S0 • H0 • H1 • S1 • S1 • H1 • W ^ 6 • W ^ 2 • H1 • S1⁻¹ • S1⁻¹ • H1 • H0 • S0⁻¹ • S0⁻¹ • H0 • CZ • H1 • H0 • CZ • H1 • H0 • CZ • H0 • R (plus , Z⊗I) • S0⁻¹ • H0 • CZ • H0 • H1 • S1 • H1 • H0 • CZ • H0 • R (plus , Z⊗I) • S0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • H1 • S0 • CZ • H0 • R (plus , Z⊗I) • S0⁻¹ • H0 • CZ • S0⁻¹ • H1 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • R (plus , Z⊗I) • S0⁻¹ • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • S1 • H1 • H0 • CZ • H0 • R (plus , Z⊗I) • S0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • H1 • S0 • CZ • H0 • R (plus , Z⊗I) • S0⁻¹ • H0 • CZ • S0⁻¹ • H1 • CZ • H0 • T0⁻¹ • H0 • CZ • S0 • CZ • H0 • T0⁻¹ • H0 • CZ • S0⁻¹ • S0 • H0 • T0⁻¹ • H0 • S0⁻¹ • T0⁻¹ • S0 • CZ • H0 • T0⁻¹ • H0 • CZ • S0⁻¹ • S0 • H0 • T0⁻¹ • H0 • S0⁻¹ • R (plus , Y⊗I) • R (plus , Y⊗Z) • R (plus , Z⊗I) • R (plus , Y⊗I) • R (plus , Y⊗Z) • R (plus , X⊗Z) • R (plus , Y⊗X) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Y⊗X) • R (plus , Z⊗Y) • R (plus , Z⊗X) • CZ • H0 • H1 • CZ • H0 • S0 • S0 • H0 • H1 • S1 • S1 • H1 • W ^ 6 • ε
          by in-context 114 1 auto lemma-R-T0⁻¹
      equals R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , I⊗Y) • R (plus , Y⊗Z) • R (plus , Z⊗Y) • R (plus , X⊗Y) • R (plus , Z⊗I) • R (plus , X⊗Y) • R (plus , Y⊗Z) • R (plus , X⊗Z) • R (plus , Z⊗X) • CZ • H0 • H1 • CZ • H0 • S0 • S0 • H0 • H1 • S1 • S1 • H1 • W ^ 6 • W ^ 2 • H1 • S1⁻¹ • S1⁻¹ • H1 • H0 • S0⁻¹ • S0⁻¹ • H0 • CZ • H1 • H0 • CZ • H1 • H0 • CZ • H0 • R (plus , Z⊗I) • S0⁻¹ • H0 • CZ • H0 • H1 • S1 • H1 • H0 • CZ • H0 • R (plus , Z⊗I) • S0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • H1 • S0 • CZ • H0 • R (plus , Z⊗I) • S0⁻¹ • H0 • CZ • S0⁻¹ • H1 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • R (plus , Z⊗I) • S0⁻¹ • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • S1 • H1 • H0 • CZ • H0 • R (plus , Z⊗I) • S0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • H1 • S0 • CZ • H0 • R (plus , Z⊗I) • S0⁻¹ • H0 • CZ • S0⁻¹ • H1 • CZ • H0 • R (plus , Z⊗I) • S0⁻¹ • H0 • CZ • S0 • CZ • H0 • T0⁻¹ • H0 • CZ • S0⁻¹ • S0 • H0 • T0⁻¹ • H0 • S0⁻¹ • T0⁻¹ • S0 • CZ • H0 • T0⁻¹ • H0 • CZ • S0⁻¹ • S0 • H0 • T0⁻¹ • H0 • S0⁻¹ • R (plus , Y⊗I) • R (plus , Y⊗Z) • R (plus , Z⊗I) • R (plus , Y⊗I) • R (plus , Y⊗Z) • R (plus , X⊗Z) • R (plus , Y⊗X) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Y⊗X) • R (plus , Z⊗Y) • R (plus , Z⊗X) • CZ • H0 • H1 • CZ • H0 • S0 • S0 • H0 • H1 • S1 • S1 • H1 • W ^ 6 • ε
          by in-context 121 1 auto lemma-R-T0⁻¹
      equals R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , I⊗Y) • R (plus , Y⊗Z) • R (plus , Z⊗Y) • R (plus , X⊗Y) • R (plus , Z⊗I) • R (plus , X⊗Y) • R (plus , Y⊗Z) • R (plus , X⊗Z) • R (plus , Z⊗X) • CZ • H0 • H1 • CZ • H0 • S0 • S0 • H0 • H1 • S1 • S1 • H1 • W ^ 6 • W ^ 2 • H1 • S1⁻¹ • S1⁻¹ • H1 • H0 • S0⁻¹ • S0⁻¹ • H0 • CZ • H1 • H0 • CZ • H1 • H0 • CZ • H0 • R (plus , Z⊗I) • S0⁻¹ • H0 • CZ • H0 • H1 • S1 • H1 • H0 • CZ • H0 • R (plus , Z⊗I) • S0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • H1 • S0 • CZ • H0 • R (plus , Z⊗I) • S0⁻¹ • H0 • CZ • S0⁻¹ • H1 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • R (plus , Z⊗I) • S0⁻¹ • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • S1 • H1 • H0 • CZ • H0 • R (plus , Z⊗I) • S0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • H1 • S0 • CZ • H0 • R (plus , Z⊗I) • S0⁻¹ • H0 • CZ • S0⁻¹ • H1 • CZ • H0 • R (plus , Z⊗I) • S0⁻¹ • H0 • CZ • S0 • CZ • H0 • R (plus , Z⊗I) • S0⁻¹ • H0 • CZ • S0⁻¹ • S0 • H0 • T0⁻¹ • H0 • S0⁻¹ • T0⁻¹ • S0 • CZ • H0 • T0⁻¹ • H0 • CZ • S0⁻¹ • S0 • H0 • T0⁻¹ • H0 • S0⁻¹ • R (plus , Y⊗I) • R (plus , Y⊗Z) • R (plus , Z⊗I) • R (plus , Y⊗I) • R (plus , Y⊗Z) • R (plus , X⊗Z) • R (plus , Y⊗X) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Y⊗X) • R (plus , Z⊗Y) • R (plus , Z⊗X) • CZ • H0 • H1 • CZ • H0 • S0 • S0 • H0 • H1 • S1 • S1 • H1 • W ^ 6 • ε
          by in-context 128 1 auto lemma-R-T0⁻¹
      equals R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , I⊗Y) • R (plus , Y⊗Z) • R (plus , Z⊗Y) • R (plus , X⊗Y) • R (plus , Z⊗I) • R (plus , X⊗Y) • R (plus , Y⊗Z) • R (plus , X⊗Z) • R (plus , Z⊗X) • CZ • H0 • H1 • CZ • H0 • S0 • S0 • H0 • H1 • S1 • S1 • H1 • W ^ 6 • W ^ 2 • H1 • S1⁻¹ • S1⁻¹ • H1 • H0 • S0⁻¹ • S0⁻¹ • H0 • CZ • H1 • H0 • CZ • H1 • H0 • CZ • H0 • R (plus , Z⊗I) • S0⁻¹ • H0 • CZ • H0 • H1 • S1 • H1 • H0 • CZ • H0 • R (plus , Z⊗I) • S0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • H1 • S0 • CZ • H0 • R (plus , Z⊗I) • S0⁻¹ • H0 • CZ • S0⁻¹ • H1 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • R (plus , Z⊗I) • S0⁻¹ • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • S1 • H1 • H0 • CZ • H0 • R (plus , Z⊗I) • S0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • H1 • S0 • CZ • H0 • R (plus , Z⊗I) • S0⁻¹ • H0 • CZ • S0⁻¹ • H1 • CZ • H0 • R (plus , Z⊗I) • S0⁻¹ • H0 • CZ • S0 • CZ • H0 • R (plus , Z⊗I) • S0⁻¹ • H0 • CZ • S0⁻¹ • S0 • H0 • R (plus , Z⊗I) • S0⁻¹ • H0 • S0⁻¹ • T0⁻¹ • S0 • CZ • H0 • T0⁻¹ • H0 • CZ • S0⁻¹ • S0 • H0 • T0⁻¹ • H0 • S0⁻¹ • R (plus , Y⊗I) • R (plus , Y⊗Z) • R (plus , Z⊗I) • R (plus , Y⊗I) • R (plus , Y⊗Z) • R (plus , X⊗Z) • R (plus , Y⊗X) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Y⊗X) • R (plus , Z⊗Y) • R (plus , Z⊗X) • CZ • H0 • H1 • CZ • H0 • S0 • S0 • H0 • H1 • S1 • S1 • H1 • W ^ 6 • ε
          by in-context 132 1 auto lemma-R-T0⁻¹
      equals R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , I⊗Y) • R (plus , Y⊗Z) • R (plus , Z⊗Y) • R (plus , X⊗Y) • R (plus , Z⊗I) • R (plus , X⊗Y) • R (plus , Y⊗Z) • R (plus , X⊗Z) • R (plus , Z⊗X) • CZ • H0 • H1 • CZ • H0 • S0 • S0 • H0 • H1 • S1 • S1 • H1 • W ^ 6 • W ^ 2 • H1 • S1⁻¹ • S1⁻¹ • H1 • H0 • S0⁻¹ • S0⁻¹ • H0 • CZ • H1 • H0 • CZ • H1 • H0 • CZ • H0 • R (plus , Z⊗I) • S0⁻¹ • H0 • CZ • H0 • H1 • S1 • H1 • H0 • CZ • H0 • R (plus , Z⊗I) • S0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • H1 • S0 • CZ • H0 • R (plus , Z⊗I) • S0⁻¹ • H0 • CZ • S0⁻¹ • H1 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • R (plus , Z⊗I) • S0⁻¹ • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • S1 • H1 • H0 • CZ • H0 • R (plus , Z⊗I) • S0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • H1 • S0 • CZ • H0 • R (plus , Z⊗I) • S0⁻¹ • H0 • CZ • S0⁻¹ • H1 • CZ • H0 • R (plus , Z⊗I) • S0⁻¹ • H0 • CZ • S0 • CZ • H0 • R (plus , Z⊗I) • S0⁻¹ • H0 • CZ • S0⁻¹ • S0 • H0 • R (plus , Z⊗I) • S0⁻¹ • H0 • S0⁻¹ • R (plus , Z⊗I) • S0⁻¹ • S0 • CZ • H0 • T0⁻¹ • H0 • CZ • S0⁻¹ • S0 • H0 • T0⁻¹ • H0 • S0⁻¹ • R (plus , Y⊗I) • R (plus , Y⊗Z) • R (plus , Z⊗I) • R (plus , Y⊗I) • R (plus , Y⊗Z) • R (plus , X⊗Z) • R (plus , Y⊗X) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Y⊗X) • R (plus , Z⊗Y) • R (plus , Z⊗X) • CZ • H0 • H1 • CZ • H0 • S0 • S0 • H0 • H1 • S1 • S1 • H1 • W ^ 6 • ε
          by in-context 137 1 auto lemma-R-T0⁻¹
      equals R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , I⊗Y) • R (plus , Y⊗Z) • R (plus , Z⊗Y) • R (plus , X⊗Y) • R (plus , Z⊗I) • R (plus , X⊗Y) • R (plus , Y⊗Z) • R (plus , X⊗Z) • R (plus , Z⊗X) • CZ • H0 • H1 • CZ • H0 • S0 • S0 • H0 • H1 • S1 • S1 • H1 • W ^ 6 • W ^ 2 • H1 • S1⁻¹ • S1⁻¹ • H1 • H0 • S0⁻¹ • S0⁻¹ • H0 • CZ • H1 • H0 • CZ • H1 • H0 • CZ • H0 • R (plus , Z⊗I) • S0⁻¹ • H0 • CZ • H0 • H1 • S1 • H1 • H0 • CZ • H0 • R (plus , Z⊗I) • S0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • H1 • S0 • CZ • H0 • R (plus , Z⊗I) • S0⁻¹ • H0 • CZ • S0⁻¹ • H1 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • R (plus , Z⊗I) • S0⁻¹ • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • S1 • H1 • H0 • CZ • H0 • R (plus , Z⊗I) • S0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • H1 • S0 • CZ • H0 • R (plus , Z⊗I) • S0⁻¹ • H0 • CZ • S0⁻¹ • H1 • CZ • H0 • R (plus , Z⊗I) • S0⁻¹ • H0 • CZ • S0 • CZ • H0 • R (plus , Z⊗I) • S0⁻¹ • H0 • CZ • S0⁻¹ • S0 • H0 • R (plus , Z⊗I) • S0⁻¹ • H0 • S0⁻¹ • R (plus , Z⊗I) • S0⁻¹ • S0 • CZ • H0 • R (plus , Z⊗I) • S0⁻¹ • H0 • CZ • S0⁻¹ • S0 • H0 • T0⁻¹ • H0 • S0⁻¹ • R (plus , Y⊗I) • R (plus , Y⊗Z) • R (plus , Z⊗I) • R (plus , Y⊗I) • R (plus , Y⊗Z) • R (plus , X⊗Z) • R (plus , Y⊗X) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Y⊗X) • R (plus , Z⊗Y) • R (plus , Z⊗X) • CZ • H0 • H1 • CZ • H0 • S0 • S0 • H0 • H1 • S1 • S1 • H1 • W ^ 6 • ε
          by in-context 144 1 auto lemma-R-T0⁻¹
      equals R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , I⊗Y) • R (plus , Y⊗Z) • R (plus , Z⊗Y) • R (plus , X⊗Y) • R (plus , Z⊗I) • R (plus , X⊗Y) • R (plus , Y⊗Z) • R (plus , X⊗Z) • R (plus , Z⊗X) • CZ • H0 • H1 • CZ • H0 • S0 • S0 • H0 • H1 • S1 • S1 • H1 • W ^ 6 • W ^ 2 • H1 • S1⁻¹ • S1⁻¹ • H1 • H0 • S0⁻¹ • S0⁻¹ • H0 • CZ • H1 • H0 • CZ • H1 • H0 • CZ • H0 • R (plus , Z⊗I) • S0⁻¹ • H0 • CZ • H0 • H1 • S1 • H1 • H0 • CZ • H0 • R (plus , Z⊗I) • S0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • H1 • S0 • CZ • H0 • R (plus , Z⊗I) • S0⁻¹ • H0 • CZ • S0⁻¹ • H1 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • R (plus , Z⊗I) • S0⁻¹ • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • S1 • H1 • H0 • CZ • H0 • R (plus , Z⊗I) • S0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • H1 • S0 • CZ • H0 • R (plus , Z⊗I) • S0⁻¹ • H0 • CZ • S0⁻¹ • H1 • CZ • H0 • R (plus , Z⊗I) • S0⁻¹ • H0 • CZ • S0 • CZ • H0 • R (plus , Z⊗I) • S0⁻¹ • H0 • CZ • S0⁻¹ • S0 • H0 • R (plus , Z⊗I) • S0⁻¹ • H0 • S0⁻¹ • R (plus , Z⊗I) • S0⁻¹ • S0 • CZ • H0 • R (plus , Z⊗I) • S0⁻¹ • H0 • CZ • S0⁻¹ • S0 • H0 • R (plus , Z⊗I) • S0⁻¹ • H0 • S0⁻¹ • R (plus , Y⊗I) • R (plus , Y⊗Z) • R (plus , Z⊗I) • R (plus , Y⊗I) • R (plus , Y⊗Z) • R (plus , X⊗Z) • R (plus , Y⊗X) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Y⊗X) • R (plus , Z⊗Y) • R (plus , Z⊗X) • CZ • H0 • H1 • CZ • H0 • S0 • S0 • H0 • H1 • S1 • S1 • H1 • W ^ 6 • ε
          by clifford-tactic 12 28 10000 auto
      equals R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , I⊗Y) • R (plus , Y⊗Z) • R (plus , Z⊗Y) • R (plus , X⊗Y) • R (plus , Z⊗I) • R (plus , X⊗Y) • R (plus , Y⊗Z) • R (plus , X⊗Z) • R (plus , Z⊗X) • H0 • H1 • CZ • H0 • R (plus , Z⊗I) • S0⁻¹ • H0 • CZ • H0 • H1 • S1 • H1 • H0 • CZ • H0 • R (plus , Z⊗I) • S0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • H1 • S0 • CZ • H0 • R (plus , Z⊗I) • S0⁻¹ • H0 • CZ • S0⁻¹ • H1 • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • R (plus , Z⊗I) • S0⁻¹ • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • S1 • H1 • H0 • CZ • H0 • R (plus , Z⊗I) • S0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • H1 • S0 • CZ • H0 • R (plus , Z⊗I) • S0⁻¹ • H0 • CZ • S0⁻¹ • H1 • CZ • H0 • R (plus , Z⊗I) • S0⁻¹ • H0 • CZ • S0 • CZ • H0 • R (plus , Z⊗I) • S0⁻¹ • H0 • CZ • S0⁻¹ • S0 • H0 • R (plus , Z⊗I) • S0⁻¹ • H0 • S0⁻¹ • R (plus , Z⊗I) • S0⁻¹ • S0 • CZ • H0 • R (plus , Z⊗I) • S0⁻¹ • H0 • CZ • S0⁻¹ • S0 • H0 • R (plus , Z⊗I) • S0⁻¹ • H0 • S0⁻¹ • R (plus , Y⊗I) • R (plus , Y⊗Z) • R (plus , Z⊗I) • R (plus , Y⊗I) • R (plus , Y⊗Z) • R (plus , X⊗Z) • R (plus , Y⊗X) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Y⊗X) • R (plus , Z⊗Y) • R (plus , Z⊗X) • CZ • H0 • H1 • CZ • H0 • S0 • S0 • H0 • H1 • S1 • S1 • H1 • W ^ 6 • ε
          by clifford-tactic 39 14 10000 auto
      equals R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , I⊗Y) • R (plus , Y⊗Z) • R (plus , Z⊗Y) • R (plus , X⊗Y) • R (plus , Z⊗I) • R (plus , X⊗Y) • R (plus , Y⊗Z) • R (plus , X⊗Z) • R (plus , Z⊗X) • H0 • H1 • CZ • H0 • R (plus , Z⊗I) • S0⁻¹ • H0 • CZ • H0 • H1 • S1 • H1 • H0 • CZ • H0 • R (plus , Z⊗I) • S0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • H1 • S0 • CZ • H0 • R (plus , Z⊗I) • S0 • H0 • CZ • S0 • H0 • S0 • S0 • H0 • S1 • S1 • H1 • W ^ 6 • Swap • R (plus , Z⊗I) • S0⁻¹ • H0 • CZ • H0 • H1 • CZ • H1 • H0 • CZ • H0 • S1 • H1 • H0 • CZ • H0 • R (plus , Z⊗I) • S0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • H1 • S0 • CZ • H0 • R (plus , Z⊗I) • S0⁻¹ • H0 • CZ • S0⁻¹ • H1 • CZ • H0 • R (plus , Z⊗I) • S0⁻¹ • H0 • CZ • S0 • CZ • H0 • R (plus , Z⊗I) • S0⁻¹ • H0 • CZ • S0⁻¹ • S0 • H0 • R (plus , Z⊗I) • S0⁻¹ • H0 • S0⁻¹ • R (plus , Z⊗I) • S0⁻¹ • S0 • CZ • H0 • R (plus , Z⊗I) • S0⁻¹ • H0 • CZ • S0⁻¹ • S0 • H0 • R (plus , Z⊗I) • S0⁻¹ • H0 • S0⁻¹ • R (plus , Y⊗I) • R (plus , Y⊗Z) • R (plus , Z⊗I) • R (plus , Y⊗I) • R (plus , Y⊗Z) • R (plus , X⊗Z) • R (plus , Y⊗X) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Y⊗X) • R (plus , Z⊗Y) • R (plus , Z⊗X) • CZ • H0 • H1 • CZ • H0 • S0 • S0 • H0 • H1 • S1 • S1 • H1 • W ^ 6 • ε
          by clifford-tactic 53 15 10000 auto
      equals R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , I⊗Y) • R (plus , Y⊗Z) • R (plus , Z⊗Y) • R (plus , X⊗Y) • R (plus , Z⊗I) • R (plus , X⊗Y) • R (plus , Y⊗Z) • R (plus , X⊗Z) • R (plus , Z⊗X) • H0 • H1 • CZ • H0 • R (plus , Z⊗I) • S0⁻¹ • H0 • CZ • H0 • H1 • S1 • H1 • H0 • CZ • H0 • R (plus , Z⊗I) • S0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • H1 • S0 • CZ • H0 • R (plus , Z⊗I) • S0 • H0 • CZ • S0 • H0 • S0 • S0 • H0 • S1 • S1 • H1 • W ^ 6 • Swap • R (plus , Z⊗I) • CZ • H0 • H1 • CZ • H1 • R (plus , Z⊗I) • S0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • H1 • S0 • CZ • H0 • R (plus , Z⊗I) • S0⁻¹ • H0 • CZ • S0⁻¹ • H1 • CZ • H0 • R (plus , Z⊗I) • S0⁻¹ • H0 • CZ • S0 • CZ • H0 • R (plus , Z⊗I) • S0⁻¹ • H0 • CZ • S0⁻¹ • S0 • H0 • R (plus , Z⊗I) • S0⁻¹ • H0 • S0⁻¹ • R (plus , Z⊗I) • S0⁻¹ • S0 • CZ • H0 • R (plus , Z⊗I) • S0⁻¹ • H0 • CZ • S0⁻¹ • S0 • H0 • R (plus , Z⊗I) • S0⁻¹ • H0 • S0⁻¹ • R (plus , Y⊗I) • R (plus , Y⊗Z) • R (plus , Z⊗I) • R (plus , Y⊗I) • R (plus , Y⊗Z) • R (plus , X⊗Z) • R (plus , Y⊗X) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Y⊗X) • R (plus , Z⊗Y) • R (plus , Z⊗X) • CZ • H0 • H1 • CZ • H0 • S0 • S0 • H0 • H1 • S1 • S1 • H1 • W ^ 6 • ε
          by clifford-tactic 96 2 10000 auto
      equals R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , I⊗Y) • R (plus , Y⊗Z) • R (plus , Z⊗Y) • R (plus , X⊗Y) • R (plus , Z⊗I) • R (plus , X⊗Y) • R (plus , Y⊗Z) • R (plus , X⊗Z) • R (plus , Z⊗X) • H0 • H1 • CZ • H0 • R (plus , Z⊗I) • S0⁻¹ • H0 • CZ • H0 • H1 • S1 • H1 • H0 • CZ • H0 • R (plus , Z⊗I) • S0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • H1 • S0 • CZ • H0 • R (plus , Z⊗I) • S0 • H0 • CZ • S0 • H0 • S0 • S0 • H0 • S1 • S1 • H1 • W ^ 6 • Swap • R (plus , Z⊗I) • CZ • H0 • H1 • CZ • H1 • R (plus , Z⊗I) • S0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • H1 • S0 • CZ • H0 • R (plus , Z⊗I) • S0⁻¹ • H0 • CZ • S0⁻¹ • H1 • CZ • H0 • R (plus , Z⊗I) • S0⁻¹ • H0 • CZ • S0 • CZ • H0 • R (plus , Z⊗I) • S0⁻¹ • H0 • CZ • S0⁻¹ • S0 • H0 • R (plus , Z⊗I) • S0⁻¹ • H0 • S0⁻¹ • R (plus , Z⊗I) • CZ • H0 • R (plus , Z⊗I) • S0⁻¹ • H0 • CZ • S0⁻¹ • S0 • H0 • R (plus , Z⊗I) • S0⁻¹ • H0 • S0⁻¹ • R (plus , Y⊗I) • R (plus , Y⊗Z) • R (plus , Z⊗I) • R (plus , Y⊗I) • R (plus , Y⊗Z) • R (plus , X⊗Z) • R (plus , Y⊗X) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Y⊗X) • R (plus , Z⊗Y) • R (plus , Z⊗X) • CZ • H0 • H1 • CZ • H0 • S0 • S0 • H0 • H1 • S1 • S1 • H1 • W ^ 6 • ε
          by in-context 12 5 auto (lemma-R (C.H0 • C.H1 • C.CZ • C.H0) (plus , Z⊗I))
      equals R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , I⊗Y) • R (plus , Y⊗Z) • R (plus , Z⊗Y) • R (plus , X⊗Y) • R (plus , Z⊗I) • R (plus , X⊗Y) • R (plus , Y⊗Z) • R (plus , X⊗Z) • R (plus , Z⊗X) • R (plus , Z⊗X) • H0 • H1 • CZ • H0 • S0⁻¹ • H0 • CZ • H0 • H1 • S1 • H1 • H0 • CZ • H0 • R (plus , Z⊗I) • S0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • H1 • S0 • CZ • H0 • R (plus , Z⊗I) • S0 • H0 • CZ • S0 • H0 • S0 • S0 • H0 • S1 • S1 • H1 • W ^ 6 • Swap • R (plus , Z⊗I) • CZ • H0 • H1 • CZ • H1 • R (plus , Z⊗I) • S0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • H1 • S0 • CZ • H0 • R (plus , Z⊗I) • S0⁻¹ • H0 • CZ • S0⁻¹ • H1 • CZ • H0 • R (plus , Z⊗I) • S0⁻¹ • H0 • CZ • S0 • CZ • H0 • R (plus , Z⊗I) • S0⁻¹ • H0 • CZ • S0⁻¹ • S0 • H0 • R (plus , Z⊗I) • S0⁻¹ • H0 • S0⁻¹ • R (plus , Z⊗I) • CZ • H0 • R (plus , Z⊗I) • S0⁻¹ • H0 • CZ • S0⁻¹ • S0 • H0 • R (plus , Z⊗I) • S0⁻¹ • H0 • S0⁻¹ • R (plus , Y⊗I) • R (plus , Y⊗Z) • R (plus , Z⊗I) • R (plus , Y⊗I) • R (plus , Y⊗Z) • R (plus , X⊗Z) • R (plus , Y⊗X) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Y⊗X) • R (plus , Z⊗Y) • R (plus , Z⊗X) • CZ • H0 • H1 • CZ • H0 • S0 • S0 • H0 • H1 • S1 • S1 • H1 • W ^ 6 • ε
          by in-context 13 15 auto (lemma-R (C.H0 • C.H1 • C.CZ • C.H0 • C.S0⁻¹ • C.H0 • C.CZ • C.H0 • C.H1 • C.S1 • C.H1 • C.H0 • C.CZ • C.H0) (plus , Z⊗I))
      equals R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , I⊗Y) • R (plus , Y⊗Z) • R (plus , Z⊗Y) • R (plus , X⊗Y) • R (plus , Z⊗I) • R (plus , X⊗Y) • R (plus , Y⊗Z) • R (plus , X⊗Z) • R (plus , Z⊗X) • R (plus , Z⊗X) • R (minus , I⊗Z) • H0 • H1 • CZ • H0 • S0⁻¹ • H0 • CZ • H0 • H1 • S1 • H1 • H0 • CZ • H0 • S0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • H1 • S0 • CZ • H0 • R (plus , Z⊗I) • S0 • H0 • CZ • S0 • H0 • S0 • S0 • H0 • S1 • S1 • H1 • W ^ 6 • Swap • R (plus , Z⊗I) • CZ • H0 • H1 • CZ • H1 • R (plus , Z⊗I) • S0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • H1 • S0 • CZ • H0 • R (plus , Z⊗I) • S0⁻¹ • H0 • CZ • S0⁻¹ • H1 • CZ • H0 • R (plus , Z⊗I) • S0⁻¹ • H0 • CZ • S0 • CZ • H0 • R (plus , Z⊗I) • S0⁻¹ • H0 • CZ • S0⁻¹ • S0 • H0 • R (plus , Z⊗I) • S0⁻¹ • H0 • S0⁻¹ • R (plus , Z⊗I) • CZ • H0 • R (plus , Z⊗I) • S0⁻¹ • H0 • CZ • S0⁻¹ • S0 • H0 • R (plus , Z⊗I) • S0⁻¹ • H0 • S0⁻¹ • R (plus , Y⊗I) • R (plus , Y⊗Z) • R (plus , Z⊗I) • R (plus , Y⊗I) • R (plus , Y⊗Z) • R (plus , X⊗Z) • R (plus , Y⊗X) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Y⊗X) • R (plus , Z⊗Y) • R (plus , Z⊗X) • CZ • H0 • H1 • CZ • H0 • S0 • S0 • H0 • H1 • S1 • S1 • H1 • W ^ 6 • ε
          by clifford-tactic 15 23 10000 auto
      equals R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , I⊗Y) • R (plus , Y⊗Z) • R (plus , Z⊗Y) • R (plus , X⊗Y) • R (plus , Z⊗I) • R (plus , X⊗Y) • R (plus , Y⊗Z) • R (plus , X⊗Z) • R (plus , Z⊗X) • R (plus , Z⊗X) • R (minus , I⊗Z) • H0 • S1 • H1 • S1 • S1 • S1 • W ^ 6 • R (plus , Z⊗I) • S0 • H0 • CZ • S0 • H0 • S0 • S0 • H0 • S1 • S1 • H1 • W ^ 6 • Swap • R (plus , Z⊗I) • CZ • H0 • H1 • CZ • H1 • R (plus , Z⊗I) • S0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • H1 • S0 • CZ • H0 • R (plus , Z⊗I) • S0⁻¹ • H0 • CZ • S0⁻¹ • H1 • CZ • H0 • R (plus , Z⊗I) • S0⁻¹ • H0 • CZ • S0 • CZ • H0 • R (plus , Z⊗I) • S0⁻¹ • H0 • CZ • S0⁻¹ • S0 • H0 • R (plus , Z⊗I) • S0⁻¹ • H0 • S0⁻¹ • R (plus , Z⊗I) • CZ • H0 • R (plus , Z⊗I) • S0⁻¹ • H0 • CZ • S0⁻¹ • S0 • H0 • R (plus , Z⊗I) • S0⁻¹ • H0 • S0⁻¹ • R (plus , Y⊗I) • R (plus , Y⊗Z) • R (plus , Z⊗I) • R (plus , Y⊗I) • R (plus , Y⊗Z) • R (plus , X⊗Z) • R (plus , Y⊗X) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Y⊗X) • R (plus , Z⊗Y) • R (plus , Z⊗X) • CZ • H0 • H1 • CZ • H0 • S0 • S0 • H0 • H1 • S1 • S1 • H1 • W ^ 6 • ε
          by in-context 14 8 auto (lemma-R (C.H0 • C.S1 • C.H1 • C.S1 • C.S1 • C.S1 • C.W ^ 6) (plus , Z⊗I))
      equals R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , I⊗Y) • R (plus , Y⊗Z) • R (plus , Z⊗Y) • R (plus , X⊗Y) • R (plus , Z⊗I) • R (plus , X⊗Y) • R (plus , Y⊗Z) • R (plus , X⊗Z) • R (plus , Z⊗X) • R (plus , Z⊗X) • R (minus , I⊗Z) • R (plus , X⊗I) • H0 • S1 • H1 • S1 • S1 • S1 • W ^ 6 • S0 • H0 • CZ • S0 • H0 • S0 • S0 • H0 • S1 • S1 • H1 • W ^ 6 • Swap • R (plus , Z⊗I) • CZ • H0 • H1 • CZ • H1 • R (plus , Z⊗I) • S0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • H1 • S0 • CZ • H0 • R (plus , Z⊗I) • S0⁻¹ • H0 • CZ • S0⁻¹ • H1 • CZ • H0 • R (plus , Z⊗I) • S0⁻¹ • H0 • CZ • S0 • CZ • H0 • R (plus , Z⊗I) • S0⁻¹ • H0 • CZ • S0⁻¹ • S0 • H0 • R (plus , Z⊗I) • S0⁻¹ • H0 • S0⁻¹ • R (plus , Z⊗I) • CZ • H0 • R (plus , Z⊗I) • S0⁻¹ • H0 • CZ • S0⁻¹ • S0 • H0 • R (plus , Z⊗I) • S0⁻¹ • H0 • S0⁻¹ • R (plus , Y⊗I) • R (plus , Y⊗Z) • R (plus , Z⊗I) • R (plus , Y⊗I) • R (plus , Y⊗Z) • R (plus , X⊗Z) • R (plus , Y⊗X) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Y⊗X) • R (plus , Z⊗Y) • R (plus , Z⊗X) • CZ • H0 • H1 • CZ • H0 • S0 • S0 • H0 • H1 • S1 • S1 • H1 • W ^ 6 • ε
          by clifford-tactic 15 20 10000 auto
      equals R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , I⊗Y) • R (plus , Y⊗Z) • R (plus , Z⊗Y) • R (plus , X⊗Y) • R (plus , Z⊗I) • R (plus , X⊗Y) • R (plus , Y⊗Z) • R (plus , X⊗Z) • R (plus , Z⊗X) • R (plus , Z⊗X) • R (minus , I⊗Z) • R (plus , X⊗I) • CZ • S0 • H0 • S1 • H1 • CZ • S0 • H0 • S0 • H1 • W ^ 4 • R (plus , Z⊗I) • CZ • H0 • H1 • CZ • H1 • R (plus , Z⊗I) • S0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • H1 • S0 • CZ • H0 • R (plus , Z⊗I) • S0⁻¹ • H0 • CZ • S0⁻¹ • H1 • CZ • H0 • R (plus , Z⊗I) • S0⁻¹ • H0 • CZ • S0 • CZ • H0 • R (plus , Z⊗I) • S0⁻¹ • H0 • CZ • S0⁻¹ • S0 • H0 • R (plus , Z⊗I) • S0⁻¹ • H0 • S0⁻¹ • R (plus , Z⊗I) • CZ • H0 • R (plus , Z⊗I) • S0⁻¹ • H0 • CZ • S0⁻¹ • S0 • H0 • R (plus , Z⊗I) • S0⁻¹ • H0 • S0⁻¹ • R (plus , Y⊗I) • R (plus , Y⊗Z) • R (plus , Z⊗I) • R (plus , Y⊗I) • R (plus , Y⊗Z) • R (plus , X⊗Z) • R (plus , Y⊗X) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Y⊗X) • R (plus , Z⊗Y) • R (plus , Z⊗X) • CZ • H0 • H1 • CZ • H0 • S0 • S0 • H0 • H1 • S1 • S1 • H1 • W ^ 6 • ε
          by in-context 15 12 auto (lemma-R (C.CZ • C.S0 • C.H0 • C.S1 • C.H1 • C.CZ • C.S0 • C.H0 • C.S0 • C.H1 • C.W ^ 4) (plus , Z⊗I))
      equals R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , I⊗Y) • R (plus , Y⊗Z) • R (plus , Z⊗Y) • R (plus , X⊗Y) • R (plus , Z⊗I) • R (plus , X⊗Y) • R (plus , Y⊗Z) • R (plus , X⊗Z) • R (plus , Z⊗X) • R (plus , Z⊗X) • R (minus , I⊗Z) • R (plus , X⊗I) • R (minus , Y⊗X) • CZ • S0 • H0 • S1 • H1 • CZ • S0 • H0 • S0 • H1 • W ^ 4 • CZ • H0 • H1 • CZ • H1 • R (plus , Z⊗I) • S0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • H1 • S0 • CZ • H0 • R (plus , Z⊗I) • S0⁻¹ • H0 • CZ • S0⁻¹ • H1 • CZ • H0 • R (plus , Z⊗I) • S0⁻¹ • H0 • CZ • S0 • CZ • H0 • R (plus , Z⊗I) • S0⁻¹ • H0 • CZ • S0⁻¹ • S0 • H0 • R (plus , Z⊗I) • S0⁻¹ • H0 • S0⁻¹ • R (plus , Z⊗I) • CZ • H0 • R (plus , Z⊗I) • S0⁻¹ • H0 • CZ • S0⁻¹ • S0 • H0 • R (plus , Z⊗I) • S0⁻¹ • H0 • S0⁻¹ • R (plus , Y⊗I) • R (plus , Y⊗Z) • R (plus , Z⊗I) • R (plus , Y⊗I) • R (plus , Y⊗Z) • R (plus , X⊗Z) • R (plus , Y⊗X) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Y⊗X) • R (plus , Z⊗Y) • R (plus , Z⊗X) • CZ • H0 • H1 • CZ • H0 • S0 • S0 • H0 • H1 • S1 • S1 • H1 • W ^ 6 • ε
          by clifford-tactic 16 16 10000 auto
      equals R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , I⊗Y) • R (plus , Y⊗Z) • R (plus , Z⊗Y) • R (plus , X⊗Y) • R (plus , Z⊗I) • R (plus , X⊗Y) • R (plus , Y⊗Z) • R (plus , X⊗Z) • R (plus , Z⊗X) • R (plus , Z⊗X) • R (minus , I⊗Z) • R (plus , X⊗I) • R (minus , Y⊗X) • H0 • S1 • H1 • CZ • H0 • S0 • H0 • W ^ 5 • R (plus , Z⊗I) • S0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • H1 • S0 • CZ • H0 • R (plus , Z⊗I) • S0⁻¹ • H0 • CZ • S0⁻¹ • H1 • CZ • H0 • R (plus , Z⊗I) • S0⁻¹ • H0 • CZ • S0 • CZ • H0 • R (plus , Z⊗I) • S0⁻¹ • H0 • CZ • S0⁻¹ • S0 • H0 • R (plus , Z⊗I) • S0⁻¹ • H0 • S0⁻¹ • R (plus , Z⊗I) • CZ • H0 • R (plus , Z⊗I) • S0⁻¹ • H0 • CZ • S0⁻¹ • S0 • H0 • R (plus , Z⊗I) • S0⁻¹ • H0 • S0⁻¹ • R (plus , Y⊗I) • R (plus , Y⊗Z) • R (plus , Z⊗I) • R (plus , Y⊗I) • R (plus , Y⊗Z) • R (plus , X⊗Z) • R (plus , Y⊗X) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Y⊗X) • R (plus , Z⊗Y) • R (plus , Z⊗X) • CZ • H0 • H1 • CZ • H0 • S0 • S0 • H0 • H1 • S1 • S1 • H1 • W ^ 6 • ε
          by in-context 16 9 auto (lemma-R (C.H0 • C.S1 • C.H1 • C.CZ • C.H0 • C.S0 • C.H0 • C.W ^ 5) (plus , Z⊗I))
      equals R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , I⊗Y) • R (plus , Y⊗Z) • R (plus , Z⊗Y) • R (plus , X⊗Y) • R (plus , Z⊗I) • R (plus , X⊗Y) • R (plus , Y⊗Z) • R (plus , X⊗Z) • R (plus , Z⊗X) • R (plus , Z⊗X) • R (minus , I⊗Z) • R (plus , X⊗I) • R (minus , Y⊗X) • R (plus , Y⊗Y) • H0 • S1 • H1 • CZ • H0 • S0 • H0 • W ^ 5 • S0⁻¹ • H0 • CZ • H0 • H1 • S1⁻¹ • H1 • S0 • CZ • H0 • R (plus , Z⊗I) • S0⁻¹ • H0 • CZ • S0⁻¹ • H1 • CZ • H0 • R (plus , Z⊗I) • S0⁻¹ • H0 • CZ • S0 • CZ • H0 • R (plus , Z⊗I) • S0⁻¹ • H0 • CZ • S0⁻¹ • S0 • H0 • R (plus , Z⊗I) • S0⁻¹ • H0 • S0⁻¹ • R (plus , Z⊗I) • CZ • H0 • R (plus , Z⊗I) • S0⁻¹ • H0 • CZ • S0⁻¹ • S0 • H0 • R (plus , Z⊗I) • S0⁻¹ • H0 • S0⁻¹ • R (plus , Y⊗I) • R (plus , Y⊗Z) • R (plus , Z⊗I) • R (plus , Y⊗I) • R (plus , Y⊗Z) • R (plus , X⊗Z) • R (plus , Y⊗X) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Y⊗X) • R (plus , Z⊗Y) • R (plus , Z⊗X) • CZ • H0 • H1 • CZ • H0 • S0 • S0 • H0 • H1 • S1 • S1 • H1 • W ^ 6 • ε
          by clifford-tactic 17 18 10000 auto
      equals R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , I⊗Y) • R (plus , Y⊗Z) • R (plus , Z⊗Y) • R (plus , X⊗Y) • R (plus , Z⊗I) • R (plus , X⊗Y) • R (plus , Y⊗Z) • R (plus , X⊗Z) • R (plus , Z⊗X) • R (plus , Z⊗X) • R (minus , I⊗Z) • R (plus , X⊗I) • R (minus , Y⊗X) • R (plus , Y⊗Y) • S0 • H0 • H1 • CZ • S0 • S0 • H0 • S1 • S1 • H1 • S1 • S1 • H1 • W⁻¹ • R (plus , Z⊗I) • S0⁻¹ • H0 • CZ • S0⁻¹ • H1 • CZ • H0 • R (plus , Z⊗I) • S0⁻¹ • H0 • CZ • S0 • CZ • H0 • R (plus , Z⊗I) • S0⁻¹ • H0 • CZ • S0⁻¹ • S0 • H0 • R (plus , Z⊗I) • S0⁻¹ • H0 • S0⁻¹ • R (plus , Z⊗I) • CZ • H0 • R (plus , Z⊗I) • S0⁻¹ • H0 • CZ • S0⁻¹ • S0 • H0 • R (plus , Z⊗I) • S0⁻¹ • H0 • S0⁻¹ • R (plus , Y⊗I) • R (plus , Y⊗Z) • R (plus , Z⊗I) • R (plus , Y⊗I) • R (plus , Y⊗Z) • R (plus , X⊗Z) • R (plus , Y⊗X) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Y⊗X) • R (plus , Z⊗Y) • R (plus , Z⊗X) • CZ • H0 • H1 • CZ • H0 • S0 • S0 • H0 • H1 • S1 • S1 • H1 • W ^ 6 • ε
          by in-context 17 15 auto (lemma-R (C.S0 • C.H0 • C.H1 • C.CZ • C.S0 • C.S0 • C.H0 • C.S1 • C.S1 • C.H1 • C.S1 • C.S1 • C.H1 • C.W⁻¹) (plus , Z⊗I))
      equals R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , I⊗Y) • R (plus , Y⊗Z) • R (plus , Z⊗Y) • R (plus , X⊗Y) • R (plus , Z⊗I) • R (plus , X⊗Y) • R (plus , Y⊗Z) • R (plus , X⊗Z) • R (plus , Z⊗X) • R (plus , Z⊗X) • R (minus , I⊗Z) • R (plus , X⊗I) • R (minus , Y⊗X) • R (plus , Y⊗Y) • R (minus , Z⊗X) • S0 • H0 • H1 • CZ • S0 • S0 • H0 • S1 • S1 • H1 • S1 • S1 • H1 • W⁻¹ • S0⁻¹ • H0 • CZ • S0⁻¹ • H1 • CZ • H0 • R (plus , Z⊗I) • S0⁻¹ • H0 • CZ • S0 • CZ • H0 • R (plus , Z⊗I) • S0⁻¹ • H0 • CZ • S0⁻¹ • S0 • H0 • R (plus , Z⊗I) • S0⁻¹ • H0 • S0⁻¹ • R (plus , Z⊗I) • CZ • H0 • R (plus , Z⊗I) • S0⁻¹ • H0 • CZ • S0⁻¹ • S0 • H0 • R (plus , Z⊗I) • S0⁻¹ • H0 • S0⁻¹ • R (plus , Y⊗I) • R (plus , Y⊗Z) • R (plus , Z⊗I) • R (plus , Y⊗I) • R (plus , Y⊗Z) • R (plus , X⊗Z) • R (plus , Y⊗X) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Y⊗X) • R (plus , Z⊗Y) • R (plus , Z⊗X) • CZ • H0 • H1 • CZ • H0 • S0 • S0 • H0 • H1 • S1 • S1 • H1 • W ^ 6 • ε
          by clifford-tactic 18 21 10000 auto
      equals R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , I⊗Y) • R (plus , Y⊗Z) • R (plus , Z⊗Y) • R (plus , X⊗Y) • R (plus , Z⊗I) • R (plus , X⊗Y) • R (plus , Y⊗Z) • R (plus , X⊗Z) • R (plus , Z⊗X) • R (plus , Z⊗X) • R (minus , I⊗Z) • R (plus , X⊗I) • R (minus , Y⊗X) • R (plus , Y⊗Y) • R (minus , Z⊗X) • CZ • H0 • S1 • H1 • CZ • S0 • W ^ 3 • R (plus , Z⊗I) • S0⁻¹ • H0 • CZ • S0 • CZ • H0 • R (plus , Z⊗I) • S0⁻¹ • H0 • CZ • S0⁻¹ • S0 • H0 • R (plus , Z⊗I) • S0⁻¹ • H0 • S0⁻¹ • R (plus , Z⊗I) • CZ • H0 • R (plus , Z⊗I) • S0⁻¹ • H0 • CZ • S0⁻¹ • S0 • H0 • R (plus , Z⊗I) • S0⁻¹ • H0 • S0⁻¹ • R (plus , Y⊗I) • R (plus , Y⊗Z) • R (plus , Z⊗I) • R (plus , Y⊗I) • R (plus , Y⊗Z) • R (plus , X⊗Z) • R (plus , Y⊗X) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Y⊗X) • R (plus , Z⊗Y) • R (plus , Z⊗X) • CZ • H0 • H1 • CZ • H0 • S0 • S0 • H0 • H1 • S1 • S1 • H1 • W ^ 6 • ε
          by in-context 18 8 auto (lemma-R (C.CZ • C.H0 • C.S1 • C.H1 • C.CZ • C.S0 • C.W ^ 3) (plus , Z⊗I))
      equals R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , I⊗Y) • R (plus , Y⊗Z) • R (plus , Z⊗Y) • R (plus , X⊗Y) • R (plus , Z⊗I) • R (plus , X⊗Y) • R (plus , Y⊗Z) • R (plus , X⊗Z) • R (plus , Z⊗X) • R (plus , Z⊗X) • R (minus , I⊗Z) • R (plus , X⊗I) • R (minus , Y⊗X) • R (plus , Y⊗Y) • R (minus , Z⊗X) • R (plus , X⊗Z) • CZ • H0 • S1 • H1 • CZ • S0 • W ^ 3 • S0⁻¹ • H0 • CZ • S0 • CZ • H0 • R (plus , Z⊗I) • S0⁻¹ • H0 • CZ • S0⁻¹ • S0 • H0 • R (plus , Z⊗I) • S0⁻¹ • H0 • S0⁻¹ • R (plus , Z⊗I) • CZ • H0 • R (plus , Z⊗I) • S0⁻¹ • H0 • CZ • S0⁻¹ • S0 • H0 • R (plus , Z⊗I) • S0⁻¹ • H0 • S0⁻¹ • R (plus , Y⊗I) • R (plus , Y⊗Z) • R (plus , Z⊗I) • R (plus , Y⊗I) • R (plus , Y⊗Z) • R (plus , X⊗Z) • R (plus , Y⊗X) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Y⊗X) • R (plus , Z⊗Y) • R (plus , Z⊗X) • CZ • H0 • H1 • CZ • H0 • S0 • S0 • H0 • H1 • S1 • S1 • H1 • W ^ 6 • ε
          by clifford-tactic 24 8 10000 auto
      equals R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , I⊗Y) • R (plus , Y⊗Z) • R (plus , Z⊗Y) • R (plus , X⊗Y) • R (plus , Z⊗I) • R (plus , X⊗Y) • R (plus , Y⊗Z) • R (plus , X⊗Z) • R (plus , Z⊗X) • R (plus , Z⊗X) • R (minus , I⊗Z) • R (plus , X⊗I) • R (minus , Y⊗X) • R (plus , Y⊗Y) • R (minus , Z⊗X) • R (plus , X⊗Z) • CZ • H0 • S1 • H1 • CZ • H0 • S0 • H0 • W ^ 3 • R (plus , Z⊗I) • S0⁻¹ • H0 • CZ • S0⁻¹ • S0 • H0 • R (plus , Z⊗I) • S0⁻¹ • H0 • S0⁻¹ • R (plus , Z⊗I) • CZ • H0 • R (plus , Z⊗I) • S0⁻¹ • H0 • CZ • S0⁻¹ • S0 • H0 • R (plus , Z⊗I) • S0⁻¹ • H0 • S0⁻¹ • R (plus , Y⊗I) • R (plus , Y⊗Z) • R (plus , Z⊗I) • R (plus , Y⊗I) • R (plus , Y⊗Z) • R (plus , X⊗Z) • R (plus , Y⊗X) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Y⊗X) • R (plus , Z⊗Y) • R (plus , Z⊗X) • CZ • H0 • H1 • CZ • H0 • S0 • S0 • H0 • H1 • S1 • S1 • H1 • W ^ 6 • ε
          by in-context 19 10 auto (lemma-R (C.CZ • C.H0 • C.S1 • C.H1 • C.CZ • C.H0 • C.S0 • C.H0 • C.W ^ 3) (plus , Z⊗I))
      equals R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , I⊗Y) • R (plus , Y⊗Z) • R (plus , Z⊗Y) • R (plus , X⊗Y) • R (plus , Z⊗I) • R (plus , X⊗Y) • R (plus , Y⊗Z) • R (plus , X⊗Z) • R (plus , Z⊗X) • R (plus , Z⊗X) • R (minus , I⊗Z) • R (plus , X⊗I) • R (minus , Y⊗X) • R (plus , Y⊗Y) • R (minus , Z⊗X) • R (plus , X⊗Z) • R (plus , X⊗X) • CZ • H0 • S1 • H1 • CZ • H0 • S0 • H0 • W ^ 3 • S0⁻¹ • H0 • CZ • S0⁻¹ • S0 • H0 • R (plus , Z⊗I) • S0⁻¹ • H0 • S0⁻¹ • R (plus , Z⊗I) • CZ • H0 • R (plus , Z⊗I) • S0⁻¹ • H0 • CZ • S0⁻¹ • S0 • H0 • R (plus , Z⊗I) • S0⁻¹ • H0 • S0⁻¹ • R (plus , Y⊗I) • R (plus , Y⊗Z) • R (plus , Z⊗I) • R (plus , Y⊗I) • R (plus , Y⊗Z) • R (plus , X⊗Z) • R (plus , Y⊗X) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Y⊗X) • R (plus , Z⊗Y) • R (plus , Z⊗X) • CZ • H0 • H1 • CZ • H0 • S0 • S0 • H0 • H1 • S1 • S1 • H1 • W ^ 6 • ε
          by clifford-tactic 21 14 10000 auto
      equals R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , I⊗Y) • R (plus , Y⊗Z) • R (plus , Z⊗Y) • R (plus , X⊗Y) • R (plus , Z⊗I) • R (plus , X⊗Y) • R (plus , Y⊗Z) • R (plus , X⊗Z) • R (plus , Z⊗X) • R (plus , Z⊗X) • R (minus , I⊗Z) • R (plus , X⊗I) • R (minus , Y⊗X) • R (plus , Y⊗Y) • R (minus , Z⊗X) • R (plus , X⊗Z) • R (plus , X⊗X) • CZ • S0 • H0 • S0 • S0 • S0 • S1 • H1 • S1 • S1 • W ^ 3 • R (plus , Z⊗I) • S0⁻¹ • H0 • S0⁻¹ • R (plus , Z⊗I) • CZ • H0 • R (plus , Z⊗I) • S0⁻¹ • H0 • CZ • S0⁻¹ • S0 • H0 • R (plus , Z⊗I) • S0⁻¹ • H0 • S0⁻¹ • R (plus , Y⊗I) • R (plus , Y⊗Z) • R (plus , Z⊗I) • R (plus , Y⊗I) • R (plus , Y⊗Z) • R (plus , X⊗Z) • R (plus , Y⊗X) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Y⊗X) • R (plus , Z⊗Y) • R (plus , Z⊗X) • CZ • H0 • H1 • CZ • H0 • S0 • S0 • H0 • H1 • S1 • S1 • H1 • W ^ 6 • ε
          by in-context 20 12 auto (lemma-R (C.CZ • C.S0 • C.H0 • C.S0 • C.S0 • C.S0 • C.S1 • C.H1 • C.S1 • C.S1 • C.W ^ 3) (plus , Z⊗I))
      equals R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , I⊗Y) • R (plus , Y⊗Z) • R (plus , Z⊗Y) • R (plus , X⊗Y) • R (plus , Z⊗I) • R (plus , X⊗Y) • R (plus , Y⊗Z) • R (plus , X⊗Z) • R (plus , Z⊗X) • R (plus , Z⊗X) • R (minus , I⊗Z) • R (plus , X⊗I) • R (minus , Y⊗X) • R (plus , Y⊗Y) • R (minus , Z⊗X) • R (plus , X⊗Z) • R (plus , X⊗X) • R (plus , Y⊗Z) • CZ • S0 • H0 • S0 • S0 • S0 • S1 • H1 • S1 • S1 • W ^ 3 • S0⁻¹ • H0 • S0⁻¹ • R (plus , Z⊗I) • CZ • H0 • R (plus , Z⊗I) • S0⁻¹ • H0 • CZ • S0⁻¹ • S0 • H0 • R (plus , Z⊗I) • S0⁻¹ • H0 • S0⁻¹ • R (plus , Y⊗I) • R (plus , Y⊗Z) • R (plus , Z⊗I) • R (plus , Y⊗I) • R (plus , Y⊗Z) • R (plus , X⊗Z) • R (plus , Y⊗X) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Y⊗X) • R (plus , Z⊗Y) • R (plus , Z⊗X) • CZ • H0 • H1 • CZ • H0 • S0 • S0 • H0 • H1 • S1 • S1 • H1 • W ^ 6 • ε
          by clifford-tactic 23 12 10000 auto
      equals R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , I⊗Y) • R (plus , Y⊗Z) • R (plus , Z⊗Y) • R (plus , X⊗Y) • R (plus , Z⊗I) • R (plus , X⊗Y) • R (plus , Y⊗Z) • R (plus , X⊗Z) • R (plus , Z⊗X) • R (plus , Z⊗X) • R (minus , I⊗Z) • R (plus , X⊗I) • R (minus , Y⊗X) • R (plus , Y⊗Y) • R (minus , Z⊗X) • R (plus , X⊗Z) • R (plus , X⊗X) • R (plus , Y⊗Z) • CZ • S0 • S0 • H0 • S0 • S0 • H0 • S1 • H1 • S1 • S1 • W • R (plus , Z⊗I) • CZ • H0 • R (plus , Z⊗I) • S0⁻¹ • H0 • CZ • S0⁻¹ • S0 • H0 • R (plus , Z⊗I) • S0⁻¹ • H0 • S0⁻¹ • R (plus , Y⊗I) • R (plus , Y⊗Z) • R (plus , Z⊗I) • R (plus , Y⊗I) • R (plus , Y⊗Z) • R (plus , X⊗Z) • R (plus , Y⊗X) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Y⊗X) • R (plus , Z⊗Y) • R (plus , Z⊗X) • CZ • H0 • H1 • CZ • H0 • S0 • S0 • H0 • H1 • S1 • S1 • H1 • W ^ 6 • ε
          by in-context 21 13 auto (lemma-R (C.CZ • C.S0 • C.S0 • C.H0 • C.S0 • C.S0 • C.H0 • C.S1 • C.H1 • C.S1 • C.S1 • C.W) (plus , Z⊗I))
      equals R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , I⊗Y) • R (plus , Y⊗Z) • R (plus , Z⊗Y) • R (plus , X⊗Y) • R (plus , Z⊗I) • R (plus , X⊗Y) • R (plus , Y⊗Z) • R (plus , X⊗Z) • R (plus , Z⊗X) • R (plus , Z⊗X) • R (minus , I⊗Z) • R (plus , X⊗I) • R (minus , Y⊗X) • R (plus , Y⊗Y) • R (minus , Z⊗X) • R (plus , X⊗Z) • R (plus , X⊗X) • R (plus , Y⊗Z) • R (minus , Z⊗I) • CZ • S0 • S0 • H0 • S0 • S0 • H0 • S1 • H1 • S1 • S1 • W • CZ • H0 • R (plus , Z⊗I) • S0⁻¹ • H0 • CZ • S0⁻¹ • S0 • H0 • R (plus , Z⊗I) • S0⁻¹ • H0 • S0⁻¹ • R (plus , Y⊗I) • R (plus , Y⊗Z) • R (plus , Z⊗I) • R (plus , Y⊗I) • R (plus , Y⊗Z) • R (plus , X⊗Z) • R (plus , Y⊗X) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Y⊗X) • R (plus , Z⊗Y) • R (plus , Z⊗X) • CZ • H0 • H1 • CZ • H0 • S0 • S0 • H0 • H1 • S1 • S1 • H1 • W ^ 6 • ε
          by clifford-tactic 22 14 10000 auto
      equals R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , I⊗Y) • R (plus , Y⊗Z) • R (plus , Z⊗Y) • R (plus , X⊗Y) • R (plus , Z⊗I) • R (plus , X⊗Y) • R (plus , Y⊗Z) • R (plus , X⊗Z) • R (plus , Z⊗X) • R (plus , Z⊗X) • R (minus , I⊗Z) • R (plus , X⊗I) • R (minus , Y⊗X) • R (plus , Y⊗Y) • R (minus , Z⊗X) • R (plus , X⊗Z) • R (plus , X⊗X) • R (plus , Y⊗Z) • R (minus , Z⊗I) • H1 • CZ • S0 • H0 • S0 • S0 • H1 • S1 • H1 • W • R (plus , Z⊗I) • S0⁻¹ • H0 • CZ • S0⁻¹ • S0 • H0 • R (plus , Z⊗I) • S0⁻¹ • H0 • S0⁻¹ • R (plus , Y⊗I) • R (plus , Y⊗Z) • R (plus , Z⊗I) • R (plus , Y⊗I) • R (plus , Y⊗Z) • R (plus , X⊗Z) • R (plus , Y⊗X) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Y⊗X) • R (plus , Z⊗Y) • R (plus , Z⊗X) • CZ • H0 • H1 • CZ • H0 • S0 • S0 • H0 • H1 • S1 • S1 • H1 • W ^ 6 • ε
          by in-context 22 11 auto (lemma-R (C.H1 • C.CZ • C.S0 • C.H0 • C.S0 • C.S0 • C.H1 • C.S1 • C.H1 • C.W) (plus , Z⊗I))
      equals R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , I⊗Y) • R (plus , Y⊗Z) • R (plus , Z⊗Y) • R (plus , X⊗Y) • R (plus , Z⊗I) • R (plus , X⊗Y) • R (plus , Y⊗Z) • R (plus , X⊗Z) • R (plus , Z⊗X) • R (plus , Z⊗X) • R (minus , I⊗Z) • R (plus , X⊗I) • R (minus , Y⊗X) • R (plus , Y⊗Y) • R (minus , Z⊗X) • R (plus , X⊗Z) • R (plus , X⊗X) • R (plus , Y⊗Z) • R (minus , Z⊗I) • R (plus , Y⊗X) • H1 • CZ • S0 • H0 • S0 • S0 • H1 • S1 • H1 • W • S0⁻¹ • H0 • CZ • S0⁻¹ • S0 • H0 • R (plus , Z⊗I) • S0⁻¹ • H0 • S0⁻¹ • R (plus , Y⊗I) • R (plus , Y⊗Z) • R (plus , Z⊗I) • R (plus , Y⊗I) • R (plus , Y⊗Z) • R (plus , X⊗Z) • R (plus , Y⊗X) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Y⊗X) • R (plus , Z⊗Y) • R (plus , Z⊗X) • CZ • H0 • H1 • CZ • H0 • S0 • S0 • H0 • H1 • S1 • S1 • H1 • W ^ 6 • ε
          by clifford-tactic 23 16 10000 auto
      equals R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , I⊗Y) • R (plus , Y⊗Z) • R (plus , Z⊗Y) • R (plus , X⊗Y) • R (plus , Z⊗I) • R (plus , X⊗Y) • R (plus , Y⊗Z) • R (plus , X⊗Z) • R (plus , Z⊗X) • R (plus , Z⊗X) • R (minus , I⊗Z) • R (plus , X⊗I) • R (minus , Y⊗X) • R (plus , Y⊗Y) • R (minus , Z⊗X) • R (plus , X⊗Z) • R (plus , X⊗X) • R (plus , Y⊗Z) • R (minus , Z⊗I) • R (plus , Y⊗X) • CZ • H0 • S1 • H1 • CZ • H0 • S0 • S0 • H0 • S0 • S1 • S1 • S1 • W • R (plus , Z⊗I) • S0⁻¹ • H0 • S0⁻¹ • R (plus , Y⊗I) • R (plus , Y⊗Z) • R (plus , Z⊗I) • R (plus , Y⊗I) • R (plus , Y⊗Z) • R (plus , X⊗Z) • R (plus , Y⊗X) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Y⊗X) • R (plus , Z⊗Y) • R (plus , Z⊗X) • CZ • H0 • H1 • CZ • H0 • S0 • S0 • H0 • H1 • S1 • S1 • H1 • W ^ 6 • ε
          by in-context 23 15 auto (lemma-R (C.CZ • C.H0 • C.S1 • C.H1 • C.CZ • C.H0 • C.S0 • C.S0 • C.H0 • C.S0 • C.S1 • C.S1 • C.S1 • C.W) (plus , Z⊗I))
      equals R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , I⊗Y) • R (plus , Y⊗Z) • R (plus , Z⊗Y) • R (plus , X⊗Y) • R (plus , Z⊗I) • R (plus , X⊗Y) • R (plus , Y⊗Z) • R (plus , X⊗Z) • R (plus , Z⊗X) • R (plus , Z⊗X) • R (minus , I⊗Z) • R (plus , X⊗I) • R (minus , Y⊗X) • R (plus , Y⊗Y) • R (minus , Z⊗X) • R (plus , X⊗Z) • R (plus , X⊗X) • R (plus , Y⊗Z) • R (minus , Z⊗I) • R (plus , Y⊗X) • R (minus , X⊗Z) • CZ • H0 • S1 • H1 • CZ • H0 • S0 • S0 • H0 • S0 • S1 • S1 • S1 • W • S0⁻¹ • H0 • S0⁻¹ • R (plus , Y⊗I) • R (plus , Y⊗Z) • R (plus , Z⊗I) • R (plus , Y⊗I) • R (plus , Y⊗Z) • R (plus , X⊗Z) • R (plus , Y⊗X) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Y⊗X) • R (plus , Z⊗Y) • R (plus , Z⊗X) • CZ • H0 • H1 • CZ • H0 • S0 • S0 • H0 • H1 • S1 • S1 • H1 • W ^ 6 • ε
          by clifford-tactic 31 10 10000 auto
      equals R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , I⊗Y) • R (plus , Y⊗Z) • R (plus , Z⊗Y) • R (plus , X⊗Y) • R (plus , Z⊗I) • R (plus , X⊗Y) • R (plus , Y⊗Z) • R (plus , X⊗Z) • R (plus , Z⊗X) • R (plus , Z⊗X) • R (minus , I⊗Z) • R (plus , X⊗I) • R (minus , Y⊗X) • R (plus , Y⊗Y) • R (minus , Z⊗X) • R (plus , X⊗Z) • R (plus , X⊗X) • R (plus , Y⊗Z) • R (minus , Z⊗I) • R (plus , Y⊗X) • R (minus , X⊗Z) • CZ • H0 • S1 • H1 • CZ • H0 • S0 • S1 • S1 • S1 • W • R (plus , Y⊗I) • R (plus , Y⊗Z) • R (plus , Z⊗I) • R (plus , Y⊗I) • R (plus , Y⊗Z) • R (plus , X⊗Z) • R (plus , Y⊗X) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Y⊗X) • R (plus , Z⊗Y) • R (plus , Z⊗X) • CZ • H0 • H1 • CZ • H0 • S0 • S0 • H0 • H1 • S1 • S1 • H1 • W ^ 6 • ε
          by in-context 17 2 auto (symm (tactic-pauli-commute (plus , X⊗Z) (minus , Z⊗X) auto))
      equals R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , I⊗Y) • R (plus , Y⊗Z) • R (plus , Z⊗Y) • R (plus , X⊗Y) • R (plus , Z⊗I) • R (plus , X⊗Y) • R (plus , Y⊗Z) • R (plus , X⊗Z) • R (plus , Z⊗X) • R (plus , Z⊗X) • R (minus , I⊗Z) • R (plus , X⊗I) • R (minus , Y⊗X) • R (plus , Y⊗Y) • R (plus , X⊗Z) • R (minus , Z⊗X) • R (plus , X⊗X) • R (plus , Y⊗Z) • R (minus , Z⊗I) • R (plus , Y⊗X) • R (minus , X⊗Z) • CZ • H0 • S1 • H1 • CZ • H0 • S0 • S1 • S1 • S1 • W • R (plus , Y⊗I) • R (plus , Y⊗Z) • R (plus , Z⊗I) • R (plus , Y⊗I) • R (plus , Y⊗Z) • R (plus , X⊗Z) • R (plus , Y⊗X) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Y⊗X) • R (plus , Z⊗Y) • R (plus , Z⊗X) • CZ • H0 • H1 • CZ • H0 • S0 • S0 • H0 • H1 • S1 • S1 • H1 • W ^ 6 • ε
          by in-context 16 2 auto (symm (tactic-pauli-commute (plus , X⊗Z) (plus , Y⊗Y) auto))
      equals R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , I⊗Y) • R (plus , Y⊗Z) • R (plus , Z⊗Y) • R (plus , X⊗Y) • R (plus , Z⊗I) • R (plus , X⊗Y) • R (plus , Y⊗Z) • R (plus , X⊗Z) • R (plus , Z⊗X) • R (plus , Z⊗X) • R (minus , I⊗Z) • R (plus , X⊗I) • R (minus , Y⊗X) • R (plus , X⊗Z) • R (plus , Y⊗Y) • R (minus , Z⊗X) • R (plus , X⊗X) • R (plus , Y⊗Z) • R (minus , Z⊗I) • R (plus , Y⊗X) • R (minus , X⊗Z) • CZ • H0 • S1 • H1 • CZ • H0 • S0 • S1 • S1 • S1 • W • R (plus , Y⊗I) • R (plus , Y⊗Z) • R (plus , Z⊗I) • R (plus , Y⊗I) • R (plus , Y⊗Z) • R (plus , X⊗Z) • R (plus , Y⊗X) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Y⊗X) • R (plus , Z⊗Y) • R (plus , Z⊗X) • CZ • H0 • H1 • CZ • H0 • S0 • S0 • H0 • H1 • S1 • S1 • H1 • W ^ 6 • ε
          by in-context 15 2 auto (symm (tactic-pauli-commute (plus , X⊗Z) (minus , Y⊗X) auto))
      equals R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , I⊗Y) • R (plus , Y⊗Z) • R (plus , Z⊗Y) • R (plus , X⊗Y) • R (plus , Z⊗I) • R (plus , X⊗Y) • R (plus , Y⊗Z) • R (plus , X⊗Z) • R (plus , Z⊗X) • R (plus , Z⊗X) • R (minus , I⊗Z) • R (plus , X⊗I) • R (plus , X⊗Z) • R (minus , Y⊗X) • R (plus , Y⊗Y) • R (minus , Z⊗X) • R (plus , X⊗X) • R (plus , Y⊗Z) • R (minus , Z⊗I) • R (plus , Y⊗X) • R (minus , X⊗Z) • CZ • H0 • S1 • H1 • CZ • H0 • S0 • S1 • S1 • S1 • W • R (plus , Y⊗I) • R (plus , Y⊗Z) • R (plus , Z⊗I) • R (plus , Y⊗I) • R (plus , Y⊗Z) • R (plus , X⊗Z) • R (plus , Y⊗X) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Y⊗X) • R (plus , Z⊗Y) • R (plus , Z⊗X) • CZ • H0 • H1 • CZ • H0 • S0 • S0 • H0 • H1 • S1 • S1 • H1 • W ^ 6 • ε
          by in-context 14 2 auto (symm (tactic-pauli-commute (plus , X⊗Z) (plus , X⊗I) auto))
      equals R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , I⊗Y) • R (plus , Y⊗Z) • R (plus , Z⊗Y) • R (plus , X⊗Y) • R (plus , Z⊗I) • R (plus , X⊗Y) • R (plus , Y⊗Z) • R (plus , X⊗Z) • R (plus , Z⊗X) • R (plus , Z⊗X) • R (minus , I⊗Z) • R (plus , X⊗Z) • R (plus , X⊗I) • R (minus , Y⊗X) • R (plus , Y⊗Y) • R (minus , Z⊗X) • R (plus , X⊗X) • R (plus , Y⊗Z) • R (minus , Z⊗I) • R (plus , Y⊗X) • R (minus , X⊗Z) • CZ • H0 • S1 • H1 • CZ • H0 • S0 • S1 • S1 • S1 • W • R (plus , Y⊗I) • R (plus , Y⊗Z) • R (plus , Z⊗I) • R (plus , Y⊗I) • R (plus , Y⊗Z) • R (plus , X⊗Z) • R (plus , Y⊗X) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Y⊗X) • R (plus , Z⊗Y) • R (plus , Z⊗X) • CZ • H0 • H1 • CZ • H0 • S0 • S0 • H0 • H1 • S1 • S1 • H1 • W ^ 6 • ε
          by in-context 13 2 auto (symm (tactic-pauli-commute (plus , X⊗Z) (minus , I⊗Z) auto))
      equals R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , I⊗Y) • R (plus , Y⊗Z) • R (plus , Z⊗Y) • R (plus , X⊗Y) • R (plus , Z⊗I) • R (plus , X⊗Y) • R (plus , Y⊗Z) • R (plus , X⊗Z) • R (plus , Z⊗X) • R (plus , Z⊗X) • R (plus , X⊗Z) • R (minus , I⊗Z) • R (plus , X⊗I) • R (minus , Y⊗X) • R (plus , Y⊗Y) • R (minus , Z⊗X) • R (plus , X⊗X) • R (plus , Y⊗Z) • R (minus , Z⊗I) • R (plus , Y⊗X) • R (minus , X⊗Z) • CZ • H0 • S1 • H1 • CZ • H0 • S0 • S1 • S1 • S1 • W • R (plus , Y⊗I) • R (plus , Y⊗Z) • R (plus , Z⊗I) • R (plus , Y⊗I) • R (plus , Y⊗Z) • R (plus , X⊗Z) • R (plus , Y⊗X) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Y⊗X) • R (plus , Z⊗Y) • R (plus , Z⊗X) • CZ • H0 • H1 • CZ • H0 • S0 • S0 • H0 • H1 • S1 • S1 • H1 • W ^ 6 • ε
          by in-context 12 2 auto (symm (tactic-pauli-commute (plus , X⊗Z) (plus , Z⊗X) auto))
      equals R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , I⊗Y) • R (plus , Y⊗Z) • R (plus , Z⊗Y) • R (plus , X⊗Y) • R (plus , Z⊗I) • R (plus , X⊗Y) • R (plus , Y⊗Z) • R (plus , X⊗Z) • R (plus , Z⊗X) • R (plus , X⊗Z) • R (plus , Z⊗X) • R (minus , I⊗Z) • R (plus , X⊗I) • R (minus , Y⊗X) • R (plus , Y⊗Y) • R (minus , Z⊗X) • R (plus , X⊗X) • R (plus , Y⊗Z) • R (minus , Z⊗I) • R (plus , Y⊗X) • R (minus , X⊗Z) • CZ • H0 • S1 • H1 • CZ • H0 • S0 • S1 • S1 • S1 • W • R (plus , Y⊗I) • R (plus , Y⊗Z) • R (plus , Z⊗I) • R (plus , Y⊗I) • R (plus , Y⊗Z) • R (plus , X⊗Z) • R (plus , Y⊗X) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Y⊗X) • R (plus , Z⊗Y) • R (plus , Z⊗X) • CZ • H0 • H1 • CZ • H0 • S0 • S0 • H0 • H1 • S1 • S1 • H1 • W ^ 6 • ε
          by in-context 11 2 auto (symm (tactic-pauli-commute (plus , X⊗Z) (plus , Z⊗X) auto))
      equals R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , I⊗Y) • R (plus , Y⊗Z) • R (plus , Z⊗Y) • R (plus , X⊗Y) • R (plus , Z⊗I) • R (plus , X⊗Y) • R (plus , Y⊗Z) • R (plus , X⊗Z) • R (plus , X⊗Z) • R (plus , Z⊗X) • R (plus , Z⊗X) • R (minus , I⊗Z) • R (plus , X⊗I) • R (minus , Y⊗X) • R (plus , Y⊗Y) • R (minus , Z⊗X) • R (plus , X⊗X) • R (plus , Y⊗Z) • R (minus , Z⊗I) • R (plus , Y⊗X) • R (minus , X⊗Z) • CZ • H0 • S1 • H1 • CZ • H0 • S0 • S1 • S1 • S1 • W • R (plus , Y⊗I) • R (plus , Y⊗Z) • R (plus , Z⊗I) • R (plus , Y⊗I) • R (plus , Y⊗Z) • R (plus , X⊗Z) • R (plus , Y⊗X) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Y⊗X) • R (plus , Z⊗Y) • R (plus , Z⊗X) • CZ • H0 • H1 • CZ • H0 • S0 • S0 • H0 • H1 • S1 • S1 • H1 • W ^ 6 • ε
          by in-context 19 2 auto (symm (tactic-pauli-commute (plus , Y⊗Z) (plus , X⊗X) auto))
      equals R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , I⊗Y) • R (plus , Y⊗Z) • R (plus , Z⊗Y) • R (plus , X⊗Y) • R (plus , Z⊗I) • R (plus , X⊗Y) • R (plus , Y⊗Z) • R (plus , X⊗Z) • R (plus , X⊗Z) • R (plus , Z⊗X) • R (plus , Z⊗X) • R (minus , I⊗Z) • R (plus , X⊗I) • R (minus , Y⊗X) • R (plus , Y⊗Y) • R (minus , Z⊗X) • R (plus , Y⊗Z) • R (plus , X⊗X) • R (minus , Z⊗I) • R (plus , Y⊗X) • R (minus , X⊗Z) • CZ • H0 • S1 • H1 • CZ • H0 • S0 • S1 • S1 • S1 • W • R (plus , Y⊗I) • R (plus , Y⊗Z) • R (plus , Z⊗I) • R (plus , Y⊗I) • R (plus , Y⊗Z) • R (plus , X⊗Z) • R (plus , Y⊗X) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Y⊗X) • R (plus , Z⊗Y) • R (plus , Z⊗X) • CZ • H0 • H1 • CZ • H0 • S0 • S0 • H0 • H1 • S1 • S1 • H1 • W ^ 6 • ε
          by in-context 18 2 auto (symm (tactic-pauli-commute (plus , Y⊗Z) (minus , Z⊗X) auto))
      equals R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , I⊗Y) • R (plus , Y⊗Z) • R (plus , Z⊗Y) • R (plus , X⊗Y) • R (plus , Z⊗I) • R (plus , X⊗Y) • R (plus , Y⊗Z) • R (plus , X⊗Z) • R (plus , X⊗Z) • R (plus , Z⊗X) • R (plus , Z⊗X) • R (minus , I⊗Z) • R (plus , X⊗I) • R (minus , Y⊗X) • R (plus , Y⊗Y) • R (plus , Y⊗Z) • R (minus , Z⊗X) • R (plus , X⊗X) • R (minus , Z⊗I) • R (plus , Y⊗X) • R (minus , X⊗Z) • CZ • H0 • S1 • H1 • CZ • H0 • S0 • S1 • S1 • S1 • W • R (plus , Y⊗I) • R (plus , Y⊗Z) • R (plus , Z⊗I) • R (plus , Y⊗I) • R (plus , Y⊗Z) • R (plus , X⊗Z) • R (plus , Y⊗X) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Y⊗X) • R (plus , Z⊗Y) • R (plus , Z⊗X) • CZ • H0 • H1 • CZ • H0 • S0 • S0 • H0 • H1 • S1 • S1 • H1 • W ^ 6 • ε
          by in-context 22 2 auto (symm (tactic-pauli-commute (minus , X⊗Z) (plus , Y⊗X) auto))
      equals R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , I⊗Y) • R (plus , Y⊗Z) • R (plus , Z⊗Y) • R (plus , X⊗Y) • R (plus , Z⊗I) • R (plus , X⊗Y) • R (plus , Y⊗Z) • R (plus , X⊗Z) • R (plus , X⊗Z) • R (plus , Z⊗X) • R (plus , Z⊗X) • R (minus , I⊗Z) • R (plus , X⊗I) • R (minus , Y⊗X) • R (plus , Y⊗Y) • R (plus , Y⊗Z) • R (minus , Z⊗X) • R (plus , X⊗X) • R (minus , Z⊗I) • R (minus , X⊗Z) • R (plus , Y⊗X) • CZ • H0 • S1 • H1 • CZ • H0 • S0 • S1 • S1 • S1 • W • R (plus , Y⊗I) • R (plus , Y⊗Z) • R (plus , Z⊗I) • R (plus , Y⊗I) • R (plus , Y⊗Z) • R (plus , X⊗Z) • R (plus , Y⊗X) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Y⊗X) • R (plus , Z⊗Y) • R (plus , Z⊗X) • CZ • H0 • H1 • CZ • H0 • S0 • S0 • H0 • H1 • S1 • S1 • H1 • W ^ 6 • ε
          by in-context 10 2 auto (lemma-combine plus plus X⊗Z)
      equals R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , I⊗Y) • R (plus , Y⊗Z) • R (plus , Z⊗Y) • R (plus , X⊗Y) • R (plus , Z⊗I) • R (plus , X⊗Y) • R (plus , Y⊗Z) • CZ • H0 • S0 • H0 • CZ • R (plus , Z⊗X) • R (plus , Z⊗X) • R (minus , I⊗Z) • R (plus , X⊗I) • R (minus , Y⊗X) • R (plus , Y⊗Y) • R (plus , Y⊗Z) • R (minus , Z⊗X) • R (plus , X⊗X) • R (minus , Z⊗I) • R (minus , X⊗Z) • R (plus , Y⊗X) • CZ • H0 • S1 • H1 • CZ • H0 • S0 • S1 • S1 • S1 • W • R (plus , Y⊗I) • R (plus , Y⊗Z) • R (plus , Z⊗I) • R (plus , Y⊗I) • R (plus , Y⊗Z) • R (plus , X⊗Z) • R (plus , Y⊗X) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Y⊗X) • R (plus , Z⊗Y) • R (plus , Z⊗X) • CZ • H0 • H1 • CZ • H0 • S0 • S0 • H0 • H1 • S1 • S1 • H1 • W ^ 6 • ε
          by in-context 15 2 auto (lemma-combine plus plus Z⊗X)
      equals R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , I⊗Y) • R (plus , Y⊗Z) • R (plus , Z⊗Y) • R (plus , X⊗Y) • R (plus , Z⊗I) • R (plus , X⊗Y) • R (plus , Y⊗Z) • CZ • H0 • S0 • H0 • CZ • H1 • H0 • CZ • H0 • S0 • H0 • CZ • H0 • H1 • R (minus , I⊗Z) • R (plus , X⊗I) • R (minus , Y⊗X) • R (plus , Y⊗Y) • R (plus , Y⊗Z) • R (minus , Z⊗X) • R (plus , X⊗X) • R (minus , Z⊗I) • R (minus , X⊗Z) • R (plus , Y⊗X) • CZ • H0 • S1 • H1 • CZ • H0 • S0 • S1 • S1 • S1 • W • R (plus , Y⊗I) • R (plus , Y⊗Z) • R (plus , Z⊗I) • R (plus , Y⊗I) • R (plus , Y⊗Z) • R (plus , X⊗Z) • R (plus , Y⊗X) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Y⊗X) • R (plus , Z⊗Y) • R (plus , Z⊗X) • CZ • H0 • H1 • CZ • H0 • S0 • S0 • H0 • H1 • S1 • S1 • H1 • W ^ 6 • ε
          by in-context 10 15 auto (lemma-R (C.CZ • C.H0 • C.S0 • C.H0 • C.CZ • C.H1 • C.H0 • C.CZ • C.H0 • C.S0 • C.H0 • C.CZ • C.H0 • C.H1) (minus , I⊗Z))
      equals R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , I⊗Y) • R (plus , Y⊗Z) • R (plus , Z⊗Y) • R (plus , X⊗Y) • R (plus , Z⊗I) • R (plus , X⊗Y) • R (plus , Y⊗Z) • R (plus , Z⊗Y) • CZ • H0 • S0 • H0 • CZ • H1 • H0 • CZ • H0 • S0 • H0 • CZ • H0 • H1 • R (plus , X⊗I) • R (minus , Y⊗X) • R (plus , Y⊗Y) • R (plus , Y⊗Z) • R (minus , Z⊗X) • R (plus , X⊗X) • R (minus , Z⊗I) • R (minus , X⊗Z) • R (plus , Y⊗X) • CZ • H0 • S1 • H1 • CZ • H0 • S0 • S1 • S1 • S1 • W • R (plus , Y⊗I) • R (plus , Y⊗Z) • R (plus , Z⊗I) • R (plus , Y⊗I) • R (plus , Y⊗Z) • R (plus , X⊗Z) • R (plus , Y⊗X) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Y⊗X) • R (plus , Z⊗Y) • R (plus , Z⊗X) • CZ • H0 • H1 • CZ • H0 • S0 • S0 • H0 • H1 • S1 • S1 • H1 • W ^ 6 • ε
          by in-context 11 15 auto (lemma-R (C.CZ • C.H0 • C.S0 • C.H0 • C.CZ • C.H1 • C.H0 • C.CZ • C.H0 • C.S0 • C.H0 • C.CZ • C.H0 • C.H1) (plus , X⊗I))
      equals R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , I⊗Y) • R (plus , Y⊗Z) • R (plus , Z⊗Y) • R (plus , X⊗Y) • R (plus , Z⊗I) • R (plus , X⊗Y) • R (plus , Y⊗Z) • R (plus , Z⊗Y) • R (plus , Y⊗X) • CZ • H0 • S0 • H0 • CZ • H1 • H0 • CZ • H0 • S0 • H0 • CZ • H0 • H1 • R (minus , Y⊗X) • R (plus , Y⊗Y) • R (plus , Y⊗Z) • R (minus , Z⊗X) • R (plus , X⊗X) • R (minus , Z⊗I) • R (minus , X⊗Z) • R (plus , Y⊗X) • CZ • H0 • S1 • H1 • CZ • H0 • S0 • S1 • S1 • S1 • W • R (plus , Y⊗I) • R (plus , Y⊗Z) • R (plus , Z⊗I) • R (plus , Y⊗I) • R (plus , Y⊗Z) • R (plus , X⊗Z) • R (plus , Y⊗X) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Y⊗X) • R (plus , Z⊗Y) • R (plus , Z⊗X) • CZ • H0 • H1 • CZ • H0 • S0 • S0 • H0 • H1 • S1 • S1 • H1 • W ^ 6 • ε
          by in-context 12 15 auto (lemma-R (C.CZ • C.H0 • C.S0 • C.H0 • C.CZ • C.H1 • C.H0 • C.CZ • C.H0 • C.S0 • C.H0 • C.CZ • C.H0 • C.H1) (minus , Y⊗X))
      equals R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , I⊗Y) • R (plus , Y⊗Z) • R (plus , Z⊗Y) • R (plus , X⊗Y) • R (plus , Z⊗I) • R (plus , X⊗Y) • R (plus , Y⊗Z) • R (plus , Z⊗Y) • R (plus , Y⊗X) • R (plus , X⊗I) • CZ • H0 • S0 • H0 • CZ • H1 • H0 • CZ • H0 • S0 • H0 • CZ • H0 • H1 • R (plus , Y⊗Y) • R (plus , Y⊗Z) • R (minus , Z⊗X) • R (plus , X⊗X) • R (minus , Z⊗I) • R (minus , X⊗Z) • R (plus , Y⊗X) • CZ • H0 • S1 • H1 • CZ • H0 • S0 • S1 • S1 • S1 • W • R (plus , Y⊗I) • R (plus , Y⊗Z) • R (plus , Z⊗I) • R (plus , Y⊗I) • R (plus , Y⊗Z) • R (plus , X⊗Z) • R (plus , Y⊗X) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Y⊗X) • R (plus , Z⊗Y) • R (plus , Z⊗X) • CZ • H0 • H1 • CZ • H0 • S0 • S0 • H0 • H1 • S1 • S1 • H1 • W ^ 6 • ε
          by in-context 13 15 auto (lemma-R (C.CZ • C.H0 • C.S0 • C.H0 • C.CZ • C.H1 • C.H0 • C.CZ • C.H0 • C.S0 • C.H0 • C.CZ • C.H0 • C.H1) (plus , Y⊗Y))
      equals R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , I⊗Y) • R (plus , Y⊗Z) • R (plus , Z⊗Y) • R (plus , X⊗Y) • R (plus , Z⊗I) • R (plus , X⊗Y) • R (plus , Y⊗Z) • R (plus , Z⊗Y) • R (plus , Y⊗X) • R (plus , X⊗I) • R (plus , Y⊗Y) • CZ • H0 • S0 • H0 • CZ • H1 • H0 • CZ • H0 • S0 • H0 • CZ • H0 • H1 • R (plus , Y⊗Z) • R (minus , Z⊗X) • R (plus , X⊗X) • R (minus , Z⊗I) • R (minus , X⊗Z) • R (plus , Y⊗X) • CZ • H0 • S1 • H1 • CZ • H0 • S0 • S1 • S1 • S1 • W • R (plus , Y⊗I) • R (plus , Y⊗Z) • R (plus , Z⊗I) • R (plus , Y⊗I) • R (plus , Y⊗Z) • R (plus , X⊗Z) • R (plus , Y⊗X) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Y⊗X) • R (plus , Z⊗Y) • R (plus , Z⊗X) • CZ • H0 • H1 • CZ • H0 • S0 • S0 • H0 • H1 • S1 • S1 • H1 • W ^ 6 • ε
          by in-context 14 15 auto (lemma-R (C.CZ • C.H0 • C.S0 • C.H0 • C.CZ • C.H1 • C.H0 • C.CZ • C.H0 • C.S0 • C.H0 • C.CZ • C.H0 • C.H1) (plus , Y⊗Z))
      equals R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , I⊗Y) • R (plus , Y⊗Z) • R (plus , Z⊗Y) • R (plus , X⊗Y) • R (plus , Z⊗I) • R (plus , X⊗Y) • R (plus , Y⊗Z) • R (plus , Z⊗Y) • R (plus , Y⊗X) • R (plus , X⊗I) • R (plus , Y⊗Y) • R (plus , Z⊗I) • CZ • H0 • S0 • H0 • CZ • H1 • H0 • CZ • H0 • S0 • H0 • CZ • H0 • H1 • R (minus , Z⊗X) • R (plus , X⊗X) • R (minus , Z⊗I) • R (minus , X⊗Z) • R (plus , Y⊗X) • CZ • H0 • S1 • H1 • CZ • H0 • S0 • S1 • S1 • S1 • W • R (plus , Y⊗I) • R (plus , Y⊗Z) • R (plus , Z⊗I) • R (plus , Y⊗I) • R (plus , Y⊗Z) • R (plus , X⊗Z) • R (plus , Y⊗X) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Y⊗X) • R (plus , Z⊗Y) • R (plus , Z⊗X) • CZ • H0 • H1 • CZ • H0 • S0 • S0 • H0 • H1 • S1 • S1 • H1 • W ^ 6 • ε
          by in-context 15 15 auto (lemma-R (C.CZ • C.H0 • C.S0 • C.H0 • C.CZ • C.H1 • C.H0 • C.CZ • C.H0 • C.S0 • C.H0 • C.CZ • C.H0 • C.H1) (minus , Z⊗X))
      equals R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , I⊗Y) • R (plus , Y⊗Z) • R (plus , Z⊗Y) • R (plus , X⊗Y) • R (plus , Z⊗I) • R (plus , X⊗Y) • R (plus , Y⊗Z) • R (plus , Z⊗Y) • R (plus , Y⊗X) • R (plus , X⊗I) • R (plus , Y⊗Y) • R (plus , Z⊗I) • R (minus , Z⊗X) • CZ • H0 • S0 • H0 • CZ • H1 • H0 • CZ • H0 • S0 • H0 • CZ • H0 • H1 • R (plus , X⊗X) • R (minus , Z⊗I) • R (minus , X⊗Z) • R (plus , Y⊗X) • CZ • H0 • S1 • H1 • CZ • H0 • S0 • S1 • S1 • S1 • W • R (plus , Y⊗I) • R (plus , Y⊗Z) • R (plus , Z⊗I) • R (plus , Y⊗I) • R (plus , Y⊗Z) • R (plus , X⊗Z) • R (plus , Y⊗X) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Y⊗X) • R (plus , Z⊗Y) • R (plus , Z⊗X) • CZ • H0 • H1 • CZ • H0 • S0 • S0 • H0 • H1 • S1 • S1 • H1 • W ^ 6 • ε
          by in-context 16 15 auto (lemma-R (C.CZ • C.H0 • C.S0 • C.H0 • C.CZ • C.H1 • C.H0 • C.CZ • C.H0 • C.S0 • C.H0 • C.CZ • C.H0 • C.H1) (plus , X⊗X))
      equals R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , I⊗Y) • R (plus , Y⊗Z) • R (plus , Z⊗Y) • R (plus , X⊗Y) • R (plus , Z⊗I) • R (plus , X⊗Y) • R (plus , Y⊗Z) • R (plus , Z⊗Y) • R (plus , Y⊗X) • R (plus , X⊗I) • R (plus , Y⊗Y) • R (plus , Z⊗I) • R (minus , Z⊗X) • R (plus , Z⊗Z) • CZ • H0 • S0 • H0 • CZ • H1 • H0 • CZ • H0 • S0 • H0 • CZ • H0 • H1 • R (minus , Z⊗I) • R (minus , X⊗Z) • R (plus , Y⊗X) • CZ • H0 • S1 • H1 • CZ • H0 • S0 • S1 • S1 • S1 • W • R (plus , Y⊗I) • R (plus , Y⊗Z) • R (plus , Z⊗I) • R (plus , Y⊗I) • R (plus , Y⊗Z) • R (plus , X⊗Z) • R (plus , Y⊗X) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Y⊗X) • R (plus , Z⊗Y) • R (plus , Z⊗X) • CZ • H0 • H1 • CZ • H0 • S0 • S0 • H0 • H1 • S1 • S1 • H1 • W ^ 6 • ε
          by in-context 17 15 auto (lemma-R (C.CZ • C.H0 • C.S0 • C.H0 • C.CZ • C.H1 • C.H0 • C.CZ • C.H0 • C.S0 • C.H0 • C.CZ • C.H0 • C.H1) (minus , Z⊗I))
      equals R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , I⊗Y) • R (plus , Y⊗Z) • R (plus , Z⊗Y) • R (plus , X⊗Y) • R (plus , Z⊗I) • R (plus , X⊗Y) • R (plus , Y⊗Z) • R (plus , Z⊗Y) • R (plus , Y⊗X) • R (plus , X⊗I) • R (plus , Y⊗Y) • R (plus , Z⊗I) • R (minus , Z⊗X) • R (plus , Z⊗Z) • R (plus , Y⊗Z) • CZ • H0 • S0 • H0 • CZ • H1 • H0 • CZ • H0 • S0 • H0 • CZ • H0 • H1 • R (minus , X⊗Z) • R (plus , Y⊗X) • CZ • H0 • S1 • H1 • CZ • H0 • S0 • S1 • S1 • S1 • W • R (plus , Y⊗I) • R (plus , Y⊗Z) • R (plus , Z⊗I) • R (plus , Y⊗I) • R (plus , Y⊗Z) • R (plus , X⊗Z) • R (plus , Y⊗X) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Y⊗X) • R (plus , Z⊗Y) • R (plus , Z⊗X) • CZ • H0 • H1 • CZ • H0 • S0 • S0 • H0 • H1 • S1 • S1 • H1 • W ^ 6 • ε
          by in-context 18 15 auto (lemma-R (C.CZ • C.H0 • C.S0 • C.H0 • C.CZ • C.H1 • C.H0 • C.CZ • C.H0 • C.S0 • C.H0 • C.CZ • C.H0 • C.H1) (minus , X⊗Z))
      equals R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , I⊗Y) • R (plus , Y⊗Z) • R (plus , Z⊗Y) • R (plus , X⊗Y) • R (plus , Z⊗I) • R (plus , X⊗Y) • R (plus , Y⊗Z) • R (plus , Z⊗Y) • R (plus , Y⊗X) • R (plus , X⊗I) • R (plus , Y⊗Y) • R (plus , Z⊗I) • R (minus , Z⊗X) • R (plus , Z⊗Z) • R (plus , Y⊗Z) • R (minus , X⊗Z) • CZ • H0 • S0 • H0 • CZ • H1 • H0 • CZ • H0 • S0 • H0 • CZ • H0 • H1 • R (plus , Y⊗X) • CZ • H0 • S1 • H1 • CZ • H0 • S0 • S1 • S1 • S1 • W • R (plus , Y⊗I) • R (plus , Y⊗Z) • R (plus , Z⊗I) • R (plus , Y⊗I) • R (plus , Y⊗Z) • R (plus , X⊗Z) • R (plus , Y⊗X) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Y⊗X) • R (plus , Z⊗Y) • R (plus , Z⊗X) • CZ • H0 • H1 • CZ • H0 • S0 • S0 • H0 • H1 • S1 • S1 • H1 • W ^ 6 • ε
          by in-context 19 15 auto (lemma-R (C.CZ • C.H0 • C.S0 • C.H0 • C.CZ • C.H1 • C.H0 • C.CZ • C.H0 • C.S0 • C.H0 • C.CZ • C.H0 • C.H1) (plus , Y⊗X))
      equals R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , I⊗Y) • R (plus , Y⊗Z) • R (plus , Z⊗Y) • R (plus , X⊗Y) • R (plus , Z⊗I) • R (plus , X⊗Y) • R (plus , Y⊗Z) • R (plus , Z⊗Y) • R (plus , Y⊗X) • R (plus , X⊗I) • R (plus , Y⊗Y) • R (plus , Z⊗I) • R (minus , Z⊗X) • R (plus , Z⊗Z) • R (plus , Y⊗Z) • R (minus , X⊗Z) • R (minus , X⊗I) • CZ • H0 • S0 • H0 • CZ • H1 • H0 • CZ • H0 • S0 • H0 • CZ • H0 • H1 • CZ • H0 • S1 • H1 • CZ • H0 • S0 • S1 • S1 • S1 • W • R (plus , Y⊗I) • R (plus , Y⊗Z) • R (plus , Z⊗I) • R (plus , Y⊗I) • R (plus , Y⊗Z) • R (plus , X⊗Z) • R (plus , Y⊗X) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Y⊗X) • R (plus , Z⊗Y) • R (plus , Z⊗X) • CZ • H0 • H1 • CZ • H0 • S0 • S0 • H0 • H1 • S1 • S1 • H1 • W ^ 6 • ε
          by clifford-tactic 20 25 10000 auto
      equals R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , I⊗Y) • R (plus , Y⊗Z) • R (plus , Z⊗Y) • R (plus , X⊗Y) • R (plus , Z⊗I) • R (plus , X⊗Y) • R (plus , Y⊗Z) • R (plus , Z⊗Y) • R (plus , Y⊗X) • R (plus , X⊗I) • R (plus , Y⊗Y) • R (plus , Z⊗I) • R (minus , Z⊗X) • R (plus , Z⊗Z) • R (plus , Y⊗Z) • R (minus , X⊗Z) • R (minus , X⊗I) • S0 • H0 • CZ • H0 • S0 • S0 • H0 • S1 • S1 • S1 • W ^ 3 • R (plus , Y⊗I) • R (plus , Y⊗Z) • R (plus , Z⊗I) • R (plus , Y⊗I) • R (plus , Y⊗Z) • R (plus , X⊗Z) • R (plus , Y⊗X) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Y⊗X) • R (plus , Z⊗Y) • R (plus , Z⊗X) • CZ • H0 • H1 • CZ • H0 • S0 • S0 • H0 • H1 • S1 • S1 • H1 • W ^ 6 • ε
          by in-context 10 2 auto (symm (tactic-pauli-commute (plus , Y⊗X) (plus , Z⊗Y) auto))
      equals R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , I⊗Y) • R (plus , Y⊗Z) • R (plus , Z⊗Y) • R (plus , X⊗Y) • R (plus , Z⊗I) • R (plus , X⊗Y) • R (plus , Y⊗Z) • R (plus , Y⊗X) • R (plus , Z⊗Y) • R (plus , X⊗I) • R (plus , Y⊗Y) • R (plus , Z⊗I) • R (minus , Z⊗X) • R (plus , Z⊗Z) • R (plus , Y⊗Z) • R (minus , X⊗Z) • R (minus , X⊗I) • S0 • H0 • CZ • H0 • S0 • S0 • H0 • S1 • S1 • S1 • W ^ 3 • R (plus , Y⊗I) • R (plus , Y⊗Z) • R (plus , Z⊗I) • R (plus , Y⊗I) • R (plus , Y⊗Z) • R (plus , X⊗Z) • R (plus , Y⊗X) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Y⊗X) • R (plus , Z⊗Y) • R (plus , Z⊗X) • CZ • H0 • H1 • CZ • H0 • S0 • S0 • H0 • H1 • S1 • S1 • H1 • W ^ 6 • ε
          by in-context 18 2 auto (symm (tactic-pauli-commute (minus , X⊗I) (minus , X⊗Z) auto))
      equals R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , I⊗Y) • R (plus , Y⊗Z) • R (plus , Z⊗Y) • R (plus , X⊗Y) • R (plus , Z⊗I) • R (plus , X⊗Y) • R (plus , Y⊗Z) • R (plus , Y⊗X) • R (plus , Z⊗Y) • R (plus , X⊗I) • R (plus , Y⊗Y) • R (plus , Z⊗I) • R (minus , Z⊗X) • R (plus , Z⊗Z) • R (plus , Y⊗Z) • R (minus , X⊗I) • R (minus , X⊗Z) • S0 • H0 • CZ • H0 • S0 • S0 • H0 • S1 • S1 • S1 • W ^ 3 • R (plus , Y⊗I) • R (plus , Y⊗Z) • R (plus , Z⊗I) • R (plus , Y⊗I) • R (plus , Y⊗Z) • R (plus , X⊗Z) • R (plus , Y⊗X) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Y⊗X) • R (plus , Z⊗Y) • R (plus , Z⊗X) • CZ • H0 • H1 • CZ • H0 • S0 • S0 • H0 • H1 • S1 • S1 • H1 • W ^ 6 • ε
          by in-context 15 1 auto (lemma-correction Z⊗X)
      equals R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , I⊗Y) • R (plus , Y⊗Z) • R (plus , Z⊗Y) • R (plus , X⊗Y) • R (plus , Z⊗I) • R (plus , X⊗Y) • R (plus , Y⊗Z) • R (plus , Y⊗X) • R (plus , Z⊗Y) • R (plus , X⊗I) • R (plus , Y⊗Y) • R (plus , Z⊗I) • R (plus , Z⊗X) • H1 • H0 • CZ • H0 • S0⁻¹ • W • H0 • CZ • H0 • H1 • R (plus , Z⊗Z) • R (plus , Y⊗Z) • R (minus , X⊗I) • R (minus , X⊗Z) • S0 • H0 • CZ • H0 • S0 • S0 • H0 • S1 • S1 • S1 • W ^ 3 • R (plus , Y⊗I) • R (plus , Y⊗Z) • R (plus , Z⊗I) • R (plus , Y⊗I) • R (plus , Y⊗Z) • R (plus , X⊗Z) • R (plus , Y⊗X) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Y⊗X) • R (plus , Z⊗Y) • R (plus , Z⊗X) • CZ • H0 • H1 • CZ • H0 • S0 • S0 • H0 • H1 • S1 • S1 • H1 • W ^ 6 • ε
          by in-context 16 11 auto (lemma-R (C.H1 • C.H0 • C.CZ • C.H0 • C.S0⁻¹ • C.W • C.H0 • C.CZ • C.H0 • C.H1) (plus , Z⊗Z))
      equals R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , I⊗Y) • R (plus , Y⊗Z) • R (plus , Z⊗Y) • R (plus , X⊗Y) • R (plus , Z⊗I) • R (plus , X⊗Y) • R (plus , Y⊗Z) • R (plus , Y⊗X) • R (plus , Z⊗Y) • R (plus , X⊗I) • R (plus , Y⊗Y) • R (plus , Z⊗I) • R (plus , Z⊗X) • R (plus , I⊗Y) • H1 • H0 • CZ • H0 • S0⁻¹ • W • H0 • CZ • H0 • H1 • R (plus , Y⊗Z) • R (minus , X⊗I) • R (minus , X⊗Z) • S0 • H0 • CZ • H0 • S0 • S0 • H0 • S1 • S1 • S1 • W ^ 3 • R (plus , Y⊗I) • R (plus , Y⊗Z) • R (plus , Z⊗I) • R (plus , Y⊗I) • R (plus , Y⊗Z) • R (plus , X⊗Z) • R (plus , Y⊗X) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Y⊗X) • R (plus , Z⊗Y) • R (plus , Z⊗X) • CZ • H0 • H1 • CZ • H0 • S0 • S0 • H0 • H1 • S1 • S1 • H1 • W ^ 6 • ε
          by in-context 17 11 auto (lemma-R (C.H1 • C.H0 • C.CZ • C.H0 • C.S0⁻¹ • C.W • C.H0 • C.CZ • C.H0 • C.H1) (plus , Y⊗Z))
      equals R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , I⊗Y) • R (plus , Y⊗Z) • R (plus , Z⊗Y) • R (plus , X⊗Y) • R (plus , Z⊗I) • R (plus , X⊗Y) • R (plus , Y⊗Z) • R (plus , Y⊗X) • R (plus , Z⊗Y) • R (plus , X⊗I) • R (plus , Y⊗Y) • R (plus , Z⊗I) • R (plus , Z⊗X) • R (plus , I⊗Y) • R (plus , Y⊗Z) • H1 • H0 • CZ • H0 • S0⁻¹ • W • H0 • CZ • H0 • H1 • R (minus , X⊗I) • R (minus , X⊗Z) • S0 • H0 • CZ • H0 • S0 • S0 • H0 • S1 • S1 • S1 • W ^ 3 • R (plus , Y⊗I) • R (plus , Y⊗Z) • R (plus , Z⊗I) • R (plus , Y⊗I) • R (plus , Y⊗Z) • R (plus , X⊗Z) • R (plus , Y⊗X) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Y⊗X) • R (plus , Z⊗Y) • R (plus , Z⊗X) • CZ • H0 • H1 • CZ • H0 • S0 • S0 • H0 • H1 • S1 • S1 • H1 • W ^ 6 • ε
          by in-context 18 11 auto (lemma-R (C.H1 • C.H0 • C.CZ • C.H0 • C.S0⁻¹ • C.W • C.H0 • C.CZ • C.H0 • C.H1) (minus , X⊗I))
      equals R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , I⊗Y) • R (plus , Y⊗Z) • R (plus , Z⊗Y) • R (plus , X⊗Y) • R (plus , Z⊗I) • R (plus , X⊗Y) • R (plus , Y⊗Z) • R (plus , Y⊗X) • R (plus , Z⊗Y) • R (plus , X⊗I) • R (plus , Y⊗Y) • R (plus , Z⊗I) • R (plus , Z⊗X) • R (plus , I⊗Y) • R (plus , Y⊗Z) • R (plus , Y⊗X) • H1 • H0 • CZ • H0 • S0⁻¹ • W • H0 • CZ • H0 • H1 • R (minus , X⊗Z) • S0 • H0 • CZ • H0 • S0 • S0 • H0 • S1 • S1 • S1 • W ^ 3 • R (plus , Y⊗I) • R (plus , Y⊗Z) • R (plus , Z⊗I) • R (plus , Y⊗I) • R (plus , Y⊗Z) • R (plus , X⊗Z) • R (plus , Y⊗X) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Y⊗X) • R (plus , Z⊗Y) • R (plus , Z⊗X) • CZ • H0 • H1 • CZ • H0 • S0 • S0 • H0 • H1 • S1 • S1 • H1 • W ^ 6 • ε
          by in-context 19 11 auto (lemma-R (C.H1 • C.H0 • C.CZ • C.H0 • C.S0⁻¹ • C.W • C.H0 • C.CZ • C.H0 • C.H1) (minus , X⊗Z))
      equals R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , I⊗Y) • R (plus , Y⊗Z) • R (plus , Z⊗Y) • R (plus , X⊗Y) • R (plus , Z⊗I) • R (plus , X⊗Y) • R (plus , Y⊗Z) • R (plus , Y⊗X) • R (plus , Z⊗Y) • R (plus , X⊗I) • R (plus , Y⊗Y) • R (plus , Z⊗I) • R (plus , Z⊗X) • R (plus , I⊗Y) • R (plus , Y⊗Z) • R (plus , Y⊗X) • R (minus , X⊗Z) • H1 • H0 • CZ • H0 • S0⁻¹ • W • H0 • CZ • H0 • H1 • S0 • H0 • CZ • H0 • S0 • S0 • H0 • S1 • S1 • S1 • W ^ 3 • R (plus , Y⊗I) • R (plus , Y⊗Z) • R (plus , Z⊗I) • R (plus , Y⊗I) • R (plus , Y⊗Z) • R (plus , X⊗Z) • R (plus , Y⊗X) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Y⊗X) • R (plus , Z⊗Y) • R (plus , Z⊗X) • CZ • H0 • H1 • CZ • H0 • S0 • S0 • H0 • H1 • S1 • S1 • H1 • W ^ 6 • ε
          by in-context 19 1 auto (lemma-correction X⊗Z)
      equals R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , I⊗Y) • R (plus , Y⊗Z) • R (plus , Z⊗Y) • R (plus , X⊗Y) • R (plus , Z⊗I) • R (plus , X⊗Y) • R (plus , Y⊗Z) • R (plus , Y⊗X) • R (plus , Z⊗Y) • R (plus , X⊗I) • R (plus , Y⊗Y) • R (plus , Z⊗I) • R (plus , Z⊗X) • R (plus , I⊗Y) • R (plus , Y⊗Z) • R (plus , Y⊗X) • R (plus , X⊗Z) • CZ • H0 • S0⁻¹ • W • H0 • CZ • H1 • H0 • CZ • H0 • S0⁻¹ • W • H0 • CZ • H0 • H1 • S0 • H0 • CZ • H0 • S0 • S0 • H0 • S1 • S1 • S1 • W ^ 3 • R (plus , Y⊗I) • R (plus , Y⊗Z) • R (plus , Z⊗I) • R (plus , Y⊗I) • R (plus , Y⊗Z) • R (plus , X⊗Z) • R (plus , Y⊗X) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Y⊗X) • R (plus , Z⊗Y) • R (plus , Z⊗X) • CZ • H0 • H1 • CZ • H0 • S0 • S0 • H0 • H1 • S1 • S1 • H1 • W ^ 6 • ε
          by clifford-tactic 22 21 10000 auto
      equals R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , I⊗Y) • R (plus , Y⊗Z) • R (plus , Z⊗Y) • R (plus , X⊗Y) • R (plus , Z⊗I) • R (plus , X⊗Y) • R (plus , Y⊗Z) • R (plus , Y⊗X) • R (plus , Z⊗Y) • R (plus , X⊗I) • R (plus , Y⊗Y) • R (plus , Z⊗I) • R (plus , Z⊗X) • R (plus , I⊗Y) • R (plus , Y⊗Z) • R (plus , Y⊗X) • R (plus , X⊗Z) • CZ • H0 • S1 • H1 • CZ • H0 • S0 • S1 • S1 • S1 • W ^ 3 • R (plus , Y⊗I) • R (plus , Y⊗Z) • R (plus , Z⊗I) • R (plus , Y⊗I) • R (plus , Y⊗Z) • R (plus , X⊗Z) • R (plus , Y⊗X) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Y⊗X) • R (plus , Z⊗Y) • R (plus , Z⊗X) • CZ • H0 • H1 • CZ • H0 • S0 • S0 • H0 • H1 • S1 • S1 • H1 • W ^ 6 • ε
          by in-context 14 2 auto (tactic-pauli-commute (plus , Z⊗I) (plus , Z⊗X) auto)
      equals R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , I⊗Y) • R (plus , Y⊗Z) • R (plus , Z⊗Y) • R (plus , X⊗Y) • R (plus , Z⊗I) • R (plus , X⊗Y) • R (plus , Y⊗Z) • R (plus , Y⊗X) • R (plus , Z⊗Y) • R (plus , X⊗I) • R (plus , Y⊗Y) • R (plus , Z⊗X) • R (plus , Z⊗I) • R (plus , I⊗Y) • R (plus , Y⊗Z) • R (plus , Y⊗X) • R (plus , X⊗Z) • CZ • H0 • S1 • H1 • CZ • H0 • S0 • S1 • S1 • S1 • W ^ 3 • R (plus , Y⊗I) • R (plus , Y⊗Z) • R (plus , Z⊗I) • R (plus , Y⊗I) • R (plus , Y⊗Z) • R (plus , X⊗Z) • R (plus , Y⊗X) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Y⊗X) • R (plus , Z⊗Y) • R (plus , Z⊗X) • CZ • H0 • H1 • CZ • H0 • S0 • S0 • H0 • H1 • S1 • S1 • H1 • W ^ 6 • ε
          by in-context 15 2 auto (tactic-pauli-commute (plus , Z⊗I) (plus , I⊗Y) auto)
      equals R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , I⊗Y) • R (plus , Y⊗Z) • R (plus , Z⊗Y) • R (plus , X⊗Y) • R (plus , Z⊗I) • R (plus , X⊗Y) • R (plus , Y⊗Z) • R (plus , Y⊗X) • R (plus , Z⊗Y) • R (plus , X⊗I) • R (plus , Y⊗Y) • R (plus , Z⊗X) • R (plus , I⊗Y) • R (plus , Z⊗I) • R (plus , Y⊗Z) • R (plus , Y⊗X) • R (plus , X⊗Z) • CZ • H0 • S1 • H1 • CZ • H0 • S0 • S1 • S1 • S1 • W ^ 3 • R (plus , Y⊗I) • R (plus , Y⊗Z) • R (plus , Z⊗I) • R (plus , Y⊗I) • R (plus , Y⊗Z) • R (plus , X⊗Z) • R (plus , Y⊗X) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Y⊗X) • R (plus , Z⊗Y) • R (plus , Z⊗X) • CZ • H0 • H1 • CZ • H0 • S0 • S0 • H0 • H1 • S1 • S1 • H1 • W ^ 6 • ε
          by in-context 10 2 auto (tactic-pauli-commute (plus , Y⊗X) (plus , Z⊗Y) auto)
      equals R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , I⊗Y) • R (plus , Y⊗Z) • R (plus , Z⊗Y) • R (plus , X⊗Y) • R (plus , Z⊗I) • R (plus , X⊗Y) • R (plus , Y⊗Z) • R (plus , Z⊗Y) • R (plus , Y⊗X) • R (plus , X⊗I) • R (plus , Y⊗Y) • R (plus , Z⊗X) • R (plus , I⊗Y) • R (plus , Z⊗I) • R (plus , Y⊗Z) • R (plus , Y⊗X) • R (plus , X⊗Z) • CZ • H0 • S1 • H1 • CZ • H0 • S0 • S1 • S1 • S1 • W ^ 3 • R (plus , Y⊗I) • R (plus , Y⊗Z) • R (plus , Z⊗I) • R (plus , Y⊗I) • R (plus , Y⊗Z) • R (plus , X⊗Z) • R (plus , Y⊗X) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Y⊗X) • R (plus , Z⊗Y) • R (plus , Z⊗X) • CZ • H0 • H1 • CZ • H0 • S0 • S0 • H0 • H1 • S1 • S1 • H1 • W ^ 6 • ε
          by in-context 9 2 auto (tactic-pauli-commute (plus , Y⊗Z) (plus , Z⊗Y) auto)
      equals R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , I⊗Y) • R (plus , Y⊗Z) • R (plus , Z⊗Y) • R (plus , X⊗Y) • R (plus , Z⊗I) • R (plus , X⊗Y) • R (plus , Z⊗Y) • R (plus , Y⊗Z) • R (plus , Y⊗X) • R (plus , X⊗I) • R (plus , Y⊗Y) • R (plus , Z⊗X) • R (plus , I⊗Y) • R (plus , Z⊗I) • R (plus , Y⊗Z) • R (plus , Y⊗X) • R (plus , X⊗Z) • CZ • H0 • S1 • H1 • CZ • H0 • S0 • S1 • S1 • S1 • W ^ 3 • R (plus , Y⊗I) • R (plus , Y⊗Z) • R (plus , Z⊗I) • R (plus , Y⊗I) • R (plus , Y⊗Z) • R (plus , X⊗Z) • R (plus , Y⊗X) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Y⊗X) • R (plus , Z⊗Y) • R (plus , Z⊗X) • CZ • H0 • H1 • CZ • H0 • S0 • S0 • H0 • H1 • S1 • S1 • H1 • W ^ 6 • ε
          by clifford-tactic 22 9 10000 auto
      equals R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , I⊗Y) • R (plus , Y⊗Z) • R (plus , Z⊗Y) • R (plus , X⊗Y) • R (plus , Z⊗I) • R (plus , X⊗Y) • R (plus , Z⊗Y) • R (plus , Y⊗Z) • R (plus , Y⊗X) • R (plus , X⊗I) • R (plus , Y⊗Y) • R (plus , Z⊗X) • R (plus , I⊗Y) • R (plus , Z⊗I) • R (plus , Y⊗Z) • R (plus , Y⊗X) • R (plus , X⊗Z) • CZ • H0 • S0⁻¹ • W • H0 • CZ • CZ • S0 • H0 • S1 • H1 • CZ • H0 • S0 • S0 • S0 • S1 • W ^ 6 • CZ • S0 • S0 • S0 • H0 • S1 • W ^ 5 • R (plus , Y⊗I) • R (plus , Y⊗Z) • R (plus , Z⊗I) • R (plus , Y⊗I) • R (plus , Y⊗Z) • R (plus , X⊗Z) • R (plus , Y⊗X) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Y⊗X) • R (plus , Z⊗Y) • R (plus , Z⊗X) • CZ • H0 • H1 • CZ • H0 • S0 • S0 • H0 • H1 • S1 • S1 • H1 • W ^ 6 • ε
          by in-context 19 7 auto (symm (lemma-correction X⊗Z))
      equals R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , I⊗Y) • R (plus , Y⊗Z) • R (plus , Z⊗Y) • R (plus , X⊗Y) • R (plus , Z⊗I) • R (plus , X⊗Y) • R (plus , Z⊗Y) • R (plus , Y⊗Z) • R (plus , Y⊗X) • R (plus , X⊗I) • R (plus , Y⊗Y) • R (plus , Z⊗X) • R (plus , I⊗Y) • R (plus , Z⊗I) • R (plus , Y⊗Z) • R (plus , Y⊗X) • R (minus , X⊗Z) • CZ • S0 • H0 • S1 • H1 • CZ • H0 • S0 • S0 • S0 • S1 • W ^ 6 • CZ • S0 • S0 • S0 • H0 • S1 • W ^ 5 • R (plus , Y⊗I) • R (plus , Y⊗Z) • R (plus , Z⊗I) • R (plus , Y⊗I) • R (plus , Y⊗Z) • R (plus , X⊗Z) • R (plus , Y⊗X) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Y⊗X) • R (plus , Z⊗Y) • R (plus , Z⊗X) • CZ • H0 • H1 • CZ • H0 • S0 • S0 • H0 • H1 • S1 • S1 • H1 • W ^ 6 • ε
          by in-context 19 13 auto (symm (lemma-R (C.CZ • C.S0 • C.H0 • C.S1 • C.H1 • C.CZ • C.H0 • C.S0 • C.S0 • C.S0 • C.S1 • C.W ^ 6) (minus , X⊗Z)))
      equals R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , I⊗Y) • R (plus , Y⊗Z) • R (plus , Z⊗Y) • R (plus , X⊗Y) • R (plus , Z⊗I) • R (plus , X⊗Y) • R (plus , Z⊗Y) • R (plus , Y⊗Z) • R (plus , Y⊗X) • R (plus , X⊗I) • R (plus , Y⊗Y) • R (plus , Z⊗X) • R (plus , I⊗Y) • R (plus , Z⊗I) • R (plus , Y⊗Z) • R (plus , Y⊗X) • CZ • S0 • H0 • S1 • H1 • CZ • H0 • S0 • S0 • S0 • S1 • W ^ 6 • R (minus , X⊗Z) • CZ • S0 • S0 • S0 • H0 • S1 • W ^ 5 • R (plus , Y⊗I) • R (plus , Y⊗Z) • R (plus , Z⊗I) • R (plus , Y⊗I) • R (plus , Y⊗Z) • R (plus , X⊗Z) • R (plus , Y⊗X) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Y⊗X) • R (plus , Z⊗Y) • R (plus , Z⊗X) • CZ • H0 • H1 • CZ • H0 • S0 • S0 • H0 • H1 • S1 • S1 • H1 • W ^ 6 • ε
          by in-context 18 13 auto (symm (lemma-R (C.CZ • C.S0 • C.H0 • C.S1 • C.H1 • C.CZ • C.H0 • C.S0 • C.S0 • C.S0 • C.S1 • C.W ^ 6) (minus , X⊗I)))
      equals R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , I⊗Y) • R (plus , Y⊗Z) • R (plus , Z⊗Y) • R (plus , X⊗Y) • R (plus , Z⊗I) • R (plus , X⊗Y) • R (plus , Z⊗Y) • R (plus , Y⊗Z) • R (plus , Y⊗X) • R (plus , X⊗I) • R (plus , Y⊗Y) • R (plus , Z⊗X) • R (plus , I⊗Y) • R (plus , Z⊗I) • R (plus , Y⊗Z) • CZ • S0 • H0 • S1 • H1 • CZ • H0 • S0 • S0 • S0 • S1 • W ^ 6 • R (minus , X⊗I) • R (minus , X⊗Z) • CZ • S0 • S0 • S0 • H0 • S1 • W ^ 5 • R (plus , Y⊗I) • R (plus , Y⊗Z) • R (plus , Z⊗I) • R (plus , Y⊗I) • R (plus , Y⊗Z) • R (plus , X⊗Z) • R (plus , Y⊗X) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Y⊗X) • R (plus , Z⊗Y) • R (plus , Z⊗X) • CZ • H0 • H1 • CZ • H0 • S0 • S0 • H0 • H1 • S1 • S1 • H1 • W ^ 6 • ε
          by in-context 17 13 auto (symm (lemma-R (C.CZ • C.S0 • C.H0 • C.S1 • C.H1 • C.CZ • C.H0 • C.S0 • C.S0 • C.S0 • C.S1 • C.W ^ 6) (plus , Y⊗I)))
      equals R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , I⊗Y) • R (plus , Y⊗Z) • R (plus , Z⊗Y) • R (plus , X⊗Y) • R (plus , Z⊗I) • R (plus , X⊗Y) • R (plus , Z⊗Y) • R (plus , Y⊗Z) • R (plus , Y⊗X) • R (plus , X⊗I) • R (plus , Y⊗Y) • R (plus , Z⊗X) • R (plus , I⊗Y) • R (plus , Z⊗I) • CZ • S0 • H0 • S1 • H1 • CZ • H0 • S0 • S0 • S0 • S1 • W ^ 6 • R (plus , Y⊗I) • R (minus , X⊗I) • R (minus , X⊗Z) • CZ • S0 • S0 • S0 • H0 • S1 • W ^ 5 • R (plus , Y⊗I) • R (plus , Y⊗Z) • R (plus , Z⊗I) • R (plus , Y⊗I) • R (plus , Y⊗Z) • R (plus , X⊗Z) • R (plus , Y⊗X) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Y⊗X) • R (plus , Z⊗Y) • R (plus , Z⊗X) • CZ • H0 • H1 • CZ • H0 • S0 • S0 • H0 • H1 • S1 • S1 • H1 • W ^ 6 • ε
          by clifford-tactic 17 12 10000 auto
      equals R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , I⊗Y) • R (plus , Y⊗Z) • R (plus , Z⊗Y) • R (plus , X⊗Y) • R (plus , Z⊗I) • R (plus , X⊗Y) • R (plus , Z⊗Y) • R (plus , Y⊗Z) • R (plus , Y⊗X) • R (plus , X⊗I) • R (plus , Y⊗Y) • R (plus , Z⊗X) • R (plus , I⊗Y) • R (plus , Z⊗I) • S0⁻¹ • W • CZ • H0 • S1 • H1 • CZ • H0 • S0 • S1 • S1 • S1 • W ^ 5 • R (plus , Y⊗I) • R (minus , X⊗I) • R (minus , X⊗Z) • CZ • S0 • S0 • S0 • H0 • S1 • W ^ 5 • R (plus , Y⊗I) • R (plus , Y⊗Z) • R (plus , Z⊗I) • R (plus , Y⊗I) • R (plus , Y⊗Z) • R (plus , X⊗Z) • R (plus , Y⊗X) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Y⊗X) • R (plus , Z⊗Y) • R (plus , Z⊗X) • CZ • H0 • H1 • CZ • H0 • S0 • S0 • H0 • H1 • S1 • S1 • H1 • W ^ 6 • ε
          by in-context 16 3 auto (symm (lemma-correction Z⊗I))
      equals R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , I⊗Y) • R (plus , Y⊗Z) • R (plus , Z⊗Y) • R (plus , X⊗Y) • R (plus , Z⊗I) • R (plus , X⊗Y) • R (plus , Z⊗Y) • R (plus , Y⊗Z) • R (plus , Y⊗X) • R (plus , X⊗I) • R (plus , Y⊗Y) • R (plus , Z⊗X) • R (plus , I⊗Y) • R (minus , Z⊗I) • CZ • H0 • S1 • H1 • CZ • H0 • S0 • S1 • S1 • S1 • W ^ 5 • R (plus , Y⊗I) • R (minus , X⊗I) • R (minus , X⊗Z) • CZ • S0 • S0 • S0 • H0 • S1 • W ^ 5 • R (plus , Y⊗I) • R (plus , Y⊗Z) • R (plus , Z⊗I) • R (plus , Y⊗I) • R (plus , Y⊗Z) • R (plus , X⊗Z) • R (plus , Y⊗X) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Y⊗X) • R (plus , Z⊗Y) • R (plus , Z⊗X) • CZ • H0 • H1 • CZ • H0 • S0 • S0 • H0 • H1 • S1 • S1 • H1 • W ^ 6 • ε
          by in-context 16 12 auto (symm (lemma-R (C.CZ • C.H0 • C.S1 • C.H1 • C.CZ • C.H0 • C.S0 • C.S1 • C.S1 • C.S1 • C.W ^ 5) (minus , Z⊗Z)))
      equals R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , I⊗Y) • R (plus , Y⊗Z) • R (plus , Z⊗Y) • R (plus , X⊗Y) • R (plus , Z⊗I) • R (plus , X⊗Y) • R (plus , Z⊗Y) • R (plus , Y⊗Z) • R (plus , Y⊗X) • R (plus , X⊗I) • R (plus , Y⊗Y) • R (plus , Z⊗X) • R (plus , I⊗Y) • CZ • H0 • S1 • H1 • CZ • H0 • S0 • S1 • S1 • S1 • W ^ 5 • R (minus , Z⊗Z) • R (plus , Y⊗I) • R (minus , X⊗I) • R (minus , X⊗Z) • CZ • S0 • S0 • S0 • H0 • S1 • W ^ 5 • R (plus , Y⊗I) • R (plus , Y⊗Z) • R (plus , Z⊗I) • R (plus , Y⊗I) • R (plus , Y⊗Z) • R (plus , X⊗Z) • R (plus , Y⊗X) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Y⊗X) • R (plus , Z⊗Y) • R (plus , Z⊗X) • CZ • H0 • H1 • CZ • H0 • S0 • S0 • H0 • H1 • S1 • S1 • H1 • W ^ 6 • ε
          by clifford-tactic 16 11 10000 auto
      equals R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , I⊗Y) • R (plus , Y⊗Z) • R (plus , Z⊗Y) • R (plus , X⊗Y) • R (plus , Z⊗I) • R (plus , X⊗Y) • R (plus , Z⊗Y) • R (plus , Y⊗Z) • R (plus , Y⊗X) • R (plus , X⊗I) • R (plus , Y⊗Y) • R (plus , Z⊗X) • R (plus , I⊗Y) • S1 • H1 • Swap • S0⁻¹ • W • Swap • H1 • S1⁻¹ • CZ • H0 • S1 • H1 • CZ • H0 • S0 • S0 • S1 • S1 • S1 • W ^ 4 • R (minus , Z⊗Z) • R (plus , Y⊗I) • R (minus , X⊗I) • R (minus , X⊗Z) • CZ • S0 • S0 • S0 • H0 • S1 • W ^ 5 • R (plus , Y⊗I) • R (plus , Y⊗Z) • R (plus , Z⊗I) • R (plus , Y⊗I) • R (plus , Y⊗Z) • R (plus , X⊗Z) • R (plus , Y⊗X) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Y⊗X) • R (plus , Z⊗Y) • R (plus , Z⊗X) • CZ • H0 • H1 • CZ • H0 • S0 • S0 • H0 • H1 • S1 • S1 • H1 • W ^ 6 • ε
          by in-context 15 9 auto (symm (lemma-correction I⊗Y))
      equals R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , I⊗Y) • R (plus , Y⊗Z) • R (plus , Z⊗Y) • R (plus , X⊗Y) • R (plus , Z⊗I) • R (plus , X⊗Y) • R (plus , Z⊗Y) • R (plus , Y⊗Z) • R (plus , Y⊗X) • R (plus , X⊗I) • R (plus , Y⊗Y) • R (plus , Z⊗X) • R (minus , I⊗Y) • CZ • H0 • S1 • H1 • CZ • H0 • S0 • S0 • S1 • S1 • S1 • W ^ 4 • R (minus , Z⊗Z) • R (plus , Y⊗I) • R (minus , X⊗I) • R (minus , X⊗Z) • CZ • S0 • S0 • S0 • H0 • S1 • W ^ 5 • R (plus , Y⊗I) • R (plus , Y⊗Z) • R (plus , Z⊗I) • R (plus , Y⊗I) • R (plus , Y⊗Z) • R (plus , X⊗Z) • R (plus , Y⊗X) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Y⊗X) • R (plus , Z⊗Y) • R (plus , Z⊗X) • CZ • H0 • H1 • CZ • H0 • S0 • S0 • H0 • H1 • S1 • S1 • H1 • W ^ 6 • ε
          by in-context 15 13 auto (symm (lemma-R (C.CZ • C.H0 • C.S1 • C.H1 • C.CZ • C.H0 • C.S0 • C.S0 • C.S1 • C.S1 • C.S1 • C.W ^ 4) (minus , Z⊗I)))
      equals R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , I⊗Y) • R (plus , Y⊗Z) • R (plus , Z⊗Y) • R (plus , X⊗Y) • R (plus , Z⊗I) • R (plus , X⊗Y) • R (plus , Z⊗Y) • R (plus , Y⊗Z) • R (plus , Y⊗X) • R (plus , X⊗I) • R (plus , Y⊗Y) • R (plus , Z⊗X) • CZ • H0 • S1 • H1 • CZ • H0 • S0 • S0 • S1 • S1 • S1 • W ^ 4 • R (minus , Z⊗I) • R (minus , Z⊗Z) • R (plus , Y⊗I) • R (minus , X⊗I) • R (minus , X⊗Z) • CZ • S0 • S0 • S0 • H0 • S1 • W ^ 5 • R (plus , Y⊗I) • R (plus , Y⊗Z) • R (plus , Z⊗I) • R (plus , Y⊗I) • R (plus , Y⊗Z) • R (plus , X⊗Z) • R (plus , Y⊗X) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Y⊗X) • R (plus , Z⊗Y) • R (plus , Z⊗X) • CZ • H0 • H1 • CZ • H0 • S0 • S0 • H0 • H1 • S1 • S1 • H1 • W ^ 6 • ε
          by clifford-tactic 15 7 10000 auto
      equals R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , I⊗Y) • R (plus , Y⊗Z) • R (plus , Z⊗Y) • R (plus , X⊗Y) • R (plus , Z⊗I) • R (plus , X⊗Y) • R (plus , Z⊗Y) • R (plus , Y⊗Z) • R (plus , Y⊗X) • R (plus , X⊗I) • R (plus , Y⊗Y) • R (plus , Z⊗X) • H1 • H0 • CZ • H0 • S0⁻¹ • W • H0 • CZ • H0 • H1 • S0 • H0 • CZ • H0 • S0 • S1 • S1 • S1 • W ^ 4 • R (minus , Z⊗I) • R (minus , Z⊗Z) • R (plus , Y⊗I) • R (minus , X⊗I) • R (minus , X⊗Z) • CZ • S0 • S0 • S0 • H0 • S1 • W ^ 5 • R (plus , Y⊗I) • R (plus , Y⊗Z) • R (plus , Z⊗I) • R (plus , Y⊗I) • R (plus , Y⊗Z) • R (plus , X⊗Z) • R (plus , Y⊗X) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Y⊗X) • R (plus , Z⊗Y) • R (plus , Z⊗X) • CZ • H0 • H1 • CZ • H0 • S0 • S0 • H0 • H1 • S1 • S1 • H1 • W ^ 6 • ε
          by in-context 14 11 auto (symm (lemma-correction Z⊗X))
      equals R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , I⊗Y) • R (plus , Y⊗Z) • R (plus , Z⊗Y) • R (plus , X⊗Y) • R (plus , Z⊗I) • R (plus , X⊗Y) • R (plus , Z⊗Y) • R (plus , Y⊗Z) • R (plus , Y⊗X) • R (plus , X⊗I) • R (plus , Y⊗Y) • R (minus , Z⊗X) • S0 • H0 • CZ • H0 • S0 • S1 • S1 • S1 • W ^ 4 • R (minus , Z⊗I) • R (minus , Z⊗Z) • R (plus , Y⊗I) • R (minus , X⊗I) • R (minus , X⊗Z) • CZ • S0 • S0 • S0 • H0 • S1 • W ^ 5 • R (plus , Y⊗I) • R (plus , Y⊗Z) • R (plus , Z⊗I) • R (plus , Y⊗I) • R (plus , Y⊗Z) • R (plus , X⊗Z) • R (plus , Y⊗X) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Y⊗X) • R (plus , Z⊗Y) • R (plus , Z⊗X) • CZ • H0 • H1 • CZ • H0 • S0 • S0 • H0 • H1 • S1 • S1 • H1 • W ^ 6 • ε
          by in-context 14 10 auto (symm (lemma-R (C.S0 • C.H0 • C.CZ • C.H0 • C.S0 • C.S1 • C.S1 • C.S1 • C.W ^ 4) (minus , X⊗X)))
      equals R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , I⊗Y) • R (plus , Y⊗Z) • R (plus , Z⊗Y) • R (plus , X⊗Y) • R (plus , Z⊗I) • R (plus , X⊗Y) • R (plus , Z⊗Y) • R (plus , Y⊗Z) • R (plus , Y⊗X) • R (plus , X⊗I) • R (plus , Y⊗Y) • S0 • H0 • CZ • H0 • S0 • S1 • S1 • S1 • W ^ 4 • R (minus , X⊗X) • R (minus , Z⊗I) • R (minus , Z⊗Z) • R (plus , Y⊗I) • R (minus , X⊗I) • R (minus , X⊗Z) • CZ • S0 • S0 • S0 • H0 • S1 • W ^ 5 • R (plus , Y⊗I) • R (plus , Y⊗Z) • R (plus , Z⊗I) • R (plus , Y⊗I) • R (plus , Y⊗Z) • R (plus , X⊗Z) • R (plus , Y⊗X) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Y⊗X) • R (plus , Z⊗Y) • R (plus , Z⊗X) • CZ • H0 • H1 • CZ • H0 • S0 • S0 • H0 • H1 • S1 • S1 • H1 • W ^ 6 • ε
          by in-context 13 10 auto (symm (lemma-R (C.S0 • C.H0 • C.CZ • C.H0 • C.S0 • C.S1 • C.S1 • C.S1 • C.W ^ 4) (minus , I⊗X)))
      equals R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , I⊗Y) • R (plus , Y⊗Z) • R (plus , Z⊗Y) • R (plus , X⊗Y) • R (plus , Z⊗I) • R (plus , X⊗Y) • R (plus , Z⊗Y) • R (plus , Y⊗Z) • R (plus , Y⊗X) • R (plus , X⊗I) • S0 • H0 • CZ • H0 • S0 • S1 • S1 • S1 • W ^ 4 • R (minus , I⊗X) • R (minus , X⊗X) • R (minus , Z⊗I) • R (minus , Z⊗Z) • R (plus , Y⊗I) • R (minus , X⊗I) • R (minus , X⊗Z) • CZ • S0 • S0 • S0 • H0 • S1 • W ^ 5 • R (plus , Y⊗I) • R (plus , Y⊗Z) • R (plus , Z⊗I) • R (plus , Y⊗I) • R (plus , Y⊗Z) • R (plus , X⊗Z) • R (plus , Y⊗X) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Y⊗X) • R (plus , Z⊗Y) • R (plus , Z⊗X) • CZ • H0 • H1 • CZ • H0 • S0 • S0 • H0 • H1 • S1 • S1 • H1 • W ^ 6 • ε
          by in-context 12 10 auto (symm (lemma-R (C.S0 • C.H0 • C.CZ • C.H0 • C.S0 • C.S1 • C.S1 • C.S1 • C.W ^ 4) (minus , X⊗Z)))
      equals R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , I⊗Y) • R (plus , Y⊗Z) • R (plus , Z⊗Y) • R (plus , X⊗Y) • R (plus , Z⊗I) • R (plus , X⊗Y) • R (plus , Z⊗Y) • R (plus , Y⊗Z) • R (plus , Y⊗X) • S0 • H0 • CZ • H0 • S0 • S1 • S1 • S1 • W ^ 4 • R (minus , X⊗Z) • R (minus , I⊗X) • R (minus , X⊗X) • R (minus , Z⊗I) • R (minus , Z⊗Z) • R (plus , Y⊗I) • R (minus , X⊗I) • R (minus , X⊗Z) • CZ • S0 • S0 • S0 • H0 • S1 • W ^ 5 • R (plus , Y⊗I) • R (plus , Y⊗Z) • R (plus , Z⊗I) • R (plus , Y⊗I) • R (plus , Y⊗Z) • R (plus , X⊗Z) • R (plus , Y⊗X) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Y⊗X) • R (plus , Z⊗Y) • R (plus , Z⊗X) • CZ • H0 • H1 • CZ • H0 • S0 • S0 • H0 • H1 • S1 • S1 • H1 • W ^ 6 • ε
          by clifford-tactic 12 6 10000 auto
      equals R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , I⊗Y) • R (plus , Y⊗Z) • R (plus , Z⊗Y) • R (plus , X⊗Y) • R (plus , Z⊗I) • R (plus , X⊗Y) • R (plus , Z⊗Y) • R (plus , Y⊗Z) • R (plus , Y⊗X) • H1 • S0 • CZ • H0 • S0⁻¹ • W • H0 • CZ • S0⁻¹ • H1 • S0 • H0 • CZ • H0 • S0 • S1 • S1 • S1 • H1 • S1 • S1 • W ^ 4 • R (minus , X⊗Z) • R (minus , I⊗X) • R (minus , X⊗X) • R (minus , Z⊗I) • R (minus , Z⊗Z) • R (plus , Y⊗I) • R (minus , X⊗I) • R (minus , X⊗Z) • CZ • S0 • S0 • S0 • H0 • S1 • W ^ 5 • R (plus , Y⊗I) • R (plus , Y⊗Z) • R (plus , Z⊗I) • R (plus , Y⊗I) • R (plus , Y⊗Z) • R (plus , X⊗Z) • R (plus , Y⊗X) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Y⊗X) • R (plus , Z⊗Y) • R (plus , Z⊗X) • CZ • H0 • H1 • CZ • H0 • S0 • S0 • H0 • H1 • S1 • S1 • H1 • W ^ 6 • ε
          by in-context 11 11 auto (symm (lemma-correction Y⊗X))
      equals R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , I⊗Y) • R (plus , Y⊗Z) • R (plus , Z⊗Y) • R (plus , X⊗Y) • R (plus , Z⊗I) • R (plus , X⊗Y) • R (plus , Z⊗Y) • R (plus , Y⊗Z) • R (minus , Y⊗X) • S0 • H0 • CZ • H0 • S0 • S1 • S1 • S1 • H1 • S1 • S1 • W ^ 4 • R (minus , X⊗Z) • R (minus , I⊗X) • R (minus , X⊗X) • R (minus , Z⊗I) • R (minus , Z⊗Z) • R (plus , Y⊗I) • R (minus , X⊗I) • R (minus , X⊗Z) • CZ • S0 • S0 • S0 • H0 • S1 • W ^ 5 • R (plus , Y⊗I) • R (plus , Y⊗Z) • R (plus , Z⊗I) • R (plus , Y⊗I) • R (plus , Y⊗Z) • R (plus , X⊗Z) • R (plus , Y⊗X) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Y⊗X) • R (plus , Z⊗Y) • R (plus , Z⊗X) • CZ • H0 • H1 • CZ • H0 • S0 • S0 • H0 • H1 • S1 • S1 • H1 • W ^ 6 • ε
          by in-context 11 13 auto (symm (lemma-R (C.S0 • C.H0 • C.CZ • C.H0 • C.S0 • C.S1 • C.S1 • C.S1 • C.H1 • C.S1 • C.S1 • C.W ^ 4) (minus , I⊗Y)))
      equals R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , I⊗Y) • R (plus , Y⊗Z) • R (plus , Z⊗Y) • R (plus , X⊗Y) • R (plus , Z⊗I) • R (plus , X⊗Y) • R (plus , Z⊗Y) • R (plus , Y⊗Z) • S0 • H0 • CZ • H0 • S0 • S1 • S1 • S1 • H1 • S1 • S1 • W ^ 4 • R (minus , I⊗Y) • R (minus , X⊗Z) • R (minus , I⊗X) • R (minus , X⊗X) • R (minus , Z⊗I) • R (minus , Z⊗Z) • R (plus , Y⊗I) • R (minus , X⊗I) • R (minus , X⊗Z) • CZ • S0 • S0 • S0 • H0 • S1 • W ^ 5 • R (plus , Y⊗I) • R (plus , Y⊗Z) • R (plus , Z⊗I) • R (plus , Y⊗I) • R (plus , Y⊗Z) • R (plus , X⊗Z) • R (plus , Y⊗X) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Y⊗X) • R (plus , Z⊗Y) • R (plus , Z⊗X) • CZ • H0 • H1 • CZ • H0 • S0 • S0 • H0 • H1 • S1 • S1 • H1 • W ^ 6 • ε
          by clifford-tactic 12 7 10000 auto
      equals R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , I⊗Y) • R (plus , Y⊗Z) • R (plus , Z⊗Y) • R (plus , X⊗Y) • R (plus , Z⊗I) • R (plus , X⊗Y) • R (plus , Z⊗Y) • R (plus , Y⊗Z) • S0 • CZ • H0 • S0⁻¹ • W • H0 • CZ • S0⁻¹ • H0 • H1 • S1 • S1 • W ^ 4 • R (minus , I⊗Y) • R (minus , X⊗Z) • R (minus , I⊗X) • R (minus , X⊗X) • R (minus , Z⊗I) • R (minus , Z⊗Z) • R (plus , Y⊗I) • R (minus , X⊗I) • R (minus , X⊗Z) • CZ • S0 • S0 • S0 • H0 • S1 • W ^ 5 • R (plus , Y⊗I) • R (plus , Y⊗Z) • R (plus , Z⊗I) • R (plus , Y⊗I) • R (plus , Y⊗Z) • R (plus , X⊗Z) • R (plus , Y⊗X) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Y⊗X) • R (plus , Z⊗Y) • R (plus , Z⊗X) • CZ • H0 • H1 • CZ • H0 • S0 • S0 • H0 • H1 • S1 • S1 • H1 • W ^ 6 • ε
          by in-context 10 9 auto (symm (lemma-correction Y⊗Z))
      equals R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , I⊗Y) • R (plus , Y⊗Z) • R (plus , Z⊗Y) • R (plus , X⊗Y) • R (plus , Z⊗I) • R (plus , X⊗Y) • R (plus , Z⊗Y) • R (minus , Y⊗Z) • H0 • H1 • S1 • S1 • W ^ 4 • R (minus , I⊗Y) • R (minus , X⊗Z) • R (minus , I⊗X) • R (minus , X⊗X) • R (minus , Z⊗I) • R (minus , Z⊗Z) • R (plus , Y⊗I) • R (minus , X⊗I) • R (minus , X⊗Z) • CZ • S0 • S0 • S0 • H0 • S1 • W ^ 5 • R (plus , Y⊗I) • R (plus , Y⊗Z) • R (plus , Z⊗I) • R (plus , Y⊗I) • R (plus , Y⊗Z) • R (plus , X⊗Z) • R (plus , Y⊗X) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Y⊗X) • R (plus , Z⊗Y) • R (plus , Z⊗X) • CZ • H0 • H1 • CZ • H0 • S0 • S0 • H0 • H1 • S1 • S1 • H1 • W ^ 6 • ε
          by in-context 10 6 auto (symm (lemma-R (C.H0 • C.H1 • C.S1 • C.S1 • C.W ^ 4) (minus , Y⊗X)))
      equals R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , I⊗Y) • R (plus , Y⊗Z) • R (plus , Z⊗Y) • R (plus , X⊗Y) • R (plus , Z⊗I) • R (plus , X⊗Y) • R (plus , Z⊗Y) • H0 • H1 • S1 • S1 • W ^ 4 • R (minus , Y⊗X) • R (minus , I⊗Y) • R (minus , X⊗Z) • R (minus , I⊗X) • R (minus , X⊗X) • R (minus , Z⊗I) • R (minus , Z⊗Z) • R (plus , Y⊗I) • R (minus , X⊗I) • R (minus , X⊗Z) • CZ • S0 • S0 • S0 • H0 • S1 • W ^ 5 • R (plus , Y⊗I) • R (plus , Y⊗Z) • R (plus , Z⊗I) • R (plus , Y⊗I) • R (plus , Y⊗Z) • R (plus , X⊗Z) • R (plus , Y⊗X) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Y⊗X) • R (plus , Z⊗Y) • R (plus , Z⊗X) • CZ • H0 • H1 • CZ • H0 • S0 • S0 • H0 • H1 • S1 • S1 • H1 • W ^ 6 • ε
          by clifford-tactic 10 5 10000 auto
      equals R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , I⊗Y) • R (plus , Y⊗Z) • R (plus , Z⊗Y) • R (plus , X⊗Y) • R (plus , Z⊗I) • R (plus , X⊗Y) • R (plus , Z⊗Y) • S1 • H1 • H0 • CZ • H0 • S0⁻¹ • W • H0 • CZ • H0 • H1 • S1⁻¹ • S1 • H1 • CZ • S0 • H0 • S1 • S1 • H1 • S1 • S1 • S1 • W ^ 2 • R (minus , Y⊗X) • R (minus , I⊗Y) • R (minus , X⊗Z) • R (minus , I⊗X) • R (minus , X⊗X) • R (minus , Z⊗I) • R (minus , Z⊗Z) • R (plus , Y⊗I) • R (minus , X⊗I) • R (minus , X⊗Z) • CZ • S0 • S0 • S0 • H0 • S1 • W ^ 5 • R (plus , Y⊗I) • R (plus , Y⊗Z) • R (plus , Z⊗I) • R (plus , Y⊗I) • R (plus , Y⊗Z) • R (plus , X⊗Z) • R (plus , Y⊗X) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Y⊗X) • R (plus , Z⊗Y) • R (plus , Z⊗X) • CZ • H0 • H1 • CZ • H0 • S0 • S0 • H0 • H1 • S1 • S1 • H1 • W ^ 6 • ε
          by in-context 9 13 auto (symm (lemma-correction Z⊗Y))
      equals R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , I⊗Y) • R (plus , Y⊗Z) • R (plus , Z⊗Y) • R (plus , X⊗Y) • R (plus , Z⊗I) • R (plus , X⊗Y) • R (minus , Z⊗Y) • S1 • H1 • CZ • S0 • H0 • S1 • S1 • H1 • S1 • S1 • S1 • W ^ 2 • R (minus , Y⊗X) • R (minus , I⊗Y) • R (minus , X⊗Z) • R (minus , I⊗X) • R (minus , X⊗X) • R (minus , Z⊗I) • R (minus , Z⊗Z) • R (plus , Y⊗I) • R (minus , X⊗I) • R (minus , X⊗Z) • CZ • S0 • S0 • S0 • H0 • S1 • W ^ 5 • R (plus , Y⊗I) • R (plus , Y⊗Z) • R (plus , Z⊗I) • R (plus , Y⊗I) • R (plus , Y⊗Z) • R (plus , X⊗Z) • R (plus , Y⊗X) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Y⊗X) • R (plus , Z⊗Y) • R (plus , Z⊗X) • CZ • H0 • H1 • CZ • H0 • S0 • S0 • H0 • H1 • S1 • S1 • H1 • W ^ 6 • ε
          by in-context 9 13 auto (symm (lemma-R (C.S1 • C.H1 • C.CZ • C.S0 • C.H0 • C.S1 • C.S1 • C.H1 • C.S1 • C.S1 • C.S1 • C.W ^ 2) (minus , X⊗Y)))
      equals R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , I⊗Y) • R (plus , Y⊗Z) • R (plus , Z⊗Y) • R (plus , X⊗Y) • R (plus , Z⊗I) • R (plus , X⊗Y) • S1 • H1 • CZ • S0 • H0 • S1 • S1 • H1 • S1 • S1 • S1 • W ^ 2 • R (minus , X⊗Y) • R (minus , Y⊗X) • R (minus , I⊗Y) • R (minus , X⊗Z) • R (minus , I⊗X) • R (minus , X⊗X) • R (minus , Z⊗I) • R (minus , Z⊗Z) • R (plus , Y⊗I) • R (minus , X⊗I) • R (minus , X⊗Z) • CZ • S0 • S0 • S0 • H0 • S1 • W ^ 5 • R (plus , Y⊗I) • R (plus , Y⊗Z) • R (plus , Z⊗I) • R (plus , Y⊗I) • R (plus , Y⊗Z) • R (plus , X⊗Z) • R (plus , Y⊗X) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Y⊗X) • R (plus , Z⊗Y) • R (plus , Z⊗X) • CZ • H0 • H1 • CZ • H0 • S0 • S0 • H0 • H1 • S1 • S1 • H1 • W ^ 6 • ε
          by clifford-tactic 12 2 10000 auto
      equals R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , I⊗Y) • R (plus , Y⊗Z) • R (plus , Z⊗Y) • R (plus , X⊗Y) • R (plus , Z⊗I) • R (plus , X⊗Y) • S1 • H1 • CZ • H0 • S0⁻¹ • W • H0 • CZ • H1 • S1⁻¹ • S1 • H1 • CZ • S0 • S0 • S0 • S1 • S1 • H1 • S1 • S1 • S1 • W ^ 2 • R (minus , X⊗Y) • R (minus , Y⊗X) • R (minus , I⊗Y) • R (minus , X⊗Z) • R (minus , I⊗X) • R (minus , X⊗X) • R (minus , Z⊗I) • R (minus , Z⊗Z) • R (plus , Y⊗I) • R (minus , X⊗I) • R (minus , X⊗Z) • CZ • S0 • S0 • S0 • H0 • S1 • W ^ 5 • R (plus , Y⊗I) • R (plus , Y⊗Z) • R (plus , Z⊗I) • R (plus , Y⊗I) • R (plus , Y⊗Z) • R (plus , X⊗Z) • R (plus , Y⊗X) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Y⊗X) • R (plus , Z⊗Y) • R (plus , Z⊗X) • CZ • H0 • H1 • CZ • H0 • S0 • S0 • H0 • H1 • S1 • S1 • H1 • W ^ 6 • ε
          by in-context 8 11 auto (symm (lemma-correction X⊗Y))
      equals R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , I⊗Y) • R (plus , Y⊗Z) • R (plus , Z⊗Y) • R (plus , X⊗Y) • R (plus , Z⊗I) • R (minus , X⊗Y) • S1 • H1 • CZ • S0 • S0 • S0 • S1 • S1 • H1 • S1 • S1 • S1 • W ^ 2 • R (minus , X⊗Y) • R (minus , Y⊗X) • R (minus , I⊗Y) • R (minus , X⊗Z) • R (minus , I⊗X) • R (minus , X⊗X) • R (minus , Z⊗I) • R (minus , Z⊗Z) • R (plus , Y⊗I) • R (minus , X⊗I) • R (minus , X⊗Z) • CZ • S0 • S0 • S0 • H0 • S1 • W ^ 5 • R (plus , Y⊗I) • R (plus , Y⊗Z) • R (plus , Z⊗I) • R (plus , Y⊗I) • R (plus , Y⊗Z) • R (plus , X⊗Z) • R (plus , Y⊗X) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Y⊗X) • R (plus , Z⊗Y) • R (plus , Z⊗X) • CZ • H0 • H1 • CZ • H0 • S0 • S0 • H0 • H1 • S1 • S1 • H1 • W ^ 6 • ε
          by in-context 8 14 auto (symm (lemma-R (C.S1 • C.H1 • C.CZ • C.S0 • C.S0 • C.S0 • C.S1 • C.S1 • C.H1 • C.S1 • C.S1 • C.S1 • C.W ^ 2) (minus , Y⊗I)))
      equals R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , I⊗Y) • R (plus , Y⊗Z) • R (plus , Z⊗Y) • R (plus , X⊗Y) • R (plus , Z⊗I) • S1 • H1 • CZ • S0 • S0 • S0 • S1 • S1 • H1 • S1 • S1 • S1 • W ^ 2 • R (minus , Y⊗I) • R (minus , X⊗Y) • R (minus , Y⊗X) • R (minus , I⊗Y) • R (minus , X⊗Z) • R (minus , I⊗X) • R (minus , X⊗X) • R (minus , Z⊗I) • R (minus , Z⊗Z) • R (plus , Y⊗I) • R (minus , X⊗I) • R (minus , X⊗Z) • CZ • S0 • S0 • S0 • H0 • S1 • W ^ 5 • R (plus , Y⊗I) • R (plus , Y⊗Z) • R (plus , Z⊗I) • R (plus , Y⊗I) • R (plus , Y⊗Z) • R (plus , X⊗Z) • R (plus , Y⊗X) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Y⊗X) • R (plus , Z⊗Y) • R (plus , Z⊗X) • CZ • H0 • H1 • CZ • H0 • S0 • S0 • H0 • H1 • S1 • S1 • H1 • W ^ 6 • ε
          by in-context 7 14 auto (symm (lemma-R (C.S1 • C.H1 • C.CZ • C.S0 • C.S0 • C.S0 • C.S1 • C.S1 • C.H1 • C.S1 • C.S1 • C.S1 • C.W ^ 2) (plus , Z⊗I)))
      equals R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , I⊗Y) • R (plus , Y⊗Z) • R (plus , Z⊗Y) • R (plus , X⊗Y) • S1 • H1 • CZ • S0 • S0 • S0 • S1 • S1 • H1 • S1 • S1 • S1 • W ^ 2 • R (plus , Z⊗I) • R (minus , Y⊗I) • R (minus , X⊗Y) • R (minus , Y⊗X) • R (minus , I⊗Y) • R (minus , X⊗Z) • R (minus , I⊗X) • R (minus , X⊗X) • R (minus , Z⊗I) • R (minus , Z⊗Z) • R (plus , Y⊗I) • R (minus , X⊗I) • R (minus , X⊗Z) • CZ • S0 • S0 • S0 • H0 • S1 • W ^ 5 • R (plus , Y⊗I) • R (plus , Y⊗Z) • R (plus , Z⊗I) • R (plus , Y⊗I) • R (plus , Y⊗Z) • R (plus , X⊗Z) • R (plus , Y⊗X) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Y⊗X) • R (plus , Z⊗Y) • R (plus , Z⊗X) • CZ • H0 • H1 • CZ • H0 • S0 • S0 • H0 • H1 • S1 • S1 • H1 • W ^ 6 • ε
          by in-context 6 14 auto (symm (lemma-R (C.S1 • C.H1 • C.CZ • C.S0 • C.S0 • C.S0 • C.S1 • C.S1 • C.H1 • C.S1 • C.S1 • C.S1 • C.W ^ 2) (plus , Y⊗I)))
      equals R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , I⊗Y) • R (plus , Y⊗Z) • R (plus , Z⊗Y) • S1 • H1 • CZ • S0 • S0 • S0 • S1 • S1 • H1 • S1 • S1 • S1 • W ^ 2 • R (plus , Y⊗I) • R (plus , Z⊗I) • R (minus , Y⊗I) • R (minus , X⊗Y) • R (minus , Y⊗X) • R (minus , I⊗Y) • R (minus , X⊗Z) • R (minus , I⊗X) • R (minus , X⊗X) • R (minus , Z⊗I) • R (minus , Z⊗Z) • R (plus , Y⊗I) • R (minus , X⊗I) • R (minus , X⊗Z) • CZ • S0 • S0 • S0 • H0 • S1 • W ^ 5 • R (plus , Y⊗I) • R (plus , Y⊗Z) • R (plus , Z⊗I) • R (plus , Y⊗I) • R (plus , Y⊗Z) • R (plus , X⊗Z) • R (plus , Y⊗X) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Y⊗X) • R (plus , Z⊗Y) • R (plus , Z⊗X) • CZ • H0 • H1 • CZ • H0 • S0 • S0 • H0 • H1 • S1 • S1 • H1 • W ^ 6 • ε
          by clifford-tactic 8 11 10000 auto
      equals R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , I⊗Y) • R (plus , Y⊗Z) • R (plus , Z⊗Y) • S1 • H1 • H0 • CZ • H0 • S0⁻¹ • W • H0 • CZ • H0 • H1 • S1⁻¹ • S1 • S1 • H1 • R (plus , Y⊗I) • R (plus , Z⊗I) • R (minus , Y⊗I) • R (minus , X⊗Y) • R (minus , Y⊗X) • R (minus , I⊗Y) • R (minus , X⊗Z) • R (minus , I⊗X) • R (minus , X⊗X) • R (minus , Z⊗I) • R (minus , Z⊗Z) • R (plus , Y⊗I) • R (minus , X⊗I) • R (minus , X⊗Z) • CZ • S0 • S0 • S0 • H0 • S1 • W ^ 5 • R (plus , Y⊗I) • R (plus , Y⊗Z) • R (plus , Z⊗I) • R (plus , Y⊗I) • R (plus , Y⊗Z) • R (plus , X⊗Z) • R (plus , Y⊗X) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Y⊗X) • R (plus , Z⊗Y) • R (plus , Z⊗X) • CZ • H0 • H1 • CZ • H0 • S0 • S0 • H0 • H1 • S1 • S1 • H1 • W ^ 6 • ε
          by in-context 5 13 auto (symm (lemma-correction Z⊗Y))
      equals R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , I⊗Y) • R (plus , Y⊗Z) • R (minus , Z⊗Y) • S1 • S1 • H1 • R (plus , Y⊗I) • R (plus , Z⊗I) • R (minus , Y⊗I) • R (minus , X⊗Y) • R (minus , Y⊗X) • R (minus , I⊗Y) • R (minus , X⊗Z) • R (minus , I⊗X) • R (minus , X⊗X) • R (minus , Z⊗I) • R (minus , Z⊗Z) • R (plus , Y⊗I) • R (minus , X⊗I) • R (minus , X⊗Z) • CZ • S0 • S0 • S0 • H0 • S1 • W ^ 5 • R (plus , Y⊗I) • R (plus , Y⊗Z) • R (plus , Z⊗I) • R (plus , Y⊗I) • R (plus , Y⊗Z) • R (plus , X⊗Z) • R (plus , Y⊗X) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Y⊗X) • R (plus , Z⊗Y) • R (plus , Z⊗X) • CZ • H0 • H1 • CZ • H0 • S0 • S0 • H0 • H1 • S1 • S1 • H1 • W ^ 6 • ε
          by in-context 5 4 auto (symm (lemma-R (C.S1 • C.S1 • C.H1) (minus , Z⊗Y)))
      equals R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , I⊗Y) • R (plus , Y⊗Z) • S1 • S1 • H1 • R (minus , Z⊗Y) • R (plus , Y⊗I) • R (plus , Z⊗I) • R (minus , Y⊗I) • R (minus , X⊗Y) • R (minus , Y⊗X) • R (minus , I⊗Y) • R (minus , X⊗Z) • R (minus , I⊗X) • R (minus , X⊗X) • R (minus , Z⊗I) • R (minus , Z⊗Z) • R (plus , Y⊗I) • R (minus , X⊗I) • R (minus , X⊗Z) • CZ • S0 • S0 • S0 • H0 • S1 • W ^ 5 • R (plus , Y⊗I) • R (plus , Y⊗Z) • R (plus , Z⊗I) • R (plus , Y⊗I) • R (plus , Y⊗Z) • R (plus , X⊗Z) • R (plus , Y⊗X) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Y⊗X) • R (plus , Z⊗Y) • R (plus , Z⊗X) • CZ • H0 • H1 • CZ • H0 • S0 • S0 • H0 • H1 • S1 • S1 • H1 • W ^ 6 • ε
          by in-context 4 4 auto (symm (lemma-R (C.S1 • C.S1 • C.H1) (plus , Y⊗X)))
      equals R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , I⊗Y) • S1 • S1 • H1 • R (plus , Y⊗X) • R (minus , Z⊗Y) • R (plus , Y⊗I) • R (plus , Z⊗I) • R (minus , Y⊗I) • R (minus , X⊗Y) • R (minus , Y⊗X) • R (minus , I⊗Y) • R (minus , X⊗Z) • R (minus , I⊗X) • R (minus , X⊗X) • R (minus , Z⊗I) • R (minus , Z⊗Z) • R (plus , Y⊗I) • R (minus , X⊗I) • R (minus , X⊗Z) • CZ • S0 • S0 • S0 • H0 • S1 • W ^ 5 • R (plus , Y⊗I) • R (plus , Y⊗Z) • R (plus , Z⊗I) • R (plus , Y⊗I) • R (plus , Y⊗Z) • R (plus , X⊗Z) • R (plus , Y⊗X) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Y⊗X) • R (plus , Z⊗Y) • R (plus , Z⊗X) • CZ • H0 • H1 • CZ • H0 • S0 • S0 • H0 • H1 • S1 • S1 • H1 • W ^ 6 • ε
          by clifford-tactic 5 2 10000 auto
      equals R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , I⊗Y) • S1 • H1 • Swap • S0⁻¹ • W • Swap • H1 • S1⁻¹ • R (plus , Y⊗X) • R (minus , Z⊗Y) • R (plus , Y⊗I) • R (plus , Z⊗I) • R (minus , Y⊗I) • R (minus , X⊗Y) • R (minus , Y⊗X) • R (minus , I⊗Y) • R (minus , X⊗Z) • R (minus , I⊗X) • R (minus , X⊗X) • R (minus , Z⊗I) • R (minus , Z⊗Z) • R (plus , Y⊗I) • R (minus , X⊗I) • R (minus , X⊗Z) • CZ • S0 • S0 • S0 • H0 • S1 • W ^ 5 • R (plus , Y⊗I) • R (plus , Y⊗Z) • R (plus , Z⊗I) • R (plus , Y⊗I) • R (plus , Y⊗Z) • R (plus , X⊗Z) • R (plus , Y⊗X) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Y⊗X) • R (plus , Z⊗Y) • R (plus , Z⊗X) • CZ • H0 • H1 • CZ • H0 • S0 • S0 • H0 • H1 • S1 • S1 • H1 • W ^ 6 • ε
          by in-context 3 9 auto (symm (lemma-correction I⊗Y))
      equals R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (minus , I⊗Y) • R (plus , Y⊗X) • R (minus , Z⊗Y) • R (plus , Y⊗I) • R (plus , Z⊗I) • R (minus , Y⊗I) • R (minus , X⊗Y) • R (minus , Y⊗X) • R (minus , I⊗Y) • R (minus , X⊗Z) • R (minus , I⊗X) • R (minus , X⊗X) • R (minus , Z⊗I) • R (minus , Z⊗Z) • R (plus , Y⊗I) • R (minus , X⊗I) • R (minus , X⊗Z) • CZ • S0 • S0 • S0 • H0 • S1 • W ^ 5 • R (plus , Y⊗I) • R (plus , Y⊗Z) • R (plus , Z⊗I) • R (plus , Y⊗I) • R (plus , Y⊗Z) • R (plus , X⊗Z) • R (plus , Y⊗X) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Y⊗X) • R (plus , Z⊗Y) • R (plus , Z⊗X) • CZ • H0 • H1 • CZ • H0 • S0 • S0 • H0 • H1 • S1 • S1 • H1 • W ^ 6 • ε
          by in-context 15 2 auto (tactic-pauli-commute (minus , Z⊗I) (minus , Z⊗Z) auto)
      equals R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (minus , I⊗Y) • R (plus , Y⊗X) • R (minus , Z⊗Y) • R (plus , Y⊗I) • R (plus , Z⊗I) • R (minus , Y⊗I) • R (minus , X⊗Y) • R (minus , Y⊗X) • R (minus , I⊗Y) • R (minus , X⊗Z) • R (minus , I⊗X) • R (minus , X⊗X) • R (minus , Z⊗Z) • R (minus , Z⊗I) • R (plus , Y⊗I) • R (minus , X⊗I) • R (minus , X⊗Z) • CZ • S0 • S0 • S0 • H0 • S1 • W ^ 5 • R (plus , Y⊗I) • R (plus , Y⊗Z) • R (plus , Z⊗I) • R (plus , Y⊗I) • R (plus , Y⊗Z) • R (plus , X⊗Z) • R (plus , Y⊗X) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Y⊗X) • R (plus , Z⊗Y) • R (plus , Z⊗X) • CZ • H0 • H1 • CZ • H0 • S0 • S0 • H0 • H1 • S1 • S1 • H1 • W ^ 6 • ε
          by in-context 9 2 auto (tactic-pauli-commute (minus , X⊗Y) (minus , Y⊗X) auto)
      equals R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (minus , I⊗Y) • R (plus , Y⊗X) • R (minus , Z⊗Y) • R (plus , Y⊗I) • R (plus , Z⊗I) • R (minus , Y⊗I) • R (minus , Y⊗X) • R (minus , X⊗Y) • R (minus , I⊗Y) • R (minus , X⊗Z) • R (minus , I⊗X) • R (minus , X⊗X) • R (minus , Z⊗Z) • R (minus , Z⊗I) • R (plus , Y⊗I) • R (minus , X⊗I) • R (minus , X⊗Z) • CZ • S0 • S0 • S0 • H0 • S1 • W ^ 5 • R (plus , Y⊗I) • R (plus , Y⊗Z) • R (plus , Z⊗I) • R (plus , Y⊗I) • R (plus , Y⊗Z) • R (plus , X⊗Z) • R (plus , Y⊗X) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Y⊗X) • R (plus , Z⊗Y) • R (plus , Z⊗X) • CZ • H0 • H1 • CZ • H0 • S0 • S0 • H0 • H1 • S1 • S1 • H1 • W ^ 6 • ε
          by in-context 10 2 auto (tactic-pauli-commute (minus , X⊗Y) (minus , I⊗Y) auto)
      equals R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (minus , I⊗Y) • R (plus , Y⊗X) • R (minus , Z⊗Y) • R (plus , Y⊗I) • R (plus , Z⊗I) • R (minus , Y⊗I) • R (minus , Y⊗X) • R (minus , I⊗Y) • R (minus , X⊗Y) • R (minus , X⊗Z) • R (minus , I⊗X) • R (minus , X⊗X) • R (minus , Z⊗Z) • R (minus , Z⊗I) • R (plus , Y⊗I) • R (minus , X⊗I) • R (minus , X⊗Z) • CZ • S0 • S0 • S0 • H0 • S1 • W ^ 5 • R (plus , Y⊗I) • R (plus , Y⊗Z) • R (plus , Z⊗I) • R (plus , Y⊗I) • R (plus , Y⊗Z) • R (plus , X⊗Z) • R (plus , Y⊗X) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Y⊗X) • R (plus , Z⊗Y) • R (plus , Z⊗X) • CZ • H0 • H1 • CZ • H0 • S0 • S0 • H0 • H1 • S1 • S1 • H1 • W ^ 6 • ε
          by in-context 8 2 auto (tactic-pauli-commute (minus , Y⊗I) (minus , Y⊗X) auto)
      equals R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (minus , I⊗Y) • R (plus , Y⊗X) • R (minus , Z⊗Y) • R (plus , Y⊗I) • R (plus , Z⊗I) • R (minus , Y⊗X) • R (minus , Y⊗I) • R (minus , I⊗Y) • R (minus , X⊗Y) • R (minus , X⊗Z) • R (minus , I⊗X) • R (minus , X⊗X) • R (minus , Z⊗Z) • R (minus , Z⊗I) • R (plus , Y⊗I) • R (minus , X⊗I) • R (minus , X⊗Z) • CZ • S0 • S0 • S0 • H0 • S1 • W ^ 5 • R (plus , Y⊗I) • R (plus , Y⊗Z) • R (plus , Z⊗I) • R (plus , Y⊗I) • R (plus , Y⊗Z) • R (plus , X⊗Z) • R (plus , Y⊗X) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Y⊗X) • R (plus , Z⊗Y) • R (plus , Z⊗X) • CZ • H0 • H1 • CZ • H0 • S0 • S0 • H0 • H1 • S1 • S1 • H1 • W ^ 6 • ε
          by in-context 4 2 auto (tactic-pauli-commute (plus , Y⊗X) (minus , Z⊗Y) auto)
      equals R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (minus , I⊗Y) • R (minus , Z⊗Y) • R (plus , Y⊗X) • R (plus , Y⊗I) • R (plus , Z⊗I) • R (minus , Y⊗X) • R (minus , Y⊗I) • R (minus , I⊗Y) • R (minus , X⊗Y) • R (minus , X⊗Z) • R (minus , I⊗X) • R (minus , X⊗X) • R (minus , Z⊗Z) • R (minus , Z⊗I) • R (plus , Y⊗I) • R (minus , X⊗I) • R (minus , X⊗Z) • CZ • S0 • S0 • S0 • H0 • S1 • W ^ 5 • R (plus , Y⊗I) • R (plus , Y⊗Z) • R (plus , Z⊗I) • R (plus , Y⊗I) • R (plus , Y⊗Z) • R (plus , X⊗Z) • R (plus , Y⊗X) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Y⊗X) • R (plus , Z⊗Y) • R (plus , Z⊗X) • CZ • H0 • H1 • CZ • H0 • S0 • S0 • H0 • H1 • S1 • S1 • H1 • W ^ 6 • ε
          by in-context 5 2 auto (tactic-pauli-commute (plus , Y⊗X) (plus , Y⊗I) auto)
      equals R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (minus , I⊗Y) • R (minus , Z⊗Y) • R (plus , Y⊗I) • R (plus , Y⊗X) • R (plus , Z⊗I) • R (minus , Y⊗X) • R (minus , Y⊗I) • R (minus , I⊗Y) • R (minus , X⊗Y) • R (minus , X⊗Z) • R (minus , I⊗X) • R (minus , X⊗X) • R (minus , Z⊗Z) • R (minus , Z⊗I) • R (plus , Y⊗I) • R (minus , X⊗I) • R (minus , X⊗Z) • CZ • S0 • S0 • S0 • H0 • S1 • W ^ 5 • R (plus , Y⊗I) • R (plus , Y⊗Z) • R (plus , Z⊗I) • R (plus , Y⊗I) • R (plus , Y⊗Z) • R (plus , X⊗Z) • R (plus , Y⊗X) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Y⊗X) • R (plus , Z⊗Y) • R (plus , Z⊗X) • CZ • H0 • H1 • CZ • H0 • S0 • S0 • H0 • H1 • S1 • S1 • H1 • W ^ 6 • ε
          by in-context 3 2 auto (tactic-pauli-commute (minus , I⊗Y) (minus , Z⊗Y) auto)
      equals R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (minus , Z⊗Y) • R (minus , I⊗Y) • R (plus , Y⊗I) • R (plus , Y⊗X) • R (plus , Z⊗I) • R (minus , Y⊗X) • R (minus , Y⊗I) • R (minus , I⊗Y) • R (minus , X⊗Y) • R (minus , X⊗Z) • R (minus , I⊗X) • R (minus , X⊗X) • R (minus , Z⊗Z) • R (minus , Z⊗I) • R (plus , Y⊗I) • R (minus , X⊗I) • R (minus , X⊗Z) • CZ • S0 • S0 • S0 • H0 • S1 • W ^ 5 • R (plus , Y⊗I) • R (plus , Y⊗Z) • R (plus , Z⊗I) • R (plus , Y⊗I) • R (plus , Y⊗Z) • R (plus , X⊗Z) • R (plus , Y⊗X) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Y⊗X) • R (plus , Z⊗Y) • R (plus , Z⊗X) • CZ • H0 • H1 • CZ • H0 • S0 • S0 • H0 • H1 • S1 • S1 • H1 • W ^ 6 • ε
          by clifford-tactic 20 7 10000 auto
      equals R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (minus , Z⊗Y) • R (minus , I⊗Y) • R (plus , Y⊗I) • R (plus , Y⊗X) • R (plus , Z⊗I) • R (minus , Y⊗X) • R (minus , Y⊗I) • R (minus , I⊗Y) • R (minus , X⊗Y) • R (minus , X⊗Z) • R (minus , I⊗X) • R (minus , X⊗X) • R (minus , Z⊗Z) • R (minus , Z⊗I) • R (plus , Y⊗I) • R (minus , X⊗I) • R (minus , X⊗Z) • S0 • S0 • H0 • S1 • W ^ 6 • CX0 • S0⁻¹ • H0 • S0⁻¹ • R (plus , Y⊗I) • R (plus , Y⊗Z) • R (plus , Z⊗I) • R (plus , Y⊗I) • R (plus , Y⊗Z) • R (plus , X⊗Z) • R (plus , Y⊗X) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Y⊗X) • R (plus , Z⊗Y) • R (plus , Z⊗X) • CZ • H0 • H1 • CZ • H0 • S0 • S0 • H0 • H1 • S1 • S1 • H1 • W ^ 6 • ε
          by in-context 19 7 auto (symm (lemma-R (C.S0 • C.S0 • C.H0 • C.S1 • C.W ^ 6 • C.CX0) (plus , Z⊗I)))
      equals R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (minus , Z⊗Y) • R (minus , I⊗Y) • R (plus , Y⊗I) • R (plus , Y⊗X) • R (plus , Z⊗I) • R (minus , Y⊗X) • R (minus , Y⊗I) • R (minus , I⊗Y) • R (minus , X⊗Y) • R (minus , X⊗Z) • R (minus , I⊗X) • R (minus , X⊗X) • R (minus , Z⊗Z) • R (minus , Z⊗I) • R (plus , Y⊗I) • R (minus , X⊗I) • S0 • S0 • H0 • S1 • W ^ 6 • CX0 • R (plus , Z⊗I) • S0⁻¹ • H0 • S0⁻¹ • R (plus , Y⊗I) • R (plus , Y⊗Z) • R (plus , Z⊗I) • R (plus , Y⊗I) • R (plus , Y⊗Z) • R (plus , X⊗Z) • R (plus , Y⊗X) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Y⊗X) • R (plus , Z⊗Y) • R (plus , Z⊗X) • CZ • H0 • H1 • CZ • H0 • S0 • S0 • H0 • H1 • S1 • S1 • H1 • W ^ 6 • ε
          by in-context 18 6 auto (symm (lemma-R (C.S0 • C.S0 • C.H0 • C.S1 • C.W ^ 6) (plus , Z⊗I)))
      equals R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (minus , Z⊗Y) • R (minus , I⊗Y) • R (plus , Y⊗I) • R (plus , Y⊗X) • R (plus , Z⊗I) • R (minus , Y⊗X) • R (minus , Y⊗I) • R (minus , I⊗Y) • R (minus , X⊗Y) • R (minus , X⊗Z) • R (minus , I⊗X) • R (minus , X⊗X) • R (minus , Z⊗Z) • R (minus , Z⊗I) • R (plus , Y⊗I) • S0 • S0 • H0 • S1 • W ^ 6 • R (plus , Z⊗I) • CX0 • R (plus , Z⊗I) • S0⁻¹ • H0 • S0⁻¹ • R (plus , Y⊗I) • R (plus , Y⊗Z) • R (plus , Z⊗I) • R (plus , Y⊗I) • R (plus , Y⊗Z) • R (plus , X⊗Z) • R (plus , Y⊗X) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Y⊗X) • R (plus , Z⊗Y) • R (plus , Z⊗X) • CZ • H0 • H1 • CZ • H0 • S0 • S0 • H0 • H1 • S1 • S1 • H1 • W ^ 6 • ε
          by clifford-tactic 19 4 10000 auto
      equals R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (minus , Z⊗Y) • R (minus , I⊗Y) • R (plus , Y⊗I) • R (plus , Y⊗X) • R (plus , Z⊗I) • R (minus , Y⊗X) • R (minus , Y⊗I) • R (minus , I⊗Y) • R (minus , X⊗Y) • R (minus , X⊗Z) • R (minus , I⊗X) • R (minus , X⊗X) • R (minus , Z⊗Z) • R (minus , Z⊗I) • R (plus , Y⊗I) • S0 • H0 • S0 • S1 • W ^ 6 • S0⁻¹ • H0 • S0 • H0 • R (plus , Z⊗I) • CX0 • R (plus , Z⊗I) • S0⁻¹ • H0 • S0⁻¹ • R (plus , Y⊗I) • R (plus , Y⊗Z) • R (plus , Z⊗I) • R (plus , Y⊗I) • R (plus , Y⊗Z) • R (plus , X⊗Z) • R (plus , Y⊗X) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Y⊗X) • R (plus , Z⊗Y) • R (plus , Z⊗X) • CZ • H0 • H1 • CZ • H0 • S0 • S0 • H0 • H1 • S1 • S1 • H1 • W ^ 6 • ε
          by in-context 17 6 auto (symm (lemma-R (C.S0 • C.H0 • C.S0 • C.S1 • C.W ^ 6) (plus , Z⊗I)))
      equals R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (minus , Z⊗Y) • R (minus , I⊗Y) • R (plus , Y⊗I) • R (plus , Y⊗X) • R (plus , Z⊗I) • R (minus , Y⊗X) • R (minus , Y⊗I) • R (minus , I⊗Y) • R (minus , X⊗Y) • R (minus , X⊗Z) • R (minus , I⊗X) • R (minus , X⊗X) • R (minus , Z⊗Z) • R (minus , Z⊗I) • S0 • H0 • S0 • S1 • W ^ 6 • R (plus , Z⊗I) • S0⁻¹ • H0 • S0 • H0 • R (plus , Z⊗I) • CX0 • R (plus , Z⊗I) • S0⁻¹ • H0 • S0⁻¹ • R (plus , Y⊗I) • R (plus , Y⊗Z) • R (plus , Z⊗I) • R (plus , Y⊗I) • R (plus , Y⊗Z) • R (plus , X⊗Z) • R (plus , Y⊗X) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Y⊗X) • R (plus , Z⊗Y) • R (plus , Z⊗X) • CZ • H0 • H1 • CZ • H0 • S0 • S0 • H0 • H1 • S1 • S1 • H1 • W ^ 6 • ε
          by clifford-tactic 17 5 10000 auto
      equals R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (minus , Z⊗Y) • R (minus , I⊗Y) • R (plus , Y⊗I) • R (plus , Y⊗X) • R (plus , Z⊗I) • R (minus , Y⊗X) • R (minus , Y⊗I) • R (minus , I⊗Y) • R (minus , X⊗Y) • R (minus , X⊗Z) • R (minus , I⊗X) • R (minus , X⊗X) • R (minus , Z⊗Z) • R (minus , Z⊗I) • H0 • S0 • S0 • H0 • S1 • S0⁻¹ • H0 • S0⁻¹ • R (plus , Z⊗I) • S0⁻¹ • H0 • S0 • H0 • R (plus , Z⊗I) • CX0 • R (plus , Z⊗I) • S0⁻¹ • H0 • S0⁻¹ • R (plus , Y⊗I) • R (plus , Y⊗Z) • R (plus , Z⊗I) • R (plus , Y⊗I) • R (plus , Y⊗Z) • R (plus , X⊗Z) • R (plus , Y⊗X) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Y⊗X) • R (plus , Z⊗Y) • R (plus , Z⊗X) • CZ • H0 • H1 • CZ • H0 • S0 • S0 • H0 • H1 • S1 • S1 • H1 • W ^ 6 • ε
          by in-context 16 6 auto (symm (lemma-R (C.H0 • C.S0 • C.S0 • C.H0 • C.S1) (plus , Z⊗I)))
      equals R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (minus , Z⊗Y) • R (minus , I⊗Y) • R (plus , Y⊗I) • R (plus , Y⊗X) • R (plus , Z⊗I) • R (minus , Y⊗X) • R (minus , Y⊗I) • R (minus , I⊗Y) • R (minus , X⊗Y) • R (minus , X⊗Z) • R (minus , I⊗X) • R (minus , X⊗X) • R (minus , Z⊗Z) • H0 • S0 • S0 • H0 • S1 • R (plus , Z⊗I) • S0⁻¹ • H0 • S0⁻¹ • R (plus , Z⊗I) • S0⁻¹ • H0 • S0 • H0 • R (plus , Z⊗I) • CX0 • R (plus , Z⊗I) • S0⁻¹ • H0 • S0⁻¹ • R (plus , Y⊗I) • R (plus , Y⊗Z) • R (plus , Z⊗I) • R (plus , Y⊗I) • R (plus , Y⊗Z) • R (plus , X⊗Z) • R (plus , Y⊗X) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Y⊗X) • R (plus , Z⊗Y) • R (plus , Z⊗X) • CZ • H0 • H1 • CZ • H0 • S0 • S0 • H0 • H1 • S1 • S1 • H1 • W ^ 6 • ε
          by clifford-tactic 17 4 10000 auto
      equals R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (minus , Z⊗Y) • R (minus , I⊗Y) • R (plus , Y⊗I) • R (plus , Y⊗X) • R (plus , Z⊗I) • R (minus , Y⊗X) • R (minus , Y⊗I) • R (minus , I⊗Y) • R (minus , X⊗Y) • R (minus , X⊗Z) • R (minus , I⊗X) • R (minus , X⊗X) • R (minus , Z⊗Z) • H0 • CZ • S0 • S0 • H0 • S1 • CX0 • R (plus , Z⊗I) • S0⁻¹ • H0 • S0⁻¹ • R (plus , Z⊗I) • S0⁻¹ • H0 • S0 • H0 • R (plus , Z⊗I) • CX0 • R (plus , Z⊗I) • S0⁻¹ • H0 • S0⁻¹ • R (plus , Y⊗I) • R (plus , Y⊗Z) • R (plus , Z⊗I) • R (plus , Y⊗I) • R (plus , Y⊗Z) • R (plus , X⊗Z) • R (plus , Y⊗X) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Y⊗X) • R (plus , Z⊗Y) • R (plus , Z⊗X) • CZ • H0 • H1 • CZ • H0 • S0 • S0 • H0 • H1 • S1 • S1 • H1 • W ^ 6 • ε
          by in-context 15 7 auto (symm (lemma-R (C.H0 • C.CZ • C.S0 • C.S0 • C.H0 • C.S1) (plus , Z⊗I)))
      equals R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (minus , Z⊗Y) • R (minus , I⊗Y) • R (plus , Y⊗I) • R (plus , Y⊗X) • R (plus , Z⊗I) • R (minus , Y⊗X) • R (minus , Y⊗I) • R (minus , I⊗Y) • R (minus , X⊗Y) • R (minus , X⊗Z) • R (minus , I⊗X) • R (minus , X⊗X) • H0 • CZ • S0 • S0 • H0 • S1 • R (plus , Z⊗I) • CX0 • R (plus , Z⊗I) • S0⁻¹ • H0 • S0⁻¹ • R (plus , Z⊗I) • S0⁻¹ • H0 • S0 • H0 • R (plus , Z⊗I) • CX0 • R (plus , Z⊗I) • S0⁻¹ • H0 • S0⁻¹ • R (plus , Y⊗I) • R (plus , Y⊗Z) • R (plus , Z⊗I) • R (plus , Y⊗I) • R (plus , Y⊗Z) • R (plus , X⊗Z) • R (plus , Y⊗X) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Y⊗X) • R (plus , Z⊗Y) • R (plus , Z⊗X) • CZ • H0 • H1 • CZ • H0 • S0 • S0 • H0 • H1 • S1 • S1 • H1 • W ^ 6 • ε
          by clifford-tactic 18 3 10000 auto
      equals R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (minus , Z⊗Y) • R (minus , I⊗Y) • R (plus , Y⊗I) • R (plus , Y⊗X) • R (plus , Z⊗I) • R (minus , Y⊗X) • R (minus , Y⊗I) • R (minus , I⊗Y) • R (minus , X⊗Y) • R (minus , X⊗Z) • R (minus , I⊗X) • R (minus , X⊗X) • H0 • CZ • S0 • S1 • S1 • H1 • S1 • S1⁻¹ • H1 • S1⁻¹ • S0 • H0 • R (plus , Z⊗I) • CX0 • R (plus , Z⊗I) • S0⁻¹ • H0 • S0⁻¹ • R (plus , Z⊗I) • S0⁻¹ • H0 • S0 • H0 • R (plus , Z⊗I) • CX0 • R (plus , Z⊗I) • S0⁻¹ • H0 • S0⁻¹ • R (plus , Y⊗I) • R (plus , Y⊗Z) • R (plus , Z⊗I) • R (plus , Y⊗I) • R (plus , Y⊗Z) • R (plus , X⊗Z) • R (plus , Y⊗X) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Y⊗X) • R (plus , Z⊗Y) • R (plus , Z⊗X) • CZ • H0 • H1 • CZ • H0 • S0 • S0 • H0 • H1 • S1 • S1 • H1 • W ^ 6 • ε
          by in-context 14 8 auto (symm (lemma-R (C.H0 • C.CZ • C.S0 • C.S1 • C.S1 • C.H1 • C.S1) (plus , I⊗Z)))
      equals R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (minus , Z⊗Y) • R (minus , I⊗Y) • R (plus , Y⊗I) • R (plus , Y⊗X) • R (plus , Z⊗I) • R (minus , Y⊗X) • R (minus , Y⊗I) • R (minus , I⊗Y) • R (minus , X⊗Y) • R (minus , X⊗Z) • R (minus , I⊗X) • H0 • CZ • S0 • S1 • S1 • H1 • S1 • R (plus , I⊗Z) • S1⁻¹ • H1 • S1⁻¹ • S0 • H0 • R (plus , Z⊗I) • CX0 • R (plus , Z⊗I) • S0⁻¹ • H0 • S0⁻¹ • R (plus , Z⊗I) • S0⁻¹ • H0 • S0 • H0 • R (plus , Z⊗I) • CX0 • R (plus , Z⊗I) • S0⁻¹ • H0 • S0⁻¹ • R (plus , Y⊗I) • R (plus , Y⊗Z) • R (plus , Z⊗I) • R (plus , Y⊗I) • R (plus , Y⊗Z) • R (plus , X⊗Z) • R (plus , Y⊗X) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Y⊗X) • R (plus , Z⊗Y) • R (plus , Z⊗X) • CZ • H0 • H1 • CZ • H0 • S0 • S0 • H0 • H1 • S1 • S1 • H1 • W ^ 6 • ε
          by clifford-tactic 15 6 10000 auto
      equals R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (minus , Z⊗Y) • R (minus , I⊗Y) • R (plus , Y⊗I) • R (plus , Y⊗X) • R (plus , Z⊗I) • R (minus , Y⊗X) • R (minus , Y⊗I) • R (minus , I⊗Y) • R (minus , X⊗Y) • R (minus , X⊗Z) • R (minus , I⊗X) • H0 • H1 • CZ • H1 • S1 • S1 • H1 • S1 • CX1 • R (plus , I⊗Z) • S1⁻¹ • H1 • S1⁻¹ • S0 • H0 • R (plus , Z⊗I) • CX0 • R (plus , Z⊗I) • S0⁻¹ • H0 • S0⁻¹ • R (plus , Z⊗I) • S0⁻¹ • H0 • S0 • H0 • R (plus , Z⊗I) • CX0 • R (plus , Z⊗I) • S0⁻¹ • H0 • S0⁻¹ • R (plus , Y⊗I) • R (plus , Y⊗Z) • R (plus , Z⊗I) • R (plus , Y⊗I) • R (plus , Y⊗Z) • R (plus , X⊗Z) • R (plus , Y⊗X) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Y⊗X) • R (plus , Z⊗Y) • R (plus , Z⊗X) • CZ • H0 • H1 • CZ • H0 • S0 • S0 • H0 • H1 • S1 • S1 • H1 • W ^ 6 • ε
          by in-context 13 9 auto (symm (lemma-R (C.H0 • C.H1 • C.CZ • C.H1 • C.S1 • C.S1 • C.H1 • C.S1) (plus , I⊗Z)))
      equals R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (minus , Z⊗Y) • R (minus , I⊗Y) • R (plus , Y⊗I) • R (plus , Y⊗X) • R (plus , Z⊗I) • R (minus , Y⊗X) • R (minus , Y⊗I) • R (minus , I⊗Y) • R (minus , X⊗Y) • R (minus , X⊗Z) • H0 • H1 • CZ • H1 • S1 • S1 • H1 • S1 • R (plus , I⊗Z) • CX1 • R (plus , I⊗Z) • S1⁻¹ • H1 • S1⁻¹ • S0 • H0 • R (plus , Z⊗I) • CX0 • R (plus , Z⊗I) • S0⁻¹ • H0 • S0⁻¹ • R (plus , Z⊗I) • S0⁻¹ • H0 • S0 • H0 • R (plus , Z⊗I) • CX0 • R (plus , Z⊗I) • S0⁻¹ • H0 • S0⁻¹ • R (plus , Y⊗I) • R (plus , Y⊗Z) • R (plus , Z⊗I) • R (plus , Y⊗I) • R (plus , Y⊗Z) • R (plus , X⊗Z) • R (plus , Y⊗X) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Y⊗X) • R (plus , Z⊗Y) • R (plus , Z⊗X) • CZ • H0 • H1 • CZ • H0 • S0 • S0 • H0 • H1 • S1 • S1 • H1 • W ^ 6 • ε
          by clifford-tactic 16 5 10000 auto
      equals R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (minus , Z⊗Y) • R (minus , I⊗Y) • R (plus , Y⊗I) • R (plus , Y⊗X) • R (plus , Z⊗I) • R (minus , Y⊗X) • R (minus , Y⊗I) • R (minus , I⊗Y) • R (minus , X⊗Y) • R (minus , X⊗Z) • H0 • H1 • CZ • S1 • S1 • H1 • W ^ 3 • S1⁻¹ • H1 • S1 • H1 • R (plus , I⊗Z) • CX1 • R (plus , I⊗Z) • S1⁻¹ • H1 • S1⁻¹ • S0 • H0 • R (plus , Z⊗I) • CX0 • R (plus , Z⊗I) • S0⁻¹ • H0 • S0⁻¹ • R (plus , Z⊗I) • S0⁻¹ • H0 • S0 • H0 • R (plus , Z⊗I) • CX0 • R (plus , Z⊗I) • S0⁻¹ • H0 • S0⁻¹ • R (plus , Y⊗I) • R (plus , Y⊗Z) • R (plus , Z⊗I) • R (plus , Y⊗I) • R (plus , Y⊗Z) • R (plus , X⊗Z) • R (plus , Y⊗X) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Y⊗X) • R (plus , Z⊗Y) • R (plus , Z⊗X) • CZ • H0 • H1 • CZ • H0 • S0 • S0 • H0 • H1 • S1 • S1 • H1 • W ^ 6 • ε
          by in-context 12 8 auto (symm (lemma-R (C.H0 • C.H1 • C.CZ • C.S1 • C.S1 • C.H1 • C.W ^ 3) (plus , I⊗Z)))
      equals R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (minus , Z⊗Y) • R (minus , I⊗Y) • R (plus , Y⊗I) • R (plus , Y⊗X) • R (plus , Z⊗I) • R (minus , Y⊗X) • R (minus , Y⊗I) • R (minus , I⊗Y) • R (minus , X⊗Y) • H0 • H1 • CZ • S1 • S1 • H1 • W ^ 3 • R (plus , I⊗Z) • S1⁻¹ • H1 • S1 • H1 • R (plus , I⊗Z) • CX1 • R (plus , I⊗Z) • S1⁻¹ • H1 • S1⁻¹ • S0 • H0 • R (plus , Z⊗I) • CX0 • R (plus , Z⊗I) • S0⁻¹ • H0 • S0⁻¹ • R (plus , Z⊗I) • S0⁻¹ • H0 • S0 • H0 • R (plus , Z⊗I) • CX0 • R (plus , Z⊗I) • S0⁻¹ • H0 • S0⁻¹ • R (plus , Y⊗I) • R (plus , Y⊗Z) • R (plus , Z⊗I) • R (plus , Y⊗I) • R (plus , Y⊗Z) • R (plus , X⊗Z) • R (plus , Y⊗X) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Y⊗X) • R (plus , Z⊗Y) • R (plus , Z⊗X) • CZ • H0 • H1 • CZ • H0 • S0 • S0 • H0 • H1 • S1 • S1 • H1 • W ^ 6 • ε
          by clifford-tactic 14 5 10000 auto
      equals R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (minus , Z⊗Y) • R (minus , I⊗Y) • R (plus , Y⊗I) • R (plus , Y⊗X) • R (plus , Z⊗I) • R (minus , Y⊗X) • R (minus , Y⊗I) • R (minus , I⊗Y) • R (minus , X⊗Y) • H0 • H1 • S1 • H1 • W ^ 4 • CX1 • S1⁻¹ • H1 • S1⁻¹ • R (plus , I⊗Z) • S1⁻¹ • H1 • S1 • H1 • R (plus , I⊗Z) • CX1 • R (plus , I⊗Z) • S1⁻¹ • H1 • S1⁻¹ • S0 • H0 • R (plus , Z⊗I) • CX0 • R (plus , Z⊗I) • S0⁻¹ • H0 • S0⁻¹ • R (plus , Z⊗I) • S0⁻¹ • H0 • S0 • H0 • R (plus , Z⊗I) • CX0 • R (plus , Z⊗I) • S0⁻¹ • H0 • S0⁻¹ • R (plus , Y⊗I) • R (plus , Y⊗Z) • R (plus , Z⊗I) • R (plus , Y⊗I) • R (plus , Y⊗Z) • R (plus , X⊗Z) • R (plus , Y⊗X) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Y⊗X) • R (plus , Z⊗Y) • R (plus , Z⊗X) • CZ • H0 • H1 • CZ • H0 • S0 • S0 • H0 • H1 • S1 • S1 • H1 • W ^ 6 • ε
          by in-context 11 7 auto (symm (lemma-R (C.H0 • C.H1 • C.S1 • C.H1 • C.W ^ 4 • C.CX1) (plus , I⊗Z)))
      equals R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (minus , Z⊗Y) • R (minus , I⊗Y) • R (plus , Y⊗I) • R (plus , Y⊗X) • R (plus , Z⊗I) • R (minus , Y⊗X) • R (minus , Y⊗I) • R (minus , I⊗Y) • H0 • H1 • S1 • H1 • W ^ 4 • CX1 • R (plus , I⊗Z) • S1⁻¹ • H1 • S1⁻¹ • R (plus , I⊗Z) • S1⁻¹ • H1 • S1 • H1 • R (plus , I⊗Z) • CX1 • R (plus , I⊗Z) • S1⁻¹ • H1 • S1⁻¹ • S0 • H0 • R (plus , Z⊗I) • CX0 • R (plus , Z⊗I) • S0⁻¹ • H0 • S0⁻¹ • R (plus , Z⊗I) • S0⁻¹ • H0 • S0 • H0 • R (plus , Z⊗I) • CX0 • R (plus , Z⊗I) • S0⁻¹ • H0 • S0⁻¹ • R (plus , Y⊗I) • R (plus , Y⊗Z) • R (plus , Z⊗I) • R (plus , Y⊗I) • R (plus , Y⊗Z) • R (plus , X⊗Z) • R (plus , Y⊗X) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Y⊗X) • R (plus , Z⊗Y) • R (plus , Z⊗X) • CZ • H0 • H1 • CZ • H0 • S0 • S0 • H0 • H1 • S1 • S1 • H1 • W ^ 6 • ε
          by in-context 10 6 auto (symm (lemma-R (C.H0 • C.H1 • C.S1 • C.H1 • C.W ^ 4) (plus , I⊗Z)))
      equals R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (minus , Z⊗Y) • R (minus , I⊗Y) • R (plus , Y⊗I) • R (plus , Y⊗X) • R (plus , Z⊗I) • R (minus , Y⊗X) • R (minus , Y⊗I) • H0 • H1 • S1 • H1 • W ^ 4 • R (plus , I⊗Z) • CX1 • R (plus , I⊗Z) • S1⁻¹ • H1 • S1⁻¹ • R (plus , I⊗Z) • S1⁻¹ • H1 • S1 • H1 • R (plus , I⊗Z) • CX1 • R (plus , I⊗Z) • S1⁻¹ • H1 • S1⁻¹ • S0 • H0 • R (plus , Z⊗I) • CX0 • R (plus , Z⊗I) • S0⁻¹ • H0 • S0⁻¹ • R (plus , Z⊗I) • S0⁻¹ • H0 • S0 • H0 • R (plus , Z⊗I) • CX0 • R (plus , Z⊗I) • S0⁻¹ • H0 • S0⁻¹ • R (plus , Y⊗I) • R (plus , Y⊗Z) • R (plus , Z⊗I) • R (plus , Y⊗I) • R (plus , Y⊗Z) • R (plus , X⊗Z) • R (plus , Y⊗X) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Y⊗X) • R (plus , Z⊗Y) • R (plus , Z⊗X) • CZ • H0 • H1 • CZ • H0 • S0 • S0 • H0 • H1 • S1 • S1 • H1 • W ^ 6 • ε
          by clifford-tactic 10 5 10000 auto
      equals R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (minus , Z⊗Y) • R (minus , I⊗Y) • R (plus , Y⊗I) • R (plus , Y⊗X) • R (plus , Z⊗I) • R (minus , Y⊗X) • R (minus , Y⊗I) • S0 • S0 • S0 • H0 • H1 • W ^ 5 • S0⁻¹ • H0 • S0⁻¹ • S1 • H1 • R (plus , I⊗Z) • CX1 • R (plus , I⊗Z) • S1⁻¹ • H1 • S1⁻¹ • R (plus , I⊗Z) • S1⁻¹ • H1 • S1 • H1 • R (plus , I⊗Z) • CX1 • R (plus , I⊗Z) • S1⁻¹ • H1 • S1⁻¹ • S0 • H0 • R (plus , Z⊗I) • CX0 • R (plus , Z⊗I) • S0⁻¹ • H0 • S0⁻¹ • R (plus , Z⊗I) • S0⁻¹ • H0 • S0 • H0 • R (plus , Z⊗I) • CX0 • R (plus , Z⊗I) • S0⁻¹ • H0 • S0⁻¹ • R (plus , Y⊗I) • R (plus , Y⊗Z) • R (plus , Z⊗I) • R (plus , Y⊗I) • R (plus , Y⊗Z) • R (plus , X⊗Z) • R (plus , Y⊗X) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Y⊗X) • R (plus , Z⊗Y) • R (plus , Z⊗X) • CZ • H0 • H1 • CZ • H0 • S0 • S0 • H0 • H1 • S1 • S1 • H1 • W ^ 6 • ε
          by in-context 9 7 auto (symm (lemma-R (C.S0 • C.S0 • C.S0 • C.H0 • C.H1 • C.W ^ 5) (plus , Z⊗I)))
      equals R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (minus , Z⊗Y) • R (minus , I⊗Y) • R (plus , Y⊗I) • R (plus , Y⊗X) • R (plus , Z⊗I) • R (minus , Y⊗X) • S0 • S0 • S0 • H0 • H1 • W ^ 5 • R (plus , Z⊗I) • S0⁻¹ • H0 • S0⁻¹ • S1 • H1 • R (plus , I⊗Z) • CX1 • R (plus , I⊗Z) • S1⁻¹ • H1 • S1⁻¹ • R (plus , I⊗Z) • S1⁻¹ • H1 • S1 • H1 • R (plus , I⊗Z) • CX1 • R (plus , I⊗Z) • S1⁻¹ • H1 • S1⁻¹ • S0 • H0 • R (plus , Z⊗I) • CX0 • R (plus , Z⊗I) • S0⁻¹ • H0 • S0⁻¹ • R (plus , Z⊗I) • S0⁻¹ • H0 • S0 • H0 • R (plus , Z⊗I) • CX0 • R (plus , Z⊗I) • S0⁻¹ • H0 • S0⁻¹ • R (plus , Y⊗I) • R (plus , Y⊗Z) • R (plus , Z⊗I) • R (plus , Y⊗I) • R (plus , Y⊗Z) • R (plus , X⊗Z) • R (plus , Y⊗X) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Y⊗X) • R (plus , Z⊗Y) • R (plus , Z⊗X) • CZ • H0 • H1 • CZ • H0 • S0 • S0 • H0 • H1 • S1 • S1 • H1 • W ^ 6 • ε
          by clifford-tactic 9 6 10000 auto
      equals R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (minus , Z⊗Y) • R (minus , I⊗Y) • R (plus , Y⊗I) • R (plus , Y⊗X) • R (plus , Z⊗I) • R (minus , Y⊗X) • H1 • CZ • S0 • S0 • W ^ 5 • S0 • H0 • CX0 • R (plus , Z⊗I) • S0⁻¹ • H0 • S0⁻¹ • S1 • H1 • R (plus , I⊗Z) • CX1 • R (plus , I⊗Z) • S1⁻¹ • H1 • S1⁻¹ • R (plus , I⊗Z) • S1⁻¹ • H1 • S1 • H1 • R (plus , I⊗Z) • CX1 • R (plus , I⊗Z) • S1⁻¹ • H1 • S1⁻¹ • S0 • H0 • R (plus , Z⊗I) • CX0 • R (plus , Z⊗I) • S0⁻¹ • H0 • S0⁻¹ • R (plus , Z⊗I) • S0⁻¹ • H0 • S0 • H0 • R (plus , Z⊗I) • CX0 • R (plus , Z⊗I) • S0⁻¹ • H0 • S0⁻¹ • R (plus , Y⊗I) • R (plus , Y⊗Z) • R (plus , Z⊗I) • R (plus , Y⊗I) • R (plus , Y⊗Z) • R (plus , X⊗Z) • R (plus , Y⊗X) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Y⊗X) • R (plus , Z⊗Y) • R (plus , Z⊗X) • CZ • H0 • H1 • CZ • H0 • S0 • S0 • H0 • H1 • S1 • S1 • H1 • W ^ 6 • ε
          by in-context 8 8 auto (symm (lemma-R (C.H1 • C.CZ • C.S0 • C.S0 • C.W ^ 5 • C.S0 • C.H0) (plus , Z⊗I)))
      equals R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (minus , Z⊗Y) • R (minus , I⊗Y) • R (plus , Y⊗I) • R (plus , Y⊗X) • R (plus , Z⊗I) • H1 • CZ • S0 • S0 • W ^ 5 • S0 • H0 • R (plus , Z⊗I) • CX0 • R (plus , Z⊗I) • S0⁻¹ • H0 • S0⁻¹ • S1 • H1 • R (plus , I⊗Z) • CX1 • R (plus , I⊗Z) • S1⁻¹ • H1 • S1⁻¹ • R (plus , I⊗Z) • S1⁻¹ • H1 • S1 • H1 • R (plus , I⊗Z) • CX1 • R (plus , I⊗Z) • S1⁻¹ • H1 • S1⁻¹ • S0 • H0 • R (plus , Z⊗I) • CX0 • R (plus , Z⊗I) • S0⁻¹ • H0 • S0⁻¹ • R (plus , Z⊗I) • S0⁻¹ • H0 • S0 • H0 • R (plus , Z⊗I) • CX0 • R (plus , Z⊗I) • S0⁻¹ • H0 • S0⁻¹ • R (plus , Y⊗I) • R (plus , Y⊗Z) • R (plus , Z⊗I) • R (plus , Y⊗I) • R (plus , Y⊗Z) • R (plus , X⊗Z) • R (plus , Y⊗X) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Y⊗X) • R (plus , Z⊗Y) • R (plus , Z⊗X) • CZ • H0 • H1 • CZ • H0 • S0 • S0 • H0 • H1 • S1 • S1 • H1 • W ^ 6 • ε
          by in-context 7 6 auto (symm (lemma-R (C.H1 • C.CZ • C.S0 • C.S0 • C.W ^ 5) (plus , Z⊗I)))
      equals R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (minus , Z⊗Y) • R (minus , I⊗Y) • R (plus , Y⊗I) • R (plus , Y⊗X) • H1 • CZ • S0 • S0 • W ^ 5 • R (plus , Z⊗I) • S0 • H0 • R (plus , Z⊗I) • CX0 • R (plus , Z⊗I) • S0⁻¹ • H0 • S0⁻¹ • S1 • H1 • R (plus , I⊗Z) • CX1 • R (plus , I⊗Z) • S1⁻¹ • H1 • S1⁻¹ • R (plus , I⊗Z) • S1⁻¹ • H1 • S1 • H1 • R (plus , I⊗Z) • CX1 • R (plus , I⊗Z) • S1⁻¹ • H1 • S1⁻¹ • S0 • H0 • R (plus , Z⊗I) • CX0 • R (plus , Z⊗I) • S0⁻¹ • H0 • S0⁻¹ • R (plus , Z⊗I) • S0⁻¹ • H0 • S0 • H0 • R (plus , Z⊗I) • CX0 • R (plus , Z⊗I) • S0⁻¹ • H0 • S0⁻¹ • R (plus , Y⊗I) • R (plus , Y⊗Z) • R (plus , Z⊗I) • R (plus , Y⊗I) • R (plus , Y⊗Z) • R (plus , X⊗Z) • R (plus , Y⊗X) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Y⊗X) • R (plus , Z⊗Y) • R (plus , Z⊗X) • CZ • H0 • H1 • CZ • H0 • S0 • S0 • H0 • H1 • S1 • S1 • H1 • W ^ 6 • ε
          by clifford-tactic 7 5 10000 auto
      equals R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (minus , Z⊗Y) • R (minus , I⊗Y) • R (plus , Y⊗I) • R (plus , Y⊗X) • S0 • H0 • H1 • W ^ 6 • CX0 • H0 • S0 • W⁻¹ • R (plus , Z⊗I) • S0 • H0 • R (plus , Z⊗I) • CX0 • R (plus , Z⊗I) • S0⁻¹ • H0 • S0⁻¹ • S1 • H1 • R (plus , I⊗Z) • CX1 • R (plus , I⊗Z) • S1⁻¹ • H1 • S1⁻¹ • R (plus , I⊗Z) • S1⁻¹ • H1 • S1 • H1 • R (plus , I⊗Z) • CX1 • R (plus , I⊗Z) • S1⁻¹ • H1 • S1⁻¹ • S0 • H0 • R (plus , Z⊗I) • CX0 • R (plus , Z⊗I) • S0⁻¹ • H0 • S0⁻¹ • R (plus , Z⊗I) • S0⁻¹ • H0 • S0 • H0 • R (plus , Z⊗I) • CX0 • R (plus , Z⊗I) • S0⁻¹ • H0 • S0⁻¹ • R (plus , Y⊗I) • R (plus , Y⊗Z) • R (plus , Z⊗I) • R (plus , Y⊗I) • R (plus , Y⊗Z) • R (plus , X⊗Z) • R (plus , Y⊗X) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Y⊗X) • R (plus , Z⊗Y) • R (plus , Z⊗X) • CZ • H0 • H1 • CZ • H0 • S0 • S0 • H0 • H1 • S1 • S1 • H1 • W ^ 6 • ε
          by in-context 6 6 auto (symm (lemma-R (C.S0 • C.H0 • C.H1 • C.W ^ 6 • C.CX0) (plus , Z⊗I)))
      equals R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (minus , Z⊗Y) • R (minus , I⊗Y) • R (plus , Y⊗I) • S0 • H0 • H1 • W ^ 6 • CX0 • R (plus , Z⊗I) • H0 • S0 • W⁻¹ • R (plus , Z⊗I) • S0 • H0 • R (plus , Z⊗I) • CX0 • R (plus , Z⊗I) • S0⁻¹ • H0 • S0⁻¹ • S1 • H1 • R (plus , I⊗Z) • CX1 • R (plus , I⊗Z) • S1⁻¹ • H1 • S1⁻¹ • R (plus , I⊗Z) • S1⁻¹ • H1 • S1 • H1 • R (plus , I⊗Z) • CX1 • R (plus , I⊗Z) • S1⁻¹ • H1 • S1⁻¹ • S0 • H0 • R (plus , Z⊗I) • CX0 • R (plus , Z⊗I) • S0⁻¹ • H0 • S0⁻¹ • R (plus , Z⊗I) • S0⁻¹ • H0 • S0 • H0 • R (plus , Z⊗I) • CX0 • R (plus , Z⊗I) • S0⁻¹ • H0 • S0⁻¹ • R (plus , Y⊗I) • R (plus , Y⊗Z) • R (plus , Z⊗I) • R (plus , Y⊗I) • R (plus , Y⊗Z) • R (plus , X⊗Z) • R (plus , Y⊗X) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Y⊗X) • R (plus , Z⊗Y) • R (plus , Z⊗X) • CZ • H0 • H1 • CZ • H0 • S0 • S0 • H0 • H1 • S1 • S1 • H1 • W ^ 6 • ε
          by in-context 5 5 auto (symm (lemma-R (C.S0 • C.H0 • C.H1 • C.W ^ 6) (plus , Z⊗I)))
      equals R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (minus , Z⊗Y) • R (minus , I⊗Y) • S0 • H0 • H1 • W ^ 6 • R (plus , Z⊗I) • CX0 • R (plus , Z⊗I) • H0 • S0 • W⁻¹ • R (plus , Z⊗I) • S0 • H0 • R (plus , Z⊗I) • CX0 • R (plus , Z⊗I) • S0⁻¹ • H0 • S0⁻¹ • S1 • H1 • R (plus , I⊗Z) • CX1 • R (plus , I⊗Z) • S1⁻¹ • H1 • S1⁻¹ • R (plus , I⊗Z) • S1⁻¹ • H1 • S1 • H1 • R (plus , I⊗Z) • CX1 • R (plus , I⊗Z) • S1⁻¹ • H1 • S1⁻¹ • S0 • H0 • R (plus , Z⊗I) • CX0 • R (plus , Z⊗I) • S0⁻¹ • H0 • S0⁻¹ • R (plus , Z⊗I) • S0⁻¹ • H0 • S0 • H0 • R (plus , Z⊗I) • CX0 • R (plus , Z⊗I) • S0⁻¹ • H0 • S0⁻¹ • R (plus , Y⊗I) • R (plus , Y⊗Z) • R (plus , Z⊗I) • R (plus , Y⊗I) • R (plus , Y⊗Z) • R (plus , X⊗Z) • R (plus , Y⊗X) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Y⊗X) • R (plus , Z⊗Y) • R (plus , Z⊗X) • CZ • H0 • H1 • CZ • H0 • S0 • S0 • H0 • H1 • S1 • S1 • H1 • W ^ 6 • ε
          by clifford-tactic 5 4 10000 auto
      equals R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (minus , Z⊗Y) • R (minus , I⊗Y) • S1 • S1 • S1 • H1 • W⁻¹ • S1⁻¹ • H1 • S1⁻¹ • S0 • H0 • R (plus , Z⊗I) • CX0 • R (plus , Z⊗I) • H0 • S0 • W⁻¹ • R (plus , Z⊗I) • S0 • H0 • R (plus , Z⊗I) • CX0 • R (plus , Z⊗I) • S0⁻¹ • H0 • S0⁻¹ • S1 • H1 • R (plus , I⊗Z) • CX1 • R (plus , I⊗Z) • S1⁻¹ • H1 • S1⁻¹ • R (plus , I⊗Z) • S1⁻¹ • H1 • S1 • H1 • R (plus , I⊗Z) • CX1 • R (plus , I⊗Z) • S1⁻¹ • H1 • S1⁻¹ • S0 • H0 • R (plus , Z⊗I) • CX0 • R (plus , Z⊗I) • S0⁻¹ • H0 • S0⁻¹ • R (plus , Z⊗I) • S0⁻¹ • H0 • S0 • H0 • R (plus , Z⊗I) • CX0 • R (plus , Z⊗I) • S0⁻¹ • H0 • S0⁻¹ • R (plus , Y⊗I) • R (plus , Y⊗Z) • R (plus , Z⊗I) • R (plus , Y⊗I) • R (plus , Y⊗Z) • R (plus , X⊗Z) • R (plus , Y⊗X) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Y⊗X) • R (plus , Z⊗Y) • R (plus , Z⊗X) • CZ • H0 • H1 • CZ • H0 • S0 • S0 • H0 • H1 • S1 • S1 • H1 • W ^ 6 • ε
          by in-context 4 6 auto (symm (lemma-R (C.S1 • C.S1 • C.S1 • C.H1 • C.W⁻¹) (plus , I⊗Z)))
      equals R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (minus , Z⊗Y) • S1 • S1 • S1 • H1 • W⁻¹ • R (plus , I⊗Z) • S1⁻¹ • H1 • S1⁻¹ • S0 • H0 • R (plus , Z⊗I) • CX0 • R (plus , Z⊗I) • H0 • S0 • W⁻¹ • R (plus , Z⊗I) • S0 • H0 • R (plus , Z⊗I) • CX0 • R (plus , Z⊗I) • S0⁻¹ • H0 • S0⁻¹ • S1 • H1 • R (plus , I⊗Z) • CX1 • R (plus , I⊗Z) • S1⁻¹ • H1 • S1⁻¹ • R (plus , I⊗Z) • S1⁻¹ • H1 • S1 • H1 • R (plus , I⊗Z) • CX1 • R (plus , I⊗Z) • S1⁻¹ • H1 • S1⁻¹ • S0 • H0 • R (plus , Z⊗I) • CX0 • R (plus , Z⊗I) • S0⁻¹ • H0 • S0⁻¹ • R (plus , Z⊗I) • S0⁻¹ • H0 • S0 • H0 • R (plus , Z⊗I) • CX0 • R (plus , Z⊗I) • S0⁻¹ • H0 • S0⁻¹ • R (plus , Y⊗I) • R (plus , Y⊗Z) • R (plus , Z⊗I) • R (plus , Y⊗I) • R (plus , Y⊗Z) • R (plus , X⊗Z) • R (plus , Y⊗X) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Y⊗X) • R (plus , Z⊗Y) • R (plus , Z⊗X) • CZ • H0 • H1 • CZ • H0 • S0 • S0 • H0 • H1 • S1 • S1 • H1 • W ^ 6 • ε
          by clifford-tactic 4 5 10000 auto
      equals R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (minus , Z⊗Y) • CZ • S1 • S1 • W⁻¹ • S1 • H1 • CX1 • R (plus , I⊗Z) • S1⁻¹ • H1 • S1⁻¹ • S0 • H0 • R (plus , Z⊗I) • CX0 • R (plus , Z⊗I) • H0 • S0 • W⁻¹ • R (plus , Z⊗I) • S0 • H0 • R (plus , Z⊗I) • CX0 • R (plus , Z⊗I) • S0⁻¹ • H0 • S0⁻¹ • S1 • H1 • R (plus , I⊗Z) • CX1 • R (plus , I⊗Z) • S1⁻¹ • H1 • S1⁻¹ • R (plus , I⊗Z) • S1⁻¹ • H1 • S1 • H1 • R (plus , I⊗Z) • CX1 • R (plus , I⊗Z) • S1⁻¹ • H1 • S1⁻¹ • S0 • H0 • R (plus , Z⊗I) • CX0 • R (plus , Z⊗I) • S0⁻¹ • H0 • S0⁻¹ • R (plus , Z⊗I) • S0⁻¹ • H0 • S0 • H0 • R (plus , Z⊗I) • CX0 • R (plus , Z⊗I) • S0⁻¹ • H0 • S0⁻¹ • R (plus , Y⊗I) • R (plus , Y⊗Z) • R (plus , Z⊗I) • R (plus , Y⊗I) • R (plus , Y⊗Z) • R (plus , X⊗Z) • R (plus , Y⊗X) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Y⊗X) • R (plus , Z⊗Y) • R (plus , Z⊗X) • CZ • H0 • H1 • CZ • H0 • S0 • S0 • H0 • H1 • S1 • S1 • H1 • W ^ 6 • ε
          by in-context 3 7 auto (symm (lemma-R (C.CZ • C.S1 • C.S1 • C.W⁻¹ • C.S1 • C.H1) (plus , I⊗Z)))
      equals R (plus , I⊗Y) • R (plus , Z⊗Y) • R (plus , I⊗Z) • CZ • S1 • S1 • W⁻¹ • S1 • H1 • R (plus , I⊗Z) • CX1 • R (plus , I⊗Z) • S1⁻¹ • H1 • S1⁻¹ • S0 • H0 • R (plus , Z⊗I) • CX0 • R (plus , Z⊗I) • H0 • S0 • W⁻¹ • R (plus , Z⊗I) • S0 • H0 • R (plus , Z⊗I) • CX0 • R (plus , Z⊗I) • S0⁻¹ • H0 • S0⁻¹ • S1 • H1 • R (plus , I⊗Z) • CX1 • R (plus , I⊗Z) • S1⁻¹ • H1 • S1⁻¹ • R (plus , I⊗Z) • S1⁻¹ • H1 • S1 • H1 • R (plus , I⊗Z) • CX1 • R (plus , I⊗Z) • S1⁻¹ • H1 • S1⁻¹ • S0 • H0 • R (plus , Z⊗I) • CX0 • R (plus , Z⊗I) • S0⁻¹ • H0 • S0⁻¹ • R (plus , Z⊗I) • S0⁻¹ • H0 • S0 • H0 • R (plus , Z⊗I) • CX0 • R (plus , Z⊗I) • S0⁻¹ • H0 • S0⁻¹ • R (plus , Y⊗I) • R (plus , Y⊗Z) • R (plus , Z⊗I) • R (plus , Y⊗I) • R (plus , Y⊗Z) • R (plus , X⊗Z) • R (plus , Y⊗X) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Y⊗X) • R (plus , Z⊗Y) • R (plus , Z⊗X) • CZ • H0 • H1 • CZ • H0 • S0 • S0 • H0 • H1 • S1 • S1 • H1 • W ^ 6 • ε
          by in-context 2 5 auto (symm (lemma-R (C.CZ • C.S1 • C.S1 • C.W⁻¹) (plus , I⊗Z)))
      equals R (plus , I⊗Y) • R (plus , Z⊗Y) • CZ • S1 • S1 • W⁻¹ • R (plus , I⊗Z) • S1 • H1 • R (plus , I⊗Z) • CX1 • R (plus , I⊗Z) • S1⁻¹ • H1 • S1⁻¹ • S0 • H0 • R (plus , Z⊗I) • CX0 • R (plus , Z⊗I) • H0 • S0 • W⁻¹ • R (plus , Z⊗I) • S0 • H0 • R (plus , Z⊗I) • CX0 • R (plus , Z⊗I) • S0⁻¹ • H0 • S0⁻¹ • S1 • H1 • R (plus , I⊗Z) • CX1 • R (plus , I⊗Z) • S1⁻¹ • H1 • S1⁻¹ • R (plus , I⊗Z) • S1⁻¹ • H1 • S1 • H1 • R (plus , I⊗Z) • CX1 • R (plus , I⊗Z) • S1⁻¹ • H1 • S1⁻¹ • S0 • H0 • R (plus , Z⊗I) • CX0 • R (plus , Z⊗I) • S0⁻¹ • H0 • S0⁻¹ • R (plus , Z⊗I) • S0⁻¹ • H0 • S0 • H0 • R (plus , Z⊗I) • CX0 • R (plus , Z⊗I) • S0⁻¹ • H0 • S0⁻¹ • R (plus , Y⊗I) • R (plus , Y⊗Z) • R (plus , Z⊗I) • R (plus , Y⊗I) • R (plus , Y⊗Z) • R (plus , X⊗Z) • R (plus , Y⊗X) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Y⊗X) • R (plus , Z⊗Y) • R (plus , Z⊗X) • CZ • H0 • H1 • CZ • H0 • S0 • S0 • H0 • H1 • S1 • S1 • H1 • W ^ 6 • ε
          by clifford-tactic 2 2 10000 auto
      equals R (plus , I⊗Y) • R (plus , Z⊗Y) • S1 • H1 • CX1 • H1 • S1 • W⁻¹ • R (plus , I⊗Z) • S1 • H1 • R (plus , I⊗Z) • CX1 • R (plus , I⊗Z) • S1⁻¹ • H1 • S1⁻¹ • S0 • H0 • R (plus , Z⊗I) • CX0 • R (plus , Z⊗I) • H0 • S0 • W⁻¹ • R (plus , Z⊗I) • S0 • H0 • R (plus , Z⊗I) • CX0 • R (plus , Z⊗I) • S0⁻¹ • H0 • S0⁻¹ • S1 • H1 • R (plus , I⊗Z) • CX1 • R (plus , I⊗Z) • S1⁻¹ • H1 • S1⁻¹ • R (plus , I⊗Z) • S1⁻¹ • H1 • S1 • H1 • R (plus , I⊗Z) • CX1 • R (plus , I⊗Z) • S1⁻¹ • H1 • S1⁻¹ • S0 • H0 • R (plus , Z⊗I) • CX0 • R (plus , Z⊗I) • S0⁻¹ • H0 • S0⁻¹ • R (plus , Z⊗I) • S0⁻¹ • H0 • S0 • H0 • R (plus , Z⊗I) • CX0 • R (plus , Z⊗I) • S0⁻¹ • H0 • S0⁻¹ • R (plus , Y⊗I) • R (plus , Y⊗Z) • R (plus , Z⊗I) • R (plus , Y⊗I) • R (plus , Y⊗Z) • R (plus , X⊗Z) • R (plus , Y⊗X) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Y⊗X) • R (plus , Z⊗Y) • R (plus , Z⊗X) • CZ • H0 • H1 • CZ • H0 • S0 • S0 • H0 • H1 • S1 • S1 • H1 • W ^ 6 • ε
          by in-context 1 4 auto (symm (lemma-R (C.S1 • C.H1 • C.CX1) (plus , I⊗Z)))
      equals R (plus , I⊗Y) • S1 • H1 • CX1 • R (plus , I⊗Z) • H1 • S1 • W⁻¹ • R (plus , I⊗Z) • S1 • H1 • R (plus , I⊗Z) • CX1 • R (plus , I⊗Z) • S1⁻¹ • H1 • S1⁻¹ • S0 • H0 • R (plus , Z⊗I) • CX0 • R (plus , Z⊗I) • H0 • S0 • W⁻¹ • R (plus , Z⊗I) • S0 • H0 • R (plus , Z⊗I) • CX0 • R (plus , Z⊗I) • S0⁻¹ • H0 • S0⁻¹ • S1 • H1 • R (plus , I⊗Z) • CX1 • R (plus , I⊗Z) • S1⁻¹ • H1 • S1⁻¹ • R (plus , I⊗Z) • S1⁻¹ • H1 • S1 • H1 • R (plus , I⊗Z) • CX1 • R (plus , I⊗Z) • S1⁻¹ • H1 • S1⁻¹ • S0 • H0 • R (plus , Z⊗I) • CX0 • R (plus , Z⊗I) • S0⁻¹ • H0 • S0⁻¹ • R (plus , Z⊗I) • S0⁻¹ • H0 • S0 • H0 • R (plus , Z⊗I) • CX0 • R (plus , Z⊗I) • S0⁻¹ • H0 • S0⁻¹ • R (plus , Y⊗I) • R (plus , Y⊗Z) • R (plus , Z⊗I) • R (plus , Y⊗I) • R (plus , Y⊗Z) • R (plus , X⊗Z) • R (plus , Y⊗X) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Y⊗X) • R (plus , Z⊗Y) • R (plus , Z⊗X) • CZ • H0 • H1 • CZ • H0 • S0 • S0 • H0 • H1 • S1 • S1 • H1 • W ^ 6 • ε
          by in-context 0 3 auto (symm (lemma-R (C.S1 • C.H1) (plus , I⊗Z)))
      equals S1 • H1 • R (plus , I⊗Z) • CX1 • R (plus , I⊗Z) • H1 • S1 • W⁻¹ • R (plus , I⊗Z) • S1 • H1 • R (plus , I⊗Z) • CX1 • R (plus , I⊗Z) • S1⁻¹ • H1 • S1⁻¹ • S0 • H0 • R (plus , Z⊗I) • CX0 • R (plus , Z⊗I) • H0 • S0 • W⁻¹ • R (plus , Z⊗I) • S0 • H0 • R (plus , Z⊗I) • CX0 • R (plus , Z⊗I) • S0⁻¹ • H0 • S0⁻¹ • S1 • H1 • R (plus , I⊗Z) • CX1 • R (plus , I⊗Z) • S1⁻¹ • H1 • S1⁻¹ • R (plus , I⊗Z) • S1⁻¹ • H1 • S1 • H1 • R (plus , I⊗Z) • CX1 • R (plus , I⊗Z) • S1⁻¹ • H1 • S1⁻¹ • S0 • H0 • R (plus , Z⊗I) • CX0 • R (plus , Z⊗I) • S0⁻¹ • H0 • S0⁻¹ • R (plus , Z⊗I) • S0⁻¹ • H0 • S0 • H0 • R (plus , Z⊗I) • CX0 • R (plus , Z⊗I) • S0⁻¹ • H0 • S0⁻¹ • R (plus , Y⊗I) • R (plus , Y⊗Z) • R (plus , Z⊗I) • R (plus , Y⊗I) • R (plus , Y⊗Z) • R (plus , X⊗Z) • R (plus , Y⊗X) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Y⊗X) • R (plus , Z⊗Y) • R (plus , Z⊗X) • CZ • H0 • H1 • CZ • H0 • S0 • S0 • H0 • H1 • S1 • S1 • H1 • W ^ 6 • ε
          by clifford-tactic 22 3 10000 auto
      equals S1 • H1 • R (plus , I⊗Z) • CX1 • R (plus , I⊗Z) • H1 • S1 • W⁻¹ • R (plus , I⊗Z) • S1 • H1 • R (plus , I⊗Z) • CX1 • R (plus , I⊗Z) • S1⁻¹ • H1 • S1⁻¹ • S0 • H0 • R (plus , Z⊗I) • CX0 • R (plus , Z⊗I) • S0⁻¹ • H0 • S0⁻¹ • H0 • R (plus , Z⊗I) • S0 • H0 • R (plus , Z⊗I) • CX0 • R (plus , Z⊗I) • S0⁻¹ • H0 • S0⁻¹ • S1 • H1 • R (plus , I⊗Z) • CX1 • R (plus , I⊗Z) • S1⁻¹ • H1 • S1⁻¹ • R (plus , I⊗Z) • S1⁻¹ • H1 • S1 • H1 • R (plus , I⊗Z) • CX1 • R (plus , I⊗Z) • S1⁻¹ • H1 • S1⁻¹ • S0 • H0 • R (plus , Z⊗I) • CX0 • R (plus , Z⊗I) • S0⁻¹ • H0 • S0⁻¹ • R (plus , Z⊗I) • S0⁻¹ • H0 • S0 • H0 • R (plus , Z⊗I) • CX0 • R (plus , Z⊗I) • S0⁻¹ • H0 • S0⁻¹ • R (plus , Y⊗I) • R (plus , Y⊗Z) • R (plus , Z⊗I) • R (plus , Y⊗I) • R (plus , Y⊗Z) • R (plus , X⊗Z) • R (plus , Y⊗X) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Y⊗X) • R (plus , Z⊗Y) • R (plus , Z⊗X) • CZ • H0 • H1 • CZ • H0 • S0 • S0 • H0 • H1 • S1 • S1 • H1 • W ^ 6 • ε
          by clifford-tactic 5 3 10000 auto
      equals S1 • H1 • R (plus , I⊗Z) • CX1 • R (plus , I⊗Z) • S1⁻¹ • H1 • S1⁻¹ • H1 • R (plus , I⊗Z) • S1 • H1 • R (plus , I⊗Z) • CX1 • R (plus , I⊗Z) • S1⁻¹ • H1 • S1⁻¹ • S0 • H0 • R (plus , Z⊗I) • CX0 • R (plus , Z⊗I) • S0⁻¹ • H0 • S0⁻¹ • H0 • R (plus , Z⊗I) • S0 • H0 • R (plus , Z⊗I) • CX0 • R (plus , Z⊗I) • S0⁻¹ • H0 • S0⁻¹ • S1 • H1 • R (plus , I⊗Z) • CX1 • R (plus , I⊗Z) • S1⁻¹ • H1 • S1⁻¹ • R (plus , I⊗Z) • S1⁻¹ • H1 • S1 • H1 • R (plus , I⊗Z) • CX1 • R (plus , I⊗Z) • S1⁻¹ • H1 • S1⁻¹ • S0 • H0 • R (plus , Z⊗I) • CX0 • R (plus , Z⊗I) • S0⁻¹ • H0 • S0⁻¹ • R (plus , Z⊗I) • S0⁻¹ • H0 • S0 • H0 • R (plus , Z⊗I) • CX0 • R (plus , Z⊗I) • S0⁻¹ • H0 • S0⁻¹ • R (plus , Y⊗I) • R (plus , Y⊗Z) • R (plus , Z⊗I) • R (plus , Y⊗I) • R (plus , Y⊗Z) • R (plus , X⊗Z) • R (plus , Y⊗X) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Y⊗X) • R (plus , Z⊗Y) • R (plus , Z⊗X) • CZ • H0 • H1 • CZ • H0 • S0 • S0 • H0 • H1 • S1 • S1 • H1 • W ^ 6 • ε
          by in-context 70 2 auto (symm lemma-R-T0⁻¹)
      equals S1 • H1 • R (plus , I⊗Z) • CX1 • R (plus , I⊗Z) • S1⁻¹ • H1 • S1⁻¹ • H1 • R (plus , I⊗Z) • S1 • H1 • R (plus , I⊗Z) • CX1 • R (plus , I⊗Z) • S1⁻¹ • H1 • S1⁻¹ • S0 • H0 • R (plus , Z⊗I) • CX0 • R (plus , Z⊗I) • S0⁻¹ • H0 • S0⁻¹ • H0 • R (plus , Z⊗I) • S0 • H0 • R (plus , Z⊗I) • CX0 • R (plus , Z⊗I) • S0⁻¹ • H0 • S0⁻¹ • S1 • H1 • R (plus , I⊗Z) • CX1 • R (plus , I⊗Z) • S1⁻¹ • H1 • S1⁻¹ • R (plus , I⊗Z) • S1⁻¹ • H1 • S1 • H1 • R (plus , I⊗Z) • CX1 • R (plus , I⊗Z) • S1⁻¹ • H1 • S1⁻¹ • S0 • H0 • R (plus , Z⊗I) • CX0 • R (plus , Z⊗I) • S0⁻¹ • H0 • S0⁻¹ • R (plus , Z⊗I) • S0⁻¹ • H0 • S0 • H0 • R (plus , Z⊗I) • CX0 • T0⁻¹ • H0 • S0⁻¹ • R (plus , Y⊗I) • R (plus , Y⊗Z) • R (plus , Z⊗I) • R (plus , Y⊗I) • R (plus , Y⊗Z) • R (plus , X⊗Z) • R (plus , Y⊗X) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Y⊗X) • R (plus , Z⊗Y) • R (plus , Z⊗X) • CZ • H0 • H1 • CZ • H0 • S0 • S0 • H0 • H1 • S1 • S1 • H1 • W ^ 6 • ε
          by general-assoc auto
      equals S1 • H1 • R (plus , I⊗Z) • CX1 • R (plus , I⊗Z) • S1⁻¹ • H1 • S1⁻¹ • H1 • R (plus , I⊗Z) • S1 • H1 • R (plus , I⊗Z) • CX1 • R (plus , I⊗Z) • S1⁻¹ • H1 • S1⁻¹ • S0 • H0 • R (plus , Z⊗I) • CX0 • R (plus , Z⊗I) • S0⁻¹ • H0 • S0⁻¹ • H0 • R (plus , Z⊗I) • S0 • H0 • R (plus , Z⊗I) • CX0 • R (plus , Z⊗I) • S0⁻¹ • H0 • S0⁻¹ • S1 • H1 • R (plus , I⊗Z) • CX1 • R (plus , I⊗Z) • S1⁻¹ • H1 • S1⁻¹ • R (plus , I⊗Z) • S1⁻¹ • H1 • S1 • H1 • R (plus , I⊗Z) • CX1 • R (plus , I⊗Z) • S1⁻¹ • H1 • S1⁻¹ • S0 • H0 • R (plus , Z⊗I) • CX0 • R (plus , Z⊗I) • S0⁻¹ • H0 • S0⁻¹ • R (plus , Z⊗I) • S0⁻¹ • H0 • CH0 • R (plus , Y⊗I) • R (plus , Y⊗Z) • R (plus , Z⊗I) • R (plus , Y⊗I) • R (plus , Y⊗Z) • R (plus , X⊗Z) • R (plus , Y⊗X) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Y⊗X) • R (plus , Z⊗Y) • R (plus , Z⊗X) • CZ • H0 • H1 • CZ • H0 • S0 • S0 • H0 • H1 • S1 • S1 • H1 • W ^ 6 • ε
          by in-context 63 2 auto (symm lemma-R-T0⁻¹)
      equals S1 • H1 • R (plus , I⊗Z) • CX1 • R (plus , I⊗Z) • S1⁻¹ • H1 • S1⁻¹ • H1 • R (plus , I⊗Z) • S1 • H1 • R (plus , I⊗Z) • CX1 • R (plus , I⊗Z) • S1⁻¹ • H1 • S1⁻¹ • S0 • H0 • R (plus , Z⊗I) • CX0 • R (plus , Z⊗I) • S0⁻¹ • H0 • S0⁻¹ • H0 • R (plus , Z⊗I) • S0 • H0 • R (plus , Z⊗I) • CX0 • R (plus , Z⊗I) • S0⁻¹ • H0 • S0⁻¹ • S1 • H1 • R (plus , I⊗Z) • CX1 • R (plus , I⊗Z) • S1⁻¹ • H1 • S1⁻¹ • R (plus , I⊗Z) • S1⁻¹ • H1 • S1 • H1 • R (plus , I⊗Z) • CX1 • R (plus , I⊗Z) • S1⁻¹ • H1 • S1⁻¹ • S0 • H0 • R (plus , Z⊗I) • CX0 • R (plus , Z⊗I) • S0⁻¹ • H0 • S0⁻¹ • T0⁻¹ • H0 • CH0 • R (plus , Y⊗I) • R (plus , Y⊗Z) • R (plus , Z⊗I) • R (plus , Y⊗I) • R (plus , Y⊗Z) • R (plus , X⊗Z) • R (plus , Y⊗X) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Y⊗X) • R (plus , Z⊗Y) • R (plus , Z⊗X) • CZ • H0 • H1 • CZ • H0 • S0 • S0 • H0 • H1 • S1 • S1 • H1 • W ^ 6 • ε
          by in-context 59 2 auto (symm lemma-R-T0⁻¹)
      equals S1 • H1 • R (plus , I⊗Z) • CX1 • R (plus , I⊗Z) • S1⁻¹ • H1 • S1⁻¹ • H1 • R (plus , I⊗Z) • S1 • H1 • R (plus , I⊗Z) • CX1 • R (plus , I⊗Z) • S1⁻¹ • H1 • S1⁻¹ • S0 • H0 • R (plus , Z⊗I) • CX0 • R (plus , Z⊗I) • S0⁻¹ • H0 • S0⁻¹ • H0 • R (plus , Z⊗I) • S0 • H0 • R (plus , Z⊗I) • CX0 • R (plus , Z⊗I) • S0⁻¹ • H0 • S0⁻¹ • S1 • H1 • R (plus , I⊗Z) • CX1 • R (plus , I⊗Z) • S1⁻¹ • H1 • S1⁻¹ • R (plus , I⊗Z) • S1⁻¹ • H1 • S1 • H1 • R (plus , I⊗Z) • CX1 • R (plus , I⊗Z) • S1⁻¹ • H1 • S1⁻¹ • S0 • H0 • R (plus , Z⊗I) • CX0 • T0⁻¹ • H0 • S0⁻¹ • T0⁻¹ • H0 • CH0 • R (plus , Y⊗I) • R (plus , Y⊗Z) • R (plus , Z⊗I) • R (plus , Y⊗I) • R (plus , Y⊗Z) • R (plus , X⊗Z) • R (plus , Y⊗X) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Y⊗X) • R (plus , Z⊗Y) • R (plus , Z⊗X) • CZ • H0 • H1 • CZ • H0 • S0 • S0 • H0 • H1 • S1 • S1 • H1 • W ^ 6 • ε
          by general-assoc auto
      equals S1 • H1 • R (plus , I⊗Z) • CX1 • R (plus , I⊗Z) • S1⁻¹ • H1 • S1⁻¹ • H1 • R (plus , I⊗Z) • S1 • H1 • R (plus , I⊗Z) • CX1 • R (plus , I⊗Z) • S1⁻¹ • H1 • S1⁻¹ • S0 • H0 • R (plus , Z⊗I) • CX0 • R (plus , Z⊗I) • S0⁻¹ • H0 • S0⁻¹ • H0 • R (plus , Z⊗I) • S0 • H0 • R (plus , Z⊗I) • CX0 • R (plus , Z⊗I) • S0⁻¹ • H0 • S0⁻¹ • S1 • H1 • R (plus , I⊗Z) • CX1 • R (plus , I⊗Z) • S1⁻¹ • H1 • S1⁻¹ • R (plus , I⊗Z) • S1⁻¹ • H1 • S1 • H1 • R (plus , I⊗Z) • CX1 • R (plus , I⊗Z) • S1⁻¹ • H1 • S1⁻¹ • CH0 • T0⁻¹ • H0 • CH0 • R (plus , Y⊗I) • R (plus , Y⊗Z) • R (plus , Z⊗I) • R (plus , Y⊗I) • R (plus , Y⊗Z) • R (plus , X⊗Z) • R (plus , Y⊗X) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Y⊗X) • R (plus , Z⊗Y) • R (plus , Z⊗X) • CZ • H0 • H1 • CZ • H0 • S0 • S0 • H0 • H1 • S1 • S1 • H1 • W ^ 6 • ε
          by in-context 51 2 auto (symm lemma-R-T1⁻¹)
      equals S1 • H1 • R (plus , I⊗Z) • CX1 • R (plus , I⊗Z) • S1⁻¹ • H1 • S1⁻¹ • H1 • R (plus , I⊗Z) • S1 • H1 • R (plus , I⊗Z) • CX1 • R (plus , I⊗Z) • S1⁻¹ • H1 • S1⁻¹ • S0 • H0 • R (plus , Z⊗I) • CX0 • R (plus , Z⊗I) • S0⁻¹ • H0 • S0⁻¹ • H0 • R (plus , Z⊗I) • S0 • H0 • R (plus , Z⊗I) • CX0 • R (plus , Z⊗I) • S0⁻¹ • H0 • S0⁻¹ • S1 • H1 • R (plus , I⊗Z) • CX1 • R (plus , I⊗Z) • S1⁻¹ • H1 • S1⁻¹ • R (plus , I⊗Z) • S1⁻¹ • H1 • S1 • H1 • R (plus , I⊗Z) • CX1 • T1⁻¹ • H1 • S1⁻¹ • CH0 • T0⁻¹ • H0 • CH0 • R (plus , Y⊗I) • R (plus , Y⊗Z) • R (plus , Z⊗I) • R (plus , Y⊗I) • R (plus , Y⊗Z) • R (plus , X⊗Z) • R (plus , Y⊗X) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Y⊗X) • R (plus , Z⊗Y) • R (plus , Z⊗X) • CZ • H0 • H1 • CZ • H0 • S0 • S0 • H0 • H1 • S1 • S1 • H1 • W ^ 6 • ε
          by in-context 49 1 auto (symm lemma-R-T1)
      equals S1 • H1 • R (plus , I⊗Z) • CX1 • R (plus , I⊗Z) • S1⁻¹ • H1 • S1⁻¹ • H1 • R (plus , I⊗Z) • S1 • H1 • R (plus , I⊗Z) • CX1 • R (plus , I⊗Z) • S1⁻¹ • H1 • S1⁻¹ • S0 • H0 • R (plus , Z⊗I) • CX0 • R (plus , Z⊗I) • S0⁻¹ • H0 • S0⁻¹ • H0 • R (plus , Z⊗I) • S0 • H0 • R (plus , Z⊗I) • CX0 • R (plus , Z⊗I) • S0⁻¹ • H0 • S0⁻¹ • S1 • H1 • R (plus , I⊗Z) • CX1 • R (plus , I⊗Z) • S1⁻¹ • H1 • S1⁻¹ • R (plus , I⊗Z) • S1⁻¹ • H1 • S1 • H1 • T1 • CX1 • T1⁻¹ • H1 • S1⁻¹ • CH0 • T0⁻¹ • H0 • CH0 • R (plus , Y⊗I) • R (plus , Y⊗Z) • R (plus , Z⊗I) • R (plus , Y⊗I) • R (plus , Y⊗Z) • R (plus , X⊗Z) • R (plus , Y⊗X) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Y⊗X) • R (plus , Z⊗Y) • R (plus , Z⊗X) • CZ • H0 • H1 • CZ • H0 • S0 • S0 • H0 • H1 • S1 • S1 • H1 • W ^ 6 • ε
          by general-assoc auto
      equals S1 • H1 • R (plus , I⊗Z) • CX1 • R (plus , I⊗Z) • S1⁻¹ • H1 • S1⁻¹ • H1 • R (plus , I⊗Z) • S1 • H1 • R (plus , I⊗Z) • CX1 • R (plus , I⊗Z) • S1⁻¹ • H1 • S1⁻¹ • S0 • H0 • R (plus , Z⊗I) • CX0 • R (plus , Z⊗I) • S0⁻¹ • H0 • S0⁻¹ • H0 • R (plus , Z⊗I) • S0 • H0 • R (plus , Z⊗I) • CX0 • R (plus , Z⊗I) • S0⁻¹ • H0 • S0⁻¹ • S1 • H1 • R (plus , I⊗Z) • CX1 • R (plus , I⊗Z) • S1⁻¹ • H1 • S1⁻¹ • R (plus , I⊗Z) • S1⁻¹ • H1 • CH1 • CH0 • T0⁻¹ • H0 • CH0 • R (plus , Y⊗I) • R (plus , Y⊗Z) • R (plus , Z⊗I) • R (plus , Y⊗I) • R (plus , Y⊗Z) • R (plus , X⊗Z) • R (plus , Y⊗X) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Y⊗X) • R (plus , Z⊗Y) • R (plus , Z⊗X) • CZ • H0 • H1 • CZ • H0 • S0 • S0 • H0 • H1 • S1 • S1 • H1 • W ^ 6 • ε
          by in-context 44 2 auto (symm lemma-R-T1⁻¹)
      equals S1 • H1 • R (plus , I⊗Z) • CX1 • R (plus , I⊗Z) • S1⁻¹ • H1 • S1⁻¹ • H1 • R (plus , I⊗Z) • S1 • H1 • R (plus , I⊗Z) • CX1 • R (plus , I⊗Z) • S1⁻¹ • H1 • S1⁻¹ • S0 • H0 • R (plus , Z⊗I) • CX0 • R (plus , Z⊗I) • S0⁻¹ • H0 • S0⁻¹ • H0 • R (plus , Z⊗I) • S0 • H0 • R (plus , Z⊗I) • CX0 • R (plus , Z⊗I) • S0⁻¹ • H0 • S0⁻¹ • S1 • H1 • R (plus , I⊗Z) • CX1 • R (plus , I⊗Z) • S1⁻¹ • H1 • S1⁻¹ • T1⁻¹ • H1 • CH1 • CH0 • T0⁻¹ • H0 • CH0 • R (plus , Y⊗I) • R (plus , Y⊗Z) • R (plus , Z⊗I) • R (plus , Y⊗I) • R (plus , Y⊗Z) • R (plus , X⊗Z) • R (plus , Y⊗X) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Y⊗X) • R (plus , Z⊗Y) • R (plus , Z⊗X) • CZ • H0 • H1 • CZ • H0 • S0 • S0 • H0 • H1 • S1 • S1 • H1 • W ^ 6 • ε
          by in-context 40 2 auto (symm lemma-R-T1⁻¹)
      equals S1 • H1 • R (plus , I⊗Z) • CX1 • R (plus , I⊗Z) • S1⁻¹ • H1 • S1⁻¹ • H1 • R (plus , I⊗Z) • S1 • H1 • R (plus , I⊗Z) • CX1 • R (plus , I⊗Z) • S1⁻¹ • H1 • S1⁻¹ • S0 • H0 • R (plus , Z⊗I) • CX0 • R (plus , Z⊗I) • S0⁻¹ • H0 • S0⁻¹ • H0 • R (plus , Z⊗I) • S0 • H0 • R (plus , Z⊗I) • CX0 • R (plus , Z⊗I) • S0⁻¹ • H0 • S0⁻¹ • S1 • H1 • R (plus , I⊗Z) • CX1 • T1⁻¹ • H1 • S1⁻¹ • T1⁻¹ • H1 • CH1 • CH0 • T0⁻¹ • H0 • CH0 • R (plus , Y⊗I) • R (plus , Y⊗Z) • R (plus , Z⊗I) • R (plus , Y⊗I) • R (plus , Y⊗Z) • R (plus , X⊗Z) • R (plus , Y⊗X) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Y⊗X) • R (plus , Z⊗Y) • R (plus , Z⊗X) • CZ • H0 • H1 • CZ • H0 • S0 • S0 • H0 • H1 • S1 • S1 • H1 • W ^ 6 • ε
          by in-context 38 1 auto (symm lemma-R-T1)
      equals S1 • H1 • R (plus , I⊗Z) • CX1 • R (plus , I⊗Z) • S1⁻¹ • H1 • S1⁻¹ • H1 • R (plus , I⊗Z) • S1 • H1 • R (plus , I⊗Z) • CX1 • R (plus , I⊗Z) • S1⁻¹ • H1 • S1⁻¹ • S0 • H0 • R (plus , Z⊗I) • CX0 • R (plus , Z⊗I) • S0⁻¹ • H0 • S0⁻¹ • H0 • R (plus , Z⊗I) • S0 • H0 • R (plus , Z⊗I) • CX0 • R (plus , Z⊗I) • S0⁻¹ • H0 • S0⁻¹ • S1 • H1 • T1 • CX1 • T1⁻¹ • H1 • S1⁻¹ • T1⁻¹ • H1 • CH1 • CH0 • T0⁻¹ • H0 • CH0 • R (plus , Y⊗I) • R (plus , Y⊗Z) • R (plus , Z⊗I) • R (plus , Y⊗I) • R (plus , Y⊗Z) • R (plus , X⊗Z) • R (plus , Y⊗X) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Y⊗X) • R (plus , Z⊗Y) • R (plus , Z⊗X) • CZ • H0 • H1 • CZ • H0 • S0 • S0 • H0 • H1 • S1 • S1 • H1 • W ^ 6 • ε
          by general-assoc auto
      equals S1 • H1 • R (plus , I⊗Z) • CX1 • R (plus , I⊗Z) • S1⁻¹ • H1 • S1⁻¹ • H1 • R (plus , I⊗Z) • S1 • H1 • R (plus , I⊗Z) • CX1 • R (plus , I⊗Z) • S1⁻¹ • H1 • S1⁻¹ • S0 • H0 • R (plus , Z⊗I) • CX0 • R (plus , Z⊗I) • S0⁻¹ • H0 • S0⁻¹ • H0 • R (plus , Z⊗I) • S0 • H0 • R (plus , Z⊗I) • CX0 • R (plus , Z⊗I) • S0⁻¹ • H0 • S0⁻¹ • CH1 • T1⁻¹ • H1 • CH1 • CH0 • T0⁻¹ • H0 • CH0 • R (plus , Y⊗I) • R (plus , Y⊗Z) • R (plus , Z⊗I) • R (plus , Y⊗I) • R (plus , Y⊗Z) • R (plus , X⊗Z) • R (plus , Y⊗X) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Y⊗X) • R (plus , Z⊗Y) • R (plus , Z⊗X) • CZ • H0 • H1 • CZ • H0 • S0 • S0 • H0 • H1 • S1 • S1 • H1 • W ^ 6 • ε
          by in-context 32 2 auto (symm lemma-R-T0⁻¹)
      equals S1 • H1 • R (plus , I⊗Z) • CX1 • R (plus , I⊗Z) • S1⁻¹ • H1 • S1⁻¹ • H1 • R (plus , I⊗Z) • S1 • H1 • R (plus , I⊗Z) • CX1 • R (plus , I⊗Z) • S1⁻¹ • H1 • S1⁻¹ • S0 • H0 • R (plus , Z⊗I) • CX0 • R (plus , Z⊗I) • S0⁻¹ • H0 • S0⁻¹ • H0 • R (plus , Z⊗I) • S0 • H0 • R (plus , Z⊗I) • CX0 • T0⁻¹ • H0 • S0⁻¹ • CH1 • T1⁻¹ • H1 • CH1 • CH0 • T0⁻¹ • H0 • CH0 • R (plus , Y⊗I) • R (plus , Y⊗Z) • R (plus , Z⊗I) • R (plus , Y⊗I) • R (plus , Y⊗Z) • R (plus , X⊗Z) • R (plus , Y⊗X) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Y⊗X) • R (plus , Z⊗Y) • R (plus , Z⊗X) • CZ • H0 • H1 • CZ • H0 • S0 • S0 • H0 • H1 • S1 • S1 • H1 • W ^ 6 • ε
          by general-assoc auto
      equals S1 • H1 • R (plus , I⊗Z) • CX1 • R (plus , I⊗Z) • S1⁻¹ • H1 • S1⁻¹ • H1 • R (plus , I⊗Z) • S1 • H1 • R (plus , I⊗Z) • CX1 • R (plus , I⊗Z) • S1⁻¹ • H1 • S1⁻¹ • S0 • H0 • R (plus , Z⊗I) • CX0 • R (plus , Z⊗I) • S0⁻¹ • H0 • S0⁻¹ • H0 • T0 • CH0 • CH1 • T1⁻¹ • H1 • CH1 • CH0 • T0⁻¹ • H0 • CH0 • R (plus , Y⊗I) • R (plus , Y⊗Z) • R (plus , Z⊗I) • R (plus , Y⊗I) • R (plus , Y⊗Z) • R (plus , X⊗Z) • R (plus , Y⊗X) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Y⊗X) • R (plus , Z⊗Y) • R (plus , Z⊗X) • CZ • H0 • H1 • CZ • H0 • S0 • S0 • H0 • H1 • S1 • S1 • H1 • W ^ 6 • ε
          by in-context 22 2 auto (symm lemma-R-T0⁻¹)
      equals S1 • H1 • R (plus , I⊗Z) • CX1 • R (plus , I⊗Z) • S1⁻¹ • H1 • S1⁻¹ • H1 • R (plus , I⊗Z) • S1 • H1 • R (plus , I⊗Z) • CX1 • R (plus , I⊗Z) • S1⁻¹ • H1 • S1⁻¹ • S0 • H0 • R (plus , Z⊗I) • CX0 • T0⁻¹ • H0 • S0⁻¹ • H0 • T0 • CH0 • CH1 • T1⁻¹ • H1 • CH1 • CH0 • T0⁻¹ • H0 • CH0 • R (plus , Y⊗I) • R (plus , Y⊗Z) • R (plus , Z⊗I) • R (plus , Y⊗I) • R (plus , Y⊗Z) • R (plus , X⊗Z) • R (plus , Y⊗X) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Y⊗X) • R (plus , Z⊗Y) • R (plus , Z⊗X) • CZ • H0 • H1 • CZ • H0 • S0 • S0 • H0 • H1 • S1 • S1 • H1 • W ^ 6 • ε
          by general-assoc auto
      equals S1 • H1 • R (plus , I⊗Z) • CX1 • R (plus , I⊗Z) • S1⁻¹ • H1 • S1⁻¹ • H1 • R (plus , I⊗Z) • S1 • H1 • R (plus , I⊗Z) • CX1 • R (plus , I⊗Z) • S1⁻¹ • H1 • S1⁻¹ • CH0 • H0 • T0 • CH0 • CH1 • T1⁻¹ • H1 • CH1 • CH0 • T0⁻¹ • H0 • CH0 • R (plus , Y⊗I) • R (plus , Y⊗Z) • R (plus , Z⊗I) • R (plus , Y⊗I) • R (plus , Y⊗Z) • R (plus , X⊗Z) • R (plus , Y⊗X) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Y⊗X) • R (plus , Z⊗Y) • R (plus , Z⊗X) • CZ • H0 • H1 • CZ • H0 • S0 • S0 • H0 • H1 • S1 • S1 • H1 • W ^ 6 • ε
          by in-context 14 2 auto (symm lemma-R-T1⁻¹)
      equals S1 • H1 • R (plus , I⊗Z) • CX1 • R (plus , I⊗Z) • S1⁻¹ • H1 • S1⁻¹ • H1 • R (plus , I⊗Z) • S1 • H1 • R (plus , I⊗Z) • CX1 • T1⁻¹ • H1 • S1⁻¹ • CH0 • H0 • T0 • CH0 • CH1 • T1⁻¹ • H1 • CH1 • CH0 • T0⁻¹ • H0 • CH0 • R (plus , Y⊗I) • R (plus , Y⊗Z) • R (plus , Z⊗I) • R (plus , Y⊗I) • R (plus , Y⊗Z) • R (plus , X⊗Z) • R (plus , Y⊗X) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Y⊗X) • R (plus , Z⊗Y) • R (plus , Z⊗X) • CZ • H0 • H1 • CZ • H0 • S0 • S0 • H0 • H1 • S1 • S1 • H1 • W ^ 6 • ε
          by in-context 12 1 auto (symm lemma-R-T1)
      equals S1 • H1 • R (plus , I⊗Z) • CX1 • R (plus , I⊗Z) • S1⁻¹ • H1 • S1⁻¹ • H1 • R (plus , I⊗Z) • S1 • H1 • T1 • CX1 • T1⁻¹ • H1 • S1⁻¹ • CH0 • H0 • T0 • CH0 • CH1 • T1⁻¹ • H1 • CH1 • CH0 • T0⁻¹ • H0 • CH0 • R (plus , Y⊗I) • R (plus , Y⊗Z) • R (plus , Z⊗I) • R (plus , Y⊗I) • R (plus , Y⊗Z) • R (plus , X⊗Z) • R (plus , Y⊗X) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Y⊗X) • R (plus , Z⊗Y) • R (plus , Z⊗X) • CZ • H0 • H1 • CZ • H0 • S0 • S0 • H0 • H1 • S1 • S1 • H1 • W ^ 6 • ε
          by general-assoc auto
      equals S1 • H1 • R (plus , I⊗Z) • CX1 • R (plus , I⊗Z) • S1⁻¹ • H1 • S1⁻¹ • H1 • R (plus , I⊗Z) • CH1 • CH0 • H0 • T0 • CH0 • CH1 • T1⁻¹ • H1 • CH1 • CH0 • T0⁻¹ • H0 • CH0 • R (plus , Y⊗I) • R (plus , Y⊗Z) • R (plus , Z⊗I) • R (plus , Y⊗I) • R (plus , Y⊗Z) • R (plus , X⊗Z) • R (plus , Y⊗X) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Y⊗X) • R (plus , Z⊗Y) • R (plus , Z⊗X) • CZ • H0 • H1 • CZ • H0 • S0 • S0 • H0 • H1 • S1 • S1 • H1 • W ^ 6 • ε
          by in-context 9 1 auto (symm lemma-R-T1)
      equals S1 • H1 • R (plus , I⊗Z) • CX1 • R (plus , I⊗Z) • S1⁻¹ • H1 • S1⁻¹ • H1 • T1 • CH1 • CH0 • H0 • T0 • CH0 • CH1 • T1⁻¹ • H1 • CH1 • CH0 • T0⁻¹ • H0 • CH0 • R (plus , Y⊗I) • R (plus , Y⊗Z) • R (plus , Z⊗I) • R (plus , Y⊗I) • R (plus , Y⊗Z) • R (plus , X⊗Z) • R (plus , Y⊗X) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Y⊗X) • R (plus , Z⊗Y) • R (plus , Z⊗X) • CZ • H0 • H1 • CZ • H0 • S0 • S0 • H0 • H1 • S1 • S1 • H1 • W ^ 6 • ε
          by in-context 4 2 auto (symm lemma-R-T1⁻¹)
      equals S1 • H1 • R (plus , I⊗Z) • CX1 • T1⁻¹ • H1 • S1⁻¹ • H1 • T1 • CH1 • CH0 • H0 • T0 • CH0 • CH1 • T1⁻¹ • H1 • CH1 • CH0 • T0⁻¹ • H0 • CH0 • R (plus , Y⊗I) • R (plus , Y⊗Z) • R (plus , Z⊗I) • R (plus , Y⊗I) • R (plus , Y⊗Z) • R (plus , X⊗Z) • R (plus , Y⊗X) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Y⊗X) • R (plus , Z⊗Y) • R (plus , Z⊗X) • CZ • H0 • H1 • CZ • H0 • S0 • S0 • H0 • H1 • S1 • S1 • H1 • W ^ 6 • ε
          by in-context 2 1 auto (symm lemma-R-T1)
      equals S1 • H1 • T1 • CX1 • T1⁻¹ • H1 • S1⁻¹ • H1 • T1 • CH1 • CH0 • H0 • T0 • CH0 • CH1 • T1⁻¹ • H1 • CH1 • CH0 • T0⁻¹ • H0 • CH0 • R (plus , Y⊗I) • R (plus , Y⊗Z) • R (plus , Z⊗I) • R (plus , Y⊗I) • R (plus , Y⊗Z) • R (plus , X⊗Z) • R (plus , Y⊗X) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Y⊗X) • R (plus , Z⊗Y) • R (plus , Z⊗X) • CZ • H0 • H1 • CZ • H0 • S0 • S0 • H0 • H1 • S1 • S1 • H1 • W ^ 6 • ε
          by general-assoc auto
      equals CH1 • H1 • T1 • CH1 • CH0 • H0 • T0 • CH0 • CH1 • T1⁻¹ • H1 • CH1 • CH0 • T0⁻¹ • H0 • CH0 • R (plus , Y⊗I) • R (plus , Y⊗Z) • R (plus , Z⊗I) • R (plus , Y⊗I) • R (plus , Y⊗Z) • R (plus , X⊗Z) • R (plus , Y⊗X) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Y⊗X) • R (plus , Z⊗Y) • R (plus , Z⊗X) • CZ • H0 • H1 • CZ • H0 • S0 • S0 • H0 • H1 • S1 • S1 • H1 • W ^ 6 • ε
          by in-context 0 8 auto (axiom rel-C)
      equals CH0 • H0 • T0 • CH0 • CH1 • H1 • T1 • CH1 • CH1 • T1⁻¹ • H1 • CH1 • CH0 • T0⁻¹ • H0 • CH0 • R (plus , Y⊗I) • R (plus , Y⊗Z) • R (plus , Z⊗I) • R (plus , Y⊗I) • R (plus , Y⊗Z) • R (plus , X⊗Z) • R (plus , Y⊗X) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Y⊗X) • R (plus , Z⊗Y) • R (plus , Z⊗X) • CZ • H0 • H1 • CZ • H0 • S0 • S0 • H0 • H1 • S1 • S1 • H1 • W ^ 6 • ε
          by in-context 7 2 auto lemma-order-CH1
      equals CH0 • H0 • T0 • CH0 • CH1 • H1 • T1 • T1⁻¹ • H1 • CH1 • CH0 • T0⁻¹ • H0 • CH0 • R (plus , Y⊗I) • R (plus , Y⊗Z) • R (plus , Z⊗I) • R (plus , Y⊗I) • R (plus , Y⊗Z) • R (plus , X⊗Z) • R (plus , Y⊗X) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Y⊗X) • R (plus , Z⊗Y) • R (plus , Z⊗X) • CZ • H0 • H1 • CZ • H0 • S0 • S0 • H0 • H1 • S1 • S1 • H1 • W ^ 6 • ε
          by general-assoc auto
      equals CH0 • H0 • T0 • CH0 • CH1 • H1 • T1 • T1 • T1 • T1 • T1 • T1 • T1 • T1 • H1 • CH1 • CH0 • T0⁻¹ • H0 • CH0 • R (plus , Y⊗I) • R (plus , Y⊗Z) • R (plus , Z⊗I) • R (plus , Y⊗I) • R (plus , Y⊗Z) • R (plus , X⊗Z) • R (plus , Y⊗X) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Y⊗X) • R (plus , Z⊗Y) • R (plus , Z⊗X) • CZ • H0 • H1 • CZ • H0 • S0 • S0 • H0 • H1 • S1 • S1 • H1 • W ^ 6 • ε
          by in-context 6 8 auto lemma-order-T1
      equals CH0 • H0 • T0 • CH0 • CH1 • H1 • H1 • CH1 • CH0 • T0⁻¹ • H0 • CH0 • R (plus , Y⊗I) • R (plus , Y⊗Z) • R (plus , Z⊗I) • R (plus , Y⊗I) • R (plus , Y⊗Z) • R (plus , X⊗Z) • R (plus , Y⊗X) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Y⊗X) • R (plus , Z⊗Y) • R (plus , Z⊗X) • CZ • H0 • H1 • CZ • H0 • S0 • S0 • H0 • H1 • S1 • S1 • H1 • W ^ 6 • ε
          by clifford-tactic 5 2 10000 auto
      equals CH0 • H0 • T0 • CH0 • CH1 • CH1 • CH0 • T0⁻¹ • H0 • CH0 • R (plus , Y⊗I) • R (plus , Y⊗Z) • R (plus , Z⊗I) • R (plus , Y⊗I) • R (plus , Y⊗Z) • R (plus , X⊗Z) • R (plus , Y⊗X) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Y⊗X) • R (plus , Z⊗Y) • R (plus , Z⊗X) • CZ • H0 • H1 • CZ • H0 • S0 • S0 • H0 • H1 • S1 • S1 • H1 • W ^ 6 • ε
          by in-context 4 2 auto lemma-order-CH1
      equals CH0 • H0 • T0 • CH0 • CH0 • T0⁻¹ • H0 • CH0 • R (plus , Y⊗I) • R (plus , Y⊗Z) • R (plus , Z⊗I) • R (plus , Y⊗I) • R (plus , Y⊗Z) • R (plus , X⊗Z) • R (plus , Y⊗X) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Y⊗X) • R (plus , Z⊗Y) • R (plus , Z⊗X) • CZ • H0 • H1 • CZ • H0 • S0 • S0 • H0 • H1 • S1 • S1 • H1 • W ^ 6 • ε
          by in-context 3 2 auto lemma-order-CH0
      equals CH0 • H0 • T0 • T0⁻¹ • H0 • CH0 • R (plus , Y⊗I) • R (plus , Y⊗Z) • R (plus , Z⊗I) • R (plus , Y⊗I) • R (plus , Y⊗Z) • R (plus , X⊗Z) • R (plus , Y⊗X) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Y⊗X) • R (plus , Z⊗Y) • R (plus , Z⊗X) • CZ • H0 • H1 • CZ • H0 • S0 • S0 • H0 • H1 • S1 • S1 • H1 • W ^ 6 • ε
          by general-assoc auto
      equals CH0 • H0 • T0 • T0 • T0 • T0 • T0 • T0 • T0 • T0 • H0 • CH0 • R (plus , Y⊗I) • R (plus , Y⊗Z) • R (plus , Z⊗I) • R (plus , Y⊗I) • R (plus , Y⊗Z) • R (plus , X⊗Z) • R (plus , Y⊗X) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Y⊗X) • R (plus , Z⊗Y) • R (plus , Z⊗X) • CZ • H0 • H1 • CZ • H0 • S0 • S0 • H0 • H1 • S1 • S1 • H1 • W ^ 6 • ε
          by in-context 2 8 auto lemma-order-T0
      equals CH0 • H0 • H0 • CH0 • R (plus , Y⊗I) • R (plus , Y⊗Z) • R (plus , Z⊗I) • R (plus , Y⊗I) • R (plus , Y⊗Z) • R (plus , X⊗Z) • R (plus , Y⊗X) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Y⊗X) • R (plus , Z⊗Y) • R (plus , Z⊗X) • CZ • H0 • H1 • CZ • H0 • S0 • S0 • H0 • H1 • S1 • S1 • H1 • W ^ 6 • ε
          by clifford-tactic 1 2 10000 auto
      equals CH0 • CH0 • R (plus , Y⊗I) • R (plus , Y⊗Z) • R (plus , Z⊗I) • R (plus , Y⊗I) • R (plus , Y⊗Z) • R (plus , X⊗Z) • R (plus , Y⊗X) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Y⊗X) • R (plus , Z⊗Y) • R (plus , Z⊗X) • CZ • H0 • H1 • CZ • H0 • S0 • S0 • H0 • H1 • S1 • S1 • H1 • W ^ 6 • ε
          by in-context 0 2 auto lemma-order-CH0
      equals R (plus , Y⊗I) • R (plus , Y⊗Z) • R (plus , Z⊗I) • R (plus , Y⊗I) • R (plus , Y⊗Z) • R (plus , X⊗Z) • R (plus , Y⊗X) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Y⊗X) • R (plus , Z⊗Y) • R (plus , Z⊗X) • CZ • H0 • H1 • CZ • H0 • S0 • S0 • H0 • H1 • S1 • S1 • H1 • W ^ 6 • ε
          by clifford-tactic 12 13 10000 auto
      equals R (plus , Y⊗I) • R (plus , Y⊗Z) • R (plus , Z⊗I) • R (plus , Y⊗I) • R (plus , Y⊗Z) • R (plus , X⊗Z) • R (plus , Y⊗X) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Y⊗X) • R (plus , Z⊗Y) • R (plus , Z⊗X) • H0 • H1 • CZ • S0 • S0 • H0 • S1 • S1 • H1 • W ^ 6 • Swap • ε
          by in-context 9 2 auto (tactic-pauli-commute (plus , Y⊗X) (plus , Z⊗Y) auto)
      equals R (plus , Y⊗I) • R (plus , Y⊗Z) • R (plus , Z⊗I) • R (plus , Y⊗I) • R (plus , Y⊗Z) • R (plus , X⊗Z) • R (plus , Y⊗X) • R (plus , Z⊗Y) • R (plus , I⊗Z) • R (plus , Z⊗Y) • R (plus , Y⊗X) • R (plus , Z⊗X) • H0 • H1 • CZ • S0 • S0 • H0 • S1 • S1 • H1 • W ^ 6 • Swap • ε
          by in-context 6 2 auto (tactic-pauli-commute (plus , Y⊗X) (plus , Z⊗Y) auto)
      equals R (plus , Y⊗I) • R (plus , Y⊗Z) • R (plus , Z⊗I) • R (plus , Y⊗I) • R (plus , Y⊗Z) • R (plus , X⊗Z) • R (plus , Z⊗Y) • R (plus , Y⊗X) • R (plus , I⊗Z) • R (plus , Z⊗Y) • R (plus , Y⊗X) • R (plus , Z⊗X) • H0 • H1 • CZ • S0 • S0 • H0 • S1 • S1 • H1 • W ^ 6 • Swap • ε
          by in-context 5 2 auto (tactic-pauli-commute (plus , X⊗Z) (plus , Z⊗Y) auto)
      equals R (plus , Y⊗I) • R (plus , Y⊗Z) • R (plus , Z⊗I) • R (plus , Y⊗I) • R (plus , Y⊗Z) • R (plus , Z⊗Y) • R (plus , X⊗Z) • R (plus , Y⊗X) • R (plus , I⊗Z) • R (plus , Z⊗Y) • R (plus , Y⊗X) • R (plus , Z⊗X) • H0 • H1 • CZ • S0 • S0 • H0 • S1 • S1 • H1 • W ^ 6 • Swap • ε
          by in-context 6 2 auto (tactic-pauli-commute (plus , X⊗Z) (plus , Y⊗X) auto)
      equals R (plus , Y⊗I) • R (plus , Y⊗Z) • R (plus , Z⊗I) • R (plus , Y⊗I) • R (plus , Y⊗Z) • R (plus , Z⊗Y) • R (plus , Y⊗X) • R (plus , X⊗Z) • R (plus , I⊗Z) • R (plus , Z⊗Y) • R (plus , Y⊗X) • R (plus , Z⊗X) • H0 • H1 • CZ • S0 • S0 • H0 • S1 • S1 • H1 • W ^ 6 • Swap • ε
          by in-context 7 2 auto (tactic-pauli-commute (plus , X⊗Z) (plus , I⊗Z) auto)
      equals R (plus , Y⊗I) • R (plus , Y⊗Z) • R (plus , Z⊗I) • R (plus , Y⊗I) • R (plus , Y⊗Z) • R (plus , Z⊗Y) • R (plus , Y⊗X) • R (plus , I⊗Z) • R (plus , X⊗Z) • R (plus , Z⊗Y) • R (plus , Y⊗X) • R (plus , Z⊗X) • H0 • H1 • CZ • S0 • S0 • H0 • S1 • S1 • H1 • W ^ 6 • Swap • ε
          by in-context 8 2 auto (tactic-pauli-commute (plus , X⊗Z) (plus , Z⊗Y) auto)
      equals R (plus , Y⊗I) • R (plus , Y⊗Z) • R (plus , Z⊗I) • R (plus , Y⊗I) • R (plus , Y⊗Z) • R (plus , Z⊗Y) • R (plus , Y⊗X) • R (plus , I⊗Z) • R (plus , Z⊗Y) • R (plus , X⊗Z) • R (plus , Y⊗X) • R (plus , Z⊗X) • H0 • H1 • CZ • S0 • S0 • H0 • S1 • S1 • H1 • W ^ 6 • Swap • ε
          by in-context 9 2 auto (tactic-pauli-commute (plus , X⊗Z) (plus , Y⊗X) auto)
      equals R (plus , Y⊗I) • R (plus , Y⊗Z) • R (plus , Z⊗I) • R (plus , Y⊗I) • R (plus , Y⊗Z) • R (plus , Z⊗Y) • R (plus , Y⊗X) • R (plus , I⊗Z) • R (plus , Z⊗Y) • R (plus , Y⊗X) • R (plus , X⊗Z) • R (plus , Z⊗X) • H0 • H1 • CZ • S0 • S0 • H0 • S1 • S1 • H1 • W ^ 6 • Swap • ε
          by in-context 10 2 auto (tactic-pauli-commute (plus , X⊗Z) (plus , Z⊗X) auto)
      equals R (plus , Y⊗I) • R (plus , Y⊗Z) • R (plus , Z⊗I) • R (plus , Y⊗I) • R (plus , Y⊗Z) • R (plus , Z⊗Y) • R (plus , Y⊗X) • R (plus , I⊗Z) • R (plus , Z⊗Y) • R (plus , Y⊗X) • R (plus , Z⊗X) • R (plus , X⊗Z) • H0 • H1 • CZ • S0 • S0 • H0 • S1 • S1 • H1 • W ^ 6 • Swap • ε
          by in-context 4 2 auto (tactic-pauli-commute (plus , Y⊗Z) (plus , Z⊗Y) auto)
      equals R (plus , Y⊗I) • R (plus , Y⊗Z) • R (plus , Z⊗I) • R (plus , Y⊗I) • R (plus , Z⊗Y) • R (plus , Y⊗Z) • R (plus , Y⊗X) • R (plus , I⊗Z) • R (plus , Z⊗Y) • R (plus , Y⊗X) • R (plus , Z⊗X) • R (plus , X⊗Z) • H0 • H1 • CZ • S0 • S0 • H0 • S1 • S1 • H1 • W ^ 6 • Swap • ε
          by clifford-tactic 12 10 10000 auto
      equals R (plus , Y⊗I) • R (plus , Y⊗Z) • R (plus , Z⊗I) • R (plus , Y⊗I) • R (plus , Z⊗Y) • R (plus , Y⊗Z) • R (plus , Y⊗X) • R (plus , I⊗Z) • R (plus , Z⊗Y) • R (plus , Y⊗X) • R (plus , Z⊗X) • R (plus , X⊗Z) • CZ • H0 • S0⁻¹ • W • H0 • CZ • S0 • H0 • H1 • CZ • S0 • S0 • H0 • S0 • S0 • S1 • H1 • W • H1 • CZ • S1 • S1 • H1 • S1 • S1 • S1 • W ^ 4 • S0⁻¹ • Swap • ε
          by in-context 11 7 auto (symm (lemma-correction X⊗Z))
      equals R (plus , Y⊗I) • R (plus , Y⊗Z) • R (plus , Z⊗I) • R (plus , Y⊗I) • R (plus , Z⊗Y) • R (plus , Y⊗Z) • R (plus , Y⊗X) • R (plus , I⊗Z) • R (plus , Z⊗Y) • R (plus , Y⊗X) • R (plus , Z⊗X) • R (minus , X⊗Z) • S0 • H0 • H1 • CZ • S0 • S0 • H0 • S0 • S0 • S1 • H1 • W • H1 • CZ • S1 • S1 • H1 • S1 • S1 • S1 • W ^ 4 • S0⁻¹ • Swap • ε
          by in-context 11 13 auto (symm (lemma-R (C.S0 • C.H0 • C.H1 • C.CZ • C.S0 • C.S0 • C.H0 • C.S0 • C.S0 • C.S1 • C.H1 • C.W) (minus , Z⊗Z)))
      equals R (plus , Y⊗I) • R (plus , Y⊗Z) • R (plus , Z⊗I) • R (plus , Y⊗I) • R (plus , Z⊗Y) • R (plus , Y⊗Z) • R (plus , Y⊗X) • R (plus , I⊗Z) • R (plus , Z⊗Y) • R (plus , Y⊗X) • R (plus , Z⊗X) • S0 • H0 • H1 • CZ • S0 • S0 • H0 • S0 • S0 • S1 • H1 • W • R (minus , Z⊗Z) • H1 • CZ • S1 • S1 • H1 • S1 • S1 • S1 • W ^ 4 • S0⁻¹ • Swap • ε
          by clifford-tactic 11 12 10000 auto
      equals R (plus , Y⊗I) • R (plus , Y⊗Z) • R (plus , Z⊗I) • R (plus , Y⊗I) • R (plus , Z⊗Y) • R (plus , Y⊗Z) • R (plus , Y⊗X) • R (plus , I⊗Z) • R (plus , Z⊗Y) • R (plus , Y⊗X) • R (plus , Z⊗X) • H1 • H0 • CZ • H0 • S0⁻¹ • W • H0 • CZ • H0 • H1 • S0 • H0 • H1 • CZ • S0 • S0 • H0 • S0 • S1 • H1 • W ^ 2 • R (minus , Z⊗Z) • H1 • CZ • S1 • S1 • H1 • S1 • S1 • S1 • W ^ 4 • S0⁻¹ • Swap • ε
          by in-context 10 11 auto (symm (lemma-correction Z⊗X))
      equals R (plus , Y⊗I) • R (plus , Y⊗Z) • R (plus , Z⊗I) • R (plus , Y⊗I) • R (plus , Z⊗Y) • R (plus , Y⊗Z) • R (plus , Y⊗X) • R (plus , I⊗Z) • R (plus , Z⊗Y) • R (plus , Y⊗X) • R (minus , Z⊗X) • S0 • H0 • H1 • CZ • S0 • S0 • H0 • S0 • S1 • H1 • W ^ 2 • R (minus , Z⊗Z) • H1 • CZ • S1 • S1 • H1 • S1 • S1 • S1 • W ^ 4 • S0⁻¹ • Swap • ε
          by in-context 10 12 auto (symm (lemma-R (C.S0 • C.H0 • C.H1 • C.CZ • C.S0 • C.S0 • C.H0 • C.S0 • C.S1 • C.H1 • C.W ^ 2) (plus , Z⊗I)))
      equals R (plus , Y⊗I) • R (plus , Y⊗Z) • R (plus , Z⊗I) • R (plus , Y⊗I) • R (plus , Z⊗Y) • R (plus , Y⊗Z) • R (plus , Y⊗X) • R (plus , I⊗Z) • R (plus , Z⊗Y) • R (plus , Y⊗X) • S0 • H0 • H1 • CZ • S0 • S0 • H0 • S0 • S1 • H1 • W ^ 2 • R (plus , Z⊗I) • R (minus , Z⊗Z) • H1 • CZ • S1 • S1 • H1 • S1 • S1 • S1 • W ^ 4 • S0⁻¹ • Swap • ε
          by clifford-tactic 10 11 10000 auto
      equals R (plus , Y⊗I) • R (plus , Y⊗Z) • R (plus , Z⊗I) • R (plus , Y⊗I) • R (plus , Z⊗Y) • R (plus , Y⊗Z) • R (plus , Y⊗X) • R (plus , I⊗Z) • R (plus , Z⊗Y) • R (plus , Y⊗X) • H1 • S0 • CZ • H0 • S0⁻¹ • W • H0 • CZ • S0⁻¹ • H1 • S0 • S0 • H0 • S0 • S0 • H1 • S1 • S1 • H1 • R (plus , Z⊗I) • R (minus , Z⊗Z) • H1 • CZ • S1 • S1 • H1 • S1 • S1 • S1 • W ^ 4 • S0⁻¹ • Swap • ε
          by in-context 9 11 auto (symm (lemma-correction Y⊗X))
      equals R (plus , Y⊗I) • R (plus , Y⊗Z) • R (plus , Z⊗I) • R (plus , Y⊗I) • R (plus , Z⊗Y) • R (plus , Y⊗Z) • R (plus , Y⊗X) • R (plus , I⊗Z) • R (plus , Z⊗Y) • R (minus , Y⊗X) • S0 • S0 • H0 • S0 • S0 • H1 • S1 • S1 • H1 • R (plus , Z⊗I) • R (minus , Z⊗Z) • H1 • CZ • S1 • S1 • H1 • S1 • S1 • S1 • W ^ 4 • S0⁻¹ • Swap • ε
          by in-context 9 10 auto (symm (lemma-R (C.S0 • C.S0 • C.H0 • C.S0 • C.S0 • C.H1 • C.S1 • C.S1 • C.H1) (plus , Y⊗X)))
      equals R (plus , Y⊗I) • R (plus , Y⊗Z) • R (plus , Z⊗I) • R (plus , Y⊗I) • R (plus , Z⊗Y) • R (plus , Y⊗Z) • R (plus , Y⊗X) • R (plus , I⊗Z) • R (plus , Z⊗Y) • S0 • S0 • H0 • S0 • S0 • H1 • S1 • S1 • H1 • R (plus , Y⊗X) • R (plus , Z⊗I) • R (minus , Z⊗Z) • H1 • CZ • S1 • S1 • H1 • S1 • S1 • S1 • W ^ 4 • S0⁻¹ • Swap • ε
          by clifford-tactic 9 9 10000 auto
      equals R (plus , Y⊗I) • R (plus , Y⊗Z) • R (plus , Z⊗I) • R (plus , Y⊗I) • R (plus , Z⊗Y) • R (plus , Y⊗Z) • R (plus , Y⊗X) • R (plus , I⊗Z) • R (plus , Z⊗Y) • S1 • H1 • H0 • CZ • H0 • S0⁻¹ • W • H0 • CZ • H0 • H1 • S1⁻¹ • S1 • H1 • CZ • S0 • S0 • S0 • H0 • S0 • S0 • S1 • S1 • S1 • H1 • S1 • W ^ 5 • R (plus , Y⊗X) • R (plus , Z⊗I) • R (minus , Z⊗Z) • H1 • CZ • S1 • S1 • H1 • S1 • S1 • S1 • W ^ 4 • S0⁻¹ • Swap • ε
          by in-context 8 13 auto (symm (lemma-correction Z⊗Y))
      equals R (plus , Y⊗I) • R (plus , Y⊗Z) • R (plus , Z⊗I) • R (plus , Y⊗I) • R (plus , Z⊗Y) • R (plus , Y⊗Z) • R (plus , Y⊗X) • R (plus , I⊗Z) • R (minus , Z⊗Y) • S1 • H1 • CZ • S0 • S0 • S0 • H0 • S0 • S0 • S1 • S1 • S1 • H1 • S1 • W ^ 5 • R (plus , Y⊗X) • R (plus , Z⊗I) • R (minus , Z⊗Z) • H1 • CZ • S1 • S1 • H1 • S1 • S1 • S1 • W ^ 4 • S0⁻¹ • Swap • ε
          by in-context 8 16 auto (symm (lemma-R (C.S1 • C.H1 • C.CZ • C.S0 • C.S0 • C.S0 • C.H0 • C.S0 • C.S0 • C.S1 • C.S1 • C.S1 • C.H1 • C.S1 • C.W ^ 5) (minus , X⊗Y)))
      equals R (plus , Y⊗I) • R (plus , Y⊗Z) • R (plus , Z⊗I) • R (plus , Y⊗I) • R (plus , Z⊗Y) • R (plus , Y⊗Z) • R (plus , Y⊗X) • R (plus , I⊗Z) • S1 • H1 • CZ • S0 • S0 • S0 • H0 • S0 • S0 • S1 • S1 • S1 • H1 • S1 • W ^ 5 • R (minus , X⊗Y) • R (plus , Y⊗X) • R (plus , Z⊗I) • R (minus , Z⊗Z) • H1 • CZ • S1 • S1 • H1 • S1 • S1 • S1 • W ^ 4 • S0⁻¹ • Swap • ε
          by in-context 7 16 auto (symm (lemma-R (C.S1 • C.H1 • C.CZ • C.S0 • C.S0 • C.S0 • C.H0 • C.S0 • C.S0 • C.S1 • C.S1 • C.S1 • C.H1 • C.S1 • C.W ^ 5) (plus , X⊗X)))
      equals R (plus , Y⊗I) • R (plus , Y⊗Z) • R (plus , Z⊗I) • R (plus , Y⊗I) • R (plus , Z⊗Y) • R (plus , Y⊗Z) • R (plus , Y⊗X) • S1 • H1 • CZ • S0 • S0 • S0 • H0 • S0 • S0 • S1 • S1 • S1 • H1 • S1 • W ^ 5 • R (plus , X⊗X) • R (minus , X⊗Y) • R (plus , Y⊗X) • R (plus , Z⊗I) • R (minus , Z⊗Z) • H1 • CZ • S1 • S1 • H1 • S1 • S1 • S1 • W ^ 4 • S0⁻¹ • Swap • ε
          by in-context 6 16 auto (symm (lemma-R (C.S1 • C.H1 • C.CZ • C.S0 • C.S0 • C.S0 • C.H0 • C.S0 • C.S0 • C.S1 • C.S1 • C.S1 • C.H1 • C.S1 • C.W ^ 5) (minus , Y⊗X)))
      equals R (plus , Y⊗I) • R (plus , Y⊗Z) • R (plus , Z⊗I) • R (plus , Y⊗I) • R (plus , Z⊗Y) • R (plus , Y⊗Z) • S1 • H1 • CZ • S0 • S0 • S0 • H0 • S0 • S0 • S1 • S1 • S1 • H1 • S1 • W ^ 5 • R (minus , Y⊗X) • R (plus , X⊗X) • R (minus , X⊗Y) • R (plus , Y⊗X) • R (plus , Z⊗I) • R (minus , Z⊗Z) • H1 • CZ • S1 • S1 • H1 • S1 • S1 • S1 • W ^ 4 • S0⁻¹ • Swap • ε
          by clifford-tactic 6 15 10000 auto
      equals R (plus , Y⊗I) • R (plus , Y⊗Z) • R (plus , Z⊗I) • R (plus , Y⊗I) • R (plus , Z⊗Y) • R (plus , Y⊗Z) • S0 • CZ • H0 • S0⁻¹ • W • H0 • CZ • S0⁻¹ • H0 • H1 • CZ • S0 • S0 • H0 • S0 • S0 • S1 • S1 • W ^ 4 • Swap • R (minus , Y⊗X) • R (plus , X⊗X) • R (minus , X⊗Y) • R (plus , Y⊗X) • R (plus , Z⊗I) • R (minus , Z⊗Z) • H1 • CZ • S1 • S1 • H1 • S1 • S1 • S1 • W ^ 4 • S0⁻¹ • Swap • ε
          by in-context 5 9 auto (symm (lemma-correction Y⊗Z))
      equals R (plus , Y⊗I) • R (plus , Y⊗Z) • R (plus , Z⊗I) • R (plus , Y⊗I) • R (plus , Z⊗Y) • R (minus , Y⊗Z) • H0 • H1 • CZ • S0 • S0 • H0 • S0 • S0 • S1 • S1 • W ^ 4 • Swap • R (minus , Y⊗X) • R (plus , X⊗X) • R (minus , X⊗Y) • R (plus , Y⊗X) • R (plus , Z⊗I) • R (minus , Z⊗Z) • H1 • CZ • S1 • S1 • H1 • S1 • S1 • S1 • W ^ 4 • S0⁻¹ • Swap • ε
          by in-context 5 13 auto (symm (lemma-R (C.H0 • C.H1 • C.CZ • C.S0 • C.S0 • C.H0 • C.S0 • C.S0 • C.S1 • C.S1 • C.W ^ 4 • C.Swap) (minus , Y⊗Z)))
      equals R (plus , Y⊗I) • R (plus , Y⊗Z) • R (plus , Z⊗I) • R (plus , Y⊗I) • R (plus , Z⊗Y) • H0 • H1 • CZ • S0 • S0 • H0 • S0 • S0 • S1 • S1 • W ^ 4 • Swap • R (minus , Y⊗Z) • R (minus , Y⊗X) • R (plus , X⊗X) • R (minus , X⊗Y) • R (plus , Y⊗X) • R (plus , Z⊗I) • R (minus , Z⊗Z) • H1 • CZ • S1 • S1 • H1 • S1 • S1 • S1 • W ^ 4 • S0⁻¹ • Swap • ε
          by clifford-tactic 5 12 10000 auto
      equals R (plus , Y⊗I) • R (plus , Y⊗Z) • R (plus , Z⊗I) • R (plus , Y⊗I) • R (plus , Z⊗Y) • S1 • H1 • H0 • CZ • H0 • S0⁻¹ • W • H0 • CZ • H0 • H1 • S1⁻¹ • S0 • H0 • CZ • S0 • S0 • H0 • S0 • S0 • S0 • S1 • S1 • S1 • W ^ 2 • R (minus , Y⊗Z) • R (minus , Y⊗X) • R (plus , X⊗X) • R (minus , X⊗Y) • R (plus , Y⊗X) • R (plus , Z⊗I) • R (minus , Z⊗Z) • H1 • CZ • S1 • S1 • H1 • S1 • S1 • S1 • W ^ 4 • S0⁻¹ • Swap • ε
          by in-context 4 13 auto (symm (lemma-correction Z⊗Y))
      equals R (plus , Y⊗I) • R (plus , Y⊗Z) • R (plus , Z⊗I) • R (plus , Y⊗I) • R (minus , Z⊗Y) • S0 • H0 • CZ • S0 • S0 • H0 • S0 • S0 • S0 • S1 • S1 • S1 • W ^ 2 • R (minus , Y⊗Z) • R (minus , Y⊗X) • R (plus , X⊗X) • R (minus , X⊗Y) • R (plus , Y⊗X) • R (plus , Z⊗I) • R (minus , Z⊗Z) • H1 • CZ • S1 • S1 • H1 • S1 • S1 • S1 • W ^ 4 • S0⁻¹ • Swap • ε
          by in-context 4 14 auto (symm (lemma-R (C.S0 • C.H0 • C.CZ • C.S0 • C.S0 • C.H0 • C.S0 • C.S0 • C.S0 • C.S1 • C.S1 • C.S1 • C.W ^ 2) (minus , X⊗Y)))
      equals R (plus , Y⊗I) • R (plus , Y⊗Z) • R (plus , Z⊗I) • R (plus , Y⊗I) • S0 • H0 • CZ • S0 • S0 • H0 • S0 • S0 • S0 • S1 • S1 • S1 • W ^ 2 • R (minus , X⊗Y) • R (minus , Y⊗Z) • R (minus , Y⊗X) • R (plus , X⊗X) • R (minus , X⊗Y) • R (plus , Y⊗X) • R (plus , Z⊗I) • R (minus , Z⊗Z) • H1 • CZ • S1 • S1 • H1 • S1 • S1 • S1 • W ^ 4 • S0⁻¹ • Swap • ε
          by clifford-tactic 6 11 10000 auto
      equals R (plus , Y⊗I) • R (plus , Y⊗Z) • R (plus , Z⊗I) • R (plus , Y⊗I) • S0 • H0 • S0⁻¹ • W • H0 • S0⁻¹ • S0 • CZ • H0 • S0⁻¹ • W • H0 • CZ • S0⁻¹ • R (minus , X⊗Y) • R (minus , Y⊗Z) • R (minus , Y⊗X) • R (plus , X⊗X) • R (minus , X⊗Y) • R (plus , Y⊗X) • R (plus , Z⊗I) • R (minus , Z⊗Z) • H1 • CZ • S1 • S1 • H1 • S1 • S1 • S1 • W ^ 4 • S0⁻¹ • Swap • ε
          by in-context 3 7 auto (symm (lemma-correction Y⊗I))
      equals R (plus , Y⊗I) • R (plus , Y⊗Z) • R (plus , Z⊗I) • R (minus , Y⊗I) • S0 • CZ • H0 • S0⁻¹ • W • H0 • CZ • S0⁻¹ • R (minus , X⊗Y) • R (minus , Y⊗Z) • R (minus , Y⊗X) • R (plus , X⊗X) • R (minus , X⊗Y) • R (plus , Y⊗X) • R (plus , Z⊗I) • R (minus , Z⊗Z) • H1 • CZ • S1 • S1 • H1 • S1 • S1 • S1 • W ^ 4 • S0⁻¹ • Swap • ε
          by in-context 3 9 auto (symm (lemma-R (C.S0 • C.CZ • C.H0 • C.S0⁻¹ • C.W • C.H0 • C.CZ • C.S0⁻¹) (minus , Y⊗I)))
      equals R (plus , Y⊗I) • R (plus , Y⊗Z) • R (plus , Z⊗I) • S0 • CZ • H0 • S0⁻¹ • W • H0 • CZ • S0⁻¹ • R (minus , Y⊗I) • R (minus , X⊗Y) • R (minus , Y⊗Z) • R (minus , Y⊗X) • R (plus , X⊗X) • R (minus , X⊗Y) • R (plus , Y⊗X) • R (plus , Z⊗I) • R (minus , Z⊗Z) • H1 • CZ • S1 • S1 • H1 • S1 • S1 • S1 • W ^ 4 • S0⁻¹ • Swap • ε
          by in-context 2 9 auto (symm (lemma-R (C.S0 • C.CZ • C.H0 • C.S0⁻¹ • C.W • C.H0 • C.CZ • C.S0⁻¹) (plus , X⊗Z)))
      equals R (plus , Y⊗I) • R (plus , Y⊗Z) • S0 • CZ • H0 • S0⁻¹ • W • H0 • CZ • S0⁻¹ • R (plus , X⊗Z) • R (minus , Y⊗I) • R (minus , X⊗Y) • R (minus , Y⊗Z) • R (minus , Y⊗X) • R (plus , X⊗X) • R (minus , X⊗Y) • R (plus , Y⊗X) • R (plus , Z⊗I) • R (minus , Z⊗Z) • H1 • CZ • S1 • S1 • H1 • S1 • S1 • S1 • W ^ 4 • S0⁻¹ • Swap • ε
          by in-context 1 9 auto (symm (lemma-correction Y⊗Z))
      equals R (plus , Y⊗I) • R (minus , Y⊗Z) • R (plus , X⊗Z) • R (minus , Y⊗I) • R (minus , X⊗Y) • R (minus , Y⊗Z) • R (minus , Y⊗X) • R (plus , X⊗X) • R (minus , X⊗Y) • R (plus , Y⊗X) • R (plus , Z⊗I) • R (minus , Z⊗Z) • H1 • CZ • S1 • S1 • H1 • S1 • S1 • S1 • W ^ 4 • S0⁻¹ • Swap • ε
          by in-context 10 2 auto (tactic-pauli-commute (plus , Z⊗I) (minus , Z⊗Z) auto)
      equals R (plus , Y⊗I) • R (minus , Y⊗Z) • R (plus , X⊗Z) • R (minus , Y⊗I) • R (minus , X⊗Y) • R (minus , Y⊗Z) • R (minus , Y⊗X) • R (plus , X⊗X) • R (minus , X⊗Y) • R (plus , Y⊗X) • R (minus , Z⊗Z) • R (plus , Z⊗I) • H1 • CZ • S1 • S1 • H1 • S1 • S1 • S1 • W ^ 4 • S0⁻¹ • Swap • ε
          by in-context 9 2 auto (tactic-pauli-commute (plus , Y⊗X) (minus , Z⊗Z) auto)
      equals R (plus , Y⊗I) • R (minus , Y⊗Z) • R (plus , X⊗Z) • R (minus , Y⊗I) • R (minus , X⊗Y) • R (minus , Y⊗Z) • R (minus , Y⊗X) • R (plus , X⊗X) • R (minus , X⊗Y) • R (minus , Z⊗Z) • R (plus , Y⊗X) • R (plus , Z⊗I) • H1 • CZ • S1 • S1 • H1 • S1 • S1 • S1 • W ^ 4 • S0⁻¹ • Swap • ε
          by in-context 8 2 auto (tactic-pauli-commute (minus , X⊗Y) (minus , Z⊗Z) auto)
      equals R (plus , Y⊗I) • R (minus , Y⊗Z) • R (plus , X⊗Z) • R (minus , Y⊗I) • R (minus , X⊗Y) • R (minus , Y⊗Z) • R (minus , Y⊗X) • R (plus , X⊗X) • R (minus , Z⊗Z) • R (minus , X⊗Y) • R (plus , Y⊗X) • R (plus , Z⊗I) • H1 • CZ • S1 • S1 • H1 • S1 • S1 • S1 • W ^ 4 • S0⁻¹ • Swap • ε
          by in-context 7 2 auto (tactic-pauli-commute (plus , X⊗X) (minus , Z⊗Z) auto)
      equals R (plus , Y⊗I) • R (minus , Y⊗Z) • R (plus , X⊗Z) • R (minus , Y⊗I) • R (minus , X⊗Y) • R (minus , Y⊗Z) • R (minus , Y⊗X) • R (minus , Z⊗Z) • R (plus , X⊗X) • R (minus , X⊗Y) • R (plus , Y⊗X) • R (plus , Z⊗I) • H1 • CZ • S1 • S1 • H1 • S1 • S1 • S1 • W ^ 4 • S0⁻¹ • Swap • ε
          by in-context 6 2 auto (tactic-pauli-commute (minus , Y⊗X) (minus , Z⊗Z) auto)
      equals R (plus , Y⊗I) • R (minus , Y⊗Z) • R (plus , X⊗Z) • R (minus , Y⊗I) • R (minus , X⊗Y) • R (minus , Y⊗Z) • R (minus , Z⊗Z) • R (minus , Y⊗X) • R (plus , X⊗X) • R (minus , X⊗Y) • R (plus , Y⊗X) • R (plus , Z⊗I) • H1 • CZ • S1 • S1 • H1 • S1 • S1 • S1 • W ^ 4 • S0⁻¹ • Swap • ε
          by in-context 4 2 auto (tactic-pauli-commute (minus , X⊗Y) (minus , Y⊗Z) auto)
      equals R (plus , Y⊗I) • R (minus , Y⊗Z) • R (plus , X⊗Z) • R (minus , Y⊗I) • R (minus , Y⊗Z) • R (minus , X⊗Y) • R (minus , Z⊗Z) • R (minus , Y⊗X) • R (plus , X⊗X) • R (minus , X⊗Y) • R (plus , Y⊗X) • R (plus , Z⊗I) • H1 • CZ • S1 • S1 • H1 • S1 • S1 • S1 • W ^ 4 • S0⁻¹ • Swap • ε
          by in-context 5 2 auto (tactic-pauli-commute (minus , X⊗Y) (minus , Z⊗Z) auto)
      equals R (plus , Y⊗I) • R (minus , Y⊗Z) • R (plus , X⊗Z) • R (minus , Y⊗I) • R (minus , Y⊗Z) • R (minus , Z⊗Z) • R (minus , X⊗Y) • R (minus , Y⊗X) • R (plus , X⊗X) • R (minus , X⊗Y) • R (plus , Y⊗X) • R (plus , Z⊗I) • H1 • CZ • S1 • S1 • H1 • S1 • S1 • S1 • W ^ 4 • S0⁻¹ • Swap • ε
          by in-context 6 2 auto (tactic-pauli-commute (minus , X⊗Y) (minus , Y⊗X) auto)
      equals R (plus , Y⊗I) • R (minus , Y⊗Z) • R (plus , X⊗Z) • R (minus , Y⊗I) • R (minus , Y⊗Z) • R (minus , Z⊗Z) • R (minus , Y⊗X) • R (minus , X⊗Y) • R (plus , X⊗X) • R (minus , X⊗Y) • R (plus , Y⊗X) • R (plus , Z⊗I) • H1 • CZ • S1 • S1 • H1 • S1 • S1 • S1 • W ^ 4 • S0⁻¹ • Swap • ε
          by in-context 3 2 auto (tactic-pauli-commute (minus , Y⊗I) (minus , Y⊗Z) auto)
      equals R (plus , Y⊗I) • R (minus , Y⊗Z) • R (plus , X⊗Z) • R (minus , Y⊗Z) • R (minus , Y⊗I) • R (minus , Z⊗Z) • R (minus , Y⊗X) • R (minus , X⊗Y) • R (plus , X⊗X) • R (minus , X⊗Y) • R (plus , Y⊗X) • R (plus , Z⊗I) • H1 • CZ • S1 • S1 • H1 • S1 • S1 • S1 • W ^ 4 • S0⁻¹ • Swap • ε
          by in-context 11 10 auto (symm (lemma-R (C.H1 • C.CZ • C.S1 • C.S1 • C.H1 • C.S1 • C.S1 • C.S1 • C.W ^ 4) (plus , Z⊗I)))
      equals R (plus , Y⊗I) • R (minus , Y⊗Z) • R (plus , X⊗Z) • R (minus , Y⊗Z) • R (minus , Y⊗I) • R (minus , Z⊗Z) • R (minus , Y⊗X) • R (minus , X⊗Y) • R (plus , X⊗X) • R (minus , X⊗Y) • R (plus , Y⊗X) • H1 • CZ • S1 • S1 • H1 • S1 • S1 • S1 • W ^ 4 • R (plus , Z⊗I) • S0⁻¹ • Swap • ε
          by clifford-tactic 13 7 10000 auto
      equals R (plus , Y⊗I) • R (minus , Y⊗Z) • R (plus , X⊗Z) • R (minus , Y⊗Z) • R (minus , Y⊗I) • R (minus , Z⊗Z) • R (minus , Y⊗X) • R (minus , X⊗Y) • R (plus , X⊗X) • R (minus , X⊗Y) • R (plus , Y⊗X) • H1 • CZ • S0 • H0 • S0 • S1 • S1 • H1 • S1 • S1 • S1 • W ^ 4 • S0⁻¹ • H0 • S0⁻¹ • R (plus , Z⊗I) • S0⁻¹ • Swap • ε
          by in-context 10 13 auto (symm (lemma-R (C.H1 • C.CZ • C.S0 • C.H0 • C.S0 • C.S1 • C.S1 • C.H1 • C.S1 • C.S1 • C.S1 • C.W ^ 4) (plus , Z⊗I)))
      equals R (plus , Y⊗I) • R (minus , Y⊗Z) • R (plus , X⊗Z) • R (minus , Y⊗Z) • R (minus , Y⊗I) • R (minus , Z⊗Z) • R (minus , Y⊗X) • R (minus , X⊗Y) • R (plus , X⊗X) • R (minus , X⊗Y) • H1 • CZ • S0 • H0 • S0 • S1 • S1 • H1 • S1 • S1 • S1 • W ^ 4 • R (plus , Z⊗I) • S0⁻¹ • H0 • S0⁻¹ • R (plus , Z⊗I) • S0⁻¹ • Swap • ε
          by clifford-tactic 12 10 10000 auto
      equals R (plus , Y⊗I) • R (minus , Y⊗Z) • R (plus , X⊗Z) • R (minus , Y⊗Z) • R (minus , Y⊗I) • R (minus , Z⊗Z) • R (minus , Y⊗X) • R (minus , X⊗Y) • R (plus , X⊗X) • R (minus , X⊗Y) • H1 • CZ • H0 • H1 • CZ • S1 • H1 • S1 • S1 • H1 • W ^ 3 • S0 • H0 • CX0 • R (plus , Z⊗I) • S0⁻¹ • H0 • S0⁻¹ • R (plus , Z⊗I) • S0⁻¹ • Swap • ε
          by in-context 9 14 auto (symm (lemma-R (C.H1 • C.CZ • C.H0 • C.H1 • C.CZ • C.S1 • C.H1 • C.S1 • C.S1 • C.H1 • C.W ^ 3 • C.S0 • C.H0) (plus , Z⊗I)))
      equals R (plus , Y⊗I) • R (minus , Y⊗Z) • R (plus , X⊗Z) • R (minus , Y⊗Z) • R (minus , Y⊗I) • R (minus , Z⊗Z) • R (minus , Y⊗X) • R (minus , X⊗Y) • R (plus , X⊗X) • H1 • CZ • H0 • H1 • CZ • S1 • H1 • S1 • S1 • H1 • W ^ 3 • S0 • H0 • R (plus , Z⊗I) • CX0 • R (plus , Z⊗I) • S0⁻¹ • H0 • S0⁻¹ • R (plus , Z⊗I) • S0⁻¹ • Swap • ε
          by in-context 8 12 auto (symm (lemma-R (C.H1 • C.CZ • C.H0 • C.H1 • C.CZ • C.S1 • C.H1 • C.S1 • C.S1 • C.H1 • C.W ^ 3) (plus , Z⊗I)))
      equals R (plus , Y⊗I) • R (minus , Y⊗Z) • R (plus , X⊗Z) • R (minus , Y⊗Z) • R (minus , Y⊗I) • R (minus , Z⊗Z) • R (minus , Y⊗X) • R (minus , X⊗Y) • H1 • CZ • H0 • H1 • CZ • S1 • H1 • S1 • S1 • H1 • W ^ 3 • R (plus , Z⊗I) • S0 • H0 • R (plus , Z⊗I) • CX0 • R (plus , Z⊗I) • S0⁻¹ • H0 • S0⁻¹ • R (plus , Z⊗I) • S0⁻¹ • Swap • ε
          by clifford-tactic 8 11 10000 auto
      equals R (plus , Y⊗I) • R (minus , Y⊗Z) • R (plus , X⊗Z) • R (minus , Y⊗Z) • R (minus , Y⊗I) • R (minus , Z⊗Z) • R (minus , Y⊗X) • R (minus , X⊗Y) • S0 • H0 • CZ • H0 • S1 • S1 • H1 • W ^ 4 • CX1 • S1⁻¹ • H1 • S1⁻¹ • X0 • Swap • R (plus , Z⊗I) • S0 • H0 • R (plus , Z⊗I) • CX0 • R (plus , Z⊗I) • S0⁻¹ • H0 • S0⁻¹ • R (plus , Z⊗I) • S0⁻¹ • Swap • ε
          by in-context 7 10 auto (symm (lemma-R (C.S0 • C.H0 • C.CZ • C.H0 • C.S1 • C.S1 • C.H1 • C.W ^ 4 • C.CX1) (plus , I⊗Z)))
      equals R (plus , Y⊗I) • R (minus , Y⊗Z) • R (plus , X⊗Z) • R (minus , Y⊗Z) • R (minus , Y⊗I) • R (minus , Z⊗Z) • R (minus , Y⊗X) • S0 • H0 • CZ • H0 • S1 • S1 • H1 • W ^ 4 • CX1 • R (plus , I⊗Z) • S1⁻¹ • H1 • S1⁻¹ • X0 • Swap • R (plus , Z⊗I) • S0 • H0 • R (plus , Z⊗I) • CX0 • R (plus , Z⊗I) • S0⁻¹ • H0 • S0⁻¹ • R (plus , Z⊗I) • S0⁻¹ • Swap • ε
          by in-context 6 9 auto (symm (lemma-R (C.S0 • C.H0 • C.CZ • C.H0 • C.S1 • C.S1 • C.H1 • C.W ^ 4) (plus , I⊗Z)))
      equals R (plus , Y⊗I) • R (minus , Y⊗Z) • R (plus , X⊗Z) • R (minus , Y⊗Z) • R (minus , Y⊗I) • R (minus , Z⊗Z) • S0 • H0 • CZ • H0 • S1 • S1 • H1 • W ^ 4 • R (plus , I⊗Z) • CX1 • R (plus , I⊗Z) • S1⁻¹ • H1 • S1⁻¹ • X0 • Swap • R (plus , Z⊗I) • S0 • H0 • R (plus , Z⊗I) • CX0 • R (plus , Z⊗I) • S0⁻¹ • H0 • S0⁻¹ • R (plus , Z⊗I) • S0⁻¹ • Swap • ε
          by clifford-tactic 6 8 10000 auto
      equals R (plus , Y⊗I) • R (minus , Y⊗Z) • R (plus , X⊗Z) • R (minus , Y⊗Z) • R (minus , Y⊗I) • R (minus , Z⊗Z) • CZ • H0 • W⁻¹ • S0 • H0 • CX0 • S0⁻¹ • H0 • S0⁻¹ • S0⁻¹ • X0 • S1 • H1 • R (plus , I⊗Z) • CX1 • R (plus , I⊗Z) • S1⁻¹ • H1 • S1⁻¹ • X0 • Swap • R (plus , Z⊗I) • S0 • H0 • R (plus , Z⊗I) • CX0 • R (plus , Z⊗I) • S0⁻¹ • H0 • S0⁻¹ • R (plus , Z⊗I) • S0⁻¹ • Swap • ε
          by in-context 5 10 auto (symm (lemma-R (C.CZ • C.H0 • C.W⁻¹ • C.S0 • C.H0 • C.CX0 • C.S0⁻¹ • C.H0 • C.S0⁻¹) (plus , Z⊗I)))
      equals R (plus , Y⊗I) • R (minus , Y⊗Z) • R (plus , X⊗Z) • R (minus , Y⊗Z) • R (minus , Y⊗I) • CZ • H0 • W⁻¹ • S0 • H0 • CX0 • S0⁻¹ • H0 • S0⁻¹ • R (plus , Z⊗I) • S0⁻¹ • X0 • S1 • H1 • R (plus , I⊗Z) • CX1 • R (plus , I⊗Z) • S1⁻¹ • H1 • S1⁻¹ • X0 • Swap • R (plus , Z⊗I) • S0 • H0 • R (plus , Z⊗I) • CX0 • R (plus , Z⊗I) • S0⁻¹ • H0 • S0⁻¹ • R (plus , Z⊗I) • S0⁻¹ • Swap • ε
          by in-context 4 7 auto (symm (lemma-R (C.CZ • C.H0 • C.W⁻¹ • C.S0 • C.H0 • C.CX0) (plus , Z⊗I)))
      equals R (plus , Y⊗I) • R (minus , Y⊗Z) • R (plus , X⊗Z) • R (minus , Y⊗Z) • CZ • H0 • W⁻¹ • S0 • H0 • CX0 • R (plus , Z⊗I) • S0⁻¹ • H0 • S0⁻¹ • R (plus , Z⊗I) • S0⁻¹ • X0 • S1 • H1 • R (plus , I⊗Z) • CX1 • R (plus , I⊗Z) • S1⁻¹ • H1 • S1⁻¹ • X0 • Swap • R (plus , Z⊗I) • S0 • H0 • R (plus , Z⊗I) • CX0 • R (plus , Z⊗I) • S0⁻¹ • H0 • S0⁻¹ • R (plus , Z⊗I) • S0⁻¹ • Swap • ε
          by in-context 3 6 auto (symm (lemma-R (C.CZ • C.H0 • C.W⁻¹ • C.S0 • C.H0) (plus , Z⊗I)))
      equals R (plus , Y⊗I) • R (minus , Y⊗Z) • R (plus , X⊗Z) • CZ • H0 • W⁻¹ • S0 • H0 • R (plus , Z⊗I) • CX0 • R (plus , Z⊗I) • S0⁻¹ • H0 • S0⁻¹ • R (plus , Z⊗I) • S0⁻¹ • X0 • S1 • H1 • R (plus , I⊗Z) • CX1 • R (plus , I⊗Z) • S1⁻¹ • H1 • S1⁻¹ • X0 • Swap • R (plus , Z⊗I) • S0 • H0 • R (plus , Z⊗I) • CX0 • R (plus , Z⊗I) • S0⁻¹ • H0 • S0⁻¹ • R (plus , Z⊗I) • S0⁻¹ • Swap • ε
          by in-context 2 4 auto (symm (lemma-R (C.CZ • C.H0 • C.W⁻¹) (plus , Z⊗I)))
      equals R (plus , Y⊗I) • R (minus , Y⊗Z) • CZ • H0 • W⁻¹ • R (plus , Z⊗I) • S0 • H0 • R (plus , Z⊗I) • CX0 • R (plus , Z⊗I) • S0⁻¹ • H0 • S0⁻¹ • R (plus , Z⊗I) • S0⁻¹ • X0 • S1 • H1 • R (plus , I⊗Z) • CX1 • R (plus , I⊗Z) • S1⁻¹ • H1 • S1⁻¹ • X0 • Swap • R (plus , Z⊗I) • S0 • H0 • R (plus , Z⊗I) • CX0 • R (plus , Z⊗I) • S0⁻¹ • H0 • S0⁻¹ • R (plus , Z⊗I) • S0⁻¹ • Swap • ε
          by clifford-tactic 2 3 10000 auto
      equals R (plus , Y⊗I) • R (minus , Y⊗Z) • Swap • X0 • S1 • H1 • CX1 • S1⁻¹ • H1 • S1⁻¹ • X0 • Swap • R (plus , Z⊗I) • S0 • H0 • R (plus , Z⊗I) • CX0 • R (plus , Z⊗I) • S0⁻¹ • H0 • S0⁻¹ • R (plus , Z⊗I) • S0⁻¹ • X0 • S1 • H1 • R (plus , I⊗Z) • CX1 • R (plus , I⊗Z) • S1⁻¹ • H1 • S1⁻¹ • X0 • Swap • R (plus , Z⊗I) • S0 • H0 • R (plus , Z⊗I) • CX0 • R (plus , Z⊗I) • S0⁻¹ • H0 • S0⁻¹ • R (plus , Z⊗I) • S0⁻¹ • Swap • ε
          by in-context 1 6 auto (symm (lemma-R (C.Swap • C.X0 • C.S1 • C.H1 • C.CX1) (plus , I⊗Z)))
      equals R (plus , Y⊗I) • Swap • X0 • S1 • H1 • CX1 • R (plus , I⊗Z) • S1⁻¹ • H1 • S1⁻¹ • X0 • Swap • R (plus , Z⊗I) • S0 • H0 • R (plus , Z⊗I) • CX0 • R (plus , Z⊗I) • S0⁻¹ • H0 • S0⁻¹ • R (plus , Z⊗I) • S0⁻¹ • X0 • S1 • H1 • R (plus , I⊗Z) • CX1 • R (plus , I⊗Z) • S1⁻¹ • H1 • S1⁻¹ • X0 • Swap • R (plus , Z⊗I) • S0 • H0 • R (plus , Z⊗I) • CX0 • R (plus , Z⊗I) • S0⁻¹ • H0 • S0⁻¹ • R (plus , Z⊗I) • S0⁻¹ • Swap • ε
          by in-context 0 5 auto (symm (lemma-R (C.Swap • C.X0 • C.S1 • C.H1) (plus , I⊗Z)))
      equals Swap • X0 • S1 • H1 • R (plus , I⊗Z) • CX1 • R (plus , I⊗Z) • S1⁻¹ • H1 • S1⁻¹ • X0 • Swap • R (plus , Z⊗I) • S0 • H0 • R (plus , Z⊗I) • CX0 • R (plus , Z⊗I) • S0⁻¹ • H0 • S0⁻¹ • R (plus , Z⊗I) • S0⁻¹ • X0 • S1 • H1 • R (plus , I⊗Z) • CX1 • R (plus , I⊗Z) • S1⁻¹ • H1 • S1⁻¹ • X0 • Swap • R (plus , Z⊗I) • S0 • H0 • R (plus , Z⊗I) • CX0 • R (plus , Z⊗I) • S0⁻¹ • H0 • S0⁻¹ • R (plus , Z⊗I) • S0⁻¹ • Swap • ε
          by in-context 43 2 auto (symm lemma-R-T0⁻¹)
      equals Swap • X0 • S1 • H1 • R (plus , I⊗Z) • CX1 • R (plus , I⊗Z) • S1⁻¹ • H1 • S1⁻¹ • X0 • Swap • R (plus , Z⊗I) • S0 • H0 • R (plus , Z⊗I) • CX0 • R (plus , Z⊗I) • S0⁻¹ • H0 • S0⁻¹ • R (plus , Z⊗I) • S0⁻¹ • X0 • S1 • H1 • R (plus , I⊗Z) • CX1 • R (plus , I⊗Z) • S1⁻¹ • H1 • S1⁻¹ • X0 • Swap • R (plus , Z⊗I) • S0 • H0 • R (plus , Z⊗I) • CX0 • R (plus , Z⊗I) • S0⁻¹ • H0 • S0⁻¹ • T0⁻¹ • Swap • ε
          by in-context 39 2 auto (symm lemma-R-T0⁻¹)
      equals Swap • X0 • S1 • H1 • R (plus , I⊗Z) • CX1 • R (plus , I⊗Z) • S1⁻¹ • H1 • S1⁻¹ • X0 • Swap • R (plus , Z⊗I) • S0 • H0 • R (plus , Z⊗I) • CX0 • R (plus , Z⊗I) • S0⁻¹ • H0 • S0⁻¹ • R (plus , Z⊗I) • S0⁻¹ • X0 • S1 • H1 • R (plus , I⊗Z) • CX1 • R (plus , I⊗Z) • S1⁻¹ • H1 • S1⁻¹ • X0 • Swap • R (plus , Z⊗I) • S0 • H0 • R (plus , Z⊗I) • CX0 • T0⁻¹ • H0 • S0⁻¹ • T0⁻¹ • Swap • ε
          by general-assoc auto
      equals Swap • X0 • S1 • H1 • R (plus , I⊗Z) • CX1 • R (plus , I⊗Z) • S1⁻¹ • H1 • S1⁻¹ • X0 • Swap • R (plus , Z⊗I) • S0 • H0 • R (plus , Z⊗I) • CX0 • R (plus , Z⊗I) • S0⁻¹ • H0 • S0⁻¹ • R (plus , Z⊗I) • S0⁻¹ • X0 • S1 • H1 • R (plus , I⊗Z) • CX1 • R (plus , I⊗Z) • S1⁻¹ • H1 • S1⁻¹ • X0 • Swap • T0 • CH0 • T0⁻¹ • Swap • ε
          by in-context 28 2 auto (symm lemma-R-T1⁻¹)
      equals Swap • X0 • S1 • H1 • R (plus , I⊗Z) • CX1 • R (plus , I⊗Z) • S1⁻¹ • H1 • S1⁻¹ • X0 • Swap • R (plus , Z⊗I) • S0 • H0 • R (plus , Z⊗I) • CX0 • R (plus , Z⊗I) • S0⁻¹ • H0 • S0⁻¹ • R (plus , Z⊗I) • S0⁻¹ • X0 • S1 • H1 • R (plus , I⊗Z) • CX1 • T1⁻¹ • H1 • S1⁻¹ • X0 • Swap • T0 • CH0 • T0⁻¹ • Swap • ε
          by in-context 26 1 auto (symm lemma-R-T1)
      equals Swap • X0 • S1 • H1 • R (plus , I⊗Z) • CX1 • R (plus , I⊗Z) • S1⁻¹ • H1 • S1⁻¹ • X0 • Swap • R (plus , Z⊗I) • S0 • H0 • R (plus , Z⊗I) • CX0 • R (plus , Z⊗I) • S0⁻¹ • H0 • S0⁻¹ • R (plus , Z⊗I) • S0⁻¹ • X0 • S1 • H1 • T1 • CX1 • T1⁻¹ • H1 • S1⁻¹ • X0 • Swap • T0 • CH0 • T0⁻¹ • Swap • ε
          by general-assoc auto
      equals Swap • X0 • S1 • H1 • R (plus , I⊗Z) • CX1 • R (plus , I⊗Z) • S1⁻¹ • H1 • S1⁻¹ • X0 • Swap • R (plus , Z⊗I) • S0 • H0 • R (plus , Z⊗I) • CX0 • R (plus , Z⊗I) • S0⁻¹ • H0 • S0⁻¹ • R (plus , Z⊗I) • S0⁻¹ • X0 • CH1 • X0 • Swap • T0 • CH0 • T0⁻¹ • Swap • ε
          by in-context 21 2 auto (symm lemma-R-T0⁻¹)
      equals Swap • X0 • S1 • H1 • R (plus , I⊗Z) • CX1 • R (plus , I⊗Z) • S1⁻¹ • H1 • S1⁻¹ • X0 • Swap • R (plus , Z⊗I) • S0 • H0 • R (plus , Z⊗I) • CX0 • R (plus , Z⊗I) • S0⁻¹ • H0 • S0⁻¹ • T0⁻¹ • X0 • CH1 • X0 • Swap • T0 • CH0 • T0⁻¹ • Swap • ε
          by in-context 17 2 auto (symm lemma-R-T0⁻¹)
      equals Swap • X0 • S1 • H1 • R (plus , I⊗Z) • CX1 • R (plus , I⊗Z) • S1⁻¹ • H1 • S1⁻¹ • X0 • Swap • R (plus , Z⊗I) • S0 • H0 • R (plus , Z⊗I) • CX0 • T0⁻¹ • H0 • S0⁻¹ • T0⁻¹ • X0 • CH1 • X0 • Swap • T0 • CH0 • T0⁻¹ • Swap • ε
          by general-assoc auto
      equals Swap • X0 • S1 • H1 • R (plus , I⊗Z) • CX1 • R (plus , I⊗Z) • S1⁻¹ • H1 • S1⁻¹ • X0 • Swap • T0 • CH0 • T0⁻¹ • X0 • CH1 • X0 • Swap • T0 • CH0 • T0⁻¹ • Swap • ε
          by in-context 6 2 auto (symm lemma-R-T1⁻¹)
      equals Swap • X0 • S1 • H1 • R (plus , I⊗Z) • CX1 • T1⁻¹ • H1 • S1⁻¹ • X0 • Swap • T0 • CH0 • T0⁻¹ • X0 • CH1 • X0 • Swap • T0 • CH0 • T0⁻¹ • Swap • ε
          by in-context 4 1 auto (symm lemma-R-T1)
      equals Swap • X0 • S1 • H1 • T1 • CX1 • T1⁻¹ • H1 • S1⁻¹ • X0 • Swap • T0 • CH0 • T0⁻¹ • X0 • CH1 • X0 • Swap • T0 • CH0 • T0⁻¹ • Swap • ε
          by general-assoc auto
      equals Swap • X0 • CH1 • X0 • Swap • T0 • CH0 • T0⁻¹ • X0 • CH1 • X0 • Swap • T0 • CH0 • T0⁻¹ • Swap • ε
          by in-context 12 3 auto (symm lemma-eqn46a)
      equals Swap • X0 • CH1 • X0 • Swap • T0 • CH0 • T0⁻¹ • X0 • CH1 • X0 • Swap • T1 • CX1 • T1⁻¹ • X1 • CX1 • Swap • X0 • CH1 • X0 • Swap • X1 • CX1 • T1 • CX1 • T1⁻¹ • Swap • ε
          by in-context 5 3 auto (symm lemma-eqn46a)
      equals Swap • X0 • CH1 • X0 • Swap • T1 • CX1 • T1⁻¹ • X1 • CX1 • Swap • X0 • CH1 • X0 • Swap • X1 • CX1 • T1 • CX1 • T1⁻¹ • X0 • CH1 • X0 • Swap • T1 • CX1 • T1⁻¹ • X1 • CX1 • Swap • X0 • CH1 • X0 • Swap • X1 • CX1 • T1 • CX1 • T1⁻¹ • Swap • ε


